!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_read_outflow_param

  use mod_types
  use mod_analyze_statement, only : get_val, file_name, line_number, &
       error_message, warning_message
  use mod_convert_type, only : to_string
  use mod_spectra_constants, only : max_dim_outflow_epis

  implicit none
  public
  real(CDR), dimension(max_dim_outflow_epis), save :: &
       outflow_begin_time, outflow_end_time
  character(len=std_string), dimension(max_dim_outflow_epis), save :: &
       outflow_type
  real(CDR), dimension(max_dim_outflow_epis), save :: &
       outflow_inst_mass, &
       outflow_const_mass, &
       outflow_SF_factor, outflow_SF_power, &
       outflow_SN_mass, outflow_SN_power, &
       outflow_CCSN_mass, outflow_CCSN_power, &
       outflow_SNIa_mass, outflow_SNIa_power, &
       outflow_ejec_threshold, outflow_ejec_factor
  character(len=std_string), dimension(max_dim_outflow_epis), save :: &
       outflow_file
  integer, dimension(max_dim_outflow_epis), save :: outflow_file_dim_time
  type(irreg_array_CDR), dimension(max_dim_outflow_epis), save :: &
       outflow_file_time, outflow_file_rate

  logical, dimension(max_dim_outflow_epis), private :: &
       outflow_inst_mass_set, outflow_const_mass_set, &
       outflow_SF_factor_set, outflow_SN_mass_set, &
       outflow_CCSN_mass_set, outflow_SNIa_mass_set, &
       outflow_ejec_threshold_set, outflow_file_set

contains

!#======================================================================
  
  subroutine reset_outflow

    use mod_spectra_def_param
    implicit none
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    outflow_begin_time(:) = outflow_begin_time_def
    outflow_end_time(:) = outflow_end_time_def

    outflow_type(:) = outflow_type_def

    outflow_inst_mass_set(:) = .false.

    outflow_const_mass_set(:) = .false.

    outflow_SF_factor_set(:) = .false.
    outflow_SF_power(:) = outflow_SF_power_def

    outflow_SN_mass_set(:) = .false.
    outflow_SN_power(:) = outflow_SN_power_def

    outflow_CCSN_mass_set(:) = .false.
    outflow_CCSN_power(:) = outflow_CCSN_power_def

    outflow_SNIa_mass_set(:) = .false.
    outflow_SNIa_power(:) = outflow_SNIa_power_def

    outflow_ejec_threshold_set(:) = .false.
    outflow_ejec_factor(:) = outflow_ejec_factor_def

    outflow_file_set(:) = .false.
   
  end subroutine reset_outflow

!#======================================================================

  subroutine outflow_check

    implicit none
!#......................................................................
    integer :: i_epis
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    do i_epis = 1, max_dim_outflow_epis
       if (outflow_type(i_epis) == "none") cycle

       if (outflow_type(i_epis) == "instantaneous") then
          if (.not. outflow_inst_mass_set(i_epis)) then
             call error_message("Value of `outflow_inst_mass(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
       endif

       if (outflow_type(i_epis) == "constant") then
          if (.not. outflow_const_mass_set(i_epis)) then
             call error_message("Value of `outflow_const_mass(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
       endif

       if (outflow_type(i_epis) == "SF") then
          if (.not. outflow_SF_factor_set(i_epis)) then
             call error_message("Value of `outflow_SF_factor(" // &
                  to_string(i_epis) // ")` is unknown.")
           endif
       endif

       if (outflow_type(i_epis) == "SN") then
          if (.not. outflow_SN_mass_set(i_epis)) then
             call error_message("Value of `outflow_SN_mass(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
       endif

       if (outflow_type(i_epis) == "CCSN") then
          if (.not. outflow_CCSN_mass_set(i_epis)) then
              call error_message("Value of `outflow_CCSN_mass(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
       endif

       if (outflow_type(i_epis) == "SNIa") then
          if (.not. outflow_SNIa_mass_set(i_epis)) then
             call error_message("Value of `outflow_SNIa_mass(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
       endif

       if (outflow_type(i_epis) == "ejecta") then
          if (.not. outflow_ejec_threshold_set(i_epis)) then
             call error_message("Value of `outflow_ejec_threshold(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
       endif

       if (outflow_type(i_epis) == "file") then
          if (.not. outflow_file_set(i_epis)) then
             call error_message("Value of `outflow_file(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
       endif
       
       if (outflow_end_time(i_epis) <= &
            outflow_begin_time(i_epis)) &
            call warning_message("`outflow_end_time(" // &
            to_string(i_epis) // ")` = " // &
            to_string(outflow_end_time(i_epis), "(f6.0)") // &
            " <= `outflow_begin_time(" // to_string(i_epis) // ")` = " // &
            to_string(outflow_begin_time(i_epis), "(f6.0)") // ".")
    enddo

  end subroutine outflow_check

!#======================================================================

  subroutine read_outflow_begin_time(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_outflow_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(outflow_begin_time, rhs, indices_string, index_present)
    where (outflow_begin_time(:) > 0)
!# To make sure that the interval is closed on the left.
       outflow_begin_time(:) = nearest(outflow_begin_time(:), -1.)
    end where

  end subroutine read_outflow_begin_time

!#======================================================================

  subroutine read_outflow_end_time(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_outflow_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(outflow_end_time, rhs, indices_string, index_present)
    where (outflow_end_time(:) > 0)
!# To make sure that the interval is open on the right.
       outflow_end_time(:) = nearest(outflow_end_time(:), -1.)
    end where

  end subroutine read_outflow_end_time
  
!#======================================================================

  subroutine read_outflow_type(rhs, indices_string)
    
    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_outflow_epis) :: index_present
    integer :: i_epis
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(outflow_type, rhs, indices_string, index_present)
    do i_epis = 1, max_dim_outflow_epis
       if (index_present(i_epis)) then
          if (all(outflow_type(i_epis) /= (/ &
               "none         ", &
               "radical      ", &
               "instantaneous", &
               "constant     ", &
               "SF           ", &
               "SN           ", &
               "CCSN         ", &
               "SNIa         ", &
               "ejecta       ", &
               "file         "/))) &
               call error_message("The value of `outflow_type(" // &
               to_string(i_epis) // ")` should be ""none"", ""radical"", &
               &""instantaneous"", ""constant"", ""SF"", ""SN"", ""CCSN"", &
               &""SNIa"", ""ejecta"" or ""file"".")
       endif
    enddo

  end subroutine read_outflow_type

!#======================================================================

  subroutine read_outflow_inst_mass(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_outflow_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(outflow_inst_mass, rhs, indices_string, index_present)
    where (index_present(:)) outflow_inst_mass_set(:) = .true.
    call set_outflow_type(index_present, "instantaneous")

  end subroutine read_outflow_inst_mass

!#======================================================================

  subroutine read_outflow_const_mass(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_outflow_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(outflow_const_mass, rhs, indices_string, index_present)
    where (index_present(:)) outflow_const_mass_set(:) = .true.
    call set_outflow_type(index_present, "constant")

  end subroutine read_outflow_const_mass

!#======================================================================

  subroutine read_outflow_SF_factor(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_outflow_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(outflow_SF_factor, rhs, indices_string, index_present)
    where (index_present(:)) outflow_SF_factor_set(:) = .true.
    call set_outflow_type(index_present, "SF")

  end subroutine read_outflow_SF_factor

!#======================================================================

  subroutine read_outflow_SF_power(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_outflow_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(outflow_SF_power, rhs, indices_string, index_present)
    call set_outflow_type(index_present, "SF")

  end subroutine read_outflow_SF_power

!#======================================================================

  subroutine read_outflow_SN_mass(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_outflow_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(outflow_SN_mass, rhs, indices_string, index_present)
    where (index_present(:)) outflow_SN_mass_set(:) = .true.
    call set_outflow_type(index_present, "SN")

  end subroutine read_outflow_SN_mass

!#======================================================================

  subroutine read_outflow_SN_power(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_outflow_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(outflow_SN_power, rhs, indices_string, index_present)
    call set_outflow_type(index_present, "SN")

  end subroutine read_outflow_SN_power

!#======================================================================

  subroutine read_outflow_CCSN_mass(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_outflow_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(outflow_CCSN_mass, rhs, indices_string, index_present)
    where (index_present(:)) outflow_CCSN_mass_set(:) = .true.
    call set_outflow_type(index_present, "CCSN")

  end subroutine read_outflow_CCSN_mass

!#======================================================================

  subroutine read_outflow_CCSN_power(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_outflow_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(outflow_CCSN_power, rhs, indices_string, index_present)
    call set_outflow_type(index_present, "CCSN")

  end subroutine read_outflow_CCSN_power

!#======================================================================

  subroutine read_outflow_SNIa_mass(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_outflow_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(outflow_SNIa_mass, rhs, indices_string, index_present)
    where (index_present(:)) outflow_SNIa_mass_set(:) = .true.
    call set_outflow_type(index_present, "SNIa")

  end subroutine read_outflow_SNIa_mass

!#======================================================================

  subroutine read_outflow_SNIa_power(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_outflow_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(outflow_SNIa_power, rhs, indices_string, index_present)
    call set_outflow_type(index_present, "SNIa")

  end subroutine read_outflow_SNIa_power

!#======================================================================

  subroutine read_outflow_ejec_threshold(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_outflow_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(outflow_ejec_threshold, rhs, indices_string, index_present)
    where (index_present(:)) outflow_ejec_threshold_set(:) = .true.
    call set_outflow_type(index_present, "ejecta")

  end subroutine read_outflow_ejec_threshold

!#======================================================================

  subroutine read_outflow_ejec_factor(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_outflow_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(outflow_ejec_factor, rhs, indices_string, index_present)
    call set_outflow_type(index_present, "ejecta")

  end subroutine read_outflow_ejec_factor

!#======================================================================

  subroutine read_outflow_file(rhs, indices_string)

    use mod_strings, only : same_case_equal
    use mod_directories, only : scenarios_dir
    use mod_read_columns
    use mod_file_access, only : path_file
 
    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    integer :: i_epis
    logical, dimension(max_dim_outflow_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(outflow_file, rhs, indices_string, index_present)

    do i_epis = 1, max_dim_outflow_epis 
       if (index_present(i_epis)) then
          call read_columns(path_file(scenarios_dir, adjustl(outflow_file(i_epis))), &
               outflow_file_dim_time(i_epis), outflow_file_time(i_epis) % val, &
               outflow_file_rate(i_epis) % val)
       endif
    enddo
    
    where (index_present(:)) outflow_file_set(:) = .true.
    call set_outflow_type(index_present, "file")
    
  end subroutine read_outflow_file

!#======================================================================

  subroutine set_outflow_type(index_present, string)

    implicit none
    logical, dimension(:), intent(in) :: index_present
    character(len=*), intent(in) :: string
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    where (index_present(:)) outflow_type(:) = string

  end subroutine set_outflow_type

end module mod_read_outflow_param

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_yields

  use mod_types

  implicit none
  private
  type :: struct_yield
     integer :: dim_elem
     integer :: dim_mass
     character(len=std_string), dimension(:), pointer :: elem => null()
     real(DPR), dimension(:), pointer :: mass => null()
     real(DPR), dimension(:), pointer :: tot_ejec => null()
     real(DPR), dimension(:,:), pointer :: gross_ejec => null()
     real(DPR), dimension(:,:), pointer :: net_ejec => null()
  end type struct_yield
  public :: read_yields, compute_yields, fn_IRA_yield, struct_yield

contains

!#======================================================================
  
  subroutine read_yields(yields_set, &
       mass_Ch, dim_elem_SNIa, gross_ejec_SNIa, elem_SNIa, &
       X_sol, Y_sol, Z_sol, dim_elem_sol, abund_sol, elem_sol, &
       dim_tracks_file, &
       yield_LMW, yield_HMW, yield_CCSN)

    use mod_types
    use mod_directories, only : yields_dir
    use mod_file_access, only : open_file, close_file, path_file
    use mod_read_abundances, only : read_abundances
    use mod_constants, only : solar_abundances

    implicit none
    character(len=*) :: yields_set
    type(struct_yield), dimension(:), pointer :: yield_LMW, yield_HMW, &
         yield_CCSN
    real(DPR), intent(out) :: mass_Ch, X_sol, Y_sol, Z_sol
    integer, intent(out) :: dim_elem_SNIa, dim_elem_sol
    real(DPR), dimension(:), pointer :: gross_ejec_SNIa
    character(len=*), dimension(:), pointer :: elem_SNIa
    real(DPR), dimension(:), pointer :: abund_sol
    character(len=*), dimension(:), pointer :: elem_sol
    integer, intent(in) :: dim_tracks_file
!#......................................................................
    integer :: i, j, unit
    real(DPR) :: x
    character(std_string) :: skipped_string
    integer :: dim_elem, dim_mass
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# {Gross ejecta}(element) is the mass of this element which is ejected.
!# {Net ejecta}(element) = {gross ejecta}(element)
!#                         - {total mass ejected}*{initial abundance}(element).

    if (associated(yield_LMW)) deallocate(yield_LMW)
    allocate(yield_LMW(dim_tracks_file))
    if (associated(yield_HMW)) deallocate(yield_HMW)
    allocate(yield_HMW(dim_tracks_file))
    if (associated(yield_CCSN)) deallocate(yield_CCSN)
    allocate(yield_CCSN(dim_tracks_file))

!# Low-mass stars (ejecta during the 1st ("red") giant branch and the AGB phase).

    call open_file(unit, path_file(yields_dir, "gross_ejecta_LMW.txt"))
    read(unit,*) dim_elem
    do i = 1, dim_tracks_file
       yield_LMW(i) % dim_elem = dim_elem
       allocate(yield_LMW(i) % elem(dim_elem))
       read(unit, *) x, dim_mass
       yield_LMW(i) % dim_mass = dim_mass
       allocate(yield_LMW(i) % mass(dim_mass))
       allocate(yield_LMW(i) % tot_ejec(dim_mass))
       allocate(yield_LMW(i) % gross_ejec(dim_mass, dim_elem))
       allocate(yield_LMW(i) % net_ejec(dim_mass, dim_elem))
       read(unit, *) skipped_string, skipped_string, &
            yield_LMW(i) % elem(1:dim_elem)
       do j = 1, dim_mass
          read(unit, *) yield_LMW(i) % mass(j), &
               yield_LMW(i) % tot_ejec(j), &
               yield_LMW(i) % gross_ejec(j, 1:dim_elem)
       enddo
    enddo
    call close_file(unit)

    call open_file(unit, path_file(yields_dir, "net_ejecta_LMW.txt"))
    read(unit,*) dim_elem
    do i = 1, dim_tracks_file
       yield_LMW(i) % dim_elem = dim_elem
       read(unit, *) x, dim_mass
       yield_LMW(i) % dim_mass = dim_mass
       read(unit, *) skipped_string, skipped_string, &
            yield_LMW(i) % elem(1:dim_elem)
       do j = 1, dim_mass
          read(unit, *) yield_LMW(i) % mass(j), &
               yield_LMW(i) % tot_ejec(j), &
               yield_LMW(i) % net_ejec(j, 1:dim_elem)
       enddo
    enddo
    call close_file(unit)

!# High-mass stars.

    if (yields_set == "yields_Portinari.txt") then

!# Wind ("Wolf-Rayet") phase.

       call open_file(unit, path_file(yields_dir, "gross_ejecta_HMW_P.txt"))
       read(unit,*) dim_elem
       do i = 1, dim_tracks_file
          yield_HMW(i) % dim_elem = dim_elem
          allocate(yield_HMW(i) % elem(dim_elem))
          read(unit, *) x, dim_mass
          yield_HMW(i) % dim_mass = dim_mass
          allocate(yield_HMW(i) % mass(dim_mass))
          allocate(yield_HMW(i) % tot_ejec(dim_mass))
          allocate(yield_HMW(i) % gross_ejec(dim_mass, dim_elem))
          allocate(yield_HMW(i) % net_ejec(dim_mass, dim_elem))
          read(unit, *) skipped_string, skipped_string, &
               yield_HMW(i) % elem(1:dim_elem)
          do j = 1, dim_mass
             read(unit, *) yield_HMW(i) % mass(j), &
                  yield_HMW(i) % tot_ejec(j), &
                  yield_HMW(i) % gross_ejec(j, 1:dim_elem)
          enddo
       enddo
       call close_file(unit)

       call open_file(unit, path_file(yields_dir, "net_ejecta_HMW_P.txt"))
       read(unit,*) dim_elem
       do i = 1, dim_tracks_file
          yield_HMW(i) % dim_elem = dim_elem
          read(unit, *) x, dim_mass
          yield_HMW(i) % dim_mass = dim_mass
          read(unit, *) skipped_string, skipped_string, &
               yield_HMW(i) % elem(1:dim_elem)
          do j = 1, dim_mass
             read(unit, *) yield_HMW(i) % mass(j), &
                  yield_HMW(i) % tot_ejec(j), &
                  yield_HMW(i) % net_ejec(j, 1:dim_elem)
          enddo
       enddo
       call close_file(unit)

!# Supernova phase.

       call open_file(unit, path_file(yields_dir, "gross_ejecta_CCSN_P.txt"))
       read(unit,*) dim_elem
       do i = 1, dim_tracks_file
          yield_CCSN(i) % dim_elem = dim_elem
          allocate(yield_CCSN(i) % elem(dim_elem))
          read(unit, *) x, dim_mass
          yield_CCSN(i) % dim_mass = dim_mass
          allocate(yield_CCSN(i) % mass(dim_mass))
          allocate(yield_CCSN(i) % tot_ejec(dim_mass))
          allocate(yield_CCSN(i) % gross_ejec(dim_mass, dim_elem))
          allocate(yield_CCSN(i) % net_ejec(dim_mass, dim_elem))
          read(unit, *) skipped_string, skipped_string, &
               yield_CCSN(i) % elem(1:dim_elem)
          do j = 1, dim_mass
             read(unit, *) yield_CCSN(i) % mass(j), &
                  yield_CCSN(i) % tot_ejec(j), &
                  yield_CCSN(i) % gross_ejec(j, 1:dim_elem)
          enddo
       enddo
       call close_file(unit)

       call open_file(unit, path_file(yields_dir, "net_ejecta_CCSN_P.txt"))
       read(unit,*) dim_elem
       do i = 1, dim_tracks_file
          yield_CCSN(i) % dim_elem = dim_elem
          read(unit, *) x, dim_mass
          yield_CCSN(i) % dim_mass = dim_mass
          read(unit, *) skipped_string, skipped_string, &
               yield_CCSN(i) % elem(1:dim_elem)
          do j = 1, dim_mass
             read(unit, *) yield_CCSN(i) % mass(j), &
                  yield_CCSN(i) % tot_ejec(j), &
                  yield_CCSN(i) % net_ejec(j, 1:dim_elem)
          enddo
       enddo
       call close_file(unit)

    else if (yields_set == "yields_Woosley_Weaver.txt") then !# Use Woosley & Weaver \
!# yields for high-mass stars (no stellar winds).

       call open_file(unit, path_file(yields_dir, "gross_ejecta_CCSN_WW.txt"))
       read(unit,*) dim_elem
       do i = 1, dim_tracks_file
          yield_CCSN(i) % dim_elem = dim_elem
          allocate(yield_CCSN(i) % elem(dim_elem))
          read(unit, *) x, dim_mass
          yield_CCSN(i) % dim_mass = dim_mass
          allocate(yield_CCSN(i) % mass(dim_mass))
          allocate(yield_CCSN(i) % tot_ejec(dim_mass))
          allocate(yield_CCSN(i) % gross_ejec(dim_mass, dim_elem))
          allocate(yield_CCSN(i) % net_ejec(dim_mass, dim_elem))
          read(unit, *) skipped_string, skipped_string, &
               yield_CCSN(i) % elem(1:dim_elem)
          do j = 1, dim_mass
             read(unit, *) yield_CCSN(i) % mass(j), &
                  yield_CCSN(i) % tot_ejec(j), &
                  yield_CCSN(i) % gross_ejec(j, 1:dim_elem)
          enddo
       enddo
       call close_file(unit)

       call open_file(unit, path_file(yields_dir, "net_ejecta_CCSN_WW.txt"))
       read(unit,*) dim_elem
       do i = 1, dim_tracks_file
          yield_CCSN(i) % dim_elem = dim_elem
          read(unit, *) x, dim_mass
          yield_CCSN(i) % dim_mass = dim_mass
          read(unit, *) skipped_string, skipped_string, &
               yield_CCSN(i) % elem(1:dim_elem)
          do j = 1, dim_mass
             read(unit, *) yield_CCSN(i) % mass(j), &
                  yield_CCSN(i) % tot_ejec(j), &
                  yield_CCSN(i) % net_ejec(j, 1:dim_elem)
          enddo
       enddo
       call close_file(unit)

    else

       write(*, "(a)") "Yields """, yields_set, """ unavailable. Stopped."
       stop

    endif

!# SNIa.

    call read_abundances(path_file(yields_dir, "W7.txt"), dim_elem_SNIa, &
         gross_ejec_SNIa, elem_SNIa)
    mass_Ch = sum(gross_ejec_SNIa(1:dim_elem_SNIa))

!# Solar abundances.

    call read_abundances(path_file(yields_dir, solar_abundances), dim_elem_sol, abund_sol, elem_sol)
    X_sol = sum(abund_sol, mask = elem_sol == "1H" .or. elem_sol == "2H")
    Y_sol = sum(abund_sol, mask = elem_sol == "3He" .or. elem_sol == "4He")
    Z_sol = 1 - X_sol - Y_sol
    
  end subroutine read_yields

!#======================================================================

  subroutine compute_yields(i_tracks_file, Y_track, Z_track, yields_set, &
       yield_LMW, yield_HMW, yield_CCSN, &
       gross_ejec_SNIa, elem_SNIa, &
       mass_Ch, Z_sol, abund_sol, elem_sol, &
       dim_mass_yields, mass_yields, ejec_tot, ejec_elem, &
       ejec_tot_SNIa, ejec_elem_SNIa, &
       carb_dust_LMW, sil_dust_LMW, carb_dust_HMW, sil_dust_HMW, &
       carb_dust_CCSN, sil_dust_CCSN, carb_dust_SNIa, sil_dust_SNIa, &
       O_dust_LMW, O_dust_HMW, O_dust_CCSN, O_dust_SNIa)

    use mod_types
    use mod_constants, only : &
         dim_elem, elem_id, A_C12, A_C13, &
         A_O16, A_O17, A_O18, A_Mg24, A_Si28, A_S32, A_Ca40, A_Ti48, A_Fe56
    use mod_loc, only : i_loc
    
    implicit none
    integer, intent(in) :: i_tracks_file
    character(len=*), intent(in) :: yields_set
    type(struct_yield), dimension(:), intent(in) :: yield_LMW, yield_HMW, &
         yield_CCSN    
    integer, intent(out) :: dim_mass_yields
    real(DPR), intent(out) :: carb_dust_SNIa, sil_dust_SNIa, O_dust_SNIa
    real(DPR), dimension(:), pointer :: ejec_tot
    real(DPR), dimension(:,:), pointer :: ejec_elem
    real(DPR), dimension(:), pointer :: mass_yields, carb_dust_LMW, &
         sil_dust_LMW, carb_dust_HMW, sil_dust_HMW, carb_dust_CCSN, &
         sil_dust_CCSN, O_dust_LMW, O_dust_HMW, O_dust_CCSN
    real(DPR), intent(out) :: ejec_tot_SNIa
    real(DPR), dimension(0:), intent(out) :: ejec_elem_SNIa
    real(DPR), intent(in) :: Y_track, Z_track, mass_Ch, Z_sol
    real(DPR), dimension(:), intent(in) :: gross_ejec_SNIa, abund_sol
    character(len=*), dimension(:), intent(in) :: elem_sol, elem_SNIa
!#......................................................................
    integer :: i_Z, i_O, i_C, i_Fe, i_He, i_N, i_Ne, i_Mg, i_Si, i_S, i_Ca

    real(DPR) :: nb_atoms_C, nb_atoms_O
    integer :: i, j
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    i_Z = 0
    i_O = i_loc(elem_id, "O")
    i_C = i_loc(elem_id, "C")
    i_Fe = i_loc(elem_id, "Fe")
    i_He = i_loc(elem_id, "He")
    i_N = i_loc(elem_id, "N")
    i_Ne = i_loc(elem_id, "Ne")
    i_Mg = i_loc(elem_id, "Mg")
    i_Si = i_loc(elem_id, "Si")
    i_S = i_loc(elem_id, "S")
    i_Ca = i_loc(elem_id, "Ca")

    if (yields_set == "yields_Woosley_Weaver.txt" .or. &
         yields_set == "yields_Portinari.txt") then
       dim_mass_yields = 1 + yield_LMW(i_tracks_file) % dim_mass &
            + yield_CCSN(i_tracks_file) % dim_mass
    
       if (associated(ejec_tot)) deallocate(ejec_tot)
       allocate(ejec_tot(dim_mass_yields))
       if (associated(ejec_elem)) deallocate(ejec_elem)
       allocate(ejec_elem(dim_mass_yields, 0:dim_elem))
       if (associated(mass_yields)) deallocate(mass_yields)
       allocate(mass_yields(dim_mass_yields))
       
       if (associated(carb_dust_LMW)) deallocate(carb_dust_LMW)
       allocate(carb_dust_LMW(dim_mass_yields))
       if (associated(sil_dust_LMW)) deallocate(sil_dust_LMW)
       allocate(sil_dust_LMW(dim_mass_yields))
       if (associated(O_dust_LMW)) deallocate(O_dust_LMW)
       allocate(O_dust_LMW(dim_mass_yields))
       
       if (associated(carb_dust_HMW)) deallocate(carb_dust_HMW)
       allocate(carb_dust_HMW(dim_mass_yields))
       if (associated(sil_dust_HMW)) deallocate(sil_dust_HMW)
       allocate(sil_dust_HMW(dim_mass_yields))
       if (associated(O_dust_HMW)) deallocate(O_dust_HMW)
       allocate(O_dust_HMW(dim_mass_yields))

       if (associated(carb_dust_CCSN)) deallocate(carb_dust_CCSN)
       allocate(carb_dust_CCSN(dim_mass_yields))
       if (associated(sil_dust_CCSN)) deallocate(sil_dust_CCSN)
       allocate(sil_dust_CCSN(dim_mass_yields))
       if (associated(O_dust_CCSN)) deallocate(O_dust_CCSN)
       allocate(O_dust_CCSN(dim_mass_yields))
       
    else
       write(*, "(a)") "Yields """, yields_set, """ unavailable. Stopped."
       stop
    endif


!# For the purpose of extrapolation below `mass_LMW(.,1)` (~= 0.8 M_sol), we assume that
!#    (1) the star with the initial mass `mass_LMW(.,1)`, denoted by "LS" (lightest star)
!#        hereafter, will end as a CO white dwarf;
!#    (2) the mass of the stellar remnant for all stars ending as CO white dwarfs and
!#        with an initial mass below `mass_LMW(.,1)` is the same as for LS;
!#    (3) all stars "dying" later than LS and before the maximal time for which SSPs
!#        are computed end as CO white dwarfs.
!# We therefore add an object with an initial mass and a remnant's mass equal to the
!# remnant's mass of LS; this object does not eject anything.

    mass_yields(1) = yield_LMW(i_tracks_file) % mass(1)-yield_LMW(i_tracks_file) % tot_ejec(1)
    ejec_tot(:) = 0
    ejec_elem(:,0:) = 0
!# Following assignments mandatory because, although `carb_dust_LMW` (for instance)
!# is defined for all stars, it is computed hereafter only for low-mass stars.
!# It might also retain the value computed for `i_tracks_file-1` if object #i
!# corresponds to a low-mass star for yields `i_tracks_file-1` and to a high-mass star
!# for yields `i_tracks_file`.
!# Similarly for other `*_LMW`, `*_HMW` and `*_CCSN` quantities.
    carb_dust_LMW(:) = 0
    sil_dust_LMW(:) = 0
    O_dust_LMW(:) = 0
    carb_dust_HMW(:) = 0
    sil_dust_HMW(:) = 0  
    O_dust_HMW(:) = 0
    carb_dust_CCSN(:) = 0
    sil_dust_CCSN(:) = 0
    O_dust_CCSN(:) = 0

!# ??? Should one modify instead the interpolation routine `interp_lin_lin` used in
!# "mod_remnants_ejec_SN.f90" to ensure, in case of extrapolation below the
!# mass of LS, that
!#    (1) the total ejected mass is non-negative and less than the initial mass;
!#    (2) the mass of the gross ejecta of each element is non-negative;
!#    (3) their sum is consistent with the total ejected mass?

!#......................................................................
!# Low-mass stars.

    dim_mass_yields = 1
    do i = 1, yield_LMW(i_tracks_file) % dim_mass
       dim_mass_yields = dim_mass_yields+1
       mass_yields(dim_mass_yields) = yield_LMW(i_tracks_file) % mass(i)
!#
       ejec_tot(dim_mass_yields) = yield_LMW(i_tracks_file) % tot_ejec(i)
!# Net yield of metals.
       ejec_elem(dim_mass_yields, i_Z) = -sum(yield_LMW(i_tracks_file) % net_ejec(i, :), &
            mask = yield_LMW(i_tracks_file) % elem(:) == "1H" .or. &
            yield_LMW(i_tracks_file) % elem(:) == "3He" .or. &
            yield_LMW(i_tracks_file) % elem(:) == "4He")
!# Net yield of oxygen.
       ejec_elem(dim_mass_yields, i_O) = sum(yield_LMW(i_tracks_file) % net_ejec(i, :), &
            mask = yield_LMW(i_tracks_file) % elem(:) == "16O" .or. &
            yield_LMW(i_tracks_file) % elem(:) == "17O" .or. &
            yield_LMW(i_tracks_file) % elem(:) == "18O")
!# Net yield of carbon.
       ejec_elem(dim_mass_yields, i_C) = sum(yield_LMW(i_tracks_file) % net_ejec(i, :), &
            mask = yield_LMW(i_tracks_file) % elem(:) == "12C" .or. &
            yield_LMW(i_tracks_file) % elem(:) == "13C")
!# Net yield of iron.
       ejec_elem(dim_mass_yields, i_Fe) = sum(yield_LMW(i_tracks_file) % net_ejec(i, :), &
            mask = yield_LMW(i_tracks_file) % elem(:) == "56Fe")
!# Net yield of helium.
       ejec_elem(dim_mass_yields, i_He) = sum(yield_LMW(i_tracks_file) % net_ejec(i, :), &
            mask = yield_LMW(i_tracks_file) % elem(:) == "3He" .or. &
            yield_LMW(i_tracks_file) % elem(:) == "4He")
!# Net yield of nitrogen.
       ejec_elem(dim_mass_yields, i_N) = sum(yield_LMW(i_tracks_file) % net_ejec(i, :), &
            mask = yield_LMW(i_tracks_file) % elem(:) == "14N" .or. &
            yield_LMW(i_tracks_file) % elem(:) == "15N")
!# Net yield of neon.
       ejec_elem(dim_mass_yields, i_Ne) = sum(yield_LMW(i_tracks_file) % net_ejec(i, :), &
            mask = yield_LMW(i_tracks_file) % elem(:) == "20Ne" .or. &
            yield_LMW(i_tracks_file) % elem(:) == "22Ne")
!# Net yield of magnesium.
       ejec_elem(dim_mass_yields, i_Mg) = sum(yield_LMW(i_tracks_file) % net_ejec(i, :), &
            mask = yield_LMW(i_tracks_file) % elem(:) == "24Mg")
!# Net yield of silicon.
       ejec_elem(dim_mass_yields, i_Si) = sum(yield_LMW(i_tracks_file) % net_ejec(i, :), &
            mask = yield_LMW(i_tracks_file) % elem(:) == "28Si")
!# Net yield of sulfur.
       ejec_elem(dim_mass_yields, i_S) = sum(yield_LMW(i_tracks_file) % net_ejec(i, :), &
            mask = yield_LMW(i_tracks_file) % elem(:) == "32S")
!# Net yield of calcium.
       ejec_elem(dim_mass_yields, i_Ca) = sum(yield_LMW(i_tracks_file) % net_ejec(i, :), &
            mask = yield_LMW(i_tracks_file) % elem(:) == "40Ca")
       nb_atoms_C = &
            sum(yield_LMW(i_tracks_file) % gross_ejec(i, :), &
            mask = yield_LMW(i_tracks_file) % elem(:) == "12C")/A_C12 &
            + sum(yield_LMW(i_tracks_file) % gross_ejec(i, :), &
            mask = yield_LMW(i_tracks_file) % elem(:) == "13C")/A_C13
       nb_atoms_O = &
            sum(yield_LMW(i_tracks_file) % gross_ejec(i, :), &
            mask = yield_LMW(i_tracks_file) % elem(:) == "16O")/A_O16 &
            + sum(yield_LMW(i_tracks_file) % gross_ejec(i, :), &
            mask = yield_LMW(i_tracks_file) % elem(:) == "17O")/A_O17 &
            + sum(yield_LMW(i_tracks_file) % gross_ejec(i, :), &
            mask = yield_LMW(i_tracks_file) % elem(:) == "18O")/A_O18

       if (nb_atoms_C > nb_atoms_O) then

!# Because the formation of the CO molecule is much more efficient than that of dust in stellar winds,
!# carbon dust is produced if the number of carbon atoms is larger than that of oxygen atoms: all oxygen atoms
!# are used for CO (so, no silicate dust may be produced, since oxygen is needed for it), and all carbon
!# atoms not used for CO may be included in dust. Note that hydrogen atoms in carbon dust are neglected.
!# The real quantity of carbon or silicate dust formed around low-mass stars is
!# determined by `LMW_carb_deplet` and `LMW_sil_deplet`.

          carb_dust_LMW(dim_mass_yields) = &
               sum(yield_LMW(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_LMW(i_tracks_file) % elem(:) == "12C" &
               .or. yield_LMW(i_tracks_file) % elem(:) == "13C") &
               -A_C12/A_O16* & !# ??? Not fully consistent: A_C13, A_O17 and A_O18 should be used too.
               sum(yield_LMW(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_LMW(i_tracks_file) % elem(:) == "16O" &
               .or. yield_LMW(i_tracks_file) % elem(:) == "17O" .or. &
               yield_LMW(i_tracks_file) % elem(:) == "18O")
          sil_dust_LMW(dim_mass_yields) = 0
          O_dust_LMW(dim_mass_yields) = 0
       else

!# If the number of oxygen atoms is larger than that of carbon atoms, only silicate dust is produced: to each
!# magnesium, silicon, sulfur, calcium or iron atom is associated one oxygen atom, in the mean. It is assumed
!# that the number of oxygen atoms is sufficient for that.

          carb_dust_LMW(dim_mass_yields) = 0
          sil_dust_LMW(dim_mass_yields) = &
               sum(yield_LMW(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_LMW(i_tracks_file) % elem(:) == "24Mg") &
               + sum(yield_LMW(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_LMW(i_tracks_file) % elem(:) == "28Si") &
               + sum(yield_LMW(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_LMW(i_tracks_file) % elem(:) == "32S") &
               + sum(yield_LMW(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_LMW(i_tracks_file) % elem(:) == "40Ca") &
               + sum(yield_LMW(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_LMW(i_tracks_file) % elem(:) == "56Fe")
          O_dust_LMW(dim_mass_yields) = &
               sum(yield_LMW(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_LMW(i_tracks_file) % elem(:) == "24Mg")*A_O16/A_Mg24 &
               + sum(yield_LMW(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_LMW(i_tracks_file) % elem(:) == "28Si")*A_O16/A_Si28 &
               + sum(yield_LMW(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_LMW(i_tracks_file) % elem(:) == "32S")*A_O16/A_S32 &
               + sum(yield_LMW(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_LMW(i_tracks_file) % elem(:) == "40Ca")*A_O16/A_Ca40 &
               + sum(yield_LMW(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_LMW(i_tracks_file) % elem(:) == "56Fe")*A_O16/A_Fe56

!# ??? The masses of the isotopes should be used too.
       endif
    enddo

!#......................................................................

!# Woosley & Weaver.

    if (yields_set == "yields_Woosley_Weaver.txt") then
       do i = 1, yield_CCSN(i_tracks_file) % dim_mass
          dim_mass_yields = dim_mass_yields+1
          mass_yields(dim_mass_yields) = yield_CCSN(i_tracks_file) % mass(i)
          ejec_tot(dim_mass_yields) = yield_CCSN(i_tracks_file) % tot_ejec(i)
!# Net yield of metals.
          ejec_elem(dim_mass_yields, i_Z) = -sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "H" .or. &
               yield_CCSN(i_tracks_file) % elem(:) == "He")
!# Net yield of oxygen.
          ejec_elem(dim_mass_yields, i_O) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "O")
!# Net yield of carbon.
          ejec_elem(dim_mass_yields, i_C) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "C")
!# Net yield of iron.
          ejec_elem(dim_mass_yields, i_Fe) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "Fe")
!# Net yield of helium.
          ejec_elem(dim_mass_yields, i_He) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "He")
!# Net yield of nitrogen.
          ejec_elem(dim_mass_yields, i_N) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "N")
!# Net yield of neon.
          ejec_elem(dim_mass_yields, i_Ne) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "Ne")
!# Net yield of magnesium.
          ejec_elem(dim_mass_yields, i_Mg) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "Mg")
!# Net yield of silicon.
          ejec_elem(dim_mass_yields, i_Si) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "Si")
!# Net yield of sulfur.
          ejec_elem(dim_mass_yields, i_S) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "S")
!# Net yield of calcium.
          ejec_elem(dim_mass_yields, i_Ca) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "Ca")
!# Gross yield of dust.
          carb_dust_CCSN(dim_mass_yields) = &
               sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "C")

          sil_dust_CCSN(dim_mass_yields) = &
               sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "Mg") &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "Si") &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "S") &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "Ca") &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "Ti") &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "Fe")
          O_dust_CCSN(dim_mass_yields) = &
               sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "Mg")*A_O16/A_Mg24 &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "Si")*A_O16/A_Si28 &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "S")*A_O16/A_S32 &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "Ca")*A_O16/A_Ca40 &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "Ti")*A_O16/A_Ti48 &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "Fe")*A_O16/A_Fe56
       enddo

    else if (yields_set == "yields_Portinari.txt") then

!# Portinari et al.
!# Only supernova ejecta for lower high-mass stars.

       do i = 1, yield_CCSN(i_tracks_file) % dim_mass-yield_HMW(i_tracks_file) % dim_mass
          dim_mass_yields = dim_mass_yields+1
          mass_yields(dim_mass_yields) = yield_CCSN(i_tracks_file) % mass(i)
          ejec_tot(dim_mass_yields) = yield_CCSN(i_tracks_file) % tot_ejec(i)
!# Net yield of metals.
          ejec_elem(dim_mass_yields, i_Z) = -sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "1H" .or. &
               yield_CCSN(i_tracks_file) % elem(:) == "3He" .or. &
               yield_CCSN(i_tracks_file) % elem(:) == "4He")
!# Net yield of oxygen.
          ejec_elem(dim_mass_yields, i_O) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "16O" .or. &
               yield_CCSN(i_tracks_file) % elem(:) == "17O" .or. &
               yield_CCSN(i_tracks_file) % elem(:) == "18O")
!# Net yield of carbon.
          ejec_elem(dim_mass_yields, i_C) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "12C" .or. &
               yield_CCSN(i_tracks_file) % elem(:) == "13C")
!# Net yield of iron.
          ejec_elem(dim_mass_yields, i_Fe) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "56Fe")
!# Net yield of helium.
          ejec_elem(dim_mass_yields, i_He) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "3He" .or. &
               yield_CCSN(i_tracks_file) % elem(:) == "4He")
!# Net yield of nitrogen.
          ejec_elem(dim_mass_yields, i_N) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "14N" .or. &
               yield_CCSN(i_tracks_file) % elem(:) == "15N")
!# Net yield of neon.
          ejec_elem(dim_mass_yields, i_Ne) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "20Ne" .or. &
               yield_CCSN(i_tracks_file) % elem(:) == "22Ne")
!# Net yield of magnesium.
          ejec_elem(dim_mass_yields, i_Mg) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "24Mg")
!# Net yield of silicon.
          ejec_elem(dim_mass_yields, i_Si) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "28Si")
!# Net yield of sulfur.
          ejec_elem(dim_mass_yields, i_S) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "32S")
!# Net yield of calcium.
          ejec_elem(dim_mass_yields, i_Ca) = sum(yield_CCSN(i_tracks_file) % net_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "40Ca")

!# No CO is formed: all the carbon, magnesium, silicon, sulfur, calcium and iron atoms may be used to form dust.
!# Note that hydrogen atoms in carbon dust are neglected.
!# To each magnesium, silicon, sulfur, calcium, titanium (for Woosley and Weaver yields only), or iron atom is associated
!# one oxygen atom, in the mean. It is assumed that the number of oxygen atoms is sufficient for that.
!# The real quantity of carbon or silicate dust formed around core-collapse
!# supernovae is determined by `CCSN_carb_deplet` and
!# `CCSN_sil_deplet`.

          carb_dust_CCSN(dim_mass_yields) = &
               sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "12C" &
               .or. yield_CCSN(i_tracks_file) % elem(:) == "13C")

          sil_dust_CCSN(dim_mass_yields) = &
               sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "24Mg") &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "28Si") &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "32S") &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "40Ca") &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "56Fe")

          O_dust_CCSN(dim_mass_yields) = &
               sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "24Mg")*A_O16/A_Mg24 &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "28Si")*A_O16/A_Si28 &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "32S")*A_O16/A_S32 &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "40Ca")*A_O16/A_Ca40 &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "56Fe")*A_O16/A_Fe56
       enddo

!#......................................................................

!# Wind (Wolf-Rayet) + supernova ejecta for higher high-mass stars.

       do i = 1, yield_HMW(i_tracks_file) % dim_mass
          dim_mass_yields = dim_mass_yields+1
          j = i+yield_CCSN(i_tracks_file) % dim_mass-yield_HMW(i_tracks_file) % dim_mass
          mass_yields(dim_mass_yields) = yield_HMW(i_tracks_file) % mass(i)
          ejec_tot(dim_mass_yields) = yield_HMW(i_tracks_file) % tot_ejec(i)+yield_CCSN(i_tracks_file) % tot_ejec(j)
!# Net yield of metals.
          ejec_elem(dim_mass_yields, i_Z) = -sum(yield_CCSN(i_tracks_file) % net_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "1H" .or. &
               yield_CCSN(i_tracks_file) % elem(:) == "3He" .or. &
               yield_CCSN(i_tracks_file) % elem(:) == "4He") &
               - sum(yield_HMW(i_tracks_file) % net_ejec(i, :), &
               mask = yield_HMW(i_tracks_file) % elem(:) == "1H" .or. &
               yield_HMW(i_tracks_file) % elem(:) == "3He" .or. &
               yield_HMW(i_tracks_file) % elem(:) == "4He")
!# Net yield of oxygen.
          ejec_elem(dim_mass_yields, i_O) = sum(yield_CCSN(i_tracks_file) % net_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "16O" .or. &
               yield_CCSN(i_tracks_file) % elem(:) == "17O" .or. &
               yield_CCSN(i_tracks_file) % elem(:) == "18O") &
               + sum(yield_HMW(i_tracks_file) % net_ejec(i, :), &
               mask = yield_HMW(i_tracks_file) % elem(:) == "16O" .or. &
               yield_HMW(i_tracks_file) % elem(:) == "17O" .or. &
               yield_HMW(i_tracks_file) % elem(:) == "18O")
!# Net yield of carbon.
          ejec_elem(dim_mass_yields, i_C) = sum(yield_CCSN(i_tracks_file) % net_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "12C" .or. &
               yield_CCSN(i_tracks_file) % elem(:) == "13C") &
               + sum(yield_HMW(i_tracks_file) % net_ejec(i, :), &
               mask = yield_HMW(i_tracks_file) % elem(:) == "12C" .or. &
               yield_HMW(i_tracks_file) % elem(:) == "13C")
!# Net yield of iron.
          ejec_elem(dim_mass_yields, i_Fe) = sum(yield_CCSN(i_tracks_file) % net_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "56Fe") &
               + sum(yield_HMW(i_tracks_file) % net_ejec(i, :), &
               mask = yield_HMW(i_tracks_file) % elem(:) == "56Fe")
!# Net yield of helium.
          ejec_elem(dim_mass_yields, i_He) = sum(yield_CCSN(i_tracks_file) % net_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "3He" .or. &
               yield_CCSN(i_tracks_file) % elem(:) == "4He") &
               + sum(yield_HMW(i_tracks_file) % net_ejec(i, :), &
               mask = yield_HMW(i_tracks_file) % elem(:) == "3He" .or. &
               yield_HMW(i_tracks_file) % elem(:) == "4He")
!# Net yield of nitrogen.
          ejec_elem(dim_mass_yields, i_N) = sum(yield_CCSN(i_tracks_file) % net_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "14N" .or. &
               yield_CCSN(i_tracks_file) % elem(:) == "15N") &
               + sum(yield_HMW(i_tracks_file) % net_ejec(i, :), &
               mask = yield_HMW(i_tracks_file) % elem(:) == "14N" .or. &
               yield_HMW(i_tracks_file) % elem(:) == "15N")
!# Net yield of neon.
          ejec_elem(dim_mass_yields, i_Ne) = sum(yield_CCSN(i_tracks_file) % net_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "20Ne" .or. &
               yield_CCSN(i_tracks_file) % elem(:) == "22Ne") &
               + sum(yield_HMW(i_tracks_file) % net_ejec(i, :), &
               mask = yield_HMW(i_tracks_file) % elem(:) == "20Ne" .or. &
               yield_HMW(i_tracks_file) % elem(:) == "22Ne")
!# Net yield of magnesium.
          ejec_elem(dim_mass_yields, i_Mg) = sum(yield_CCSN(i_tracks_file) % net_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "24Mg") &
               + sum(yield_HMW(i_tracks_file) % net_ejec(i, :), &
               mask = yield_HMW(i_tracks_file) % elem(:) == "24Mg")
!# Net yield of silicon.
          ejec_elem(dim_mass_yields, i_Si) = sum(yield_CCSN(i_tracks_file) % net_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "28Si") &
               + sum(yield_HMW(i_tracks_file) % net_ejec(i, :), &
               mask = yield_HMW(i_tracks_file) % elem(:) == "28Si")
!# Net yield of sulfur.
          ejec_elem(dim_mass_yields, i_S) = sum(yield_CCSN(i_tracks_file) % net_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "32S") &
               + sum(yield_HMW(i_tracks_file) % net_ejec(i, :), &
               mask = yield_HMW(i_tracks_file) % elem(:) == "32S")
!# Net yield of calcium.
          ejec_elem(dim_mass_yields, i_Ca) = sum(yield_CCSN(i_tracks_file) % net_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "40Ca") &
               + sum(yield_HMW(i_tracks_file) % net_ejec(i, :), &
               mask = yield_HMW(i_tracks_file) % elem(:) == "40Ca")

!# Gross yield of dust.
!# No CO is formed: all the carbon, magnesium, silicon, sulfur, calcium and iron atoms may be used to form dust.
!# Note that hydrogen atoms in carbon dust are neglected.
!# To each magnesium, silicon, sulfur, calcium or iron atom is associated one oxygen atom, in the mean.
!# It is assumed that the number of oxygen atoms is sufficient for that.
!# The real quantity of carbon or silicate dust formed around core-collapse
!# supernovae is determined by `CCSN_carb_deplet` and
!# `CCSN_sil_deplet`.

          carb_dust_CCSN(dim_mass_yields) = &
               sum(yield_CCSN(i_tracks_file) % gross_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "12C" &
               .or. yield_CCSN(i_tracks_file) % elem(:) == "13C")

          sil_dust_CCSN(dim_mass_yields) = &
               sum(yield_CCSN(i_tracks_file) % gross_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "24Mg") &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "28Si") &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "32S") &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "40Ca") &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "56Fe")

          O_dust_CCSN(dim_mass_yields) = &
               sum(yield_CCSN(i_tracks_file) % gross_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "24Mg")*A_O16/A_Mg24 &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "28Si")*A_O16/A_Si28 &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "32S")*A_O16/A_S32 &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "40Ca")*A_O16/A_Ca40 &
               + sum(yield_CCSN(i_tracks_file) % gross_ejec(j, :), &
               mask = yield_CCSN(i_tracks_file) % elem(:) == "56Fe")*A_O16/A_Fe56

          nb_atoms_C = &
               sum(yield_HMW(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_HMW(i_tracks_file) % elem(:) == "12C")/A_C12 &
               + sum(yield_HMW(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_HMW(i_tracks_file) % elem(:) == "13C")/A_C13
          nb_atoms_O = &
               sum(yield_HMW(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_HMW(i_tracks_file) % elem(:) == "16O")/A_O16 &
               + sum(yield_HMW(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_HMW(i_tracks_file) % elem(:) == "17O")/A_O17 &
               + sum(yield_HMW(i_tracks_file) % gross_ejec(i, :), &
               mask = yield_HMW(i_tracks_file) % elem(:) == "18O")/A_O18

          if (nb_atoms_C > nb_atoms_O) then

!# Because the formation of the CO molecule is much more efficient than that of dust in stellar winds,
!# carbon dust is produced if the number of carbon atoms is larger than that of oxygen atoms: all oxygen
!# atoms are used for CO (so, no silicate dust may be produced, since oxygen is needed for it), and all carbon
!# atoms not used for CO may be included in dust. Note that hydrogen atoms in carbon dust are neglected.
!# The real quantity of carbon or silicate dust formed in the winds of
!# high-mass stars is determined by `HMW_carb_deplet` and `HMW_sil_deplet`.

             carb_dust_HMW(dim_mass_yields) = &
                  sum(yield_HMW(i_tracks_file) % gross_ejec(i, :), &
                  mask = yield_HMW(i_tracks_file) % elem(:) == "12C" &
                  .or. yield_HMW(i_tracks_file) % elem(:) == "13C") &
                  -A_C12/A_O16* & !# ??? Not fully consistent: A_C13, A_O17 and A_O18 should be used too.
                  sum(yield_HMW(i_tracks_file) % gross_ejec(i, :), &
                  mask = yield_HMW(i_tracks_file) % elem(:) == "16O" &
                  .or. yield_HMW(i_tracks_file) % elem(:) == "17O" .or. &
                  yield_HMW(i_tracks_file) % elem(:) == "18O")
             sil_dust_HMW(dim_mass_yields) = 0
             O_dust_HMW(dim_mass_yields) = 0
          else

!# If the number of oxygen atoms is larger than that of carbon atoms, only silicate dust is produced: to each
!# magnesium, silicon, sulfur, calcium or iron atom is associated one oxygen atom, in the mean. It is assumed
!# that the number of oxygen atoms is sufficient for that.

             carb_dust_HMW(dim_mass_yields) = 0

             sil_dust_HMW(dim_mass_yields) = &
                  sum(yield_HMW(i_tracks_file) % gross_ejec(i, :), &
                  mask = yield_HMW(i_tracks_file) % elem(:) == "24Mg") &
                  + sum(yield_HMW(i_tracks_file) % gross_ejec(i, :), &
                  mask = yield_HMW(i_tracks_file) % elem(:) == "28Si") &
                  + sum(yield_HMW(i_tracks_file) % gross_ejec(i, :), &
                  mask = yield_HMW(i_tracks_file) % elem(:) == "32S") &
                  + sum(yield_HMW(i_tracks_file) % gross_ejec(i, :), &
                  mask = yield_HMW(i_tracks_file) % elem(:) == "40Ca") &
                  + sum(yield_HMW(i_tracks_file) % gross_ejec(i, :), &
                  mask = yield_HMW(i_tracks_file) % elem(:) == "56Fe")

             O_dust_HMW(dim_mass_yields) = &
                  sum(yield_HMW(i_tracks_file) % gross_ejec(i, :), &
                  mask = yield_HMW(i_tracks_file) % elem(:) == "24Mg")*A_O16/A_Mg24 &
                  + sum(yield_HMW(i_tracks_file) % gross_ejec(i, :), &
                  mask = yield_HMW(i_tracks_file) % elem(:) == "28Si")*A_O16/A_Si28 &
                  + sum(yield_HMW(i_tracks_file) % gross_ejec(i, :), &
                  mask = yield_HMW(i_tracks_file) % elem(:) == "32S")*A_O16/A_S32 &
                  + sum(yield_HMW(i_tracks_file) % gross_ejec(i, :), &
                  mask = yield_HMW(i_tracks_file) % elem(:) == "40Ca")*A_O16/A_Ca40 &
                  + sum(yield_HMW(i_tracks_file) % gross_ejec(i, :), &
                  mask = yield_HMW(i_tracks_file) % elem(:) == "56Fe")*A_O16/A_Fe56
!# ??? The masses of the isotopes should be used too.
          endif
       enddo
    endif

!#......................................................................

!# SNIa
    ejec_tot_SNIa = mass_Ch

!# Net yield of metals.
    ejec_elem_SNIa(i_Z) = mass_Ch-Z_track*ejec_tot_SNIa

!# Net yield of oxygen.
    ejec_elem_SNIa(i_O) = sum(gross_ejec_SNIa, mask = elem_SNIa == "16O" .or. &
         elem_SNIa == "17O" .or. elem_SNIa == "18O") &
         -ejec_tot_SNIa*Z_track/Z_sol * &
         sum(abund_sol, mask = elem_sol == "16O" .or. elem_sol == "17O" .or. &
         elem_sol == "18O")

!# Net yield of carbon.
    ejec_elem_SNIa(i_C) = sum(gross_ejec_SNIa, mask = elem_SNIa == "12C" .or. &
         elem_SNIa == "13C" .or. elem_SNIa == "14C") &
         -ejec_tot_SNIa*Z_track/Z_sol * &
         sum(abund_sol, mask = elem_sol == "12C" .or. elem_sol == "13C" .or. &
         elem_sol == "14C")

!# Net yield of iron.
    ejec_elem_SNIa(i_Fe) = sum(gross_ejec_SNIa, mask = elem_SNIa == "54Fe" .or. &
         elem_SNIa == "56Fe" .or. elem_SNIa == "57Fe" .or. elem_SNIa == "58Fe") &
         -ejec_tot_SNIa*Z_track/Z_sol * &
         sum(abund_sol, mask = elem_sol == "54Fe" .or. elem_sol == "56Fe" .or. &
         elem_sol == "57Fe" .or.  elem_sol == "58Fe")

!# Net yield of helium.
    ejec_elem_SNIa(i_He) = -ejec_tot_SNIa*Y_track

!# Net yield of nitrogen.
    ejec_elem_SNIa(i_N) = sum(gross_ejec_SNIa, mask = elem_SNIa == "14N" .or. &
         elem_SNIa == "15N") &
         -ejec_tot_SNIa*Z_track/Z_sol * &
         sum(abund_sol, mask = elem_sol == "14N" .or. elem_sol == "15N")

!# Net yield of neon.
    ejec_elem_SNIa(i_Ne) = sum(gross_ejec_SNIa, mask = elem_SNIa == "20Ne" .or. &
         elem_SNIa == "21Ne" .or. elem_SNIa == "22Ne") &
         -ejec_tot_SNIa*Z_track/Z_sol * &
         sum(abund_sol, mask = elem_sol == "20Ne" .or. elem_sol == "21Ne" .or. &
         elem_sol == "22Ne")

!# Net yield of magnesium.
    ejec_elem_SNIa(i_Mg) = sum(gross_ejec_SNIa, mask = elem_SNIa == "24Mg" .or. &
         elem_SNIa == "25Mg" .or. elem_SNIa == "26Mg") &
         -ejec_tot_SNIa*Z_track/Z_sol * &
         sum(abund_sol, mask = elem_sol == "24Mg" .or. elem_sol == "25Mg" .or. &
         elem_sol == "26Mg")

!# Net yield of silicon.
    ejec_elem_SNIa(i_Si) = sum(gross_ejec_SNIa, mask = elem_SNIa == "28Si" .or. &
         elem_SNIa == "29Si" .or. elem_SNIa == "30Si") &
         -ejec_tot_SNIa*Z_track/Z_sol * &
         sum(abund_sol, mask = elem_sol == "28Si" .or. elem_sol == "29Si" .or. &
         elem_sol == "30Si")

!# Net yield of sulfur.
    ejec_elem_SNIa(i_S) = sum(gross_ejec_SNIa, mask = elem_SNIa == "32S" .or. &
         elem_SNIa == "33S" .or. elem_SNIa == "34S" .or. elem_SNIa == "36S") &
         -ejec_tot_SNIa*Z_track/Z_sol * &
         sum(abund_sol, mask = elem_sol == "32S" .or.  elem_sol == "33S" .or.  &
         elem_sol == "34S" .or.  elem_sol == "36S")

!# Net yield of calcium.
    ejec_elem_SNIa(i_Ca) = sum(gross_ejec_SNIa, mask = elem_SNIa == "40Ca" .or. &
         elem_SNIa == "42Ca" .or. elem_SNIa == "43Ca" &
         .or. elem_SNIa == "44Ca" .or. elem_SNIa == "46Ca" .or. &
         elem_SNIa == "48Ca") &
         -ejec_tot_SNIa*Z_track/Z_sol * &
         sum(abund_sol, mask = elem_sol == "40Ca" .or. elem_sol == "42Ca" .or. &
         elem_sol == "43Ca" .or. elem_sol == "44Ca" .or. elem_sol == "46Ca" .or. &
         elem_sol == "48Ca")

!# Gross yield of dust.
!# No CO is formed: all the carbon, magnesium, silicon, sulfur, calcium and iron atoms may be used to form dust.
!# Note that hydrogen atoms in carbon dust are neglected.
!# To each magnesium, silicon, sulfur, calcium, titanium (for Woosley and Weaver yields only), or iron atom is associated
!# one oxygen atom, in the mean. It is assumed that the number of oxygen atoms is sufficient for that.
!# The real quantity of carbon or silicate dust formed around type Ia supernovae is
!# determined by `SNIa_carb_deplet` and `SNIa_sil_deplet`.

    carb_dust_SNIa = sum(gross_ejec_SNIa, mask = elem_SNIa == "12C" .or. &
         elem_SNIa == "13C" .or. elem_SNIa == "14C")

    sil_dust_SNIa = sum(gross_ejec_SNIa, mask = elem_SNIa == "24Mg" .or. &
         elem_SNIa == "25Mg" .or. elem_SNIa == "26Mg") &
         + sum(gross_ejec_SNIa, mask = elem_SNIa == "28Si" .or. &
         elem_SNIa == "29Si" .or. elem_SNIa == "30Si") &
         + sum(gross_ejec_SNIa, mask = elem_SNIa == "32S" .or. &
         elem_SNIa == "33S" .or. elem_SNIa == "34S" .or. elem_SNIa == "36S") &
         + sum(gross_ejec_SNIa, mask = elem_SNIa == "40Ca" .or. &
         elem_SNIa == "42Ca" .or.  elem_SNIa == "43Ca" .or.  &
         elem_SNIa == "44Ca" .or.  elem_SNIa == "46Ca" .or.  &
         elem_SNIa == "48Ca") &
         + sum(gross_ejec_SNIa, mask = elem_SNIa == "54Fe" .or. &
         elem_SNIa == "56Fe" .or. elem_SNIa == "57Fe" .or. &
         elem_SNIa == "58Fe")

    O_dust_SNIa = sum(gross_ejec_SNIa, mask = elem_SNIa == "24Mg" .or. &
         elem_SNIa == "25Mg" .or. elem_SNIa == "26Mg")*A_O16/A_Mg24 &
         + sum(gross_ejec_SNIa, mask = elem_SNIa == "28Si" .or. &
         elem_SNIa == "29Si" .or. elem_SNIa == "30Si")*A_O16/A_Si28 &
         + sum(gross_ejec_SNIa, mask = elem_SNIa == "32S" .or. &
         elem_SNIa == "33S" .or. elem_SNIa == "34S" .or. elem_SNIa == "36S") &
         *A_O16/A_S32 &
         + sum(gross_ejec_SNIa, mask = elem_SNIa == "40Ca" .or. &
         elem_SNIa == "42Ca" .or.  elem_SNIa == "43Ca" .or.  &
         elem_SNIa == "44Ca" .or.  elem_SNIa == "46Ca" .or.  &
         elem_SNIa == "48Ca")*A_O16/A_Ca40 &
         + sum(gross_ejec_SNIa, mask = elem_SNIa == "54Fe" .or. &
         elem_SNIa == "56Fe" .or. elem_SNIa == "57Fe" .or. &
         elem_SNIa == "58Fe")*A_O16/A_Fe56

  end subroutine compute_yields

!#======================================================================

  function fn_IRA_yield(IMF_file, IMF_dim_slope, IMF_bin_coeff, IMF_bin_bottom_mass, IMF_bin_slope, &
       IMF_mass_min, IMF_mass_max, dim_mass_yields, mass_yields, ejec_tot, ejec_Z, IMF_norm)

    use mod_types
    use mod_interp, only : bracket, interp_lin_lin
    use mod_IMF, only : IMF_d_n
    use mod_SSPs_constants, only : d_l10_m_ejec
    
    implicit none
    character(len=*), intent(in) :: IMF_file
    integer, intent(in) :: IMF_dim_slope, dim_mass_yields
    real(DPR), dimension(:), intent(in) :: IMF_bin_coeff, IMF_bin_bottom_mass, IMF_bin_slope, mass_yields, ejec_tot, ejec_Z
    real(DPR), intent(in) :: IMF_mass_min, IMF_mass_max
    real(DPR), intent(in) :: IMF_norm
    real(DPR) :: fn_IRA_yield
!#......................................................................
    real(DPR) :: IRA_tot_ejec, IRA_Z_ejec, l10_mass_min, l10_mass_max, d_l10_mass, l10_mass, d_n
    integer :: n_bins, i_bin, i_bracket
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    IRA_tot_ejec = 0
    IRA_Z_ejec = 0
    l10_mass_min = log10(IMF_mass_min)
    l10_mass_max = log10(IMF_mass_max)
    n_bins = int((l10_mass_max-l10_mass_min)/d_l10_m_ejec+1)
    d_l10_mass = (l10_mass_max-l10_mass_min)/n_bins
    do i_bin = 0, n_bins-1
       l10_mass = l10_mass_min+(i_bin+0.5_DPR)*d_l10_mass
       d_n = IMF_d_n(l10_mass, d_l10_mass, IMF_file, IMF_dim_slope, IMF_bin_coeff, IMF_bin_bottom_mass, IMF_bin_slope, &
            IMF_mass_min, IMF_mass_max, IMF_norm)
       if (10**l10_mass >= mass_yields(1)) then
          i_bracket = 0
          call bracket(dim_mass_yields, mass_yields, 10**l10_mass, i_bracket)
          IRA_tot_ejec = IRA_tot_ejec + d_n * interp_lin_lin( &
               mass_yields(i_bracket), mass_yields(i_bracket+1), &
               ejec_tot(i_bracket), ejec_tot(i_bracket+1), 10**l10_mass)
          IRA_Z_ejec = IRA_Z_ejec + d_n * interp_lin_lin( &
               mass_yields(i_bracket), mass_yields(i_bracket+1), &
               ejec_Z(i_bracket), ejec_Z(i_bracket+1), 10**l10_mass)
       endif
    end do
    fn_IRA_yield = IRA_Z_ejec/(1-IRA_tot_ejec)

  end function fn_IRA_yield

end module mod_yields

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_read_abundances

  private
  public :: read_abundances

contains

!#======================================================================
  
  subroutine read_abundances(file, dim_elem, abund, elem_id)
    
    use mod_types
    use mod_linked_list
    use mod_file_access, only : open_file, skip_comment_lines, close_file

    implicit none
    character(len=*), intent(in) :: file
    integer, intent(out) :: dim_elem
    real(DPR), dimension(:), pointer :: abund
    character(len=std_string), dimension(:), pointer :: elem_id
!#......................................................................
    integer :: unit, ios
    real(DPR) :: tmp_abund
    character(len=std_string) :: tmp_elem
    type(lk_lst_DPR) :: head_node_abund
    type(lk_lst_DPR), pointer :: current_node_abund
    type(lk_lst_std_string) :: head_node_elem
    type(lk_lst_std_string), pointer :: current_node_elem
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call open_file(unit, file)
    dim_elem = 0
    call lk_lst_initialize(head_node_abund)
    call lk_lst_initialize(head_node_elem)
    do 
       read(unit,*,iostat=ios) tmp_abund, tmp_elem
       if (ios /= 0) exit
       dim_elem = dim_elem+1
       call lk_lst_new_node(head_node_abund, current_node_abund)
       call lk_lst_new_node(head_node_elem, current_node_elem)
       current_node_abund % val = tmp_abund
       current_node_elem % val = adjustl(tmp_elem)
    enddo
    call close_file(unit)

    call lk_lst_to_array(head_node_abund, abund, dim_elem)
    call lk_lst_to_array(head_node_elem, elem_id, dim_elem)

  end subroutine read_abundances

end module mod_read_abundances

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

!# This file is included in "colors.f90". To change the output of code "colors",
!# edit the present file as explained in the comments below, and compile the 
!# code in "bin_dir/" with the `Make` command.
!#
!# Notations:
!# -- `xxx`: code segment;
!# -- ^yyy^: metasyntactic variable (= placeholder: ^yyy^ must be replaced by an actual quantity).
!#
!# The output consists in a series of tables written in the output file. 
!# Each table provides several quantities, one per column, as a function of 
!# the age (in Myr; automatically written at the beginning of each line).
!# You may add other quantities to any table; you may also create a new table.
!# 
!# For each quantity (except the age), the subroutine `add_column` must be called like this:
!#
!#   `call add_column(^column_heading^, ^column^, ^fmt_col^)`,
!#
!# where the string ^column_heading^ is the heading which will be
!# automatically written at the top of each column,
!# ^column^ is an array of reals containing the quantity,
!# and the optional string ^fmt_col^ is the Fortran-style format of the quantity for this column.
!#
!# Once a table is complete, the statement 
!#
!#   `call write_table`
!#
!# writes the table in the output file.
!#
!# The quantities `data % ^quantity^` are directly read from the input file 
!# produced by "spectra". 
!#
!# To write absolute magnitudes in a given filter, type
!#
!#   `call add_column(^column_heading^, magnit(^filter_id^), ^fmt_col^)`,
!#
!# where the string ^filter_id^ is the name of the filter.
!#
!# To write the intrisic luminosity through this filter, replace `magnit` by `lum_band`.
!# For the intrisic luminosity normalized to the solar luminosity in the same filter,
!# use `lum_band_rel_Sun` instead.
!#
!# To write the color `magnit(^filter1_id^) - magnit(^filter2_id^)`, type
!#
!#   `call add_column(^column_heading^, color(^filter1_id^, ^filter2_id^), ^fmt_col^)`.
!#
!# To write the luminosity of a given emission line, type
!#
!#   `call add_column(^column_heading^, L_line(^line_id^), ^fmt_col^)`,
!#
!# where the string ^line_id^ is the name of the line.
!#
!# To write the equivalent width of this line, replace `L_line` by `eq_width`.
!#
!# The functions `magnit`, etc., produce an array containing the quantity for all ages.
!# To get the quantity at the `i_output_age`-th age, type
!#
!#   `magnit(i_output_age, ^filter_id^)`, 
!#   `color(i_output_age, ^filter1_id^, ^filter2_id^)`, 
!#
!# etc.

  call add_column("M_gal", data % galaxy_mass, "es8.2")
  call add_column("M_*", data % live_stars_mass, "es8.2")
  call add_column("M_WD", data % WD_mass, "es8.2")
  call add_column("M_BHNS", data % BHNS_mass, "es8.2")
  call add_column("M_inert", data % inert_mass, "es8.2")
  call add_column("M_ISM", data % ISM_mass, "es8.2")
  call add_column("Z_ISM", data % ISM_Z, "es8.2")
  call add_column("<Z*>_mass", data % stel_Z_mass_avrg, "es8.2")
  call add_column("<Z*>_bol", data % stel_Z_bol_avrg, "es8.2")
  call write_table

  call add_column("He", ISM_abund("He"), "es8.2")
  call add_column("O", ISM_abund("O"), "es8.2")
  call add_column("Fe", ISM_abund("Fe"), "es8.2")
  call add_column("C", ISM_abund("C"), "es8.2")
  call add_column("N", ISM_abund("N"), "es8.2")
  call add_column("alpha\O", ISM_abund("Ne")+ISM_abund("Mg")+ISM_abund("Si") &
       +ISM_abund("S")+ISM_abund("Ca"), "es8.2")
  call write_table

  call add_column("L_bol", data % L_bol, "es8.2")
  call add_column("tau_V", data % tau_V, "es8.2")
  call add_column("L_dust/L_bol", data % L_dust, "es8.2")
  call add_column("SFR", data % SF_rate, "es8.2")
  call add_column("CCSN rate", data % CCSN_rate, "es8.2")
  call add_column("SNIa rate", data % SNIa_rate, "es8.2")
  call add_column("<t*>_mass", data % stel_age_mass_avrg, "es8.2")
  call add_column("<t*>_bol", data % stel_age_bol_avrg, "es8.2")
  call add_column("M*/L_K", data % live_stars_mass / lum_band_rel_Sun("K"), "es8.2")
  call write_table

  call add_column("LC rate", data % Lyman_cont_rate, "es8.2")
  call add_column("L(H_alpha)", L_line("H_I__6564.62_A"), "es8.2")
  call add_column("EW(H_alpha)", eq_width("H_I__6564.62_A"), "es8.2")
  call add_column("L(H_beta)", L_line("H_I__4862.69_A"), "es8.2")
  call add_column("EW(H_beta)", eq_width("H_I__4862.69_A"), "es8.2")
  call add_column("L_V/L_V(Sun)", lum_band_rel_Sun("V_BK78"), "es8.2")
  call add_column("L_B/L_B(Sun)", lum_band_rel_Sun("B3_BK78"), "es8.2")
  call add_column("D4000", D4000, "es8.2")
  call add_column("Dn4000", Dn4000, "es8.2")
  call write_table

  call add_column("M_bol", M_bol, "f7.3")
  call add_column("V", magnit("V_BK78"), "f7.3")
  call add_column("U-B", color("U3_BK78", "B2_BK78"), "f7.3")
  call add_column("B-V", color("B3_BK78", "V_BK78"), "f7.3")
  call add_column("V-K", color("V_BK78", "K"), "f7.3")
  call add_column("V-R_C", color("V_BK78", "RC"), "f7.3")
  call add_column("V-I_C", color("V_BK78", "IC"), "f7.3")
  call add_column("J-H", color("J", "H"), "f7.3")
  call add_column("H-K", color("H", "K"), "f7.3")
  call write_table

  call add_column("K-L", color("K", "L"), "f7.3")
  call add_column("L-M", color("L", "M"), "f7.3")
  call add_column("V-R_J", color("V_BK78", "RJ"), "f7.3")
  call add_column("V-I_J", color("V_BK78", "IJ"), "f7.3")
  call add_column("JK-V", color("JK", "V_BK78"), "f7.3")
  call add_column("U_K-J_K", color("UK", "JK"), "f7.3")
  call add_column("J_K-F_K", color("JK", "FK"), "f7.3")
  call add_column("F_K-N_K", color("FK", "NK"), "f7.3")
  call add_column("2000-V", color("2000", "V_BK78"), "f7.3")
  call write_table

  call add_column("V-I_D", color("V_BK78", "ID"), "f7.3")
  call add_column("I_D-J_D", color("ID", "JD"), "f7.3")
  call add_column("J_D-K_D", color("JD", "KD"), "f7.3")
  call add_column("B_J-V", color("BJ", "V_BK78"), "f7.3")
  call add_column("B_J-R_F", color("BJ", "RF"), "f7.3")
  call add_column("V-606", color("V_BK78", "606"), "f7.3")
  call add_column("300-450", color("300", "450"), "f7.3")
  call add_column("450-606", color("450", "606"), "f7.3")
  call add_column("606-814", color("606", "814"), "f7.3")
  call write_table

  call add_column("u'-g'", color("u'", "g'"), "f7.3")
  call add_column("g'-r'", color("g'", "r'"), "f7.3")
  call add_column("V-r'", color("V_BK78", "r'"), "f7.3")
  call add_column("r'-i'", color("r'", "i'"), "f7.3")
  call add_column("i'-z'", color("i'", "z'"), "f7.3")
  call add_column("u-v", color("u", "v"), "f7.3")
  call add_column("v-g", color("v", "g"), "f7.3")
  call add_column("g-V", color("g", "V_BK78"), "f7.3")
  call add_column("g-r", color("g", "r"), "f7.3")
  call write_table

  call add_column("1650-B", color("1650", "B3_BK78"), "f7.3")
  call add_column("1650-2500", color("1650", "2500"), "f7.3")
  call add_column("3150-B", color("3150", "B3_BK78"), "f7.3")
  call add_column("log_10(12/25)", log10(lum_band("IRAS12")/lum_band("IRAS25")), "f7.3")
  call add_column("log_10(25/60)", log10(lum_band("IRAS25")/lum_band("IRAS60")), "f7.3")
  call add_column("log_10(60/100)", log10(lum_band("IRAS60")/lum_band("IRAS100")), "f7.3")
  call write_table

  call add_column("(u-g)_SDSS", color("u_SDSS", "g_SDSS"), "f7.3")
  call add_column("(g-r)_SDSS", color("g_SDSS", "r_SDSS"), "f7.3")
  call add_column("(r-i)_SDSS", color("r_SDSS", "i_SDSS"), "f7.3")
  call add_column("(g-r)_SDSS", color("i_SDSS", "z_SDSS"), "f7.3")
  call write_table

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_isochrone

  use mod_interp, only : bracket
  use mod_types, only : DPR

  implicit none
  private
  type :: struct_isoch
!# Next point on the isochrone:
     type(struct_isoch), pointer :: ptr => null()
!# Current point:
     real(DPR) :: m !# log10(initial mass/M_sol).
     real(DPR) :: T !# log10(effective temperature/kelvin).
     real(DPR) :: L !# log10(bolometric luminosity/L_sol).
     real(DPR) :: g !# log10(surface gravity/(cm.s^-2)).
  end type struct_isoch
  public :: compute_isochrone, compute_isochrone_WD, struct_isoch

contains

!#======================================================================
  
  subroutine compute_isochrone(time, dim_isoch, isoch, isoch_node, top_isoch_mass, &
       std_track, n_VLM, n_He_flash, n_MS, n_HB)

    use mod_types
    use mod_tracks, only : struct_track
    
    implicit none
    real(CDR), intent(in) :: time !# in Myr.
    integer, intent(out) :: dim_isoch
    type(struct_isoch), intent(out) :: isoch
    type(struct_isoch), pointer :: isoch_node
    real(DPR), intent(out) :: top_isoch_mass
    type(struct_track), dimension(:), intent(in) :: std_track
    integer, intent(in) :: n_VLM, n_He_flash, n_MS, n_HB
!#......................................................................
    
!# Used in "mod_isochrone.f90" to avoid interpolating between a stellar evolutionary track
!# with equivalent points corresponding to those of the previous mass and the same track with
!# equivalent points corresponding to those of the next mass:
    real(DPR), parameter :: eps_init_mass = 1.e-6_DPR !# (Probably useless since the test on \
!# `init_mass` is a strict inequality.)
    integer :: i, j, j1, j2
    real(DPR) :: alpha
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call isoch_initialize(isoch)

    dim_isoch = 0
    if (time > 0) then

!# Very low mass stars: {
       do i = 1, n_VLM
          dim_isoch = dim_isoch+1
          j = 0
          call bracket(std_track(i) % dim_age, std_track(i) % age(:), &
               real(time, kind(std_track(i) % age)), j)
          alpha = (time-std_track(i) % age(j))/(std_track(i) % age(j+1)-std_track(i) % age(j))
          call isoch_new_node(isoch, isoch_node)
          isoch_node % m = std_track(i) % l10_init_mass
          top_isoch_mass = isoch_node % m
          isoch_node % T = std_track(i) % T_eff(j)+alpha*(std_track(i) % T_eff(j+1)-std_track(i) % T_eff(j))
          isoch_node % L = std_track(i) % lum(j)+alpha*(std_track(i) % lum(j+1)-std_track(i) % lum(j))      
          isoch_node % g = std_track(i) % grav(j)+alpha*(std_track(i) % grav(j+1)-std_track(i) % grav(j))
       end do
!# }
       
       do i = n_VLM+1, n_VLM+n_He_flash-1
          if ((std_track(i) % dim_age == std_track(i+1) % dim_age) .and. &
               (std_track(i) % init_mass < std_track(i+1) % init_mass - &
               eps_init_mass)) then
             if (((std_track(i) % age(1)-time)*(std_track(i+1) % age(std_track(i+1) % dim_age)-time) <= 0) .or. &
                  ((std_track(i) % age(std_track(i) % dim_age)-time)*(std_track(i+1) % age(1)-time) <= 0)) then

                call find_j(time, i, j1, std_track)
                call find_j(time, i+1, j2, std_track)

                call on_track(time, i, j1, dim_isoch, isoch, isoch_node, top_isoch_mass, &
                     std_track)

                call between_tracks(time, i, j1, j2, dim_isoch, isoch, isoch_node, top_isoch_mass, &
                     std_track)

                call on_track(time, i+1, j2, dim_isoch, isoch, isoch_node, top_isoch_mass, &
                     std_track)

             end if
          end if
       end do

       i = n_VLM+n_He_flash
       do j = 1, std_track(i) % dim_age-1
          if (std_track(i) % age(j) <= time .and. time <= std_track(i) % age(j+1)) then
             dim_isoch = dim_isoch+1
             alpha = (time-std_track(i) % age(j))/(std_track(i) % age(j+1)-std_track(i) % age(j))
             call isoch_new_node(isoch, isoch_node)
             isoch_node % m = std_track(i) % l10_init_mass
             top_isoch_mass = isoch_node % m
             isoch_node % T = std_track(i) % T_eff(j)+alpha*(std_track(i) % T_eff(j+1)-std_track(i) % T_eff(j))
             isoch_node % L = std_track(i) % lum(j)+alpha*(std_track(i) % lum(j+1)-std_track(i) % lum(j))      
             isoch_node % g = std_track(i) % grav(j)+alpha*(std_track(i) % grav(j+1)-std_track(i) % grav(j))
          end if
       end do
       do i = n_MS+1, n_MS+n_HB-1
          if ((std_track(i) % dim_age == std_track(i+1) % dim_age) .and. &
               (std_track(i) % init_mass < std_track(i+1) % init_mass - &
               eps_init_mass)) then
             if (((std_track(i) % age(1)-time)*(std_track(i+1) % age(std_track(i+1) % dim_age)-time) <= 0) .or. &
                  ((std_track(i) % age(std_track(i) % dim_age)-time)*(std_track(i+1) % age(1)-time) <= 0)) then

                call find_j(time, i, j1, std_track)
                call find_j(time, i+1, j2, std_track)

                call on_track(time, i, j1, dim_isoch, isoch, isoch_node, top_isoch_mass, &
                     std_track)

                call between_tracks(time, i, j1, j2, dim_isoch, isoch, isoch_node, top_isoch_mass, &
                     std_track)
                
                call on_track(time, i+1, j2, dim_isoch, isoch, isoch_node, top_isoch_mass, &
                     std_track)

             end if
          end if
       end do

       i = n_MS+n_HB
       do j = 1, std_track(i) % dim_age-1
          if (std_track(i) % age(j) <= time .and. time <= std_track(i) % age(j+1)) then
             dim_isoch = dim_isoch+1
             alpha = (time-std_track(i) % age(j))/(std_track(i) % age(j+1)-std_track(i) % age(j))
             call isoch_new_node(isoch, isoch_node)
             isoch_node % m = std_track(i) % l10_init_mass
             top_isoch_mass = isoch_node % m
             isoch_node % T = std_track(i) % T_eff(j)+alpha*(std_track(i) % T_eff(j+1)-std_track(i) % T_eff(j))
             isoch_node % L = std_track(i) % lum(j)+alpha*(std_track(i) % lum(j+1)-std_track(i) % lum(j))      
             isoch_node % g = std_track(i) % grav(j)+alpha*(std_track(i) % grav(j+1)-std_track(i) % grav(j))
          end if
       end do

       do i = n_VLM+n_He_flash+1, n_MS-1
          if ((std_track(i) % dim_age == std_track(i+1) % dim_age) .and. &
               (std_track(i) % init_mass < std_track(i+1) % init_mass - &
               eps_init_mass)) then
             if (((std_track(i) % age(1)-time)*(std_track(i+1) % age(std_track(i+1) % dim_age)-time) <= 0) .or. &
                  ((std_track(i) % age(std_track(i) % dim_age)-time)*(std_track(i+1) % age(1)-time) <= 0)) then

                call find_j(time, i, j1, std_track)
                call find_j(time, i+1, j2, std_track)

                call on_track(time, i, j1, dim_isoch, isoch, isoch_node, top_isoch_mass, &
                     std_track)

                call between_tracks(time, i, j1, j2, dim_isoch, isoch, isoch_node, top_isoch_mass, &
                     std_track)

                call on_track(time, i+1, j2, dim_isoch, isoch, isoch_node, top_isoch_mass, &
                     std_track)

             end if
          end if
       end do

       i = n_MS
       do j = 1, std_track(i) % dim_age-1
          if (std_track(i) % age(j) <= time .and. time <= std_track(i) % age(j+1)) then
             dim_isoch = dim_isoch+1
             alpha = (time-std_track(i) % age(j))/(std_track(i) % age(j+1)-std_track(i) % age(j))
             call isoch_new_node(isoch, isoch_node)             
             isoch_node % m = std_track(i) % l10_init_mass
             top_isoch_mass = isoch_node % m
             isoch_node % T = std_track(i) % T_eff(j)+alpha*(std_track(i) % T_eff(j+1)-std_track(i) % T_eff(j))
             isoch_node % L = std_track(i) % lum(j)+alpha*(std_track(i) % lum(j+1)-std_track(i) % lum(j))      
             isoch_node % g = std_track(i) % grav(j)+alpha*(std_track(i) % grav(j+1)-std_track(i) % grav(j))
          end if
       end do
    else

!# Time = 0. The isochrone is the ZAMS.

       do i = 1, n_MS
          dim_isoch = dim_isoch+1
          call isoch_new_node(isoch, isoch_node)
          isoch_node % m = std_track(i) % l10_init_mass
          top_isoch_mass = isoch_node % m
          isoch_node % T = std_track(i) % T_eff(1)
          isoch_node % L = std_track(i) % lum(1)
          isoch_node % g = std_track(i) % grav(1)
       end do
    end if

  end subroutine compute_isochrone

!#======================================================================

  subroutine compute_isochrone_WD(time, dim_isoch, isoch, isoch_node, &
       dim_WD, WD_track, dim_age_WD)
    
    use mod_types
    use mod_tracks, only : struct_track

    implicit none
    real(CDR), intent(in) :: time
    integer, intent(inout) :: dim_isoch
    type(struct_isoch), intent(inout) :: isoch
    type(struct_isoch), pointer :: isoch_node
    integer, intent(in) :: dim_WD, dim_age_WD
    type(struct_track), dimension(:), intent(in) :: WD_track
!#......................................................................
    integer :: i, j, j1, j2
    real(DPR) :: alpha
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    do i = 1, dim_WD-1
       if (((WD_track(i) % age(1)-time)*(WD_track(i+1) % age(dim_age_WD)-time) <= 0) .or. &
            ((WD_track(i) % age(dim_age_WD)-time)*(WD_track(i+1) % age(1)-time) <= 0)) then
          j1 = 1
          j2 = 1
          if (WD_track(i) % age(1) > time) j1 = 0
          if (WD_track(i) % age(dim_age_WD) < time) j1 = dim_age_WD
          if (WD_track(i+1) % age(1) > time) j2 = 0
          if (WD_track(i+1) % age(dim_age_WD) < time) j2 = dim_age_WD
          if (j1 /= 0 .and. j1 /= dim_age_WD) then
             j1 = 0
             call bracket(dim_age_WD, WD_track(i) % age(1:dim_age_WD), &
                  real(time, kind(WD_track(i) % age)), j1)
          end if
          if (j2 /= 0 .and. j2 /= dim_age_WD) then
             j2 = 0
             call bracket(dim_age_WD, WD_track(i+1) % age(1:dim_age_WD), &
                  real(time, kind(WD_track(i) % age)), j2)
          end if
          if (j1 /= 0 .and. j1 /= dim_age_WD) then
             dim_isoch = dim_isoch+1
             alpha = (time-WD_track(i) % age(j1))/(WD_track(i) % age(j1+1)-WD_track(i) % age(j1))
             call isoch_new_node(isoch, isoch_node)
             isoch_node % m = WD_track(i) % l10_init_mass
             isoch_node % T = WD_track(i) % T_eff(j1)+alpha*(WD_track(i) % T_eff(j1+1)-WD_track(i) % T_eff(j1))
             isoch_node % L = WD_track(i) % lum(j1)+alpha*(WD_track(i) % lum(j1+1)-WD_track(i) % lum(j1))
             isoch_node % g = WD_track(i) % grav(j1)+alpha*(WD_track(i) % grav(j1+1)-WD_track(i) % grav(j1))
          end if
          if (j1 > j2) then
             do j = j1, j2+1, -1
                alpha = log10(time/WD_track(i+1) % age(j))/log10(WD_track(i) % age(j)/ &
                     WD_track(i+1) % age(j))
                dim_isoch = dim_isoch+1
                call isoch_new_node(isoch, isoch_node)
                isoch_node % m = alpha*WD_track(i) % l10_init_mass + &
                     (1-alpha)*WD_track(i+1) % l10_init_mass
                isoch_node % T = alpha*WD_track(i) % T_eff(j)+(1-alpha)*WD_track(i+1) % T_eff(j)
                isoch_node % L = alpha*WD_track(i) % lum(j)+(1-alpha)*WD_track(i+1) % lum(j)
                isoch_node % g = alpha*WD_track(i) % grav(j)+(1-alpha)*WD_track(i+1) % grav(j)
             end do
          else
             do j = j1+1, j2
                alpha = log10(time/WD_track(i+1) % age(j))/log10(WD_track(i) % age(j)/ &
                     WD_track(i+1) % age(j))
                dim_isoch = dim_isoch+1
                call isoch_new_node(isoch, isoch_node)
                isoch_node % m = alpha*WD_track(i) % l10_init_mass + &
                     (1-alpha)*WD_track(i+1) % l10_init_mass
                isoch_node % T = alpha*WD_track(i) % T_eff(j)+(1-alpha)*WD_track(i+1) % T_eff(j)
                isoch_node % L = alpha*WD_track(i) % lum(j)+(1-alpha)*WD_track(i+1) % lum(j)
                isoch_node % g = alpha*WD_track(i) % grav(j)+(1-alpha)*WD_track(i+1) % grav(j)
             end do
          end if
          if (j2 /= 0 .and. j2 /= dim_age_WD) then
             dim_isoch = dim_isoch+1
             alpha = (time-WD_track(i+1) % age(j2))/(WD_track(i+1) % age(j2+1)-WD_track(i+1) % age(j2))
             call isoch_new_node(isoch, isoch_node)
             isoch_node % m = WD_track(i+1) % l10_init_mass
             isoch_node % T = WD_track(i+1) % T_eff(j2)+alpha*(WD_track(i+1) % T_eff(j2+1) &
                  -WD_track(i+1) % T_eff(j2))
             isoch_node % L = WD_track(i+1) % lum(j2)+alpha*(WD_track(i+1) % lum(j2+1)-WD_track(i+1) % lum(j2))
             isoch_node % g = WD_track(i+1) % grav(j2)+alpha*(WD_track(i+1) % grav(j2+1) &
                  -WD_track(i+1) % grav(j2))
          end if
       end if
    end do

  end subroutine compute_isochrone_WD

!#======================================================================

  subroutine find_j(time, i, j, std_track)

    use mod_types
    use mod_tracks, only : struct_track
    
    implicit none
    real(CDR), intent(in) :: time
    integer, intent(in) :: i
    integer, intent(out) :: j
    type(struct_track), dimension(:), intent(in) :: std_track
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    if (std_track(i) % age(1) > time) then 
       j = 0
    else if (std_track(i) % age(std_track(i) % dim_age) < time) then
       j = std_track(i) % dim_age
    else
       j = 0
       call bracket(std_track(i) % dim_age, std_track(i) % age(:), &
            real(time, kind(std_track(i) % age)), j)
    end if

  end subroutine find_j

!#======================================================================

  subroutine on_track(time, i, j, dim_isoch, isoch, isoch_node, &
       top_isoch_mass, &
       std_track)

    use mod_types
    use mod_tracks, only : struct_track
    
    implicit none
    real(CDR), intent(in) :: time
    integer, intent(in) :: i, j
    integer, intent(inout) :: dim_isoch
    type(struct_isoch), intent(inout) :: isoch
    type(struct_isoch), pointer :: isoch_node
    real(DPR), intent(out) :: top_isoch_mass
    type(struct_track), dimension(:), intent(in) :: std_track
!#......................................................................
    real(DPR) :: alpha
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (j /= 0 .and. j /= std_track(i) % dim_age) then
       dim_isoch = dim_isoch+1
       alpha = (time-std_track(i) % age(j))/(std_track(i) % age(j+1)-std_track(i) % age(j))
       call isoch_new_node(isoch, isoch_node)
       isoch_node % m = std_track(i) % l10_init_mass
       top_isoch_mass = isoch_node % m
       isoch_node % T = std_track(i) % T_eff(j)+alpha*(std_track(i) % T_eff(j+1)-std_track(i) % T_eff(j))
       isoch_node % L = std_track(i) % lum(j)+alpha*(std_track(i) % lum(j+1)-std_track(i) % lum(j))      
       isoch_node % g = std_track(i) % grav(j)+alpha*(std_track(i) % grav(j+1)-std_track(i) % grav(j))
    end if

  end subroutine on_track

!#======================================================================

  subroutine between_tracks(time, i, j1, j2, dim_isoch, isoch, isoch_node, &
       top_isoch_mass, &
       std_track)

    use mod_types
    use mod_tracks, only : struct_track

    implicit none
    real(CDR), intent(in) :: time
    integer, intent(in) :: i, j1, j2
    integer, intent(inout) :: dim_isoch
    type(struct_isoch), intent(inout) :: isoch
    type(struct_isoch), pointer :: isoch_node
    real(DPR), intent(out) :: top_isoch_mass
    type(struct_track), dimension(:), intent(in) :: std_track
!#......................................................................
    integer :: first, last, step, j
    real(DPR) :: alpha
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (j1 > j2) then
       first = j1
       last = j2+1
       step = -1
    else
       first = j1+1
       last = j2
       step = 1
    endif
    do j = first, last, step
       alpha = log10(time/std_track(i+1) % age(j)) / &
            log10(std_track(i) % age(j)/std_track(i+1) % age(j))
       dim_isoch = dim_isoch+1
       call isoch_new_node(isoch, isoch_node)
       isoch_node % m = alpha*std_track(i) % l10_init_mass + &
            (1-alpha)*std_track(i+1) % l10_init_mass
       top_isoch_mass = isoch_node % m
       isoch_node % T = alpha*std_track(i) % T_eff(j)+(1-alpha)*std_track(i+1) % T_eff(j)
       isoch_node % L = alpha*std_track(i) % lum(j)+(1-alpha)*std_track(i+1) % lum(j)
       isoch_node % g = alpha*std_track(i) % grav(j)+(1-alpha)*std_track(i+1) % grav(j)
    end do

  end subroutine between_tracks

!#======================================================================

  subroutine isoch_initialize(isoch)

    implicit none
    type(struct_isoch), intent(inout) :: isoch
!#......................................................................
    type(struct_isoch), pointer :: isoch_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Delete previous isochrone, if any.
    isoch_node => isoch % ptr
    do
       if (.not.associated(isoch_node)) exit
       isoch % ptr => isoch_node % ptr
       deallocate(isoch_node)
       isoch_node => isoch % ptr
    enddo

!# Set the head of the linked list of isochrone nodes.
    nullify(isoch % ptr)

  end subroutine isoch_initialize

!#======================================================================

  subroutine isoch_new_node(isoch, isoch_node)

    implicit none
    type(struct_isoch), intent(inout) :: isoch
    type(struct_isoch), pointer :: isoch_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (.not.associated(isoch % ptr)) then
       allocate(isoch % ptr)
       isoch_node => isoch % ptr
    else
       allocate(isoch_node % ptr)
       isoch_node => isoch_node % ptr
    endif
    nullify(isoch_node % ptr)

  end subroutine isoch_new_node

end module mod_isochrone

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

!# Do not forget to recompile if you change `dir_sep` or `home_dir`!

module mod_dir_access

  implicit none

!# Separator between directories
!# (replace `/` by `\` if not under Linux/Unix):
  character(len=*), parameter, public :: dir_sep = "/"

!# Path from the root directory to the user's home directory 
!# (replaces `~` at the beginning of a path):
  character(len=*), parameter, public :: &
       home_dir = "/path/from/root/directory/to/home/directory/"
!# (Do not forget the leading and trailing `/`, and replace all the `/` 
!# by `\` if not under Linux/Unix.)

end module mod_dir_access

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_nebular
  
  private
  public :: nebular_computations

contains

!#======================================================================
  
  subroutine nebular_computations(inner_radius, H_density, &
       n_Z_neb, n_Q_neb, Z_neb, Q_neb, &
       dim_lambda, lambda, rel_lum_neb_cont, &
       dim_line, lambda_line, rel_L_line, line_id, i_Lyman_alpha, &
       i_Lyman_break, Q_neb_weight_DISM, &
       rel_lum_other_lines, rel_volume_neb)

    use mod_types
    use mod_directories, only : Cloudy_dir
    use mod_constants, only : lambda_Lyman_break_A, parsec, neb_set
    use mod_file_access, only : open_file, close_file, path_file, skip_comment_lines
    use mod_interp, only : interp_lin_log, compute_weights
    use mod_heap_index, only : heap_index
    use mod_scenario, only : l10_mean_U_DISM
    
    implicit none
    real(CDR), intent(out) :: inner_radius, H_density
    integer, intent(out) :: n_Z_neb, n_Q_neb
    real(CDR), dimension(:), pointer :: Z_neb, Q_neb
    real(CDR), dimension(:,:), pointer :: Q_neb_weight_DISM
    integer, intent(in) :: dim_lambda
    real(CDR), dimension(:), intent(in) :: lambda
    real(CDR), dimension(:,:,:), pointer :: rel_lum_neb_cont
    integer, intent(out) :: dim_line
    real(CDR), dimension(:), pointer :: lambda_line
    real(CDR), dimension(:,:,:), pointer :: rel_L_line
    character(len=*), dimension(:), pointer :: line_id
    integer, intent(out) :: i_Lyman_alpha, i_Lyman_break
    real(CDR), dimension(:,:), pointer :: rel_lum_other_lines
    real(DPR), dimension(:,:), pointer :: rel_volume_neb
!#......................................................................
    integer :: unit, unit2, i_neb_cont, i_lambda, i_Z, i_Q
    character(len=long_string) :: neb_lines_list_file, neb_cont_wavelengths_file
    character(len=long_string) :: neb_lines_file, neb_cont_file
    real(CDR), dimension(:), allocatable :: rel_lum_neb_cont0, l10_mean_U
    integer :: dim_neb_cont, unit_HII 
    real(CDR), dimension(:), allocatable :: lambda_neb_cont
    integer :: i_line
    integer, dimension(:), allocatable :: idx
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
   
    call open_file(unit, file=path_file(Cloudy_dir, neb_set))
    read(unit,*) inner_radius
    inner_radius = inner_radius*parsec
    
    read(unit,*) H_density
    H_density = 10**H_density

    read(unit,*) n_Z_neb, n_Q_neb
    allocate(Z_neb(n_Z_neb))
    allocate(Q_neb(n_Q_neb))
    allocate(Q_neb_weight_DISM(n_Z_neb, n_Q_neb))
    read(unit,*) Z_neb(:)
    read(unit,*) Q_neb(:)

    read(unit,*) neb_lines_list_file
    call open_file(unit2, file=path_file(Cloudy_dir, neb_lines_list_file))
    read(unit2,*) dim_line
    call skip_comment_lines(unit2)
    if (associated(lambda_line)) deallocate(lambda_line)
    allocate(lambda_line(dim_line))
    if (associated(line_id)) deallocate(line_id)
    allocate(line_id(dim_line))
    do i_line = 1, dim_line
       read(unit2,*) line_id(i_line), lambda_line(i_line)
    end do    
    close(unit2)

    read(unit,*) neb_cont_wavelengths_file
    call open_file(unit2, file=path_file(Cloudy_dir, neb_cont_wavelengths_file))
    read(unit2, *) dim_neb_cont
    if (allocated(lambda_neb_cont)) then
       deallocate(lambda_neb_cont)
    endif
    allocate(lambda_neb_cont(dim_neb_cont))
    do i_neb_cont = 1, dim_neb_cont
       read(unit2,*) lambda_neb_cont(i_neb_cont)
    end do
    close(unit2)

    if (associated(rel_volume_neb)) deallocate(rel_volume_neb)
    allocate(rel_volume_neb(n_Z_neb, n_Q_neb))
    allocate(l10_mean_U(n_Q_neb))
    if (associated(rel_lum_other_lines)) deallocate(rel_lum_other_lines)
    allocate(rel_lum_other_lines(n_Z_neb, n_Q_neb))

    if (associated(rel_L_line)) deallocate(rel_L_line)
    allocate(rel_L_line(n_Z_neb, n_Q_neb, dim_line))

    if (allocated(rel_lum_neb_cont0)) deallocate(rel_lum_neb_cont0)
    allocate(rel_lum_neb_cont0(dim_neb_cont))

    if (associated(rel_lum_neb_cont)) deallocate(rel_lum_neb_cont)
    allocate(rel_lum_neb_cont(n_Z_neb, n_Q_neb, dim_lambda))

    do i_Z = 1, n_Z_neb
       do i_Q = 1, n_Q_neb
          read(unit,*) rel_volume_neb(i_Z, i_Q)
          read(unit,*) l10_mean_U(i_Q)
          read(unit,*) neb_lines_file
          read(unit,*) neb_cont_file

          call open_file(unit2, path_file(Cloudy_dir, neb_lines_file))
          read(unit2,*) rel_lum_other_lines(i_Z, i_Q)
          do i_line = 1, dim_line
             read(unit2,*) rel_L_line(i_Z, i_Q, i_line)
          enddo
          call close_file(unit2)

          call open_file(unit2, path_file(Cloudy_dir, neb_cont_file))
          do i_neb_cont = 1, dim_neb_cont
             read(unit2,*) rel_lum_neb_cont0(i_neb_cont)
          enddo
          do i_lambda = 1, dim_lambda
             if (lambda(i_lambda) < lambda_neb_cont(1)) then
                rel_lum_neb_cont(i_Z, i_Q, i_lambda) = 0
             else if (lambda(i_lambda) > lambda_neb_cont(dim_neb_cont)) then
                i_neb_cont = dim_neb_cont-1
                rel_lum_neb_cont(i_Z, i_Q, i_lambda) = interp_lin_log( &
                     1/lambda_neb_cont(i_neb_cont), &
                     1/lambda_neb_cont(i_neb_cont+1), &
                     rel_lum_neb_cont0(i_neb_cont), &
                     rel_lum_neb_cont0(i_neb_cont+1), 1/lambda(i_lambda))
             else
                i_neb_cont = 1
                do
                   if (lambda_neb_cont(i_neb_cont) <= lambda(i_lambda) .and. &
                        lambda(i_lambda) <= lambda_neb_cont(i_neb_cont+1)) exit
                   if (i_neb_cont >= dim_neb_cont) exit
                   i_neb_cont = i_neb_cont+1
                end do
                if (lambda_neb_cont(i_neb_cont) <= lambda(i_lambda) .and. &
                     lambda(i_lambda) <= lambda_neb_cont(i_neb_cont+1)) then !# ??? And if not?
                   rel_lum_neb_cont(i_Z, i_Q, i_lambda) = interp_lin_log( &
                        1/lambda_neb_cont(i_neb_cont), &
                        1/lambda_neb_cont(i_neb_cont+1), &
                        rel_lum_neb_cont0(i_neb_cont), &
                        rel_lum_neb_cont0(i_neb_cont+1), 1/lambda(i_lambda))
                else
                   write(*,*) "Error in ""mod_nebular.f90"". Stopped."
                   stop
                endif
             endif
          enddo
          call close_file(unit2)
       enddo
       call compute_weights(l10_mean_U(:), l10_mean_U_DISM, &
            Q_neb_weight_DISM(i_Z,:), interp_proc="interp_lin_lin")
    enddo
    call close_file(unit)
    deallocate(l10_mean_U)

!# Check that the same identifier is not used for two emission lines or more.
    allocate(idx(dim_line))
    call heap_index(line_id, idx)
    do i_line = 1, dim_line-1
       if (line_id(idx(i_line)) == line_id(idx(i_line+1))) then
          write(*,"(a,i0,a,i0,a)") "The emission lines ", idx(i_line), &
               " and ", idx(i_line+1), " share the same identifier, """ // &
               trim(line_id(idx(i_line))) // """. Stopped."
          stop
       end if
    enddo
    deallocate(idx)

!# Find the index of Lyman alpha.
    i_Lyman_alpha = 0
    do i_line = 1, dim_line
       if (line_id(i_line) == "H_I__1215.67_A") then
          i_Lyman_alpha = i_line
          exit
       endif
    end do
    if (i_Lyman_alpha == 0) then
       write(*,"(a)") "Identifier ""H_I__1215.67_A"" was not found for &
            &Lyman alpha. Stopped."
       stop
    endif

!# Find the indices of the stellar wavelengths bracketing the Lyman break.
    i_Lyman_break = 0
    do while (lambda(i_Lyman_break+1) < lambda_Lyman_break_A)
       i_Lyman_break = i_Lyman_break+1
    enddo
    
    call close_file(unit_HII)
    
  end subroutine nebular_computations

end module mod_nebular

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_interm_grid

  implicit none
  private

  interface interm_grid
     module procedure interm_grid_s, interm_grid_d
  end interface interm_grid

  public :: interm_grid
  
contains

!#======================================================================
  
  subroutine interm_grid_s(n, x, x_interm)
    
    use mod_types
    
    implicit none
    integer, intent(in) :: n
    real(SPR), dimension(:) :: x
    real(SPR), dimension(:), pointer :: x_interm
!#......................................................................
    integer :: i
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (associated(x_interm)) deallocate(x_interm)
    allocate(x_interm(n+1))
    x_interm(1) = x(1)*sqrt(x(1)/x(2))
    do i = 2, n
       x_interm(i) = sqrt(real(x(i-1), DPR)*real(x(i), DPR)) !# `real(., DPR)` \
!# to avoid over- and underflows.
    enddo
    x_interm(n+1) = x(n)*sqrt(x(n)/x(n-1))

  end subroutine interm_grid_s

!#======================================================================
  
  subroutine interm_grid_d(n, x, x_interm)
    
    use mod_types
    
    implicit none
    integer, intent(in) :: n
    real(DPR), dimension(:) :: x
    real(DPR), dimension(:), pointer :: x_interm
!#......................................................................
    integer :: i
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (associated(x_interm)) deallocate(x_interm)
    allocate(x_interm(n+1))
    x_interm(1) = x(1)*sqrt(x(1)/x(2))
    do i = 2, n
       x_interm(i) = sqrt(x(i-1)*x(i))
    enddo
    x_interm(n+1) = x(n)*sqrt(x(n)/x(n-1))

  end subroutine interm_grid_d

end module mod_interm_grid

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_intersperse

  private
  public :: intersperse

contains

!#======================================================================
!# Given two arrays, `x1` and `x2`, of size `n1` and `n2`, ordered by
!# increasing values, `intersperse` intersperses in `x1` all the values
!# of `x2` unless they are too close to one of `x1` (see parameter `eps`).

  subroutine intersperse(n1, n2, x1, x2, eps)

    use mod_types
    implicit none
    integer, intent(inout) :: n1
    integer, intent(in) :: n2
    real(CDR), dimension(:), pointer :: x1
    real(CDR), dimension(:), intent(in) :: x2
    real(CDR), intent(in), optional :: eps
!#......................................................................
    integer :: n
    real(CDR), dimension(size(x1)+size(x2)) :: x
    integer :: i1, i2
    real(CDR) :: eps_eff
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(eps)) then
       eps_eff = eps
    else
       eps_eff = 0
    endif

    n = 1
    if (x1(1) <= x2(1)) then
       x(n) = x1(1)
       i1 = 2
       i2 = 1
    else
       x(n) = x2(1)
       i1 = 1
       i2 = 2
    endif
    do
       if (i2 > n2) then
          if (i1 > n1) exit
          if (x1(i1)-x(n) > eps_eff*x(n)) then
             n = n+1
             x(n) = x1(i1)
          endif
          i1 = i1+1
       else if (i1 > n1) then
          if (x2(i2)-x(n) > eps_eff*x(n)) then
             n = n+1
             x(n) = x2(i2)
          endif
          i2 = i2+1
       else
          if (x1(i1) <= x2(i2)) then
             if (x1(i1)-x(n) > eps_eff*x(n)) then
                n = n+1
                x(n) = x1(i1)
             endif
             i1 = i1+1
          else
             if (x2(i2)-x(n) > eps_eff*x(n)) then
                n = n+1
                x(n) = x2(i2)
             endif
             i2 = i2+1
          endif
       endif
    enddo

    n1 = n
    deallocate(x1)
    allocate(x1(n1))
    x1(1:n1) = x(1:n)

  end subroutine intersperse

end module mod_intersperse

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_directories

  use mod_dir_access, only : dir_sep
  implicit none
  private

  character(len=*), parameter, public :: PEGASE3_dir = ".." // dir_sep
  character(len=*), parameter, public :: doc_dir = PEGASE3_dir // "doc_dir" // dir_sep
  character(len=*), parameter, public :: IMFs_dir = PEGASE3_dir // "IMFs_dir" // dir_sep
  character(len=*), parameter, public :: stel_lib_dir = PEGASE3_dir // "stel_lib_dir" // dir_sep
  character(len=*), parameter, public :: tracks_dir = PEGASE3_dir // "tracks_dir" // dir_sep
  character(len=*), parameter, public :: yields_dir = PEGASE3_dir // "yields_dir" // dir_sep
  character(len=*), parameter, public :: SSPs_dir = PEGASE3_dir // "SSPs_dir" // dir_sep
  character(len=*), parameter, public :: spectra_dir = PEGASE3_dir // "spectra_dir" // dir_sep
  character(len=*), parameter, public :: grain_temp_dir = PEGASE3_dir // "grain_temp_dir" // dir_sep
  character(len=*), parameter, public :: grain_SED_dir = PEGASE3_dir // "grain_SED_dir" // dir_sep
  character(len=*), parameter, public :: scenarios_dir = PEGASE3_dir // "scenarios_dir" // dir_sep
  character(len=*), parameter, public :: ages_dir = PEGASE3_dir // "ages_dir" // dir_sep
  character(len=*), parameter, public :: RT_dir = PEGASE3_dir // "RT_dir" // dir_sep
  character(len=*), parameter, public :: dust_dir = PEGASE3_dir // "dust_dir" // dir_sep
  character(len=*), parameter, public :: calib_dir = PEGASE3_dir // "calib_dir" // dir_sep
  character(len=*), parameter, public :: colors_dir = PEGASE3_dir // "colors_dir" // dir_sep
  character(len=*), parameter, public :: bin_dir = PEGASE3_dir // "bin_dir" // dir_sep
  character(len=*), parameter, public :: Cloudy_dir = PEGASE3_dir // "Cloudy_dir" // dir_sep
  character(len=*), parameter, public :: log_spectra_dir = bin_dir // "log_spectra_dir" // dir_sep

end module mod_directories

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_heap_index
  
  implicit none
  private
  public :: heap_index

contains

!#======================================================================

  subroutine heap_index(a, idx)

!# Given an array `a(1:n)` of strings, return the array of integers `idx(1:n)`
!# such that `a(idx(1:n))` is ordered by increasing values.
!# Based on the "heapsort" algorithm.

    implicit none
    character(len=*), dimension(:), intent(in) :: a
    integer, dimension(:), intent(out) :: idx
!#......................................................................
    integer :: n
    integer :: right, i
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    n = size(a)
    idx(1:n) = (/(i, i = 1, n)/)
    call heapify(a, idx, n)
    right = n
    do
       if (right <= 1) exit
       call swap(idx(right), idx(1))
       right = right - 1
       call sift_down(a, idx, 1, right)
    enddo

  end subroutine heap_index

!#======================================================================

  subroutine swap(x, y)

    integer, intent(inout) :: x, y
!#......................................................................
    integer :: tmp
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    tmp = y
    y = x
    x = tmp
    
  end subroutine swap

!#======================================================================

  subroutine heapify(a, idx, n)

    implicit none
    integer, intent(in) :: n
    character(len=*), dimension(:), intent(in) :: a
    integer, dimension(:), intent(inout) :: idx
!#......................................................................
    integer :: left
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    left = n/2
    do
       if (left < 1) exit
       call sift_down(a, idx, left, n)
       left = left - 1
    enddo

  end subroutine heapify

!#======================================================================

  subroutine sift_down(a, idx, left, right)
    
    character(len=*), dimension(:), intent(in) :: a
    integer, dimension(:), intent(inout) :: idx
    integer, intent(in) :: left, right
!#......................................................................
    integer :: root, left_child, right_child, tmp
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    root = left
    do
       left_child = 2*root
       if (left_child > right) exit
       tmp = root
       if (a(idx(tmp)) < a(idx(left_child))) tmp = left_child
       right_child = left_child + 1
       if (right_child <= right) then
          if (a(idx(tmp)) < a(idx(right_child))) tmp = right_child
       endif
       if (tmp /= root) then
          call swap(idx(root), idx(tmp))
          root = tmp
       else
          return
       endif

    enddo

  end subroutine sift_down

end module mod_heap_index

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_remove_duplicates

  implicit none
  private
  public :: remove_duplicates

contains

!#======================================================================
  subroutine remove_duplicates(string, n_strings, back)

    use mod_heap_index, only : heap_index
    
    implicit none
    character(len=*), dimension(:), pointer :: string
    integer, intent(inout) :: n_strings   
    logical, intent(in) :: back
!#......................................................................
    integer :: i, n_strings_tmp, n_removed, n
    integer, dimension(:), allocatable :: idx, unique
    logical, dimension(:), allocatable :: duplicate, removed
    character(len=len(string)), dimension(:), allocatable :: string_tmp
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    n_strings_tmp = n_strings
    allocate(string_tmp(n_strings_tmp))
    string_tmp(:) = string(:)

    allocate(idx(n_strings_tmp))
    call heap_index(string_tmp, idx)

    allocate(duplicate(n_strings_tmp))
    duplicate(:) = .false.
    allocate(unique(n_strings_tmp))
    unique(:) = (/(i, i=1, n_strings_tmp)/)
    n_removed = 0
    if (back) then
       do i = n_strings_tmp, 2, -1
          if (string_tmp(idx(i)) == string_tmp(idx(i-1))) then
             duplicate(idx(i)) = .true.
             duplicate(idx(i-1)) = .true.
             unique(idx(i-1)) = unique(idx(i))
             n_removed = n_removed+1
          endif
       enddo
    else
       do i = 2, n_strings_tmp
          if (string_tmp(idx(i)) == string_tmp(idx(i-1))) then
             duplicate(idx(i)) = .true.
             duplicate(idx(i-1)) = .true.
             unique(idx(i)) = unique(idx(i-1))
             n_removed = n_removed+1
          endif
       enddo
    endif

    allocate(removed(n_strings_tmp))
    removed(1:n_strings_tmp) = .false.
    n_strings = n_strings_tmp-n_removed
    deallocate(string)
    allocate(string(n_strings))
    if (back) then
       n = n_strings+1
       do i = n_strings_tmp, 1, -1
          if (.not.duplicate(i)) then
             n = n-1
             string(n) = string_tmp(i)
          else if (.not.removed(unique(i))) then
             n = n-1
             string(n) = string_tmp(i)
             removed(unique(i)) = .true.
          endif
       enddo
    else
       n = 0
       do i = 1, n_strings_tmp
          if (.not.duplicate(i)) then
             n = n+1
             string(n) = string_tmp(i)
          else if (.not.removed(unique(i))) then
             n = n+1
             string(n) = string_tmp(i)
             removed(unique(i)) = .true.
          endif
       enddo
    endif

    deallocate(string_tmp)
    deallocate(idx)
    deallocate(duplicate)
    deallocate(unique)
    deallocate(removed)

  end subroutine remove_duplicates

end module mod_remove_duplicates

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_spectra_def_param

  use mod_types
  implicit none
  public


!# Maximal age in Myr:
  real(CDR), parameter, public :: max_age = 20001._CDR

!#**********************************************************************
!# Default values of parameters used in "mod_read_SF_param.f90":
  real(CDR), parameter :: SF_begin_time_def = 0._CDR
  real(CDR), parameter :: SF_end_time_def = max_age
  character(len=std_string), parameter :: SF_type_def = "none"
  real(CDR), parameter :: SF_inst_mass_def = 1._CDR
  real(CDR), parameter :: SF_const_mass_def = 1._CDR
  real(CDR), parameter :: SF_expo_mass_def = 1._CDR
  real(CDR), parameter :: SF_peaked_mass_def = 1._CDR
  real(CDR), parameter :: SF_ISM_power_def = 1._CDR
  real(CDR), parameter :: SF_ISM_threshold_def = 0._CDR
  real(CDR), parameter :: SF_infall_factor_def = 1._CDR
  logical, parameter :: SF_stochastic_def = .false.
  character(len=std_string), parameter :: SF_Z_type_def = "consistent"
  real(CDR), parameter :: SF_inert_frac_def = 0._CDR

!#**********************************************************************
!# Default values of parameters used in "mod_read_dust_evol_param.f90":

  character(len=std_string), parameter :: dust_evolution_def = "basic"
  real(CDR), parameter :: O_sil_ratio_def = 1._CDR
  real(CDR), parameter :: ISM_carb_deplet_def = 1._CDR/3
  real(CDR), parameter :: ISM_sil_deplet_def = 1._CDR
  real(CDR), parameter :: CCSN_carb_deplet_def = 0.5_CDR
  real(CDR), parameter :: SNIa_carb_deplet_def = 0.5_CDR
  real(CDR), parameter :: HMW_carb_deplet_def = 1._CDR
  real(CDR), parameter :: LMW_carb_deplet_def = 1._CDR
  real(CDR), parameter :: CCSN_sil_deplet_def = 0.8_CDR
  real(CDR), parameter :: SNIa_sil_deplet_def = 0.8_CDR
  real(CDR), parameter :: HMW_sil_deplet_def = 1._CDR
  real(CDR), parameter :: LMW_sil_deplet_def = 1._CDR
  real(CDR), parameter :: SN_swept_mass_def = 400._CDR !# \
!# ~= <m_d>_MW/Z_{d, MW}. See Dwek & Cherchneff 2011, ApJ 727, 63, just after Eq. (9).
  real(CDR), parameter :: carb_accr_timescale_def = 250._CDR !# See McKinnon \
!# et al. 2015, arXiv:1505.04792, Sect. 3.2.
  real(CDR), parameter :: sil_accr_timescale_def = 250._CDR !# Idem.

!#**********************************************************************
!# Default values of parameters used in "mod_read_dust_transfer_param.f90":

  logical, parameter :: extinction_def = .false., &
       extinction_SFC_def = extinction_def, &
       extinction_DISM_def = extinction_def
  real(CDR), parameter :: bulge_tot_ratio_def = 1._CDR/7
  real(CDR), parameter :: M_sys_spiral_def = 7.e10_CDR
  real(CDR), parameter :: expo_radius_def = 3.5e3_CDR
  real(CDR), parameter :: M_sys_spher_def = 2.79e11_CDR
  real(CDR), parameter :: core_radius_def = 192._CDR
  real(CDR), parameter :: slab_factor_def = 6.8e21_CDR
!# Laor, A. & Draine, B. T., 1993; ApJ, 402, 441; Sec. 2.3, p. 448, 3rd paragraph:
  real(CDR), parameter :: carb_sublim_temp_def = 1750._CDR
  real(CDR), parameter :: carb_sublim_temp_SFC_def = carb_sublim_temp_def
  real(CDR), parameter :: carb_sublim_temp_DISM_def = carb_sublim_temp_def
  real(CDR), parameter :: sil_sublim_temp_def = 1400._CDR
  real(CDR), parameter :: sil_sublim_temp_SFC_def = sil_sublim_temp_def
  real(CDR), parameter :: sil_sublim_temp_DISM_def = sil_sublim_temp_def
  character(len=std_string), parameter :: geometry_def = "spiral"
  logical, parameter :: dust_emission_def = .false.
  logical, parameter :: dust_emission_SFC_def = dust_emission_def
  logical, parameter :: dust_emission_DISM_def = dust_emission_def
  real(CDR), parameter :: self_abs_power_def = 0._CDR
  real(CDR), parameter :: self_abs_power_SFC_def = self_abs_power_def
  real(CDR), parameter :: self_abs_power_DISM_def = self_abs_power_def
  logical, parameter :: stoch_heating_def = .true.
  logical, parameter :: stoch_heating_SFC_def = stoch_heating_def
  logical, parameter :: stoch_heating_DISM_def = stoch_heating_def
  logical, parameter :: inclin_averaged_def = .true.
  real(CDR), parameter :: inclination_def = 0._CDR
  character(len=std_string), parameter :: grains_file_def = &
       "ZDA.txt"
  character(len=std_string), parameter :: &
       grains_file_SFC_def = grains_file_def, &
       grains_file_DISM_def = grains_file_def

!#**********************************************************************
!# Default values of parameters used in "mod_read_cloud_neb_param.f90":

  logical, parameter :: nebular_emission_def = .false., &
       nebular_emission_SFC_def = nebular_emission_def, &
       nebular_emission_DISM_def = nebular_emission_def
  character(len=std_string), parameter :: neb_emis_type_def = "automatic", &
       neb_emis_type_SFC_def = neb_emis_type_def, &
       neb_emis_type_DISM_def = neb_emis_type_def
  real(CDR), parameter :: neb_emis_const_frac_def = 0.7_CDR, &
       neb_emis_const_frac_SFC_def = neb_emis_const_frac_def, &
       neb_emis_const_frac_DISM_def = neb_emis_const_frac_def
!# Log10(typical value of ionization parameter in the diffuse ISM):
  real(CDR), parameter, public :: l10_mean_U_DISM_def = -3.5_CDR
!# (From Flores-Fajardo et al. 2011, MNRAS 415, 2182.)
  real(CDR), parameter :: cluster_stel_mass_def = 1.e4_CDR
  real(CDR), parameter :: cloud_init_frac_def = 1._CDR
  real(CDR), parameter :: cloud_power_def = 1._CDR
  real(CDR), parameter :: cloud_duration_def = 10._CDR

!#**********************************************************************
!# Default values of parameters used in "mod_read_other_param.f90":

  logical, parameter :: check_only_def = .false.
  real(CDR), parameter :: ISM_init_Z_def = 0
  real(CDR), parameter :: close_bin_frac_def = 0.05_CDR
  integer, parameter :: verbosity_def = 0

!#**********************************************************************
!# Default values of parameters used in "mod_read_output_param.f90":

  character(len=std_string), parameter :: spectra_output_def = "basic"
  logical, parameter :: RF_output_def = .false.
  logical, parameter :: sublim_output_def = .false.
  character(len=std_string), parameter :: &
       ages_file_def = "spectra_ages.txt"
  character(len=std_string), parameter :: prefix_def = ""
  logical, parameter :: stamp_time_def = .false.
  logical, parameter :: overwrite_def = .false.
  logical, parameter :: grain_temp_output_def = .false.
  logical, parameter :: grain_SED_output_def = .false.
  logical, parameter :: grain_output_SFC_def = .true.
  logical, parameter :: grain_output_DISM_def = .true.
  real(CDR), parameter :: grain_output_min_age_def = 0, &
       grain_output_max_age_def = huge(1._CDR)
  real(CDR), parameter :: grain_output_min_size_def = 0, &
       grain_output_max_size_def = huge(1._CDR)

!#**********************************************************************
!# Default values of parameters used in "mod_read_outflow_param.f90":

  character(len=std_string), parameter :: outflow_type_def = "none"
  real(CDR), parameter :: outflow_begin_time_def = 0._CDR
  real(CDR), parameter :: outflow_end_time_def = max_age
  real(CDR), parameter :: outflow_SF_power_def = 0._CDR
  real(CDR), parameter :: outflow_SN_power_def = 0._CDR
  real(CDR), parameter :: outflow_CCSN_power_def = 0._CDR
  real(CDR), parameter :: outflow_SNIa_power_def = 0._CDR
  real(CDR), parameter :: outflow_ejec_factor_def = 1._CDR

!#**********************************************************************
!# Default values of parameters used in "mod_read_reserv_infall_param.f90":

  real(CDR), parameter :: reserv_init_mass_def = 0._CDR
  real(CDR), parameter :: reserv_Z_def = 0._CDR
  character(len=std_string), parameter :: infall_type_def = "none"
  real(CDR), parameter :: infall_inst_mass_def = 1._CDR
  real(CDR), parameter :: infall_const_mass_def = 1._CDR
  real(CDR), parameter :: infall_expo_mass_def = 1._CDR
  real(CDR), parameter :: infall_reserv_power_def = 1._CDR
  real(CDR), parameter :: infall_begin_time_def = 0._CDR
  real(CDR), parameter :: infall_end_time_def = max_age

!#**********************************************************************
!# Default values of parameters used in "mod_read_cosmo_param.f90":

  real(CDR), parameter :: Omega_m_def = 0.308_CDR !# Planck 2015 results. XIII. Cosmological parameters, \
  real(CDR), parameter :: H_0_def = 67.8_CDR       !# A&A 594, A13.

  real(CDR), parameter :: form_redshift_def = 10._CDR
  logical, parameter :: CBR_def = .false.

end module mod_spectra_def_param

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université,
!# Institut d'astrophysique de Paris/CNRS, France.
!#
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides
!# by the rules of distribution of free software. You can use, modify and/or
!# redistribute this software under the terms of the CeCILL license as circulated
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!#
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability.
!#
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#======================================================================

module mod_write_spectra_output

  implicit none
  private

  public :: write_spectra_main_preamble, write_spectra_various, write_spectra_SED, &
       write_spectra_warning, write_spectra_grain_preamble

contains

!#======================================================================

  subroutine write_spectra_main_preamble(unit_spectra, spectra_output, time_step, &
       dim_output_age, dim_elem, elem_id, &
       dim_species_SFC, dim_species_DISM, &
       species_id_SFC, species_id_DISM, dim_cont, dim_line, &
       lambda_cont, lambda_line, line_id, &
       max_dim_reserv, &
       reserv_warn_present, SF_warn_present, SF_warn_age, &
       infall_warn_present, infall_warn_age, &
       outflow_warn_present, outflow_warn_age, &
       run_begin_time, dim_SSP, header_SSPs)

    use mod_types
    use mod_convert_type, only : to_string
    use mod_strings, only : quote_string
    use mod_constants, only : in_um_to_in_A
    use mod_write_scenario_param, only : write_scenario_param
    use mod_code_version, only : version_id, version_date
    use mod_compiler, only : compiler
    use mod_linked_list
    implicit none
    integer, intent(in) :: unit_spectra, dim_output_age, dim_elem, dim_cont, dim_line, max_dim_reserv
    integer, intent(in) :: dim_species_SFC, dim_species_DISM
    character(len=*), intent(in) :: spectra_output
    character(len=*), dimension(:), intent(in) :: elem_id, line_id
    character(len=*), dimension(:), intent(in) :: species_id_SFC, species_id_DISM
    real(CDR), intent(in) :: time_step
    real(CDR), dimension(:), intent(in) :: lambda_cont, lambda_line
    logical, intent(in) :: reserv_warn_present, SF_warn_present, &
         outflow_warn_present
    logical, dimension(:), intent(in) :: infall_warn_present
    real(CDR), intent(in) :: SF_warn_age, &
         outflow_warn_age
    real(CDR), dimension(:), intent(in) :: infall_warn_age
    character(len=*), intent(in) :: run_begin_time
    integer, intent(in) :: dim_SSP
    type(lk_lst_long_string), dimension(:) :: header_SSPs
!#......................................................................
    integer :: i_elem, i_species, i_line, i_reserv, line_id_max_length
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call write_scenario_param( &
         version_id, &
         version_date, &
         compiler, &
         run_begin_time, &
         dim_SSP, &
         header_SSPs, &
         unit_spectra, line_prefix = "!#")

    line_id_max_length = maxval(len_trim(line_id(:)))

    if (spectra_output /= "none") then
       write(unit_spectra, "(f8.2,a)") time_step, " !# `time_step`."
       write(unit_spectra, "(i0,a)") dim_output_age, " !# `dim_output_age`."
       write(unit_spectra, "(i0,a)") dim_elem, " !# `dim_elem`."
       write(unit_spectra, "(" // to_string(dim_elem) // "(a,tr1),a)") &
            (quote_string(elem_id(i_elem)), i_elem=1,dim_elem), &
            "!# `elem_id(1:dim_elem)`."
       write(unit_spectra, "(i0,tr1,i0,a)") dim_species_SFC, &
            dim_species_DISM, " !# `dim_species_SFC`, `dim_species_DISM`."
       write(unit_spectra, "(" // to_string(dim_species_SFC) // "(a,tr1),a)") &
            (quote_string(species_id_SFC(i_species)), i_species=1,dim_species_SFC), &
            "!# `species_id_SFC(1:dim_species_SFC)`."
       write(unit_spectra, "(" // to_string(dim_species_DISM) // "(a,tr1),a)") &
            (quote_string(species_id_DISM(i_species)), i_species=1,dim_species_DISM), &
            "!# `species_id_DISM(1:dim_species_DISM)`."
       write(unit_spectra, "(i0,a)") dim_cont, " !# `dim_cont`."
       write(unit_spectra, "(i0,a)") dim_line, " !# `dim_line`."
       write(unit_spectra, "(a)") "!# `lambda_cont`:"
!# Unit conversion:
       write(unit_spectra, "(5(f10.1, tr2))") &
            lambda_cont(1:dim_cont)*in_um_to_in_A !# -> wavelength in angstroems.
       write(unit_spectra, "(a)") "!# `line_id`, `lambda_line`:"
       write(unit_spectra, "(a,t" // to_string(line_id_max_length+4) // ",f9.1)") &
            (quote_string(line_id(i_line)), &
            lambda_line(i_line)*in_um_to_in_A, & !# -> wavelength in angstroems.
            i_line = 1, dim_line)

       write(unit_spectra, "(2a)") to_string(reserv_warn_present), &
            " !# `reserv_warn_present`."

       write(unit_spectra, "(2a)") to_string(SF_warn_present), &
            " !# `SF_warn_present`."
       if (SF_warn_present) then
          write(unit_spectra, "(f8.2, a)") SF_warn_age, " !# `SF_warn_age`."
       endif

       write(unit_spectra, "(i0,a)") count(infall_warn_present), &
            " !# `dim_infall_warn`."
       do i_reserv = 1, max_dim_reserv
          if (infall_warn_present(i_reserv)) then
             write(unit_spectra, "(i0,tr1,f8.2, a)") i_reserv, &
                  infall_warn_age(i_reserv), &
                  " !# `infall_warn_present` for this reservoir, `infall_warn_age`."
          endif
       enddo

       write(unit_spectra, "(2a)") to_string(outflow_warn_present), &
            " !# `outflow_warn_present`."
       if (outflow_warn_present) then
          write(unit_spectra, "(f8.2, a)") outflow_warn_age, " !# `outflow_warn_age`."
       endif
    endif

  end subroutine write_spectra_main_preamble

!#======================================================================

  subroutine write_spectra_various(unit_spectra, spectra_output, &
       time, convol_time, cosmic_time, redshift, &
       galaxy_mass, live_stars_mass, WD_mass, BHNS_mass, &
       inert_mass, ISM_mass, ISM_Z, &
       stel_Z_mass_avrg, stel_Z_bol_avrg, carb_abund, sil_abund, &
       ISM_abund, L_bol, tau_V, dust_bol_ratio, SF_rate, &
       Lyman_cont_rate, CCSN_rate, SNIa_rate, &
       stel_age_mass_avrg, stel_age_bol_avrg, &
       Lyman_cont_gas_abs, Lyman_cont_dust_abs, &
       ejec_rate_tot, infall_rate, outflow_rate, &
       ejec_cumul_mass, SF_live_cumul_mass, &
       infall_cumul_mass, outflow_cumul_mass, &
       L_dust_SFC, L_dust_DISM, &
       opt_depth_warn_present, opt_depth_warn_min_lambda, opt_depth_warn_max_lambda)

    use mod_types
    use mod_convert_type, only : to_string

    implicit none
    integer, intent(in) :: unit_spectra
    character(len=*), intent(in) :: spectra_output
    real(CDR), intent(in) :: time, convol_time, cosmic_time, &
         redshift, galaxy_mass, live_stars_mass, WD_mass, BHNS_mass, &
         inert_mass, ISM_mass, ISM_Z, &
         stel_Z_mass_avrg, stel_Z_bol_avrg, carb_abund, sil_abund
    real(CDR), dimension(:), intent(in) :: ISM_abund
    real(CDR), intent(in) :: L_bol, tau_V, dust_bol_ratio, &
         Lyman_cont_rate, &
         stel_age_mass_avrg, stel_age_bol_avrg, Lyman_cont_gas_abs, Lyman_cont_dust_abs, &
         L_dust_SFC, L_dust_DISM
    real(DPR), intent(in) :: SF_rate, CCSN_rate, SNIa_rate, &
         ejec_rate_tot, infall_rate, outflow_rate, &
         ejec_cumul_mass, SF_live_cumul_mass, &
         infall_cumul_mass, outflow_cumul_mass
    logical :: opt_depth_warn_present
    real(CDR) :: opt_depth_warn_min_lambda, opt_depth_warn_max_lambda
!#......................................................................
    integer :: dim_elem
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (spectra_output /= "none") then
       write(unit_spectra, "(f8.2, a)") time, " !# `output_age`."
       write(unit_spectra, "(f8.2, a)") convol_time, &
            " !# `convol_time`."
       write(unit_spectra, "(es11.4, a)") cosmic_time, &
            " !# `cosmic_time`."
       write(unit_spectra, "(es11.4, a)") redshift, &
            " !# `redshift`."
       write(unit_spectra, "(es10.4, a)") galaxy_mass, &
            " !# `galaxy_mass`."
       write(unit_spectra, "(es10.4, a)") live_stars_mass, &
            " !# `live_stars_mass`."
       write(unit_spectra, "(es10.4, a)") WD_mass, " !# `WD_mass`."
       write(unit_spectra, "(es10.4, a)") BHNS_mass, &
            " !# `BHNS_mass`."
       write(unit_spectra, "(es10.4, a)") inert_mass, &
            " !# `inert_mass`."
       write(unit_spectra, "(es10.4, a)") ISM_mass, &
            " !# `ISM_mass`."
       write(unit_spectra, "(es10.4, a)") ISM_Z, &
            " !# `ISM_Z`."
       write(unit_spectra, "(es10.4, a)") stel_Z_mass_avrg, &
            " !# `stel_Z_mass_avrg`."
       write(unit_spectra, "(es10.4, a)") stel_Z_bol_avrg, &
            " !# `stel_Z_bol_avrg`."
       write(unit_spectra, "(es10.4, a)") carb_abund, " !# `carb_abund`."
       write(unit_spectra, "(es10.4, a)") sil_abund, " !# `sil_abund`."
       dim_elem = size(ISM_abund)
       write(unit_spectra, &
            "(" // to_string(dim_elem) // "(es10.4,tr1), tl1, a)") &
            ISM_abund(:), &
            " !# `ISM_abund` for elements `elem_id(1:dim_elem)`."
       write(unit_spectra, "(es10.4, a)") L_bol, " !# `L_bol`."
       write(unit_spectra, "(es10.4, a)") tau_V, " !# `tau_V`."
       write(unit_spectra, "(es10.4, a)") dust_bol_ratio, " !# `dust_bol_ratio`."
       write(unit_spectra, "(es10.4, a)") SF_rate, " !# `SF_rate`."
       write(unit_spectra, "(es10.4, a)") Lyman_cont_rate, &
            " !# `Lyman_cont_rate`."
       write(unit_spectra, "(es10.4, a)") CCSN_rate, &
            " !# `CCSN_rate`."
       write(unit_spectra, "(es10.4, a)") SNIa_rate, &
            " !# `SNIa_rate`."
       write(unit_spectra, "(es10.4, a)")  stel_age_mass_avrg, &
            " !# `stel_age_mass_avrg`."
       write(unit_spectra, "(es10.4, a)") stel_age_bol_avrg, &
            " !# `stel_age_bol_avrg`."
       write(unit_spectra, "(es10.4, a)") Lyman_cont_gas_abs, &
            " !# `Lyman_cont_gas_abs`."
       write(unit_spectra, "(es10.4, a)") Lyman_cont_dust_abs, &
            " !# `Lyman_cont_dust_abs`."
       write(unit_spectra, "(es10.4, a)") ejec_rate_tot, &
            " !# `ejec_rate_tot`."
       write(unit_spectra, "(es10.4, a)") infall_rate, &
            " !# `infall_rate`."
       write(unit_spectra, "(es10.4, a)") outflow_rate, &
            " !# `outflow_rate`."
       write(unit_spectra, "(es10.4, a)") ejec_cumul_mass, &
            " !# `ejec_cumul_mass`."
       write(unit_spectra, "(es10.4, a)") SF_live_cumul_mass, &
            " !# `SF_live_cumul_mass`."
       write(unit_spectra, "(es10.4, a)") infall_cumul_mass, &
            " !# `infall_cumul_mass`."
       write(unit_spectra, "(es10.4, a)") outflow_cumul_mass, &
            " !# `outflow_cumul_mass`."
       write(unit_spectra, "(es10.4, a)") L_dust_SFC, " !# `L_dust_SFC`."
       write(unit_spectra, "(es10.4, a)") L_dust_DISM, " !# `L_dust_DISM`."

       write(unit_spectra, "(2a)") to_string(opt_depth_warn_present), " !# `opt_depth_warn_present`."
       if (opt_depth_warn_present) then
          write(unit_spectra, "(es10.4, a)") opt_depth_warn_min_lambda, &
               " !# `opt_depth_warn_min_lambda`."
          write(unit_spectra, "(es10.4, a)") opt_depth_warn_max_lambda, &
               " !# `opt_depth_warn_max_lambda`."
       endif
    endif

  end subroutine write_spectra_various

!#======================================================================

  subroutine write_spectra_SED(unit_spectra, spectra_output, &
       dim_species_SFC, dim_species_DISM, dim_cont, dim_line, &
       lum_cont, lum_stel_SFC_unatt, lum_stel_DISM_unatt, &
       lum_neb_cont_SFC_unatt, lum_neb_cont_DISM_unatt, &
       lum_species_SFC, lum_species_DISM, &
       L_line, L_line_SFC_unatt, L_line_DISM_unatt, &
       RF_output, RF_cont_SFC, RF_cont_DISM, RF_line_SFC, RF_line_DISM, &
       sublim_output, sublim_lum_species_SFC, sublim_lum_species_DISM)

    use mod_types
    use mod_convert_type, only : to_string, E_format
    use mod_constants, only : L_sol, per_um_to_per_A

    implicit none
    integer, intent(in) :: unit_spectra, dim_species_SFC, dim_species_DISM, dim_cont, dim_line
    character(len=*), intent(in) :: spectra_output
    real(CDR), dimension(:), intent(in) :: lum_cont, lum_stel_SFC_unatt, &
         lum_stel_DISM_unatt, lum_neb_cont_SFC_unatt, lum_neb_cont_DISM_unatt
    real(CDR), dimension(:,:), intent(in) :: lum_species_SFC, lum_species_DISM
    real(CDR), dimension(:), intent(in) :: L_line, L_line_SFC_unatt, &
         L_line_DISM_unatt
    logical, intent(in) :: RF_output
    real(CDR), dimension(:), intent(in) :: RF_cont_SFC, RF_cont_DISM
    real(CDR), dimension(:), intent(in) :: RF_line_SFC, RF_line_DISM
    logical, intent(in) :: sublim_output
    real(CDR), dimension(:,:), intent(in) :: sublim_lum_species_SFC, sublim_lum_species_DISM
!#......................................................................
    integer :: i_cont, i_line
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# `SFC`, `DISM`: star-forming clouds, diffuse ISM.
!#
!# `lum_stel_*_unatt`: unattenuated stellar spectrum from stars in region `*`.
!#
!# `lum_neb_cont_*_unatt`: unattenuated nebular continuum from ionized gas
!# in region `*`.
!#
!# `L_line_*_unatt`: the same for emission lines.
!#
!# `lum_species_*`: spectrum emitted by dust species in region `*`.
!#
!# `lum_cont`: emerging overall continuum spectrum (monochromatic luminosity in erg.s-1.angstroem-1.).
!#
!# `L_line`: the same for emission lines (in erg.s-1).
!#
!# `RF_cont` and `RF_line`: radiation field at continuum and line wavelengths.

    if (spectra_output == "detailed") then
       if (RF_output) then
          write(unit_spectra, "(a)") &
               "!# `lum_cont`, `lum_stel_SFC_unatt`, `lum_stel_DISM_unatt`, &
               &`lum_neb_cont_SFC_unatt`, `lum_neb_cont_DISM_unatt`, &
               &`RF_cont_SFC`, `RF_cont_DISM`:"
          do i_cont = 1, dim_cont
             write(unit_spectra, "(7(a9, tr1))") &
                  E_format(lum_cont(i_cont), 9, 3), &
                  E_format(lum_stel_SFC_unatt(i_cont)*L_sol, 9, 3), &
                  E_format(lum_stel_DISM_unatt(i_cont)*L_sol, 9, 3), &
                  E_format(lum_neb_cont_SFC_unatt(i_cont)*L_sol, 9, 3), &
                  E_format(lum_neb_cont_DISM_unatt(i_cont)*L_sol, 9, 3), &
                  E_format(RF_cont_SFC(i_cont), 9, 3), &
                  E_format(RF_cont_DISM(i_cont), 9, 3)
          enddo
          write(unit_spectra, "(a,i0,a,i0,a)") &
               "!# `lum_species_SFC(1:", dim_species_SFC, &
               ")`, `lum_species_DISM(1:", dim_species_DISM, &
               ")`:"
          do i_cont = 1, dim_cont
             write(unit_spectra, "(" // &
                  to_string(dim_species_SFC+dim_species_DISM) // &
                  "(a9, tr1))") &
!# Unit conversion:
                  E_format(lum_species_SFC(1:dim_species_SFC,i_cont)*per_um_to_per_A, 9, 3), &
                  E_format(lum_species_DISM(1:dim_species_DISM,i_cont)*per_um_to_per_A, 9, 3)
          enddo
       else !# `RF_output = .false.`.
          write(unit_spectra, "(a)") &
               "!# `lum_cont`, `lum_stel_SFC_unatt`, `lum_stel_DISM_unatt`, &
               &`lum_neb_cont_SFC_unatt`, `lum_neb_cont_DISM_unatt`:"
          do i_cont = 1, dim_cont
             write(unit_spectra, "(5(a9, tr1))") &
                  E_format(lum_cont(i_cont), 9, 3), &
                  E_format(lum_stel_SFC_unatt(i_cont)*L_sol, 9, 3), &
                  E_format(lum_stel_DISM_unatt(i_cont)*L_sol, 9, 3), &
                  E_format(lum_neb_cont_SFC_unatt(i_cont)*L_sol, 9, 3), &
                  E_format(lum_neb_cont_DISM_unatt(i_cont)*L_sol, 9, 3)
          enddo
          write(unit_spectra, "(a,i0,a,i0,a)") &
               "!# `lum_species_SFC(1:", dim_species_SFC, &
               ")`, `lum_species_DISM(1:", dim_species_DISM, &
               ")`:"
          do i_cont = 1, dim_cont
             write(unit_spectra, "(" // to_string(dim_species_SFC+dim_species_DISM) // "(a9, tr1))") &
!# Unit conversion:
                  E_format(lum_species_SFC(1:dim_species_SFC,i_cont)*per_um_to_per_A, 9, 3), &
                  E_format(lum_species_DISM(1:dim_species_DISM,i_cont)*per_um_to_per_A, 9, 3)
          enddo
       endif

       if (sublim_output) then
          write(unit_spectra, "(a,i0,a,i0,a)") &
               "!# `sublim_lum_species_SFC(1:", dim_species_SFC, &
               ")`, `sublim_lum_species_DISM(1:", dim_species_DISM, ")`:"
          do i_cont = 1, dim_cont
             write(unit_spectra, "(" // to_string(dim_species_SFC+dim_species_DISM) // "(a9, tr1))") &
!# Unit conversion:
                  E_format(sublim_lum_species_SFC(1:dim_species_SFC,i_cont)*per_um_to_per_A, 9, 3), &
                  E_format(sublim_lum_species_DISM(1:dim_species_DISM,i_cont)*per_um_to_per_A, 9, 3)
          enddo
       endif

       if (RF_output) then
          write(unit_spectra, "(a)") "!# `L_line`, `L_line_SFC_unatt`, &
               &`L_line_DISM_unatt`, `RF_line_SFC`, `RF_line_DISM`:"
          do i_line = 1, dim_line
             write(unit_spectra, "(5(a9, tr1))") &
                  E_format(L_line(i_line), 9, 3), &
                  E_format(L_line_SFC_unatt(i_line)*L_sol, 9, 3), &
                  E_format(L_line_DISM_unatt(i_line)*L_sol, 9, 3), &
                  E_format(RF_line_SFC(i_line), 9, 3), &
                  E_format(RF_line_DISM(i_line), 9, 3)
          enddo
       else
          write(unit_spectra, "(a)") "!# `L_line`, `L_line_SFC_unatt`, &
               &`L_line_DISM_unatt`:"
          do i_line = 1, dim_line
             write(unit_spectra, "(3(a9, tr1))") &
                  E_format(L_line(i_line), 9, 3), &
                  E_format(L_line_SFC_unatt(i_line)*L_sol, 9, 3), &
                  E_format(L_line_DISM_unatt(i_line)*L_sol, 9, 3)
          enddo
       endif

    else if (spectra_output == "basic") then
       write(unit_spectra, "(a)") "!# `lum_cont`:"
       write(unit_spectra, "(10(a9, tr1))") &
            E_format(lum_cont(1:dim_cont), 9, 3)
       write(unit_spectra, "(a)") "!# `L_line`:"
       write(unit_spectra, "(10(a9, tr1))") &
            E_format(L_line(1:dim_line), 9, 3)
    endif

  end subroutine write_spectra_SED

!#======================================================================

  subroutine write_spectra_warning(unit_spectra, spectra_file, &
       spectra_output, unit_log, verbosity, output_age, max_dim_reserv, &
       reserv_warn_present, &
       SF_warn_present, SF_warn_age, &
       infall_warn_present, infall_warn_age, &
       outflow_warn_present, outflow_warn_age, &
       opt_depth_warn_present, opt_depth_warn_min_lambda, opt_depth_warn_max_lambda)

    use mod_types
    use mod_strings, only : quote_string
    use mod_convert_type, only : to_string
    use mod_write_scenario_param, only : ord_scenario
    implicit none
    integer, intent(in) :: unit_spectra, unit_log, verbosity, max_dim_reserv
    character(len=*), intent(in) :: spectra_file, spectra_output
    real(CDR), dimension(:), intent(in) :: output_age, infall_warn_age, &
         opt_depth_warn_min_lambda, opt_depth_warn_max_lambda
    logical, dimension(:), intent(in) :: infall_warn_present, opt_depth_warn_present
    logical, intent(in) :: reserv_warn_present, SF_warn_present, outflow_warn_present
    real(CDR), intent(in) :: SF_warn_age, outflow_warn_age
!#......................................................................
    integer :: i_reserv, i_output_age
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (reserv_warn_present .or. SF_warn_present .or. &
         any(infall_warn_present) .or. outflow_warn_present .or. &
         any(opt_depth_warn_present)) then
       write(unit_log, "(/a,i0)", advance="no") "Scenario number ", ord_scenario
       if (spectra_output /= "none") then
          write(unit_log, "(3a/)") ", file ", &
               quote_string(spectra_file), ":"
       else
          write(unit_log, "(a/)") ":"
       endif
    endif

    if (reserv_warn_present) then
       if (spectra_output /= "none") &
            write(unit_spectra, "(a/,a/,a)") "!# WARNING: &
            &the initial normalized mass of the &
            &galaxy computed from the normalized masses of the reservoir &
            &was negative.", &
            "Initial values of `reserv_mass(:)` have been scaled so that &
            &`galaxy_mass` is null at t = 0.", &
            "(The input parameters `reserv_init_mass(:)` are not changed.)"
       write(unit_log, "(a/,a/,a)") "!# WARNING: &
            &the initial normalized mass of the &
            &galaxy computed from the normalized masses of the reservoir &
            &was negative.", &
            "Initial values of `reserv_mass(:)` have been scaled so that &
            &`galaxy_mass` is null at t = 0.", &
            "(The input parameters `reserv_init_mass(:)` are not changed.)"
       if (verbosity >= 0) &
            write(*, "(2(a/),a)") &
            "WARNING: " // quote_string(spectra_file) // &
            ": the initial normalized mass of the &
            &galaxy computed from the normalized masses of the reservoir &
            &was negative.", &
            "Initial values of `reserv_mass(:)` have been scaled so that &
            &`galaxy_mass` is null at t = 0.", &
            "(The input parameters `reserv_init_mass(:)` are not changed.)"
    endif

    if (SF_warn_present) then
       if (spectra_output /= "none") &
            write(unit_spectra, "(a)") "!# WARNING: &
            &the SFR has exceeded the maximal possible rate at " // &
            to_string(SF_warn_age) // " Myr."
       if (verbosity >= 0) &
            write(*, "(a)") "WARNING: " // quote_string(spectra_file) // &
            ": the SFR has exceeded the maximal possible rate at " // &
            to_string(SF_warn_age) // " Myr."
    endif

    do i_reserv = 1, max_dim_reserv
       if (infall_warn_present(i_reserv)) then
          if (spectra_output /= "none") &
               write(unit_spectra, "(a,i0,a)") "!# WARNING: &
               &the infall rate from reservoir ", i_reserv, &
               " has exceeded the maximal possible rate at " // &
               to_string(infall_warn_age(i_reserv)) // " Myr."
          write(unit_log, "(a,i0,a)") "!# WARNING: &
               &the infall rate from reservoir ", i_reserv, &
               " has exceeded the maximal possible rate at " // &
               to_string(infall_warn_age(i_reserv)) // " Myr."
          if (verbosity >= 0) &
               write(*, "(a,i0,a)") "WARNING: " // quote_string(spectra_file) // &
               ": the infall rate from reservoir ", i_reserv, &
               " has exceeded the maximal possible rate at " // &
               to_string(infall_warn_age(i_reserv)) // " Myr."
       endif
    enddo

    if (outflow_warn_present) then
       if (spectra_output /= "none") &
            write(unit_spectra, "(a)") &
            "!# WARNING: the outflow rate &
            &has exceeded the maximal possible rate at " // &
            to_string(outflow_warn_age) // " Myr."
       write(unit_log, "(a)") &
            "!# WARNING: the outflow rate &
            &has exceeded the maximal possible rate at " // &
            to_string(outflow_warn_age) // " Myr."
       if (verbosity >= 0) &
            write(*, "(a)") "WARNING: " // quote_string(spectra_file) // &
            ": the outflow rate has exceeded the maximal possible &
            &rate at " // to_string(outflow_warn_age) // " Myr."
    endif

    do i_output_age = 1, size(output_age)
       if (opt_depth_warn_present(i_output_age)) then
          if (spectra_output /= "none")  &
               write(unit_spectra, "(a)") "!# WARNING: &
               &the optical depth exceeds the maximal value &
               &for which the radiative transfer has been precomputed at " // &
               to_string(output_age(i_output_age)) // &
               " Myr for wavelengths in [" // &
               to_string(opt_depth_warn_min_lambda(i_output_age)) // ", " // &
               to_string(opt_depth_warn_max_lambda(i_output_age)) // "] micrometers."
          write(unit_log, "(a)") "!# WARNING: &
               &the optical depth exceeds the maximal value &
               &for which the radiative transfer has been precomputed at " // &
               to_string(output_age(i_output_age)) // &
               " Myr for wavelengths in [" // &
               to_string(opt_depth_warn_min_lambda(i_output_age)) // ", " // &
               to_string(opt_depth_warn_max_lambda(i_output_age)) // "] micrometers."
          if (verbosity >= 0) write(*, "(a)") "WARNING: " // &
               quote_string(spectra_file) // &
               ": the optical depth exceeds the maximal value for which &
               &the radiative transfer has been precomputed at " // &
               to_string(output_age(i_output_age)) // &
               " Myr for wavelengths in [" // &
               to_string(opt_depth_warn_min_lambda(i_output_age)) // ", " // &
               to_string(opt_depth_warn_max_lambda(i_output_age)) // "] micrometers."
       endif
    enddo

  end subroutine write_spectra_warning

!#======================================================================

  subroutine write_spectra_grain_preamble(unit_grain_temp, unit_grain_SED, &
       dim_species_SFC, dim_species_DISM, &
       stoch_heating_SFC, stoch_heating_DISM, &
       species_id_SFC, species_id_DISM, output_age, &
       grain_output_min_age, grain_output_max_age, &
       grain_output_SFC, grain_output_DISM, &
       grain_temp_output, grain_SED_output, grain_abs_SFC, grain_abs_DISM, &
       run_begin_time, dim_SSP, header_SSPs)

    use mod_types
    use mod_grain_properties, only : struct_grain_abs
    use mod_strings, only : quote_string
    use mod_write_scenario_param, only : write_scenario_param, write_parameter
    use mod_code_version, only : version_id, version_date
    use mod_compiler, only : compiler
    use mod_linked_list
    implicit none
    integer, intent(in) :: unit_grain_temp, unit_grain_SED
    integer, intent(in) :: dim_species_SFC, dim_species_DISM
    logical, intent(in) :: stoch_heating_SFC, stoch_heating_DISM
    logical, intent(in) :: grain_output_SFC, grain_output_DISM
    logical, intent(in) :: grain_temp_output, grain_SED_output
    character(len=*), dimension(:), intent(in) :: species_id_SFC, species_id_DISM
    real(CDR), dimension(:), intent(in) :: output_age
    real(CDR), intent(in) :: grain_output_min_age, grain_output_max_age
    type(struct_grain_abs), dimension(:), intent(in) :: grain_abs_SFC, &
         grain_abs_DISM
    character(len=*), intent(in) :: run_begin_time
    integer, intent(in) :: dim_SSP
    type(lk_lst_long_string), dimension(:) :: header_SSPs
!#......................................................................
    integer :: output_grain_dim_time, output_grain_dim_region, i_species
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    output_grain_dim_time = count(output_age(:) >= grain_output_min_age &
         .and. output_age(:) <= grain_output_max_age)
    output_grain_dim_region = &
         count((/grain_output_SFC, grain_output_DISM/))

    if (grain_temp_output) then
!# Note: main data are written by subroutine `write_grain_temp` of "mod_dust_emission.f90".
       call write_scenario_param( &
            version_id, &
            version_date, &
            compiler, &
            run_begin_time, &
            dim_SSP, &
            header_SSPs, &
            unit_grain_temp, line_prefix = "!#", for_grains = .true.)

       write(unit_grain_temp, "(i0,tr1,i0)") output_grain_dim_time, &
            output_grain_dim_region

!# Note: grain species and wavelengths written once for star-forming clouds and once for
!# the diffuse ISM, in case grain size distributions and properties depend
!# on the region.

       if (grain_output_SFC) then
          write(unit_grain_temp, "(a,tr1,i0,tr1,l1)") &
               quote_string("SFC"), dim_species_SFC, stoch_heating_SFC
          do i_species = 1, dim_species_SFC
             write(unit_grain_temp, "(a)") quote_string(species_id_SFC(i_species))
          enddo
       endif

       if (grain_output_DISM) then
          write(unit_grain_temp, "(a,tr1,i0,tr1,l1)") &
               quote_string("DISM"), dim_species_DISM, stoch_heating_DISM
          do i_species = 1, dim_species_DISM
             write(unit_grain_temp, "(a)") quote_string(species_id_DISM(i_species))
          enddo
       endif
    endif

    if (grain_SED_output) then
!# Note: main data are written by subroutine `write_grain_SED` of "mod_dust_emission.f90".
       call write_scenario_param( &
            version_id, &
            version_date, &
            compiler, &
            run_begin_time, &
            dim_SSP, &
            header_SSPs, &
            unit_grain_SED, line_prefix = "!#", for_grains = .true.)

       write(unit_grain_SED, "(i0,tr1,i0)") output_grain_dim_time, &
            output_grain_dim_region

!# Note: grain species and wavelengths written once for star-forming clouds and once for
!# the diffuse ISM, in case grain size distributions and properties depend
!# on the region.

       if (grain_output_SFC) then
          write(unit_grain_SED, "(a,tr1,i0,tr1,l1)") &
               quote_string("SFC"), dim_species_SFC, stoch_heating_SFC
          do i_species = 1, dim_species_SFC
             write(unit_grain_SED, "(a,tr1,i0)") &
                  quote_string(species_id_SFC(i_species)), grain_abs_SFC(i_species) % dim_lambda
             write(unit_grain_SED, "(10(es10.4,tr1))") &
                  grain_abs_SFC(i_species) % lambda(1:grain_abs_SFC(i_species) % dim_lambda)
          enddo
       endif

       if (grain_output_DISM) then
          write(unit_grain_SED, "(a,tr1,i0,tr1,l1)") &
               quote_string("DISM"), dim_species_DISM, stoch_heating_DISM
          do i_species = 1, dim_species_DISM
             write(unit_grain_SED, "(a,tr1,i0)") &
                  quote_string(species_id_DISM(i_species)), grain_abs_DISM(i_species) % dim_lambda
             write(unit_grain_SED, "(10(es10.4,tr1))") &
                  grain_abs_DISM(i_species) % lambda(1:grain_abs_DISM(i_species) % dim_lambda)
          enddo
       endif
    endif

  end subroutine write_spectra_grain_preamble

end module mod_write_spectra_output

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_filters

  use mod_types

  implicit none
  private

  type :: struct_filter
     character(std_string) :: file, id, trans_type, calib_type
     integer :: power
     real(DPR) :: lambda_nom
     real(DPR) :: ZPO !# zero point offset. !!! Not used currently.
     integer :: dim_lambda
     real(DPR), dimension(:), pointer :: lambda => null(), trans => null()
  end type struct_filter

  public :: struct_filter, read_filters, flux_band

contains

!#======================================================================

  subroutine read_filters(filters_list, dim_filter, filter)

    use mod_linked_list
    use mod_file_access, only : open_file, skip_comment_lines, skip_lines, &
         close_file, path_file
    use mod_directories, only : calib_dir
    use mod_heap_index, only : heap_index
    use mod_filters_constants, only : filter_min_resol
    implicit none
    character(len=*), intent(in) :: filters_list
    integer, intent(out) :: dim_filter
    type(struct_filter), dimension(:), pointer :: filter
!#......................................................................
    integer :: unit_list, unit_filter, i_filter, error, dim_lambda
    character(std_string) :: filter_file
    character(long_string) :: line
    real(DPR) :: lambda, trans
    type(lk_lst_std_string) :: head_node
    type(lk_lst_std_string), pointer :: current_node, next_node
    type(lk_lst_DPR) :: head_node_lambda, head_node_trans
    type(lk_lst_DPR), pointer :: current_node_lambda, current_node_trans
    logical :: exist
    integer :: i_supp, n_supp
    integer :: pos
    real(DPR) :: lambda_prev, trans_prev
    integer, dimension(:), allocatable :: idx
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call open_file(unit_list, filters_list, exist = exist)
    dim_filter = 0
    call lk_lst_initialize(head_node)
    do
       read(unit_list, *, iostat = error) filter_file
       if (error /= 0 .or. filter_file == "") exit
       dim_filter = dim_filter+1
       call lk_lst_new_node(head_node, current_node)
       current_node % val = adjustl(filter_file)
    enddo
    call close_file(unit_list)

    if (associated(filter)) then
       do i_filter = 1, size(filter)
          if (associated(filter(i_filter) % lambda)) deallocate(filter(i_filter) % lambda)
          if (associated(filter(i_filter) % trans)) deallocate(filter(i_filter) % trans)
       enddo
       deallocate(filter)
    endif
    allocate(filter(dim_filter))

    current_node => head_node % ptr
    do i_filter = 1, dim_filter
       next_node => current_node % ptr
       filter_file = current_node % val
       filter(i_filter) % file = filter_file
       deallocate(current_node)
       current_node => next_node
    end do

    allocate(idx(dim_filter))
!# Check that the same file of filter is not more than once in the list of filters.
    call heap_index(filter(:) % file, idx)
    do i_filter = 1, dim_filter-1
       if (filter(idx(i_filter)) % file == filter(idx(i_filter+1)) % file) then
          write(*, "(a)") "The file of filter """ // &
               trim(filter(idx(i_filter)) % file) // &
               """ appears more than once in """ // trim(filters_list) // &
               """. Stopped."
          stop
       endif
    enddo

    do i_filter = 1, dim_filter
       call open_file(unit_filter, path_file(calib_dir, filter(i_filter) % file), &
            exist = exist)
       read(unit_filter, *) filter(i_filter) % id
       read(unit_filter, *) filter(i_filter) % trans_type
       read(unit_filter, "(a)") line
       line = adjustl(line)
       read(line, *) filter(i_filter) % calib_type

       if (line(1:1) == '"') then
          line = line(2:)
          pos = index(line, '"')
       else if (line(1:1) == "'") then
          line = line(2:)
          pos = index(line, "'")
       else !# No quote character.
          pos = index(line, " ")
       endif
       line = adjustl(line(pos+1:))
       if (filter(i_filter) % calib_type == "Vega") then
          if (line == "") then !# `ZPO` is optional.
             filter(i_filter) % ZPO = 0
          else
             read(line, *, iostat=error) filter(i_filter) % ZPO
             if (error /= 0) then
                write(*, "(a)") "Filter """ // trim(filter(i_filter) % id) // &
                     """: `ZPO` cannot be read. Stopped."
                stop
             endif
          endif
       else if (filter(i_filter) % calib_type == "IRAS") then
          read(line, *, iostat=error) filter(i_filter) % lambda_nom
          if (error /= 0) then
             write(*, "(a)") "Filter """ // trim(filter(i_filter) % id) // &
                  """: `lambda_nom` cannot be read. Stopped."
             stop
          endif
       else if (.not.any(filter(i_filter) % calib_type == (/"AB   ", "TG   ", "HST  ", "FOCA ", "D4000"/))) then
          write(*, "(a)") "Filter """ // trim(filter(i_filter) % id) // &
               """: type of calibration """ // &
               trim(filter(i_filter) % calib_type) // """ is not defined. Stopped."
          stop
       endif

       if (filter(i_filter) % trans_type == "energy") then
          filter(i_filter) % power = 0
       else if (filter(i_filter) % trans_type == "nb_phot") then
          filter(i_filter) % power = 1
       else
          write(*, "(a)") "Filter """ // trim(filter(i_filter) % id) // &
               """: type of transmission """ // &
               trim(filter(i_filter) % trans_type) // """ is not defined. Stopped."
          stop
       end if

       dim_lambda = 0
       call lk_lst_initialize(head_node_lambda)
       call lk_lst_initialize(head_node_trans)
       do
          read(unit_filter, *, iostat = error) lambda, trans
          if (error /= 0) exit
          dim_lambda = dim_lambda+1

          if (dim_lambda > 1) then
             n_supp = floor(filter_min_resol*(lambda-lambda_prev)/lambda_prev)
             do i_supp = 1, n_supp
                dim_lambda = dim_lambda+1
                call lk_lst_new_node(head_node_lambda, current_node_lambda)
                call lk_lst_new_node(head_node_trans, current_node_trans)
                current_node_lambda % val = lambda_prev + (lambda-lambda_prev)*i_supp/n_supp
                current_node_trans % val = trans_prev + (trans-trans_prev)*i_supp/n_supp
             enddo
          endif

          call lk_lst_new_node(head_node_lambda, current_node_lambda)
          call lk_lst_new_node(head_node_trans, current_node_trans)
          current_node_lambda % val = lambda
          current_node_trans % val = trans

          lambda_prev = lambda
          trans_prev = trans
       end do
       call close_file(unit_filter)

       filter(i_filter) % dim_lambda = dim_lambda
       call lk_lst_to_array(head_node_lambda, filter(i_filter) % lambda, dim_lambda)
       call lk_lst_to_array(head_node_trans, filter(i_filter) % trans, dim_lambda)
    end do
    call lk_lst_destroy(head_node_lambda)
    call lk_lst_destroy(head_node_trans)

!# Check that the same identifier is not used for two filters or more.
    call heap_index(filter(:) % id, idx)
    do i_filter = 1, dim_filter-1
       if (filter(idx(i_filter)) % id == filter(idx(i_filter+1)) % id) then
          write(*, "(a)") "The files of filter """ // &
               trim(path_file(calib_dir, filter(idx(i_filter)) % file)) // &
               """ and """ // &
               trim(path_file(calib_dir, filter(idx(i_filter+1)) % file)) // &
               """ share the same identifier, """ // &
               trim(filter(idx(i_filter)) % id) // &
               """. Change the identifier in one of these files. Stopped."
          stop
       endif
    enddo
    deallocate(idx)

  end subroutine read_filters

!#======================================================================

  function flux_band(filter, dim_lambda_cont, lambda_cont, lum_cont, &
       dim_line, lambda_line, L_line)

    use mod_types
    use mod_interp, only : interp_lin_lin, interp_log_log

    implicit none
    real(DPR) :: flux_band
    type(struct_filter), intent(in) :: filter
    integer, intent(in) :: dim_lambda_cont
    real(DPR), dimension(:), intent(in) :: lambda_cont, lum_cont
    integer, intent(in), optional :: dim_line
    real(DPR), dimension(:), intent(in), optional :: lambda_line, L_line
!#......................................................................
    integer :: i_lambda, i_cont, i_line
    real(DPR) :: lambda_inf, lambda_sup, trans_line
    real(DPR) :: lum_inf, lum_sup, trans_inf, trans_sup
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    flux_band = 0
    if ((lambda_cont(1) <= filter % lambda(1)) .and. &
         (lambda_cont(dim_lambda_cont) >= filter % lambda(filter % dim_lambda))) then
       i_cont = 1
       do while(lambda_cont(i_cont+1) < filter % lambda(1))
          i_cont = i_cont+1
       enddo
       i_lambda = 1
       lambda_inf = filter % lambda(i_lambda)
       trans_inf = 0
       lum_inf = 0
       lambda_sup = lambda_inf
       do while(i_lambda+1 <= filter % dim_lambda .and. i_cont+1 <= dim_lambda_cont)
          if (filter % lambda(i_lambda+1) < lambda_cont(i_cont+1)) then
             lambda_sup = filter % lambda(i_lambda+1)
             lum_sup = interp_log_log(lambda_cont(i_cont), lambda_cont(i_cont+1), &
                  lum_cont(i_cont), lum_cont(i_cont+1), lambda_sup)
             trans_sup = filter % trans(i_lambda+1)*lambda_sup**filter % power
             i_lambda = i_lambda+1
          else
             lambda_sup = lambda_cont(i_cont+1)
             lum_sup = lum_cont(i_cont+1)
             trans_sup = interp_lin_lin(filter % lambda(i_lambda), filter % lambda(i_lambda+1), &
                  filter % trans(i_lambda), filter % trans(i_lambda+1), lambda_sup) &
                  * lambda_sup**filter % power
             i_cont = i_cont+1
          endif

          flux_band = flux_band+(trans_inf*lum_inf+trans_sup*lum_sup) &
               *(lambda_sup - lambda_inf)/2

          lambda_inf = lambda_sup
          lum_inf = lum_sup
          trans_inf = trans_sup
       enddo
    endif

    if (present(dim_line)) then
       do i_line = 1, dim_line
          i_lambda = 1
          if ((lambda_line(i_line) > filter % lambda(1)) .and. &
               (lambda_line(i_line) < filter % lambda(filter % dim_lambda))) then
             do while (.not.((lambda_line(i_line) >= filter % lambda(i_lambda)) .and. &
                  (lambda_line(i_line) < filter % lambda(i_lambda+1))))
                i_lambda = i_lambda+1
             end do

             trans_line = interp_lin_lin(filter % lambda(i_lambda), filter % lambda(i_lambda+1), &
                  filter % trans(i_lambda), filter % trans(i_lambda+1), lambda_line(i_line)) &
                  * lambda_line(i_line)**filter % power

             flux_band = flux_band + trans_line*L_line(i_line)
          end if
       end do
    endif

  end function flux_band

end module mod_filters

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_file_name_decomposition

  implicit none
  private
  public :: file_name_decomposition, path_file

contains

!#======================================================================
  
  subroutine file_name_decomposition(full_name, dir_name, stem, &
       extension, base_name, dir_sep, ext_sep, absolute_path)

!# `full_name` = `dir_name` + `base_name`.
!# `base_name` = `stem` + `extension`.
!# If not void, the last non blank character of `dir_name` is `dir_sep_eff` 
!# (`/` in Unix).
!# If not void, the first character of `extension` is `ext_sep_eff`
!# (`.` normally).

    implicit none
    character(len=*), intent(in) :: full_name    
    character(len=1), intent(in), optional :: dir_sep, ext_sep
    character(len=len(full_name)), intent(out), optional :: &
         dir_name, stem, extension, base_name
    logical, intent(out), optional :: absolute_path
!#......................................................................
    character(len=1), parameter :: dir_sep_def = "/"
    character(len=1) :: dir_sep_eff
    character(len=1), parameter :: ext_sep_def = "."
    character(len=1) :: ext_sep_eff
    character(len=len(full_name)) :: dir_name_eff, stem_eff, &
         extension_eff, base_name_eff
    integer :: pos
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(dir_sep)) then
       dir_sep_eff = dir_sep
    else
       dir_sep_eff = dir_sep_def
    endif

    pos = index(full_name, dir_sep_eff, back = .true.)
    dir_name_eff = adjustl(full_name(:pos))
    base_name_eff = adjustl(full_name(pos+1:))

    if (present(ext_sep)) then
       ext_sep_eff = ext_sep
    else
       ext_sep_eff = ext_sep_def
    endif

    pos = index(base_name_eff, ext_sep_eff, back = .true.)
    if (pos > 1) then !# "> 1" and not "> 0", so that hidden files (beginning
!# with a dot) will not be considered as extension if there is no other dot.
       stem_eff = base_name_eff(:pos-1)
       extension_eff = base_name_eff(pos:)
    else
       stem_eff = base_name_eff
       extension_eff = ""
    endif
    if (present(dir_name)) dir_name = dir_name_eff
    if (present(stem)) stem = stem_eff
    if (present(extension)) extension = extension_eff
    if (present(base_name)) base_name = base_name_eff
    if (present(absolute_path)) then
       if (dir_name_eff(1:1) == dir_sep_eff .or. dir_name_eff(1:1) == "~") then
          absolute_path = .true.
       else
          absolute_path = .false.
       endif
    endif

  end subroutine file_name_decomposition

!#======================================================================

  function path_file(dir_name, file_name)

    use mod_types
    implicit none
    character(len=*), intent(in) :: dir_name, file_name
    character(len=len_trim(dir_name)+len_trim(file_name)) :: path_file
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    path_file = trim(dir_name) // trim(file_name)

  end function path_file

end module mod_file_name_decomposition

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_convert_type

  use mod_types

  implicit none
  private

  interface to_string
     module procedure int_to_string, SPR_to_string, SPR_to_string_fmt, &
          DPR_to_string, DPR_to_string_fmt, bool_to_string
  end interface to_string

  interface E_format
     module procedure SPR_E_format, DPR_E_format
  end interface E_format

  character, parameter :: NAK = achar(6) !# Negative-acknowledge character.

  public :: int_to_string, SPR_to_string, SPR_to_string_fmt, &
       DPR_to_string, DPR_to_string_fmt, bool_to_string, to_string, &
       boolean_answer, E_format, SPR_E_format, DPR_E_format

contains

!#======================================================================

  pure function int_to_string_aux(x)

    use mod_types

    implicit none
    integer, intent(in) :: x
!#......................................................................
    character(len=std_string) :: int_to_string_aux
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    write(int_to_string_aux, *) x
    int_to_string_aux = adjustl(int_to_string_aux)

  end function int_to_string_aux

!#======================================================================

  function int_to_string(x)

    implicit none
    integer, intent(in) :: x
!#......................................................................
!# Surprisingly, the following works. Used to convert a number to a string
!# with exactly the right length to contain it. Inefficient because the 
!# `*_aux` function is called twice.
    character(len=len_trim(int_to_string_aux(x))) :: int_to_string 
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    int_to_string = int_to_string_aux(x)

  end function int_to_string

!#======================================================================

  pure function SPR_to_string_aux(x, fmt)

    use mod_types

    implicit none
    real(SPR), intent(in) :: x
    character(len=*), intent(in), optional :: fmt
!#......................................................................
    character(len=long_string) :: SPR_to_string_aux
    character(len=*), parameter :: fmt_def = "(es10.3)"
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(fmt)) then
       write(SPR_to_string_aux, fmt) x
    else
       write(SPR_to_string_aux, fmt_def) x
    endif
    SPR_to_string_aux = adjustl(SPR_to_string_aux)

!# If the number does not fit in the format...
    if (SPR_to_string_aux(1:1) == "*") then
       write(SPR_to_string_aux, *) x
       SPR_to_string_aux = NAK // "Inappropriate format `" // trim(fmt) // &
            "` for this real number: " // trim(adjustl(SPR_to_string_aux)) // &
            ". Stopped."
    endif

  end function SPR_to_string_aux

!#======================================================================

  function SPR_to_string(x)

    implicit none
    real(SPR), intent(in) :: x
!#......................................................................
!# See comment in `int_to_string`.
    character(len=len_trim(SPR_to_string_aux(x))) :: SPR_to_string
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    SPR_to_string = SPR_to_string_aux(x)

    if (SPR_to_string(1:1) == NAK) then
       write(*, "(a)") SPR_to_string(2:)
       stop
    endif

  end function SPR_to_string

!#======================================================================

  function SPR_to_string_fmt(x, fmt)

    implicit none
    real(SPR), intent(in) :: x
    character(len=*), intent(in) :: fmt
!#......................................................................
!# See comment in `int_to_string`.
    character(len=len_trim(SPR_to_string_aux(x, fmt))) :: &
         SPR_to_string_fmt
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    SPR_to_string_fmt = SPR_to_string_aux(x, fmt)

    if (SPR_to_string_fmt(1:1) == NAK) then
       write(*, "(a)") SPR_to_string_fmt(2:)
       stop
    endif

  end function SPR_to_string_fmt

!#======================================================================

  pure function DPR_to_string_aux(x, fmt)

    use mod_types

    implicit none
    real(DPR), intent(in) :: x
    character(len=*), intent(in), optional :: fmt
!#......................................................................
    character(len=std_string) :: DPR_to_string_aux
    character(len=*), parameter :: fmt_def = "(es10.3)"
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(fmt)) then
       write(DPR_to_string_aux, fmt) x
    else
       write(DPR_to_string_aux, fmt_def) x
    endif
    DPR_to_string_aux = adjustl(DPR_to_string_aux)

!# If the number does not fit in the format...
    if (DPR_to_string_aux(1:1) == "*") then
       write(DPR_to_string_aux, *) x
       DPR_to_string_aux = NAK // "Inappropriate format `" // trim(fmt) // &
            "` for this real number: " // trim(adjustl(DPR_to_string_aux)) // &
            ". Stopped."
    endif

  end function DPR_to_string_aux

!#======================================================================

  function DPR_to_string(x)

    implicit none
    real(DPR), intent(in) :: x
!#......................................................................
!# See comment in `int_to_string`.
    character(len=len_trim(DPR_to_string_aux(x))) :: DPR_to_string
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    DPR_to_string = DPR_to_string_aux(x)

    if (DPR_to_string(1:1) == NAK) then
       write(*, "(a)") DPR_to_string(2:)
       stop
    endif

  end function DPR_to_string

!#======================================================================

  function DPR_to_string_fmt(x, fmt)

    implicit none
    real(DPR), intent(in) :: x
    character(len=*), intent(in) :: fmt
!#......................................................................
!# See comment in `int_to_string`.
    character(len=len_trim(DPR_to_string_aux(x, fmt))) :: DPR_to_string_fmt
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    DPR_to_string_fmt = DPR_to_string_aux(x, fmt)

    if (DPR_to_string_fmt(1:1) == NAK) then
       write(*, "(a)") DPR_to_string_fmt(2:)
       stop
    endif

  end function DPR_to_string_fmt

!#======================================================================

  pure function bool_to_string_aux(x)

    use mod_types

    implicit none
    logical, intent(in) :: x
!#......................................................................
    character(len=std_string) :: bool_to_string_aux
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (x) then
       bool_to_string_aux = ".true."
    else
       bool_to_string_aux = ".false."
    endif

  end function bool_to_string_aux

!#======================================================================

  function bool_to_string(x)

    implicit none
    logical, intent(in) :: x
!#......................................................................
!# See comment in `int_to_string`.
    character(len=len_trim(bool_to_string_aux(x))) :: bool_to_string
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    bool_to_string = bool_to_string_aux(x)

  end function bool_to_string

!#======================================================================

  subroutine boolean_answer(boolean, default)

    use mod_strings, only : down_case, unquote_string

    implicit none
    logical, intent(out) :: boolean
    logical, intent(in), optional :: default
!#......................................................................
    character(len=long_string) :: string
    integer :: ios
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    do
       if (present(default)) then
          write(*, "(a)") "Default: """ // to_string(default) // &
               """. Press the <RETURN>/<ENTER> key to select it."
          write(*, "(a/a)") "Otherwise, type either "".true."" or "".false.""", &
               "(or any equivalent to these: ""T""/""true""/""Y""/""yes""... &
               &or ""F""/""false""/""N""/""no""...)."
       else
          write(*, "(a/a)") "Type either "".true."" or "".false.""", &
               "(or any equivalent to these: ""T""/""true""/""Y""/""yes""... &
               &or ""F""/""false""/""N""/""no""...)."
       endif

       read(*, "(a)") string
       string = unquote_string(string)
       string = down_case(string)
       if (present(default) .and. string == "") then
          boolean = default
          return
       endif

       if (string == "y" .or. string == "yes") then
          boolean = .true.
          return
       else if (string == "n" .or. string == "no") then
          boolean = .false.
          return
       else
          read(string,*,iostat=ios) boolean
          if (ios == 0) then
             return
          else
             write(*, "(a/)") "Wrong input."
          endif
       endif
    enddo

  end subroutine boolean_answer

!#======================================================================

  elemental function SPR_E_format(number, w_fmt, d_fmt)

!# Converts a scalar real number or an array of real numbers to
!# "ES|w_fmt|.|d_fmt|E2" format with the following modifications, to
!# ensure that the exponent part (the part following decimals) always start
!# with "E":
!#
!# -- for very small numbers (magnitude < 1O^-99), the exponent part
!#    is never written as "-^3 digits^" but as "E-99".
!#    As a consequence, leading zeroes are added and the number of significant
!#    figures is reduced (denormalized output).
!#    Example: the number 1.234*10^-101, normally output as "1.234-101"
!#    with format "ES9.3" and as "*********" with "ES9.3E2", will be printed
!#    as "0.012E-99";
!#
!# -- even smaller numbers are formatted as 0.
!#    Example: the number 1.234*10^-103, normally output as "1.234-103"
!#    with format "ES9.3", will be printed as "0.000E+00";
!#
!# -- for very large numbers (magnitude >= 10^100), the exponent part
!#    is never written as "+^3 digits^" but as "E+^3 digits^". As a consequence,
!#    the number of figures after the decimal point is reduced by 1.
!#    Example: the number 1.234*10^102, normally output as "1.234+102"
!#    with format "ES9.3" and as "*********" with "ES9.2E2", will be printed
!#    as "1.23E+102".
!#
!# Note that some cases cannot occur for usual single precision reals.

    use mod_types
    implicit none
    character(len=std_string) :: SPR_E_format !# Ideally, `len` would be \
!# assigned to `w_fmt`, but this is not possible for an elemental function,
!# so assign `len` to some value >= `|w_fmt|` and print the formatted values
!# with "write(.,"(a|w_fmt|)") SPR_E_format(array, d_fmt, w_fmt)"
!# in the calling routine.
    real(kind=SPR), intent(in) :: number
    integer, intent(in) :: d_fmt, w_fmt
!#......................................................................
    real(kind=DPR) :: abs_number, decapower
    character(len=std_string) :: fmt
    integer :: n_leading_zeros
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    abs_number = abs(number)

    if (abs_number >= 1.e-99_DPR .and. abs_number < 1.e100_DPR) then
       write(fmt,"(a,i0,a,i0,a)") "(ES", w_fmt, ".", d_fmt, "E2)"
       write(SPR_E_format, fmt) number
    else if (abs_number >= 1.e100_DPR) then !# >= 10.E99
       if (d_fmt > 0) then
          write(fmt,"(a,i0,a,i0,a)") "(ES", w_fmt, ".", d_fmt-1, "E3)"
          write(SPR_E_format, fmt) number
       else
          write(fmt,"(a,i0,a,i0,a)") "(ES", w_fmt, ".", d_fmt, "E2)"
          write(SPR_E_format, fmt) number !# Will be filled with "*". \
!# The "NAK" trick used in other procedures to stop with some explanations
!# cannot be used here because this function is elemental, and therefore pure:
!# it can contain neither a "write" statement to an external file (including the
!# standard output) nor a "stop" statement.
       endif
    else !# < 1.E-99
       decapower = 1.e-99_DPR/10**d_fmt
       if (abs_number < decapower) then
          write(fmt,"(a,i0,a,i0,a)") "(ES", w_fmt, ".", d_fmt, "E2)"
          write(SPR_E_format, fmt) 0._SPR
       else
          decapower = 1.e-99_DPR
          do n_leading_zeros = 1, d_fmt
             decapower = decapower/10
             if (abs_number >= decapower) then
                write(fmt,"(a,i0,a,i0,a,i0,a)") "(", 1-n_leading_zeros, &
                     "P E", w_fmt, ".", d_fmt, "E2)"
                write(SPR_E_format, fmt) number
                exit
             endif
          enddo
       endif
    endif

  end function SPR_E_format

!#======================================================================

  elemental function DPR_E_format(number, w_fmt, d_fmt)

!# DPR version of `SPR_E_format`. See comments therein.

    use mod_types
    implicit none
    character(len=std_string) :: DPR_E_format
    real(kind=DPR), intent(in) :: number
    integer, intent(in) :: d_fmt, w_fmt
!#......................................................................
    real(kind=DPR) :: abs_number, decapower
    character(len=std_string) :: fmt
    integer :: n_leading_zeros
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    abs_number = abs(number)

    if (abs_number >= 1.e-99_DPR .and. abs_number < 1.e100_DPR) then
       write(fmt,"(a,i0,a,i0,a)") "(ES", w_fmt, ".", d_fmt, "E2)"
       write(DPR_E_format, fmt) number
    else if (abs_number >= 1.e100_DPR) then !# >= 10.E99
       if (d_fmt > 0) then
          write(fmt,"(a,i0,a,i0,a)") "(ES", w_fmt, ".", d_fmt-1, "E3)"
          write(DPR_E_format, fmt) number
       else
          write(fmt,"(a,i0,a,i0,a)") "(ES", w_fmt, ".", d_fmt, "E2)"
          write(DPR_E_format, fmt) number !# Will be filled with "*".
       endif
    else !# < 1.E-99
       decapower = 1.e-99_DPR/10**d_fmt
       if (abs_number < decapower) then
          write(fmt,"(a,i0,a,i0,a)") "(ES", w_fmt, ".", d_fmt, "E2)"
          write(DPR_E_format, fmt) 0._DPR
       else
          decapower = 1.e-99_DPR
          do n_leading_zeros = 1, d_fmt
             decapower = decapower/10
             if (abs_number >= decapower) then
                write(fmt,"(a,i0,a,i0,a,i0,a)") "(", 1-n_leading_zeros, &
                     "P E", w_fmt, ".", d_fmt, "E2)"
                write(DPR_E_format, fmt) number
                exit
             endif
          enddo
       endif
    endif

  end function DPR_E_format

end module mod_convert_type

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_types

  implicit none
  public

  integer, parameter :: std_int = kind(0)
  integer, parameter :: long_int = selected_int_kind(9)
  integer, parameter :: std_string = 72
  integer, parameter :: long_string = 132
  integer, parameter :: SPR = selected_real_kind(6, 37) !# Usual "single \
!# precision" real.
  integer, parameter :: DPR = selected_real_kind(15, 307) !# Usual "double \
!# precision" real.
  integer, parameter :: CDR = DPR !# Code's default real. Set to `DPR` for \
!# accuracy, but may be switched to `SPR` if memory is missing.

  type :: irreg_array_int
     integer :: dim = 0
     integer, dimension(:), pointer :: val => null()
  end type irreg_array_int

  type :: irreg_array_CDR
     integer :: dim = 0
     real(CDR), dimension(:), pointer :: val => null()
  end type irreg_array_CDR

  type :: irreg_array_DPR
     integer :: dim = 0
     real(DPR), dimension(:), pointer :: val => null()
  end type irreg_array_DPR

end module mod_types

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_scenario

  use mod_types
  use mod_analyze_statement, only : get_val, file_name, line_number, unit_log
  use mod_read_reserv_infall_param
  use mod_read_SF_param
  use mod_read_outflow_param
  use mod_read_dust_evol_param
  use mod_read_dust_transfer_param
  use mod_read_cloud_neb_param
  use mod_read_cosmo_param
  use mod_read_output_param
  use mod_read_other_param
  use mod_random, only : initialize_seed

  implicit none
  public

contains

!#======================================================================

  subroutine init_proc

    implicit none
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call reset_all

  end subroutine init_proc

!#======================================================================

  subroutine reset_all

    implicit none
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call reset_reserv_infall
    call reset_SF
    call reset_outflow
    call reset_dust_evol
    call reset_dust_transfer
    call reset_cloud_neb
    call reset_cosmo
    call reset_output
    call reset_others

  end subroutine reset_all

!#======================================================================

  subroutine end_proc(run)

    use mod_strings, only : same_case_equal

    implicit none
    logical, intent(out) :: run
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call infall_check
    call SF_check
    call outflow_check
    call dust_evol_check
    call dust_transfer_check
    call cloud_neb_check
    call read_other_param_check

    if (new_statement .and. .not.check_only) then
       run = .true.
    else !# No new statement since the last `return`, so nothing to run.
       run = .false.
    endif

  end subroutine end_proc

!#======================================================================

  subroutine read_spectra_input_param(key, rhs, indices_string, &
       unknown_statement, statement_type)

    use mod_strings, only : same_case_equal

    implicit none
    character(len=*), intent(in) :: key
    character(len=*), intent(in) :: rhs
    character(len=*), intent(in) :: statement_type
    character(len=*), intent(inout) :: indices_string
    logical, intent(out) :: unknown_statement
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    new_statement = .true.
    unknown_statement = .false.

    if (same_case_equal(key, "echo")) then
       call read_echo

!#----------------------------------------------------------------------
    else if (same_case_equal(key, "reset_reserv_infall")) then
       call reset_reserv_infall

    else if (same_case_equal(key, "reserv_init_mass")) then
       call read_reserv_init_mass(rhs, indices_string)

    else if (same_case_equal(key, "reserv_Z")) then
       call read_reserv_Z(rhs, indices_string)
!#----------------------------------------------------------------------
    else if (same_case_equal(key, "infall_source")) then
       call read_infall_source(rhs, indices_string)

    else if (same_case_equal(key, "infall_begin_time")) then
       call read_infall_begin_time(rhs, indices_string)

    else if (same_case_equal(key, "infall_end_time")) then
       call read_infall_end_time(rhs, indices_string)

    else if (same_case_equal(key, "infall_type")) then
       call read_infall_type(rhs, indices_string)

    else if (same_case_equal(key, "infall_file")) then
       call read_infall_file(rhs, indices_string)

    else if (same_case_equal(key, "infall_inst_mass")) then
       call read_infall_inst_mass(rhs, indices_string)

    else if (same_case_equal(key, "infall_const_mass")) then
       call read_infall_const_mass(rhs, indices_string)

    else if (same_case_equal(key, "infall_expo_timescale")) then
       call read_infall_expo_timescale(rhs, indices_string)

    else if (same_case_equal(key, "infall_expo_mass")) then
       call read_infall_expo_mass(rhs, indices_string)

    else if (same_case_equal(key, "infall_reserv_timescale")) then
       call read_infall_reserv_timescale(rhs, indices_string)

    else if (same_case_equal(key, "infall_reserv_power")) then
       call read_infall_reserv_power(rhs, indices_string)
!#----------------------------------------------------------------------
    else if (same_case_equal(key, "reset_SF")) then
       call reset_SF

    else if (same_case_equal(key, "SF_begin_time")) then
       call read_SF_begin_time(rhs, indices_string)

    else if (same_case_equal(key, "SF_end_time")) then
       call read_SF_end_time(rhs, indices_string)

    else if (same_case_equal(key, "SF_type")) then
       call read_SF_type(rhs, indices_string)

    else if (same_case_equal(key, "SF_inst_mass")) then
       call read_SF_inst_mass(rhs, indices_string)

    else if (same_case_equal(key, "SF_const_mass")) then
       call read_SF_const_mass(rhs, indices_string)

    else if (same_case_equal(key, "SF_expo_timescale")) then
       call read_SF_expo_timescale(rhs, indices_string)

    else if (same_case_equal(key, "SF_expo_mass")) then
       call read_SF_expo_mass(rhs, indices_string)

    else if (same_case_equal(key, "SF_peaked_timescale")) then
       call read_SF_peaked_timescale(rhs, indices_string)

    else if (same_case_equal(key, "SF_peaked_mass")) then
       call read_SF_peaked_mass(rhs, indices_string)

    else if (same_case_equal(key, "SF_ISM_timescale")) then
       call read_SF_ISM_timescale(rhs, indices_string)

    else if (same_case_equal(key, "SF_ISM_power")) then
       call read_SF_ISM_power(rhs, indices_string)

    else if (same_case_equal(key, "SF_ISM_threshold")) then
       call read_SF_ISM_threshold(rhs, indices_string)

    else if (same_case_equal(key, "SF_infall_factor")) then
       call read_SF_infall_factor(rhs, indices_string)

    else if (same_case_equal(key, "SF_file")) then
       call read_SF_file(rhs, indices_string)

    else if (same_case_equal(key, "SF_stochastic")) then
       call read_SF_stochastic(rhs, indices_string)

    else if (same_case_equal(key, "SF_stoch_fluc")) then
       call read_SF_stoch_fluc(rhs, indices_string)

    else if (same_case_equal(key, "SF_stoch_timescale")) then
       call read_SF_stoch_timescale(rhs, indices_string)

    else if (same_case_equal(key, "SF_Z_type")) then
       call read_SF_Z_type(rhs, indices_string)

    else if (same_case_equal(key, "SF_Z_const_val")) then
       call read_SF_Z_const_val(rhs, indices_string)

    else if (same_case_equal(key, "SF_Z_file")) then
       call read_SF_Z_file(rhs, indices_string)

    else if (same_case_equal(key, "SF_inert_frac")) then
       call read_SF_inert_frac(rhs, indices_string)
!#----------------------------------------------------------------------
    else if (same_case_equal(key, "reset_outflow")) then
       call reset_outflow

    else if (same_case_equal(key, "outflow_begin_time")) then
       call read_outflow_begin_time(rhs, indices_string)

    else if (same_case_equal(key, "outflow_end_time")) then
       call read_outflow_end_time(rhs, indices_string)

    else if (same_case_equal(key, "outflow_type")) then
       call read_outflow_type(rhs, indices_string)

    else if (same_case_equal(key, "outflow_inst_mass")) then
       call read_outflow_inst_mass(rhs, indices_string)

    else if (same_case_equal(key, "outflow_const_mass")) then
       call read_outflow_const_mass(rhs, indices_string)

    else if (same_case_equal(key, "outflow_SF_factor")) then
       call read_outflow_SF_factor(rhs, indices_string)

    else if (same_case_equal(key, "outflow_SN_mass")) then
       call read_outflow_SN_mass(rhs, indices_string)

    else if (same_case_equal(key, "outflow_SN_power")) then
       call read_outflow_SN_power(rhs, indices_string)

    else if (same_case_equal(key, "outflow_CCSN_mass")) then
       call read_outflow_CCSN_mass(rhs, indices_string)

    else if (same_case_equal(key, "outflow_CCSN_power")) then
       call read_outflow_CCSN_power(rhs, indices_string)

    else if (same_case_equal(key, "outflow_SNIa_mass")) then
       call read_outflow_SNIa_mass(rhs, indices_string)

    else if (same_case_equal(key, "outflow_SNIa_power")) then
       call read_outflow_SNIa_power(rhs, indices_string)

    else if (same_case_equal(key, "outflow_ejec_threshold")) then
       call read_outflow_ejec_threshold(rhs, indices_string)

    else if (same_case_equal(key, "outflow_ejec_factor")) then
       call read_outflow_ejec_factor(rhs, indices_string)

    else if (same_case_equal(key, "outflow_file")) then
       call read_outflow_file(rhs, indices_string)
!#----------------------------------------------------------------------
    else if (same_case_equal(key, "reset_dust_evol")) then
       call reset_dust_evol

    else if (same_case_equal(key, "dust_evolution")) then
       call read_dust_evolution(rhs)

    else if (same_case_equal(key, "O_sil_ratio")) then
       call read_O_sil_ratio(rhs)

    else if (same_case_equal(key, "ISM_carb_deplet")) then
       call read_ISM_carb_deplet(rhs)

    else if (same_case_equal(key, "ISM_sil_deplet")) then
       call read_ISM_sil_deplet(rhs)

    else if (same_case_equal(key, "CCSN_carb_deplet")) then
       call read_CCSN_carb_deplet(rhs)

    else if (same_case_equal(key, "SNIa_carb_deplet")) then
       call read_SNIa_carb_deplet(rhs)

    else if (same_case_equal(key, "HMW_carb_deplet")) then
       call read_HMW_carb_deplet(rhs)

    else if (same_case_equal(key, "LMW_carb_deplet")) then
       call read_LMW_carb_deplet(rhs)

    else if (same_case_equal(key, "CCSN_sil_deplet")) then
       call read_CCSN_sil_deplet(rhs)

    else if (same_case_equal(key, "SNIa_sil_deplet")) then
       call read_SNIa_sil_deplet(rhs)

    else if (same_case_equal(key, "HMW_sil_deplet")) then
       call read_HMW_sil_deplet(rhs)

    else if (same_case_equal(key, "LMW_sil_deplet")) then
       call read_LMW_sil_deplet(rhs)

    else if (same_case_equal(key, "SN_swept_mass")) then
       call read_SN_swept_mass(rhs)

    else if (same_case_equal(key, "carb_accr_timescale")) then
       call read_carb_accr_timescale(rhs)

    else if (same_case_equal(key, "sil_accr_timescale")) then
       call read_sil_accr_timescale(rhs)

!#----------------------------------------------------------------------
    else if (same_case_equal(key, "reset_dust_transfer")) then
       call reset_dust_transfer

    else if (same_case_equal(key, "extinction")) then
       call read_extinction(rhs)

    else if (same_case_equal(key, "extinction_SFC")) then
       call read_extinction_SFC(rhs)

    else if (same_case_equal(key, "extinction_DISM")) then
       call read_extinction_DISM(rhs)

    else if (same_case_equal(key, "grains_file")) then
       call read_grains_file(rhs)

    else if (same_case_equal(key, "grains_file_SFC")) then
       call read_grains_file_SFC(rhs)

    else if (same_case_equal(key, "grains_file_DISM")) then
       call read_grains_file_DISM(rhs)

    else if (same_case_equal(key, "carb_sublim_temp")) then
       call read_carb_sublim_temp(rhs)

    else if (same_case_equal(key, "carb_sublim_temp_SFC")) then
       call read_carb_sublim_temp_SFC(rhs)

    else if (same_case_equal(key, "carb_sublim_temp_DISM")) then
       call read_carb_sublim_temp_DISM(rhs)

    else if (same_case_equal(key, "sil_sublim_temp")) then
       call read_sil_sublim_temp(rhs)

    else if (same_case_equal(key, "sil_sublim_temp_SFC")) then
       call read_sil_sublim_temp_SFC(rhs)

    else if (same_case_equal(key, "sil_sublim_temp_DISM")) then
       call read_sil_sublim_temp_DISM(rhs)

    else if (same_case_equal(key, "bulge_tot_ratio")) then
       call read_bulge_tot_ratio(rhs)

    else if (same_case_equal(key, "M_sys_spiral")) then
       call read_M_sys_spiral(rhs)

    else if (same_case_equal(key, "expo_radius")) then
       call read_expo_radius(rhs)

    else if (same_case_equal(key, "M_sys_spher")) then
       call read_M_sys_spher(rhs)

    else if (same_case_equal(key, "core_radius")) then
       call read_core_radius(rhs)

    else if (same_case_equal(key, "geometry")) then
       call read_geometry(rhs)

    else if (same_case_equal(key, "inclin_averaged")) then
       call read_inclin_averaged(rhs)

    else if (same_case_equal(key, "inclination")) then
       call read_inclination(rhs)

    else if (same_case_equal(key, "slab_factor")) then
       call read_slab_factor(rhs)

    else if (same_case_equal(key, "dust_emission")) then
       call read_dust_emission(rhs)

    else if (same_case_equal(key, "dust_emission_SFC")) then
       call read_dust_emission_SFC(rhs)

    else if (same_case_equal(key, "dust_emission_DISM")) then
       call read_dust_emission_DISM(rhs)

    else if (same_case_equal(key, "self_abs_power")) then
       call read_self_abs_power(rhs)

    else if (same_case_equal(key, "self_abs_power_SFC")) then
       call read_self_abs_power_SFC(rhs)

    else if (same_case_equal(key, "self_abs_power_DISM")) then
       call read_self_abs_power_DISM(rhs)

    else if (same_case_equal(key, "stoch_heating")) then
       call read_stoch_heating(rhs)

    else if (same_case_equal(key, "stoch_heating_SFC")) then
       call read_stoch_heating_SFC(rhs)

    else if (same_case_equal(key, "stoch_heating_DISM")) then
       call read_stoch_heating_DISM(rhs)

!#----------------------------------------------------------------------
    else if (same_case_equal(key, "reset_others")) then
       call  reset_others

    else if (same_case_equal(key, "SSPs_set")) then
       call read_SSPs_set_name(rhs)

    else if (same_case_equal(key, "ISM_init_Z")) then
       call read_ISM_init_Z(rhs)

    else if (same_case_equal(key, "close_bin_frac")) then
       call read_close_bin_frac(rhs)

    else if (same_case_equal(key, "spectra_output")) then
       call read_spectra_output(rhs)

    else if (same_case_equal(key, "RF_output")) then
       call read_RF_output(rhs)

    else if (same_case_equal(key, "sublim_output")) then
       call read_sublim_output(rhs)

    else if (same_case_equal(key, "grain_temp_output")) then
       call read_grain_temp_output(rhs)

    else if (same_case_equal(key, "grain_temp_file")) then
       call read_grain_temp_file(rhs)

    else if (same_case_equal(key, "grain_SED_output")) then
       call read_grain_SED_output(rhs)

    else if (same_case_equal(key, "grain_SED_file")) then
       call read_grain_SED_file(rhs)

    else if (same_case_equal(key, "grain_output_min_age")) then
       call read_grain_output_min_age(rhs)

    else if (same_case_equal(key, "grain_output_max_age")) then
       call read_grain_output_max_age(rhs)

    else if (same_case_equal(key, "grain_output_SFC")) then
       call read_grain_output_SFC(rhs)

    else if (same_case_equal(key, "grain_output_DISM")) then
       call read_grain_output_DISM(rhs)

    else if (same_case_equal(key, "grain_output_min_size")) then
       call read_grain_output_min_size(rhs)

    else if (same_case_equal(key, "grain_output_max_size")) then
       call read_grain_output_max_size(rhs)

    else if (same_case_equal(key, "ages_file")) then
       call read_ages_file(rhs)

    else if (same_case_equal(key, "spectra_file")) then
       call read_spectra_file(rhs)

    else if (same_case_equal(key, "prefix")) then
       call read_prefix(rhs)

    else if (same_case_equal(key, "stamp_time")) then
       call read_stamp_time(rhs)

    else if (same_case_equal(key, "overwrite")) then
       call read_overwrite(rhs)

    else if (same_case_equal(key, "check_only")) then
       call read_check_only(rhs)

    else if (same_case_equal(key, "erase_text")) then
       call erase_text

    else if (same_case_equal(key, "add_text")) then
       call read_add_text(rhs, statement_type)

    else if (same_case_equal(key, "verbosity")) then
       call read_verbosity(rhs)

    else if (same_case_equal(key, "seed")) then
       call read_seed(rhs, indices_string)

    else if (same_case_equal(key, "initialize_seed")) then
       call initialize_seed
!#----------------------------------------------------------------------
    else if (same_case_equal(key, "reset_cloud_neb")) then
       call  reset_cloud_neb

    else if (same_case_equal(key, "nebular_emission")) then
       call read_nebular_emission(rhs)

    else if (same_case_equal(key, "nebular_emission_SFC")) then
       call read_nebular_emission_SFC(rhs)

    else if (same_case_equal(key, "nebular_emission_DISM")) then
       call read_nebular_emission_DISM(rhs)

    else if (same_case_equal(key, "neb_emis_type")) then
       call read_neb_emis_type(rhs)

    else if (same_case_equal(key, "neb_emis_type_SFC")) then
       call read_neb_emis_type_SFC(rhs)

    else if (same_case_equal(key, "neb_emis_type_DISM")) then
       call read_neb_emis_type_DISM(rhs)

    else if (same_case_equal(key, "neb_emis_const_frac")) then
       call read_neb_emis_const_frac(rhs)

    else if (same_case_equal(key, "neb_emis_const_frac_SFC")) then
       call read_neb_emis_const_frac_SFC(rhs)

    else if (same_case_equal(key, "neb_emis_const_frac_DISM")) then
       call read_neb_emis_const_frac_DISM(rhs)

    else if (same_case_equal(key, "l10_mean_U_DISM")) then
       call read_l10_mean_U_DISM(rhs)

    else if (same_case_equal(key, "cluster_stel_mass")) then
       call read_cluster_stel_mass(rhs)

    else if (same_case_equal(key, "cloud_init_frac")) then
       call read_cloud_init_frac(rhs)

    else if (same_case_equal(key, "cloud_power")) then
       call read_cloud_power(rhs)

    else if (same_case_equal(key, "cloud_duration")) then
       call read_cloud_duration(rhs)
!#----------------------------------------------------------------------
    else if (same_case_equal(key, "reset_cosmo")) then
       call  reset_cosmo

    else if (same_case_equal(key, "Omega_m")) then
       call  read_Omega_m(rhs)

    else if (same_case_equal(key, "H_0")) then
       call  read_H_0(rhs)

    else if (same_case_equal(key, "form_redshift")) then
       call  read_form_redshift(rhs)

    else if (same_case_equal(key, "CBR")) then
       call  read_CBR(rhs)

!#----------------------------------------------------------------------
    else
       unknown_statement = .true.
    end if

  end subroutine read_spectra_input_param

!#======================================================================

  subroutine read_check_only(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(check_only, rhs)

  end subroutine read_check_only

!#======================================================================

  subroutine read_echo

    use mod_write_scenario_param, only : write_scenario_param
    implicit none
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    write(*, "(a)") repeat("=",80)
    write(*, "(a, i0, a)") "File """ // trim(file_name) // """, line ", &
         line_number, ":"
    write(unit_log, "(/a, i0, a)") "File """ // trim(file_name) // """, line ", &
         line_number, ":"
    call write_scenario_param(unit = -1, &
         line_prefix = "")
    call write_scenario_param(unit = unit_log, &
         line_prefix = "")
    write(*, "(a)") repeat("=",80)

  end subroutine read_echo

end module mod_scenario

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_interp

  use mod_types

  implicit none
  private

  interface bracket
     module procedure bracket_SPR, bracket_DPR
  end interface bracket

  interface Steffen
     module procedure Steffen_SPR, Steffen_DPR
  end interface Steffen

  interface Steffen3
     module procedure Steffen3_SPR, Steffen3_DPR
  end interface Steffen3

  interface Steffen4
     module procedure Steffen4_SPR, Steffen4_DPR
  end interface Steffen4

  interface interp_lin_lin
     module procedure interp_lin_lin_SPR, interp_lin_lin_DPR
  end interface interp_lin_lin

  interface interp_lin_log
     module procedure interp_lin_log_SPR, interp_lin_log_DPR
  end interface interp_lin_log

  interface interp_log_lin
     module procedure interp_log_lin_SPR, interp_log_lin_DPR
  end interface interp_log_lin

  interface interp_log_log
     module procedure interp_log_log_SPR, interp_log_log_DPR
  end interface interp_log_log

  interface compute_weights
     module procedure compute_weights_SPR, compute_weights_DPR
  end interface compute_weights

  public :: bracket, Steffen, Steffen3, Steffen4, interp_lin_lin, &
       interp_lin_log, interp_log_lin, interp_log_log, &
       compute_weights

contains

!#======================================================================

  subroutine bracket_SPR(n, x, t, i, extrap)

!# ??? Add case where `x` is in reverse order.
!# ??? Add check that `x` is monotonous.

!# Given an array `x(1) <= ... <= x(n)`, `bracket` finds the integer `i`
!# such that `x(i) <= t <= x(i+1)`.
!# If `t <= x(1)`, `i = 1`; if `t >= x(n)`, `i = n-1`.
!# If `i = 0` in input, `bracket` finds `i` by dichotomy between 1 and
!# `n`; otherwise, the input `i` is used as an initial guess.

    implicit none
    integer, intent(in) :: n
    real(SPR), dimension(:), intent(in) :: x
    real(kind(x)), intent(in) :: t
    integer, intent(inout) :: i
    character(len=max(len("down"), len("up"), len("none"))), intent(out), optional :: extrap
!#......................................................................
    integer :: i_inf, i_sup, i_med, d_i
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (t < x(1)) then !# Downward extrapolation.
       i_inf = 1
       if (present(extrap)) extrap = "down"
    else if (t > x(n)) then !# Upward extrapolation.
       if (present(extrap)) extrap = "up"
       i_inf = n-1
    else !# Interpolation.
       if (present(extrap)) extrap = "none"
       i_inf = 1
       i_sup = n
       if (i >= 1 .and. i <= n) then !# Valid initial guess provided; \
!#                                      search first in the vicinity of `x(i)`.
          d_i = 1
          if (t >= x(i)) then
             i_inf = i
             i_sup = min(n, i+d_i)
             do while(t > x(i_sup))
                i_inf = i_sup
                d_i = 2*d_i
                i_sup = min(n, i+d_i)
             enddo
          else
             i_sup = i
             i_inf = max(1, i-d_i)
             do while(t < x(i_inf))
                i_sup = i_inf
                d_i = 2*d_i
                i_inf = max(1, i-d_i)
             enddo
          endif
       endif
!# Search by dichotomy:
       do while (i_inf+1 < i_sup)
          i_med = (i_inf+i_sup)/2
          if (t <= x(i_med)) then
             i_sup = i_med
          else
             i_inf = i_med
          end if
       end do
    endif

    i = i_inf

  end subroutine bracket_SPR

!#======================================================================

  subroutine Steffen_SPR(n, x, y, t, z, i, null_deriv_at_0)

!# Steffen M. (1990), A&A 239, 443.
!# Interpolation (or extrapolation) routine. Advantages are
!# that the interpolation is smooth, local (contrary to splines),
!# fast, without oscillations and that extrema happen only at the
!# tabulated values (or outside the interval if is an extrapolation).
!# Given:
!# 1. a function `y(x)`, tabulated for `n` values such as
!#    `x(1) <= ... <= x(n)`; and
!# 2. an integer `i` found by subroutine `bracket`, such as
!#    x(i) <= t <= x(i+1)` (`i = 1` if `t <= x(1)`; `i = n`
!#    if `t >= x(n)`),
!# `Steffen` finds `z = y(t)`.
!# Optional variable `null_deriv_at_0` is usually false. It is true only when
!# one wants to force `dy/dx` to 0 at `x = 0`.


    implicit none
    integer, intent(in) :: n, i
    real(SPR), dimension(:), intent(in) :: x, y
    real(SPR), intent(in) :: t
    real(SPR), intent(out) :: z
    logical, intent(in), optional :: null_deriv_at_0
!#......................................................................
    real(SPR) :: a, b, c, d
    real(SPR) :: h_i, h_im1, h_ip1
    real(SPR) :: s_i, s_im1, s_ip1
    real(SPR) :: p_i, p_ip1, y1_i, y1_ip1
    real(SPR) :: tmx_i
    logical :: null_deriv_at_0_eff
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(null_deriv_at_0)) then
       null_deriv_at_0_eff = null_deriv_at_0
    else
       null_deriv_at_0_eff = .false.
    endif

    if (i == 1) then
       h_i = x(i+1)-x(i)
       s_i = (y(i+1)-y(i))/h_i
       h_ip1 = x(i+2)-x(i+1)
       s_ip1 = (y(i+2)-y(i+1))/h_ip1
       p_ip1 = (s_i*h_ip1+s_ip1*h_i)/(h_i+h_ip1)
       y1_ip1 = (sign(1._SPR, s_i)+sign(1._SPR, s_ip1))*min(abs(s_i), abs(s_ip1), &
            0.5_SPR*abs(p_ip1))
       if (null_deriv_at_0_eff) then !# 1st derivative forced to 0 at `x` = 0.
          y1_i = (6._SPR*s_i*x(1)*(x(1)+h_i)-y1_ip1*x(1)*(3._SPR*x(1)+2._SPR*h_i))/ &
               (3._SPR*x(1)**2+4._SPR*x(1)*h_i+h_i**2)
       else
          y1_i = 1.5_SPR*s_i-0.5_SPR*y1_ip1
       end if
    else
       if (i == n-1) then
          h_i = x(i+1)-x(i)
          s_i = (y(i+1)-y(i))/h_i
          h_im1 = x(i)-x(i-1)
          s_im1 = (y(i)-y(i-1))/h_im1
          p_i = (s_im1*h_i+s_i*h_im1)/(h_im1+h_i)
          y1_i = (sign(1._SPR, s_im1)+sign(1._SPR, s_i))*min(abs(s_im1), abs(s_i), &
               0.5_SPR*abs(p_i))
          y1_ip1 = 1.5_SPR*s_i-0.5_SPR*y1_i
       else
          h_i = x(i+1)-x(i)
          s_i = (y(i+1)-y(i))/h_i
          h_im1 = x(i)-x(i-1)
          s_im1 = (y(i)-y(i-1))/h_im1
          h_ip1 = x(i+2)-x(i+1)
          s_ip1 = (y(i+2)-y(i+1))/h_ip1
          p_i = (s_im1*h_i+s_i*h_im1)/(h_im1+h_i)
          p_ip1 = (s_i*h_ip1+s_ip1*h_i)/(h_i+h_ip1)
          y1_i = (sign(1._SPR, s_im1)+sign(1._SPR, s_i))*min(abs(s_im1), abs(s_i), &
               0.5_SPR*abs(p_i))
          y1_ip1 = (sign(1._SPR, s_i)+sign(1._SPR, s_ip1))*min(abs(s_i), abs(s_ip1), &
               0.5_SPR*abs(p_ip1))
       end if
    end if
    if (t > x(n)) then
       z = y(n)+y1_ip1*(t-x(n))
    else
       tmx_i = t-x(i)
       a = (y1_i+y1_ip1-2._SPR*s_i)/h_i**2
       b = (3._SPR*s_i-2._SPR*y1_i-y1_ip1)/h_i
       c = y1_i
       d = y(i)
       z = ((a*tmx_i+b)*tmx_i+c)*tmx_i+d
    endif

  end subroutine Steffen_SPR

!#======================================================================

  subroutine Steffen3_SPR(x1, x2, x3, y, n1, n2, n3, t1, t2, t3, z, i01, i02, &
       i03)

!# 3-dimensional version of subroutine `Steffen`.
!# Given `y(x1, x2, x3)`, where `x1(1) <= ... <= x1(n1)` (the same for `x2`
!# and `x3`), `Steffen3` computes `z(t1, t2, t3)`.
!# `i01`, etc., are the starting indices used by `bracket`.

    implicit none
    integer, intent(in) :: n1, n2, n3
    real(SPR), dimension(:), intent(in) :: x1
    real(SPR), dimension(:), intent(in) :: x2
    real(SPR), dimension(:), intent(in) :: x3
    real(SPR), dimension(:, :, :), intent(in) :: y
    real(SPR), intent(in) :: t1, t2, t3
    integer, intent(inout) :: i01, i02, i03
    real(SPR), intent(out) :: z
!#......................................................................
    integer :: i1, i2, i3
    real(SPR), dimension(n1) :: y1
    real(SPR), dimension(n2) :: y2
    real(SPR), dimension(n3) :: y3
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call bracket(n1, x1, t1, i01)
    call bracket(n2, x2, t2, i02)
    call bracket(n3, x3, t3, i03)
!# N.B.: In the following loops, one could cycle from 1 to `n1`
!# (`n2`, `n3`), but since `Steffen` is a local interpolation routine,
!# there is no need to compute all the values of `y1`, `y2`, `y3`.
    do i1 = max(1, i01-1), min(n1, i01+2)
       do i2 = max(1, i02-1), min(n2, i02+2)
          do i3 = max(1, i03-1), min(n3, i03+2)
             y3(i3) = y(i1, i2, i3)
          end do
          call Steffen(n3, x3, y3, t3, y2(i2), i03)
       end do
       call Steffen(n2, x2, y2, t2, y1(i1), i02)
    end do
    call Steffen(n1, x1, y1, t1, z, i01)

  end subroutine Steffen3_SPR

!#======================================================================

  subroutine Steffen4_SPR(x1, x2, x3, x4, y, n1, n2, n3, n4, t1, t2, t3, t4, z, &
       i01, i02, i03, i04, null_deriv_at_0)

!# 4-dimensional version of subroutine `Steffen`.
!# See `Steffen3` for the details.

    implicit none
    integer, intent(in) :: n1, n2, n3, n4
    real(SPR), dimension(:), intent(in) :: x1
    real(SPR), dimension(:), intent(in) :: x2
    real(SPR), dimension(:), intent(in) :: x3
    real(SPR), dimension(:), intent(in) :: x4
    real(SPR), dimension(:, :, :, :), intent(in) :: y
    real(SPR), intent(in) :: t1, t2, t3, t4
    integer, intent(inout) :: i01, i02, i03, i04
    real(SPR), intent(out) :: z
    logical, intent(in), optional :: null_deriv_at_0 !# For the interpolation on `x4` only.
!#......................................................................
    integer :: i1, i2, i3, i4
    real(SPR), dimension(n1) :: y1
    real(SPR), dimension(n2) :: y2
    real(SPR), dimension(n3) :: y3
    real(SPR), dimension(n4) :: y4
    logical :: null_deriv_at_0_eff
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(null_deriv_at_0)) then
       null_deriv_at_0_eff = null_deriv_at_0
    else
       null_deriv_at_0_eff = .false.
    endif

    call bracket(n1, x1, t1, i01)
    call bracket(n2, x2, t2, i02)
    call bracket(n3, x3, t3, i03)
    call bracket(n4, x4, t4, i04)
    do i1 = max(1, i01-1), min(n1, i01+2)
       do i2 = max(1, i02-1), min(n2, i02+2)
          do i3 = max(1, i03-1), min(n3, i03+2)
             do i4 = max(1, i04-1), min(n4, i04+2)
                y4(i4) = y(i1, i2, i3, i4)
             end do
             call Steffen(n4, x4, y4, t4, y3(i3), i04, null_deriv_at_0=null_deriv_at_0_eff)
          end do
          call Steffen(n3, x3, y3, t3, y2(i2), i03)
       end do
       call Steffen(n2, x2, y2, t2, y1(i1), i02)
    end do
    call Steffen(n1, x1, y1, t1, z, i01)

  end subroutine Steffen4_SPR

!#======================================================================

  function interp_lin_lin_SPR(x1, x2, y1, y2, x) result(interp)

    implicit none
    real(SPR), intent(in) :: x1, x2, y1, y2, x
    real(SPR) :: interp
!#......................................................................
    real(kind(x)) :: alpha
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (x1 /= x2) then
       alpha = (x2 - x)/(x2 - x1)
       interp = alpha*y1 + (1-alpha)*y2
    else
       interp = (y1+y2)/2
    endif

  end function interp_lin_lin_SPR

!#======================================================================

  recursive function interp_lin_log_SPR(x1, x2, y1, y2, x) result(interp)

!# Linear interpolation in `log(y)`.

    implicit none
    real(SPR), intent(in) :: x1, x2, y1, y2, x
    real(SPR) :: interp
!#......................................................................
    real(kind(x)) :: alpha
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (y1 <= 0 .or. y2 <= 0) then
       if (y1 < 0 .and. y2 < 0) then
          interp = -interp_lin_log_SPR(x1, x2, -y1, -y2, x)
       else !# `y1` = 0 or `y2` = 0 or {sgn(`y1`) /= sgn(`y2`) and `y1` /= 0 and `y2` /= 0}.
          if (y1 == 0) then
             if ((x1 <= x2 .and. x <= x1) .or. (x1 >= x2 .and. x >= x1)) then !# Extrapolation.
                interp = 0
                return
             endif
          else if (y2 == 0) then
             if ((x1 <= x2 .and. x >= x2) .or. (x1 >= x2 .and. x <= x2)) then !# Extrapolation.
                interp = 0
                return
             endif
          endif
!# {{`y1` = 0 or `y2` = 0} and no extrapolation} or {sgn(`y1`) /= sgn(`y2`) and `y1` /= 0 and `y2` /= 0}.
          interp = interp_lin_lin_SPR(x1, x2, y1, y2, x)
       endif
       return
    endif

    if (x1 /= x2) then
       alpha = (x2 - x)/(x2 - x1)
       interp = exp(alpha*log(y1) + (1-alpha)*log(y2))
    else
       interp = sqrt(real(y1, DPR)*real(y2, DPR)) !# `real(., DPR)` \
!# to avoid over- and underflows.
    endif

  end function interp_lin_log_SPR

!#======================================================================

  recursive function interp_log_lin_SPR(x1, x2, y1, y2, x) result(interp)

    implicit none
    real(SPR), intent(in) :: x1, x2, y1, y2, x
    real(SPR) :: interp
!#......................................................................
    real(kind(x)) :: alpha, ln_x2
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (x1 <= 0 .or. x2 <= 0 .or. x <= 0) then
       if (x1 < 0 .and. x2 < 0 .and. x < 0) then
          interp = interp_log_lin_SPR(-x1, -x2, y1, y2, -x)
       else
          interp = interp_lin_lin_SPR(x1, x2, y1, y2, x)
       endif
       return
    endif

    if (x1 /= x2) then
       ln_x2 = log(x2)
       alpha = (ln_x2 - log(x))/(ln_x2 - log(x1))
       interp = alpha*y1 + (1-alpha)*y2
    else
       interp = (y1+y2)/2
    endif

  end function interp_log_lin_SPR

!#======================================================================

  recursive function interp_log_log_SPR(x1, x2, y1, y2, x) result(interp)

    implicit none
    real(SPR), intent(in) :: x1, x2, y1, y2, x
    real(SPR) :: interp
!#......................................................................
    real(kind(x)) :: alpha, ln_x2
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (y1 <= 0 .or. y2 <= 0) then
       if (y1 < 0 .and. y2 < 0) then
          interp = -interp_log_log_SPR(x1, x2, -y1, -y2, x)
       else !# `y1` = 0 or `y2` = 0 or {sgn(`y1`) /= sgn(`y2`) and `y1` /= 0 and `y2` /= 0}.
          if (y1 == 0) then
             if ((x1 <= x2 .and. x <= x1) .or. (x1 >= x2 .and. x >= x1)) then !# Extrapolation.
                interp = 0
                return
             endif
          else if (y2 == 0) then
             if ((x1 <= x2 .and. x >= x2) .or. (x1 >= x2 .and. x <= x2)) then !# Extrapolation.
                interp = 0
                return
             endif
          endif
!# {{`y1` = 0 or `y2` = 0} and no extrapolation} or {sgn(`y1`) /= sgn(`y2`) and `y1` /= 0 and `y2` /= 0}.
          interp = interp_log_lin_SPR(x1, x2, y1, y2, x)
       endif
       return
    endif

    if (x1 <= 0 .or. x2 <= 0 .or. x <= 0) then
       if (x1 < 0 .and. x2 < 0 .and. x < 0) then
          interp = interp_log_log_SPR(-x1, -x2, y1, y2, -x)
       else
          interp = interp_lin_log_SPR(x1, x2, y1, y2, x)
       endif
       return
    endif

    if (x1 /= x2) then
       ln_x2 = log(x2)
       alpha = (ln_x2 - log(x))/(ln_x2 - log(x1))
       interp = exp(alpha*log(y1) + (1-alpha)*log(y2))
    else
       interp = sqrt(real(y1, DPR)*real(y2, DPR)) !# `real(., DPR)` \
!# to avoid over- and underflows.
    endif

  end function interp_log_log_SPR

!#======================================================================

  subroutine bracket_DPR(n, x, t, i, extrap)

!# Given an array `x(1) <= ... <= x(n)`, `bracket` finds the integer `i`
!# such that `x(i) <= t <= x(i+1)`.
!# If `t <= x(1)`, `i = 1`; if `t >= x(n)`, `i = n-1`.
!# If `i = 0` in input, `bracket` finds `i` by dichotomy between 1 and
!# `n`; otherwise, the input `i` is used as an initial guess.

    implicit none
    integer, intent(in) :: n
    real(DPR), dimension(:), intent(in) :: x
    real(kind(x)), intent(in) :: t
    integer, intent(inout) :: i
    character(len=max(len("down"), len("up"), len("none"))), intent(out), optional :: extrap
!#......................................................................
    integer :: i_inf, i_sup, i_med, d_i
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (t < x(1)) then !# Downward extrapolation.
       i_inf = 1
       if (present(extrap)) extrap = "down"
    else if (t > x(n)) then !# Upward extrapolation.
       if (present(extrap)) extrap = "up"
       i_inf = n-1
    else !# Interpolation.
       if (present(extrap)) extrap = "none"
       i_inf = 1
       i_sup = n
       if (i >= 1 .and. i <= n) then !# Valid initial guess provided; \
!#                                      search first in the vicinity of `x(i)`.
          d_i = 1
          if (t >= x(i)) then
             i_inf = i
             i_sup = min(n, i+d_i)
             do while(t > x(i_sup))
                i_inf = i_sup
                d_i = 2*d_i
                i_sup = min(n, i+d_i)
             enddo
          else
             i_sup = i
             i_inf = max(1, i-d_i)
             do while(t < x(i_inf))
                i_sup = i_inf
                d_i = 2*d_i
                i_inf = max(1, i-d_i)
             enddo
          endif
       endif
!# Search by dichotomy:
       do while (i_inf+1 < i_sup)
          i_med = (i_inf+i_sup)/2
          if (t <= x(i_med)) then
             i_sup = i_med
          else
             i_inf = i_med
          end if
       end do
    endif

    i = i_inf

  end subroutine bracket_DPR

!#======================================================================

  subroutine Steffen_DPR(n, x, y, t, z, i, null_deriv_at_0)

!# Steffen M. (1990), A&A 443, 450.
!# Interpolation (or extrapolation) routine. Advantages are
!# that the interpolation is smooth, local (contrary to splines),
!# fast, without oscillations and that extrema happen only at the
!# tabulated values (or outside the interval if is an extrapolation).
!# Given:
!# 1. a function `y(x)`, tabulated for `n` values such as
!#    `x(1) <= ... <= x(n)`; and
!# 2. an integer `i` found by subroutine `bracket`, such as
!#    x(i) <= t <= x(i+1)` (`i = 1` if `t <= x(1)`; `i = n`
!#    if `t >= x(n)`),
!# `Steffen` finds `z = y(t)`.
!# Optional variable `null_deriv_at_0` is usually false. It is true only when
!# one wants to force `dy/dx` to 0 at `x = 0`.

    implicit none
    integer, intent(in) :: n, i
    real(DPR), dimension(:), intent(in) :: x, y
    real(DPR), intent(in) :: t
    real(DPR), intent(out) :: z
    logical, intent(in), optional :: null_deriv_at_0
!#......................................................................
    real(DPR) :: a, b, c, d
    real(DPR) :: h_i, h_im1, h_ip1
    real(DPR) :: s_i, s_im1, s_ip1
    real(DPR) :: p_i, p_ip1, y1_i, y1_ip1
    real(DPR) :: tmx_i
    logical :: null_deriv_at_0_eff
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(null_deriv_at_0)) then
       null_deriv_at_0_eff = null_deriv_at_0
    else
       null_deriv_at_0_eff = .false.
    endif

    if (i == 1) then
       h_i = x(i+1)-x(i)
       s_i = (y(i+1)-y(i))/h_i
       h_ip1 = x(i+2)-x(i+1)
       s_ip1 = (y(i+2)-y(i+1))/h_ip1
       p_ip1 = (s_i*h_ip1+s_ip1*h_i)/(h_i+h_ip1)
       y1_ip1 = (sign(1._DPR, s_i)+sign(1._DPR, s_ip1))*min(abs(s_i), abs(s_ip1), &
            0.5_DPR*abs(p_ip1))
       if (null_deriv_at_0_eff) then !# 1st derivative forced to 0 at `x` = 0.
          y1_i = (6._DPR*s_i*x(1)*(x(1)+h_i)-y1_ip1*x(1)*(3._DPR*x(1)+2._DPR*h_i))/ &
               (3._DPR*x(1)**2+4._DPR*x(1)*h_i+h_i**2)
       else
          y1_i = 1.5_DPR*s_i-0.5_DPR*y1_ip1
       end if
    else
       if (i == n-1) then
          h_i = x(i+1)-x(i)
          s_i = (y(i+1)-y(i))/h_i
          h_im1 = x(i)-x(i-1)
          s_im1 = (y(i)-y(i-1))/h_im1
          p_i = (s_im1*h_i+s_i*h_im1)/(h_im1+h_i)
          y1_i = (sign(1._DPR, s_im1)+sign(1._DPR, s_i))*min(abs(s_im1), &
               abs(s_i), 0.5_DPR*abs(p_i))
          y1_ip1 = 1.5_DPR*s_i-0.5_DPR*y1_i
       else
          h_i = x(i+1)-x(i)
          s_i = (y(i+1)-y(i))/h_i
          h_im1 = x(i)-x(i-1)
          s_im1 = (y(i)-y(i-1))/h_im1
          h_ip1 = x(i+2)-x(i+1)
          s_ip1 = (y(i+2)-y(i+1))/h_ip1
          p_i = (s_im1*h_i+s_i*h_im1)/(h_im1+h_i)
          p_ip1 = (s_i*h_ip1+s_ip1*h_i)/(h_i+h_ip1)
          y1_i = (sign(1._DPR, s_im1)+sign(1._DPR, s_i))*min(abs(s_im1), &
               abs(s_i), 0.5_DPR*abs(p_i))
          y1_ip1 = (sign(1._DPR, s_i)+sign(1._DPR, s_ip1))*min(abs(s_i), &
               abs(s_ip1), 0.5_DPR*abs(p_ip1))
       end if
    end if
    if (t > x(n)) then
       z = y(n)+y1_ip1*(t-x(n))
    else
       tmx_i = t-x(i)
       a = (y1_i+y1_ip1-2._DPR*s_i)/h_i**2
       b = (3._DPR*s_i-2._DPR*y1_i-y1_ip1)/h_i
       c = y1_i
       d = y(i)
       z = ((a*tmx_i+b)*tmx_i+c)*tmx_i+d
    endif

  end subroutine Steffen_DPR

!#======================================================================

  subroutine Steffen3_DPR(x1, x2, x3, y, n1, n2, n3, t1, t2, t3, z, i01, i02, &
       i03)

!# 3-dimensional version of subroutine `Steffen`.
!# Given `y(x1, x2, x3)`, where `x1(1) <= ... <= x1(n1)` (the same for `x2`
!# and `x3`), `Steffen3` computes `z(t1, t2, t3)`.
!# `i01`, etc., are the starting indices used by `bracket`.

    implicit none
    integer, intent(in) :: n1, n2, n3
    real(DPR), dimension(:), intent(in) :: x1
    real(DPR), dimension(:), intent(in) :: x2
    real(DPR), dimension(:), intent(in) :: x3
    real(DPR), dimension(:, :, :), intent(in) :: y
    real(DPR), intent(in) :: t1, t2, t3
    integer, intent(inout) :: i01, i02, i03
    real(DPR), intent(out) :: z
!#......................................................................
    integer :: i1, i2, i3
    real(DPR), dimension(n1) :: y1
    real(DPR), dimension(n2) :: y2
    real(DPR), dimension(n3) :: y3
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call bracket(n1, x1, t1, i01)
    call bracket(n2, x2, t2, i02)
    call bracket(n3, x3, t3, i03)
!# N.B.: In the following loops, one could cycle from 1 to `n1`
!# (`n2`, `n3`), but since `Steffen` is a local interpolation routine,
!# there is no need to compute all the values of `y1`, `y2`, `y3`.
    do i1 = max(1, i01-1), min(n1, i01+2)
       do i2 = max(1, i02-1), min(n2, i02+2)
          do i3 = max(1, i03-1), min(n3, i03+2)
             y3(i3) = y(i1, i2, i3)
          end do
          call Steffen(n3, x3, y3, t3, y2(i2), i03)
       end do
       call Steffen(n2, x2, y2, t2, y1(i1), i02)
    end do
    call Steffen(n1, x1, y1, t1, z, i01)

  end subroutine Steffen3_DPR

!#======================================================================

  subroutine Steffen4_DPR(x1, x2, x3, x4, y, n1, n2, n3, n4, t1, t2, t3, t4, &
       z, i01, i02, i03, i04, null_deriv_at_0)

!# 4-dimensional version of subroutine `Steffen`.
!# See `Steffen3` for the details.

    implicit none
    integer, intent(in) :: n1, n2, n3, n4
    real(DPR), dimension(:), intent(in) :: x1
    real(DPR), dimension(:), intent(in) :: x2
    real(DPR), dimension(:), intent(in) :: x3
    real(DPR), dimension(:), intent(in) :: x4
    real(DPR), dimension(:, :, :, :), intent(in) :: y
    real(DPR), intent(in) :: t1, t2, t3, t4
    integer, intent(inout) :: i01, i02, i03, i04
    real(DPR), intent(out) :: z
    logical, intent(in), optional :: null_deriv_at_0 !# For the interpolation on `x4` only.
!#......................................................................
    integer :: i1, i2, i3, i4
    real(DPR), dimension(n1) :: y1
    real(DPR), dimension(n2) :: y2
    real(DPR), dimension(n3) :: y3
    real(DPR), dimension(n4) :: y4
    logical :: null_deriv_at_0_eff
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(null_deriv_at_0)) then
       null_deriv_at_0_eff = null_deriv_at_0
    else
       null_deriv_at_0_eff = .false.
    endif

    call bracket(n1, x1, t1, i01)
    call bracket(n2, x2, t2, i02)
    call bracket(n3, x3, t3, i03)
    call bracket(n4, x4, t4, i04)
    do i1 = max(1, i01-1), min(n1, i01+2)
       do i2 = max(1, i02-1), min(n2, i02+2)
          do i3 = max(1, i03-1), min(n3, i03+2)
             do i4 = max(1, i04-1), min(n4, i04+2)
                y4(i4) = y(i1, i2, i3, i4)
             end do
             call Steffen(n4, x4, y4, t4, y3(i3), i04, null_deriv_at_0=null_deriv_at_0_eff)
          end do
          call Steffen(n3, x3, y3, t3, y2(i2), i03)
       end do
       call Steffen(n2, x2, y2, t2, y1(i1), i02)
    end do
    call Steffen(n1, x1, y1, t1, z, i01)

  end subroutine Steffen4_DPR

!#======================================================================

  function interp_lin_lin_DPR(x1, x2, y1, y2, x) result(interp)

    implicit none
    real(DPR), intent(in) :: x1, x2, y1, y2, x
    real(DPR) :: interp
!#......................................................................
    real(kind(x)) :: alpha
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (x1 /= x2) then
       alpha = (x2 - x)/(x2 - x1)
       interp = alpha*y1 + (1-alpha)*y2
    else
       interp = (y1+y2)/2
    endif

  end function interp_lin_lin_DPR

!#======================================================================

  recursive function interp_lin_log_DPR(x1, x2, y1, y2, x) result(interp)

!# Linear interpolation in `log(y)`.

    implicit none
    real(DPR), intent(in) :: x1, x2, y1, y2, x
    real(DPR) :: interp
!#......................................................................
    real(kind(x)) :: alpha
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (y1 <= 0 .or. y2 <= 0) then
       if (y1 < 0 .and. y2 < 0) then
          interp = -interp_lin_log_DPR(x1, x2, -y1, -y2, x)
       else !# `y1` = 0 or `y2` = 0 or {sgn(`y1`) /= sgn(`y2`) and `y1` /= 0 and `y2` /= 0}.
          if (y1 == 0) then
             if ((x1 <= x2 .and. x <= x1) .or. (x1 >= x2 .and. x >= x1)) then !# Extrapolation.
                interp = 0
                return
             endif
          else if (y2 == 0) then
             if ((x1 <= x2 .and. x >= x2) .or. (x1 >= x2 .and. x <= x2)) then !# Extrapolation.
                interp = 0
                return
             endif
          endif
!# {{`y1` = 0 or `y2` = 0} and no extrapolation} or {sgn(`y1`) /= sgn(`y2`) and `y1` /= 0 and `y2` /= 0}.
          interp = interp_lin_lin_DPR(x1, x2, y1, y2, x)
       endif
       return
    endif

    if (x1 /= x2) then
       alpha = (x2 - x)/(x2 - x1)
       interp = exp(alpha*log(y1) + (1-alpha)*log(y2))
    else
       interp = sqrt(y1*y2)
    endif

  end function interp_lin_log_DPR

!#======================================================================

  recursive function interp_log_lin_DPR(x1, x2, y1, y2, x) result(interp)

    implicit none
    real(DPR), intent(in) :: x1, x2, y1, y2, x
    real(DPR) :: interp
!#......................................................................
    real(kind(x)) :: alpha, ln_x2
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (x1 <= 0 .or. x2 <= 0 .or. x <= 0) then
       if (x1 < 0 .and. x2 < 0 .and. x < 0) then
          interp = interp_log_lin_DPR(-x1, -x2, y1, y2, -x)
       else
          interp = interp_lin_lin_DPR(x1, x2, y1, y2, x)
       endif
       return
    endif

    if (x1 /= x2) then
       ln_x2 = log(x2)
       alpha = (ln_x2 - log(x))/(ln_x2 - log(x1))
       interp = alpha*y1 + (1-alpha)*y2
    else
       interp = (y1+y2)/2
    endif

  end function interp_log_lin_DPR

!#======================================================================

  recursive function interp_log_log_DPR(x1, x2, y1, y2, x) result(interp)

    implicit none
    real(DPR), intent(in) :: x1, x2, y1, y2, x
    real(DPR) :: interp
!#......................................................................
    real(kind(x)) :: alpha, ln_x2
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (y1 <= 0 .or. y2 <= 0) then
       if (y1 < 0 .and. y2 < 0) then
          interp = -interp_log_log_DPR(x1, x2, -y1, -y2, x)
       else !# `y1` = 0 or `y2` = 0 or {sgn(`y1`) /= sgn(`y2`) and `y1` /= 0 and `y2` /= 0}.
          if (y1 == 0) then
             if ((x1 <= x2 .and. x <= x1) .or. (x1 >= x2 .and. x >= x1)) then !# Extrapolation.
                interp = 0
                return
             endif
          else if (y2 == 0) then
             if ((x1 <= x2 .and. x >= x2) .or. (x1 >= x2 .and. x <= x2)) then !# Extrapolation.
                interp = 0
                return
             endif
          endif
!# {{`y1` = 0 or `y2` = 0} and no extrapolation} or {sgn(`y1`) /= sgn(`y2`) and `y1` /= 0 and `y2` /= 0}.
          interp = interp_log_lin_DPR(x1, x2, y1, y2, x)
       endif
       return
    endif

    if (x1 <= 0 .or. x2 <= 0 .or. x <= 0) then
       if (x1 < 0 .and. x2 < 0 .and. x < 0) then
          interp = interp_log_log_DPR(-x1, -x2, y1, y2, -x)
       else
          interp = interp_lin_log_DPR(x1, x2, y1, y2, x)
       endif
       return
    endif

    if (x1 /= x2) then
       ln_x2 = log(x2)
       alpha = (ln_x2 - log(x))/(ln_x2 - log(x1))
       interp = exp(alpha*log(y1) + (1-alpha)*log(y2))
    else
       interp = sqrt(y1*y2)
    endif

  end function interp_log_log_DPR

!#======================================================================

  subroutine compute_weights_SPR(x_arr, x, weight, interp_proc)

    implicit none
    real(SPR), dimension(:), intent(in) :: x_arr
    real(SPR), intent(in) :: x
    real(SPR), dimension(:), intent(out) :: weight
    character(len=*), optional :: interp_proc
!#......................................................................
    integer :: i, n
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    n = size(x_arr)
    if (n > 1) then
       weight(:) = 0
       if (x_arr(1) <= x_arr(n)) then
          if (x <= x_arr(1)) then
             weight(1) = 1
             return
          else if (x >= x_arr(n)) then
             weight(n) = 1
             return
          else
             i = 0
             call bracket_SPR(n, x_arr, x, i)
          endif
       else
          if (x >= x_arr(1)) then
             weight(1) = 1
             return
          else if (x <= x_arr(n)) then
             weight(n) = 1
             return
          else
             i = 0
             call bracket_SPR(n, -x_arr, -x, i)
          endif
       endif
       if (present(interp_proc)) then
          if (interp_proc == "interp_log_lin") then
             weight(i) =  interp_log_lin(x_arr(i), x_arr(i+1), 1._SPR, 0._SPR, x)
          else if (interp_proc == "interp_lin_log") then
             weight(i) =  interp_lin_log(x_arr(i), x_arr(i+1), 1._SPR, 0._SPR, x)
          else if (interp_proc == "interp_log_log") then
             weight(i) =  interp_log_log(x_arr(i), x_arr(i+1), 1._SPR, 0._SPR, x)
          else if (interp_proc == "interp_lin_lin") then
             weight(i) =  interp_lin_lin(x_arr(i), x_arr(i+1), 1._SPR, 0._SPR, x)
          else
             write(*,"(a)") "In procedure `compute_weights_SPR` of file &
                  &""utilities_dir/mod_interp.f90"", the value of &
                  &`interp_proc` cannot be """ // trim(interp_proc) // """."
          endif
       else
          weight(i) =  interp_lin_lin(x_arr(i), x_arr(i+1), 1._SPR, 0._SPR, x)
       endif
       weight(i+1) = 1-weight(i)
    else
       weight(1) = 1
    endif

  end subroutine compute_weights_SPR

!#======================================================================

  subroutine compute_weights_DPR(x_arr, x, weight, interp_proc)

    implicit none
    real(DPR), dimension(:), intent(in) :: x_arr
    real(DPR), intent(in) :: x
    real(DPR), dimension(:), intent(out) :: weight
    character(len=*), optional :: interp_proc
!#......................................................................
    integer :: i, n
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    n = size(x_arr)
    if (n > 1) then
       weight(:) = 0
       if (x_arr(1) <= x_arr(n)) then
          if (x <= x_arr(1)) then
             weight(1) = 1
             return
          else if (x >= x_arr(n)) then
             weight(n) = 1
             return
          else
             i = 0
             call bracket_DPR(n, x_arr, x, i)
          endif
       else
          if (x >= x_arr(1)) then
             weight(1) = 1
             return
          else if (x <= x_arr(n)) then
             weight(n) = 1
             return
          else
             i = 0
             call bracket_DPR(n, -x_arr, -x, i)
          endif
       endif
       if (present(interp_proc)) then
          if (interp_proc == "interp_log_lin") then
             weight(i) =  interp_log_lin(x_arr(i), x_arr(i+1), 1._DPR, 0._DPR, x)
          else if (interp_proc == "interp_lin_log") then
             weight(i) =  interp_lin_log(x_arr(i), x_arr(i+1), 1._DPR, 0._DPR, x)
          else if (interp_proc == "interp_log_log") then
             weight(i) =  interp_log_log(x_arr(i), x_arr(i+1), 1._DPR, 0._DPR, x)
          else if (interp_proc == "interp_lin_lin") then
             weight(i) =  interp_lin_lin(x_arr(i), x_arr(i+1), 1._DPR, 0._DPR, x)
          else
             write(*,"(a)") "In procedure `compute_weights_DPR` of file &
                  &""utilities_dir/mod_interp.f90"", the value of &
                  &`interp_proc` cannot be """ // trim(interp_proc) // """."
          endif
       else
          weight(i) =  interp_lin_lin(x_arr(i), x_arr(i+1), 1._DPR, 0._DPR, x)
       endif
       weight(i+1) = 1-weight(i)
    else
       weight(1) = 1
    endif

  end subroutine compute_weights_DPR

end module mod_interp

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_initialization
  
  private
  public :: initialization

contains

!#======================================================================
  
  subroutine initialization(reserv_abund, &
       ISM_abund, galaxy_init_mass, reserv_init_mass_scaled, ISM_init_mass, BHNS_init_mass, &
       WD_init_mass, inert_init_mass, carb_init_abund, sil_init_abund, ISM_elem_init_mass, &
       carb_init_mass, sil_init_mass, abund_sol, elem_sol, Z_sol, dY_over_dZ, &
       SF_warn_present, infall_warn_present, outflow_warn_present, &
       reserv_warn_present)
    
    use mod_constants, only : Y_prim, Z_prim, elem_id
    use mod_loc, only : i_loc
    use mod_scenario
    
    implicit none
    real(CDR), dimension(:, 0:), intent(inout) :: ISM_abund !# ??? `0:` necessary?
    real(CDR), dimension(:,0:), intent(out) :: reserv_abund !# ??? `0:` necessary?
    real(DPR), dimension(:), intent(in) :: abund_sol
    character(len=*), dimension(:), intent(in) :: elem_sol
    real(CDR), intent(in) :: Z_sol, dY_over_dZ    
    real(CDR), intent(out) :: galaxy_init_mass, ISM_init_mass, BHNS_init_mass, WD_init_mass, &
         inert_init_mass, carb_init_abund, sil_init_abund
    real(CDR), dimension(:), intent(out) ::  reserv_init_mass_scaled
    real(CDR), intent(out) :: carb_init_mass, sil_init_mass
    real(CDR), dimension(0:), intent(out) :: ISM_elem_init_mass !# ??? `0:` necessary?
    logical, intent(out) :: SF_warn_present, &
         outflow_warn_present, reserv_warn_present
    logical, dimension(:), intent(out) :: infall_warn_present
!#......................................................................
    real(CDR) :: abund_ratio
    integer ::  i_Z, i_O, i_C, i_Fe, i_He, i_N, i_Ne, i_Mg, i_Si, i_S, i_Ca
    integer :: i_reserv
    integer, parameter :: init_step = 1
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    i_Z = i_loc(elem_id, "Z")
    i_O = i_loc(elem_id, "O")
    i_C = i_loc(elem_id, "C")
    i_Fe = i_loc(elem_id, "Fe")
    i_He = i_loc(elem_id, "He")
    i_N = i_loc(elem_id, "N")
    i_Ne = i_loc(elem_id, "Ne")
    i_Mg = i_loc(elem_id, "Mg")
    i_Si = i_loc(elem_id, "Si")
    i_S = i_loc(elem_id, "S")
    i_Ca = i_loc(elem_id, "Ca")
    
    do i_reserv = 1, max_dim_reserv
       reserv_init_mass_scaled(i_reserv) = reserv_init_mass(i_reserv)
       reserv_abund(i_reserv, i_Z) = reserv_Z(i_reserv)
    end do
    galaxy_init_mass = 1 - sum(reserv_init_mass(:))
    reserv_warn_present = .false.
    if (galaxy_init_mass < 0) then
       galaxy_init_mass = 0
       reserv_init_mass_scaled(:) = reserv_init_mass(:)/sum(reserv_init_mass(:))
       reserv_warn_present = .true.
    endif
    ISM_init_mass = galaxy_init_mass
    ISM_abund(init_step,i_Z) = ISM_init_Z

!# Oxygen.
    abund_ratio = sum(abund_sol, &
         mask = elem_sol == "16O" .or. elem_sol == "17O" .or. elem_sol == "18O" &
         )/Z_sol
    ISM_abund(init_step,i_O) = ISM_abund(init_step,i_Z) * abund_ratio
    reserv_abund(:,i_O) = reserv_abund(:,i_Z) * abund_ratio

!# Carbon.
    abund_ratio = sum(abund_sol, &
         mask = elem_sol == "12C" .or. elem_sol == "13C" .or. elem_sol == "14C" &
         )/Z_sol
    ISM_abund(init_step,i_C) = ISM_abund(init_step,i_Z) * abund_ratio
    reserv_abund(:,i_C) = reserv_abund(:,i_Z) * abund_ratio

!# Iron.
    abund_ratio = sum(abund_sol, &
         mask = elem_sol == "54Fe" .or. elem_sol == "56Fe" .or. elem_sol == "57Fe" &
         .or.  elem_sol == "58Fe" &
         )/Z_sol
    ISM_abund(init_step,i_Fe) = ISM_abund(init_step,i_Z) * abund_ratio
    reserv_abund(:,i_Fe) = reserv_abund(:,i_Z) * abund_ratio

!# Helium.
    ISM_abund(init_step,i_He) = Y_prim + dY_over_dZ*(ISM_abund(init_step,i_Z)-Z_prim)
    reserv_abund(:,i_He) = Y_prim + dY_over_dZ*(reserv_abund(:,i_Z)-Z_prim)

!# Nitrogen.
    abund_ratio = sum(abund_sol, &
         mask = elem_sol == "14N" .or. elem_sol == "15N" &
         )/Z_sol
    ISM_abund(init_step,i_N) = ISM_abund(init_step,i_Z) * abund_ratio
    reserv_abund(:,i_N) = reserv_abund(:,i_Z) * abund_ratio

!# Neon.
    abund_ratio = sum(abund_sol, &
         mask = elem_sol == "20Ne" .or. elem_sol == "21Ne" .or. elem_sol == "22Ne" &
         )/Z_sol
    ISM_abund(init_step,i_Ne) = ISM_abund(init_step,i_Z) * abund_ratio
    reserv_abund(:,i_Ne) = reserv_abund(:,i_Z) * abund_ratio

!# Magnesium.
    abund_ratio = sum(abund_sol, &
         mask = elem_sol == "24Mg" .or. elem_sol == "25Mg" .or. elem_sol == "26Mg" &
         )/Z_sol
    ISM_abund(init_step,i_Mg) = ISM_abund(init_step,i_Z) * abund_ratio
    reserv_abund(:,i_Mg) = reserv_abund(:,i_Z) * abund_ratio

!# Silicon.
    abund_ratio = sum(abund_sol, &
         mask = elem_sol == "28Si" .or. elem_sol == "29Si" .or. elem_sol == "30Si" &
         )/Z_sol
    ISM_abund(init_step,i_Si) = ISM_abund(init_step,i_Z) * abund_ratio
    reserv_abund(:,i_Si) = reserv_abund(:,i_Z) * abund_ratio

!# Sulfur.
    abund_ratio = sum(abund_sol, &
         mask = elem_sol == "32S" .or.  elem_sol == "33S" .or.  elem_sol == "34S" &
         .or.  elem_sol == "36S" &
         )/Z_sol
    ISM_abund(init_step,i_S) = ISM_abund(init_step,i_Z) * abund_ratio
    reserv_abund(:,i_S) = reserv_abund(:,i_Z) * abund_ratio

!# Calcium.
    abund_ratio = sum(abund_sol, &
         mask = elem_sol == "40Ca" .or. elem_sol == "42Ca" .or. elem_sol == "43Ca" &
         .or. elem_sol == "44Ca" .or. elem_sol == "46Ca" .or. elem_sol == "48Ca" &
         )/Z_sol
    ISM_abund(init_step,i_Ca) = ISM_abund(init_step,i_Z) * abund_ratio
    reserv_abund(:,i_Ca) = reserv_abund(:,i_Z) * abund_ratio

    ISM_elem_init_mass(:) = ISM_init_mass*ISM_abund(init_step,:)
    BHNS_init_mass = 0
    WD_init_mass = 0
    SF_warn_present = .false.
    infall_warn_present(:) = .false.
    outflow_warn_present = .false.
    inert_init_mass = 0

    if (dust_evolution == "Dwek") then
       carb_init_mass = 0
       sil_init_mass = 0
       carb_init_abund = 0
       sil_init_abund = 0
    endif

  end subroutine initialization
  
end module mod_initialization

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_read_output_param
  
  use mod_types
  use mod_linked_list
  use mod_analyze_statement, only : get_val, error_message, warning_message
  use mod_random, only : dim_seed, seed

  implicit none
  public
  character(len=std_string), save :: spectra_output
  logical, save :: RF_output
  logical, save :: sublim_output
  logical, save :: grain_temp_output
  logical, save :: grain_SED_output
  logical, save :: grain_output_SFC
  logical, save :: grain_output_DISM
  real(CDR), save :: grain_output_min_age, grain_output_max_age
  real(CDR), save :: grain_output_min_size, grain_output_max_size
  character(len=std_string), save :: ages_file

  character(len=std_string), save :: spectra_file, &
       grain_temp_file, grain_SED_file, orig_spectra_file, &
       orig_grain_temp_file, orig_grain_SED_file

  character(len=std_string), save :: prefix
  logical, save :: stamp_time, overwrite
  type(lk_lst_long_string), save :: text !# Head node.
  type(lk_lst_long_string), pointer, save, private :: text_current_node

contains

!#======================================================================
  
  subroutine reset_output

    use mod_spectra_def_param
    implicit none
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    spectra_output = spectra_output_def
    RF_output = RF_output_def
    sublim_output = sublim_output_def
    grain_temp_output = grain_temp_output_def
    grain_SED_output = grain_SED_output_def
    grain_output_min_age = grain_output_min_age_def
    grain_output_max_age = grain_output_max_age_def
    grain_output_SFC = grain_output_SFC_def
    grain_output_DISM = grain_output_DISM_def
    grain_output_min_size = grain_output_min_size_def
    grain_output_max_size = grain_output_max_size_def
    ages_file = ages_file_def
    prefix = prefix_def
    stamp_time = stamp_time_def
    overwrite = overwrite_def
    call erase_text

  end subroutine reset_output
  
!#======================================================================

  subroutine read_output_param_check

    implicit none

  end subroutine read_output_param_check

!#======================================================================

  subroutine read_spectra_output(rhs)
    
    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(spectra_output, rhs)
    if (all(spectra_output /= (/ &
         "none    ", &
         "basic   ", &
         "detailed"/))) &
         call error_message("The value of `spectra_output` should be &
         &""none"", ""basic"" or ""detailed"".")

  end subroutine read_spectra_output

!#======================================================================
  
  subroutine set_spectra_output(val_spectra_output)
    
    implicit none
    character(len=*), intent(in) :: val_spectra_output

    spectra_output = val_spectra_output

  end subroutine set_spectra_output

!#======================================================================
  
  subroutine read_RF_output(rhs)
    
    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(RF_output, rhs)
    if (RF_output) call set_spectra_output("detailed")

  end subroutine read_RF_output

!#======================================================================
  
  subroutine read_sublim_output(rhs)
    
    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(sublim_output, rhs)
    if (sublim_output) call set_spectra_output("detailed")

  end subroutine read_sublim_output

!#======================================================================

  subroutine read_grain_temp_output(rhs)
    
    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(grain_temp_output, rhs)

  end subroutine read_grain_temp_output

!#======================================================================
  
  subroutine set_grain_temp_output(val_grain_temp_output)
    
    implicit none
    logical, intent(in) :: val_grain_temp_output

    grain_temp_output = val_grain_temp_output

  end subroutine set_grain_temp_output

!#======================================================================

  subroutine read_grain_temp_file(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(grain_temp_file, rhs)
    call set_grain_temp_output(.true.)

  end subroutine read_grain_temp_file

!#======================================================================

  subroutine read_grain_SED_output(rhs)
    
    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(grain_SED_output, rhs)

  end subroutine read_grain_SED_output

!#======================================================================
  
  subroutine set_grain_SED_output(val_grain_SED_output)
    
    implicit none
    logical, intent(in) :: val_grain_SED_output

    grain_SED_output = val_grain_SED_output

  end subroutine set_grain_SED_output

!#======================================================================

  subroutine read_grain_SED_file(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(grain_SED_file, rhs)
    call set_grain_SED_output(.true.)

  end subroutine read_grain_SED_file

!#======================================================================

  subroutine read_grain_output_min_age(rhs)
    
    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(grain_output_min_age, rhs)
!# To make sure that the interval is closed on the left.
    if (grain_output_min_age > 0) &
         grain_output_min_age = nearest(grain_output_min_age, -1.)

  end subroutine read_grain_output_min_age

!#======================================================================

  subroutine read_grain_output_max_age(rhs)
    
    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(grain_output_max_age, rhs)
!# To make sure that the interval is closed on the right.
    if (grain_output_max_age < huge(grain_output_max_age)) &
         grain_output_max_age = nearest(grain_output_max_age, +1.)

  end subroutine read_grain_output_max_age

!#======================================================================

  subroutine read_grain_output_SFC(rhs)
    
    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(grain_output_SFC, rhs)

  end subroutine read_grain_output_SFC

!#======================================================================

  subroutine read_grain_output_DISM(rhs)
    
    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(grain_output_DISM, rhs)

  end subroutine read_grain_output_DISM

!#======================================================================

  subroutine read_grain_output_min_size(rhs)
    
    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(grain_output_min_size, rhs)
!# To make sure that the interval is closed on the left.
    if (grain_output_min_size > 0) &
         grain_output_min_size = nearest(grain_output_min_size, -1.)

  end subroutine read_grain_output_min_size

!#======================================================================

  subroutine read_grain_output_max_size(rhs)
    
    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(grain_output_max_size, rhs)
!# To make sure that the interval is closed on the right.
    if (grain_output_max_size < huge(grain_output_max_size)) &
         grain_output_max_size = nearest(grain_output_max_size, +1.)

  end subroutine read_grain_output_max_size

!#======================================================================

  subroutine read_ages_file(rhs)
    
    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(ages_file, rhs)

  end subroutine read_ages_file

!#======================================================================

  subroutine read_spectra_file(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(spectra_file, rhs)

  end subroutine read_spectra_file

!#======================================================================

  subroutine read_prefix(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(prefix, rhs)
    
  end subroutine read_prefix

!#======================================================================

  subroutine read_stamp_time(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(stamp_time, rhs)
    
  end subroutine read_stamp_time

!#======================================================================

  subroutine read_overwrite(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(overwrite, rhs)
    
  end subroutine read_overwrite

!#======================================================================
  
  subroutine read_add_text(rhs, statement_type)
    
    implicit none
    character(len=*), intent(in) :: rhs, statement_type
!#......................................................................
    character(len=long_string) :: new_text
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    if (statement_type == "assignment") then
       call warning_message("The statement `add_text` is a command, &
            &not a parameter. It should be followed by one or more spaces &
            &and a string of characters, not by `=`. &
            &Character `=` is removed.")
    endif
    call get_val(new_text, rhs)
    call lk_lst_new_node(text, text_current_node)
    text_current_node % val = new_text

  end subroutine read_add_text

!#======================================================================

  subroutine erase_text

    call lk_lst_initialize(text)
    
  end subroutine erase_text
  
end module mod_read_output_param

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_analyze_statement

  use mod_types, only : std_string, long_string

  implicit none
  private

  interface get_val
     module procedure array_integer_key, array_SPR_key, &
          array_DPR_key, array_logical_key, array_string_key, &
          scalar_integer_key, scalar_SPR_key, scalar_DPR_key, &
          scalar_logical_key, scalar_string_key
  end interface get_val

  character(len=std_string), save :: file_name
  integer, save :: line_number, unit_log = -1

  public :: analyze_statement, get_val, file_name, line_number, &
       error_message, warning_message, unit_log

contains

!#======================================================================

  subroutine analyze_statement(statement, read_proc, &
       end_statement, return_statement)

    implicit none
    character(len=*), intent(in) :: statement
    logical, intent(out) :: end_statement, return_statement
    external :: read_proc
    interface
       subroutine read_proc(key, rhs, indices_string, unknown_statement, &
            statement_type)
         use mod_strings, only : same_case_equal
         implicit none
         character(len=*), intent(in) :: key, rhs, statement_type
         character(len=*), intent(inout) :: indices_string
         logical, intent(out) :: unknown_statement
       end subroutine read_proc
    end interface
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call find_key_val(statement, &
         end_statement, return_statement, read_proc)

  end subroutine analyze_statement

!#======================================================================

  subroutine find_key_val(statement, &
       end_statement, return_statement, read_proc)

    use mod_strings, only : same_case_equal
    use mod_types

    implicit none
    character(len=*), intent(in) :: statement
    logical, intent(out) :: end_statement, return_statement
    external :: read_proc
    interface
       subroutine read_proc(key, rhs, indices_string, unknown_statement, &
            statement_type)
         use mod_strings, only : same_case_equal
         implicit none
         character(len=*), intent(in) :: key, rhs, statement_type
         character(len=*), intent(inout) :: indices_string
         logical, intent(out) :: unknown_statement
       end subroutine read_proc
    end interface
!#......................................................................
    character(len=len(statement)) :: key, rhs, indices_string, &
         statement_type
    logical :: unknown_statement
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call find_key(statement, key, rhs, indices_string, &
         statement_type)

    if (same_case_equal(key, "end")) then
       end_statement = .true.
       return

    else if (same_case_equal(key, "return")) then
       return_statement = .true.
       return

    else if (same_case_equal(key, "stop")) then
       stop

    else
       call read_proc(key, rhs, indices_string, unknown_statement, &
            statement_type)
       if (unknown_statement) then
          call error_message("Statement or key `" // trim(key) // "` unknown.")
       endif
    endif

  end subroutine find_key_val

!#======================================================================

  subroutine find_key(statement, key, rhs, indices_string, statement_type)

!    use mod_strings, only  : down_case

    implicit none
    character(len=*), intent(in) :: statement
    character(len=*), intent(out) :: key, rhs, indices_string !# rhs = "right-hand side".
    character(len=*), intent(out) :: statement_type
!#......................................................................
    integer :: pos, pos1, pos2
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    pos1 = index(statement, "=")
    pos2 = index(statement, " ")
    if (pos1 == 0) then !# No `=`.
       pos = pos2
       statement_type = "command"       
    else !# Some `=` found.
       if (pos2 < pos1) then
          if (index(adjustl(statement(pos2+1:)), "=") == 1) then !# `=` is the \
!# first non-blank character after the space: separator is `=`.
             pos = pos1
             statement_type = "assignment"
          else !# Separator is a space character. (Excludes the case where a \
!# string contains `=`.
             pos = pos2
             statement_type = "command"
          endif
       else !# Separator is `=`.
          pos = pos1
          statement_type = "assignment"
       endif
    endif

    if (pos /= 0) then
!       key = down_case(statement(:pos-1))
       key = statement(:pos-1)
       rhs = adjustl(statement(pos+1:))
    else
!       key = down_case(statement)
       key = statement
       rhs = ""
    endif

    pos = index(key, "(")
    if (pos /= 0) then
       indices_string = adjustl(key(pos:))
       key = trim(key(:pos-1))
    else
       indices_string = ""
    endif

  end subroutine find_key

!#======================================================================

  subroutine read_indices(string, index_present, index_number, index_val, &
       scalar_key)

    use mod_convert_type, only : to_string

    implicit none
    character(len=*), intent(inout) :: string
    logical, dimension(:), intent(out) :: index_present
    integer, intent(out) :: index_number
    integer, dimension(size(index_present)), intent(out) :: index_val
    logical, intent(out) :: scalar_key
!#......................................................................
    integer :: pos, first, last, stride, i
    character(len=len(string)) :: substring
    integer :: max_last
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    max_last = size(index_present)
    index_present(:) = .false.
    index_number = 0

    string = adjustl(string(2:)) !# Remove "(".
    pos = index(string, ")")
    if (pos == 0) then
       call error_message("No "")"" found.")
    else
       if (string(pos+1:) /= "") then
          call error_message("Something found between "")"" and ""="".")
       endif
       string = adjustl(string(:pos-1)) !# Remove ")".
    endif

    if (string(1:1) == "[") then
       scalar_key = .false.
       string = adjustl(string(2:)) !# Remove "[".
       pos = index(string, "]")
       if (pos == 0) then
          call error_message("No ""]"" found.")
       else
          if (string(pos+1:) /= "") then
             call error_message("Something found after ""]"".")
          endif
          string = string(:pos-1) !# Remove "]".
          do
             pos = index(string, ",")
             if (pos == 0) then
                substring = string
             else
                substring = string(:pos-1)
             endif
             if (substring == "") then
                call error_message("Nothing found after "","".")
             endif

             call read_indices2(substring, max_last, first, last, stride)
             do i = first, last, stride
                if (index_present(i)) then
                   call error_message("Index " // to_string(i) // " should appear only once.")
                endif
                index_present(i) = .true.
                index_number = index_number + 1
                index_val(index_number) = i
             enddo

             if (pos == 0) exit
             string = string(pos+1:)
          enddo
       endif
    else !# No "[".
       call read_indices2(string, max_last, first, last, stride, scalar_key)
       index_present(first:last:stride) = .true.
       do i = first, last, stride
          index_number = index_number + 1
          index_val(index_number) = i
       enddo
    endif

  end subroutine read_indices

!#======================================================================

  subroutine read_indices2(string, max_last, first, last, stride, scalar_key)

    implicit none
    character(len=*), intent(inout) :: string
    integer, intent(in) :: max_last
    integer, intent(out) :: first, last, stride
    logical, intent(out), optional :: scalar_key
!#......................................................................
    integer :: pos, effective_last, ios
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Read first index: {
    pos = index(string, ":")
    if (pos == 0) then !# Single index.
       if (present(scalar_key)) scalar_key = .true.
!# string = "first".
       read(string, *, iostat=ios) first
       if (ios /= 0) call error_message("Indices must be integers.")
       last = first
       stride = 1
    else !# Index loop.
       if (present(scalar_key)) scalar_key = .false.
       if (string(:pos-1) == "") then
!# string = ": [last : stride]".
          first = 1
       else
!# string = "first : [last : stride]".
          read(string(:pos-1), *, iostat=ios) first
          if (ios /= 0) call error_message("Indices must be integers.")
       endif
!# }.

!# Read last index: {
       string = adjustl(string(pos+1:))
       pos = index(string, ":")
       if (pos == 0) then !# Stride not provided.
          if (string == "") then !# Last index not provided.
!# string = "[first] : ".
             call error_message("The last index must be provided for index loops.")
!# Not used currently: {
             last = max_last
             stride = 1
!# }.
          else !# Last index provided.
!# string = "[first] : last".
             read(string, *, iostat=ios) last
             if (ios /= 0) call error_message("Indices must be integers.")
             stride = 1
          endif
       else !# Stride provided.
          if (string(:pos-1) == "") then !# Last index not provided.
!# string = "[first] : : [stride]".
             call error_message("The last index must be provided for index loops.")
             last = max_last
          else !# Last index provided.
!# string = "[first] : last : [stride]".
             read(string(:pos-1), *, iostat=ios) last
             if (ios /= 0) call error_message("Indices must be integers.")
          endif
!# }.

!# Read stride: {
          string = adjustl(string(pos+1:))
          if (string == "") then
             stride = 1
          else
             read(string, *, iostat=ios) stride
             if (ios /= 0) call error_message("Indices must be integers.")
             if (stride == 0) then
                call error_message("Strides must not be null.")
             endif
          endif
       endif
    endif
!# }.

    effective_last = first + stride * ((last-first)/stride)
    if (first < 1 .or. first > max_last .or. effective_last < 1 &
         .or. effective_last > max_last) then
       call error_message("Wrong bounds for indices.")
    endif

  end subroutine read_indices2

!#======================================================================

  subroutine scalar_integer_val(string, val)

    implicit none
    character(len=*), intent(in) :: string
    integer, intent(out) :: val
!#......................................................................
    character(len=len(string)) :: string_tmp, other_input
    integer :: pos, ios
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    string_tmp = adjustl(string)
    pos = index(string_tmp, " ")
    if (pos /= 0) then
       other_input = string_tmp(pos+1:)
       if (other_input /= "") call error_message("Something trailing on the line after the value.")
       string_tmp = string_tmp(:pos-1)
    endif

!# The "/" separator and the repetition of values with "*" (although allowed in
!# list-directed formatting) are here forbidden.
    if (index(string_tmp, "/") /= 0) &
         call error_message("""/"" must not be used to separate values. &
         & Use "","" instead.")
    if (index(string_tmp, "*") /= 0) &
         call error_message("""*"" cannot be used to repeat values.")

    read(string_tmp, *, iostat=ios) val
    if (ios /= 0) call error_message("Not an integer number.")

  end subroutine scalar_integer_val

!#======================================================================

  subroutine array_integer_val(string, val)

    implicit none
    character(len=*), intent(in) :: string
    integer, dimension(:), intent(out) :: val
!#......................................................................
    character(len=len(string)) :: string_tmp
    integer :: scalar
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    string_tmp = adjustl(string)
    if (string_tmp(1:1) == "[") then
       call array_integer_val2(string_tmp, val(:))
    else
       call scalar_integer_val(string_tmp, scalar)
       val(:) = scalar
    endif

  end subroutine array_integer_val

!#======================================================================

  subroutine array_integer_val2(string, val)

    implicit none
    character(len=*), intent(in) :: string
    integer, dimension(:), intent(out) :: val
!#......................................................................
    integer :: i, pos
    character(len=len(string)) :: string_tmp
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    pos = index(string, "[")
    string_tmp = string(pos+1:)
    do i = 1, size(val)
       pos = scan(string_tmp, ",]")
       if (pos == 0) then
          call error_message("Neither "","" nor ""]"" have been found.")
       else if (i == size(val) .and. string_tmp(pos:pos) /= "]") then
          call error_message("Too many values.")
       else if (i < size(val) .and. string_tmp(pos:pos) /= ",") then
          call error_message("Too few values.")
       endif
       call scalar_integer_val(string_tmp(:pos-1), val(i))
       string_tmp = adjustl(string_tmp(pos+1:))
    enddo

  end subroutine array_integer_val2

!#======================================================================

  subroutine scalar_SPR_val(string, val)

    use mod_types

    implicit none
    character(len=*), intent(in) :: string
    real(SPR), intent(out) :: val
!#......................................................................
    character(len=len(string)) :: string_tmp, other_input
    integer :: pos, ios
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    string_tmp = adjustl(string)
    pos = index(string_tmp, " ")
    if (pos /= 0) then
       other_input = string_tmp(pos+1:)
       if (other_input /= "") call error_message("Something trailing on the line after the value.")
       string_tmp = string_tmp(:pos-1)
    endif

!# The "/" separator and the repetition of values with "*" (although allowed in
!# list-directed formatting) are here forbidden.
    if (index(string_tmp, "/") /= 0) &
         call error_message("""/"" must not be used to separate values. &
         & Use "","" instead.")
    if (index(string_tmp, "*") /= 0) &
         call error_message("""*"" must not be used to repeat values.")

    read(string_tmp, *, iostat=ios) val
    if (ios /= 0) call error_message("Not a real number.")

  end subroutine scalar_SPR_val

!#======================================================================

  subroutine array_SPR_val(string, val)

    use mod_types

    implicit none
    character(len=*), intent(in) :: string
    real(SPR), dimension(:), intent(out) :: val
!#......................................................................
    character(len=len(string)) :: string_tmp
    real(SPR) :: scalar
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    string_tmp = adjustl(string)
    if (string_tmp(1:1) == "[") then
       call array_SPR_val2(string_tmp, val(:))
    else
       call scalar_SPR_val(string_tmp, scalar)
       val(:) = scalar
    endif

  end subroutine array_SPR_val

!#======================================================================

  subroutine array_SPR_val2(string, val)

    use mod_types

    implicit none
    character(len=*), intent(in) :: string
    real(SPR), dimension(:), intent(out) :: val
!#......................................................................
    integer :: i, pos
    character(len=len(string)) :: string_tmp
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    pos = index(string, "[")
    string_tmp = string(pos+1:)
    do i = 1, size(val)
       pos = scan(string_tmp, ",]")
       if (pos == 0) then
          call error_message("Neither "","" nor ""]"" have been found.")
       else if (i == size(val) .and. string_tmp(pos:pos) /= "]") then
          call error_message("Too many values.")
       else if (i < size(val) .and. string_tmp(pos:pos) /= ",") then
          call error_message("Too few values.")
       endif
       call scalar_SPR_val(string_tmp(:pos-1), val(i))
       string_tmp = adjustl(string_tmp(pos+1:))
    enddo

  end subroutine array_SPR_val2

!#======================================================================

  subroutine scalar_DPR_val(string, val)

    use mod_types

    implicit none
    character(len=*), intent(in) :: string
    real(DPR), intent(out) :: val
!#......................................................................
    character(len=len(string)) :: string_tmp, other_input
    integer :: pos, ios
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    string_tmp = adjustl(string)
    pos = index(string_tmp, " ")
    if (pos /= 0) then
       other_input = string_tmp(pos+1:)
       if (other_input /= "") call error_message("Something trailing on the line after the value.")
       string_tmp = string_tmp(:pos-1)
    endif

!# The "/" separator and the repetition of values with "*" (although allowed in
!# list-directed formatting) are here forbidden.
    if (index(string_tmp, "/") /= 0) &
         call error_message("""/"" must not be used to separate values. &
         & Use "","" instead.")
    if (index(string_tmp, "*") /= 0) &
         call error_message("""*"" must not be used to repeat values.")

    read(string_tmp, *, iostat=ios) val
    if (ios /= 0) call error_message("Not a real number.")

  end subroutine scalar_DPR_val

!#======================================================================

  subroutine array_DPR_val(string, val)

    use mod_types

    implicit none
    character(len=*), intent(in) :: string
    real(DPR), dimension(:), intent(out) :: val
!#......................................................................
    character(len=len(string)) :: string_tmp
    real(DPR) :: scalar
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    string_tmp = adjustl(string)
    if (string_tmp(1:1) == "[") then
       call array_DPR_val2(string_tmp, val(:))
    else
       call scalar_DPR_val(string_tmp, scalar)
       val(:) = scalar
    endif

  end subroutine array_DPR_val

!#======================================================================

  subroutine array_DPR_val2(string, val)

    use mod_types

    implicit none
    character(len=*), intent(in) :: string
    real(DPR), dimension(:), intent(out) :: val
!#......................................................................
    integer :: i, pos
    character(len=len(string)) :: string_tmp
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    pos = index(string, "[")
    string_tmp = string(pos+1:)
    do i = 1, size(val)
       pos = scan(string_tmp, ",]")
       if (pos == 0) then
          call error_message("Neither "","" nor ""]"" have been found.")
       else if (i == size(val) .and. string_tmp(pos:pos) /= "]") then
          call error_message("Too many values.")
       else if (i < size(val) .and. string_tmp(pos:pos) /= ",") then
          call error_message("Too few values.")
       endif
       call scalar_DPR_val(string_tmp(:pos-1), val(i))
       string_tmp = adjustl(string_tmp(pos+1:))
    enddo

  end subroutine array_DPR_val2

!#======================================================================

  subroutine scalar_logical_val(string, val)

    use mod_strings, only : down_case, unquote_string

    implicit none
    character(len=*), intent(in) :: string
    logical, intent(out) :: val
!#......................................................................
    character(len=long_string) :: string_tmp
    character(len=len(string)) :: other_input
    integer :: pos
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    string_tmp = adjustl(string)
    pos = index(string_tmp, " ")
    if (pos /= 0) then
       other_input = string_tmp(pos+1:)
       if (other_input /= "") call error_message("Something trailing on the line after the value.")
       string_tmp = string_tmp(:pos-1)
    endif

!# The "/" separator and the repetition of values with "*" (although allowed in
!# list-directed formatting) are here forbidden.
    if (index(string_tmp, "/") /= 0) &
         call error_message("""/"" must not be used to separate values. &
         & Use "","" instead.")
    if (index(string_tmp, "*") /= 0) &
         call error_message("""*"" must not be used to repeat values.")

    string_tmp = unquote_string(down_case(string_tmp)) !# Strip possible quotes around boolean.
    if (any(string_tmp == (/".true.", "true  ", "t     ", "yes   ", "y     "/))) then
       val = .true.
    else if (any(string_tmp == (/".false.", "false  ", "f      ", "no     ", "n      "/))) then
       val = .false.
    else
       call error_message("Not a boolean.")
    endif

  end subroutine scalar_logical_val

!#======================================================================

  subroutine array_logical_val(string, val)

    implicit none
    character(len=*), intent(in) :: string
    logical, dimension(:), intent(out) :: val
!#......................................................................
    character(len=len(string)) :: string_tmp
    logical :: scalar
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    string_tmp = adjustl(string)
    if (string_tmp(1:1) == "[") then
       call array_logical_val2(string_tmp, val(:))
    else
       call scalar_logical_val(string_tmp, scalar)
       val(:) = scalar
    endif

  end subroutine array_logical_val

!#======================================================================

  subroutine array_logical_val2(string, val)

    implicit none
    character(len=*), intent(in) :: string
    logical, dimension(:), intent(out) :: val
!#......................................................................
    integer :: i, pos
    character(len=len(string)) :: string_tmp
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    pos = index(string, "[")
    string_tmp = string(pos+1:)
    do i = 1, size(val)
       pos = scan(string_tmp, ",]")
       if (pos == 0) then
          call error_message("Neither "","" nor ""]"" have been found.")
       else if (i == size(val) .and. string_tmp(pos:pos) /= "]") then
          call error_message("Too many values.")
       else if (i < size(val) .and. string_tmp(pos:pos) /= ",") then
          call error_message("Too few values.")
       endif
       call scalar_logical_val(string_tmp(:pos-1), val(i))
       string_tmp = adjustl(string_tmp(pos+1:))
    enddo

  end subroutine array_logical_val2

!#======================================================================

  subroutine scalar_string_val(string, val, pos)

    use mod_strings, only : find_closing_quote

    implicit none
    character(len=*), intent(in) :: string
    character(len=*), intent(out) :: val
    integer, intent(out), optional :: pos
!#......................................................................
    integer :: pos_beg, pos_end
    character(len=len(string)) :: string_tmp, other_input
    character(len=1) :: quote_character
    logical :: quote_found
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    string_tmp = adjustl(string)
    if (string_tmp(1:1) == '"') then
       quote_character = '"'
       pos_beg = index(string, '"')
    else if (string_tmp(1:1) == "'") then
       quote_character = "'"
       pos_beg = index(string, "'")
    else
       quote_character = ""
       pos_beg = verify(string, " ") !# Position of the first non-blank character \
!# (horizontal tabulations already converted to spaces).
    endif

    if (quote_character /= "") then
       pos_end = pos_beg+1
       call find_closing_quote(string, pos_end, quote_character, quote_found)
       if (quote_found) then
          read(string(pos_beg:pos_end), *) val
       else
          if (quote_character == "'") then
             call error_message("The string should end with ""'"".")
          else
             call error_message("The string should end with '""'.")
          endif
       endif
    else
       pos_end = scan(string, " ,]")
       if (pos_end /= 0) then
          val = string(pos_beg:pos_end-1)
       else
          val = string(pos_beg:)
       end if
    endif

    if (present(pos)) then !# `scalar_string_val` called from within \
!# `array_string_val` via `array_string_val2`.
!# Test `other_input` in `array_string_val2` once `]` has been found.
       pos = pos_end+1
    else !# `scalar_string_val` called for a single value.
       other_input = string_tmp(pos_end+1:)
       if (other_input /= "") call error_message("Something trailing on the line after the value.")
    endif

  end subroutine scalar_string_val

!#======================================================================

  subroutine array_string_val(string, val)

    implicit none
    character(len=*), intent(in) :: string
    character(len=*), dimension(:), intent(out) :: val
!#......................................................................
    character(len=len(string)) :: string_tmp, scalar
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    string_tmp = adjustl(string)
    if (string_tmp(1:1) == "[") then
       call array_string_val2(string_tmp, val(:))
    else
       call scalar_string_val(string_tmp, scalar)
       val(:) = scalar
    endif

  end subroutine array_string_val

!#======================================================================

  subroutine array_string_val2(string, val)

    implicit none
    character(len=*), intent(in) :: string
    character(len=*), dimension(:), intent(out) :: val
!#......................................................................
    integer :: i, pos
    character(len=len(string)) :: string_tmp, other_input
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    pos = index(string, "[")
    string_tmp = string(pos+1:)
    do i = 1, size(val)
       call scalar_string_val(string_tmp, val(i), pos)
       if (i == size(val)) then !# Last value; should be followed by "]".
          string_tmp = adjustl(string_tmp(pos:))
          if (string_tmp(1:1) /= "]") call error_message("""]"" not found.")
          other_input = string_tmp(2:)
          if (other_input /= "") &
               call error_message("Something trailing on the line after the last value.")
       else !# Not the last value; should be followed by ",".
          string_tmp = adjustl(string_tmp(pos:))
          if (string_tmp(1:1) == "/") then
!# The "/" separator (although allowed in list-directed formatting) is here forbidden.
!# ??? What about "*"?
             call error_message("""/"" must not be used to separate values. &
                  & Use "","" instead.")
          else if (string_tmp(1:1) /= ",") then
             call error_message(""","" not found.")
          else
             string_tmp = string_tmp(2:)
          endif
       endif
    enddo

  end subroutine array_string_val2

!#======================================================================

  subroutine array_integer_key(array, rhs, indices_string, index_present)

    implicit none
    integer, dimension(:), intent(out) :: array
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
    logical, dimension(size(array)), intent(out) :: index_present
!#......................................................................
    logical :: scalar_key
    integer :: index_number, i
    integer, dimension(size(array)) :: index_val
    integer, dimension(size(array)) :: array_tmp
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (indices_string /= "") then
       call read_indices(indices_string, index_present, index_number, &
            index_val, scalar_key)
    else
       scalar_key = .false.
       index_present(1) = .true.
       index_present(2:) = .false.
       index_number = 1
       index_val(1) = 1
    endif

    if (scalar_key) then
       call scalar_integer_val(rhs, array(index_val(1)))
    else
       call array_integer_val(rhs, array_tmp(1:index_number))
       do i = 1, index_number
          array(index_val(i)) = array_tmp(i)
       enddo
    endif

  end subroutine array_integer_key

!#======================================================================

  subroutine array_SPR_key(array, rhs, indices_string, index_present)

    use mod_types

    implicit none
    real(SPR), dimension(:), intent(out) :: array
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
    logical, dimension(size(array)), intent(out) :: index_present
!#......................................................................
    logical :: scalar_key
    integer :: index_number, i
    integer, dimension(size(array)) :: index_val
    real(SPR), dimension(size(array)) :: array_tmp
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (indices_string /= "") then
       call read_indices(indices_string, index_present, index_number, &
            index_val, scalar_key)
    else
       scalar_key = .false.
       index_present(1) = .true.
       index_present(2:) = .false.
       index_number = 1
       index_val(1) = 1
    endif

    if (scalar_key) then
       call scalar_SPR_val(rhs, array(index_val(1)))
    else
       call array_SPR_val(rhs, array_tmp(1:index_number))
       do i = 1, index_number
          array(index_val(i)) = array_tmp(i)
       enddo
    endif

  end subroutine array_SPR_key

!#======================================================================

  subroutine array_DPR_key(array, rhs, indices_string, index_present)

    use mod_types

    implicit none
    real(DPR), dimension(:), intent(out) :: array
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
    logical, dimension(size(array)), intent(out) :: index_present
!#......................................................................
    logical :: scalar_key
    integer :: index_number, i
    integer, dimension(size(array)) :: index_val
    real(DPR), dimension(size(array)) :: array_tmp
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (indices_string /= "") then
       call read_indices(indices_string, index_present, index_number, &
            index_val, scalar_key)
    else
       scalar_key = .false.
       index_present(1) = .true.
       index_present(2:) = .false.
       index_number = 1
       index_val(1) = 1
    endif

    if (scalar_key) then
       call scalar_DPR_val(rhs, array(index_val(1)))
    else
       call array_DPR_val(rhs, array_tmp(1:index_number))
       do i = 1, index_number
          array(index_val(i)) = array_tmp(i)
       enddo
    endif

  end subroutine array_DPR_key

!#======================================================================

  subroutine array_logical_key(array, rhs, indices_string, index_present)

    implicit none
    logical, dimension(:), intent(out) :: array
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
    logical, dimension(size(array)), intent(out) :: index_present
!#......................................................................
    logical :: scalar_key
    integer :: index_number, i
    integer, dimension(size(array)) :: index_val
    logical, dimension(size(array)) :: array_tmp
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (indices_string /= "") then
       call read_indices(indices_string, index_present, index_number, &
            index_val, scalar_key)
    else
       scalar_key = .false.
       index_present(1) = .true.
       index_present(2:) = .false.
       index_number = 1
       index_val(1) = 1
    endif

    if (scalar_key) then
       call scalar_logical_val(rhs, array(index_val(1)))
    else
       call array_logical_val(rhs, array_tmp(1:index_number))
       do i = 1, index_number
          array(index_val(i)) = array_tmp(i)
       enddo
    endif

  end subroutine array_logical_key

!#======================================================================

  subroutine array_string_key(array, rhs, indices_string, index_present)

    implicit none
    character(len=*), dimension(:), intent(out) :: array
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
    logical, dimension(size(array)), intent(out) :: index_present
!#......................................................................
    logical :: scalar_key
    integer :: index_number, i
    integer, dimension(size(array)) :: index_val
    character(len=len(array)), dimension(size(array)) :: array_tmp
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (indices_string /= "") then
       call read_indices(indices_string, index_present, index_number, &
            index_val, scalar_key)
    else
       scalar_key = .false.
       index_present(1) = .true.
       index_present(2:) = .false.
       index_number = 1
       index_val(1) = 1
    endif

    if (scalar_key) then
       call scalar_string_val(rhs, array(index_val(1)))
    else
       call array_string_val(rhs, array_tmp(1:index_number))
       do i = 1, index_number
          array(index_val(i)) = array_tmp(i)
       enddo
    endif

  end subroutine array_string_key

!#======================================================================

  subroutine scalar_integer_key(scalar, rhs)

    implicit none
    integer, intent(out) :: scalar
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call scalar_integer_val(rhs, scalar)

  end subroutine scalar_integer_key

!#======================================================================

  subroutine scalar_SPR_key(scalar, rhs)

    use mod_types

    implicit none
    real(SPR), intent(out) :: scalar
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call scalar_SPR_val(rhs, scalar)

  end subroutine scalar_SPR_key

!#======================================================================

  subroutine scalar_DPR_key(scalar, rhs)

    use mod_types

    implicit none
    real(DPR), intent(out) :: scalar
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call scalar_DPR_val(rhs, scalar)

  end subroutine scalar_DPR_key

!#======================================================================

  subroutine scalar_logical_key(scalar, rhs)

    implicit none
    logical, intent(out) :: scalar
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call scalar_logical_val(rhs, scalar)

  end subroutine scalar_logical_key

!#======================================================================

  subroutine scalar_string_key(scalar, rhs)

    implicit none
    character(len=*), intent(out) :: scalar
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call scalar_string_val(rhs, scalar)

  end subroutine scalar_string_key

!#======================================================================

  subroutine error_message(message)

    implicit none
    character(len=*), intent(in) :: message
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (unit_log > 0) write(unit_log, "(a,i0,2(a/),a)") "Error: file """ // &
         trim(file_name) // """, line ", line_number, ": ", &
         trim(adjustl(message)), "Stopped."
    write(*, "(a,i0,2(a/),a)") "Error: file """ // trim(file_name) // """, line ", &
         line_number, ": ", trim(adjustl(message)), "Stopped."
    stop

  end subroutine error_message

!#======================================================================

  subroutine warning_message(message)

    implicit none
    character(len=*), intent(in) :: message
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (unit_log > 0) write(unit_log, "(a,i0,a/a)") &
         "Warning: file """ // trim(file_name) // &
         """, line ", line_number, ": ", trim(adjustl(message))
    write(*, "(a,i0,a/a)") "Warning: file """ // trim(file_name) // &
         """, line ", line_number, ": ", trim(adjustl(message))

  end subroutine warning_message

end module mod_analyze_statement

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_read_other_param
  
  use mod_types
  use mod_linked_list
  use mod_analyze_statement, only : get_val, error_message
  use mod_parse_file, only : len_max_statement
  use mod_random, only : dim_seed, seed

  implicit none
  public
  character(len=std_string), save :: SSPs_set
  real(CDR), save :: ISM_init_Z
  real(CDR), save :: close_bin_frac
  integer, save :: verbosity

  logical, save :: new_statement
  logical, save :: check_only
  character(len=std_string), save :: scenarios_file = ""

!# Variables for which no default value exists.

  logical, private :: SSPs_set_set

contains

!#======================================================================
  
  subroutine reset_others !# ??? And for `seed`?

    use mod_spectra_def_param
    implicit none
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    SSPs_set_set = .false.
    check_only = check_only_def
    ISM_init_Z = ISM_init_Z_def
    close_bin_frac = close_bin_frac_def
    verbosity = verbosity_def

  end subroutine reset_others
  
!#======================================================================

  subroutine read_other_param_check

    implicit none

    if (.not. SSPs_set_set) then
       write(*, "(a,i0,a)") "Value of `SSPs_set` is unknown. Stopped."
       stop
    endif

  end subroutine read_other_param_check

!#======================================================================

  subroutine read_SSPs_set_name(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SSPs_set, rhs)
    SSPs_set_set = .true.

  end subroutine read_SSPs_set_name

!#======================================================================

  subroutine read_ISM_init_Z(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(ISM_init_Z, rhs)

  end subroutine read_ISM_init_Z

!#======================================================================

  subroutine read_close_bin_frac(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(close_bin_frac, rhs)

  end subroutine read_close_bin_frac

!#======================================================================
  
  subroutine read_verbosity(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(verbosity, rhs)
    
  end subroutine read_verbosity

!#======================================================================

  subroutine read_seed(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(dim_seed) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(seed, rhs, indices_string, index_present) 
    if (.not.all(index_present)) then
       call error_message("The assignment to `seed` must be provided as &
            &`seed(1:^dim_seed^) = [^seeds^]`, where &
            &(1) ^dim_seed^ is the size of the array `seed` and &
            &(2) ^seeds^ is the full list of the elements of `seed`, separated by commas. &
            &All these values are integer literals.")
    endif
    call random_seed(put = seed)
    
  end subroutine read_seed

end module mod_read_other_param

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_read_file_list

  implicit none
  private
  public :: read_file_list

contains

!#======================================================================
  
  subroutine read_file_list(dir, list, file, n_files, exist_warning, back)

!# Reads from file `list` a list of file names, `file(1)`, ..., `file(n_files)`;
!# all these files must be in directory `dir`.

    use mod_types
    use mod_linked_list
    use mod_file_access, only : open_file, skip_comment_lines, close_file, &
         path_file
    use mod_remove_duplicates, only : remove_duplicates
    
    implicit none
    character(len=*), intent(in) :: dir
    character(len=*), intent(in) :: list
    character(len=*), dimension(:), pointer :: file
    integer, intent(out) :: n_files
    logical, intent(in), optional :: exist_warning
    logical, intent(in), optional :: back
!#......................................................................
    integer :: unit, error
    logical :: exist, exist_warning_eff, back_eff
    character(len=std_string) :: string
    type(lk_lst_std_string) :: head_node
    type(lk_lst_std_string), pointer :: current_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(exist_warning)) then
       exist_warning_eff = exist_warning
    else
       exist_warning_eff = .false.
    endif

    if (present(back)) then
       back_eff = back
    else
       back_eff = .false.
    endif

!    call open_file(unit, dir // list)
    call open_file(unit, path_file(dir, list))
    n_files = 0
    call lk_lst_initialize(head_node)
    do
       read(unit, *, iostat = error) string
       if (error /= 0) exit
       string = adjustl(string)
       if (string == "" .or. string(1:1) == "!") cycle
!       inquire(file = dir // string, exist = exist)
       inquire(file = path_file(dir, string), exist = exist)
       if (exist) then
          n_files = n_files+1
          call lk_lst_new_node(head_node, current_node)
          current_node % val = string
       else
          if (exist_warning_eff) write(*, "(a)") "Warning: file """ // &
               trim(string) // """ listed in """ // trim(list) // """ does not exist."
       endif
    enddo
    call close_file(unit)

    call lk_lst_to_array(head_node, file, n_files)

    call remove_duplicates(file, n_files, back = back_eff)

  end subroutine read_file_list

end module mod_read_file_list

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_filters_constants

  use mod_types

  implicit none
  private
  
  character(len=*), parameter :: filters_list = "list_filters.txt"

!# Value used in "calib.f90" and "colors.f90" for undefined magnitudes and colors.
  real(DPR), parameter :: undefined_mag = 99.999_DPR

!# Minimal resolution for filter passbands:
  real(DPR), parameter :: filter_min_resol = 300._DPR

!# Standard magnitude of Vega:
  real(DPR), parameter :: std_Vega_def = 0.03_DPR

!# SED used for Vega:
  character(len=*), parameter :: Vega_SED_file = "Vega_BaSeL_SED.txt" !# From the BaSeL library.

!# SED used for the Sun:
  character(len=*), parameter :: Sun_SED_file = "Sun_BaSeL_SED.txt" !# From the BaSeL library.

!# SED of the faint subdwarf BD+17°4708 used to calibrate the Thuan & Gunn photometric system:
  character(len=*), parameter :: TG_SED_file = "BD+17d4708_SED.txt"

!# Bolometric magnitude of the Sun:
  real(DPR), parameter :: M_bol_Sun = 4.74_DPR
!# (Resolution B2 of the 29th general assembly of the International Astronomical Union.)

  public :: filters_list, undefined_mag, filter_min_resol, std_Vega_def, &
       Vega_SED_file, Sun_SED_file, TG_SED_file, M_bol_Sun

end module mod_filters_constants

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_extinction

  private
  public :: compute_opacity_DISM, compute_opacity_SFC, &
       compute_RF_DISM, compute_RF_SFC, &
       dust_optical_properties, attenuate_DISM

contains

!#======================================================================

  subroutine compute_opacity_DISM(ISM_mass, dim_cont, lambda_cont, &
       dim_line, lambda_line, i_Lyman_alpha, M_dust, carb_abund, sil_abund, &
       dim_species, grain_abs, &
       species_weight, tau_V, King, slab, disk, bulge, &
       cont_trans_DISM_tot, cont_trans_DISM_incl, &
       line_trans_DISM_tot, line_trans_DISM_incl, &
       opt_depth_warn_present, opt_depth_warn_min_lambda, opt_depth_warn_max_lambda, &
       kappa_abs_cont, kappa_abs_line, ISM_over_H)

    use mod_types
    use mod_interp, only : Steffen3, Steffen4
    use mod_constants, only : M_sol, H_atom_mass, &
         pi, parsec
    use mod_spectra_constants, only : King_factor, lambda_V
    use mod_RT, only : struct_RT_sph_sym, struct_RT_cyl_sym
    use mod_read_dust_transfer_param, only : bulge_tot_ratio, M_sys_spiral, &
         expo_radius, M_sys_spher, core_radius, extinction_DISM, geometry, &
         inclin_averaged, inclination, slab_factor
    use mod_grain_properties, only : struct_grain_abs

    implicit none
    real(CDR), intent(in) :: ISM_mass
    integer, intent(in) :: dim_cont, dim_line
    real(CDR), dimension(:), intent(in) :: lambda_cont
    real(CDR), dimension(:), intent(in) :: lambda_line
    real(CDR), intent(out) :: M_dust
    integer, intent(in) :: dim_species
    type(struct_grain_abs), dimension(:), intent(in) :: grain_abs
    real(CDR), intent(in) :: carb_abund, sil_abund
    real(CDR), dimension(:), intent(in) :: species_weight
    real(CDR), intent(out) :: tau_V
    real(CDR), intent(in) :: ISM_over_H
    integer, intent(in) :: i_Lyman_alpha

    type(struct_RT_sph_sym), intent(in) :: King
    type(struct_RT_cyl_sym), intent(in) :: slab, disk, bulge

    real(CDR), dimension(:), intent(out) :: cont_trans_DISM_tot, cont_trans_DISM_incl
    real(CDR), dimension(:), intent(out) :: line_trans_DISM_tot, line_trans_DISM_incl
    logical, intent(inout) :: opt_depth_warn_present
    real(CDR), intent(inout) :: opt_depth_warn_min_lambda, opt_depth_warn_max_lambda
    real(CDR), dimension(:), intent(out) :: kappa_abs_cont, kappa_abs_line
!#......................................................................
    real(CDR) :: H_col_dens, dust_col_dens, albedo, asym, tau
    integer :: i_cont, i_line, i_bracket1, i_bracket2, i_bracket3, i_bracket4
    real(CDR) :: kappa_ext, ln_trans
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Extinction.

    tau_V = 0
    M_dust = 0
    cont_trans_DISM_tot(:) = 1
    cont_trans_DISM_incl(:) = 1
    line_trans_DISM_tot(:) = 1
    line_trans_DISM_incl(:) = 1
    kappa_abs_cont(:) = 0
    kappa_abs_line(:) = 0
    opt_depth_warn_min_lambda = lambda_cont(dim_cont)
    opt_depth_warn_max_lambda = lambda_cont(1)
    if (extinction_DISM) then
       if ((carb_abund > 0 .or. sil_abund > 0) .and. ISM_mass > 0) then !# `M_dust` > 0.

!# Mass fraction of dust components and dust mass in grams.
!# !!! The mass of dust in star-forming clouds is not subtracted.
          M_dust = (carb_abund+sil_abund)*ISM_mass*M_sol

!# Dust column density in g.cm^-2.

          if (geometry == "spheroidal") then
             dust_col_dens = King_factor* &
                  real(M_dust, DPR) & !# To avoid overflows.
                  *M_sys_spher/(core_radius*parsec)**2
          else if (geometry == "spiral") then
             dust_col_dens = real(M_dust, DPR) & !# To avoid overflows.
                  *M_sys_spiral/(2*pi*(expo_radius*parsec)**2)
          else if (geometry == "slab") then
             H_col_dens = slab_factor*ISM_mass
             dust_col_dens = (carb_abund+sil_abund)*H_col_dens &
                  *H_atom_mass*ISM_over_H
          else
             write(*, "(a)") "`geometry` """ // trim(geometry) // &
                  """ is undefined. Stopped."
             stop
          endif

          call dust_optical_properties(dim_species, grain_abs, &
               lambda_V, species_weight, kappa_ext, albedo, asym)
          tau_V = kappa_ext*dust_col_dens

          i_bracket1 = 0
          i_bracket2 = 0
          i_bracket3 = 0
          i_bracket4 = 0

!# Continuum, total.

          do i_cont = 1, dim_cont
             call dust_optical_properties(dim_species, grain_abs, &
                  lambda_cont(i_cont), species_weight, kappa_ext, albedo, asym)

             tau = kappa_ext*dust_col_dens
             kappa_abs_cont(i_cont) = kappa_ext*(1-albedo)

             if (geometry == "spheroidal") then
                if (tau > King % tau(King % dim_tau)) then
                   opt_depth_warn_min_lambda = min(opt_depth_warn_min_lambda, &
                        lambda_cont(i_cont))
                   opt_depth_warn_max_lambda = max(opt_depth_warn_max_lambda, &
                        lambda_cont(i_cont))
                   opt_depth_warn_present = .true.
                endif
                call Steffen3(King % tau, King % alb, King % asym, King % ln_trans_tot, &
                     King % dim_tau, King % dim_alb, King % dim_asym, tau, albedo, asym, &
                     ln_trans, i_bracket1, i_bracket2, i_bracket3)
                cont_trans_DISM_tot(i_cont) = exp(ln_trans)

             else if (geometry == "spiral") then
                if (tau > disk % tau(disk % dim_tau) .or. &
                     tau > bulge % tau(bulge % dim_tau)) then
                   opt_depth_warn_min_lambda = min(opt_depth_warn_min_lambda, &
                        lambda_cont(i_cont))
                   opt_depth_warn_max_lambda = max(opt_depth_warn_max_lambda, &
                        lambda_cont(i_cont))
                   opt_depth_warn_present = .true.
                   write(*,*) "spiral", tau, disk % tau(disk % dim_tau), &
                        bulge % tau(bulge % dim_tau), kappa_ext, &
                        dust_col_dens, M_dust, carb_abund, sil_abund, &
                        ISM_mass, M_sys_spiral, expo_radius, parsec, &
                        M_dust*M_sys_spiral
                   stop
                endif
                call Steffen3(disk % tau, disk % alb, disk % asym, disk % ln_trans_tot, &
                     disk % dim_tau, disk % dim_alb, disk % dim_asym, tau, albedo, asym, &
                     ln_trans, i_bracket1, i_bracket2, i_bracket3)
                cont_trans_DISM_tot(i_cont) = &
                     exp(ln_trans)*(1-bulge_tot_ratio)

                call Steffen3(bulge % tau, bulge % alb, bulge % asym, bulge % ln_trans_tot, &
                     bulge % dim_tau, bulge % dim_alb, bulge % dim_asym, tau, albedo, &
                     asym, ln_trans, i_bracket1, i_bracket2, i_bracket3)
                cont_trans_DISM_tot(i_cont) = &
                     cont_trans_DISM_tot(i_cont) + &
                     exp(ln_trans)*bulge_tot_ratio

             else if (geometry == "slab") then
                if (tau > slab % tau(slab % dim_tau)) then
                   opt_depth_warn_min_lambda = min(opt_depth_warn_min_lambda, &
                        lambda_cont(i_cont))
                   opt_depth_warn_max_lambda = max(opt_depth_warn_max_lambda, &
                        lambda_cont(i_cont))
                   opt_depth_warn_present = .true.
                endif
                call Steffen3(slab % tau, slab % alb, slab % asym, slab % ln_trans_tot, &
                     slab % dim_tau, slab % dim_alb, slab % dim_asym, tau, albedo, asym, &
                     ln_trans, i_bracket1, i_bracket2, i_bracket3)
                cont_trans_DISM_tot(i_cont) = exp(ln_trans)
             endif

!# Continuum, inclined.

             if (.not.inclin_averaged) then
                if (geometry == "spiral") then
                   if (tau > disk % tau(disk % dim_tau) .or. &
                        tau > bulge % tau(bulge % dim_tau)) then
                      opt_depth_warn_min_lambda = min(opt_depth_warn_min_lambda, &
                           lambda_cont(i_cont))
                      opt_depth_warn_max_lambda = max(opt_depth_warn_max_lambda, &
                           lambda_cont(i_cont))
                      opt_depth_warn_present = .true.
                   endif

!# Variable `null_deriv_at_0` is set to `.true.`
!# for the inner call of `Steffen` by subroutine `Steffen4`:
!# there, `x` is the inclination of the galaxy (`x = 0` means
!# face-on) and `y` is the fraction of light emerging in this
!# direction.
                   call Steffen4(disk % tau, disk % alb, disk % asym, disk % inclin, &
                        disk % ln_trans_incl, disk % dim_tau, disk % dim_alb, &
                        disk % dim_asym, &
                        disk % dim_inclin, tau, albedo, asym, inclination, &
                        ln_trans, i_bracket1, i_bracket2, i_bracket3, i_bracket4, null_deriv_at_0=.true.)
                   cont_trans_DISM_incl(i_cont) = &
                        exp(ln_trans)*(1-bulge_tot_ratio)

                   call Steffen4(bulge % tau, bulge % alb, bulge % asym, &
                        bulge % inclin, bulge % ln_trans_incl, bulge % dim_tau, &
                        bulge % dim_alb, bulge % dim_asym, &
                        bulge % dim_inclin, tau, albedo, asym, inclination, &
                        ln_trans, i_bracket1, i_bracket2, i_bracket3, i_bracket4, null_deriv_at_0=.true.)
                   cont_trans_DISM_incl(i_cont) = &
                        cont_trans_DISM_incl(i_cont) + &
                        exp(ln_trans)*bulge_tot_ratio

                else if (geometry == "slab") then
                   if (tau > slab % tau(slab % dim_tau)) then
                      opt_depth_warn_min_lambda = min(opt_depth_warn_min_lambda, &
                           lambda_cont(i_cont))
                      opt_depth_warn_max_lambda = max(opt_depth_warn_max_lambda, &
                           lambda_cont(i_cont))
                      opt_depth_warn_present = .true.
                   endif

!# Variable `null_deriv_at_0` is set to `.true.`
!# for the inner call of `Steffen` by subroutine `Steffen4`:
!# there, `x` is the inclination of the galaxy (`x = 0` means
!# face-on) and `y` is the fraction of light emerging in this
!# direction.
                   call Steffen4(slab % tau, slab % alb, slab % asym, slab % inclin, &
                        slab % ln_trans_incl, slab % dim_tau, slab % dim_alb, &
                        slab % dim_asym, slab % dim_inclin, tau, albedo, asym, &
                        inclination, ln_trans, i_bracket1, i_bracket2, i_bracket3, i_bracket4, null_deriv_at_0=.true.)
                   cont_trans_DISM_incl(i_cont) = exp(ln_trans)
                endif
             else
                cont_trans_DISM_incl(i_cont) = cont_trans_DISM_tot(i_cont)
             endif
          enddo

!# Lines, total.

          do i_line = 1, dim_line
             i_bracket1 = 0
             i_bracket2 = 0
             i_bracket3 = 0
             i_bracket4 = 0
             call dust_optical_properties(dim_species, grain_abs, lambda_line(i_line), species_weight, kappa_ext, albedo, asym)

             tau = kappa_ext*dust_col_dens
             kappa_abs_line(i_line) = kappa_ext*(1-albedo)
             if (geometry == "spheroidal") then
                if (tau > King % tau(King % dim_tau)) then
                   opt_depth_warn_min_lambda = min(opt_depth_warn_min_lambda, &
                        lambda_line(i_line))
                   opt_depth_warn_max_lambda = max(opt_depth_warn_max_lambda, &
                        lambda_line(i_line))
                   opt_depth_warn_present = .true.
                endif
                call Steffen3(King % tau, King % alb, King % asym, King % ln_trans_tot, &
                     King % dim_tau, King % dim_alb, King % dim_asym, tau, albedo, asym, &
                     ln_trans, i_bracket1, i_bracket2, i_bracket3)
                line_trans_DISM_tot(i_line) = exp(ln_trans)

             else if (geometry == "spiral") then
                if (tau > disk % tau(disk % dim_tau) .or. &
                     tau > bulge % tau(bulge % dim_tau)) then
                   opt_depth_warn_min_lambda = min(opt_depth_warn_min_lambda, &
                        lambda_line(i_line))
                   opt_depth_warn_max_lambda = max(opt_depth_warn_max_lambda, &
                        lambda_line(i_line))
                   opt_depth_warn_present = .true.
                endif

                call Steffen3(disk % tau, disk % alb, disk % asym, disk % ln_trans_tot, &
                     disk % dim_tau, disk % dim_alb, disk % dim_asym, tau, albedo, asym, &
                     ln_trans, i_bracket1, i_bracket2, i_bracket3)
                line_trans_DISM_tot(i_line) = &
                     exp(ln_trans)*(1-bulge_tot_ratio)

                call Steffen3(bulge % tau, bulge % alb, bulge % asym, bulge % ln_trans_tot, &
                     bulge % dim_tau, bulge % dim_alb, bulge % dim_asym, tau, albedo, &
                     asym, ln_trans, i_bracket1, i_bracket2, i_bracket3)
                line_trans_DISM_tot(i_line) = &
                     line_trans_DISM_tot(i_line) + &
                     exp(ln_trans)*bulge_tot_ratio

             else if (geometry == "slab") then
                if (tau > slab % tau(slab % dim_tau)) then
                   opt_depth_warn_min_lambda = min(opt_depth_warn_min_lambda, &
                        lambda_line(i_line))
                   opt_depth_warn_max_lambda = max(opt_depth_warn_max_lambda, &
                        lambda_line(i_line))
                   opt_depth_warn_present = .true.
                endif
                call Steffen3(slab % tau, slab % alb, slab % asym, slab % ln_trans_tot, &
                     slab % dim_tau, slab % dim_alb, slab % dim_asym, tau, albedo, asym, &
                     ln_trans, i_bracket1, i_bracket2, i_bracket3)
                line_trans_DISM_tot(i_line) = exp(ln_trans)
             endif

!# Lines, inclined.

             if (.not.inclin_averaged) then
                if (geometry == "spiral") then
                   if (tau > disk % tau(disk % dim_tau) .or. &
                        tau > bulge % tau(bulge % dim_tau)) then
                      opt_depth_warn_min_lambda = min(opt_depth_warn_min_lambda, &
                           lambda_line(i_line))
                      opt_depth_warn_max_lambda = max(opt_depth_warn_max_lambda, &
                           lambda_line(i_line))
                      opt_depth_warn_present = .true.
                   endif

!# Variable `null_deriv_at_0` is set to `.true.`
!# for the inner call of `Steffen` by subroutine `Steffen4`:
!# there, `x` is the inclination of the galaxy (`x = 0` means
!# face-on) and `y` is the fraction of light emerging in this
!# direction.
                   call Steffen4(disk % tau, disk % alb, disk % asym, disk % inclin, &
                        disk % ln_trans_incl, disk % dim_tau, disk % dim_alb, &
                        disk % dim_asym, disk % dim_inclin, tau, albedo, asym, &
                        inclination, ln_trans, i_bracket1, i_bracket2, i_bracket3, i_bracket4, null_deriv_at_0=.true.)
                   line_trans_DISM_incl(i_line) = &
                        exp(ln_trans)*(1-bulge_tot_ratio)

                   call Steffen4(bulge % tau, bulge % alb, bulge % asym, &
                        bulge % inclin, bulge % ln_trans_incl, bulge % dim_tau, &
                        bulge % dim_alb, bulge % dim_asym, &
                        bulge % dim_inclin, tau, albedo, asym, inclination, &
                        ln_trans, i_bracket1, i_bracket2, i_bracket3, i_bracket4, null_deriv_at_0=.true.)
                   line_trans_DISM_incl(i_line) = &
                        line_trans_DISM_incl(i_line) + &
                        exp(ln_trans)*bulge_tot_ratio

                else if (geometry == "slab") then
                   if (tau > slab % tau(slab % dim_tau)) then
                      opt_depth_warn_min_lambda = min(opt_depth_warn_min_lambda, &
                           lambda_line(i_line))
                      opt_depth_warn_max_lambda = max(opt_depth_warn_max_lambda, &
                           lambda_line(i_line))
                      opt_depth_warn_present = .true.
                   endif

!# Variable `null_deriv_at_0` is set to `.true.`
!# for the inner call of `Steffen` by subroutine `Steffen4`:
!# there, `x` is the inclination of the galaxy (`x = 0` means
!# face-on) and `y` is the fraction of light emerging in this
!# direction.
                   call Steffen4(slab % tau, slab % alb, slab % asym, slab % inclin, &
                        slab % ln_trans_incl, slab % dim_tau, slab % dim_alb, &
                        slab % dim_asym, slab % dim_inclin, tau, albedo, asym, &
                        inclination, ln_trans, i_bracket1, i_bracket2, i_bracket3, i_bracket4, null_deriv_at_0=.true.)
                   line_trans_DISM_incl(i_line) = exp(ln_trans)
                endif
             else
                line_trans_DISM_incl(i_line) = line_trans_DISM_tot(i_line)
             endif
          enddo

!# For Lyman alpha with `extinction_DISM = .true.` and `M_dust > 0`:
          line_trans_DISM_tot(i_Lyman_alpha) = 0
          line_trans_DISM_incl(i_Lyman_alpha) = 0

       endif
    endif

  end subroutine compute_opacity_DISM

!#======================================================================

  subroutine compute_opacity_SFC(dim_cont, lambda_cont, dim_line, lambda_line, &
       M_dust_SFC, carb_abund, sil_abund, dim_species, grain_abs, &
       species_weight, kappa_abs_cont, kappa_abs_line, lum_cont, lum_cont_unatt, &
       L_line, L_line_unatt, cont_trans_SFC, line_trans_SFC)

    use mod_types
    use mod_read_dust_transfer_param, only : extinction_SFC
    use mod_grain_properties, only : struct_grain_abs

    implicit none
    integer, intent(in) :: dim_cont, dim_line
    real(CDR), dimension(:), intent(in) :: lambda_cont
    real(CDR), dimension(:), intent(in) :: lambda_line
    real(CDR), intent(in) :: M_dust_SFC
    integer, intent(in) :: dim_species
    type(struct_grain_abs), dimension(:), intent(in) :: grain_abs
    real(CDR), intent(in) :: carb_abund, sil_abund
    real(CDR), dimension(:), intent(in) :: species_weight
    real(CDR), dimension(:), intent(out) :: kappa_abs_cont, kappa_abs_line
    real(CDR), dimension(:), intent(in) :: lum_cont, lum_cont_unatt, &
         L_line, L_line_unatt
    real(CDR), dimension(:), intent(out) :: cont_trans_SFC, line_trans_SFC
!#......................................................................
    real(CDR) :: albedo, asym
    integer :: i_cont, i_line
    real(CDR) :: kappa_ext
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Extinction.

    cont_trans_SFC(:) = 1 !# `cont_trans_SFC` is used only to assess the effects of self-absorption.
    line_trans_SFC(:) = 1 !# `line_trans_SFC` is not used elsewhere.
    kappa_abs_cont(:) = 0
    kappa_abs_line(:) = 0

    if (extinction_SFC) then
       if (carb_abund > 0 .or. sil_abund > 0) then
!# !!! Does not depend on the mass of the diffuse ISM, `ISM_mass`. It is assumed
!# that even if the diffuse ISM has been entirely removed by star formation or
!# outflow, there is always enough residual ISM in the star-forming region so
!# that the HII region is ionization bounded.

          if (M_dust_SFC > 0) then
             do i_cont = 1, dim_cont
                call dust_optical_properties(dim_species, grain_abs, &
                     lambda_cont(i_cont), species_weight, kappa_ext, albedo, asym)

                kappa_abs_cont(i_cont) = kappa_ext*(1-albedo)

                if (lum_cont_unatt(i_cont) > 0) then
                   cont_trans_SFC(i_cont) = &
                        lum_cont(i_cont) / lum_cont_unatt(i_cont)
                else if (lum_cont_unatt(i_cont) == 0) then
                   cont_trans_SFC(i_cont) = 0
                endif
             enddo

             do i_line = 1, dim_line
                call dust_optical_properties(dim_species, grain_abs, &
                     lambda_line(i_line), species_weight, kappa_ext, albedo, asym)

                kappa_abs_line(i_line) = kappa_ext*(1-albedo)

                if (L_line_unatt(i_line) > 0) line_trans_SFC(i_line) = &
                     L_line(i_line) / L_line_unatt(i_line)
             enddo
          endif
       endif
    endif

  end subroutine compute_opacity_SFC

!#======================================================================

  subroutine compute_RF_SFC(dim_cont, dim_line, dim_species, &
       grain_abs, kappa_abs_cont, kappa_abs_line, &
       lambda_cont, lambda_line, M_dust_SFC, lum_cont, lum_cont_unatt, &
       L_line, L_line_unatt, &
       L_dust_SFC, RF_SFC, RF_cont_SFC, RF_line_SFC, &
       T_CBR)

    use mod_types
    use mod_constants, only : c_cm
    use mod_black_body, only : pi_B_lambda
    use mod_grain_properties, only : struct_grain_abs

    implicit none
    integer, intent(in) :: dim_cont, dim_line, dim_species
    real(CDR), dimension(:), intent(in) :: kappa_abs_cont, kappa_abs_line, &
         lambda_cont, lambda_line
    type(struct_grain_abs), dimension(:), intent(in) :: grain_abs
    real(CDR), intent(in) :: M_dust_SFC
    real(CDR), dimension(:), intent(in) :: lum_cont, L_line, &
         lum_cont_unatt, L_line_unatt
    real(CDR), intent(out) :: L_dust_SFC
    type(irreg_array_CDR), dimension(:), pointer :: RF_SFC
    real(CDR), dimension(:), intent(out) :: RF_cont_SFC
    real(CDR), dimension(:), intent(out) :: RF_line_SFC
    real(CDR), intent(in), optional :: T_CBR
!#......................................................................
    integer :: i_cont, i_line, i_species, dim_lambda_grains
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    L_dust_SFC = 0
    do i_cont = 1, dim_cont
       if (kappa_abs_cont(i_cont) > 0 .and. M_dust_SFC > 0) then
          RF_cont_SFC(i_cont) = max(lum_cont_unatt(i_cont)-lum_cont(i_cont), 0._CDR)/ & !# ???
               kappa_abs_cont(i_cont)/M_dust_SFC/c_cm
       else
          RF_cont_SFC(i_cont) = 0
       endif

       if (i_cont < dim_cont) L_dust_SFC = L_dust_SFC &
            + ((lum_cont_unatt(i_cont)+lum_cont_unatt(i_cont+1))- &
            (lum_cont(i_cont)+lum_cont(i_cont+1))) * (lambda_cont(i_cont+1)-lambda_cont(i_cont))/2
    enddo

    do i_line = 1, dim_line
       if (kappa_abs_line(i_line) > 0 .and. M_dust_SFC > 0) then
          RF_line_SFC(i_line) = (L_line_unatt(i_line)-L_line(i_line))/ &
               kappa_abs_line(i_line)/M_dust_SFC/c_cm
       else
          RF_line_SFC(i_line) = 0
       endif
       L_dust_SFC = L_dust_SFC+L_line_unatt(i_line)-L_line(i_line)
    enddo

    if (present(T_CBR)) then
       RF_cont_SFC(1:dim_cont) = RF_cont_SFC(1:dim_cont) &
            + 4*pi_B_lambda(T_CBR, lambda_cont(1:dim_cont))/c_cm !# erg.um-1.cm-3
    endif

    if (associated(RF_SFC)) then
       do i_species = 1, size(RF_SFC)
          if (associated(RF_SFC(i_species) % val)) deallocate(RF_SFC(i_species) % val)
       enddo
       deallocate(RF_SFC)
    endif
    allocate(RF_SFC(dim_species))

    do i_species = 1, dim_species
       dim_lambda_grains = grain_abs(i_species) % dim_lambda
       if (associated(RF_SFC(i_species) % val)) deallocate(RF_SFC(i_species) % val)
       allocate(RF_SFC(i_species) % val(dim_lambda_grains))
       call rebin_RF(dim_cont, dim_line, lambda_cont, lambda_line, RF_cont_SFC, &
            RF_line_SFC, dim_lambda_grains, grain_abs(i_species) % lambda_interm(:), &
            RF_SFC(i_species) % val(:))
    enddo

  end subroutine compute_RF_SFC

!#======================================================================
!# ??? `M_dust_SFC` should not be used here. Use instead
!# `cont_trans_DISM_tot` and `line_trans_DISM_tot` for all continuum
!# wavelengths and emission lines.

  subroutine compute_RF_DISM(dim_cont, dim_line, dim_species, &
       grain_abs, kappa_abs_cont, kappa_abs_line, &
       lambda_cont, lambda_line, L_dust_SFC, M_dust, &
       lum_cont, L_line, cont_trans_DISM_tot, &
       line_trans_DISM_tot, L_dust_DISM, L_dust, RF_DISM, RF_cont_DISM, RF_line_DISM, &
       T_CBR)

    use mod_types
    use mod_constants, only : c_cm
    use mod_black_body, only : pi_B_lambda
    use mod_grain_properties, only : struct_grain_abs

    implicit none
    integer, intent(in) :: dim_cont, dim_line, dim_species
    real(CDR), dimension(:), intent(in) :: kappa_abs_cont, kappa_abs_line, &
         lambda_cont, lambda_line
    type(struct_grain_abs), dimension(:), intent(in) :: grain_abs
    real(CDR), intent(in) :: L_dust_SFC, M_dust
    real(CDR), dimension(:), intent(inout) :: lum_cont, L_line, &
         cont_trans_DISM_tot, line_trans_DISM_tot
    real(CDR), intent(out) :: L_dust_DISM, L_dust
    type(irreg_array_CDR), dimension(:), pointer :: RF_DISM
    real(CDR), dimension(:), intent(out) :: RF_cont_DISM
    real(CDR), dimension(:), intent(out) :: RF_line_DISM
    real(CDR), intent(in), optional :: T_CBR !# Temperature of the cosmic background \
!#                                              radiation field.
!#......................................................................
    integer :: i_cont, i_line, i_species, dim_lambda_grains
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    do i_cont = 1, dim_cont
       if (kappa_abs_cont(i_cont) > 0) then
          RF_cont_DISM(i_cont) = lum_cont(i_cont)*(1-cont_trans_DISM_tot(i_cont))/ &
               kappa_abs_cont(i_cont)/M_dust/c_cm
       else
          RF_cont_DISM(i_cont) = 0
       endif
    enddo

    do i_line = 1, dim_line
       if (kappa_abs_line(i_line) > 0) then
          RF_line_DISM(i_line) = L_line(i_line)*(1-line_trans_DISM_tot(i_line))/ &
               kappa_abs_line(i_line)/M_dust/c_cm
       else
          RF_line_DISM(i_line) = 0
       endif
    enddo

    if (present(T_CBR)) then
       RF_cont_DISM(1:dim_cont) = RF_cont_DISM(1:dim_cont) &
            + 4*pi_B_lambda(T_CBR, lambda_cont(1:dim_cont))/c_cm !# erg.um-1.cm-3
    endif

    if (associated(RF_DISM)) then
       do i_species = 1, size(RF_DISM)
          if (associated(RF_DISM(i_species) % val)) deallocate(RF_DISM(i_species) % val)
       enddo
       deallocate(RF_DISM)
    endif
    allocate(RF_DISM(dim_species))
    do i_species = 1, dim_species
       dim_lambda_grains = grain_abs(i_species) % dim_lambda
       if (associated(RF_DISM(i_species) % val)) deallocate(RF_DISM(i_species) % val)
       allocate(RF_DISM(i_species) % val(dim_lambda_grains))
       call rebin_RF(dim_cont, dim_line, lambda_cont, lambda_line, RF_cont_DISM, &
            RF_line_DISM, dim_lambda_grains, grain_abs(i_species) % lambda_interm(:), &
            RF_DISM(i_species) % val(:))
    enddo

    L_dust_DISM = 0
    do i_cont = 1, dim_cont-1
       L_dust_DISM = L_dust_DISM &
            + (lum_cont(i_cont)*(1-cont_trans_DISM_tot(i_cont)) &
            + lum_cont(i_cont+1)*(1-cont_trans_DISM_tot(i_cont+1))) &
            * (lambda_cont(i_cont+1)-lambda_cont(i_cont))/2
    enddo
    do i_line = 1, dim_line
       L_dust_DISM = L_dust_DISM &
            +L_line(i_line)*(1-line_trans_DISM_tot(i_line))
    enddo

    L_dust = L_dust_DISM + L_dust_SFC

  end subroutine compute_RF_DISM

!#======================================================================

  subroutine dust_optical_properties(dim_species, grain_abs, lambda_cont, species_weight, kappa_ext, albedo, asym)

    use mod_types
    use mod_interp, only : bracket
    use mod_grain_properties, only : struct_grain_abs

    implicit none
    real(CDR), dimension(:), intent(in) :: species_weight
    integer, intent(in) :: dim_species
    type(struct_grain_abs), dimension(:), intent(in) :: grain_abs
    real(CDR), intent(in) :: lambda_cont
    real(CDR), intent(out) :: kappa_ext, albedo, asym
!#......................................................................
    integer :: i_species
    integer :: i_lambda
    real(CDR), dimension(dim_species) :: alpha
    real(CDR), dimension(dim_species) :: interp_kappa_ext_species, interp_albedo_species, interp_asym_species
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    do i_species = 1, dim_species
       i_lambda = 0
       call bracket(grain_abs(i_species) % dim_lambda, grain_abs(i_species) % lambda(1:grain_abs(i_species) % dim_lambda), &
            lambda_cont, i_lambda)
       alpha(i_species) = (1/lambda_cont-1/grain_abs(i_species) % lambda(i_lambda)) / &
            (1/grain_abs(i_species) % lambda(i_lambda+1)-1/grain_abs(i_species) % lambda(i_lambda))
       interp_kappa_ext_species(i_species) = grain_abs(i_species) % kappa_ext(i_lambda) &
            + alpha(i_species)*(grain_abs(i_species) % kappa_ext(i_lambda+1) - grain_abs(i_species) % kappa_ext(i_lambda))
       interp_albedo_species(i_species) = grain_abs(i_species) % albedo(i_lambda) &
            + alpha(i_species)* (grain_abs(i_species) % albedo(i_lambda+1) - grain_abs(i_species) % albedo(i_lambda))
       interp_asym_species(i_species) = grain_abs(i_species) % asym(i_lambda) &
            + alpha(i_species)*(grain_abs(i_species) % asym(i_lambda+1) - grain_abs(i_species) % asym(i_lambda))
    enddo
    kappa_ext = sum(species_weight(1:dim_species)*interp_kappa_ext_species(1:dim_species))

    if (kappa_ext > 0) then
       albedo = sum(species_weight(1:dim_species)*interp_kappa_ext_species(1:dim_species)*interp_albedo_species(1:dim_species))
       albedo = albedo/kappa_ext
       if (albedo > 1) albedo = 1
       if (albedo > 0) then
          asym = sum(species_weight(1:dim_species)*interp_kappa_ext_species(1:dim_species) &
               *interp_albedo_species(1:dim_species)*interp_asym_species(1:dim_species))
          asym = asym/kappa_ext/albedo
          if (asym > 1) asym = 1
          if (asym < -1) asym = -1
       else
          albedo = 0
          asym = 0
       endif
    else
       kappa_ext = 0
       albedo = 0
       asym = 0
    endif

  end subroutine dust_optical_properties

!#======================================================================

  subroutine rebin_RF(dim_cont, dim_line, lambda_cont, lambda_line, &
       RF_cont, RF_line, dim_lambda_grains, lambda_grains_interm, &
       RF)

    use mod_types

    implicit none
    integer, intent(in) :: dim_cont, dim_line, dim_lambda_grains
    real(CDR), dimension(:), intent(in) :: lambda_cont, lambda_line, &
         RF_cont, RF_line
    real(DPR), dimension(:), intent(in) :: lambda_grains_interm
    real(CDR), dimension(:), intent(out) :: RF
!#......................................................................
    integer :: i
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    do i = 1, dim_lambda_grains
       call average_RF(real(lambda_grains_interm(i), CDR), &
            real(lambda_grains_interm(i+1), CDR), dim_cont, &
            dim_line, lambda_cont, lambda_line, RF_cont, RF_line, RF(i))
    enddo

  end subroutine rebin_RF

!#======================================================================

  subroutine average_RF(lambda_grains_inf, lambda_grains_sup, dim_cont, &
       dim_line, lambda_cont, lambda_line, RF_cont, RF_line, RF)

    use mod_types
    use mod_interp, only : bracket, interp_log_log

    implicit none
    real(CDR), intent(in) :: lambda_grains_inf, lambda_grains_sup
    integer, intent(in) :: dim_cont, dim_line
    real(CDR), dimension(:), intent(in) :: lambda_cont, lambda_line, &
         RF_cont, RF_line
    real(CDR), intent(out) :: RF
!#......................................................................
    integer :: i_inf, i_sup, i
    real(CDR) :: RF_inf, RF_sup
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    RF = 0
    i_inf = 0 ; i_sup = 0
    call bracket(dim_cont, lambda_cont, lambda_grains_inf, i_inf)
    call bracket(dim_cont, lambda_cont, lambda_grains_sup, i_sup)
    RF_inf = interp_log_log(lambda_cont(i_inf), lambda_cont(i_inf+1), &
         RF_cont(i_inf), RF_cont(i_inf+1), lambda_grains_inf)
    RF_sup = interp_log_log(lambda_cont(i_sup), lambda_cont(i_sup+1), &
         RF_cont(i_sup), RF_cont(i_sup+1), lambda_grains_sup)

    if (lambda_grains_inf <= lambda_cont(1)) then
       if (lambda_grains_sup <= lambda_cont(1)) then
!# lambda_grains_inf < lambda_grains_sup < lambda_cont(1)
          RF = (RF_inf+RF_sup)*(lambda_grains_sup-lambda_grains_inf)/2
       else
          if (lambda_grains_sup >= lambda_cont(dim_cont)) then
!# lambda_grains_inf < lambda_cont(1) < lambda_cont(n) < lambda_grains_sup
             RF = (RF_inf+RF_cont(1)) * &
                  (lambda_cont(1)-lambda_grains_inf)/2
             do i = 1, dim_cont-1
                RF = RF+(RF_cont(i)+RF_cont(i+1))*(lambda_cont(i+1) &
                     -lambda_cont(i))/2
             enddo
             RF = RF+(RF_cont(dim_cont)+RF_sup)* &
                  (lambda_grains_sup-lambda_cont(dim_cont))/2
          else
!# lambda_grains_inf < lambda_cont(1) < lambda_grains_sup < lambda_cont(n)
             RF = (RF_inf+RF_cont(1))* &
                  (lambda_cont(1)-lambda_grains_inf)/2
             do i = 1, i_sup-1
                RF = RF+(RF_cont(i)+RF_cont(i+1))*(lambda_cont(i+1) &
                     -lambda_cont(i))/2
             enddo
             RF = RF+(RF_cont(i_sup)+RF_sup)* &
                  (lambda_grains_sup-lambda_cont(i_sup))/2
          endif
       endif
    else
!# lambda_cont(1) < lambda_grains_inf
       if (lambda_grains_inf >= lambda_cont(dim_cont)) then
!# lambda_cont(n) < lambda_grains_inf < lambda_grains_sup
          RF = (RF_inf+RF_sup)*(lambda_grains_sup-lambda_grains_inf)/2
       else
!# lambda_cont(1) < lambda_grains_inf < lambda_cont(n)
          if (lambda_grains_sup >= lambda_cont(dim_cont)) then
!# lambda_cont(1) < lambda_grains_inf < lambda_cont(n) < lambda_grains_sup
             RF = (RF_inf+RF_cont(i_inf+1))* &
                  (lambda_cont(i_inf+1)-lambda_grains_inf)/2
             do i = i_inf+1, dim_cont-1
                RF = RF+(RF_cont(i)+RF_cont(i+1))*(lambda_cont(i+1) &
                     -lambda_cont(i))/2
             enddo
             RF = RF+(RF_cont(dim_cont)+RF_sup)* &
                  (lambda_grains_sup-lambda_cont(dim_cont))/2
          else
!# lambda_cont(1) < lambda_grains_inf < lambda_grains_sup < lambda_cont(n)
             if (i_sup == i_inf) then
!# lambda_cont(i_inf) < lambda_grains_inf < lambda_grains_sup
!# < lambda_cont(i_inf+1)
                RF = (RF_inf+RF_sup)* &
                     (lambda_grains_sup-lambda_grains_inf)/2
             else
!# lambda_cont(i_inf) < lambda_grains_inf < lambda_cont(i_inf+1)
!# < lambda_cont(i_sup) < lambda_grains_sup < lambda_cont(i_sup+1)
                RF = (RF_inf+RF_cont(i_inf+1))* &
                     (lambda_cont(i_inf+1)-lambda_grains_inf)/2

                do i = i_inf+1, i_sup-1
                   RF = RF+(RF_cont(i)+RF_cont(i+1))* &
                        (lambda_cont(i+1)-lambda_cont(i))/2
                enddo
                RF = RF+(RF_cont(i_sup)+RF_sup)* &
                     (lambda_grains_sup-lambda_cont(i_sup))/2
             endif
          endif
       endif
    endif

    do i = 1, dim_line
       if ((lambda_line(i) >= lambda_grains_inf) .and. &
            (lambda_line(i) < lambda_grains_sup)) RF = RF+RF_line(i)
    enddo
    RF = RF/(lambda_grains_sup-lambda_grains_inf)

  end subroutine average_RF

!#======================================================================

  subroutine attenuate_DISM(lum_cont, L_line, &
       cont_trans_DISM_incl, line_trans_DISM_incl, &
       lambda_cont, Lyman_cont_dust_abs, &
       cont_trans_DISM_tot, i_Lyman_break_cont)

    use mod_types
    use mod_constants, only : h_Planck, c_um

    implicit none
    real(CDR), dimension(:), intent(inout) :: lum_cont, L_line
    real(CDR), dimension(:), intent(in) :: cont_trans_DISM_incl, line_trans_DISM_incl
    real(CDR), dimension(:), intent(in) :: lambda_cont, cont_trans_DISM_tot
    real(CDR), intent(inout) :: Lyman_cont_dust_abs
    integer,  intent(in) :: i_Lyman_break_cont
!#......................................................................
    integer :: i_cont
    real(DPR) :: nb_phot
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Number of Lyman continuum photons emitted by stars and absorbed in the
!# diffuse medium by dust:

    nb_phot = 0
    do i_cont = 1, i_Lyman_break_cont-1
       nb_phot = nb_phot + ( &
            lum_cont(i_cont)*(1-cont_trans_DISM_tot(i_cont)) &
            * lambda_cont(i_cont) &
            + lum_cont(i_cont+1)*(1-cont_trans_DISM_tot(i_cont+1)) &
            * lambda_cont(i_cont+1) &
            ) * (lambda_cont(i_cont+1)-lambda_cont(i_cont))
    enddo
    nb_phot = nb_phot / 2 / h_Planck / c_um

!# Units: `lum_cont` in erg.s-1.micrometer-1.M_sys-1;
!# `lambda_cont` in micrometers; `nb_phot` in s-1.M_sys-1.

    Lyman_cont_dust_abs = Lyman_cont_dust_abs + nb_phot

!# Continuum and line luminosities emerging from the galaxy in direction
!# `inclination` (or averaged on all directions if `inclin_averaged = .true.`).
    lum_cont(:) = lum_cont(:) * cont_trans_DISM_incl(:)
    L_line(:) = L_line(:) * line_trans_DISM_incl(:)

  end subroutine attenuate_DISM

end module mod_extinction

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

!# Code "colors" takes as input a file of spectra (the main output file of code 
!# "spectra"), processes it and outputs in a file of colors various quantities
!# as a function of the age of the modeled galaxy.
!#
!# To change the output, edit file "incl_colors.f90", and compile the code in
!# "bin_dir/" with the `make` command.

program colors

  use mod_types
  use mod_directories, only : calib_dir, colors_dir, spectra_dir, bin_dir
  use mod_dir_access, only : dir_sep
  use mod_file_access, only : open_file, close_file, file_name_decomposition, &
       path_file, extract_path, base_name, file_name_components, skip_comment_lines
  use mod_constants, only : area_10pc, spectra_list, c_ang
  use mod_filters_constants, only : filters_list, undefined_mag, std_Vega_def, M_bol_Sun
  use mod_filters, only : struct_filter, read_filters, flux_band
  use mod_read_spectra_output, only : read_spectra_output, struct_spectra_output
  use mod_select_file, only : select_single_file
  use mod_interp, only : interp_lin_lin
  use mod_colors
  use mod_hash
  use mod_magnit
  use mod_strings, only : quote_string, unquote_string
  use mod_code_version, only : version_id, version_date
  use mod_compiler, only : compiler
  use mod_convert_type, only : boolean_answer
  use mod_ISO_8601, only : ISO_8601

  implicit none
!#......................................................................
  character(std_string) :: spectra_file_name, spectra_base_name
  type(struct_spectra_output) :: data
  character(std_string+len("colors_")) :: colors_file, colors_file_def
  character(2*std_string) :: colors_full_name, colors_dir_name, &
       colors_base_name
  logical :: first_time
  type(struct_filter), dimension(:), pointer :: filter => null()

  character(len=std_string) :: name
  real(DPR), dimension(:), allocatable :: calib, filter_norm, lambda_mean, &
       lambda_pivot, filter_width, mag_abs_Sun

  integer :: i_elem, i_line, i_cont, dim_filter, unit_calib
  integer, dimension(:), allocatable :: pos_line

  real(DPR), dimension(:), allocatable :: D4000, M_bol, Dn4000
  real(DPR) :: flux_band_Vega, std_Vega, AB_Vega, TG_Vega, unused_number
  integer :: dim_elem, dim_cont, dim_line
  integer :: i_filter, i_output_age
  logical :: exist, overwrite
  integer :: unit_compiler
  character(len=25) :: run_begin_time
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

  call ISO_8601(local_time_extended = run_begin_time)
  
  call open_file(unit_compiler, path_file(bin_dir, "compil_colors.txt"))
  read(unit_compiler,*) compiler
  call close_file(unit_compiler)

!# Read the transmission of the filters.

  call read_filters(path_file(calib_dir, filters_list), dim_filter, filter)

!# Create the hash table for filters.

  call create_hash_table(filter(:) % id, hash_filter, dim_hash_filter)

!# Read the calibrations of the filters.

  if (allocated(calib)) deallocate(calib)
  allocate(calib(dim_filter))
  if (allocated(filter_norm)) deallocate(filter_norm)
  allocate(filter_norm(dim_filter))
  if (allocated(lum_band_Sun)) deallocate(lum_band_Sun)
  allocate(lum_band_Sun(dim_filter))
  if (allocated(lambda_mean)) deallocate(lambda_mean)
  allocate(lambda_mean(dim_filter))
  if (allocated(lambda_pivot)) deallocate(lambda_pivot)
  allocate(lambda_pivot(dim_filter))
  if (allocated(filter_width)) deallocate(filter_width)
  allocate(filter_width(dim_filter))
  if (allocated(mag_abs_Sun)) deallocate(mag_abs_Sun)
  allocate(mag_abs_Sun(dim_filter))

  call open_file(unit_calib, path_file(calib_dir, "calib.txt"))
  read(unit_calib, *) !# `version_id` of "calib".
  read(unit_calib, *) !# `version_date` of "calib".
  call skip_comment_lines(unit_calib)

  do i_filter = 1, dim_filter
     read(unit_calib, *) name, unused_number, flux_band_Vega, filter_norm(i_filter), &
          lambda_mean(i_filter), unused_number, AB_Vega, TG_Vega, lum_band_Sun(i_filter), &
          mag_abs_Sun(i_filter), lambda_pivot(i_filter), filter_width(i_filter)
     if (filter(i_filter) % calib_type == "D4000") then
        calib(i_filter) = undefined_mag
     else if (filter(i_filter) % calib_type == "HST") then !# ref = -21.10
        calib(i_filter) = -21.10_DPR
     else if (filter(i_filter) % calib_type == "FOCA") then !# ref = -21.175
        calib(i_filter) = -21.175_DPR
     else if (filter(i_filter) % calib_type == "IRAS") then
        calib(i_filter) = undefined_mag
     else
        std_Vega = std_Vega_def + filter(i_filter) % ZPO
        if (filter(i_filter) % calib_type == "Vega") then !# ref = Vega
           calib(i_filter) = 2.5_DPR*log10(flux_band_Vega) + std_Vega
        else if (filter(i_filter) % calib_type == "AB") then !# ref = AB
           calib(i_filter) = 2.5_DPR*log10(flux_band_Vega) + AB_Vega - std_Vega
        else if (filter(i_filter) % calib_type == "TG") then !# ref = BD+17d4708 (Thuan & Gunn system)
           if (TG_Vega == undefined_mag) then
              calib(i_filter) = undefined_mag
           else
              calib(i_filter) = 2.5_DPR*log10(flux_band_Vega) + TG_Vega - std_Vega
           endif
        end if
     endif
  end do
  call close_file(unit_calib)

  write(*, "(a)") "Name of the input file (file of spectra)?"
  call select_single_file(dir = spectra_dir, list = spectra_list, &
       selected_file = spectra_file_name, object = "input file", &
       objects = "input files", back = .true.)

  call file_name_decomposition(full_name=spectra_file_name, &
       base_name=spectra_base_name, dir_sep=dir_sep)
  colors_file_def = "colors_" // trim(spectra_base_name)

  first_time = .true.
  do 
     if (first_time) then
        write(*, "(/a)") "Name of the output file?"
        write(*, "(a/a)") "(If the file is in a subdirectory of """ // &
             trim(colors_dir) // """ or in another directory,", &
             "the path, relative to """ // trim(colors_dir) // &
             """ or absolute, must be present.)"
        write(*, "(a)") "Default: """ // trim(colors_file_def) // """"
     else
        write(*, "(a)") "Type the name of the output file of ""colors"" &
             &or press the <RETURN>/<ENTER> key to stop."
     endif
     read(*, "(a)") colors_file
     colors_file = adjustl(unquote_string(colors_file))
     if (colors_file == "") then
        if (first_time) then
           colors_file = colors_file_def
        else
           write(*, "(a)") "Stopped."
           stop
        endif
     endif
     call file_name_components(file_name=colors_file, path=colors_dir, &
          full_name=colors_full_name, dir_name=colors_dir_name, &
          base_name=colors_base_name, dir_sep=dir_sep)
     inquire(file = colors_full_name, exist=exist)
     if (.not.exist) then
        call open_file(unit_colors, colors_full_name, status = "new")
        exit
     else
        write(*, "(a)") "File """ // trim(colors_base_name) // &
             """ already exists in """ // trim(colors_dir_name) // &
             """. Do you want to overwrite it?"
        call boolean_answer(overwrite)
        if (overwrite) then
           call open_file(unit_colors, colors_full_name, &
                status = "replace")
           exit
        endif
        first_time = .false.
     endif
  end do

  write(unit_colors, "(a)") quote_string(version_id) // " !# `version_id`."
  write(unit_colors, "(a)") quote_string(version_date) // " !# `version_date`."
  write(unit_colors, "(a)") "!# Code ""colors"" executed at " // trim(run_begin_time) // "."     
  write(unit_colors, "(a)") "!# Compiler for ""colors"": " // trim(compiler) // "."
  write(unit_colors, "(a)") "!# `spectra_file` = " // &
       quote_string(spectra_file_name) // "."


!# Read the outputs of "spectra".

  call read_spectra_output(spectra_file_name, data)
  dim_output_age = data % dim_output_age
  if (associated(output_age)) deallocate(output_age)
  allocate(output_age(dim_output_age))
  output_age(:) = data % output_age(:)
  dim_elem = data % dim_elem
  dim_cont = data % dim_cont
  dim_line = data % dim_line

!# Create the hash table for ISM abundances of elements.

  call create_hash_table(data % elem_id(:), hash_elem, dim_hash_elem)  
  allocate(ISM_abund_aux(dim_output_age, dim_elem))
  do i_output_age = 1, dim_output_age
     do i_elem = 1, dim_elem
        ISM_abund_aux(i_output_age, i_elem) = data % ISM_abund(i_output_age, i_elem)
     enddo
  enddo

!# Create the hash table for emission lines.

  call create_hash_table(data % line_id(:), hash_line, dim_hash_line)

  allocate(D4000(dim_output_age))
  allocate(Dn4000(dim_output_age))
  allocate(M_bol(dim_output_age))
  allocate(pos_line(dim_line))
  allocate(L_line_aux(dim_output_age, dim_line))
  allocate(eq_width_aux(dim_output_age, dim_line))
  allocate(lum_band_aux(dim_output_age, dim_filter))
  allocate(magnit_aux(dim_output_age, dim_filter))

!# Find the index of the continuum wavelength just below the wavelength of the emission line.
!# ??? Should one do it in "spectra"?
  do i_line = 1, dim_line
     if ((data % lambda_line(i_line)-data % lambda_cont(1)) * &
          (data % lambda_line(i_line)-data % lambda_cont(dim_cont)) < 0) &
          then
        i_cont = 1
        do while (data % lambda_cont(i_cont) < data % lambda_line(i_line))
           i_cont = i_cont+1
        end do
        pos_line(i_line) = i_cont-1
     else
        pos_line(i_line) = 0
     end if
  end do

  do i_output_age = 1, dim_output_age
!# Equivalent width.
!# !!! Absorption in the continuum is not taken into account.
     do i_line = 1, dim_line
        L_line_aux(i_output_age, i_line) = data % L_line(i_output_age, i_line)
        if (pos_line(i_line) /= 0 .and. data % lum_cont(i_output_age,pos_line(i_line)) > 0) then
           eq_width_aux(i_output_age, i_line) = L_line_aux(i_output_age,i_line)/interp_lin_lin( &
                data % lambda_cont(pos_line(i_line)), &
                data % lambda_cont(pos_line(i_line)+1), &
                data % lum_cont(i_output_age, pos_line(i_line)), &
                data % lum_cont(i_output_age, pos_line(i_line)+1), &
                data % lambda_line(i_line))
        else
           eq_width_aux(i_output_age, i_line) = 0
        end if
     end do

     if (data % L_bol(i_output_age) > 0) then
        M_bol(i_output_age) = M_bol_Sun - 2.5_DPR*log10(data % L_bol(i_output_age))
     else
        M_bol(i_output_age) = 0
     endif

     do i_filter = 1, dim_filter
        if (filter(i_filter) % calib_type == "D4000") then
           lum_band_aux(i_output_age, i_filter) = flux_band(filter(i_filter), &
                dim_cont, real(data % lambda_cont, DPR), &
                real(data % lum_cont(i_output_age,:), DPR) * &
                data % lambda_cont**2, &             
                dim_line = dim_line, &
                lambda_line = real(data % lambda_line, DPR), &
                L_line = real(data % L_line(i_output_age,:), DPR) * &
                data % lambda_line**2) &
                / c_ang / filter_norm(i_filter)
        else
           lum_band_aux(i_output_age, i_filter) = flux_band(filter(i_filter), &
                dim_cont, real(data % lambda_cont, DPR), &
                real(data % lum_cont(i_output_age,:), DPR), &             
                dim_line = dim_line, &
                lambda_line = real(data % lambda_line, DPR), &
                L_line = real(data % L_line(i_output_age,:), DPR))/filter_norm(i_filter)
        endif
     enddo

     do i_filter = 1, dim_filter
        if (lum_band_aux(i_output_age, i_filter) > 0 .and. calib(i_filter) /= undefined_mag) then
           magnit_aux(i_output_age, i_filter) = -2.5_DPR*log10(lum_band_aux(i_output_age, i_filter)/area_10pc) &
                + calib(i_filter)
        else
           magnit_aux(i_output_age,i_filter) = undefined_mag
        end if
     end do

!# 4000A break index (Bruzual 1983) in the object's frame.

     if (lum_band(i_output_age, "D4000-") > 0 .and. lum_band(i_output_age, "D4000+") > 0) then
        D4000(i_output_age) = lum_band(i_output_age, "D4000+")/ &
             lum_band(i_output_age, "D4000-")
     end if

!# 4000A break narrow index (Balogh et al. 1999) in the object's frame.

     if (lum_band(i_output_age, "Dn4000-") > 0 .and. lum_band(i_output_age, "Dn4000+") > 0) then
        Dn4000(i_output_age) = lum_band(i_output_age, "Dn4000+")/ &
             lum_band(i_output_age, "Dn4000-")
     end if
  end do

!#----------------------------------------------------------------------
!# Outputs: {

  include "incl_colors.f90"

!# } :Outputs.
!#----------------------------------------------------------------------

  call close_file(unit_colors)
  deallocate(D4000, M_bol, Dn4000, pos_line, L_line_aux, eq_width_aux, lum_band_aux, magnit_aux, ISM_abund_aux)
  call delete_hash_table(hash_filter)
  call delete_hash_table(hash_line)
  call delete_hash_table(hash_elem)
  
end program colors

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

program plot_grain_SED

  use mod_read_grain_SED
  use mod_types
  use mod_directories, only : grain_SED_dir
  use mod_select_file, only : select_single_file
  use mod_constants, only : grain_SED_list
  use mod_strings, only : quote_string

  implicit none
!#......................................................................
  character(len=std_string) :: file_name
  type(struct_grain_SED) :: data
  integer :: i_age, i_species, i_region, i_radius, dim_lambda
  real :: x_min, x_max, y_min, y_max, delta_x
  real(CDR) :: eps
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

  call select_single_file(dir = grain_SED_dir, list = grain_SED_list, &
       selected_file = file_name, &
       object = "file of grain SEDs", &
       objects = "files of grain SEDs", back = .true.)
  
  write(*,*) "Reading file..."
  call read_grain_SED(file_name, data)

  call pgbegin(0, "?", 1, 1)
  call pgask(.false.)
  call pgscf(2)
  do i_age = 1, data % dim_age_grains
     write(*,*) "age/(1 Myr)  = ", data % age_grains(i_age)
     do i_region = 1, data % dim_region
        write(*,*) "region = ", quote_string(data % region(i_region) % id)
        do i_species = 1, data % region(i_region) % dim_species
           dim_lambda = data % region(i_region) % species(i_species) % dim_lambda
           write(*,*) "species = ", quote_string(data % region(i_region) &
                % species(i_species) % id)
           do i_radius = 1, data % region(i_region) % species(i_species) &
                % dim_radius
              write(*,*) "radius/(1 um) = ", data % region(i_region) &
                   % species(i_species) % radius(i_radius)
              x_min = log10(data % region(i_region) % species(i_species) &
                   % lambda(1))
              x_max = log10(data % region(i_region) % species(i_species) &
                   % lambda(dim_lambda))
              y_min = minval(data % region(i_region) % species(i_species) &
                   % lambda(:) * data % region(i_region) % species(i_species) &
                   % lum_eq(i_age, i_radius, :))
              y_max = maxval(data % region(i_region) % species(i_species) &
                   % lambda(:) * data % region(i_region) % species(i_species) &
                   % lum_eq(i_age, i_radius, :))
              if (data % region(i_region) % stoch_heating) then
                 y_min = min(y_min, &
                      real(minval(data % region(i_region) % species(i_species) &
                      % lambda(:) * data % region(i_region) % species(i_species) &
                      % lum_stoch(i_age, i_radius, :))))
                 y_max = max(y_max, &
                      real(maxval(data % region(i_region) % species(i_species) &
                      % lambda(:) * data % region(i_region) % species(i_species) &
                      % lum_stoch(i_age, i_radius, :))))
              endif
              y_min = max(y_min, y_max/1.e10)
              eps = y_min
              delta_x = x_max - x_min
              x_min = x_min - 0.1*delta_x
              x_max = x_max + 0.1*delta_x
              y_min = log10(y_min)
              y_max = log10(y_max)
              y_max = y_max + 0.1*(y_max - y_min)
              call pgenv(x_min, x_max, y_min, y_max, 0, 30)
              call pglabel("\gl/(1 \A)", "\gl \fiL\fr\d\gl\u", &
                   "Grain emission spectrum")
              if (data % region(i_region) % stoch_heating) then
                 call pgsci(2)
                 call pgtext(x_min+0.05*(x_max-x_min), &
                      y_max-0.1*(y_max-y_min), "With stochastic heating.")
                 call pgline(dim_lambda, &
                      real(log10(data % region(i_region) % species(i_species) &
                      % lambda(:))), &
                      real(log10(max(data % region(i_region) % species(i_species) &
                      % lambda(:) * data % region(i_region) % species(i_species) &
                      % lum_stoch(i_age, i_radius, :), eps))))
              end if
              call pgsci(3)
              call pgtext(x_min+0.05*(x_max-x_min), &
                   y_max-0.05*(y_max-y_min), "Without stochastic heating.")
              call pgline(dim_lambda, &
                   real(log10(data % region(i_region) % species(i_species) &
                   % lambda(:))), &
                   real(log10(max(data % region(i_region) % species(i_species) &
                   % lambda(:) * data % region(i_region) % species(i_species) &
                   % lum_eq(i_age, i_radius, :), eps))))
              call pgsci(1)
              write(*,*) "Press the <RETURN>/<ENTER> key to proceed."
              read(*,*)
           enddo
        enddo
     enddo
  enddo
  call pgend

end program plot_grain_SED

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_SSPs_ages

  implicit none
  public :: read_SSPs_ages

contains

!#======================================================================
  
  subroutine read_SSPs_ages(SSPs_ages_file, time_step, dim_time_SSP, time_SSP)

    use mod_types
    use mod_linked_list
    use mod_file_access
    use mod_directories, only : ages_dir

    implicit none
    character(len=*), intent(in) :: SSPs_ages_file
    real(CDR), intent(out) :: time_step
    integer, intent(out) :: dim_time_SSP
    real(CDR), dimension(:), pointer :: time_SSP
!#......................................................................
    integer :: unit, ios, factor, tot_factor
    real(CDR) :: time
    type(lk_lst_CDR) :: head_node
    type(lk_lst_CDR), pointer :: current_node => null()
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call open_file(unit, file = path_file(ages_dir, SSPs_ages_file))
    read(unit,*) time_step
    dim_time_SSP = 1
    call lk_lst_initialize(head_node)
    call lk_lst_new_node(head_node, current_node)
    current_node % val = 0
    tot_factor = 0
    do
       read(unit,*,iostat=ios) time, factor
       if (ios /= 0) exit
       do 
          if (current_node % val < time) then
             dim_time_SSP = dim_time_SSP+1
             tot_factor = tot_factor+factor
             call lk_lst_new_node(head_node, current_node)
             current_node % val = tot_factor*time_step
          else
             exit
          endif
       enddo
    enddo
    call close_file(unit)

    call lk_lst_to_array(head_node, time_SSP, dim_time_SSP)
    
  end subroutine read_SSPs_ages

end module mod_SSPs_ages

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

!# References:
!# DL2001 = Draine & Li (2001), ApJ 551, 807;
!# LD2001 = Li & Draine (2001), ApJ 554, 778.

module mod_dust_emission

  use mod_types
  use mod_read_output_param, only : grain_temp_output, grain_SED_output
  private

  type :: struct_grain
     real(CDR) :: sublim_temp
     integer :: dim_temp
     real(CDR), dimension(:), pointer :: temp => null()
     real(CDR), dimension(:), pointer :: grain_energ0 => null()
     real(CDR), dimension(:,:), pointer :: bol_lum => null()
  end type struct_grain
  
  public :: struct_grain

  integer, public :: unit_grain_temp, unit_grain_SED
  logical, public :: do_output_grain
  public :: temp_grid, compute_grain_bol_lum, compute_grain_energ, compute_dust_emission, read_Debye

contains

!#======================================================================

  subroutine temp_grid(dim_temp, temp, T_min, T_max)

    use mod_types
    use mod_spectra_constants, only : T_min_def, T_max_def

    implicit none
    integer, intent(in) :: dim_temp
    real(CDR), intent(in), optional :: T_min, T_max
    real(CDR), dimension(:), pointer :: temp
!#......................................................................
    real(CDR) :: temp_min, temp_max, alpha
    integer :: i_temp
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (associated(temp)) deallocate(temp)
    allocate(temp(dim_temp))

    if (present(T_min)) then
       temp_min = T_min
    else
       temp_min = T_min_def
    endif
    if (present(T_max)) then
       temp_max = T_max
    else
       temp_max = T_max_def
    endif

    alpha = (temp_max/temp_min)**(1._CDR/(dim_temp-1))
    
    temp(1) = temp_min
    do i_temp = 2, dim_temp
       temp(i_temp) = temp(i_temp-1)*alpha
    enddo

  end subroutine temp_grid

!#======================================================================

  subroutine temp_grid2(dim_temp2, temp2, &
       T_min, T_max, dim_temp, T_interm, lum_frac)

    use mod_types
    use mod_linked_list
    implicit none
    integer, intent(out) :: dim_temp2
    real(CDR), dimension(:), pointer :: temp2
    real(CDR), intent(in) :: T_min, T_max
    integer, intent(in) :: dim_temp
    real(CDR), dimension(:), intent(in) :: T_interm, lum_frac
!#......................................................................
    integer :: i_sub, i_temp
    real(CDR) :: l10_T_bot, l10_T_top
    real(CDR), parameter :: max_delta_l10_T = 0.05_CDR, &
         max_bin_P = 0.05_CDR, min_delta_l10_T = 0.02_CDR
    type(lk_lst_CDR) :: head_node
    type(lk_lst_CDR), pointer :: current_node => null(), &
         next_node => null()
    integer :: n_sub
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Subdivide the temperature grid.
    call lk_lst_initialize(head_node)
    dim_temp2 = 0
    do i_temp = 1, dim_temp
       if (T_interm(i_temp+1) < T_min) cycle
       if (T_interm(i_temp) > T_max) exit
       l10_T_bot = log10(max(T_interm(i_temp), T_min))
       l10_T_top = log10(min(T_interm(i_temp+1), T_max))
       n_sub = ceiling( max( &
            (l10_T_top-l10_T_bot)/max_delta_l10_T, &
            lum_frac(i_temp)/max_bin_P) )
       
       dim_temp2 = dim_temp2 + n_sub
       do i_sub = 1, n_sub
          call lk_lst_new_node(head_node, current_node)
          current_node % val = 10**(l10_T_bot + &
               (i_sub-0.5_CDR)/n_sub*(l10_T_top-l10_T_bot))
       enddo
    enddo

!# Merge consecutive temperature nodes if too close.
    current_node => head_node % ptr
    do
       if (associated(current_node)) then
          next_node => current_node % ptr
          if (associated(next_node)) then
             if (log10(next_node % val/current_node % val) &
                  < min_delta_l10_T) then
                current_node % val = &
                     sqrt(current_node % val * next_node % val)
!# Remove next node: {
!# ??? Shouldn't the deleted node be deallocated?
                next_node => next_node % ptr
                deallocate(current_node % ptr)
                current_node % ptr => next_node
!# }
                dim_temp2 = dim_temp2 - 1
             endif
             current_node => next_node
          else
             exit
          endif
       else
          exit
       endif
    enddo

    call lk_lst_to_array(head_node, temp2, dim_temp2)

  end subroutine temp_grid2

!#======================================================================
  
  subroutine compute_dust_emission(carb_abund, sil_abund, &
       dim_cont, lambda_cont, grain_data, M_dust, &
       RF, lum_species, &
       dim_species, species_id, grain_density, grain_mean_atomic_mass, &
       species_weight, grain_abs, stoch_heating, &
       self_abs_power, cont_trans_tot, cont_trans_incl, sublim_lum_species)
  
    use mod_types
    use mod_interp, only : interp_log_log, bracket
    use mod_grain_properties, only : struct_grain_abs
    
    implicit none
    real(CDR), intent(in) :: carb_abund, sil_abund
    integer, intent(in) :: dim_cont, dim_species
    real(CDR), dimension(:), intent(in) :: lambda_cont
    type(struct_grain), dimension(:), intent(in) :: grain_data
    real(CDR), intent(in) :: M_dust
    type(irreg_array_CDR), dimension(:), intent(in) :: RF
    real(CDR), dimension(:,:), intent(out) :: lum_species
    character(len=*), dimension(:), intent(in) :: species_id
    real(CDR), dimension(:), intent(in) :: grain_density, grain_mean_atomic_mass
    type(struct_grain_abs), dimension(:), intent(in) :: grain_abs
    real(CDR), dimension(:), intent(in) :: species_weight
    logical, intent(in) :: stoch_heating
    real(CDR), intent(in), optional :: self_abs_power
    real(CDR), dimension(:), intent(in), optional :: cont_trans_tot, &
         cont_trans_incl
    real(CDR), dimension(:,:), intent(out), optional :: sublim_lum_species
!#......................................................................
    integer :: i_species
    type(irreg_array_CDR), dimension(:), allocatable :: lum_species_orig, &
         sublim_lum_species_orig
    integer :: i_bracket, i_cont
    real(CDR) :: int_num, int_den, ratio
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    if (allocated(lum_species_orig)) then
       do i_species = 1, dim_species
          if (associated(lum_species_orig(i_species) % val)) deallocate(lum_species_orig(i_species) % val)
       enddo
       deallocate(lum_species_orig)
    endif
    allocate(lum_species_orig(dim_species))
    do i_species = 1, dim_species
       allocate(lum_species_orig(i_species) % val(grain_abs(i_species) % dim_lambda))
    enddo

    if (allocated(sublim_lum_species_orig)) then
       do i_species = 1, dim_species
          if (associated(sublim_lum_species_orig(i_species) % val)) deallocate(sublim_lum_species_orig(i_species) % val)
       enddo
       deallocate(sublim_lum_species_orig)
    endif
    allocate(sublim_lum_species_orig(dim_species))
    do i_species = 1, dim_species
       allocate(sublim_lum_species_orig(i_species) % val(grain_abs(i_species) % dim_lambda))
    enddo
    
    if (present(self_abs_power)) then
       if (self_abs_power > 0 .and. .not.(present(cont_trans_tot) .and. &
            present(cont_trans_incl))) then
          write(*, "(a)") "Subroutine `compute_dust_emission`: optional &
               &`cont_trans_tot` and `cont_trans_incl` must be present if &
               &`self_abs_power` is present and > 0. Stopped."
          stop
       endif
    endif

    do i_species = 1, dim_species
       lum_species_orig(i_species) % val = 0
       sublim_lum_species_orig(i_species) % val = 0
    enddo
    lum_species = 0
    if (present(sublim_lum_species)) sublim_lum_species = 0

    if (carb_abund > 0 .or. sil_abund > 0) then
       if (do_output_grain) then
          if (grain_temp_output) write(unit_grain_temp, "(i0)") dim_species
          if (grain_SED_output)  write(unit_grain_SED, "(i0)") dim_species
       endif
       do i_species = 1, dim_species
          if (any(RF(i_species) % val(:) > 0)) then
             call compute_lum_species(grain_abs(i_species) % dim_radius, &
                  grain_abs(i_species) % radius(:), species_id(i_species), grain_density(i_species), &
                  grain_mean_atomic_mass(i_species), &
                  grain_data(i_species) % bol_lum(:,:), grain_abs(i_species) % Q_abs(:,:), &
                  grain_data(i_species) % grain_energ0(:), grain_abs(i_species) % dim_lambda, &
                  grain_abs(i_species) % lambda(:), &
                  grain_abs(i_species) % lambda_interm(:), &
                  RF(i_species) % val(:), grain_data(i_species) % temp, &
                  grain_abs(i_species) % d_S_grain(:), lum_species_orig(i_species) % val(:), &
                  stoch_heating, &
                  grain_data(i_species) % sublim_temp, sublim_lum_species_orig(i_species) % val(:))

          endif
       enddo

       do i_species = 1, dim_species
          lum_species_orig(i_species) % val(:) = M_dust*species_weight(i_species) * &
               lum_species_orig(i_species) % val(:)
          sublim_lum_species_orig(i_species) % val(:) = M_dust*species_weight(i_species) * &
               sublim_lum_species_orig(i_species) % val(:)
       enddo

!# Rebin `lum_species_orig` from `lambda_grains` to `lambda_cont` -> `lum_species`.

       do i_species = 1, dim_species
          i_bracket = 0
          do i_cont = 1, dim_cont
             call bracket(grain_abs(i_species) % dim_lambda, grain_abs(i_species) % lambda(:), &
                  lambda_cont(i_cont), i_bracket)
             lum_species(i_species, i_cont) = interp_log_log(grain_abs(i_species) % lambda(i_bracket), &
                  grain_abs(i_species) % lambda(i_bracket+1), lum_species_orig(i_species) % val(i_bracket), &
                  lum_species_orig(i_species) % val(i_bracket+1), lambda_cont(i_cont))
             if (present(sublim_lum_species)) &
                  sublim_lum_species(i_species, i_cont) = interp_log_log(grain_abs(i_species) % lambda(i_bracket), &
                  grain_abs(i_species) % lambda(i_bracket+1), sublim_lum_species_orig(i_species) % val(i_bracket), &
                  sublim_lum_species_orig(i_species) % val(i_bracket+1), lambda_cont(i_cont))
          enddo
       enddo

!# Self-absorption.

       if (present(self_abs_power)) then
          if (self_abs_power > 0) then
             int_num = 0
             int_den = 0
             do i_cont = 1, dim_cont-1
                int_num = int_num+(lambda_cont(i_cont+1)-lambda_cont(i_cont)) &
                     *sum(lum_species(1:dim_species, i_cont:i_cont+1))/2
                int_den = int_den+(lambda_cont(i_cont+1)-lambda_cont(i_cont)) &
                     *(cont_trans_tot(i_cont)**self_abs_power &
                     *sum(lum_species(1:dim_species, i_cont)) &
                     + cont_trans_tot(i_cont+1)**self_abs_power &
                     *sum(lum_species(1:dim_species, i_cont+1)))/2
             enddo
             
             if (int_num /= 0 .and. int_den /= 0) then
                ratio = int_num/int_den
                do i_cont = 1, dim_cont
                   lum_species(1:dim_species, i_cont) = lum_species(1:dim_species, i_cont) * &
                        cont_trans_incl(i_cont)**self_abs_power * ratio
                   if (present(sublim_lum_species)) &
                        sublim_lum_species(1:dim_species, i_cont) = sublim_lum_species(1:dim_species, i_cont) * &
                        cont_trans_incl(i_cont)**self_abs_power * ratio
                enddo
             endif
          endif
       endif
    else
       if (do_output_grain) then
          if (grain_temp_output) write(unit_grain_temp, "(i0)") 0
          if (grain_SED_output) write(unit_grain_SED, "(i0)") 0
       end if
    endif

  end subroutine compute_dust_emission

!#======================================================================

  subroutine compute_lum_species(dim_radius, radius, species_id, grain_density, &
       grain_mean_atomic_mass, grain_bol_lum, Q_abs, &
       grain_energ0, dim_lambda_grains, lambda_grains, &
       lambda_grains_interm, &
       RF, temp, d_S_grain, &
       lum_species_orig, stoch_heating, sublim_temp, sublim_lum_species_orig)

    use mod_types
    use mod_interp,  only : bracket, interp_log_log
    use mod_loc, only : min_loc, max_loc
    use mod_constants, only : in_um_to_in_cm, pi, H_atom_mass
    use mod_read_output_param, only : grain_output_min_size, grain_output_max_size

    implicit none
    integer, intent(in) :: dim_radius, dim_lambda_grains
    real(CDR), dimension(:), intent(in) :: radius, lambda_grains, &
         RF, temp
    real(DPR), dimension(:), intent(in) :: lambda_grains_interm
    real(CDR), intent(in) :: grain_density, grain_mean_atomic_mass
    character(len=*), intent(in) :: species_id
    real(CDR), dimension(:, :), intent(in) :: grain_bol_lum, Q_abs
    real(CDR), dimension(:), intent(out) :: lum_species_orig
    real(CDR), dimension(:), intent(in) :: grain_energ0, d_S_grain
    logical, intent(in) :: stoch_heating
    real(CDR), intent(in), optional :: sublim_temp
    real(CDR), dimension(:), intent(out), optional :: sublim_lum_species_orig
!#......................................................................
    integer :: dim_temp
    integer :: i_radius
    real(CDR) :: r_cm, area, volume, nb_atoms
    real(CDR), dimension(dim_radius, dim_lambda_grains) :: grain_X_lambda, grain_X_lambda_eq, &
         sublim_grain_X_lambda
    real(CDR) :: temp_eq
    real(CDR), dimension(:), pointer :: T_interm => null(), U_interm => null(), &
         T_interm2 => null(), U_interm2 => null() !# ??? Use rather `nullify` in the executable part, otherwise it is `save`d?
    real(DPR), dimension(:), pointer :: lum_cumul_frac => null()
    real(CDR), dimension(:), pointer :: lum2 => null(), &
         temp2 => null(), &
         lum_frac => null()
    real(CDR), dimension(:), pointer :: prob => null()
    real(CDR), dimension(:), pointer :: grain_energ2 => null()

    integer :: i_radius_min, i_radius_max, dim_temp2
    real(DPR), dimension(dim_lambda_grains+1) :: integral_wqu, h_c_integral_qu
    real(DPR), dimension(dim_lambda_grains) :: q_u_over_2, h_c_q_u
    integer :: i_temp
    real(CDR) :: total_heat_rate
    integer :: i_bracket, dim_temp2_prev
    real(CDR) :: T_min, T_max, temp_eq_prev, T_min_prev, T_max_prev
    real(CDR), parameter :: lum_cumul_frac_min = 1.e-8_DPR, &
         lum_cumul_frac_max = 1-lum_cumul_frac_min
    integer :: dim_output_grain_radius
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    dim_temp = size(temp)

!# No need to initialize `grain_X_lambda` and `grain_X_lambda_eq` because `integrate_over_size`
!# sums them only from `i_radius_min` to `i_radius_max`.
!~    grain_X_lambda(:,:) = 0 
!~    grain_X_lambda_eq(:,:) = 0
    
    i_radius_min = 1
    do
       if (i_radius_min >= dim_radius) exit
       if (d_S_grain(i_radius_min) > 0) exit
       i_radius_min = i_radius_min+1
    enddo
    i_radius_max = dim_radius
    do
       if (i_radius_max <= 1) exit
       if (d_S_grain(i_radius_max) > 0) exit
       i_radius_max = i_radius_max-1
    enddo

    dim_output_grain_radius = &
         count(radius(i_radius_min:i_radius_max) >= grain_output_min_size &
         .and. radius(i_radius_min:i_radius_max) <= grain_output_max_size)
    if (do_output_grain) then
       if (grain_temp_output) then
          write(unit_grain_temp, "(i0)") dim_output_grain_radius
       endif
       if (grain_SED_output) &
            write(unit_grain_SED, "(i0)") dim_output_grain_radius
    end if
    do i_radius = i_radius_min, i_radius_max
       r_cm = radius(i_radius) * in_um_to_in_cm
       area = 4*pi*r_cm**2
       volume = area*r_cm/3
       nb_atoms = grain_density*volume/(grain_mean_atomic_mass*H_atom_mass)

       call compute_integrals_temp_eq(dim_lambda_grains, lambda_grains_interm, &
            Q_abs(i_radius, :), RF, grain_bol_lum(i_radius, :), &
            temp, radius(i_radius), h_c_integral_qu, &
            integral_wqu, h_c_q_u, q_u_over_2, total_heat_rate, temp_eq)

!#//////////////////////////////////////////////////////////////////////
!# Smallest grain for the grain species considered.

       if (i_radius == i_radius_min) then
          if (stoch_heating) then

!# Use first a regular grid of temperatures to compute the approximate probability distribution
!# of temperatures.
             
             call U_grid(species_id, nb_atoms, dim_temp, temp, grain_energ0(:), &
                  T_interm, U_interm)
             
             call GD(dim_lambda_grains, radius(i_radius), grain_bol_lum(i_radius, :), &
                  dim_temp, U_interm, prob, &
                  lambda_grains_interm, integral_wqu, h_c_q_u, q_u_over_2, &
                  h_c_integral_qu, total_heat_rate)

!# Create a refined grid of temperatures to compute the final probability distribution
!# of temperatures, with a higher resolution at most likely temperatures.

             if (associated(lum_cumul_frac)) deallocate(lum_cumul_frac)
             allocate(lum_cumul_frac(dim_temp+1))
             if (associated(lum_frac)) deallocate(lum_frac)
             allocate(lum_frac(dim_temp))

             lum_cumul_frac(1) = 0
             do i_temp = 2, dim_temp+1
                lum_cumul_frac(i_temp) = lum_cumul_frac(i_temp-1) + prob(i_temp-1)*grain_bol_lum(i_radius, i_temp-1)
             enddo
             do i_temp = 1, dim_temp
                lum_frac(i_temp) = prob(i_temp)*grain_bol_lum(i_radius, i_temp)
             enddo
             lum_frac(1:dim_temp) = lum_frac(1:dim_temp)/lum_cumul_frac(dim_temp+1) !# Do not move this line \
!#                                                                                     after next one!
             lum_cumul_frac(1:dim_temp+1) = lum_cumul_frac(1:dim_temp+1)/lum_cumul_frac(dim_temp+1)
             T_min = T_interm(max_loc(lum_cumul_frac(1:dim_temp+1), &
                  mask = lum_cumul_frac(1:dim_temp+1) < lum_cumul_frac_min, &
                  default = 1))
             T_max = T_interm(min_loc(lum_cumul_frac(1:dim_temp+1), &
                  mask = lum_cumul_frac(1:dim_temp+1) > lum_cumul_frac_max, &
                  default = dim_temp+1))

             call temp_grid2(dim_temp2, temp2, &
                  T_min, T_max, dim_temp, T_interm, lum_frac)
             if (associated(lum2)) deallocate(lum2)
             allocate(lum2(dim_temp2))
             if (associated(grain_energ2)) deallocate(grain_energ2)
             allocate(grain_energ2(dim_temp2))

             i_bracket = 0
             do i_temp = 1, dim_temp2
                call bracket(dim_temp, temp, temp2(i_temp), i_bracket)
                lum2(i_temp) = interp_log_log(temp(i_bracket), temp(i_bracket+1), grain_bol_lum(i_radius, i_bracket), &
                     grain_bol_lum(i_radius, i_bracket+1), temp2(i_temp))
                grain_energ2(i_temp) = interp_log_log(temp(i_bracket), temp(i_bracket+1), &
                     grain_energ0(i_bracket), &
                     grain_energ0(i_bracket+1), temp2(i_temp))
             enddo

             call U_grid(species_id, nb_atoms, dim_temp2, temp2, grain_energ2(:), &
                  T_interm2, U_interm2)

             call GD(dim_lambda_grains, radius(i_radius), lum2, dim_temp2, U_interm2, &
                  prob, &
                  lambda_grains_interm, integral_wqu, h_c_q_u, q_u_over_2, &
                  h_c_integral_qu, total_heat_rate)

             temp_eq_prev = temp_eq

             if (present(sublim_temp)) then
                call compute_grain_X_lambda(dim_temp2, temp2, prob, dim_lambda_grains, &
                     lambda_grains, Q_abs(i_radius, :), grain_X_lambda(i_radius, :), &
                     sublim_temp, sublim_grain_X_lambda(i_radius, :))
             else
                call compute_grain_X_lambda(dim_temp2, temp2, prob, dim_lambda_grains, &
                     lambda_grains, Q_abs(i_radius, :), grain_X_lambda(i_radius, :))
                sublim_grain_X_lambda(i_radius, :) = 0
             endif
             if (do_output_grain .and. &
                  radius(i_radius) >= grain_output_min_size .and. &
                  radius(i_radius) <= grain_output_max_size) then
                if (grain_temp_output) &
                     call write_grain_temp(radius(i_radius), temp_eq, dim_temp2, &
                     temp2, T_interm2, prob)
                if (grain_SED_output) then
                   call compute_grain_X_lambda(1, (/temp_eq/), (/1._CDR/), &
                        dim_lambda_grains, lambda_grains, Q_abs(i_radius, :), &
                        grain_X_lambda_eq(i_radius, :))
                   call write_grain_SED(radius(i_radius), &
                        grain_X_lambda(i_radius, :), &
                        grain_X_lambda_eq(i_radius, :))
                end if
             endif
          else  !# No stochastic heating.
             if (present(sublim_temp)) then
                call compute_grain_X_lambda(1, (/temp_eq/), (/1._CDR/), dim_lambda_grains, &
                     lambda_grains, Q_abs(i_radius, :), grain_X_lambda(i_radius, :), &
                     sublim_temp, sublim_grain_X_lambda(i_radius, :))
             else
                call compute_grain_X_lambda(1, (/temp_eq/), (/1._CDR/), &
                     dim_lambda_grains, lambda_grains, Q_abs(i_radius, :), &
                     grain_X_lambda(i_radius, :))
                sublim_grain_X_lambda(i_radius, :) = 0
             endif

             if (do_output_grain .and. &
                  radius(i_radius) >= grain_output_min_size .and. &
                  radius(i_radius) <= grain_output_max_size) then
                if (grain_temp_output) &
                     call write_grain_temp(radius(i_radius), temp_eq)
                if (grain_SED_output) then
                   call write_grain_SED(radius(i_radius), &
                        grain_X_lambda(i_radius, :))
                end if
             end if
          endif

!#//////////////////////////////////////////////////////////////////////
!# Larger grains for the grain species considered.

       else !# i_radius > i_radius_min
          if (stoch_heating) then

             if (associated(lum_cumul_frac)) deallocate(lum_cumul_frac)
             allocate(lum_cumul_frac(dim_temp2+1))
             if (associated(lum_frac)) deallocate(lum_frac)
             allocate(lum_frac(dim_temp2))

             lum_cumul_frac(1) = 0
             do i_temp = 2, dim_temp2+1
                lum_cumul_frac(i_temp) = lum_cumul_frac(i_temp-1) + prob(i_temp-1)*lum2(i_temp-1)
             enddo
             do i_temp = 1, dim_temp2
                lum_frac(i_temp) = prob(i_temp)*lum2(i_temp)
             enddo
             lum_frac(1:dim_temp2) = &
                  lum_frac(1:dim_temp2)/lum_cumul_frac(dim_temp2+1) !# Do not move this line \
!#                                                                     after next one!
             lum_cumul_frac(1:dim_temp2+1) = lum_cumul_frac(1:dim_temp2+1)/lum_cumul_frac(dim_temp2+1)
             T_min_prev = T_interm2(max_loc(lum_cumul_frac(1:dim_temp2+1), &
                  mask = lum_cumul_frac(1:dim_temp2+1) < lum_cumul_frac_min, &
                  default = 1))
             T_max_prev = T_interm2(min_loc(lum_cumul_frac(1:dim_temp2+1), &
                  mask = lum_cumul_frac(1:dim_temp2+1) > lum_cumul_frac_max, &
                  default = dim_temp2+1))

             T_min = max(T_interm(1), min(1._CDR, temp_eq/temp_eq_prev)*T_min_prev)
             T_max = min(T_interm(dim_temp+1), max(1._CDR, temp_eq/temp_eq_prev)*T_max_prev)
             T_interm2(1:dim_temp2+1) = T_interm2(1:dim_temp2+1)*temp_eq/temp_eq_prev

!# Introducing `dim_temp2_prev` is necessary with gfortran because this compiler
!# confuses it in the call to subroutine `temp_grid2` with [the first] 
!# `dim_temp2`, although the latter is `intent(out)` and `dim_temp2[_prev]` is 
!# `intent(in)`.
!# With ifort, `dim_temp2_prev` may be replaced by `dim_temp2` in the call to
!# `temp_grid2`.
             dim_temp2_prev = dim_temp2 
             call temp_grid2(dim_temp2, temp2, &
                  T_min, T_max, dim_temp2_prev, T_interm2, lum_frac)

             if (associated(lum2)) deallocate(lum2)
             allocate(lum2(dim_temp2))
             if (associated(grain_energ2)) deallocate(grain_energ2)
             allocate(grain_energ2(dim_temp2))

             i_bracket = 0
             do i_temp = 1, dim_temp2
                call bracket(dim_temp, temp, temp2(i_temp), i_bracket)
                lum2(i_temp) = interp_log_log(temp(i_bracket), temp(i_bracket+1), grain_bol_lum(i_radius, i_bracket), &
                     grain_bol_lum(i_radius, i_bracket+1), temp2(i_temp))
                grain_energ2(i_temp) = interp_log_log(temp(i_bracket), temp(i_bracket+1), &
                     grain_energ0(i_bracket), &
                     grain_energ0(i_bracket+1), temp2(i_temp))
             enddo

             call U_grid(species_id, nb_atoms, dim_temp2, temp2, grain_energ2(:), &
                  T_interm2, U_interm2)

             call GD(dim_lambda_grains, radius(i_radius), lum2, dim_temp2, U_interm2, prob, &
                  lambda_grains_interm, integral_wqu, h_c_q_u, q_u_over_2, &
                  h_c_integral_qu, total_heat_rate)

             temp_eq_prev = temp_eq

             if (present(sublim_temp)) then
                call compute_grain_X_lambda(dim_temp2, temp2, prob, dim_lambda_grains, &
                     lambda_grains, Q_abs(i_radius, :), grain_X_lambda(i_radius, :), &
                     sublim_temp, sublim_grain_X_lambda(i_radius, :))
             else
                call compute_grain_X_lambda(dim_temp2, temp2, prob, dim_lambda_grains, &
                     lambda_grains, Q_abs(i_radius, :), grain_X_lambda(i_radius, :))
                sublim_grain_X_lambda(i_radius, :) = 0
             endif
             if (do_output_grain .and. &
                  radius(i_radius) >= grain_output_min_size .and. &
                  radius(i_radius) <= grain_output_max_size) then
                if (grain_temp_output) &
                     call write_grain_temp(radius(i_radius), temp_eq, &
                     dim_temp2, temp2, T_interm2, prob)
                if (grain_SED_output) then
                   call compute_grain_X_lambda(1, (/temp_eq/), (/1._CDR/), &
                        dim_lambda_grains, lambda_grains, Q_abs(i_radius, :), &
                        grain_X_lambda_eq(i_radius, :))
                   call write_grain_SED(radius(i_radius), &
                        grain_X_lambda(i_radius, :), &
                        grain_X_lambda_eq(i_radius, :))
                endif
             end if
          else !# No stochastic heating.
             if (present(sublim_temp)) then
                call compute_grain_X_lambda(1, (/temp_eq/), (/1._CDR/), dim_lambda_grains, &
                     lambda_grains, Q_abs(i_radius, :), grain_X_lambda(i_radius, :), &
                     sublim_temp, sublim_grain_X_lambda(i_radius, :))
             else
                call compute_grain_X_lambda(1, (/temp_eq/), (/1._CDR/), &
                     dim_lambda_grains, lambda_grains, Q_abs(i_radius, :), &
                     grain_X_lambda(i_radius, :))
                sublim_grain_X_lambda(i_radius, :) = 0
             endif

             if (do_output_grain .and. &
                  radius(i_radius) >= grain_output_min_size .and. &
                  radius(i_radius) <= grain_output_max_size) then
                if (grain_temp_output) &
                     call write_grain_temp(radius(i_radius), temp_eq)
                if (grain_SED_output) then
                   call write_grain_SED(radius(i_radius), &
                        grain_X_lambda(i_radius, :))
                end if
             endif
          endif
       endif
    end do

    call integrate_over_size(i_radius_min, i_radius_max, dim_lambda_grains, &
         grain_X_lambda, d_S_grain(:), lum_species_orig(:))
    if (present(sublim_temp) .and. present(sublim_lum_species_orig)) &
         call integrate_over_size(i_radius_min, i_radius_max, dim_lambda_grains, &
         sublim_grain_X_lambda, d_S_grain(:), sublim_lum_species_orig(:))
    
  end subroutine compute_lum_species

!#======================================================================

  subroutine compute_integrals_temp_eq(dim_lambda_grains, lambda_grains_interm, &
       Q_abs, RF, grain_bol_lum, &
       temp, radius, h_c_integral_qu, &
       integral_wqu, h_c_q_u, q_u_over_2, total_heat_rate, temp_eq)

    use mod_types
    use mod_constants, only : h_c, pi, um_to_cm, h_Planck
    use mod_interp, only : interp_lin_lin

    implicit none
    integer, intent(in) :: dim_lambda_grains
    real(DPR), dimension(:), intent(in) :: lambda_grains_interm
    real(CDR), dimension(:), intent(in) :: Q_abs, RF, grain_bol_lum, temp
    real(CDR), intent(in) :: radius
    real(DPR), dimension(:), intent(out) :: h_c_integral_qu, integral_wqu, &
         h_c_q_u, q_u_over_2
    real(CDR), intent(out) :: total_heat_rate, temp_eq
!#......................................................................
    integer :: i_temp_eq, dim_temp
    real(DPR) :: lambda_grains_inf, lambda_grains_sup, q_u
    integer :: i_lambda
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    dim_temp = size(temp)

    h_c_integral_qu(1) = 0
    integral_wqu(1) = 0
    do i_lambda = 1, dim_lambda_grains-1
       q_u = Q_abs(i_lambda)*RF(i_lambda)
       h_c_q_u(i_lambda) = h_c*q_u
       q_u_over_2(i_lambda) = q_u/2
       lambda_grains_inf = lambda_grains_interm(i_lambda)
       lambda_grains_sup = lambda_grains_interm(i_lambda+1)
       h_c_integral_qu(i_lambda+1) = h_c_integral_qu(i_lambda) + &
            (lambda_grains_sup-lambda_grains_inf)*h_c_q_u(i_lambda)
       integral_wqu(i_lambda+1) = integral_wqu(i_lambda) + &
            (lambda_grains_sup**2-lambda_grains_inf**2)*q_u_over_2(i_lambda)
    enddo
    q_u = Q_abs(dim_lambda_grains)*RF(dim_lambda_grains)
    h_c_q_u(dim_lambda_grains) = h_c*q_u
    q_u_over_2(dim_lambda_grains) = q_u/2
    lambda_grains_inf = lambda_grains_interm(dim_lambda_grains)
    lambda_grains_sup = lambda_grains_interm(dim_lambda_grains+1)
    h_c_integral_qu(dim_lambda_grains+1) = h_c_integral_qu(dim_lambda_grains) &
         +(lambda_grains_sup-lambda_grains_inf)*h_c_q_u(dim_lambda_grains)
    integral_wqu(dim_lambda_grains+1) = integral_wqu(dim_lambda_grains) &
         +(lambda_grains_sup**2-lambda_grains_inf**2) * &
         q_u_over_2(dim_lambda_grains)

    total_heat_rate = um_to_cm**3*pi*radius**2 * &
         h_c_integral_qu(dim_lambda_grains+1)/h_Planck
    i_temp_eq = 1
    do while(grain_bol_lum(i_temp_eq+1)-total_heat_rate < 0 .and. i_temp_eq < dim_temp-2)
       i_temp_eq = i_temp_eq+1
    enddo
    temp_eq = interp_lin_lin(grain_bol_lum(i_temp_eq)-total_heat_rate, grain_bol_lum(i_temp_eq+1) &
         -total_heat_rate, temp(i_temp_eq), temp(i_temp_eq+1), 0._CDR)

  end subroutine compute_integrals_temp_eq

!#======================================================================

  subroutine integrate_over_size(i_radius_min, i_radius_max, dim_lambda_grains, grain_X_lambda, &
       d_S_grain, lum_species_orig)

    use mod_types
    
    implicit none
    integer, intent(in) :: i_radius_min, i_radius_max, dim_lambda_grains
    real(CDR), dimension(:,:), intent(in) :: grain_X_lambda
    real(CDR), dimension(:), intent(in) :: d_S_grain
    real(CDR), dimension(:), intent(out) :: lum_species_orig
!#......................................................................
    integer :: i_lambda
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    do i_lambda = 1, dim_lambda_grains
       lum_species_orig(i_lambda) = 4*sum(grain_X_lambda(i_radius_min:i_radius_max, i_lambda) * &
            d_S_grain(i_radius_min:i_radius_max))
    enddo

  end subroutine integrate_over_size

!#======================================================================

  subroutine U_grid(species_id, nb_atoms, dim_temp, temp, grain_energ0, &
       T_interm, U_interm)

    use mod_types
    use mod_strings, only : quote_string
    use mod_constants, only : h_Planck, kB, c_cm
    use mod_interm_grid

    implicit none
    integer, intent(in) :: dim_temp
    character(len=*), intent(in) :: species_id
    real(CDR), intent(in) :: nb_atoms
    real(CDR), dimension(:), intent(in) :: temp
    real(CDR), dimension(:), intent(in) :: grain_energ0
    real(CDR), dimension(:), pointer :: T_interm, U_interm
!#......................................................................
    integer :: i_temp
    real(CDR), dimension(size(temp)) :: grain_energ
    real(CDR) :: nb_H
    real(CDR), parameter :: nu1 = c_cm*886._CDR, nu2 = c_cm*1161._CDR, &
         nu3 = c_cm*3030._CDR
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    do i_temp = 1, dim_temp
       if (species_id == "silicates") then !# Equation (34) of DL2001 = eq. (17) of LD2001.
          grain_energ(i_temp) = (nb_atoms-2) * grain_energ0(i_temp)
       else if (species_id == "graphites") then !# {Equation (33) of DL2001  = eq. (15) \
!#                                                  of LD2001} with nb_H = 0.
          grain_energ(i_temp) = (nb_atoms-2) * grain_energ0(i_temp)
       else if (species_id == "neutral PAHs" .or. species_id == "ionized PAHs") then
!# Equation (8) of DL2001 = eq. (4) of LD2001.
          if (nb_atoms <= 25) then
             nb_H = 0.5_CDR*nb_atoms
          else if (nb_atoms <= 100) then
             nb_H = 2.5_CDR*sqrt(nb_atoms)
          else
             nb_H = 0.25_CDR*nb_atoms
          endif
!# Equation (33) of DL2001 = eq. (15) of LD2001.
          grain_energ(i_temp) = (nb_atoms-2)* grain_energ0(i_temp) &
               + nb_H*(h_Planck*nu1/(exp(h_Planck*nu1/kB/temp(i_temp))-1) &
               + h_Planck*nu2/(exp(h_Planck*nu2/kB/temp(i_temp))-1) &
               + h_Planck*nu3/(exp(h_Planck*nu3/kB/temp(i_temp))-1))
       else
          write(*, "(a)") "Grain species " // quote_string(species_id) // &
               " unknown. Stopped."
          stop
       endif
    end do

!# Create *`_interm` grids.

    call interm_grid(dim_temp, temp, T_interm)
    call interm_grid(dim_temp, grain_energ, U_interm)

  end subroutine U_grid

!#======================================================================

  subroutine GD(dim_lambda_grains, radius, grain_bol_lum, dim_temp, &
       U_interm, prob, lambda_grains_interm, integral_wqu, h_c_q_u, q_u_over_2, &
       h_c_integral_qu, total_heat_rate)

    use mod_types
    use mod_constants, only : h_c, pi, um_to_cm, h_Planck
    use mod_interp, only : bracket, interp_lin_lin
    use mod_interm_grid

    implicit none
    integer, intent(in) :: dim_lambda_grains, dim_temp
    real(CDR), intent(in) :: radius
    real(CDR), dimension(:), intent(in) :: grain_bol_lum, U_interm
    real(DPR), dimension(:), intent(in) :: lambda_grains_interm
    real(DPR), dimension(:), intent(in) :: integral_wqu, &
         h_c_q_u, q_u_over_2, h_c_integral_qu
    real(CDR), intent(in) :: total_heat_rate
    real(CDR), dimension(:), pointer :: prob
!#......................................................................
    integer :: i_temp, f_temp, i_bracket, i_temp0
    real(DPR), parameter :: lambda_c = 1000._DPR !# `lambda_c` in micrometers.
    real(DPR), parameter :: h_c_over_lambda_c = h_c/lambda_c
    real(DPR) :: norm
    real(CDR) :: cont_heat_rate
    real(DPR), dimension(dim_temp, dim_temp) :: A, B
    real(DPR), dimension(dim_temp) :: dU_over_dtime, X
    real(CDR), dimension(:), pointer :: lum_interm => null()
    real(DPR) :: lambda_1, lambda_2, lambda_3, lambda_4, U_f_plus, U_f_minus, &
         U_i_plus, U_i_minus
    real(DPR) :: delta_U, delta_U_max, delta_U_min, h_c_integral_qu_1, &
         h_c_integral_qu_2, h_c_integral_qu_3, h_c_integral_qu_4
    real(DPR) :: integral_wqu_1, integral_wqu_2, integral_wqu_3, integral_wqu_4, &
         A_f_i
    real(DPR) :: fact, h_c_integral_qu_c, integral_wqu_c
    real(DPR) :: delta_U_f, delta_U_i, delta_U_f_plus_i_minus, &
         delta_U_f_minus_i_plus
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (associated(prob)) deallocate(prob)
    allocate(prob(dim_temp))

    norm = sqrt(huge(1.))
    fact = pi*radius**2*um_to_cm**3/h_Planck

    call interm_grid(dim_temp, grain_bol_lum, lum_interm)

    i_bracket = 0
    call bracket(dim_lambda_grains, lambda_grains_interm, lambda_c, i_bracket)
    h_c_integral_qu_c = integr(lambda_grains_interm, h_c_integral_qu(i_bracket), &
         h_c_q_u(i_bracket), 0, lambda_c, i_bracket)
    integral_wqu_c = integr(lambda_grains_interm, integral_wqu(i_bracket), &
         q_u_over_2(i_bracket), 1, lambda_c, i_bracket)
    cont_heat_rate = total_heat_rate - um_to_cm**3 * pi * radius**2 &
         * h_c_integral_qu_c/h_Planck
    i_temp0 = 1
    do while(lum_interm(i_temp0)-cont_heat_rate < 0 .and. i_temp0 < dim_temp-2)
       i_temp0 = i_temp0+1
    enddo
    dU_over_dtime(:) = cont_heat_rate-lum_interm(:dim_temp)
    dU_over_dtime(i_temp0) = 0

    A(:, :) = 0

!# Computation of A(f, f+1).

    do f_temp = i_temp0, dim_temp-1
       if (U_interm(f_temp+2) /= U_interm(f_temp+1)) then
          A(f_temp, f_temp+1) = -dU_over_dtime(f_temp+1) &
               /(U_interm(f_temp+2)-U_interm(f_temp+1))
       else
          A(f_temp, f_temp+1) = 0
       endif
    enddo

!# Computation of A(f, i) when i < f < dim_temp.

    do f_temp = i_temp0+1, dim_temp-1
       U_f_plus = U_interm(f_temp+1)
       U_f_minus = U_interm(f_temp)
       delta_U_f = U_f_plus-U_f_minus
       do i_temp = i_temp0, f_temp-1
          U_i_plus = U_interm(i_temp+1)
          U_i_minus = U_interm(i_temp)
          i_bracket = 0
          delta_U_f_plus_i_minus = U_f_plus-U_i_minus
          if (h_c_over_lambda_c < delta_U_f_plus_i_minus) then
             lambda_1 = h_c/delta_U_f_plus_i_minus
             call bracket(dim_lambda_grains, lambda_grains_interm, lambda_1, i_bracket)
             h_c_integral_qu_1 = integr(lambda_grains_interm, &
                  h_c_integral_qu(i_bracket), h_c_q_u(i_bracket), 0, lambda_1, i_bracket)
             integral_wqu_1 = integr(lambda_grains_interm, integral_wqu(i_bracket), &
                  q_u_over_2(i_bracket), 1, lambda_1, i_bracket)
             delta_U_i = U_i_plus-U_i_minus
             if (delta_U_f > delta_U_i) then
                delta_U_max = U_f_plus-U_i_plus
                delta_U_min = U_f_minus-U_i_minus
                delta_U = delta_U_i
             else
                delta_U_min = U_f_plus-U_i_plus
                delta_U_max = U_f_minus-U_i_minus
                delta_U = delta_U_f
             endif

             if (h_c_over_lambda_c < delta_U_max) then
                lambda_2 = h_c/delta_U_max
                call bracket(dim_lambda_grains, lambda_grains_interm, lambda_2, i_bracket)
                h_c_integral_qu_2 = integr(lambda_grains_interm, &
                     h_c_integral_qu(i_bracket), h_c_q_u(i_bracket), 0, lambda_2, i_bracket)
                integral_wqu_2 = integr(lambda_grains_interm, &
                     integral_wqu(i_bracket), q_u_over_2(i_bracket), 1, lambda_2, i_bracket)
                A_f_i = delta_U_f_plus_i_minus*(integral_wqu_2 &
                     -integral_wqu_1)-(h_c_integral_qu_2-h_c_integral_qu_1)

                if (h_c_over_lambda_c < delta_U_min) then
                   lambda_3 = h_c/delta_U_min
                   call bracket(dim_lambda_grains, lambda_grains_interm, lambda_3, i_bracket)
                   h_c_integral_qu_3 = integr(lambda_grains_interm, &
                        h_c_integral_qu(i_bracket), h_c_q_u(i_bracket), 0, lambda_3, i_bracket)
                   integral_wqu_3 = integr(lambda_grains_interm, &
                        integral_wqu(i_bracket), q_u_over_2(i_bracket), 1, lambda_3, i_bracket)

                   A_f_i = A_f_i+delta_U*(integral_wqu_3-integral_wqu_2)

                   delta_U_f_minus_i_plus = U_f_minus-U_i_plus
                   if (h_c_over_lambda_c < delta_U_f_minus_i_plus) then
                      lambda_4 = h_c/delta_U_f_minus_i_plus
                      call bracket(dim_lambda_grains, lambda_grains_interm, lambda_4, i_bracket)
                      h_c_integral_qu_4 = integr(lambda_grains_interm, &
                           h_c_integral_qu(i_bracket), h_c_q_u(i_bracket), 0, lambda_4, i_bracket)
                      integral_wqu_4 = integr(lambda_grains_interm, &
                           integral_wqu(i_bracket), q_u_over_2(i_bracket), 1, lambda_4, i_bracket)
                      A_f_i = A_f_i+delta_U_f_minus_i_plus*(integral_wqu_3 &
                           -integral_wqu_4) &
                           +(h_c_integral_qu_4-h_c_integral_qu_3)
                   else
                      A_f_i = A_f_i+delta_U_f_minus_i_plus*(integral_wqu_3 &
                           -integral_wqu_c) &
                           +(h_c_integral_qu_c-h_c_integral_qu_3)
                   endif

                else !# integration from lambda_2 to lambda_c; stop.
                   A_f_i = A_f_i+delta_U*(integral_wqu_c-integral_wqu_2)
                endif

             else !# integration from lambda_1 to lambda_c; stop.
                A_f_i = delta_U_f_plus_i_minus*(integral_wqu_c &
                     -integral_wqu_1)-(h_c_integral_qu_c-h_c_integral_qu_1)

             endif
             if (delta_U_i /= 0) then
                A(f_temp, i_temp) = fact*max(A_f_i, 0._DPR)/delta_U_i
             else
                A(f_temp, i_temp) = 0
             endif
          else
             A(f_temp, i_temp) = 0
          endif
       enddo
    enddo

!# Computation of A(f, i) when i < f = dim_temp.

    U_f_minus = U_interm(dim_temp)
    do i_temp = i_temp0, dim_temp-1
       U_i_plus = U_interm(i_temp+1)
       U_i_minus = U_interm(i_temp)
       delta_U_min = U_f_minus-U_i_minus
       i_bracket = 0
       if (h_c_over_lambda_c < delta_U_min) then
!# Integration from 0 to lambda_3.
          delta_U = U_i_plus-U_i_minus
          lambda_3 = h_c/delta_U_min
          call bracket(dim_lambda_grains, lambda_grains_interm, lambda_3, i_bracket)
          h_c_integral_qu_3 = integr(lambda_grains_interm, &
               h_c_integral_qu(i_bracket), h_c_q_u(i_bracket), 0, lambda_3, i_bracket)
          integral_wqu_3 = integr(lambda_grains_interm, integral_wqu(i_bracket), &
               q_u_over_2(i_bracket), 1, lambda_3, i_bracket)
          A_f_i = delta_U*integral_wqu_3

          delta_U_f_minus_i_plus = U_f_minus-U_i_plus
          if (h_c_over_lambda_c < delta_U_f_minus_i_plus) then
             lambda_4 = h_c/delta_U_f_minus_i_plus
             call bracket(dim_lambda_grains, lambda_grains_interm, lambda_4, i_bracket)
             h_c_integral_qu_4 = integr(lambda_grains_interm, &
                  h_c_integral_qu(i_bracket), h_c_q_u(i_bracket), 0, lambda_4, i_bracket)
             integral_wqu_4 = integr(lambda_grains_interm, integral_wqu(i_bracket), &
                  q_u_over_2(i_bracket), 1, lambda_4, i_bracket)
             A_f_i = A_f_i+delta_U_f_minus_i_plus*(integral_wqu_3 &
                  -integral_wqu_4) &
                  +(h_c_integral_qu_4-h_c_integral_qu_3)
          else
             A_f_i = A_f_i+delta_U_f_minus_i_plus*(integral_wqu_3 &
                  -integral_wqu_c) &
                  +(h_c_integral_qu_c-h_c_integral_qu_3)
          endif
          if (delta_U /= 0) then
             A(dim_temp, i_temp) = fact*max(A_f_i, 0._DPR)/delta_U
          else
             A(dim_temp, i_temp) = 0
          endif
       else !# Integration from 0 to lambda_c; stop.
          A(dim_temp, i_temp) = fact*integral_wqu_c
       endif
    enddo

    B(:, :) = 0
    B(dim_temp, i_temp0:dim_temp-1) = A(dim_temp, i_temp0:dim_temp-1)
    do f_temp = dim_temp-1, i_temp0, -1
       B(f_temp, i_temp0:f_temp-1) = B(f_temp+1, i_temp0:f_temp-1) &
            +A(f_temp, i_temp0:f_temp-1)
    enddo

    X(:) = 0
    X(i_temp0) = 1
    do f_temp = i_temp0+1, dim_temp
       if (A(f_temp-1, f_temp) /= 0) then
          X(f_temp) = sum(B(f_temp, i_temp0:f_temp-1)*X(i_temp0:f_temp-1))/ &
               A(f_temp-1, f_temp)
       else
          X(f_temp) = 0
       endif

       if (X(f_temp) > norm) then !# Renormalization if X is too big.
          X(:) = X(:)/norm
       endif
    enddo

!# `prob(i)`: probability of being between U_i_minus and U_i_plus.
    prob(1:dim_temp) = X(:)/sum(X)

!# Normalization to the luminosity of the grain (necessary if the bins are
!# too wide).
    prob(:) = prob(:)*total_heat_rate/sum(prob(:)*grain_bol_lum(:))

  end subroutine GD

!#======================================================================

  function integr(lambda_grains_interm, f, g, code, lambda, i_bracket)

    use mod_types
    
    implicit none
    integer, intent(in) :: code, i_bracket
    real(DPR), dimension(:), intent(in) :: lambda_grains_interm
    real(DPR), intent(in) :: lambda, f, g
    real(DPR) :: integr
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    if (i_bracket == 1) then
       if (lambda < lambda_grains_interm(1)) then
          integr = 0
       else
          if (code == 0) then
             integr = f+(lambda-lambda_grains_interm(i_bracket))*g
          else if (code == 1) then
             integr = f+(lambda-lambda_grains_interm(i_bracket))* &
                  (lambda+lambda_grains_interm(i_bracket))*g
          else
             write(*, "(a)") "Wrong value of `code` in function `integr` of &
                  &""mod_dust_emission.f90"". Stopped."
             stop
          end if
       endif
    else
       if (code == 0) then
          integr = f+(lambda-lambda_grains_interm(i_bracket))*g
       else if (code == 1) then
          integr = f+(lambda-lambda_grains_interm(i_bracket))* &
               (lambda+lambda_grains_interm(i_bracket))*g
       else
          write(*, "(a)") "Wrong value of `code` in function `integr` of &
               &""mod_dust_emission.f90"". Stopped."
          stop
       end if
    endif

  end function integr

!#======================================================================
!# Compute the spectral exitance of grains (i.e., the flux, per unit surface of a grain
!# and per unit wavelength, summed on all the directions in the half hemisphere above
!# the surface).

  subroutine compute_grain_X_lambda(dim_temp, temp, prob, &
       dim_lambda_grains, lambda_grains, Q_abs, grain_X_lambda, &
       sublim_temp, sublim_grain_X_lambda)

    use mod_types
    use mod_black_body, only : pi_B_lambda

    implicit none
    integer, intent(in) :: dim_lambda_grains, dim_temp
    real(CDR), dimension(:), intent(in) :: prob, Q_abs, temp, lambda_grains
    real(CDR), dimension(:), intent(out) :: grain_X_lambda
    real(CDR), intent(in), optional :: sublim_temp
    real(CDR), dimension(:), intent(out), optional :: sublim_grain_X_lambda
!#......................................................................
    integer :: i_lambda_grains, i_temp
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    do i_lambda_grains = 1, dim_lambda_grains
       grain_X_lambda(i_lambda_grains) = 0
       if (present(sublim_temp)) sublim_grain_X_lambda(i_lambda_grains) = 0
       do i_temp = 1, dim_temp
          grain_X_lambda(i_lambda_grains) = grain_X_lambda(i_lambda_grains) + &
               Q_abs(i_lambda_grains) * prob(i_temp) &
               * pi_B_lambda(temp(i_temp), lambda_grains(i_lambda_grains))
          if (present(sublim_temp)) then
             if (temp(i_temp) > sublim_temp) then
                sublim_grain_X_lambda(i_lambda_grains) = &
                     sublim_grain_X_lambda(i_lambda_grains) + &
                     Q_abs(i_lambda_grains) * prob(i_temp) & !# ??? No need to recompute this.
                     * pi_B_lambda(temp(i_temp), lambda_grains(i_lambda_grains))
             endif
          endif
       enddo
    enddo

  end subroutine compute_grain_X_lambda

!#======================================================================

  subroutine compute_grain_bol_lum(dim_radius, radius, dim_lambda_grains, lambda_grains, &
       Q_abs, temp, bol_lum)

    use mod_types
    use mod_constants, only : pi, in_um_to_in_cm
    use mod_black_body, only : pi_B_lambda
    
    implicit none
    integer, intent(in) :: dim_radius, dim_lambda_grains
    real(CDR), dimension(:), intent(in) :: radius
    real(CDR), dimension(:), intent(in) :: lambda_grains
    real(CDR), dimension(:, :), intent(in) :: Q_abs
    real(CDR), dimension(:), intent(in) :: temp
    real(CDR), dimension(:,:), pointer :: bol_lum
!#......................................................................
    integer :: i_lambda, i_radius, i_temp, dim_temp
    real(CDR) :: area
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    dim_temp = size(temp)

    if (associated(bol_lum)) deallocate(bol_lum)
    allocate(bol_lum(dim_radius, dim_temp))

    do i_radius = 1, dim_radius
       area = 4*pi*(radius(i_radius)*in_um_to_in_cm)**2
       do i_temp = 1, dim_temp
          bol_lum(i_radius, i_temp) = 0
          do i_lambda = 1, dim_lambda_grains-1
             bol_lum(i_radius, i_temp) = bol_lum(i_radius, i_temp) + &
                  (pi_B_lambda(temp(i_temp),lambda_grains(i_lambda)) * Q_abs(i_radius, i_lambda) + &
                  pi_B_lambda(temp(i_temp),lambda_grains(i_lambda+1)) * Q_abs(i_radius, i_lambda+1)) &
                  * (lambda_grains(i_lambda+1)-lambda_grains(i_lambda))/2
          enddo
          bol_lum(i_radius, i_temp) = area * bol_lum(i_radius, i_temp)
       end do
    end do

  end subroutine compute_grain_bol_lum

!#======================================================================

  subroutine compute_grain_energ(species_id, temp, grain_energ0, dim_Debye, u_Debye, &
       I2_Debye, I3_Debye)

    use mod_types
    use mod_interp,  only : bracket, interp_log_log
    use mod_constants, only : kB
    use mod_strings, only : quote_string

    implicit none
    character(len=*), intent(in) :: species_id
    real(CDR), dimension(:), intent(in) :: temp
    real(CDR), dimension(:), pointer :: grain_energ0 
    integer, intent(in) :: dim_Debye
    real(CDR), dimension(:), intent(in) :: u_Debye, I2_Debye, I3_Debye
!#......................................................................
    integer :: i_temp, dim_temp
    real(CDR), parameter :: theta2 = 500._CDR, theta3 = 1500._CDR, &
         theta_op = 863._CDR, theta_ip = 2504._CDR
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    dim_temp = size(temp)

    if (associated(grain_energ0)) deallocate(grain_energ0)
    allocate(grain_energ0(dim_temp))

    do i_temp = 1, dim_temp
       if (species_id == "silicates") then !# Eqs. (10) and (34) of DL2001 = eqs. (16) \
!#                                            and (17) of LD2001.
          grain_energ0(i_temp) = kB*(2*theta2*f_2_Debye(temp(i_temp)/theta2, dim_Debye, u_Debye, I2_Debye) &
               +theta3*f_3_Debye(temp(i_temp)/theta3, dim_Debye, u_Debye, I3_Debye))
       else if (species_id == "graphites" .or. species_id == "neutral PAHs" .or. &
            species_id == "ionized PAHs") then !# Eqs. (10) and (33) of DL2001 = eqs. (15) \
!#                                                and (16) of LD2001.
          grain_energ0(i_temp) = kB*(theta_op*f_2_Debye(temp(i_temp)/theta_op, dim_Debye, u_Debye, I2_Debye) &
               +2*theta_ip*f_2_Debye(temp(i_temp)/theta_ip, dim_Debye, u_Debye, I2_Debye))
       else
          write(*, "(a)") "Grain species " // quote_string(species_id) // &
               " unknown. Stopped."
          stop
       endif
    end do

  end subroutine compute_grain_energ

!#======================================================================
!# $f_n(x) = n x^{n+1} \int_{t=0}^u t^n dt/(e^t-1)$ (DL2001 give instead
!# "$f_n(x) = (1/n) x^{n+1} \int_{t=0}^u t^n dt/(e^t-1)$", which is wrong;
!# see file "dust_dir/Debye.txt").

  function f_2_Debye(x, dim_Debye, u_Debye, I2_Debye)

    use mod_types
    use mod_interp, only : bracket, interp_log_log

    implicit none
    real(CDR), intent(in) :: x
    integer, intent(in) :: dim_Debye
    real(CDR), dimension(:), intent(in) :: u_Debye, I2_Debye
!#......................................................................
    real(CDR) :: f_2_Debye, inv_x
    integer :: i_bracket
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    inv_x = 1/x
    if (inv_x < u_Debye(1)) then
       f_2_Debye = x
    else if (inv_x > u_Debye(dim_Debye)) then
       f_2_Debye = x**3*I2_Debye(dim_Debye)
    else
       i_bracket = 0
       call bracket(dim_Debye, u_Debye, inv_x, i_bracket)
       f_2_Debye = x**3*interp_log_log(u_Debye(i_bracket), u_Debye(i_bracket+1), I2_Debye(i_bracket), I2_Debye(i_bracket+1), inv_x)
    endif

  end function f_2_Debye

!#======================================================================

  function f_3_Debye(x, dim_Debye, u_Debye, I3_Debye)

    use mod_types
    use mod_interp, only : bracket, interp_log_log
    implicit none
    real(CDR), intent(in) :: x
    integer, intent(in) :: dim_Debye
    real(CDR), dimension(:), intent(in) :: u_Debye, I3_Debye
!#......................................................................
    real(CDR) :: f_3_Debye, inv_x
    integer :: i_bracket
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    inv_x = 1/x
    if (inv_x < u_Debye(1)) then
       f_3_Debye = x
    else if (inv_x > u_Debye(dim_Debye)) then
       f_3_Debye = x**4*I3_Debye(dim_Debye)
    else
       i_bracket = 0
       call bracket(dim_Debye, u_Debye, inv_x, i_bracket)
       f_3_Debye = x**4*interp_log_log(u_Debye(i_bracket), u_Debye(i_bracket+1), I3_Debye(i_bracket), I3_Debye(i_bracket+1), inv_x)
    endif

  end function f_3_Debye

!#======================================================================

  subroutine read_Debye(dim_Debye, u_Debye, I2_Debye, I3_Debye)

    use mod_directories, only : dust_dir
    use mod_types, only : CDR
    use mod_file_access, only : open_file, close_file, path_file

    implicit none
    integer, intent(out) :: dim_Debye
    real(CDR), dimension(:), pointer :: u_Debye, I2_Debye, I3_Debye
!#......................................................................
    integer :: unit, i_Debye
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call open_file(unit, path_file(dust_dir, "Debye.txt"))
    read(unit,*) dim_Debye
    if (associated(u_Debye)) deallocate(u_Debye)
    allocate(u_Debye(dim_Debye))
    if (associated(I2_Debye)) deallocate(I2_Debye)
    allocate(I2_Debye(dim_Debye))
    if (associated(I3_Debye)) deallocate(I3_Debye)
    allocate(I3_Debye(dim_Debye))
    do i_Debye = 1, dim_Debye
       read(unit,*) u_Debye(i_Debye), I2_Debye(i_Debye), I3_Debye(i_Debye)
    enddo
    call close_file(unit)

  end subroutine read_Debye

!#======================================================================

  subroutine write_grain_temp(radius, temp_eq, dim_temp, temp, &
       T_interm, prob)
    
    use mod_types

    implicit none
    real(CDR), intent(in) :: radius, temp_eq
    integer, intent(in), optional :: dim_temp
    real(CDR), dimension(:), intent(in), optional :: temp, T_interm, prob
!#......................................................................
    integer :: i_temp
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(prob)) then
       write(unit_grain_temp, "(2(es10.4,tr1),i0,a)") radius, temp_eq, dim_temp, &
            " !# `radius`, etc."
       do i_temp = 1, dim_temp
          write(unit_grain_temp, "(2(es10.4,tr1))") temp(i_temp), &
               prob(i_temp)/log10(T_interm(i_temp+1)/T_interm(i_temp))
       enddo
    else
       write(unit_grain_temp, "(2(es10.4,tr1),a)") radius, temp_eq, &
            " !# `radius`, etc."
    end if
    
  end subroutine write_grain_temp

!#======================================================================

  subroutine write_grain_SED(radius, grain_X_lambda, grain_X_lambda_eq)

!# Outputs the monochromatic luminosity of a single grain in erg.s-1.um-1.
!# The exitance `grain_X_lambda` of the grain is in erg.s-1.um-1.cm-2;
!# its radius is in um.

    use mod_types
    use mod_constants, only : pi, in_um_to_in_cm
    use mod_convert_type, only : E_format

    implicit none
    real(CDR), intent(in) :: radius
    real(CDR), dimension(:), intent(in) :: grain_X_lambda
    real(CDR), dimension(:), intent(in), optional :: grain_X_lambda_eq
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    if (present(grain_X_lambda_eq)) then
       write(unit_grain_SED, "(es10.4,a)") radius, " !# `radius`."
       write(unit_grain_SED, "(10(a10,tr1))") &
            E_format(4*pi*(radius*in_um_to_in_cm)**2*grain_X_lambda(:), 10, 4)
       write(unit_grain_SED, "(10(a10,tr1))") &
            E_format(4*pi*(radius*in_um_to_in_cm)**2*grain_X_lambda_eq(:), 10, 4)
    else
       write(unit_grain_SED, "(es10.4,a)") radius, " !# `radius`."
       write(unit_grain_SED, "(10(a10,tr1))") &
            E_format(4*pi*(radius*in_um_to_in_cm)**2*grain_X_lambda(:), 10, 4)
    endif

  end subroutine write_grain_SED

end module mod_dust_emission

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_read_dust_evol_param

  use mod_types
  use mod_analyze_statement, only : get_val, file_name, line_number, &
       error_message, warning_message

  implicit none
  public
  real(CDR), save :: ISM_carb_deplet, ISM_sil_deplet, &
       CCSN_carb_deplet, HMW_carb_deplet, LMW_carb_deplet, &
       CCSN_sil_deplet, HMW_sil_deplet, LMW_sil_deplet, &
       SN_swept_mass, SNIa_carb_deplet, SNIa_sil_deplet, &
       carb_accr_timescale, sil_accr_timescale, O_sil_ratio

  character(len=std_string), save :: dust_evolution

contains

!#======================================================================

  subroutine reset_dust_evol

    use mod_spectra_def_param
    implicit none
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    dust_evolution = dust_evolution_def

    O_sil_ratio = O_sil_ratio_def

    ISM_carb_deplet = ISM_carb_deplet_def
    ISM_sil_deplet = ISM_sil_deplet_def

    CCSN_carb_deplet = CCSN_carb_deplet_def
    SNIa_carb_deplet = SNIa_carb_deplet_def
    HMW_carb_deplet = HMW_carb_deplet_def
    LMW_carb_deplet = LMW_carb_deplet_def
    CCSN_sil_deplet = CCSN_sil_deplet_def
    SNIa_sil_deplet = SNIa_sil_deplet_def
    HMW_sil_deplet = HMW_sil_deplet_def
    LMW_sil_deplet = LMW_sil_deplet_def
    SN_swept_mass = SN_swept_mass_def
    carb_accr_timescale = carb_accr_timescale_def
    sil_accr_timescale = sil_accr_timescale_def

  end subroutine reset_dust_evol

!#======================================================================

  subroutine dust_evol_check
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

  end subroutine dust_evol_check

!#======================================================================

  subroutine read_dust_evolution(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(dust_evolution, rhs)
    if (all(dust_evolution /= (/ &
         "basic", &
         "Dwek "/))) &
         call error_message("The value of `dust_evolution` should be &
         &""basic"" or ""Dwek"".")

  end subroutine read_dust_evolution

!#======================================================================

  subroutine read_O_sil_ratio(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(O_sil_ratio, rhs)

  end subroutine read_O_sil_ratio

!#======================================================================

  subroutine read_ISM_carb_deplet(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(ISM_carb_deplet, rhs)
    call set_dust_evolution("basic")

  end subroutine read_ISM_carb_deplet

!#======================================================================

  subroutine read_ISM_sil_deplet(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(ISM_sil_deplet, rhs)
    call set_dust_evolution("basic")

  end subroutine read_ISM_sil_deplet

!#======================================================================

  subroutine read_CCSN_carb_deplet(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(CCSN_carb_deplet, rhs)
    call set_dust_evolution("Dwek")

  end subroutine read_CCSN_carb_deplet

!#======================================================================

  subroutine read_SNIa_carb_deplet(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(SNIa_carb_deplet, rhs)
    call set_dust_evolution("Dwek")

  end subroutine read_SNIa_carb_deplet

!#======================================================================

  subroutine read_HMW_carb_deplet(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(HMW_carb_deplet, rhs)
    call set_dust_evolution("Dwek")

  end subroutine read_HMW_carb_deplet

!#======================================================================

  subroutine read_LMW_carb_deplet(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(LMW_carb_deplet, rhs)
    call set_dust_evolution("Dwek")

  end subroutine read_LMW_carb_deplet

!#======================================================================

  subroutine read_CCSN_sil_deplet(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(CCSN_sil_deplet, rhs)
    call set_dust_evolution("Dwek")

  end subroutine read_CCSN_sil_deplet

!#======================================================================

  subroutine read_SNIa_sil_deplet(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(SNIa_sil_deplet, rhs)
    call set_dust_evolution("Dwek")

  end subroutine read_SNIa_sil_deplet

!#======================================================================

  subroutine read_HMW_sil_deplet(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(HMW_sil_deplet, rhs)
    call set_dust_evolution("Dwek")

  end subroutine read_HMW_sil_deplet

!#======================================================================

  subroutine read_LMW_sil_deplet(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(LMW_sil_deplet, rhs)
    call set_dust_evolution("Dwek")

  end subroutine read_LMW_sil_deplet

!#======================================================================

  subroutine read_SN_swept_mass(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(SN_swept_mass, rhs)
    call set_dust_evolution("Dwek")

  end subroutine read_SN_swept_mass

!#======================================================================

  subroutine read_carb_accr_timescale(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(carb_accr_timescale, rhs)
    call set_dust_evolution("Dwek")

  end subroutine read_carb_accr_timescale

!#======================================================================

  subroutine read_sil_accr_timescale(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(sil_accr_timescale, rhs)
    call set_dust_evolution("Dwek")

  end subroutine read_sil_accr_timescale

!#======================================================================

  subroutine set_dust_evolution(val_dust_evolution)

    implicit none
    character(len=*), intent(in) :: val_dust_evolution
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    dust_evolution = val_dust_evolution

  end subroutine set_dust_evolution

end module mod_read_dust_evol_param

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_read_SF_param

  use mod_types
  use mod_analyze_statement, only : get_val, file_name, line_number, &
       error_message, warning_message
  use mod_convert_type, only : to_string
  use mod_spectra_constants, only : max_dim_SF_epis

  implicit none
  public
  real(CDR), dimension(max_dim_SF_epis), save :: SF_begin_time, SF_end_time
  character(len=std_string), dimension(max_dim_SF_epis), save :: SF_type
  real(CDR), dimension(max_dim_SF_epis), save :: SF_inst_mass, &
       SF_const_mass, &
       SF_expo_timescale, SF_expo_mass, &
       SF_peaked_timescale, SF_peaked_mass, &
       SF_ISM_timescale, SF_ISM_power, SF_ISM_threshold, &
       SF_infall_factor
  character(len=std_string), dimension(max_dim_SF_epis), save :: SF_file
  integer, dimension(max_dim_SF_epis), save :: SF_file_dim_time
  type(irreg_array_CDR), dimension(max_dim_SF_epis), save :: SF_file_time, &
       SF_file_rate

  logical, dimension(max_dim_SF_epis), save :: SF_stochastic
  real(CDR), dimension(max_dim_SF_epis), save :: SF_stoch_sigma, & !# Used in \
!# subroutine `evolution`, but not an input parameter: derived from \
!# `SF_stoch_fluc`.
       SF_stoch_fluc, & !# Output by subroutine `write_scenario_param`.
       SF_stoch_timescale
  character(len=std_string), dimension(max_dim_SF_epis), save :: SF_Z_type
  real(CDR), dimension(max_dim_SF_epis), save :: SF_Z_const_val
  character(len=std_string), dimension(max_dim_SF_epis), save :: SF_Z_file
  integer, dimension(max_dim_SF_epis), save :: SF_Z_file_dim_time
  type(irreg_array_CDR), dimension(max_dim_SF_epis), save :: SF_Z_file_time, &
       SF_Z_file_Z
  real(CDR), dimension(max_dim_SF_epis), save :: SF_inert_frac

!# Variables for which no default value exists.

  logical, dimension(max_dim_SF_epis), private :: SF_file_set, &
       SF_expo_timescale_set, &
       SF_peaked_timescale_set, &
       SF_ISM_timescale_set, &
       SF_stoch_fluc_set, SF_stoch_timescale_set, &
       SF_Z_const_val_set, &
       SF_Z_file_set

contains

!#======================================================================
  
  subroutine reset_SF

    use mod_spectra_def_param
    implicit none
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    SF_begin_time(:) = SF_begin_time_def
    SF_end_time(:) = SF_end_time_def

    SF_type(:) = SF_type_def

    SF_inst_mass(:) = SF_inst_mass_def

    SF_const_mass(:) = SF_const_mass_def

    SF_expo_timescale_set(:) = .false.
    SF_expo_mass(:) = SF_expo_mass_def

    SF_peaked_timescale_set(:) = .false.
    SF_peaked_mass(:) = SF_peaked_mass_def

    SF_ISM_timescale_set(:) = .false.
    SF_ISM_power(:) = SF_ISM_power_def
    SF_ISM_threshold(:) = SF_ISM_threshold_def

    SF_infall_factor(:) = SF_infall_factor_def

    SF_file_set(:)  = .false.

    SF_stochastic(:) = SF_stochastic_def
    SF_stoch_fluc_set(:) = .false.
    where (SF_stoch_fluc_set(:)) SF_stoch_sigma(:) = &
         sqrt(log(1+SF_stoch_fluc(:)**2))
    SF_stoch_timescale_set(:) = .false.

    SF_Z_type(:) = SF_Z_type_def
    SF_Z_const_val_set(:) = .false.
    SF_Z_file_set(:) = .false.

    SF_inert_frac(:) = SF_inert_frac_def

  end subroutine reset_SF

!#======================================================================

  subroutine SF_check

    implicit none
!#......................................................................
    integer :: i_epis
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    do i_epis = 1, max_dim_SF_epis
       if (SF_type(i_epis) == "none") cycle

       if (SF_type(i_epis) == "exponential") then
          if (.not. SF_expo_timescale_set(i_epis)) then
             call error_message("Value of `SF_expo_timescale(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
       endif

       if (SF_type(i_epis) == "peaked") then
          if (.not. SF_peaked_timescale_set(i_epis)) then
             call error_message("Value of `SF_peaked_timescale(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
       endif

       if (SF_type(i_epis) == "ISM_mass") then
          if (.not. SF_ISM_timescale_set(i_epis)) then
             call error_message("Value of `SF_ISM_timescale(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
       endif
 
       if (SF_type(i_epis) == "file") then
          if (.not. SF_file_set(i_epis)) then
             call error_message("Value of `SF_file(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
       endif

       if (SF_stochastic(i_epis)) then
          if (.not. SF_stoch_fluc_set(i_epis)) then
             call error_message("Value of `SF_stoch_fluc(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
          if (.not. SF_stoch_timescale_set(i_epis)) then
             call error_message("Value of `SF_stoch_timescale(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
       endif

       if (SF_Z_type(i_epis) == "file") then
          if (.not. SF_Z_file_set(i_epis)) then
             call error_message("Value of `SF_Z_file(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
       else if (SF_Z_type(i_epis) == "constant") then
          if (.not. SF_Z_const_val_set(i_epis)) then
             call error_message("Value of `SF_Z_const_val(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
       endif

       if (SF_end_time(i_epis) <= SF_begin_time(i_epis)) then
          call warning_message("Warning: `SF_end_time(" // &
               to_string(i_epis) // ")` = " // &
               to_string(SF_end_time(i_epis), "(f6.0)") // &
               " <= `SF_begin_time(" // to_string(i_epis) // ")` = " // &
               to_string(SF_begin_time(i_epis), "(f6.0)") // ".")
       endif
    enddo

  end subroutine SF_check

!#======================================================================

  subroutine read_SF_begin_time(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_begin_time, rhs, indices_string, index_present)
    where (SF_begin_time(:) > 0)
!# To make sure that the interval is closed on the left.
       SF_begin_time(:) = nearest(SF_begin_time(:), -1.) 
    end where

  end subroutine read_SF_begin_time

!#======================================================================

  subroutine read_SF_end_time(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_end_time, rhs, indices_string, index_present)
    where (SF_end_time(:) > 0)
!# To make sure that the interval is open on the right.
       SF_end_time(:) = nearest(SF_end_time(:), -1.)
    end where

  end subroutine read_SF_end_time

!#======================================================================

  subroutine read_SF_type(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
    integer :: i_epis
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_type, rhs, indices_string, index_present)
    do i_epis = 1, max_dim_SF_epis
       if (index_present(i_epis)) then
          if (all(SF_type(i_epis) /= (/ &
               "none         ", &
               "instantaneous", &
               "constant     ", &
               "exponential  ", &
               "peaked       ", &
               "ISM_mass     ", &
               "infall       ", &
               "file         "/))) &
               call error_message("The value of `SF_type(" // &
               to_string(i_epis) // ")` should be ""none"", &
               &""instantaneous"", ""constant"", ""exponential"", &
               &""peaked"", ""ISM_mass"", ""infall"" or ""file"".")
       endif
    enddo

  end subroutine read_SF_type

!#======================================================================

  subroutine read_SF_inst_mass(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_inst_mass, rhs, indices_string, index_present)
    call set_SF_type(index_present, "instantaneous")

  end subroutine read_SF_inst_mass

!#======================================================================

  subroutine read_SF_const_mass(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_const_mass, rhs, indices_string, index_present)
    call set_SF_type(index_present, "constant")

  end subroutine read_SF_const_mass

!#======================================================================

  subroutine read_SF_expo_timescale(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_expo_timescale, rhs, indices_string, index_present)
    where (index_present(:)) SF_expo_timescale_set(:) = .true.
    call set_SF_type(index_present, "exponential")

  end subroutine read_SF_expo_timescale

!#======================================================================

  subroutine read_SF_expo_mass(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_expo_mass, rhs, indices_string, index_present)
    call set_SF_type(index_present, "exponential")

  end subroutine read_SF_expo_mass

!#======================================================================
  
!# Parametrization of Sandage-like (1986; A&A 161, 89) star formation 
!# histories.

  subroutine read_SF_peaked_timescale(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_peaked_timescale, rhs, indices_string, index_present)
    where (index_present(:)) SF_peaked_timescale_set(:) = .true.
    call set_SF_type(index_present, "peaked")

  end subroutine read_SF_peaked_timescale

!#======================================================================

  subroutine read_SF_peaked_mass(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_peaked_mass, rhs, indices_string, index_present)
    call set_SF_type(index_present, "peaked")

  end subroutine read_SF_peaked_mass

!#======================================================================

  subroutine read_SF_ISM_timescale(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_ISM_timescale, rhs, indices_string, index_present)
    where (index_present(:)) SF_ISM_timescale_set(:) = .true.
    call set_SF_type(index_present, "ISM_mass")

  end subroutine read_SF_ISM_timescale

!#======================================================================

  subroutine read_SF_ISM_power(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_ISM_power, rhs, indices_string, index_present)
    call set_SF_type(index_present, "ISM_mass")

  end subroutine read_SF_ISM_power

!#======================================================================

  subroutine read_SF_ISM_threshold(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_ISM_threshold, rhs, indices_string, index_present)
    call set_SF_type(index_present, "ISM_mass")

  end subroutine read_SF_ISM_threshold

!#======================================================================

  subroutine read_SF_infall_factor(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_infall_factor, rhs, indices_string, index_present)
    call set_SF_type(index_present, "infall")

  end subroutine read_SF_infall_factor

!#======================================================================

  subroutine read_SF_file(rhs, indices_string)

    use mod_strings, only : same_case_equal
    use mod_directories, only : scenarios_dir
    use mod_read_columns
    use mod_file_access, only : path_file

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    integer :: i_epis
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_file, rhs, indices_string, index_present)

    do i_epis = 1, max_dim_SF_epis
       if (index_present(i_epis)) then
          call read_columns(path_file(scenarios_dir, adjustl(SF_file(i_epis))), &
               SF_file_dim_time(i_epis), SF_file_time(i_epis) % val, &
               SF_file_rate(i_epis) % val)
       endif
    enddo

    where (index_present(:)) SF_file_set(:) = .true.
    call set_SF_type(index_present, "file")

  end subroutine read_SF_file

!#======================================================================

  subroutine read_SF_stochastic(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_stochastic, rhs, indices_string, index_present)

  end subroutine read_SF_stochastic

!#======================================================================

  subroutine read_SF_stoch_fluc(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_stoch_fluc, rhs, indices_string, index_present)
    where (index_present(:))
       SF_stoch_fluc_set(:) = .true.
       SF_stoch_sigma(:) = sqrt(log(1+SF_stoch_fluc(:)**2))
    end where
    call set_SF_stochastic(index_present)

  end subroutine read_SF_stoch_fluc

!#======================================================================

  subroutine read_SF_stoch_timescale(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_stoch_timescale, rhs, indices_string, index_present)
    where (index_present(:)) SF_stoch_timescale_set(:) = .true.
    call set_SF_stochastic(index_present)

  end subroutine read_SF_stoch_timescale

!#======================================================================

  subroutine read_SF_Z_type(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
    integer :: i_epis
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_Z_type, rhs, indices_string, index_present)
    do i_epis = 1, max_dim_SF_epis
       if (index_present(i_epis)) then
          if (all(SF_Z_type(i_epis) /= (/ &
               "consistent", &
               "constant  ", &
               "file      "/))) &
               call error_message("The value of `SF_Z_type(" // &
               to_string(i_epis) // ")` should be ""consistent"", &
               &""constant"" or ""file"".")
       endif
    enddo

  end subroutine read_SF_Z_type

!#======================================================================

  subroutine read_SF_Z_const_val(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_Z_const_val, rhs, indices_string, index_present)
    where (index_present(:)) SF_Z_const_val_set(:) = .true.
    call set_SF_Z_type(index_present, "constant")

  end subroutine read_SF_Z_const_val

!#======================================================================

  subroutine read_SF_Z_file(rhs, indices_string)

    use mod_strings, only : same_case_equal
    use mod_directories, only : scenarios_dir
    use mod_read_columns
    use mod_file_access, only : path_file
    
    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    integer :: i_epis
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_Z_file, rhs, indices_string, index_present)

    do i_epis = 1, max_dim_SF_epis
       if (index_present(i_epis)) then
          call read_columns(path_file(scenarios_dir, adjustl(SF_Z_file(i_epis))), &
               SF_Z_file_dim_time(i_epis), SF_Z_file_time(i_epis) % val, &
               SF_Z_file_Z(i_epis) % val)
       endif
    enddo

    where (index_present(:)) SF_Z_file_set(:) = .true.
    call set_SF_Z_type(index_present, "file")

  end subroutine read_SF_Z_file

!#======================================================================

  subroutine read_SF_inert_frac(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_SF_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(SF_inert_frac, rhs, indices_string, index_present)

  end subroutine read_SF_inert_frac

!#======================================================================

  subroutine set_SF_type(index_present, string)

    implicit none
    logical, dimension(:), intent(in) :: index_present
    character(len=*), intent(in) :: string
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    where (index_present(:)) SF_type(:) = string

  end subroutine set_SF_type

!#======================================================================

  subroutine set_SF_stochastic(index_present)

    implicit none
    logical, dimension(:), intent(in) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    where (index_present(:)) SF_stochastic(:) = .true.

  end subroutine set_SF_stochastic

!#======================================================================

  subroutine set_SF_Z_type(index_present, string)

    implicit none
    logical, dimension(:), intent(in) :: index_present
    character(len=*), intent(in) :: string
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    where (index_present(:)) SF_Z_type(:) = string

  end subroutine set_SF_Z_type

end module mod_read_SF_param

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_read_cloud_neb_param

  use mod_types
  use mod_analyze_statement, only : get_val, file_name, line_number, &
       error_message, warning_message

  implicit none
  public
  logical, save :: nebular_emission, nebular_emission_SFC, nebular_emission_DISM
  character(len=std_string), save :: neb_emis_type, neb_emis_type_SFC, neb_emis_type_DISM
  real(CDR), save :: cluster_stel_mass, cloud_init_frac, cloud_power, &
       cloud_duration, neb_emis_const_frac, neb_emis_const_frac_SFC, neb_emis_const_frac_DISM, l10_mean_U_DISM

  private :: nebular_emission, neb_emis_type, neb_emis_const_frac

contains

!#======================================================================
  
  subroutine reset_cloud_neb

    use mod_spectra_def_param
    implicit none
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    nebular_emission_SFC = nebular_emission_SFC_def
    nebular_emission_DISM = nebular_emission_DISM_def
    neb_emis_type_SFC = neb_emis_type_SFC_def
    neb_emis_const_frac_SFC = neb_emis_const_frac_SFC_def
    neb_emis_type_DISM = neb_emis_type_DISM_def
    neb_emis_const_frac_DISM = neb_emis_const_frac_DISM_def
    l10_mean_U_DISM = l10_mean_U_DISM_def
    cluster_stel_mass = cluster_stel_mass_def
    cloud_init_frac = cloud_init_frac_def
    cloud_power = cloud_power_def
    cloud_duration = cloud_duration_def

  end subroutine reset_cloud_neb

!#======================================================================

  subroutine cloud_neb_check

    implicit none
!# ???
  end subroutine cloud_neb_check

!#======================================================================

  subroutine read_nebular_emission(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(nebular_emission, rhs)
    nebular_emission_SFC = nebular_emission
    nebular_emission_DISM = nebular_emission

  end subroutine read_nebular_emission

!#======================================================================

  subroutine read_nebular_emission_SFC(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(nebular_emission_SFC, rhs)

  end subroutine read_nebular_emission_SFC
!#======================================================================

  subroutine read_nebular_emission_DISM(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(nebular_emission_DISM, rhs)

  end subroutine read_nebular_emission_DISM

!#======================================================================

  subroutine read_neb_emis_type(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(neb_emis_type, rhs)

    if (all(neb_emis_type /= (/ &
         "automatic", &
         "constant "/))) then
       call error_message("The value of `neb_emis_type` should be &
            &""automatic"" or ""constant"".")
    else
       neb_emis_type_SFC = neb_emis_type
       neb_emis_type_DISM = neb_emis_type
       call set_nebular_emission_SFC(.true.)
       call set_nebular_emission_DISM(.true.)
    endif

  end subroutine read_neb_emis_type

!#======================================================================

  subroutine read_neb_emis_type_SFC(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(neb_emis_type_SFC, rhs)

    if (all(neb_emis_type_SFC /= (/ &
         "automatic", &
         "constant "/))) then
       call error_message("The value of `neb_emis_type_SFC` should be &
            &""automatic"" or ""constant"".")
    else
       call set_nebular_emission_SFC(.true.)
    endif

  end subroutine read_neb_emis_type_SFC

!#======================================================================

  subroutine read_neb_emis_type_DISM(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(neb_emis_type_DISM, rhs)

    if (all(neb_emis_type_DISM /= (/ &
         "automatic", &
         "constant "/))) then
       call error_message("The value of `neb_emis_type_DISM` should be &
            &""automatic"" or ""constant"".")
    else
       call set_nebular_emission_DISM(.true.)
    endif

  end subroutine read_neb_emis_type_DISM

!#======================================================================

  subroutine read_neb_emis_const_frac(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(neb_emis_const_frac, rhs)
    neb_emis_const_frac_SFC = neb_emis_const_frac
    neb_emis_const_frac_DISM = neb_emis_const_frac    
    call set_neb_emis_type_SFC("constant")
    call set_neb_emis_type_DISM("constant")

  end subroutine read_neb_emis_const_frac

!#======================================================================

  subroutine read_neb_emis_const_frac_SFC(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(neb_emis_const_frac_SFC, rhs)
    call set_neb_emis_type_SFC("constant")

  end subroutine read_neb_emis_const_frac_SFC

!#======================================================================

  subroutine read_neb_emis_const_frac_DISM(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(neb_emis_const_frac_DISM, rhs)
    call set_neb_emis_type_DISM("constant")

  end subroutine read_neb_emis_const_frac_DISM

!#======================================================================

  subroutine read_l10_mean_U_DISM(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(l10_mean_U_DISM, rhs)

  end subroutine read_l10_mean_U_DISM

!#======================================================================

  subroutine set_nebular_emission_SFC(val_nebular_emission)

    implicit none
    logical, intent(in) :: val_nebular_emission
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    nebular_emission_SFC = val_nebular_emission

  end subroutine set_nebular_emission_SFC

!#======================================================================

  subroutine set_nebular_emission_DISM(val_nebular_emission)

    implicit none
    logical, intent(in) :: val_nebular_emission
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    nebular_emission_DISM = val_nebular_emission

  end subroutine set_nebular_emission_DISM

!#======================================================================

  subroutine set_neb_emis_type_SFC(val_neb_emis_type)

    implicit none
    character(len=*), intent(in) :: val_neb_emis_type
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    neb_emis_type_SFC = val_neb_emis_type
    call set_nebular_emission_SFC(.true.)

  end subroutine set_neb_emis_type_SFC

!#======================================================================

  subroutine set_neb_emis_type_DISM(val_neb_emis_type)

    implicit none
    character(len=*), intent(in) :: val_neb_emis_type
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    neb_emis_type_DISM = val_neb_emis_type
    call set_nebular_emission_DISM(.true.)

  end subroutine set_neb_emis_type_DISM

!#======================================================================

  subroutine read_cluster_stel_mass(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(cluster_stel_mass, rhs)

  end subroutine read_cluster_stel_mass

!#======================================================================

  subroutine read_cloud_init_frac(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(cloud_init_frac, rhs)

  end subroutine read_cloud_init_frac

!#======================================================================

  subroutine read_cloud_power(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(cloud_power, rhs)

  end subroutine read_cloud_power

!#======================================================================

  subroutine read_cloud_duration(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(cloud_duration, rhs)

  end subroutine read_cloud_duration

end module mod_read_cloud_neb_param

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_cosmo

  use mod_types
  implicit none
  private
  public :: fn_cosmic_time, fn_redshift

contains

!#======================================================================
!# Cosmic time as a function of redshift, assuming Omega_m + Omega_Lambda = 1.

  function fn_cosmic_time(redshift)

    use mod_constants, only : H_0_unit
    use mod_read_cosmo_param, only : Omega_m, H_0
    implicit none
    real(CDR), intent(in) :: redshift
    real(CDR) :: fn_cosmic_time

!# Cosmic time = f(z) for a flat Universe with a cosmpological constant.
!# Density of radiation neglected with regard to that of matter.
!# Ref.: Peebles, "Principles of physical cosmology", ed. 1993, p. 317.

    fn_cosmic_time = 2*arsinh(sqrt((1-Omega_m)/Omega_m/(1+redshift)**3))/3/ &
         H_0/H_0_unit/sqrt(1-Omega_m)

  end function fn_cosmic_time

!#======================================================================

  function fn_redshift0(age, form_redshift)

    implicit none
    real(CDR), intent(in) :: age, form_redshift
    real(CDR) :: fn_redshift0
!#......................................................................
    real(CDR), parameter :: epsilon_redshift = 1.e-6
    real(CDR) :: redshift1, redshift2, redshift_mid, age_mid, t_for
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    redshift1 = -1
    redshift2 = form_redshift
    t_for = fn_cosmic_time(form_redshift)

    do
       redshift_mid = (redshift1 + redshift2)/2
       age_mid = fn_cosmic_time(redshift_mid) - t_for
       if (age > age_mid) then
          redshift2 = redshift_mid
       else
          redshift1 = redshift_mid
       endif
       if (redshift2 - redshift1 < epsilon_redshift) exit
    enddo
    fn_redshift0 = redshift_mid

  end function fn_redshift0

!#======================================================================

  function fn_redshift(cosmic_time)

    implicit none
    real(CDR), intent(in) :: cosmic_time
    real(CDR) :: fn_redshift
!#......................................................................
    real(CDR), parameter :: epsilon_redshift = 1.e-6
    real(CDR) :: redshift1, redshift2, redshift_mid, cosmic_time0, cosmic_time_mid
    real(CDR) :: scale_factor1, scale_factor2, scale_factor_mid
    logical :: use_scale_factor
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    cosmic_time0 = fn_cosmic_time(0._CDR)
    if (cosmic_time > cosmic_time0) then
       redshift1 = -1
       redshift2 = 0
       use_scale_factor = .false.
    else 
       scale_factor1 = 1
       scale_factor2 = 0
       redshift1 = 0
       redshift2 = huge(1._CDR)
       use_scale_factor = .true.
    endif

    do
       if (use_scale_factor) then
          scale_factor_mid = (scale_factor1 + scale_factor2)/2
          redshift_mid = 1/scale_factor_mid - 1
       else
          redshift_mid = (redshift1 + redshift2)/2
          scale_factor_mid = 1/(1 + redshift_mid) 
       endif
       cosmic_time_mid = fn_cosmic_time(redshift_mid)
       if (cosmic_time > cosmic_time_mid) then
          redshift2 = redshift_mid
          scale_factor2 = scale_factor_mid
       else
          redshift1 = redshift_mid
          scale_factor1 = scale_factor_mid
       endif
       if (redshift2 - redshift1 < epsilon_redshift) exit
    enddo
    fn_redshift = redshift_mid

  end function fn_redshift

!#======================================================================

  function arsinh(x)

    implicit none
    real(CDR), intent(in) :: x
    real(CDR) :: arsinh
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    arsinh = log(x + sqrt(x**2+1))

  end function arsinh

end module mod_cosmo

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_remnants_ejec_SN

  use mod_IMF, only : IMF_d_n

  implicit none
  private
  public :: isolated_stars, close_binaries, reset_remnants_ejec_SN

contains
  
!#======================================================================
  
  subroutine reset_remnants_ejec_SN( &
       nb_CCSN_IS, nb_CCSN_CB, nb_SNIa, ejec_tot_IS, &
       ejec_elem_IS, ejec_tot_CB, ejec_elem_CB, ejec_carb_LMW_IS, &
       ejec_sil_LMW_IS, ejec_carb_HMW_IS, ejec_sil_HMW_IS, &
       ejec_carb_CCSN_IS, ejec_sil_CCSN_IS, &
       ejec_carb_LMW_CB, &
       ejec_sil_LMW_CB, ejec_carb_HMW_CB, ejec_sil_HMW_CB, &
       ejec_carb_CCSN_CB, ejec_sil_CCSN_CB, &
       ejec_carb_SNIa, ejec_sil_SNIa, &
       ejec_dust_O_LMW_IS, ejec_dust_O_HMW_IS, &
       ejec_dust_O_CCSN_IS,ejec_dust_O_LMW_CB, &
       ejec_dust_O_HMW_CB, ejec_dust_O_CCSN_CB, &
       ejec_dust_O_SNIa, &
       mass_BHNS_IS, mass_BHNS_CB, &
       mass_WD_IS, mass_WD_CB)

    use mod_types
    
    implicit none
    real(DPR), intent(out) :: nb_CCSN_IS, nb_CCSN_CB, nb_SNIa, &
         ejec_carb_LMW_IS, ejec_sil_LMW_IS, ejec_carb_HMW_IS, &
         ejec_sil_HMW_IS, ejec_carb_CCSN_IS, &
         ejec_sil_CCSN_IS, &
         ejec_carb_LMW_CB, ejec_sil_LMW_CB, ejec_carb_HMW_CB, &
         ejec_sil_HMW_CB, ejec_carb_CCSN_CB, &
         ejec_sil_CCSN_CB, &
         ejec_carb_SNIa, ejec_sil_SNIa, &
         mass_BHNS_IS, mass_BHNS_CB, mass_WD_IS, mass_WD_CB    
    real(DPR), intent(out) :: ejec_dust_O_LMW_IS, ejec_dust_O_HMW_IS, &
         ejec_dust_O_CCSN_IS,ejec_dust_O_LMW_CB, &
         ejec_dust_O_HMW_CB, ejec_dust_O_CCSN_CB, &
         ejec_dust_O_SNIa
    real(DPR), intent(out) :: ejec_tot_IS, ejec_tot_CB
    real(DPR), dimension(0:), intent(out) :: ejec_elem_IS, ejec_elem_CB
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
!# Computation of the mass of gas and metals ejected since the
!# previous time-step. The apportionment between "isolated" stars [IS]
!# and stars in close binary systems [CB] is made in spectra.f ("f_SNIa").

    nb_CCSN_IS = 0
    nb_CCSN_CB = 0
    nb_SNIa = 0
    ejec_tot_IS = 0
    ejec_elem_IS(0:) = 0
    ejec_tot_CB = 0
    ejec_elem_CB(0:) = 0
    ejec_carb_LMW_IS = 0
    ejec_sil_LMW_IS = 0
    ejec_carb_HMW_IS = 0
    ejec_sil_HMW_IS = 0
    ejec_carb_CCSN_IS = 0
    ejec_sil_CCSN_IS = 0
    ejec_carb_LMW_CB = 0
    ejec_sil_LMW_CB = 0
    ejec_carb_HMW_CB = 0
    ejec_sil_HMW_CB = 0
    ejec_carb_CCSN_CB = 0
    ejec_sil_CCSN_CB = 0
    ejec_carb_SNIa = 0
    ejec_sil_SNIa = 0

    ejec_dust_O_LMW_IS = 0
    ejec_dust_O_HMW_IS = 0
    ejec_dust_O_CCSN_IS = 0
    ejec_dust_O_LMW_CB = 0
    ejec_dust_O_HMW_CB = 0
    ejec_dust_O_CCSN_CB = 0
    ejec_dust_O_SNIa = 0

    mass_BHNS_IS = 0
    mass_BHNS_CB = 0
    mass_WD_IS = 0
    mass_WD_CB = 0

  end subroutine reset_remnants_ejec_SN

!#======================================================================

  subroutine isolated_stars(l10_mass, d_l10_mass, IMF_file, IMF_dim_slope, IMF_bin_coeff, IMF_bin_bottom_mass, &
       IMF_bin_slope, IMF_mass_min, IMF_mass_max, IMF_norm, ejec_tot_IS, ejec_elem_IS, &
       ejec_carb_LMW_IS, ejec_sil_LMW_IS, ejec_carb_HMW_IS, &
       ejec_sil_HMW_IS, ejec_carb_CCSN_IS, ejec_sil_CCSN_IS, &
       ejec_dust_O_LMW_IS, ejec_dust_O_HMW_IS, ejec_dust_O_CCSN_IS, &
       nb_CCSN_IS, mass_BHNS_IS, mass_WD_IS, dim_mass_yields, mass_yields, ejec_tot, ejec_elem, carb_dust_LMW, &
       sil_dust_LMW, carb_dust_HMW, sil_dust_HMW, carb_dust_CCSN, sil_dust_CCSN, &
       O_dust_LMW, O_dust_HMW, O_dust_CCSN, &
       min_mass_CCSN)

    use mod_types
    use mod_interp, only : bracket, interp_lin_lin
    
    implicit none
    real(DPR), intent(in) :: l10_mass, d_l10_mass
    character(len=*), intent(in) :: IMF_file
    integer, intent(in) :: IMF_dim_slope
    real(DPR), dimension(:), intent(in) :: IMF_bin_coeff, IMF_bin_bottom_mass, IMF_bin_slope
    real(DPR), intent(in) :: IMF_mass_min, IMF_mass_max, IMF_norm
    real(DPR), intent(inout) :: ejec_carb_LMW_IS, ejec_sil_LMW_IS, &
         ejec_carb_HMW_IS, ejec_sil_HMW_IS, &
         ejec_carb_CCSN_IS, ejec_sil_CCSN_IS, &
         ejec_dust_O_LMW_IS, ejec_dust_O_HMW_IS, ejec_dust_O_CCSN_IS, &
         nb_CCSN_IS, mass_BHNS_IS, mass_WD_IS
    real(DPR), intent(inout) :: ejec_tot_IS
    real(DPR), dimension(0:), intent(inout) :: ejec_elem_IS
    real(DPR), dimension(:), intent(in) :: mass_yields, carb_dust_LMW, &
         sil_dust_LMW, carb_dust_HMW, sil_dust_HMW, carb_dust_CCSN, sil_dust_CCSN
    real(DPR), dimension(:), intent(in) :: O_dust_LMW, O_dust_HMW, O_dust_CCSN
    real(DPR), dimension(:,0:), intent(in) :: ejec_elem
    real(DPR), intent(in) :: min_mass_CCSN
    real(DPR), dimension(:), intent(in) :: ejec_tot
    integer, intent(in) :: dim_mass_yields
!#......................................................................
    integer :: i_bracket, i_elem
    real(DPR) :: d_n, mass
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# "Isolated" star (single star or member of a loose binary system).

    d_n = IMF_d_n(l10_mass, d_l10_mass, IMF_file, IMF_dim_slope, IMF_bin_coeff, IMF_bin_bottom_mass, IMF_bin_slope, &
         IMF_mass_min, IMF_mass_max, IMF_norm)
    mass = 10**l10_mass
    i_bracket = 0
    call bracket(dim_mass_yields, mass_yields, mass, i_bracket)
    ejec_tot_IS = ejec_tot_IS + d_n*interp_lin_lin(mass_yields(i_bracket), mass_yields(i_bracket+1), &
         ejec_tot(i_bracket), ejec_tot(i_bracket+1), mass)

    do i_elem = 0, size(ejec_elem_IS)-1
       ejec_elem_IS(i_elem) = ejec_elem_IS(i_elem) + d_n*interp_lin_lin(mass_yields(i_bracket), &
            mass_yields(i_bracket+1), ejec_elem(i_bracket, i_elem), ejec_elem(i_bracket+1, i_elem), mass)
    enddo
    ejec_carb_LMW_IS = ejec_carb_LMW_IS &
         + d_n*interp_lin_lin(mass_yields(i_bracket), mass_yields(i_bracket+1), &
         carb_dust_LMW(i_bracket), carb_dust_LMW(i_bracket+1), mass)
    ejec_sil_LMW_IS = ejec_sil_LMW_IS &
         + d_n*interp_lin_lin(mass_yields(i_bracket), &
         mass_yields(i_bracket+1), sil_dust_LMW(i_bracket), sil_dust_LMW(i_bracket+1), mass)
    ejec_carb_HMW_IS = ejec_carb_HMW_IS & 
         + d_n*interp_lin_lin(mass_yields(i_bracket), &
         mass_yields(i_bracket+1), carb_dust_HMW(i_bracket), carb_dust_HMW(i_bracket+1), mass)
    ejec_sil_HMW_IS = ejec_sil_HMW_IS & 
         + d_n*interp_lin_lin(mass_yields(i_bracket), &
         mass_yields(i_bracket+1), sil_dust_HMW(i_bracket), sil_dust_HMW(i_bracket+1), mass)
    ejec_carb_CCSN_IS = ejec_carb_CCSN_IS & 
         + d_n*interp_lin_lin(mass_yields(i_bracket), &
         mass_yields(i_bracket+1), carb_dust_CCSN(i_bracket), carb_dust_CCSN(i_bracket+1), mass)
    ejec_sil_CCSN_IS = ejec_sil_CCSN_IS & 
         + d_n*interp_lin_lin(mass_yields(i_bracket), &
         mass_yields(i_bracket+1), sil_dust_CCSN(i_bracket), sil_dust_CCSN(i_bracket+1), mass)

    ejec_dust_O_LMW_IS = ejec_dust_O_LMW_IS &
         + d_n*interp_lin_lin(mass_yields(i_bracket), &
         mass_yields(i_bracket+1), O_dust_LMW(i_bracket), O_dust_LMW(i_bracket+1), mass)
    ejec_dust_O_HMW_IS = ejec_dust_O_HMW_IS & 
         + d_n*interp_lin_lin(mass_yields(i_bracket), &
         mass_yields(i_bracket+1), O_dust_HMW(i_bracket), O_dust_HMW(i_bracket+1), mass)
    ejec_dust_O_CCSN_IS = ejec_dust_O_CCSN_IS & 
         + d_n*interp_lin_lin(mass_yields(i_bracket), &
         mass_yields(i_bracket+1), O_dust_CCSN(i_bracket), O_dust_CCSN(i_bracket+1), mass)

    if (mass >= min_mass_CCSN) then 
!#     Core-collapse supernova.
       nb_CCSN_IS = nb_CCSN_IS + d_n
       mass_BHNS_IS = mass_BHNS_IS + d_n*( & !# Mass locked in black holes \
            mass &                           !# or neutron stars. 
            -interp_lin_lin(mass_yields(i_bracket), mass_yields(i_bracket+1), ejec_tot(i_bracket), ejec_tot(i_bracket+1), mass))
    else
       mass_WD_IS = mass_WD_IS + d_n*( & !# Mass locked in white dwarfs. 
            mass &
            -interp_lin_lin(mass_yields(i_bracket), mass_yields(i_bracket+1), ejec_tot(i_bracket), ejec_tot(i_bracket+1), mass))
    end if

  end subroutine isolated_stars

!#======================================================================

  subroutine close_binaries(l10_mass, d_l10_mass, IMF_file, IMF_dim_slope, IMF_bin_coeff, IMF_bin_bottom_mass, &
       IMF_bin_slope, IMF_mass_min, IMF_mass_max, IMF_norm, mass_Ch, ejec_tot_CB, ejec_elem_CB, &
       ejec_carb_LMW_CB, ejec_sil_LMW_CB, &
       ejec_carb_HMW_CB, ejec_sil_HMW_CB, &
       ejec_carb_CCSN_CB, ejec_sil_CCSN_CB, &
       ejec_carb_SNIa, ejec_sil_SNIa, &
       ejec_dust_O_LMW_CB, ejec_dust_O_HMW_CB, &
       ejec_dust_O_CCSN_CB, ejec_dust_O_SNIa, &
       nb_CCSN_CB, mass_BHNS_CB, mass_WD_CB, nb_SNIa, dim_mass_yields, mass_yields, ejec_tot, ejec_elem, &
       carb_dust_LMW, sil_dust_LMW, &
       carb_dust_HMW, sil_dust_HMW, carb_dust_CCSN, sil_dust_CCSN, &
       carb_dust_SNIa, sil_dust_SNIa, &
       O_dust_LMW, O_dust_HMW, O_dust_CCSN, O_dust_SNIa, &
       ejec_tot_SNIa, ejec_elem_SNIa, min_mass_CCSN)

    use mod_types
    use mod_SSPs_constants, only : min_mass_SNIa, close_bin_gamma, d_mu0
    use mod_interp, only : bracket, interp_lin_lin
    
    implicit none
    real(DPR), intent(in) :: l10_mass, d_l10_mass
    character(len=*), intent(in) :: IMF_file
    integer, intent(in) :: IMF_dim_slope
    real(DPR), dimension(:), intent(in) :: IMF_bin_coeff, IMF_bin_bottom_mass, IMF_bin_slope
    real(DPR), intent(in) :: IMF_mass_min, IMF_mass_max, IMF_norm, mass_Ch !# Mass of Chandrasekhar.
    real(DPR), intent(inout) :: nb_CCSN_CB, &
         mass_BHNS_CB, mass_WD_CB, nb_SNIa
    real(DPR), intent(inout) :: ejec_tot_CB
    real(DPR), dimension(0:), intent(inout) :: ejec_elem_CB
    real(DPR), intent(inout) :: ejec_carb_LMW_CB, ejec_sil_LMW_CB, &
         ejec_carb_HMW_CB, ejec_sil_HMW_CB, &
         ejec_carb_CCSN_CB, ejec_sil_CCSN_CB, &
         ejec_carb_SNIa, ejec_sil_SNIa
    real(DPR), intent(inout) :: ejec_dust_O_LMW_CB, &
         ejec_dust_O_HMW_CB, ejec_dust_O_CCSN_CB, ejec_dust_O_SNIa
    real(DPR), dimension(:), intent(in) :: mass_yields
    real(DPR), dimension(0:), intent(in) :: ejec_elem_SNIa
    real(DPR), dimension(:,0:), intent(in) :: ejec_elem
    real(DPR), dimension(:), intent(in) :: carb_dust_LMW, sil_dust_LMW, &
         carb_dust_HMW, sil_dust_HMW, carb_dust_CCSN, sil_dust_CCSN
    real(DPR), intent(in) :: carb_dust_SNIa, sil_dust_SNIa
    real(DPR), dimension(:), intent(in) :: O_dust_LMW, &
         O_dust_HMW, O_dust_CCSN
    real(DPR), intent(in) :: O_dust_SNIa
    real(DPR), dimension(:), intent(in) :: ejec_tot
    real(DPR), intent(in) :: ejec_tot_SNIa
    real(DPR), intent(in) :: min_mass_CCSN
    integer, intent(in) :: dim_mass_yields
!#......................................................................
    integer :: i_bracket, i_elem
    integer :: n_mu, i_mu
    real(DPR) :: mass1, mass2, mu_inf, mass2_max, mu_sup, CB_norm, d_mu, mu, &
         CB_mass, d_n, d_n12, mWD1, delta_mass, mass
    real(DPR) :: ejec_tot1, ejec_tot2, ejec_scaling_factor
    real(DPR), dimension(0:size(ejec_elem_CB)-1) :: ejec_elem1, ejec_elem2
    real(DPR) :: ejec_carb_LMW1, ejec_sil_LMW1, ejec_carb_HMW1, &
         ejec_sil_HMW1, ejec_carb_CCSN1, ejec_sil_CCSN1
    real(DPR) :: ejec_carb_LMW2, ejec_sil_LMW2, ejec_carb_HMW2, &
         ejec_sil_HMW2, ejec_carb_CCSN2, ejec_sil_CCSN2
    real(DPR) :: ejec_dust_O_LMW1, ejec_dust_O_HMW1, ejec_dust_O_CCSN1
    real(DPR) :: ejec_dust_O_LMW2, ejec_dust_O_HMW2, ejec_dust_O_CCSN2
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
!#     Close binary system.
!#     `IMF_mass_min` <= `mass2` <= `mass1` <= `IMF_mass_max`.
!#     `mu = mass2/(mass1+mass2)`.
!#     `f(mu) = CB_norm*mu**close_bin_gamma`: mass-ratio function.
!#     $\int_{mu_inf}^{mu_sup} f(mu) d_mu = 1$.
!#     The overall mass of the close binary, `CB_mass = mass1+mass2`,
!#     is assumed to be distributed according to the IMF for "isolated" stars.

!# Primary star of a close binary system.     

    mass = 10**l10_mass
    mass1 = mass

    i_bracket = 0
    call bracket(dim_mass_yields, mass_yields, mass1, i_bracket)
    ejec_tot1 = interp_lin_lin(mass_yields(i_bracket), mass_yields(i_bracket+1), ejec_tot(i_bracket), ejec_tot(i_bracket+1), &
         mass1)

    do i_elem = 0, size(ejec_elem_CB)-1
       ejec_elem1(i_elem) = interp_lin_lin(mass_yields(i_bracket), mass_yields(i_bracket+1), ejec_elem(i_bracket, i_elem), &
            ejec_elem(i_bracket+1, i_elem), mass1)
    enddo
    ejec_carb_LMW1 = interp_lin_lin(mass_yields(i_bracket), mass_yields(i_bracket+1), carb_dust_LMW(i_bracket), &
         carb_dust_LMW(i_bracket+1), mass1)
    ejec_sil_LMW1 = interp_lin_lin(mass_yields(i_bracket), mass_yields(i_bracket+1), sil_dust_LMW(i_bracket), &
         sil_dust_LMW(i_bracket+1), mass1)
    ejec_carb_HMW1 = interp_lin_lin(mass_yields(i_bracket), mass_yields(i_bracket+1), carb_dust_HMW(i_bracket), &
         carb_dust_HMW(i_bracket+1), mass1)
    ejec_sil_HMW1 = interp_lin_lin(mass_yields(i_bracket), mass_yields(i_bracket+1), sil_dust_HMW(i_bracket), &
         sil_dust_HMW(i_bracket+1), mass1)
    ejec_carb_CCSN1 = interp_lin_lin(mass_yields(i_bracket), mass_yields(i_bracket+1), carb_dust_CCSN(i_bracket), &
         carb_dust_CCSN(i_bracket+1), mass1)
    ejec_sil_CCSN1 = interp_lin_lin(mass_yields(i_bracket), mass_yields(i_bracket+1), sil_dust_CCSN(i_bracket), &
         sil_dust_CCSN(i_bracket+1), mass1)

    ejec_dust_O_LMW1 = interp_lin_lin(mass_yields(i_bracket), mass_yields(i_bracket+1), O_dust_LMW(i_bracket), &
         O_dust_LMW(i_bracket+1), mass1)
    ejec_dust_O_HMW1 = interp_lin_lin(mass_yields(i_bracket), mass_yields(i_bracket+1), O_dust_HMW(i_bracket), &
         O_dust_HMW(i_bracket+1), mass1)
    ejec_dust_O_CCSN1 = interp_lin_lin(mass_yields(i_bracket), mass_yields(i_bracket+1), O_dust_CCSN(i_bracket), &
         O_dust_CCSN(i_bracket+1), mass1)

    mu_inf = IMF_mass_min/(IMF_mass_min+mass1)
    mass2_max = min(mass1, IMF_mass_max-mass1)
    mu_sup = mass2_max/(mass2_max+mass1)
    if (mu_sup > mu_inf) then
       CB_norm = (close_bin_gamma+1)/ &
            (mu_sup**(close_bin_gamma+1)-mu_inf**(close_bin_gamma+1))
       n_mu = int((mu_sup-mu_inf)/d_mu0+1)
       d_mu = (mu_sup-mu_inf)/n_mu
       do i_mu = 0, n_mu-1
          mu = mu_inf+(i_mu+0.5_DPR)*d_mu
          CB_mass = mass1/(1-mu)

!# Note: `d_l10_mass*d_mu` := d(log10[mass1])*d(mu) = d(log10[CB_mass])*d(mu).

          d_n = IMF_d_n(log10(CB_mass), d_l10_mass, IMF_file, IMF_dim_slope, IMF_bin_coeff, &
               IMF_bin_bottom_mass, IMF_bin_slope, IMF_mass_min, IMF_mass_max, IMF_norm)
          d_n12 = d_n*CB_norm*mu**close_bin_gamma*d_mu
          ejec_tot_CB = ejec_tot_CB + d_n12*ejec_tot1
           ejec_elem_CB(0:) = ejec_elem_CB(0:) + d_n12*ejec_elem1(0:)
          
          ejec_carb_LMW_CB = ejec_carb_LMW_CB &
               + d_n12*ejec_carb_LMW1
          ejec_sil_LMW_CB = ejec_sil_LMW_CB &
               + d_n12*ejec_sil_LMW1
          ejec_carb_HMW_CB = ejec_carb_HMW_CB & 
               + d_n12*ejec_carb_HMW1
          ejec_sil_HMW_CB = ejec_sil_HMW_CB & 
               + d_n12*ejec_sil_HMW1
          ejec_carb_CCSN_CB = ejec_carb_CCSN_CB & 
               + d_n12*ejec_carb_CCSN1
          ejec_sil_CCSN_CB = ejec_sil_CCSN_CB & 
               + d_n12*ejec_sil_CCSN1
          
          ejec_dust_O_LMW_CB = ejec_dust_O_LMW_CB &
               + d_n12*ejec_dust_O_LMW1
          ejec_dust_O_HMW_CB = ejec_dust_O_HMW_CB & 
               + d_n12*ejec_dust_O_HMW1
          ejec_dust_O_CCSN_CB = ejec_dust_O_CCSN_CB & 
               + d_n12*ejec_dust_O_CCSN1

          if (mass1 >= min_mass_CCSN) then
             nb_CCSN_CB = nb_CCSN_CB + d_n12
             mass_BHNS_CB = mass_BHNS_CB + d_n12*(mass1-ejec_tot1)
          else
             mass_WD_CB = mass_WD_CB + d_n12*(mass1-ejec_tot1)
          end if
       end do
    end if

!# Secondary star of a close binary system.

    mass2 = mass
    ejec_tot2 = ejec_tot1
    ejec_elem2(0:) = ejec_elem1(0:)
    ejec_carb_LMW2 = ejec_carb_LMW1
    ejec_sil_LMW2 = ejec_sil_LMW1
    ejec_carb_HMW2 = ejec_carb_HMW1 
    ejec_sil_HMW2 = ejec_sil_HMW1 
    ejec_carb_CCSN2 = ejec_carb_CCSN1 
    ejec_sil_CCSN2 = ejec_sil_CCSN1 

    ejec_dust_O_LMW2 = ejec_dust_O_LMW1
    ejec_dust_O_HMW2 = ejec_dust_O_HMW1 
    ejec_dust_O_CCSN2 = ejec_dust_O_CCSN1 

    mu_inf = mass2/IMF_mass_max
    mu_sup = 0.5_DPR
    if (mu_sup > mu_inf) then
       CB_norm = (close_bin_gamma+1)/ &
            (mu_sup**(close_bin_gamma+1)-mu_inf**(close_bin_gamma+1))
       n_mu = int((mu_sup-mu_inf)/d_mu0+1)
       d_mu = (mu_sup-mu_inf)/n_mu
       do i_mu = 0, n_mu-1
          mu = mu_inf+(i_mu+0.5_DPR)*d_mu
          mass1 = mass2*(1-mu)/mu
          CB_mass = mass1+mass2

!# Note: `d_l10_mass*d_mu` := d(log10[mass2])*d(mu) = d(log10[CB_mass])*d(mu).

          d_n = IMF_d_n(log10(CB_mass), d_l10_mass, IMF_file, IMF_dim_slope, IMF_bin_coeff, &
               IMF_bin_bottom_mass, IMF_bin_slope, IMF_mass_min, IMF_mass_max, IMF_norm)
          d_n12 = d_n*CB_norm*mu**close_bin_gamma*d_mu
          if (CB_mass < min_mass_SNIa .or. mass1 > min_mass_CCSN) then 
!# No SNIa explosion: mass too small or the remnant of the primary 
!# is not a white dwarf. 
             ejec_tot_CB = ejec_tot_CB + d_n12 &
                  *ejec_tot2
             ejec_elem_CB(0:) = ejec_elem_CB(0:) + d_n12 &
                  *ejec_elem2(0:)
             ejec_carb_LMW_CB = ejec_carb_LMW_CB &
                  + d_n12*ejec_carb_LMW2
             ejec_sil_LMW_CB = ejec_sil_LMW_CB &
                  + d_n12*ejec_sil_LMW2
             ejec_carb_HMW_CB = ejec_carb_HMW_CB & 
                  + d_n12*ejec_carb_HMW2
             ejec_sil_HMW_CB = ejec_sil_HMW_CB & 
                  + d_n12*ejec_sil_HMW2
             ejec_carb_CCSN_CB = ejec_carb_CCSN_CB & 
                  + d_n12*ejec_carb_CCSN2
             ejec_sil_CCSN_CB = ejec_sil_CCSN_CB & 
                  + d_n12*ejec_sil_CCSN2

             ejec_dust_O_LMW_CB = ejec_dust_O_LMW_CB &
                  + d_n12*ejec_dust_O_LMW2
             ejec_dust_O_HMW_CB = ejec_dust_O_HMW_CB & 
                  + d_n12*ejec_dust_O_HMW2
             ejec_dust_O_CCSN_CB = ejec_dust_O_CCSN_CB & 
                  + d_n12*ejec_dust_O_CCSN2

             if (mass2 >= min_mass_CCSN) then
                nb_CCSN_CB = nb_CCSN_CB + d_n12
                mass_BHNS_CB = mass_BHNS_CB + d_n12*(mass2-ejec_tot2)
             else
                mass_WD_CB = mass_WD_CB + d_n12*(mass2-ejec_tot2)
             end if
          else          
!# SNIa explosion.
             nb_SNIa = nb_SNIa + d_n12             
             i_bracket = 0
             call bracket(dim_mass_yields, mass_yields, mass1, i_bracket)
!# `ejec_elem1` is not needed. `ejec_tot1` needed just to 
!# compute the mass of the white dwarf remnant of the primary.
             ejec_tot1 = interp_lin_lin(mass_yields(i_bracket), mass_yields(i_bracket+1), ejec_tot(i_bracket), &
                  ejec_tot(i_bracket+1), mass1)
!# Mass of the white dwarf remnant of the primary.
             mWD1 = mass1-ejec_tot1
!# White dwarf destroyed in the explosion.
             mass_WD_CB = mass_WD_CB-d_n12*mWD1

!# Mass ejected by the secondary used by the primary to reach 
!# the Chandrasekhar mass.
             delta_mass = mass_Ch-mWD1 

             ejec_tot_CB = ejec_tot_CB + d_n12*( &
!# Ejecta of the secondary not processed by the primary. 
                  ejec_tot2-delta_mass &
!# Ejecta of the primary (totally destroyed).
                  + ejec_tot_SNIa) 
             
             ejec_scaling_factor = (ejec_tot2-delta_mass)/ejec_tot2
             do i_elem = 0, size(ejec_elem_CB)-1
                ejec_elem_CB(i_elem) = ejec_elem_CB(i_elem) + d_n12*( &
!# Secundary; ejecta scaled to `ejec_tot2-delta_mass`. 
                     ejec_elem2(i_elem)*ejec_scaling_factor &
!# Primary (no H or He remains).
                     +ejec_elem_SNIa(i_elem)) !# W7.
             enddo

!# Dust ejecta of the secondary, scaled to `ejec_tot2-delta_mass`.
             ejec_carb_LMW_CB = ejec_carb_LMW_CB &
                  + d_n12*ejec_carb_LMW2*ejec_scaling_factor
             ejec_sil_LMW_CB = ejec_sil_LMW_CB &
                  + d_n12*ejec_sil_LMW2*ejec_scaling_factor
             ejec_carb_HMW_CB = ejec_carb_HMW_CB & 
                  + d_n12*ejec_carb_HMW2*ejec_scaling_factor
             ejec_sil_HMW_CB = ejec_sil_HMW_CB & 
                  + d_n12*ejec_sil_HMW2*ejec_scaling_factor
             ejec_carb_CCSN_CB = ejec_carb_CCSN_CB & 
                  + d_n12*ejec_carb_CCSN2*ejec_scaling_factor
             ejec_sil_CCSN_CB = ejec_sil_CCSN_CB & 
                  + d_n12*ejec_sil_CCSN2*ejec_scaling_factor

             ejec_dust_O_LMW_CB = ejec_dust_O_LMW_CB &
                  + d_n12*ejec_dust_O_LMW2*ejec_scaling_factor
             ejec_dust_O_HMW_CB = ejec_dust_O_HMW_CB & 
                  + d_n12*ejec_dust_O_HMW2*ejec_scaling_factor
             ejec_dust_O_CCSN_CB = ejec_dust_O_CCSN_CB & 
                  + d_n12*ejec_dust_O_CCSN2*ejec_scaling_factor

!# Dust ejecta from the SNIa exlosion.
             ejec_carb_SNIa = ejec_carb_SNIa &
                  + d_n12*carb_dust_SNIa
             ejec_sil_SNIa = ejec_sil_SNIa &
                  + d_n12*sil_dust_SNIa

             ejec_dust_O_SNIa = ejec_dust_O_SNIa &
                  + d_n12*O_dust_SNIa

          end if
       end do
    end if

  end subroutine close_binaries

end module mod_remnants_ejec_SN

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_spectra_alloc

  implicit none
  private
  public :: spectra_alloc1, spectra_alloc2

contains

!#======================================================================
  
  subroutine spectra_alloc1(dim_cont, dim_lambda_stel, dim_line, &
       dim_species_SFC, dim_species_DISM, &
       lum_cont, lum_stel_SFC_att_gas, lum_stel_SFC_unatt, &
       lum_stel_SFC, lum_stel_DISM_att_gas, lum_stel_DISM_unatt, &
       lum_cont_unatt, &
       lum_neb_cont_SFC_unatt, lum_neb_cont_SFC, &
       lum_neb_cont_DISM_unatt, &
       kappa_abs_cont, cont_trans_DISM_tot, &
       cont_trans_DISM_incl, cont_trans_SFC, &
       lum_species_SFC, lum_species_DISM, &
       sublim_lum_species_SFC, sublim_lum_species_DISM, &
       kappa_abs_line, L_line, L_line_SFC_unatt, L_line_SFC, &
       L_line_DISM_unatt, L_line_unatt, line_trans_DISM_tot, &
       line_trans_DISM_incl, line_trans_SFC, &
       RF_cont_SFC, RF_line_SFC, RF_cont_DISM, RF_line_DISM, &
       lum_stel_SFC_att_gas0, lum_stel_SFC_unatt0, lum_stel_DISM_att_gas0, lum_stel_DISM_unatt0, &
       lum_stel_SFC0, &
       lum_neb_cont_SFC_unatt0, lum_neb_cont_SFC0, &
       lum_neb_cont_DISM_unatt0, &
       species_weight_SFC, species_weight_DISM)

    use mod_types

    implicit none
    integer, intent(in) :: dim_cont, dim_lambda_stel, dim_line
    integer, intent(in) :: dim_species_SFC, dim_species_DISM
    real(CDR), dimension(:), pointer :: lum_cont, lum_stel_SFC_att_gas, &
         lum_stel_SFC_unatt, lum_stel_SFC, &
         lum_stel_DISM_att_gas, lum_stel_DISM_unatt, &
         lum_cont_unatt, &
         lum_neb_cont_SFC_unatt, lum_neb_cont_SFC, &
         lum_neb_cont_DISM_unatt, &
         kappa_abs_cont, cont_trans_DISM_tot, &
         cont_trans_DISM_incl, cont_trans_SFC
    real(CDR), dimension(:,:), pointer :: lum_species_SFC, lum_species_DISM
    real(CDR), dimension(:,:), pointer :: sublim_lum_species_SFC, sublim_lum_species_DISM
    real(CDR), dimension(:), pointer :: kappa_abs_line, L_line, &
         L_line_SFC_unatt, L_line_SFC, L_line_DISM_unatt, L_line_unatt, &
         line_trans_DISM_tot, line_trans_DISM_incl, line_trans_SFC, &
         RF_cont_SFC, RF_line_SFC, RF_cont_DISM, RF_line_DISM
    real(CDR), dimension(:), pointer :: lum_stel_SFC_att_gas0, lum_stel_SFC_unatt0, &
         lum_stel_DISM_att_gas0, lum_stel_DISM_unatt0, lum_stel_SFC0, &
         lum_neb_cont_SFC_unatt0, lum_neb_cont_SFC0, &
         lum_neb_cont_DISM_unatt0, &
         species_weight_SFC, species_weight_DISM
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    if (associated(lum_cont)) deallocate(lum_cont)
    allocate(lum_cont(dim_cont))

    if (associated(lum_stel_SFC_att_gas)) deallocate(lum_stel_SFC_att_gas)
    allocate(lum_stel_SFC_att_gas(dim_cont))

    if (associated(lum_stel_SFC_unatt)) deallocate(lum_stel_SFC_unatt)
    allocate(lum_stel_SFC_unatt(dim_cont))

    if (associated(lum_stel_SFC)) deallocate(lum_stel_SFC)
    allocate(lum_stel_SFC(dim_cont))

    if (associated(lum_stel_DISM_att_gas)) deallocate(lum_stel_DISM_att_gas)
    allocate(lum_stel_DISM_att_gas(dim_cont))

    if (associated(lum_stel_DISM_unatt)) deallocate(lum_stel_DISM_unatt)
    allocate(lum_stel_DISM_unatt(dim_cont))

    if (associated(lum_cont_unatt)) deallocate(lum_cont_unatt)
    allocate(lum_cont_unatt(dim_cont))

    if (associated(lum_neb_cont_SFC_unatt)) deallocate(lum_neb_cont_SFC_unatt)
    allocate(lum_neb_cont_SFC_unatt(dim_cont))

    if (associated(lum_neb_cont_SFC)) deallocate(lum_neb_cont_SFC)
    allocate(lum_neb_cont_SFC(dim_cont))

    if (associated(lum_neb_cont_DISM_unatt)) deallocate(lum_neb_cont_DISM_unatt)
    allocate(lum_neb_cont_DISM_unatt(dim_cont))

    if (associated(kappa_abs_cont)) deallocate(kappa_abs_cont)
    allocate(kappa_abs_cont(dim_cont))

    if (associated(cont_trans_DISM_tot)) deallocate(cont_trans_DISM_tot)
    allocate(cont_trans_DISM_tot(dim_cont))

    if (associated(cont_trans_DISM_incl)) deallocate(cont_trans_DISM_incl)
    allocate(cont_trans_DISM_incl(dim_cont))

    if (associated(cont_trans_SFC)) deallocate(cont_trans_SFC)
    allocate(cont_trans_SFC(dim_cont))

    if (associated(lum_species_SFC)) deallocate(lum_species_SFC)
    allocate(lum_species_SFC(dim_species_SFC, dim_cont))
    
    if (associated(lum_species_DISM)) deallocate(lum_species_DISM)
    allocate(lum_species_DISM(dim_species_DISM, dim_cont))

    if (associated(sublim_lum_species_SFC)) deallocate(sublim_lum_species_SFC)
    allocate(sublim_lum_species_SFC(dim_species_SFC, dim_cont))
    
    if (associated(sublim_lum_species_DISM)) deallocate(sublim_lum_species_DISM)
    allocate(sublim_lum_species_DISM(dim_species_DISM, dim_cont))
    
    if (associated(kappa_abs_line)) deallocate(kappa_abs_line)
    allocate(kappa_abs_line(dim_line))
    
    if (associated(L_line)) deallocate(L_line)
    allocate(L_line(dim_line))
    
    if (associated(L_line_SFC_unatt)) deallocate(L_line_SFC_unatt)
    allocate(L_line_SFC_unatt(dim_line))

    if (associated(L_line_SFC)) deallocate(L_line_SFC)
    allocate(L_line_SFC(dim_line))

    if (associated(L_line_DISM_unatt)) deallocate(L_line_DISM_unatt)
    allocate(L_line_DISM_unatt(dim_line))

    if (associated(L_line_unatt)) deallocate(L_line_unatt)
    allocate(L_line_unatt(dim_line))
    
    if (associated(line_trans_DISM_tot)) deallocate(line_trans_DISM_tot)
    allocate(line_trans_DISM_tot(dim_line))
    
    if (associated(line_trans_DISM_incl)) deallocate(line_trans_DISM_incl)
    allocate(line_trans_DISM_incl(dim_line))
    
    if (associated(line_trans_SFC)) deallocate(line_trans_SFC)
    allocate(line_trans_SFC(dim_line))

    if (associated(RF_cont_SFC)) deallocate(RF_cont_SFC)
    allocate(RF_cont_SFC(dim_cont))

    if (associated(RF_line_SFC)) deallocate(RF_line_SFC)
    allocate(RF_line_SFC(dim_line))

    if (associated(RF_cont_DISM)) deallocate(RF_cont_DISM)
    allocate(RF_cont_DISM(dim_cont))

    if (associated(RF_line_DISM)) deallocate(RF_line_DISM)
    allocate(RF_line_DISM(dim_line))

    if (associated(lum_stel_SFC_att_gas0)) deallocate(lum_stel_SFC_att_gas0)
    allocate(lum_stel_SFC_att_gas0(dim_lambda_stel))

    if (associated(lum_stel_SFC_unatt0)) deallocate(lum_stel_SFC_unatt0)
    allocate(lum_stel_SFC_unatt0(dim_lambda_stel))

    if (associated(lum_stel_DISM_att_gas0)) deallocate(lum_stel_DISM_att_gas0)
    allocate(lum_stel_DISM_att_gas0(dim_lambda_stel))

    if (associated(lum_stel_DISM_unatt0)) deallocate(lum_stel_DISM_unatt0)
    allocate(lum_stel_DISM_unatt0(dim_lambda_stel))

    if (associated(lum_stel_SFC0)) deallocate(lum_stel_SFC0)
    allocate(lum_stel_SFC0(dim_lambda_stel))

    if (associated(lum_neb_cont_SFC_unatt0)) deallocate(lum_neb_cont_SFC_unatt0)
    allocate(lum_neb_cont_SFC_unatt0(dim_lambda_stel))

    if (associated(lum_neb_cont_SFC0)) deallocate(lum_neb_cont_SFC0)
    allocate(lum_neb_cont_SFC0(dim_lambda_stel))

    if (associated(lum_neb_cont_DISM_unatt0)) deallocate(lum_neb_cont_DISM_unatt0)
    allocate(lum_neb_cont_DISM_unatt0(dim_lambda_stel))

    if (associated(species_weight_SFC)) deallocate(species_weight_SFC)
    allocate(species_weight_SFC(dim_species_SFC))

    if (associated(species_weight_DISM)) deallocate(species_weight_DISM)
    allocate(species_weight_DISM(dim_species_DISM))
    
  end subroutine spectra_alloc1

!#======================================================================

  subroutine spectra_alloc2(dim_convol_time, dim_elem, &
       galaxy_mass, ISM_mass, BHNS_mass, &
       WD_mass, carb_abund, sil_abund, SF_rate, CCSN_rate, SNIa_rate, &
       ejec_rate_tot, infall_rate, outflow_rate, ejec_cumul_mass, &
       SF_live_cumul_mass, infall_cumul_mass, outflow_cumul_mass, &
       inert_mass, ISM_over_H, &
       LC_gas_abs_birth_cloud, LC_dust_abs_birth_cloud, &
       LC_gas_abs_DISM, dust_col_dens_birth_cloud, &
       cloud_frac, ISM_elem_mass, ISM_abund, reserv_abund, &
       n_Z_neb, n_Q_neb, Z_neb_weight, Q_neb_weight_SFC)

    use mod_types
    use mod_scenario, only : max_dim_reserv

    implicit none
    integer, intent(in) :: dim_convol_time, dim_elem
    real(CDR), dimension(:), pointer :: galaxy_mass, ISM_mass, BHNS_mass, &
         WD_mass, carb_abund, sil_abund
    real(DPR), dimension(:), pointer :: SF_rate
    real(DPR), dimension(:), pointer :: CCSN_rate, &
         SNIa_rate, &
         ejec_rate_tot, &
         infall_rate, &
         outflow_rate, &
         ejec_cumul_mass, &
         SF_live_cumul_mass, &
         infall_cumul_mass, &
         outflow_cumul_mass
    real(CDR), dimension(:), pointer :: inert_mass, &
         ISM_over_H, &
         LC_gas_abs_birth_cloud, LC_dust_abs_birth_cloud, &
         LC_gas_abs_DISM, &
         dust_col_dens_birth_cloud, &
         cloud_frac
    real(CDR), dimension(:), pointer :: ISM_elem_mass
    real(CDR), dimension(:,:), pointer :: ISM_abund
    real(CDR), dimension(:,:), pointer :: reserv_abund
    integer, intent(in) :: n_Z_neb, n_Q_neb
    real(CDR), dimension(:,:), pointer :: Z_neb_weight, Q_neb_weight_SFC
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    if (associated(galaxy_mass)) deallocate(galaxy_mass)
    allocate(galaxy_mass(dim_convol_time+1))

    if (associated(ISM_mass)) deallocate(ISM_mass)
    allocate(ISM_mass(dim_convol_time+1))

    if (associated(BHNS_mass)) deallocate(BHNS_mass)
    allocate(BHNS_mass(dim_convol_time+1))

    if (associated(WD_mass)) deallocate(WD_mass)
    allocate(WD_mass(dim_convol_time+1))

    if (associated(carb_abund)) deallocate(carb_abund)
    allocate(carb_abund(dim_convol_time+1-1))

    if (associated(sil_abund)) deallocate(sil_abund)
    allocate(sil_abund(dim_convol_time+1-1))

    if (associated(SF_rate)) deallocate(SF_rate)
!# ??? Why not `dim_convol_time+1`, as for others? Or why for others?
    allocate(SF_rate(dim_convol_time)) 
    
    if (associated(CCSN_rate)) deallocate(CCSN_rate)
    allocate(CCSN_rate(dim_convol_time+1))

    if (associated(SNIa_rate)) deallocate(SNIa_rate)
    allocate(SNIa_rate(dim_convol_time+1))

    if (associated(ejec_rate_tot)) deallocate(ejec_rate_tot)
    allocate(ejec_rate_tot(dim_convol_time+1))

    if (associated(infall_rate)) deallocate(infall_rate)
    allocate(infall_rate(dim_convol_time+1-1))

    if (associated(outflow_rate)) deallocate(outflow_rate)
    allocate(outflow_rate(dim_convol_time+1))

    if (associated(ejec_cumul_mass)) deallocate(ejec_cumul_mass)
    allocate(ejec_cumul_mass(dim_convol_time+1))

    if (associated(SF_live_cumul_mass)) deallocate(SF_live_cumul_mass)
    allocate(SF_live_cumul_mass(dim_convol_time+1))

    if (associated(infall_cumul_mass)) deallocate(infall_cumul_mass)
    allocate(infall_cumul_mass(dim_convol_time+1))

    if (associated(outflow_cumul_mass)) deallocate(outflow_cumul_mass)
    allocate(outflow_cumul_mass(dim_convol_time+1))

    if (associated(inert_mass)) deallocate(inert_mass)
    allocate(inert_mass(dim_convol_time+1))

    if (associated(ISM_over_H)) deallocate(ISM_over_H)
    allocate(ISM_over_H(dim_convol_time+1-1))

    if (associated(LC_gas_abs_birth_cloud)) deallocate(LC_gas_abs_birth_cloud)
    allocate(LC_gas_abs_birth_cloud(dim_convol_time+1-1))

    if (associated(LC_dust_abs_birth_cloud)) deallocate(LC_dust_abs_birth_cloud)
    allocate(LC_dust_abs_birth_cloud(dim_convol_time+1-1))

    if (associated(LC_gas_abs_DISM)) deallocate(LC_gas_abs_DISM)
    allocate(LC_gas_abs_DISM(dim_convol_time+1-1))

    if (associated(dust_col_dens_birth_cloud)) deallocate(dust_col_dens_birth_cloud)
    allocate(dust_col_dens_birth_cloud(dim_convol_time+1-1))

    if (associated(cloud_frac)) deallocate(cloud_frac)
    allocate(cloud_frac(dim_convol_time+1-1))

    if (associated(ISM_elem_mass)) deallocate(ISM_elem_mass)
    allocate(ISM_elem_mass(0:dim_elem))
    
    if (associated(ISM_abund)) deallocate(ISM_abund)
    allocate(ISM_abund(dim_convol_time, 0:dim_elem))
    
    if (associated(reserv_abund)) deallocate(reserv_abund)
    allocate(reserv_abund(max_dim_reserv, 0:dim_elem))

    if (associated(Z_neb_weight)) deallocate(Z_neb_weight)
    allocate(Z_neb_weight(dim_convol_time+1-1, n_Z_neb))
    

    if (associated(Q_neb_weight_SFC)) deallocate(Q_neb_weight_SFC)
    allocate(Q_neb_weight_SFC(dim_convol_time+1-1, n_Q_neb))

  end subroutine spectra_alloc2
  
end module mod_spectra_alloc

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# except function `Jenkins_one_at_a_time_hash`.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_hash

  use mod_types

  implicit none
  private

  type :: struct_hash
     character(len=std_string) :: string = ""
     integer :: indx = -1
     type(struct_hash), pointer :: ptr => null()
  end type struct_hash

  public :: struct_hash, create_hash_table, hash_index, &
       delete_hash_table, print_hash_table

contains

!#======================================================================
  
  function Jenkins_one_at_a_time_hash(key)

!# B. Jenkins, "Hash functions", Dr. Dobb's Journal (September 1997).
    implicit none
    character(len=*), intent(in) :: key
    integer :: Jenkins_one_at_a_time_hash
!#......................................................................    
    integer(long_int) :: hash
    integer :: i
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    hash = 0
    
    do i = 1, len(key)
       hash = hash + iachar(key(i:i))
       hash = hash + ishft(hash, 10)
       hash = ieor(hash, ishft(hash, -6))
    enddo
    hash = hash + ishft(hash, 3)
    hash = ieor(hash, ishft(hash, -11))
    hash = hash + ishft(hash, 15)
    
    Jenkins_one_at_a_time_hash = hash
    
  end function Jenkins_one_at_a_time_hash

!#======================================================================

  subroutine create_hash_table(string, hash_table, dim_hash)

    implicit none
    character(len=*), dimension(:), intent(in) :: string
    type(struct_hash), dimension(:), pointer :: hash_table 
!# `hash_table` is a pointer to an array, not an array of pointers. 
!# `(/hash_table(1) % ptr, ...,  hash_table(i_hash) % ptr/)` is an array of pointers.
!# In Fortran 2003, the array `hash_table` might be `allocatable` and have the
!# the `target` attribute; `hash_node(i_hash) % ptr` could then point directly
!# to `hash_table(i_hash)` instead of `hash_table(i_hash) % ptr`, which would
!# therefore not need to be allocated.
    integer, intent(out) :: dim_hash
!#......................................................................
    real, parameter :: hash_load_factor = 0.1
    integer :: dim_string, i_string, i_hash
    type(struct_hash), dimension(:), allocatable :: hash_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    dim_string = size(string)
    if (hash_load_factor <= 0) then
       write(*, "(a)") "File ""mod_hash.f90"", subroutine `create_hash_table`: &
            &parameter `hash_load_factor` must be strictly positive. Stopped."
       stop
    endif
    dim_hash = ceiling(dim_string/hash_load_factor)

!# `hash_table` is an array of `dim_hash` linked lists.
!# `hash_table(i_hash) % ptr` is the head of the `i_hash`-th linked list
!# and `hash_node(i_hash) % ptr` the current tail.

    allocate(hash_table(dim_hash))
    allocate(hash_node(dim_hash))
    do i_string = 1, dim_string
       i_hash = modulo(Jenkins_one_at_a_time_hash(trim(string(i_string))), dim_hash) + 1
       if (.not.associated(hash_table(i_hash) % ptr)) then !# Allocate the head of linked list.
          allocate(hash_table(i_hash) % ptr)
          hash_node(i_hash) % ptr => hash_table(i_hash) % ptr
       else !# Add a new node to the linked list.
          allocate(hash_node(i_hash) % ptr % ptr)
          hash_node(i_hash) % ptr => hash_node(i_hash) % ptr % ptr
       endif
       hash_node(i_hash) % ptr % string = trim(string(i_string))
       hash_node(i_hash) % ptr % indx = i_string
    enddo
!???    deallocate(hash_node) !# This deallocates the *array* `hash_node`, \
!# not the targets pointed to by the *pointer* `hash_node(i_hash) % ptr`,
!# which may be accessed through `hash_table(i_hash)`.
    
  end subroutine create_hash_table

!#======================================================================

  function hash_index(string, hash_table, failed)

    implicit none
    character(len=*), intent(in) :: string
    type(struct_hash), dimension(:), intent(in) :: hash_table
    logical, intent(out) :: failed
    integer :: hash_index
!#......................................................................
    integer :: i_hash, dim_hash
    type(struct_hash), pointer :: hash_node => null()
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    failed = .false.
    dim_hash = size(hash_table)
    i_hash = modulo(Jenkins_one_at_a_time_hash(trim(string)), dim_hash) + 1
    hash_node => hash_table(i_hash) % ptr
    do
       if (.not.associated(hash_node)) then
          failed = .true.
          exit
       endif
       if (hash_node % string == string) exit
       hash_node => hash_node % ptr
    enddo
    if (.not.failed) then
       hash_index = hash_node % indx
    else
       hash_index = -huge(1)
    endif

  end function hash_index
  
!#======================================================================

  subroutine delete_hash_table(hash_table)

    type(struct_hash), dimension(:), pointer :: hash_table
!#......................................................................
    integer :: i_hash, dim_hash
    type(struct_hash), pointer :: hash_node => null(), next_node => null()
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    dim_hash = size(hash_table)    
    do i_hash = 1, dim_hash !# Deallocate the *linked list* `hash_table(i_hash) % ptr`.
       hash_node => hash_table(i_hash) % ptr
       do 
          if (.not.associated(hash_node)) exit
          next_node => hash_node % ptr
          deallocate(hash_node)
          hash_node => next_node
       enddo
    enddo

    deallocate(hash_table) !# Deallocate the *array* `hash_table`.

  end subroutine delete_hash_table

!#======================================================================

  subroutine print_hash_table(hash_table) !# Just for checks.

    type(struct_hash), dimension(:), pointer :: hash_table
!#......................................................................
    integer :: i_hash, dim_hash
    type(struct_hash), pointer :: hash_node => null(), next_node => null()
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    dim_hash = size(hash_table)    
    do i_hash = 1, dim_hash
       hash_node => hash_table(i_hash) % ptr
       if (.not.associated(hash_node)) cycle
       write(*,"(i0,tr1,a)") i_hash, trim(hash_node % string)
       do 
          next_node => hash_node % ptr
          hash_node => next_node
          if (.not.associated(hash_node)) exit
          write(*,"(tr4,a)") trim(hash_node % string)
       enddo
    enddo

  end subroutine print_hash_table

end module mod_hash

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_parse_file
  
  use mod_types

  implicit none
  private
  
!# Linked list of files.
  type :: struct_file_list
     integer :: unit
     character(len=std_string) :: file_name
     integer :: line_number
     logical :: included_file
     type(struct_file_list), pointer :: next => null()
  end type struct_file_list

  type(struct_file_list), pointer :: file_list => null()

  integer, parameter :: n_max_lines_per_statement = 10, &
       len_max_line = long_string, &
       len_max_statement = n_max_lines_per_statement*len_max_line

  public :: parse_file, file_list, struct_file_list, &
       len_max_statement, len_max_line

contains
  
!#======================================================================
  
  subroutine parse_file(file_list, read_proc, end_proc, &
       run, end_of_file, end_statement, return_statement, init_proc)

    use mod_strings, only : same_case_equal
    use mod_file_access, only : open_file, close_file
    use mod_analyze_statement, only : analyze_statement, file_name, &
         line_number, error_message
    
    implicit none
    external :: read_proc, end_proc !# ???
    type(struct_file_list), pointer :: file_list
    logical, intent(out) :: run, end_of_file, end_statement, return_statement
    external :: init_proc !# ???
    optional :: init_proc
    interface
       subroutine read_proc(key, rhs, indices_string, unknown_statement, &
            statement_type)
         use mod_strings, only : same_case_equal
         implicit none
         character(len=*), intent(in) :: key, rhs, statement_type
         character(len=*), intent(inout) :: indices_string
         logical, intent(out) :: unknown_statement
       end subroutine read_proc

       subroutine end_proc(run)
         use mod_strings, only : same_case_equal
         implicit none
         logical, intent(out) :: run
       end subroutine end_proc

       subroutine init_proc
         implicit none
       end subroutine init_proc
    end interface
!#......................................................................
    integer :: unit
    character(len=len_max_statement) :: statement
    character(len=len_max_line) :: line, processed_line
    integer :: len_line, len_statement, pos, quote, pos2, quote0
    logical :: incomplete_statement, other_statement, block_comment, &
         included_file
    character(len=len(statement)) :: after_include
    character(len=len_max_line) :: statement_beginning
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(init_proc)) call init_proc

    run = .false.
    end_statement = .false.
    return_statement = .false.
    end_of_file = .false.
    incomplete_statement = .false.
    other_statement = .false.
    block_comment = .false.

    unit = file_list % unit
    file_name = file_list % file_name
    line_number = file_list % line_number
    included_file = file_list % included_file
    
    do 
       if (other_statement) then !# After a `;`. Read another statement \
!#                                  on the same line.
          statement = ""
          len_statement = 0
          quote = 0
          line = adjustl(line(pos:))
          pos = 1
          other_statement = .false.
       else
          if (.not.incomplete_statement) then !# Read a new statement.
             statement = ""
             len_statement = 0
             quote = 0
          endif
          pos = 1
          
          call read_line(line, end_of_file, unit)
          file_list % line_number = line_number

          if (end_of_file) then
             if (incomplete_statement) call error_message( &
                  "previous statement is not complete.")
             if (included_file) then !# Return to enclosing file 
!#                                      and go on reading.
                call close_file(unit)
                file_list => file_list % next
                unit = file_list % unit
                file_name = file_list % file_name
                line_number = file_list % line_number
                included_file = file_list % included_file
!# ???                if (.not.associated(file_list % next)) included_file = .false.
                end_of_file = .false.
                cycle
             else !# Nothing more to read; return to main program.
                call end_proc(run) 
                return
             endif
          endif
       endif

       processed_line = ""
       len_line = 0
       quote0 = quote !# Value of variable "quote" at the beginning \
!#                       of the processed line.
       call process_line1(line, processed_line, &
            len_line, pos, quote, other_statement, block_comment)
       if (processed_line == "") cycle !# Empty line.
       call process_line2(processed_line, len_line, &
            quote0, quote, incomplete_statement)

       statement = statement(:len_statement) // processed_line(:len_line)
       len_statement = len_statement+len_line   

       if (.not.incomplete_statement .and. statement /= "") then          
          pos2 = scan(statement, " '""")
          statement_beginning = statement(:pos2-1)
          if (same_case_equal(statement_beginning, "include")) then
             after_include = adjustl(statement(pos2:))
             call include_file(file_name, after_include, &
                  read_proc, end_proc, run, end_of_file, end_statement, &
                  return_statement)
          else
             call analyze_statement(statement, &
                  read_proc, end_statement, return_statement)
          endif
          if (end_statement .or. return_statement) then
             call end_proc(run)
             return
          endif
       endif
    enddo
    
  end subroutine parse_file

!#======================================================================
  
  subroutine read_line(line, end_of_file, unit)

    use mod_strings, only : untabify
    use mod_analyze_statement, only : line_number, error_message
    use mod_convert_type, only : to_string

    implicit none
    character(len=*), intent(out) :: line
    logical, intent(out) :: end_of_file
    integer, intent(in) :: unit
!#......................................................................
    integer :: ios
    integer :: len_max_line
    character(len=2*len(line)) :: extended_line
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    len_max_line = len(line)

    read(unit, "(a)", iostat = ios) extended_line           

    line_number = line_number+1
    
    if (ios > 0) then
       call error_message("this line could not be read.")
    else if (ios < 0) then !# End of file reached.
       end_of_file = .true. !# Nothing more to read.
    else 
!# Replace horizontal tabulations by spaces {
       extended_line = untabify(extended_line)
!# }.
       
       if (extended_line(len_max_line+1:) /= "") then !# Line too long. \
!# The end of the line could not be read.
          call error_message("a line should not be longer than " // &
               to_string(len_max_line) // " characters.")
       else
          line = adjustl(extended_line(:len_max_line))
       endif
    endif

  end subroutine read_line

!#======================================================================

  recursive subroutine process_line1(line, &
       processed_line, len_line, pos, quote, other_statement, block_comment)
   
    use mod_strings, only : find_closing_quote
    
    implicit none
    character(len=*), intent(in) :: line
    character(len=*), intent(inout) :: processed_line
    integer, intent(inout) :: len_line, pos, quote
    logical, intent(out) :: other_statement
    logical, intent(inout) :: block_comment
!#......................................................................
    character(len=2) :: special_token
    character :: quote_character
    logical :: quote_found
    integer :: from_pos, shift
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    from_pos = pos
    if (block_comment) then !# Within a block-comment.
       shift = index(line(pos:), "*/")
       if (shift == 0) then
          other_statement = .false.
          return
       else
          pos = pos+shift+1
          block_comment = .false.
          call process_line1(line, processed_line, &
               len_line, pos, quote, other_statement, block_comment)
       endif
    else !# Not within a block-comment.
       if (quote == 0) then !# Not within a string.
          if (pos > len_trim(line)) then
             other_statement = .false.
             return
          endif
          
          call find_first_special_token(line, pos, special_token)

          if (special_token == "/*") then !# Block comment starting.
             
             pos = pos-1
             processed_line = processed_line(:len_line) // line(from_pos:pos)
             len_line = len_line+pos-from_pos+1
             pos = pos+3
             block_comment = .true.
             other_statement = .false.
             call process_line1(line, processed_line, &
                  len_line, pos, quote, other_statement, block_comment)

          else if (special_token == "!") then !# Inline comment.
             
             pos = pos-1
             processed_line = processed_line(:len_line) // line(from_pos:pos)
             len_line = len_line+pos-from_pos+1
             other_statement = .false.             
             return
             
          else if (special_token == ";") then
             
             if (line(pos:) /= ";") then
                other_statement = .true. !# Statement after the `;`.
             else
                other_statement = .false.
             endif
             pos = pos-1
             processed_line = processed_line(:len_line) // line(from_pos:pos)
             len_line = len_line+pos-from_pos+1
             pos = pos+2
             return
             
          else if (special_token == "'") then !# String beginning with `'`.
             
             processed_line = processed_line(:len_line) // line(from_pos:pos)
             len_line = len_line+pos-from_pos+1
             pos = pos+1
             quote = 1
             call process_line1(line, processed_line, &
                  len_line, pos, quote, other_statement, block_comment)

          else if (special_token == '"') then !# String beginning with `"`.
             
             processed_line = processed_line(:len_line) // line(from_pos:pos)
             len_line = len_line+pos-from_pos+1
             pos = pos+1
             quote = 2
             call process_line1(line, processed_line, &
                  len_line, pos, quote, other_statement, block_comment)

          else !# No special_token.
             
             other_statement = .false.
             pos = len_trim(line)
             processed_line = processed_line(:len_line) // line(from_pos:pos)
             len_line = len_line+pos-from_pos+1
             return
          endif
          
       else !# Within a string.
          
          if (quote == 1) then
             quote_character = "'"
          else !# quote = 2.
             quote_character = '"'
          endif
          call find_closing_quote(line, pos, quote_character, quote_found)
          if (quote_found) then
             processed_line = processed_line(:len_line) // line(from_pos:pos)
             len_line = len_line+pos-from_pos+1
             pos = pos+1
             quote = 0
             call process_line1(line, processed_line, &
                  len_line, pos, quote, other_statement, block_comment)
          else
             pos = len_trim(line)
             processed_line = processed_line(:len_line) // line(from_pos:pos)
             len_line = len_line+pos-from_pos+1
             other_statement = .false.
             return
          endif
       endif
    endif

  end subroutine process_line1

!#======================================================================

  subroutine process_line2(processed_line, len_line, &
       quote0, quote, incomplete_statement)

    use mod_analyze_statement, only : error_message
    
    implicit none
    character(len=*), intent(inout) :: processed_line
    integer, intent(out) :: len_line
    integer, intent(in) :: quote0, quote
    logical, intent(inout) :: incomplete_statement
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
!# `&` at the beginning of the line?

    processed_line = adjustl(processed_line)       
    if (processed_line(1:1) == "&") then
       processed_line = processed_line(2:)
       if (processed_line == "") call error_message( &
            "`&` should not be the only nonblank character on a line, nor be &
            &the only nonblank character before a comment.")
       if (.not.incomplete_statement) call error_message( &
            "this line begins with a `&`, but previous line did not end &
            &with `&`.")
    else if (quote0 /= 0) then
       call error_message( &
            "current line should begin with `&` since a string has been split &
            &at the end of previous line.")
    else if (incomplete_statement) then !# To detect split tokens.
       processed_line = " " // processed_line
    endif

!# `&` at the end of the line?
    
    len_line = len_trim(processed_line)
    if (processed_line(len_line:len_line) == "&") then
       incomplete_statement = .true.
       len_line = len_line-1          
    else
       if (quote /= 0) call error_message( &
            "string not closed; close it or continue the line with `&`.")
       incomplete_statement = .false.
    endif
    
  end subroutine process_line2

!#======================================================================

  subroutine find_first_special_token(line, pos, special_token)

    implicit none
    character(len=*), intent(in) :: line
    integer, intent(inout) :: pos
    character(len=2), intent(out) :: special_token
!#......................................................................
    integer :: shift, shift2
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    shift = scan(line(pos:), "!;'""")
    shift2 = index(line(pos:), "/*")

    if (shift == 0 .and. shift2 == 0) then !# No special token.
       special_token = ""
    else if (shift == 0 .or. (shift2 > 0 .and. shift2 < shift)) then !# Special \
!# token: `/*`.
       pos = pos+shift2-1
       special_token = "/*"
    else !# Other special token.
       pos = pos+shift-1
       special_token = line(pos:pos)
    endif

  end subroutine find_first_special_token
  
!#======================================================================

  subroutine include_file(enclosing_file_name, statement, &
       read_proc, end_proc, run, end_of_file, end_statement, return_statement)

    use mod_file_access
    use mod_analyze_statement, only : file_name, error_message
    
    implicit none
    external :: read_proc, end_proc
    interface
       subroutine read_proc(key, rhs, indices_string, unknown_statement, &
            statement_type)
         use mod_strings, only : same_case_equal
         implicit none
         character(len=*), intent(in) :: key, rhs, statement_type
         character(len=*), intent(inout) :: indices_string
         logical, intent(out) :: unknown_statement
       end subroutine read_proc

       subroutine end_proc(run)
         use mod_strings, only : same_case_equal
         implicit none
         logical, intent(out) :: run
       end subroutine end_proc
    end interface
    character(len=*), intent(in) :: enclosing_file_name, statement
    logical, intent(out) :: run, end_of_file, end_statement, return_statement
!#......................................................................
    character(len=len(statement)) :: included_file_name
    character(len=len(enclosing_file_name)) :: dir_name
    integer :: unit
    logical :: opened
    type(struct_file_list), pointer :: tmp_file_list
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    if (scan(statement(1:1), "'""") == 0) then
       file_name = enclosing_file_name
       call error_message( &
            "the name of an included file should be given between quotes &
            &or apostrophes.")
    endif
    read(statement,*) included_file_name
    dir_name = enclosing_file_name(:index(enclosing_file_name, "/", &
         back=.true.))
    included_file_name = trim(dir_name) // trim(included_file_name)

    inquire(file = included_file_name, opened = opened)
    if (opened) then
       file_name = enclosing_file_name
       call error_message( &
            "a file cannot include itself, directly or indirectly.")
    endif

    call open_file(unit, included_file_name)
    allocate(tmp_file_list)
    tmp_file_list % unit = unit
    tmp_file_list % file_name = included_file_name
    tmp_file_list % line_number = 0
    tmp_file_list % included_file = .true.
    tmp_file_list % next => file_list !# `next` is the enclosing file.
    file_list => tmp_file_list
    call parse_file(file_list = file_list, read_proc = read_proc, &
         end_proc = end_proc, &
         run = run, end_of_file = end_of_file, end_statement = end_statement, &
         return_statement = return_statement)
    
  end subroutine include_file

end module mod_parse_file

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_linked_list

  use mod_types
  implicit none
  private

  type :: lk_lst_CDR
     real(CDR) :: val
     type(lk_lst_CDR), pointer :: ptr => null()
  end type lk_lst_CDR

  type :: lk_lst_DPR
     real(DPR) :: val
     type(lk_lst_DPR), pointer :: ptr => null()
  end type lk_lst_DPR

  type :: lk_lst_std_string
     character(len=std_string) :: val
     type(lk_lst_std_string), pointer :: ptr => null()
  end type lk_lst_std_string

  type :: lk_lst_long_string
     character(len=long_string) :: val
     type(lk_lst_long_string), pointer :: ptr => null()
  end type lk_lst_long_string

  interface lk_lst_destroy
     module procedure lk_lst_destroy_CDR, &
          lk_lst_destroy_DPR, &
          lk_lst_destroy_std_string, &
          lk_lst_destroy_long_string
  end interface lk_lst_destroy

  interface lk_lst_initialize
     module procedure lk_lst_initialize_CDR, &
          lk_lst_initialize_DPR, &
          lk_lst_initialize_std_string, &
          lk_lst_initialize_long_string
  end interface lk_lst_initialize

  interface lk_lst_new_node
     module procedure lk_lst_new_node_CDR, &
          lk_lst_new_node_DPR, &
          lk_lst_new_node_std_string, &
          lk_lst_new_node_long_string
  end interface lk_lst_new_node

  interface lk_lst_to_array
     module procedure lk_lst_to_array_CDR, &
          lk_lst_to_array_DPR, &
          lk_lst_to_array_std_string, &
          lk_lst_to_array_long_string
  end interface lk_lst_to_array

  public :: lk_lst_CDR, lk_lst_DPR, &
       lk_lst_std_string, lk_lst_long_string, &
       lk_lst_destroy, lk_lst_initialize, lk_lst_new_node, &
       lk_lst_to_array

contains

!#======================================================================

  subroutine lk_lst_destroy_CDR(head_node)

    implicit none
    type(lk_lst_CDR), intent(inout) :: head_node
!#......................................................................
    type(lk_lst_CDR), pointer :: current_node, next_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Delete linked list, if already existing.
    current_node => head_node % ptr
    do
       if (.not.associated(current_node)) exit
       next_node => current_node % ptr
       deallocate(current_node)
       current_node => next_node
    enddo

  end subroutine lk_lst_destroy_CDR

!#======================================================================

  subroutine lk_lst_initialize_CDR(head_node)

    implicit none
    type(lk_lst_CDR), intent(inout) :: head_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Delete linked list, if already existing.
    call lk_lst_destroy_CDR(head_node)

!# Set the head of the linked list.
    nullify(head_node % ptr)

  end subroutine lk_lst_initialize_CDR

!#======================================================================

  subroutine lk_lst_new_node_CDR(head_node, current_node)

    implicit none
    type(lk_lst_CDR), intent(inout) :: head_node
    type(lk_lst_CDR), pointer :: current_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (.not.associated(head_node % ptr)) then
       allocate(head_node % ptr)
       current_node => head_node % ptr
    else
       allocate(current_node % ptr)
       current_node => current_node % ptr
    endif
    nullify(current_node % ptr)

  end subroutine lk_lst_new_node_CDR

!#======================================================================

  subroutine lk_lst_to_array_CDR(head_node, array, dim_array)

!# Convert linked list `head_node` to the 1D array `array` and destroy the linked list.
!# If not provided, the size of the array, `dim_array` is computed from the linked list.

    implicit none
    type(lk_lst_CDR) :: head_node
    real(CDR), dimension(:), pointer :: array
    integer, intent(in), optional :: dim_array
!#......................................................................
    integer :: dim_array_eff, i
    type(lk_lst_CDR), pointer :: current_node, next_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(dim_array)) then
       dim_array_eff = dim_array
    else
       dim_array_eff = 0
       current_node => head_node % ptr
       do
          if (.not.associated(current_node)) exit
          dim_array_eff = dim_array_eff + 1
          current_node => current_node % ptr
       enddo
    endif

    if (associated(array)) deallocate(array)
    allocate(array(dim_array_eff))

    current_node => head_node % ptr
    do i = 1, dim_array_eff
       if (.not.associated(current_node)) then
          write(*,"(a)") "The length of the linked list is larger than &
               &the size of the array into which it is converted. Stopped."
          stop
       endif
       next_node => current_node % ptr
       array(i) = current_node % val
       deallocate(current_node)
       current_node => next_node
    enddo

    nullify(head_node % ptr)

  end subroutine lk_lst_to_array_CDR

!#======================================================================

  subroutine lk_lst_destroy_DPR(head_node)

    implicit none
    type(lk_lst_DPR), intent(inout) :: head_node
!#......................................................................
    type(lk_lst_DPR), pointer :: current_node, next_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Delete linked list, if already existing.
    current_node => head_node % ptr
    do
       if (.not.associated(current_node)) exit
       next_node => current_node % ptr
       deallocate(current_node)
       current_node => next_node
    enddo

  end subroutine lk_lst_destroy_DPR

!#======================================================================

  subroutine lk_lst_initialize_DPR(head_node)

    implicit none
    type(lk_lst_DPR), intent(inout) :: head_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Delete linked list, if already existing.
    call lk_lst_destroy_DPR(head_node)

!# Set the head of the linked list.
    nullify(head_node % ptr)

  end subroutine lk_lst_initialize_DPR

!#======================================================================

  subroutine lk_lst_new_node_DPR(head_node, current_node)

    implicit none
    type(lk_lst_DPR), intent(inout) :: head_node
    type(lk_lst_DPR), pointer :: current_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (.not.associated(head_node % ptr)) then
       allocate(head_node % ptr)
       current_node => head_node % ptr
    else
       allocate(current_node % ptr)
       current_node => current_node % ptr
    endif
    nullify(current_node % ptr)

  end subroutine lk_lst_new_node_DPR

!#======================================================================

  subroutine lk_lst_to_array_DPR(head_node, array, dim_array)

!# Convert linked list `head_node` to the 1D array `array` and destroy the linked list.
!# If not provided, the size of the array, `dim_array` is computed from the linked list.

    implicit none
    type(lk_lst_DPR) :: head_node
    real(DPR), dimension(:), pointer :: array
    integer, intent(in), optional :: dim_array
!#......................................................................
    integer :: dim_array_eff, i
    type(lk_lst_DPR), pointer :: current_node, next_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(dim_array)) then
       dim_array_eff = dim_array
    else
       dim_array_eff = 0
       current_node => head_node % ptr
       do
          if (.not.associated(current_node)) exit
          dim_array_eff = dim_array_eff + 1
          current_node => current_node % ptr
       enddo
    endif

    if (associated(array)) deallocate(array)
    allocate(array(dim_array_eff))

    current_node => head_node % ptr
    do i = 1, dim_array_eff
       if (.not.associated(current_node)) then
          write(*,"(a)") "The length of the linked list is larger than &
               &the size of the array into which it is converted. Stopped."
          stop
       endif
       next_node => current_node % ptr
       array(i) = current_node % val
       deallocate(current_node)
       current_node => next_node
    enddo

    nullify(head_node % ptr)

  end subroutine lk_lst_to_array_DPR

!#======================================================================

  subroutine lk_lst_destroy_std_string(head_node)

    implicit none
    type(lk_lst_std_string), intent(inout) :: head_node
!#......................................................................
    type(lk_lst_std_string), pointer :: current_node, next_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Delete linked list, if already existing.
    current_node => head_node % ptr
    do
       if (.not.associated(current_node)) exit
       next_node => current_node % ptr
       deallocate(current_node)
       current_node => next_node
    enddo

  end subroutine lk_lst_destroy_std_string

!#======================================================================

  subroutine lk_lst_initialize_std_string(head_node)

    implicit none
    type(lk_lst_std_string), intent(inout) :: head_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Delete linked list, if already existing.
    call lk_lst_destroy_std_string(head_node)

!# Set the head of the linked list.
    nullify(head_node % ptr)

  end subroutine lk_lst_initialize_std_string

!#======================================================================

  subroutine lk_lst_new_node_std_string(head_node, current_node)

    implicit none
    type(lk_lst_std_string), intent(inout) :: head_node
    type(lk_lst_std_string), pointer :: current_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (.not.associated(head_node % ptr)) then
       allocate(head_node % ptr)
       current_node => head_node % ptr
    else
       allocate(current_node % ptr)
       current_node => current_node % ptr
    endif
    nullify(current_node % ptr)

  end subroutine lk_lst_new_node_std_string

!#======================================================================

  subroutine lk_lst_to_array_std_string(head_node, array, dim_array)

!# Convert linked list `head_node` to the 1D array `array` and destroy the linked list.
!# If not provided, the size of the array, `dim_array` is computed from the linked list.

    implicit none
    type(lk_lst_std_string) :: head_node
    character(len=*), dimension(:), pointer :: array
    integer, intent(in), optional :: dim_array
!#......................................................................
    integer :: dim_array_eff, i
    type(lk_lst_std_string), pointer :: current_node, next_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(dim_array)) then
       dim_array_eff = dim_array
    else
       dim_array_eff = 0
       current_node => head_node % ptr
       do
          if (.not.associated(current_node)) exit
          dim_array_eff = dim_array_eff + 1
          current_node => current_node % ptr
       enddo
    endif

    if (associated(array)) deallocate(array)
    allocate(array(dim_array_eff))

    current_node => head_node % ptr
    do i = 1, dim_array_eff
       if (.not.associated(current_node)) then
          write(*,"(a)") "The length of the linked list is larger than &
               &the size of the array into which it is converted. Stopped."
          stop
       endif
       next_node => current_node % ptr
       array(i) = current_node % val
       deallocate(current_node)
       current_node => next_node
    enddo

    nullify(head_node % ptr)

  end subroutine lk_lst_to_array_std_string

!#======================================================================

  subroutine lk_lst_destroy_long_string(head_node)

    implicit none
    type(lk_lst_long_string), intent(inout) :: head_node
!#......................................................................
    type(lk_lst_long_string), pointer :: current_node, next_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Delete linked list, if already existing.
    current_node => head_node % ptr
    do
       if (.not.associated(current_node)) exit
       next_node => current_node % ptr
       deallocate(current_node)
       current_node => next_node
    enddo

  end subroutine lk_lst_destroy_long_string

!#======================================================================

  subroutine lk_lst_initialize_long_string(head_node)

    implicit none
    type(lk_lst_long_string), intent(inout) :: head_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Delete linked list, if already existing.
    call lk_lst_destroy_long_string(head_node)

!# Set the head of the linked list.
    nullify(head_node % ptr)

  end subroutine lk_lst_initialize_long_string

!#======================================================================

  subroutine lk_lst_new_node_long_string(head_node, current_node)

    implicit none
    type(lk_lst_long_string), intent(inout) :: head_node
    type(lk_lst_long_string), pointer :: current_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (.not.associated(head_node % ptr)) then
       allocate(head_node % ptr)
       current_node => head_node % ptr
    else
       allocate(current_node % ptr)
       current_node => current_node % ptr
    endif
    nullify(current_node % ptr)

  end subroutine lk_lst_new_node_long_string

!#======================================================================

  subroutine lk_lst_to_array_long_string(head_node, array, dim_array)

!# Convert linked list `head_node` to the 1D array `array` and destroy the linked list.
!# If not provided, the size of the array, `dim_array` is computed from the linked list.

    implicit none
    type(lk_lst_long_string) :: head_node
    character(len=*), dimension(:), pointer :: array
    integer, intent(in), optional :: dim_array
!#......................................................................
    integer :: dim_array_eff, i
    type(lk_lst_long_string), pointer :: current_node, next_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(dim_array)) then
       dim_array_eff = dim_array
    else
       dim_array_eff = 0
       current_node => head_node % ptr
       do
          if (.not.associated(current_node)) exit
          dim_array_eff = dim_array_eff + 1
          current_node => current_node % ptr
       enddo
    endif

    if (associated(array)) deallocate(array)
    allocate(array(dim_array_eff))

    current_node => head_node % ptr
    do i = 1, dim_array_eff
       if (.not.associated(current_node)) then
          write(*,"(a)") "The length of the linked list is larger than &
               &the size of the array into which it is converted. Stopped."
          stop
       endif
       next_node => current_node % ptr
       array(i) = current_node % val
       deallocate(current_node)
       current_node => next_node
    enddo

    nullify(head_node % ptr)

  end subroutine lk_lst_to_array_long_string

end module mod_linked_list

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_tracks

  use mod_types

  implicit none
  private
  type :: struct_track
     real(DPR) :: init_mass
     real(DPR) :: l10_init_mass
     real(DPR) :: mass_HB
     real(DPR) :: final_mass
     real(DPR) :: lifetime
     integer :: dim_age
     integer :: WD_extension
     real(DPR) :: last_age
     real(DPR), dimension(:), pointer :: age => null()
     real(DPR), dimension(:), pointer :: lum => null()
     real(DPR), dimension(:), pointer :: T_eff => null()
     real(DPR), dimension(:), pointer :: grav => null()
  end type struct_track

  type :: lk_lst_track
     type(lk_lst_track), pointer :: ptr => null()
     real(DPR) :: init_mass
     real(DPR) :: l10_mass
     integer :: WD_extension
     integer :: dim_age
     real(DPR), dimension(:), pointer :: age => null()
     real(DPR), dimension(:), pointer :: lum => null()
     real(DPR), dimension(:), pointer :: T_eff => null()
     real(DPR), dimension(:), pointer :: grav => null()
  end type lk_lst_track

  public :: read_tracks, connect_tracks, white_dwarfs_tracks, struct_track

contains

!#======================================================================

  subroutine read_tracks(tracks_file, X_sol, Z_sol, &
       n_MS, n_He_flash, n_HB, n_VLM, dim_age_WD, Y_track, Z_track, &
       M_over_H_track, min_mass_CCSN, &
       std_track)

    use mod_types
    use mod_directories, only : tracks_dir
    use mod_interp, only : interp_lin_lin, interp_lin_log
    use mod_file_access, only : open_file, close_file, path_file

    implicit none
    character(len=*), intent(in) :: tracks_file
    real(DPR), intent(in) :: X_sol, Z_sol
    integer, intent(out) :: n_MS, n_He_flash, n_HB, n_VLM, dim_age_WD
    real(DPR), intent(out) :: Y_track, Z_track, M_over_H_track, min_mass_CCSN
    type(struct_track), dimension(:), pointer :: std_track
!#......................................................................
    real(DPR) :: mass_core, gross_Z_ejec_wind, delta_t, X_track
    integer :: i_track, i_MS, i_age, unit, dim_age_tot
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call open_file(unit, path_file(tracks_dir, tracks_file))
    read(unit, *) n_MS, n_He_flash, n_HB, n_VLM, Z_track, Y_track, &
         min_mass_CCSN, dim_age_WD
    X_track = 1 - Y_track - Z_track
    M_over_H_track = log10((Z_track/X_track) / (Z_sol/X_sol))

!#     `n_MS`: total number of ZAMS tracks (i.e. starting on the zero-age main sequence).
!#     `n_HB`: number of ZAHB tracks (i.e. starting on the zero-age horizontal branch);
!#           only for stars undergoing the helium flash.
!#     `n_VLM`: number of ZAMS tracks for very low mass stars (~<= 0.5 Msol)
!#           which do not evolve. (Included in `n_MS`.)
!#     `n_He_flash`: number of ZAMS tracks (ZAMS->tip of the RGB)
!#           for low-mass stars which undergo the helium flash
!#           and *must* be connected to ZAHB tracks. (Included in `n_MS`, but excludes
!#           very low mass stars.)
!#
!# `mass_core` is the final mass of the core.
!# `gross_Z_ejec_wind` is the gross ejecta from metals due to winds and directly computed
!# from the tracks.
!# None of these quantities is used. (The yields of metals are read from files of yields.)

    if (associated(std_track)) then
       do i_track = 1, size(std_track)
          if (associated(std_track(i_track) % age)) &
               deallocate(std_track(i_track) % age)
          if (associated(std_track(i_track) % lum)) &
               deallocate(std_track(i_track) % lum)
          if (associated(std_track(i_track) % T_eff)) &
               deallocate(std_track(i_track) % T_eff)
          if (associated(std_track(i_track) % grav)) &
               deallocate(std_track(i_track) % grav)
       enddo
       deallocate(std_track)
    endif

!# The size of `std_track` will be larger than `n_MS + n_HB` (the original
!# value of `n_HB`) because `n_HB_supp` tracks are added in subroutine
!# `connect_tracks`.
    allocate(std_track(n_MS + n_HB))

!# For all ZAMS tracks:
    do i_track = 1, n_MS
       read(unit, *) std_track(i_track) % init_mass, &
            std_track(i_track) % dim_age, &
            mass_core, &
            std_track(i_track) % final_mass, &
            std_track(i_track) % WD_extension, &
            gross_Z_ejec_wind
       dim_age_tot = std_track(i_track) % dim_age + &
            std_track(i_track) % WD_extension*dim_age_WD
       allocate(std_track(i_track) % age(dim_age_tot))
       allocate(std_track(i_track) % lum(dim_age_tot))
       allocate(std_track(i_track) % T_eff(dim_age_tot))
       allocate(std_track(i_track) % grav(dim_age_tot))
       do i_age = 1, dim_age_tot
          read(unit, *) std_track(i_track) % lum(i_age), &
               std_track(i_track) % T_eff(i_age), &
               std_track(i_track) % grav(i_age), std_track(i_track) % age(i_age)
       end do
       std_track(i_track) % last_age = &
            std_track(i_track) % age(std_track(i_track) % dim_age)
       std_track(i_track) % l10_init_mass = &
            log10(std_track(i_track) % init_mass)
    end do

!# For ZAHB tracks except the one with the largest mass on the ZAHB:
    do i_track = n_MS+1, n_MS+n_HB-1
       read(unit, *) std_track(i_track) % mass_HB, &
            std_track(i_track) % dim_age, &
            mass_core, &
            std_track(i_track) % final_mass, &
            std_track(i_track) % WD_extension, &
            gross_Z_ejec_wind
       i_MS = n_VLM
       do while(.not.(std_track(i_MS) % final_mass <= std_track(i_track) % mass_HB .and. &
            std_track(i_track) % mass_HB <= std_track(i_MS+1) % final_mass))
          i_MS = i_MS+1
       end do
       std_track(i_track) % init_mass = interp_lin_lin( &
            std_track(i_MS) % final_mass, &
            std_track(i_MS+1) % final_mass, &
            std_track(i_MS) % init_mass, &
            std_track(i_MS+1) % init_mass, &
            std_track(i_track) % mass_HB)
       std_track(i_track) % l10_init_mass = &
            log10(std_track(i_track) % init_mass)
       std_track(i_track) % lifetime = &
            interp_lin_log(std_track(i_MS) % l10_init_mass, &
            std_track(i_MS+1) % l10_init_mass, &
            std_track(i_MS) % last_age, &
            std_track(i_MS+1) % last_age, &
            std_track(i_track) % l10_init_mass)

       dim_age_tot = std_track(i_track) % dim_age + &
            std_track(i_track) % WD_extension*dim_age_WD
       allocate(std_track(i_track) % age(dim_age_tot))
       allocate(std_track(i_track) % lum(dim_age_tot))
       allocate(std_track(i_track) % T_eff(dim_age_tot))
       allocate(std_track(i_track) % grav(dim_age_tot))
       do i_age = 1, dim_age_tot
          read(unit, *) std_track(i_track) % lum(i_age), &
               std_track(i_track) % T_eff(i_age), &
               std_track(i_track) % grav(i_age), &
               std_track(i_track) % age(i_age)
       end do
       std_track(i_track) % last_age = &
            std_track(i_track) % age(std_track(i_track) % dim_age)
    end do

!# For the ZAHB track with the largest mass on the ZAHB:
    i_track = n_MS+n_HB
    read(unit, *) std_track(i_track) % mass_HB, &
         std_track(i_track) % dim_age, mass_core, &
         std_track(i_track) % final_mass, std_track(i_track) % WD_extension, &
         gross_Z_ejec_wind
    dim_age_tot = std_track(i_track) % dim_age + &
         std_track(i_track) % WD_extension*dim_age_WD
    allocate(std_track(i_track) % age(dim_age_tot))
    allocate(std_track(i_track) % lum(dim_age_tot))
    allocate(std_track(i_track) % T_eff(dim_age_tot))
    allocate(std_track(i_track) % grav(dim_age_tot))
    do i_age = 1, dim_age_tot
       read(unit, *) std_track(i_track) % lum(i_age), &
            std_track(i_track) % T_eff(i_age), &
            std_track(i_track) % grav(i_age), std_track(i_track) % age(i_age)
    end do
    std_track(i_track) % last_age = &
         std_track(i_track) % age(std_track(i_track) % dim_age)
    std_track(i_track) % lifetime = std_track(n_VLM+n_He_flash) % last_age
    std_track(i_track) % init_mass = std_track(n_VLM+n_He_flash) % init_mass
    std_track(i_track) % l10_init_mass = std_track(n_VLM+n_He_flash) % l10_init_mass

!# For the ZAMS track with the lowest mass not undergoing the helium flash
!# (excluding very low mass stars):
    i_track = n_VLM+n_He_flash+1
    delta_t = std_track(n_VLM+n_He_flash) % last_age &
         + std_track(n_MS+n_HB) % last_age &
         - std_track(i_track) % last_age
    dim_age_tot = std_track(i_track) % dim_age + &
         std_track(i_track) % WD_extension*dim_age_WD
    do i_age = std_track(i_track) % dim_age, dim_age_tot
       std_track(i_track) % age(i_age) = std_track(i_track) % age(i_age) + &
            delta_t !# !!! Age shift added so that the sequence of ages is increasing.
    end do
    call close_file(unit)

  end subroutine read_tracks

!#======================================================================

  subroutine connect_tracks(n_MS, n_VLM, n_He_flash, n_HB, dim_age_WD, &
       std_track)

    use mod_types

    implicit none
    integer, intent(in) :: n_MS, n_VLM, n_He_flash, dim_age_WD
    integer, intent(inout) :: n_HB
    type(struct_track), dimension(:), pointer :: std_track
!#......................................................................
    integer :: n_HB_supp, i_MS, i_HB, i_track, first_HB
    real(DPR) :: alpha
    integer :: dim_age_tot
    type(struct_track), dimension(:), allocatable :: tmp_track

    type(lk_lst_track) :: head_node
    type(lk_lst_track), pointer :: current_node => null()
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    first_HB = n_MS+1
    i_HB = first_HB
    i_MS = n_VLM+1
    n_HB_supp = 0

    call lk_lst_initialize_track(head_node)

!# Extension of the ZAMS tracks by ZAHB tracks for stars undergoing
!# the Helium flash AND "extension" of the ZAHB tracks by ZAMS tracks.

    do while (i_MS < n_VLM+n_He_flash)
       if (std_track(i_MS) % final_mass < std_track(first_HB) % mass_HB) then
          if (std_track(i_MS) % init_mass >= std_track(first_HB) % mass_HB) then

!# Stars with a ZAMS mass higher than the lowest ZAHB mass
!# [mass_HB(n_MS+1)], but which have, at the end of the RGB, a current
!# mass lower than mass_HB(n_MS+1), are assigned the evolution
!# corresponding to mass_HB(n_MS+1) after the RGB.

             n_HB_supp = n_HB_supp+1
             dim_age_tot = std_track(first_HB) % dim_age &
                  + std_track(first_HB) % WD_extension*dim_age_WD
             call lk_lst_new_node_track(head_node, current_node, &
                  dim_age_tot)
             current_node % l10_mass = std_track(i_MS) % l10_init_mass
             current_node % init_mass = std_track(i_MS) % init_mass
             current_node % WD_extension = std_track(first_HB) % WD_extension
             current_node % dim_age = std_track(first_HB) % dim_age
             current_node % age(:) = &
                  std_track(i_MS) % last_age &
                  + std_track(first_HB) % age(:)
             current_node % lum(:) = std_track(first_HB) % lum(:)
             current_node % T_eff(:) = std_track(first_HB) % T_eff(:)
             current_node % grav(:) = std_track(first_HB) % grav(:)
             i_MS = i_MS+1
          end if
       else
          if (std_track(i_HB) % l10_init_mass < &
               std_track(i_MS) % l10_init_mass) then

!# "Extension" of the ZAHB tracks by ZAMS tracks.

             dim_age_tot = std_track(i_HB) % dim_age + &
                  std_track(i_HB) % WD_extension*dim_age_WD
             call lk_lst_new_node_track(head_node, current_node, &
                  dim_age_tot)
             current_node % l10_mass = std_track(i_HB) % l10_init_mass
             current_node % init_mass = std_track(i_HB) % init_mass
             current_node % WD_extension = std_track(i_HB) % WD_extension
             current_node % dim_age = std_track(i_HB) % dim_age
             current_node % age(:) = std_track(i_HB) % lifetime + &
                  std_track(i_HB) % age(:)
             current_node % lum(:) = std_track(i_HB) % lum(:)
             current_node % T_eff(:) = std_track(i_HB) % T_eff(:)
             current_node % grav(:) = std_track(i_HB) % grav(:)
             i_HB = i_HB+1
          else

!# Extension of the ZAMS tracks by ZAHB tracks.

             n_HB_supp = n_HB_supp+1
             alpha = (std_track(i_HB) % l10_init_mass - &
                  std_track(i_MS) % l10_init_mass)/ &
                  (std_track(i_HB) % l10_init_mass - &
                  std_track(i_HB-1) % l10_init_mass)
             dim_age_tot = std_track(i_HB-1) % dim_age + &
                  std_track(i_HB-1) % WD_extension*dim_age_WD
             call lk_lst_new_node_track(head_node, current_node, &
                  dim_age_tot)
             current_node % WD_extension = std_track(i_HB-1) % WD_extension
             current_node % l10_mass = std_track(i_MS) % l10_init_mass
             current_node % init_mass = std_track(i_MS) % init_mass
             current_node % dim_age = std_track(i_HB-1) % dim_age
             current_node % age(1) = std_track(i_MS) % last_age
             current_node % age(2:) = &
                  std_track(i_MS) % last_age &
                  + 10**(alpha*log10(std_track(i_HB-1) % age(2:)) &
                  + (1-alpha)*log10(std_track(i_HB) % age(2:)))
             current_node % lum(:) = alpha*std_track(i_HB-1) % lum(:) &
                  + (1-alpha)*std_track(i_HB) % lum(:)
             current_node % T_eff(:) = alpha*std_track(i_HB-1) % T_eff(:) &
                  + (1-alpha)*std_track(i_HB) % T_eff(:)
             current_node % grav(:) = alpha*std_track(i_HB-1) % grav(:) &
                  + (1-alpha)*std_track(i_HB) % grav(:)
             i_MS = i_MS+1
          end if
       end if
    end do

!# "Extension" of the remaining ZAHB tracks by ZAMS tracks.

    do i_track = i_HB, n_MS+n_HB
       dim_age_tot = std_track(i_track) % dim_age + &
            std_track(i_track) % WD_extension*dim_age_WD
       call lk_lst_new_node_track(head_node, current_node, &
            dim_age_tot)
       current_node % l10_mass = std_track(i_track) % l10_init_mass
       current_node % init_mass = std_track(i_track) % init_mass
       current_node % WD_extension = std_track(i_track) % WD_extension
       current_node % dim_age = std_track(i_track) % dim_age
       current_node % age(:) = std_track(i_track) % lifetime + &
            std_track(i_track) % age(:)
       current_node % lum(:) = std_track(i_track) % lum(:)
       current_node % T_eff(:) = std_track(i_track) % T_eff(:)
       current_node % grav(:) = std_track(i_track) % grav(:)
    end do

    n_HB = n_HB+n_HB_supp

!# Reallocate `std_track` to include `_supp` tracks. Uses the temporary
!# array `tmp_track`.
!# ??? Cumbersome!
    if (allocated(tmp_track)) then
       do i_track = 1, size(tmp_track)
          if (associated(tmp_track(i_track) % age)) &
               deallocate(tmp_track(i_track) % age)
          if (associated(tmp_track(i_track) % lum)) &
               deallocate(tmp_track(i_track) % lum)
          if (associated(tmp_track(i_track) % T_eff)) &
               deallocate(tmp_track(i_track) % T_eff)
          if (associated(tmp_track(i_track) % grav)) &
               deallocate(tmp_track(i_track) % grav)
       enddo
       deallocate(tmp_track)
    endif
    allocate(tmp_track(n_MS))
    do i_track = 1, n_MS
       tmp_track(i_track) % l10_init_mass = std_track(i_track) % l10_init_mass
       tmp_track(i_track) % init_mass = std_track(i_track) % init_mass
       tmp_track(i_track) % dim_age = std_track(i_track) % dim_age
       tmp_track(i_track) % WD_extension = std_track(i_track) % WD_extension
       dim_age_tot = size(std_track(i_track) % age)
       allocate(tmp_track(i_track) % age(dim_age_tot))
       allocate(tmp_track(i_track) % lum(dim_age_tot))
       allocate(tmp_track(i_track) % T_eff(dim_age_tot))
       allocate(tmp_track(i_track) % grav(dim_age_tot))
       tmp_track(i_track) % age(:) = std_track(i_track) % age(:)
       tmp_track(i_track) % lum(:) = std_track(i_track) % lum(:)
       tmp_track(i_track) % T_eff(:) = std_track(i_track) % T_eff(:)
       tmp_track(i_track) % grav(:) = std_track(i_track) % grav(:)
    enddo

    do i_track = 1, size(std_track)
       deallocate(std_track(i_track) % age, std_track(i_track) % lum, &
            std_track(i_track) % T_eff, std_track(i_track) % grav)
    enddo
    deallocate(std_track)

    allocate(std_track(n_MS + n_HB))
    do i_track = 1, n_MS
       std_track(i_track) % l10_init_mass = tmp_track(i_track) % l10_init_mass
       std_track(i_track) % init_mass = tmp_track(i_track) % init_mass
       std_track(i_track) % dim_age = tmp_track(i_track) % dim_age
       std_track(i_track) % WD_extension = tmp_track(i_track) % WD_extension
       dim_age_tot = size(tmp_track(i_track) % age)
       allocate(std_track(i_track) % age(dim_age_tot))
       allocate(std_track(i_track) % lum(dim_age_tot))
       allocate(std_track(i_track) % T_eff(dim_age_tot))
       allocate(std_track(i_track) % grav(dim_age_tot))
       std_track(i_track) % age(:) = tmp_track(i_track) % age(:)
       std_track(i_track) % lum(:) = tmp_track(i_track) % lum(:)
       std_track(i_track) % T_eff(:) = tmp_track(i_track) % T_eff(:)
       std_track(i_track) % grav(:) = tmp_track(i_track) % grav(:)
       deallocate(tmp_track(i_track) % age, tmp_track(i_track) % lum, &
            tmp_track(i_track) % T_eff, tmp_track(i_track) % grav)
    enddo
    deallocate(tmp_track)

    current_node => head_node % ptr
    do i_track = first_HB, n_MS+n_HB
       std_track(i_track) % l10_init_mass = current_node % l10_mass
       std_track(i_track) % init_mass = current_node % init_mass
       std_track(i_track) % dim_age = current_node % dim_age
       std_track(i_track) % WD_extension = current_node % WD_extension
       dim_age_tot = std_track(i_track) % dim_age + &
            std_track(i_track) % WD_extension*dim_age_WD
       allocate(std_track(i_track) % age(dim_age_tot))
       allocate(std_track(i_track) % lum(dim_age_tot))
       allocate(std_track(i_track) % T_eff(dim_age_tot))
       allocate(std_track(i_track) % grav(dim_age_tot))
       std_track(i_track) % age(:) = current_node % age(:)
       std_track(i_track) % lum(:) = current_node % lum(:)
       std_track(i_track) % T_eff(:) = current_node % T_eff(:)
       std_track(i_track) % grav(:) = current_node % grav(:)
       current_node => current_node % ptr
    end do

  end subroutine connect_tracks

!#======================================================================

  subroutine white_dwarfs_tracks(dim_WD, n_MS, n_HB, n_VLM, n_He_flash, &
       dim_age_WD, &
       WD_track, std_track)

    use mod_types

    implicit none
    integer, intent(out) :: dim_WD
    integer, intent(in) :: n_MS, n_HB, n_VLM, n_He_flash, dim_age_WD
    type(struct_track), dimension(:), intent(in) :: std_track
    type(struct_track), dimension(:), pointer :: WD_track
!#......................................................................
    integer :: i_track, i_age, i_WD, dim_age
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    dim_WD = count(std_track(n_VLM+n_He_flash+1:n_MS+n_HB-1) % &
         WD_extension > 0)
    if (associated(WD_track)) then
       do i_WD = 1, size(WD_track)
          if (associated(WD_track(i_WD) % lum)) deallocate(WD_track(i_WD) % lum)
          if (associated(WD_track(i_WD) % T_eff)) deallocate(WD_track(i_WD) % T_eff)
          if (associated(WD_track(i_WD) % grav)) deallocate(WD_track(i_WD) % grav)
          if (associated(WD_track(i_WD) % age)) deallocate(WD_track(i_WD) % age)
       enddo
       deallocate(WD_track)
    endif
    allocate(WD_track(dim_WD))
    
    i_WD = 0
    do i_track = n_MS+1, n_MS+n_HB-1
       if (std_track(i_track) % WD_extension > 0) then
          i_WD = i_WD+1
          allocate(WD_track(i_WD) % lum(dim_age_WD))
          allocate(WD_track(i_WD) % T_eff(dim_age_WD))
          allocate(WD_track(i_WD) % grav(dim_age_WD))
          allocate(WD_track(i_WD) % age(dim_age_WD))
          WD_track(i_WD) % init_mass = std_track(i_track) % init_mass
          WD_track(i_WD) % l10_init_mass = std_track(i_track) % l10_init_mass
          dim_age = std_track(i_track) % dim_age
          do i_age = 1, dim_age_WD
             WD_track(i_WD) % lum(i_age) = std_track(i_track) % lum(i_age + dim_age)
             WD_track(i_WD) % T_eff(i_age) = std_track(i_track) % T_eff(i_age + dim_age)
             WD_track(i_WD) % grav(i_age) = std_track(i_track) % grav(i_age + dim_age)
             WD_track(i_WD) % age(i_age) = std_track(i_track) % age(i_age + dim_age)
          end do
          WD_track(i_WD) % last_age = WD_track(i_WD) % age(dim_age_WD)
       end if
    end do
    do i_track = n_VLM+n_He_flash+1, n_MS
       if (std_track(i_track) % WD_extension > 0) then
          i_WD = i_WD+1
          allocate(WD_track(i_WD) % lum(dim_age_WD))
          allocate(WD_track(i_WD) % T_eff(dim_age_WD))
          allocate(WD_track(i_WD) % grav(dim_age_WD))
          allocate(WD_track(i_WD) % age(dim_age_WD))
          WD_track(i_WD) % init_mass = std_track(i_track) % init_mass
          WD_track(i_WD) % l10_init_mass = std_track(i_track) % l10_init_mass
          dim_age = std_track(i_track) % dim_age
          do i_age = 1, dim_age_WD
             WD_track(i_WD) % lum(i_age) = std_track(i_track) % lum(i_age + dim_age)
             WD_track(i_WD) % T_eff(i_age) = std_track(i_track) % T_eff(i_age + dim_age)
             WD_track(i_WD) % grav(i_age) = std_track(i_track) % grav(i_age + dim_age)
             WD_track(i_WD) % age(i_age) = std_track(i_track) % age(i_age + dim_age)
          end do
          WD_track(i_WD) % last_age = WD_track(i_WD) % age(dim_age_WD)
       end if
    end do

  end subroutine white_dwarfs_tracks

!#======================================================================

  subroutine lk_lst_initialize_track(head_node)

    implicit none
    type(lk_lst_track), intent(inout) :: head_node
!#......................................................................
    type(lk_lst_track), pointer :: current_node => null(), &
         next_node => null()
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Delete linked list, if already existing.
!# ??? Utiliser next_node.
    current_node => head_node % ptr
    do
       if (.not.associated(current_node)) exit
       next_node => current_node % ptr
       if (associated(current_node % age)) deallocate(current_node % age)
       if (associated(current_node % lum)) deallocate(current_node % lum)
       if (associated(current_node % T_eff)) deallocate(current_node % T_eff)
       if (associated(current_node % grav)) deallocate(current_node % grav)
       deallocate(current_node)
       current_node => next_node
    enddo

!# Set the head of the linked list.
    nullify(head_node % ptr)

  end subroutine lk_lst_initialize_track

!#======================================================================

  subroutine lk_lst_new_node_track(head_node, current_node, dim_age_tot)

    implicit none
    type(lk_lst_track), intent(inout) :: head_node
    type(lk_lst_track), pointer :: current_node
    integer, intent(in) :: dim_age_tot
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    if (.not.associated(head_node % ptr)) then
       allocate(head_node % ptr)
       current_node => head_node % ptr
    else
       allocate(current_node % ptr)
       current_node => current_node % ptr
    endif
    nullify(current_node % ptr)
    allocate(current_node % age(dim_age_tot))
    allocate(current_node % lum(dim_age_tot))
    allocate(current_node % T_eff(dim_age_tot))
    allocate(current_node % grav(dim_age_tot))

  end subroutine lk_lst_new_node_track

end module mod_tracks

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_SSPs_constants

  use mod_types
  
  implicit none
  private

  character(len=std_string), parameter, public :: &
       tracks_sets_list = "list_tracks_sets.txt", &
       SSPs_ages_list = "list_SSPs_ages.txt", &
       yields_list = "list_yields.txt"

!# Bin size, in log10 of the stellar mass, used to compute the ejecta of SSPs.
  real(DPR), parameter, public :: d_l10_m_ejec = 0.01_DPR

!# Bin sizes in log10 of the {stellar mass / effective temperature / bolometric
!# luminosity} used to subdivide the isochrones.
  real(DPR), parameter, public :: d_l10_m_isoch = 0.01_DPR, &
       d_T_isoch = 0.01_DPR, d_L_isoch = 0.01_DPR

!# Minimal mass (primary + secundary) a close binary system must have to produce 
!# an SNIa (Matteucci & Greggio 86).
  real(DPR), parameter, public :: min_mass_SNIa = 3._DPR

!# Exponent of the mass-ratio function of close binary stars (MG86).
  real(DPR), parameter, public :: close_bin_gamma = 2._DPR

!# Indicative value of the bin size in `mu` used for the mass ratio of binary stars:
  real(DPR), parameter, public :: d_mu0 = 1.e-3_DPR

!# Default lower and upper values of the initial stellar mass (in solar masses):
  real(DPR), parameter, public :: default_IMF_mass_min = 0.08_DPR
  real(DPR), parameter, public :: default_IMF_mass_max = 120._DPR

!# Default values of `LN_C1` and `LN_C2` used for the log-normal IMF:
  real(DPR), parameter, public :: default_LN_C1 = 1.09_DPR
  real(DPR), parameter, public :: default_LN_C2 = -1.02_DPR

!# Indicative value of the bin size in log10(stellar mass) used for the IMF:
  real(DPR), parameter, public :: d_l10_mass0 = 1.e-3_DPR

!# Parameter used to exclude stars with too different a temperature when interpolating
!# the library of stellar spectra:
  real(DPR), parameter, public :: d_T_max_SL = 0.1_DPR

!# Relative importance of surface gravity to effective temperature when looking for
!# the nearest neighbors in the library of stellar spectra:
  real(DPR), parameter, public :: kappa_SL = 0.1_DPR

  character(len=std_string), parameter, public :: &
       SSPs_sets_list = "list_SSPs_sets.txt", stel_lib_sets_list = "list_stel_lib_sets.txt"

!#----------------------------------------------------------------------
!# Relation used to convert between the mass fraction of metals $Z$ used in stellar
!# evolutionary tracks and the parameter $[M/H]$ (more accurately, $[Fe/H]$) 
!# characterizing the metallicity of libraries of stellar spectra: {

  logical, parameter, public :: P2_metal_conv = .false. !# `.false.` = default in Pégase.3; \
!# set `P2_metal_conv` to `.true.` to recover Pégase.2's results.
  
  real(DPR), parameter, public :: P2_Z_Sun = 0.02_DPR !# Solar metallicity used in Pégase.2.

!# Explanations:
!# With `P2_metal_conv = .false.`, the track's mass fraction `Z_track` of metals 
!# is converted to $[M/H]$ through the relation
!#
!#     $[M/H] = `log10((Z_track/X_track)/(Z_Sun/X_Sun))`$,
!#
!# where `X_track = 1 - Y_track - Z_track` is the mass fraction of hydrogen,
!# and `Y_track` is the mass fraction of helium (provided with the stellar evolutionary tracks);
!# `Z_Sun` and `X_Sun` are the solar abundances used everywhere in the code.
!# The track's value of $[M/H]$ is then used to interpolate between the libraries of 
!# stellar spectra (which actually provide $[Fe/H]$).
!#
!# On the other hand, version 2 of Pégase converted the $[M/H]$ of the spectra to $Z$ 
!# through the relation
!#
!#     `Z = P2_Z_Sun * 10.**($[M/H]$)`,
!#
!# where `P2_Z_Sun` is the value of the solar metallicity hard-coded in Pégase.2.
!# This formula does not take into account the helium abundance and is incorrect.
!# To use it nonetheless, set `P2_metal_conv = .true`.

end module mod_SSPs_constants

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_select_file

  use mod_types, only : long_string
  use mod_read_file_list, only : read_file_list

  implicit none
  private
  integer, parameter :: n_max_text_lines = 15

  public :: select_single_file, select_several_files

contains

!#======================================================================
!# Select one single file from a list.

  subroutine select_single_file(dir, list, selected_file, object, objects, back, &
       exist_warning, print_first_line)

    use mod_file_access, only : open_file, close_file, path_file
    use mod_strings, only : HT, quote_string, unquote_string

    implicit none
    character(len=*), intent(in) :: dir
    character(len=*), intent(in) :: list
    character(len=*), intent(out) :: selected_file
    character(len=*), intent(in), optional :: object, objects
    logical, intent(in), optional :: back, exist_warning, print_first_line
!#......................................................................
    logical :: exist_list, exist_file, void, back_eff, exist_warning_eff, print_first_line_eff
    integer :: error, n_files, i_file, choice
    character(len=long_string) :: string, object_eff, objects_eff, &
         current_file, first_line
    character(len=long_string), dimension(:), pointer :: file => null()
    logical :: provide_directly
    integer :: unit
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(object)) then
       object_eff = object
    else
       object_eff = "file"
    endif
    if (present(objects)) then
       objects_eff = objects
    else
       objects_eff = "files"
    endif
    if (present(back)) then
       back_eff = back
    else
       back_eff = .false.
    endif
    if (present(exist_warning)) then
       exist_warning_eff = exist_warning
    else
       exist_warning_eff = .false.
    endif
    if (present(print_first_line)) then
       print_first_line_eff = print_first_line
    else
       print_first_line_eff = .false.
    endif

    inquire(file =  path_file(dir, list), exist = exist_list)
    if (exist_list) then
       call read_file_list(dir, list, file, n_files, exist_warning_eff, &
            back_eff)
       if (n_files == 0) then
          write(*, "(a)") "Warning: list """ // trim(list) // """ is void."
          void = .true.
       else
          void = .false.
       endif
    else
       write(*, "(a)") "Warning: list """ // trim(list) // """ does not exist."
    endif

    if (exist_list .and. .not.void) then
       if (back_eff) then
          current_file = file(n_files)
       else
          current_file = file(1)
       endif

       if (print_first_line_eff) then
          call open_file(unit, path_file(dir, current_file))
          read(unit,*) first_line
          call close_file(unit)
          first_line = adjustl(first_line)
       endif

       if (print_first_line_eff .and. first_line /= "") then
          write(*, "(a)") "Default " // trim(object_eff) // ": " // &
               trim(first_line) // " (file """ // trim(current_file) // """)."
       else
          write(*, "(a)") "Default " // trim(object_eff) // ": """ // &
               trim(current_file) // """."
       endif

       do
          write(*, "(/a)") "Either"
          write(*, "(a)") "-- press the <RETURN>/<ENTER> key to select the default " // &
               trim(object_eff) // ","
          write(*, "(a)") "-- press <TAB>, then <RETURN> to show a list of possible " // &
               trim(objects_eff) // ", or"
          write(*, "(a/a/a)") "-- enter the name of the " // trim(object_eff) // &
               " you want to select (even if not in the list).", &
               "   If the file is in a subdirectory of """ // trim(dir) // &
               """ or in another directory, ", &
               "   the path (relative to """ // trim(dir) // """ or absolute) must be present."
          provide_directly = .false.
          read(*, "(a)") string
          string = adjustl(string)

          if (string == "") then !# Default.
             if (back_eff) then
                selected_file = file(n_files)
             else
                selected_file = file(1)
             endif

          else if (string == HT) then !# Select from a list.
             file_loop : do i_file = 1, n_files
                if (back_eff) then
                   current_file = file(n_files+1-i_file)
                else
                   current_file = file(i_file)
                endif
                if (print_first_line_eff) then
                   call open_file(unit, path_file(dir, current_file))
                   read(unit,*) first_line
                   call close_file(unit)
                   first_line = adjustl(first_line)
                endif

                if (print_first_line_eff .and. first_line /= "") then
                   write(*, "(tr3,i0,a)") i_file, ": " // trim(first_line) // &
                        " (file """ // trim(current_file) // """)."
                else
                   write(*, "(tr3,i0,a)") i_file, ": """ // trim(current_file) // &
                        """."
                endif

                if (mod(i_file, n_max_text_lines) == 0) then
                   do
                      write(*, "(/a)") "Either"
                      write(*, "(a)") "-- enter the number of the " // trim(object_eff) // &
                           " you want to select,"
                      write(*, "(a)") "-- press <TAB>, then <RETURN> to show the next " // &
                           trim(objects_eff) // " in the list,"
                      write(*, "(a)") "-- press <RETURN> to stop, or"
                      write(*, "(a)") "-- enter ""0"" to return to previous menu."

                      read(*, "(a)") string
                      string = adjustl(string)

                      if (string == "") stop

                      if (string == HT) exit
                      read(string,*,iostat = error) choice
                      if (error == 0) then
                         if (choice >= 1 .and. choice <= n_files) then
                            if (back_eff) then
                               selected_file = file(n_files+1-choice)
                            else
                               selected_file = file(choice)
                            endif
                            exit file_loop
                         else if (choice == 0) then
                            selected_file = ""
                            exit file_loop
                         else
                            write(*, "(a,i0,a)") "The number should be between &
                                 &1 and ", n_files, "!"
                            cycle
                         endif
                      else
                         write(*, "(a)") "??"
                      endif
                   enddo
                else if (i_file == n_files) then
                   do
                      write(*, "(/a)") "Either"
                      write(*, "(a)") "-- enter the number of the " // trim(object_eff) // " you want to select,"
                      write(*, "(a)") "-- press <RETURN> to stop, or"
                      write(*, "(a)") "-- enter ""0"" to return to previous menu."

                      read(*, "(a)") string
                      string = adjustl(string)

                      if (string == "") stop

                      read(string,*,iostat = error) choice

                      if (error == 0) then
                         if (choice >= 1 .and. choice <= n_files) then
                            if (back_eff) then
                               selected_file = file(n_files+1-choice)
                            else
                               selected_file = file(choice)
                            endif
                            exit file_loop
                         else if (choice == 0) then
                            selected_file = ""
                            exit file_loop
                         else
                            write(*, "(a,i0,a)") "The number should be between &
                                 &1 and ", n_files, "!"
                            cycle
                         endif
                      else
                         write(*, "(a)") "??"
                      endif
                   enddo
                endif
             enddo file_loop

          else !# Provide name of the file directly.
             provide_directly = .true.
             string = unquote_string(string)
             selected_file = adjustl(string)
          endif
          if (selected_file == "") cycle

          inquire(file = path_file(dir, selected_file), exist = exist_file)
          if (exist_file) then
             if (provide_directly) then !# Update the list of files.
                call open_file(unit, path_file(dir, list), position="append", &
                     action="write")
                write(unit, "(a)") quote_string(selected_file)
                call close_file(unit)
             endif
             exit
          else
             write(*, "(a)") trim(object_eff) // " """ // trim(selected_file) // &
                  """ does not exist."
          endif
       enddo

    else !# Non-existent or void list.
       do
          write(*, "(/a)") "Either"
          write(*, "(a)") "-- enter the name of the " // trim(object_eff) // " you want to select, or"
          write(*, "(a)") "-- press <RETURN> to stop."

          read(*, "(a)") string

          if (string == "") then
             stop

          else
             string = unquote_string(string)
             selected_file = adjustl(string)
             inquire(file = path_file(dir, selected_file), exist = exist_file)
             if (exist_file) then
                if (exist_list) then !# The list of files exists but is void. Update it!
                   call open_file(unit, path_file(dir, list), &
                        position="append", action="write")
                   write(unit, "(a)") quote_string(selected_file)
                   call close_file(unit)
                endif
                exit
             else
                write(*, "(a)") trim(object_eff) // " """ // trim(selected_file) // &
                     """ does not exist."
             endif
          endif
       enddo
    endif

  end subroutine select_single_file

!#======================================================================
!# Select one or more files from a list.

  subroutine select_several_files(dir, list, selected_file, n_selected_files, object, &
       objects, back, exist_warning)

    use mod_file_access, only : open_file, close_file, path_file
    use mod_strings, only : quote_string, unquote_string, HT
    use mod_types
    use mod_linked_list

    implicit none
    character(len=*), intent(in) :: dir
    character(len=*), intent(in) :: list
    character(len=*), dimension(:), pointer :: selected_file
    integer, intent(out) :: n_selected_files
    character(len=*), intent(in), optional :: object, objects
    logical, intent(in), optional :: back, exist_warning
!#......................................................................
    logical :: exist_list, exist_file, void, back_eff, exist_warning_eff
    integer :: error, n_files, i_file, choice
    character(len=long_string) :: string, object_eff, objects_eff, current_file
    character(len=long_string), dimension(:), pointer :: file => null()
    logical :: provide_directly
    integer :: unit
    type(lk_lst_long_string) :: head_node
    type(lk_lst_long_string), pointer :: current_node
    character(len=len(selected_file)) :: potential_file
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(object)) then
       object_eff = object
    else
       object_eff = "file"
    endif
    if (present(objects)) then
       objects_eff = objects
    else
       objects_eff = "files"
    endif
    if (present(back)) then
       back_eff = back
    else
       back_eff = .false.
    endif
    if (present(exist_warning)) then
       exist_warning_eff = exist_warning
    else
       exist_warning_eff = .false.
    endif

    inquire(file =  path_file(dir, list), exist = exist_list)
    if (exist_list) then
       call read_file_list(dir, list, file, n_files, exist_warning_eff, &
            back_eff)
       if (n_files == 0) then
          write(*, "(a)") "Warning: list """ // trim(list) // """ is void."
          void = .true.
       else
          void = .false.
       endif
    else
       write(*, "(a)") "Warning: list """ // trim(list) // """ does not exist."
    endif

    n_selected_files = 0
    call lk_lst_initialize(head_node)
    if (exist_list .and. .not.void) then
       file_loop : do i_file = 1, n_files
          if (back_eff) then
             current_file = file(n_files+1-i_file)
          else
             current_file = file(i_file)
          endif
          write(*, "(tr3,i0,a)") i_file, ": """ // trim(current_file) // """."

          if  (mod(i_file, n_max_text_lines) == 0) then
             write(*, "(/a)") "-- Enter the integers associated to the " // trim(objects_eff) // &
                  " you want to select (press the <RETURN>/<ENTER> key after each)."
             write(*,"(a/a/a)") "   You may enter their names instead (even if not in the list), " // &
                  "but if the file is in a subdirectory ", &
                  "   of """ // trim(dir) // """ or in another directory, " // &
                  "the path (relative to """ // trim(dir) // """ or absolute) ", &
                  "   must be present;"
             write(*, "(a)") "-- press <TAB>, then <RETURN> to show the next " // trim(objects_eff) // &
                  " in the list;"
             write(*, "(a)") "-- press <RETURN> to stop selecting additional " // trim(objects_eff) // "."

             do
                provide_directly = .false.
                read(*, "(a)") string
                string = adjustl(string)

                if (string == "") exit file_loop !# Stop reading files.

                if (string == HT) exit

                if (verify(trim(string), "0123456789") == 0) then !# Integer input.
                   read(string,*,iostat = error) choice
                   if (error == 0) then
                      if (choice >= 1 .and. choice <= n_files) then
                         if (back_eff) then
                            potential_file = file(n_files+1-choice)
                         else
                            potential_file = file(choice)
                         endif
                      else
                         write(*, "(a,i0,a)") "The number should be between 1 and ", &
                              n_files, "!"
                         cycle
                      endif
                   else
                      write(*, "(a)") "??"
                   endif

                else !# Provide name of the file directly.
                   provide_directly = .true.
                   string = unquote_string(string)
                   potential_file = adjustl(string)
                endif

                inquire(file = path_file(dir, potential_file), exist = exist_file)
                if (exist_file) then
                   n_selected_files = n_selected_files+1
                   call lk_lst_new_node(head_node, current_node)
                   current_node % val = potential_file
                   if (provide_directly) then !# Update the list of files.
                      call open_file(unit, path_file(dir, list), &
                           position="append", action="write")
                      write(unit, "(a)") quote_string(potential_file)
                      call close_file(unit)
                   endif
                else
                   write(*, "(a)") trim(object_eff) // " """ // &
                        trim(potential_file) // """ does not exist."
                endif
             enddo

          else if (i_file == n_files) then
             write(*, "(/a)") "-- Enter the integers associated to the " // trim(objects_eff) // &
                  " you want to select (press the <RETURN>/<ENTER> key after each)."
             write(*,"(a/a/a)") "   You may enter their names instead (even if not in the list), " // &
                  "but if the file is in a subdirectory ", &
                  "   of """ // trim(dir) // """ or in another directory, " // &
                  "the path (relative to """ // trim(dir) // """ or absolute) ", &
                  "   must be present;"
             write(*, "(a)") "-- press <RETURN> to stop selecting additional " // trim(objects_eff) // "."

!# Note: typing <TAB> in the last screen prints ''file "  " does not exist.''.
!# Should it restart the loop on the list of files???

             do
                provide_directly = .false.
                read(*, "(a)") string
                string = adjustl(string)

                if (string == "") exit file_loop !# Stop reading files.

                if (verify(trim(string), "0123456789") == 0) then !# Integer input.
                   read(string,*,iostat = error) choice
                   if (error == 0) then
                      if (choice >= 1 .and. choice <= n_files) then
                         if (back_eff) then
                            potential_file = file(n_files+1-choice)
                         else
                            potential_file = file(choice)
                         endif
                      else
                         write(*, "(a,i0,a)") "The number should be between 1 and ", &
                              n_files, "!"
                         cycle
                      endif
                   else
                      write(*, "(a)") "??"
                   endif

                else !# Provide name of the file directly.
                   provide_directly = .true.
                   string = unquote_string(string)
                   potential_file = adjustl(string)
                endif

                inquire(file = path_file(dir, potential_file), exist = exist_file)
                if (exist_file) then
                   n_selected_files = n_selected_files+1
                   call lk_lst_new_node(head_node, current_node)
                   current_node % val = potential_file
                   if (provide_directly) then !# Update the list of files.
                      call open_file(unit, path_file(dir, list), &
                           position="append", action="write")
                      write(unit, "(a)") quote_string(potential_file)
                      call close_file(unit)
                   endif
                else
                   write(*, "(a)") trim(object_eff) // " """ // &
                        trim(potential_file) // """ does not exist."
                endif
             enddo
          endif
       enddo file_loop

    else !# Non-existent or void list.
       write(*, "(/a)") "-- Enter the name of the " // trim(objects_eff) // " you want to select &
            &(press the <RETURN>/<ENTER> key after each);"
       write(*, "(a)") "-- press <RETURN> to stop selecting additional " // trim(objects_eff) // "."

       do
          read(*, "(a)") string
          if (string == "") then
             exit

          else
             string = unquote_string(string)
             potential_file = adjustl(string)
             inquire(file = path_file(dir, potential_file), &
                  exist = exist_file)
             if (exist_file) then
                n_selected_files = n_selected_files+1
                call lk_lst_new_node(head_node, current_node)
                current_node % val = potential_file
                if (exist_list) then !# The list of files exists but is void: \
!# update it! Do not create it if it does not already exist.
                   call open_file(unit, path_file(dir, list), &
                        position="append", action="write")
                   write(unit, "(a)") quote_string(potential_file)
                   call close_file(unit)
                endif
             else
                write(*, "(a)") trim(object_eff) // " """ // trim(potential_file) // &
                     """ does not exist."
             endif
          endif
       enddo
    endif

    call lk_lst_to_array(head_node, selected_file, n_selected_files)

  end subroutine select_several_files

end module mod_select_file

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_IMF

  use mod_types
  private
  public :: choose_IMF, IMF_d_n
  real(DPR) :: LN_C1, LN_C2
  public :: LN_C1, LN_C2

contains

!#======================================================================

  subroutine choose_IMF(IMF_file, IMF_dim_slope, IMF_bin_coeff, &
       IMF_bin_bottom_mass, IMF_bin_slope, IMF_mass_min, IMF_mass_max, &
       IMF_norm)

    use mod_types
    use mod_directories, only : IMFs_dir
    use mod_file_access, only : open_file, close_file, path_file, skip_comment_lines
    use mod_SSPs_constants, only : default_IMF_mass_min, default_IMF_mass_max, &
         default_LN_C1, default_LN_C2

    implicit none
    character(len=*), intent(in) :: IMF_file
    integer, intent(out) :: IMF_dim_slope
    real(DPR), dimension(:), pointer :: IMF_bin_coeff, IMF_bin_bottom_mass, &
         IMF_bin_slope
    real(DPR), intent(out) :: IMF_mass_min, IMF_mass_max, IMF_norm
!#......................................................................
    integer :: i_slope
    real(DPR) :: IMF_last_bin_top_mass
    integer :: error, unit
    character(len=std_string) :: string
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    LN_C1 = default_LN_C1
    LN_C2 = default_LN_C2
    
    if ((IMF_file /= "IMF_log_normal.txt") .and. &
         (IMF_file /= "IMF_Rana_Basu.txt") .and. &
         (IMF_file /= "IMF_Ferrini.txt") .and. &
         (IMF_file /= "IMF_Chabrier_2005.txt")  .and. &
         (IMF_file /= "IMF_Chabrier_2003.txt")) then
       call open_file(unit, path_file(IMFs_dir, IMF_file))
       read(unit,*) string
       call skip_comment_lines(unit)
       read(unit, *) IMF_dim_slope
       if (associated(IMF_bin_coeff)) deallocate(IMF_bin_coeff)
       allocate(IMF_bin_coeff(IMF_dim_slope))
       if (associated(IMF_bin_bottom_mass)) deallocate(IMF_bin_bottom_mass)
       allocate(IMF_bin_bottom_mass(IMF_dim_slope))
       if (associated(IMF_bin_slope)) deallocate(IMF_bin_slope)
       allocate(IMF_bin_slope(IMF_dim_slope))
       do i_slope = 1, IMF_dim_slope
          read(unit, *) IMF_bin_bottom_mass(i_slope), IMF_bin_slope(i_slope)
       end do
       read(unit, *) IMF_last_bin_top_mass
       IMF_bin_coeff(1) = 1
       call close_file(unit)
       do i_slope = 2, IMF_dim_slope
          IMF_bin_coeff(i_slope) = IMF_bin_coeff(i_slope-1)* &
               IMF_bin_bottom_mass(i_slope)**(IMF_bin_slope(i_slope-1)-IMF_bin_slope(i_slope))
       end do
       IMF_mass_min = IMF_bin_bottom_mass(1)
       IMF_mass_max = IMF_last_bin_top_mass
    else
       IMF_mass_min = default_IMF_mass_min
       IMF_mass_max = default_IMF_mass_max

       if (IMF_file == "IMF_log_normal.txt") then
          error = 1
          do while (error /= 0)
             write(*, "(a)") "Log-normal C1 parameter?"
             write(*, "(a, es9.2, a)") "Default: ", LN_C1, "."
             read(*, "(a)") string !# Not `read(*, *) string`!
             if (string /= "") then
                read(string, *, iostat = error) LN_C1
             else
                error = 0
             end if
             if (error /= 0) write(*, "(a)") "Invalid input!"
          end do

          error = 1
          do while (error /= 0)
             write(*, "(a)") "Log-normal C2 parameter?"
             write(*, "(a, es9.2, a)") "Default: ", LN_C2, "."
             read(*, "(a)") string !# Not `read(*, *) string`!
             if (string /= "") then
                read(string, *, iostat = error) LN_C2
             else
                error = 0
             end if
             if (error /= 0) write(*, "(a)") "Invalid input!"
          end do
       endif
    end if

!# Modify the lower mass:
    error = 1
    do while (error /= 0)
       write(*, "(a)") "Lower mass of the IMF (in solar masses)?"
       write(*, "(a, es8.2, a)") "Default: ", IMF_mass_min, " solar masses."
       read(*, "(a)") string !# Not `read(*, *) string`!
       if (string /= "") then
          read(string, *, iostat = error) IMF_mass_min
       else
          error = 0
       end if
       if (error /= 0) write(*, "(a)") "Invalid input!"
    end do

!# Modify the upper mass:
    error = 1
    do while (error /= 0)
       write(*, "(a)") "Upper mass of the IMF (in solar masses)?"
       write(*, "(a, es8.2, a)") "Default: ", IMF_mass_max, " solar masses."
       read(*, "(a)") string !# Not `read(*, *) string`!
       if (string /= "") then
          read(string, *, iostat = error) IMF_mass_max
       else
          error = 0
       end if
       if (error /= 0) write(*, "(a)") "Invalid input!"
    end do

!# Compute the normalization:
    IMF_norm = IMF_normalization(IMF_file, IMF_dim_slope, IMF_bin_coeff, &
         IMF_bin_bottom_mass, IMF_bin_slope, IMF_mass_min, IMF_mass_max)

  end subroutine choose_IMF

!#======================================================================

  function IMF_d_n(l10_mass, d_l10_mass, IMF_file, IMF_dim_slope, IMF_bin_coeff, &
       IMF_bin_bottom_mass, IMF_bin_slope, &
       IMF_mass_min, IMF_mass_max, IMF_norm)

    use mod_types
    use mod_interp, only : bracket

    implicit none
    real(DPR), intent(in) :: l10_mass, d_l10_mass
    real(DPR), intent(in), optional :: IMF_norm
    character(len=*), intent(in) :: IMF_file
    integer, intent(in) :: IMF_dim_slope
    real(DPR), dimension(:), intent(in) :: IMF_bin_coeff, IMF_bin_bottom_mass, IMF_bin_slope
    real(DPR), intent(in) :: IMF_mass_min, IMF_mass_max
    real(DPR) :: IMF_d_n
!#......................................................................
    real(DPR) :: mass, d_n
    integer :: i_slope
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    mass = 10**l10_mass
    if (mass > IMF_mass_max .or. mass < IMF_mass_min) then
       d_n = 0
    else
       if (IMF_file == "IMF_log_normal.txt") then
          d_n = d_l10_mass * exp(-LN_C1*(l10_mass-LN_C2)**2)

!# Note: `exp(-LN_C1*(l10_mass-LN_C2)**2)` = 
!#           $k_0 10^{k_1 `l10_mass`} 10^{k_2 `l10_mass`^2}$,
!# with $k_0 = \exp(-`LN_C1` `LN_C2`^2)$,
!#      $k_1 = 2 `LN_C1` `LN_C2`/\ln 10$ and
!#      $k_2 = -`LN_C1`/\ln 10$.
!#
!# For `LN_C1 = 1.09` and `LN_C2 = -1.02`, 
!# $k_1$ = -0.96 ~= -1 and $k_2$ = -0.47 ~= -1/2, 
!# leading to the formula used in Pégase.2:
!# `d_n = d_l10_mass * 10**(-l10_mass**2/2)/mass` 
!# (up to the $k_0$ factor which does not matter since the IMF is normalized).

       else if (IMF_file == "IMF_Rana_Basu.txt") then
          d_n = d_l10_mass * 10**(1.548_DPR - 1.513_DPR*l10_mass &
               - 0.395_DPR*l10_mass**2 + 0.502_DPR*l10_mass**3 &
               - 0.169_DPR*l10_mass**4)

       else if (IMF_file == "IMF_Ferrini.txt") then
          d_n = d_l10_mass * 2.01_DPR*mass**(-0.52_DPR)* &
               10**(-sqrt(2.07_DPR*l10_mass**2 + 1.92_DPR*l10_mass &
               + 0.73_DPR))

       else if (IMF_file == "IMF_Chabrier_2005.txt") then
          if (mass <= 1) then
             d_n = d_l10_mass * 0.093_DPR*exp(-(l10_mass+0.69897_DPR)**2/0.605_DPR)
          else
             d_n = d_l10_mass * 0.04147_DPR*mass**(-1.35_DPR)
          endif

       else if (IMF_file == "IMF_Chabrier_2003.txt") then
          if (mass <= 1) then
             d_n = d_l10_mass * 0.158_DPR*exp(-(l10_mass+1.1024_DPR)**2/0.9522_DPR)
          else !# Factor "0.9953" to ensure continuity at 1 solar mass.
             d_n = d_l10_mass * 0.0443_DPR*mass**(-1.3_DPR)*0.9953_DPR
          endif

       else
          i_slope = 1
          if (mass > IMF_bin_bottom_mass(1)) then
             if (mass >= IMF_bin_bottom_mass(IMF_dim_slope)) then
                i_slope = IMF_dim_slope
             else
                i_slope = 0
                call bracket(IMF_dim_slope, IMF_bin_bottom_mass, mass, i_slope)
             end if
          else
             i_slope = 1
          end if
          d_n = IMF_bin_coeff(i_slope) * d_l10_mass * mass**IMF_bin_slope(i_slope)
       end if
    end if
    if (present(IMF_norm)) then
       IMF_d_n = d_n/IMF_norm
    else
       IMF_d_n = d_n
    endif

    if (IMF_d_n < 0) then
       if (present(IMF_norm)) then
          write(*,*) l10_mass, d_l10_mass, IMF_norm
          write(*, "(a)") "`IMF_d_n` < 0. Stopped."
          stop
       else
          write(*,*) l10_mass, d_l10_mass
          write(*, "(a)") "`IMF_d_n` < 0. Stopped."
          stop
       endif
       stop
    endif

  end function IMF_d_n

!#======================================================================

  function IMF_normalization(IMF_file, IMF_dim_slope, IMF_bin_coeff, &
       IMF_bin_bottom_mass, IMF_bin_slope, &
       IMF_mass_min, IMF_mass_max)

    use mod_types
    use mod_SSPs_constants, only : d_l10_mass0
    use mod_interp, only : bracket, interp_lin_lin

    implicit none
    character(len=*), intent(in) :: IMF_file
    integer, intent(in) :: IMF_dim_slope
    real(DPR), dimension(:), intent(in) :: IMF_bin_coeff, IMF_bin_bottom_mass, &
         IMF_bin_slope
    real(DPR), intent(in) :: IMF_mass_min, IMF_mass_max
    real(DPR) :: IMF_normalization
!#......................................................................
    real(DPR) :: l10_mass_min, l10_mass_max, d_l10_mass, l10_mass, d_n
    integer :: n_bins, i_bin
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    l10_mass_min = log10(IMF_mass_min)
    l10_mass_max = log10(IMF_mass_max)
    n_bins = ceiling((l10_mass_max-l10_mass_min)/d_l10_mass0)
    d_l10_mass = (l10_mass_max-l10_mass_min)/n_bins
    IMF_normalization = 0
    do i_bin = 0, n_bins-1
       l10_mass = l10_mass_min+(i_bin+0.5_DPR)*d_l10_mass
       d_n = IMF_d_n(l10_mass, d_l10_mass, IMF_file, IMF_dim_slope, IMF_bin_coeff, &
            IMF_bin_bottom_mass, IMF_bin_slope, &
            IMF_mass_min, IMF_mass_max)
       IMF_normalization = IMF_normalization + d_n * 10**l10_mass
    end do

  end function IMF_normalization

end module mod_IMF

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_grain_properties

  use mod_types

  implicit none
  private
  type :: struct_GSD
     integer :: dim_radius
     real(CDR), dimension(:), pointer :: radius => null()
     real(CDR), dimension(:), pointer :: number => null()
  end type struct_GSD

  type :: struct_grain_abs
     integer :: dim_radius
     real(CDR), dimension(:), pointer :: radius => null()
     integer :: dim_lambda
     real(CDR), dimension(:), pointer :: lambda => null()
     real(DPR), dimension(:), pointer :: lambda_interm => null()
     real(CDR), dimension(:, :), pointer :: Q_abs => null()
     real(CDR), dimension(:), pointer :: d_S_grain => null()
     real(CDR), dimension(:), pointer :: kappa_ext => null()
     real(CDR), dimension(:), pointer :: albedo => null()
     real(CDR), dimension(:), pointer :: asym => null()
  end type struct_grain_abs
  public :: read_dust, struct_grain_abs

contains

!#======================================================================
  
  subroutine read_dust(grain_abs, &
       grain_density, grain_mean_atomic_mass, grains_file, dim_species, &
       species_id, carb_frac, sil_frac, carb_sublim_temp, sil_sublim_temp, sublim_temp)

    use mod_types
    use mod_directories, only : dust_dir
    use mod_file_access, only : open_file, close_file, path_file
    use mod_interp, only : interp_log_log, interp_log_lin
    use mod_interm_grid, only : interm_grid

    implicit none
    type(struct_grain_abs), dimension(:), pointer :: grain_abs
    real(CDR), dimension(:), pointer :: grain_density, grain_mean_atomic_mass
    character(len=*), intent(in) :: grains_file
    integer, intent(out) :: dim_species
    character(len=*), dimension(:), pointer :: species_id
    real(CDR), dimension(:), pointer :: carb_frac, sil_frac, sublim_temp
    real(CDR), intent(in) :: carb_sublim_temp, sil_sublim_temp
!#......................................................................
    integer :: i_species, i_lambda, i_radius, unit, dim_radius, dim_lambda
    character(std_string), dimension(:), pointer :: grain_opt_prop_file => null()
    real(CDR), dimension(:,:), allocatable :: Q_sca, cos_sca
    real(CDR) :: unused_number, m_C, m_sil
    logical, dimension(:), pointer :: carbonaceous => null()

    type(struct_GSD), dimension(:), pointer :: GSD => null()
    real(CDR), dimension(:), pointer :: radius_GSD_min => null(), radius_GSD_max => null(), grain_mass => null()

    integer :: dim_radius_supp, dim_radius_tmp
    real(CDR), dimension(:), allocatable :: radius_supp, radius_tmp
    real(CDR), dimension(:,:), allocatable :: Q_abs_tmp, Q_sca_tmp, cos_sca_tmp
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call read_grain_size_distribution(grains_file, &
         GSD, dim_species, grain_opt_prop_file, carbonaceous)

!# Read dust properties (absorption, albedo, asymmetry)
!# for graphites and silicates.

    if (associated(species_id)) deallocate(species_id)
    allocate(species_id(dim_species))
    if (associated(grain_density)) deallocate(grain_density)
    allocate(grain_density(dim_species))
    if (associated(grain_mean_atomic_mass)) deallocate(grain_mean_atomic_mass)
    allocate(grain_mean_atomic_mass(dim_species))
    if (associated(radius_GSD_min)) deallocate(radius_GSD_min)
    allocate(radius_GSD_min(dim_species))
    if (associated(radius_GSD_max)) deallocate(radius_GSD_max)
    allocate(radius_GSD_max(dim_species))
    if (associated(grain_mass)) deallocate(grain_mass) ; allocate(grain_mass(dim_species))

    if (associated(grain_abs)) then
       do i_species = 1, size(grain_abs)
          if (associated(grain_abs(i_species) % radius)) deallocate(grain_abs(i_species) % radius)
          if (associated(grain_abs(i_species) % lambda)) deallocate(grain_abs(i_species) % lambda)
          if (associated(grain_abs(i_species) % lambda_interm)) deallocate(grain_abs(i_species) % lambda_interm)
          if (associated(grain_abs(i_species) % Q_abs)) deallocate(grain_abs(i_species) % Q_abs)
          if (associated(grain_abs(i_species) % d_S_grain)) deallocate(grain_abs(i_species) % d_S_grain)
          if (associated(grain_abs(i_species) % kappa_ext)) deallocate(grain_abs(i_species) % kappa_ext)
          if (associated(grain_abs(i_species) % albedo)) deallocate(grain_abs(i_species) % albedo)
          if (associated(grain_abs(i_species) % asym)) deallocate(grain_abs(i_species) % asym)
       enddo
       deallocate(grain_abs)
    endif
    allocate(grain_abs(dim_species))
    
    do i_species = 1, dim_species
       call open_file(unit, path_file(dust_dir, grain_opt_prop_file(i_species)))
       read(unit,*) species_id(i_species)
       read(unit,*) grain_density(i_species)
       read(unit,*) grain_mean_atomic_mass(i_species)
       read(unit,*) dim_radius_tmp
       read(unit,*) dim_lambda
       grain_abs(i_species) % dim_lambda = dim_lambda

       if (allocated(radius_tmp)) deallocate(radius_tmp)
       allocate(radius_tmp(dim_radius_tmp))

       if (associated(grain_abs(i_species) % lambda)) deallocate(grain_abs(i_species) % lambda)
       allocate(grain_abs(i_species) % lambda(dim_lambda))

       if (associated(grain_abs(i_species) % kappa_ext)) deallocate(grain_abs(i_species) % kappa_ext)
       allocate(grain_abs(i_species) % kappa_ext(dim_lambda))

       if (associated(grain_abs(i_species) % albedo)) deallocate(grain_abs(i_species) % albedo)
       allocate(grain_abs(i_species) % albedo(dim_lambda))

       if (associated(grain_abs(i_species) % asym)) deallocate(grain_abs(i_species) % asym)
       allocate(grain_abs(i_species) % asym(dim_lambda))

       if (allocated(Q_abs_tmp)) deallocate(Q_abs_tmp)
       allocate(Q_abs_tmp(dim_radius_tmp, dim_lambda))

       if (allocated(Q_sca_tmp)) deallocate(Q_sca_tmp)
       allocate(Q_sca_tmp(dim_radius_tmp, dim_lambda))

       if (allocated(cos_sca_tmp)) deallocate(cos_sca_tmp)
       allocate(cos_sca_tmp(dim_radius_tmp, dim_lambda))

       do i_radius = 1, dim_radius_tmp
          read(unit,*)
          read(unit,*) radius_tmp(i_radius)
          read(unit,*)
          do i_lambda = dim_lambda, 1, -1
             if (grain_opt_prop_file(i_species) == "PAHneu_30" .or. &
                  grain_opt_prop_file(i_species) == "PAHion_30") then
                read(unit,*) grain_abs(i_species) % lambda(i_lambda), unused_number, &
                     Q_abs_tmp(i_radius, i_lambda), &
                     Q_sca_tmp(i_radius, i_lambda), cos_sca_tmp(i_radius, i_lambda)
             else
                read(unit,*) grain_abs(i_species) % lambda(i_lambda), &
                     Q_abs_tmp(i_radius, i_lambda), &
                     Q_sca_tmp(i_radius, i_lambda), cos_sca_tmp(i_radius, i_lambda)
             endif
          enddo
       enddo
       call close_file(unit)

       call interm_grid(grain_abs(i_species) % dim_lambda, &
            real(grain_abs(i_species) % lambda(:), DPR), &
            grain_abs(i_species) % lambda_interm)

       radius_GSD_min(i_species) = minval(GSD(i_species) % radius(:), &
            mask = GSD(i_species) % number(:) > 0)
       radius_GSD_max(i_species) = maxval(GSD(i_species) % radius(:), &
            mask = GSD(i_species) % number(:) > 0)

!# Extrapolate below `radius_tmp(1)` if `radius_GSD_min(i_species)` is smaller.

       dim_radius_supp = max( &
            ceiling(log10(radius_tmp(1)/radius_GSD_min(i_species))/ &
            log10(radius_tmp(dim_radius_tmp)/radius_tmp(1))*dim_radius_tmp), &
            0)
       if (allocated(radius_supp)) deallocate(radius_supp)
       allocate(radius_supp(dim_radius_supp))
       do i_radius = 1, dim_radius_supp
          radius_supp(i_radius) = 10**(log10(radius_tmp(1)) - &
               (dim_radius_supp-i_radius+1)*log10(radius_tmp(dim_radius_tmp)/radius_tmp(1))/ &
               dim_radius_tmp)
       enddo

       dim_radius = dim_radius_tmp + dim_radius_supp
       grain_abs(i_species) % dim_radius = dim_radius

       if (associated(grain_abs(i_species) % radius)) deallocate(grain_abs(i_species) % radius)
       allocate(grain_abs(i_species) % radius(dim_radius))

       if (associated(grain_abs(i_species) % d_S_grain)) deallocate(grain_abs(i_species) % d_S_grain)
       allocate(grain_abs(i_species) % d_S_grain(dim_radius))

       if (associated(grain_abs(i_species) % Q_abs)) deallocate(grain_abs(i_species) % Q_abs)
       allocate(grain_abs(i_species) % Q_abs(dim_radius, dim_lambda))

       if (allocated(Q_sca)) deallocate(Q_sca)
       allocate(Q_sca(dim_radius, dim_lambda))

       if (allocated(cos_sca)) deallocate(cos_sca)
       allocate(cos_sca(dim_radius, dim_lambda))


!# Shift indices up by `dim_radius_supp` to leave space for extrapolated values.
       grain_abs(i_species) % radius(1+dim_radius_supp : dim_radius) = &
            radius_tmp(1:dim_radius_tmp)
       grain_abs(i_species) % Q_abs(1+dim_radius_supp : dim_radius, :) = &
            Q_abs_tmp(1:dim_radius_tmp, :)
       Q_sca(1+dim_radius_supp : dim_radius, :) = &
            Q_sca_tmp(1:dim_radius_tmp, :)
       cos_sca(1+dim_radius_supp : dim_radius, :) = &
            cos_sca_tmp(1:dim_radius_tmp, :)

!# Additional values are computed by extrapolation at radii below the smallest value in the grain_opt_prop_file.
!# ??? Should radii be also added above the largest value in the grain_opt_prop_file?

       do i_radius = 1, dim_radius_supp
          grain_abs(i_species) % radius(i_radius) = radius_supp(i_radius)
          do i_lambda = 1, dim_lambda
!# Inter/extrapolation in `Q_abs/radius` is more accurate than in `Q_abs`.
             grain_abs(i_species) % Q_abs(i_radius, i_lambda) = grain_abs(i_species) % radius(i_radius) * &
                  interp_log_log(grain_abs(i_species) % radius(dim_radius_supp+1), &
                  grain_abs(i_species) % radius(dim_radius_supp+2), &
                  grain_abs(i_species) % Q_abs(dim_radius_supp+1, i_lambda) / &
                  grain_abs(i_species) % radius(dim_radius_supp+1), &
                  grain_abs(i_species) % Q_abs(dim_radius_supp+2, i_lambda) / &
                  grain_abs(i_species) % radius(dim_radius_supp+2), grain_abs(i_species) % radius(i_radius))
!# Inter/extrapolation in `Q_sca/radius**4` is more accurate than in `Q_sca`.
             Q_sca(i_radius, i_lambda) = grain_abs(i_species) % radius(i_radius)**4 * &
                  interp_log_log(grain_abs(i_species) % radius(dim_radius_supp+1), &
                  grain_abs(i_species) % radius(dim_radius_supp+2), &
                  Q_sca(dim_radius_supp+1, i_lambda)/grain_abs(i_species) % radius(dim_radius_supp+1)**4, &
                  Q_sca(dim_radius_supp+2, i_lambda)/grain_abs(i_species) % radius(dim_radius_supp+2)**4, &
                  grain_abs(i_species) % radius(i_radius))
             cos_sca(i_radius, i_lambda) = interp_log_lin(grain_abs(i_species) % radius(dim_radius_supp+1), &
                  grain_abs(i_species) % radius(dim_radius_supp+2), &
                  cos_sca(dim_radius_supp+1, i_lambda), cos_sca(dim_radius_supp+2, i_lambda), &
                  grain_abs(i_species) % radius(i_radius))
             cos_sca(i_radius, i_lambda) = min(max(cos_sca(i_radius, i_lambda), -1._CDR), 1._CDR)
          enddo
       enddo

       call grain_size_distribution(dim_radius, grain_abs(i_species) % radius(:), &
            grain_density(i_species), grain_abs(i_species) % d_S_grain(:), &
            GSD(i_species), grain_mass(i_species))

       call compute_kappa(dim_radius, grain_abs(i_species) % d_S_grain(:), &
            dim_lambda, grain_abs(i_species) % Q_abs(:,:), Q_sca, cos_sca, &
            grain_abs(i_species) % kappa_ext(:), grain_abs(i_species) % albedo(:), grain_abs(i_species) % asym(:))
    enddo

!# Determination of the mass fractions of PAH and graphite, assuming continuity of the
!# grain size distribution at "radius_PAH_max". Actually, the mass fraction of PAH is only
!# the carbon mass fraction.

    if (associated(carb_frac)) deallocate(carb_frac)
    if (associated(sil_frac)) deallocate(sil_frac)
    allocate(carb_frac(dim_species))
    allocate(sil_frac(dim_species))
    if (associated(sublim_temp)) deallocate(sublim_temp)
    allocate(sublim_temp(dim_species))

    m_C = sum(grain_mass, mask = carbonaceous)
    m_sil = sum(grain_mass, mask = .not.carbonaceous)
    do i_species = 1, dim_species
       if (carbonaceous(i_species)) then
          carb_frac(i_species) = grain_mass(i_species)/m_C
          sil_frac(i_species) = 0
          sublim_temp(i_species) = carb_sublim_temp
       else
          carb_frac(i_species) = 0
          sil_frac(i_species) = grain_mass(i_species)/m_sil
          sublim_temp(i_species) = sil_sublim_temp
       endif
    enddo

  end subroutine read_dust

!#======================================================================

  subroutine read_grain_size_distribution(grains_file, GSD, &
       dim_species, grain_opt_prop_file, carbonaceous)

    use mod_types
    use mod_directories, only : dust_dir
    use mod_file_access, only : open_file, close_file, path_file
    use mod_strings, only : down_case, quote_string
    
    implicit none
    character(len=*), intent(in) :: grains_file
    type(struct_GSD), dimension(:), pointer :: GSD
    integer, intent(out) :: dim_species
    character(len=*), dimension(:), pointer :: grain_opt_prop_file
    logical, dimension(:), pointer :: carbonaceous
!#......................................................................
    integer :: unit, i_species, i_radius, dim_radius
    character(std_string) :: GSD_type
    real(CDR) :: slope, slope_prev, norm
    logical :: numbers
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call open_file(unit, path_file(dust_dir, grains_file))
    read(unit,*) GSD_type, dim_species

    GSD_type = adjustl(down_case(GSD_type))
    if (GSD_type == "numbers") then
       numbers = .true.
    else if (GSD_type == "slopes") then
       numbers = .false.
    else
       write(*, "(a)") quote_string(grains_file) // ": either the number of grains &
            &(""numbers"" keyword) or the slope (""slopes"" keyword) of the &
            &size distribution should be given for the grain size distribution. Stopped."
       stop
    endif

    if (associated(grain_opt_prop_file)) deallocate(grain_opt_prop_file)
    allocate(grain_opt_prop_file(dim_species))
    if (associated(carbonaceous)) deallocate(carbonaceous)
    allocate(carbonaceous(dim_species))
    if (associated(GSD)) then
       do i_species = 1, size(GSD)
          if (associated(GSD(i_species) % radius)) deallocate(GSD(i_species) % radius)
          if (associated(GSD(i_species) % number)) deallocate(GSD(i_species) % number)
       enddo
       deallocate(GSD)
    endif
    allocate(GSD(dim_species))

    if (numbers) then
       do i_species = 1, dim_species
          read(unit,*) dim_radius, grain_opt_prop_file(i_species), carbonaceous(i_species)
          GSD(i_species) % dim_radius = dim_radius
          if (associated(GSD(i_species) % radius)) deallocate(GSD(i_species) % radius)
          allocate(GSD(i_species) % radius(dim_radius))
          if (associated(GSD(i_species) % number)) deallocate(GSD(i_species) % number)
          allocate(GSD(i_species) % number(dim_radius))
          do i_radius = 1, dim_radius
             read(unit,*) GSD(i_species) % radius(i_radius), GSD(i_species) % number(i_radius)
          enddo
       enddo
    else !# "slopes".
       do i_species = 1, dim_species
          read(unit,*) GSD(i_species) % dim_radius, grain_opt_prop_file(i_species), carbonaceous(i_species), &
               norm
          if (associated(GSD(i_species) % radius)) deallocate(GSD(i_species) % radius)
          allocate(GSD(i_species) % radius(dim_radius))
          if (associated(GSD(i_species) % number)) deallocate(GSD(i_species) % number)
          allocate(GSD(i_species) % number(dim_radius))
          do i_radius = 1, GSD(i_species) % dim_radius
             if (i_radius < GSD(i_species) % dim_radius) then
                read(unit,*) GSD(i_species) % radius(i_radius), slope
             else
                read(unit,*) GSD(i_species) % radius(i_radius)
             endif
             if (i_radius == 1) then
                GSD(i_species) % number(i_radius) = norm
             else
                GSD(i_species) % number(i_radius) = GSD(i_species) % number(i_radius-1) * &
                     (GSD(i_species) % radius(i_radius)/GSD(i_species) % radius(i_radius-1))**slope_prev
             endif
             slope_prev = slope
          enddo
       enddo
    endif

    call close_file(unit)

  end subroutine read_grain_size_distribution

!#======================================================================

  subroutine grain_size_distribution(dim_radius, radius, &
       grain_density, d_S_grain, GSD, grain_mass)

    use mod_types
    use mod_constants, only : pi, um_to_cm
    use mod_spectra_constants, only : d_l10_rad0
    use mod_interp, only : bracket, interp_log_log
    use mod_interm_grid
    
    implicit none
    integer, intent(in) :: dim_radius
    real(CDR), dimension(:), intent(in) :: radius
    real(CDR), intent(in) :: grain_density
    real(CDR), dimension(:), intent(out) :: d_S_grain
    type(struct_GSD), intent(in) :: GSD
    real(CDR), intent(out) :: grain_mass
!#......................................................................
    real(CDR), dimension(:), pointer :: radius_interm => null()
    real(CDR) :: radius_bottom, radius_top, &
         rad_sub, d_l10_rad_sub, d_rad_sub, d_n
    integer :: i_radius, i_rad_sub, n_rad_sub, i_bracket
    real(CDR) :: n_tot, V_grain
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::    

    n_tot = 0

    call interm_grid(dim_radius, radius, radius_interm)

    d_S_grain(:) = 0
    V_grain = 0
    do i_radius = 1, dim_radius
       radius_bottom = radius_interm(i_radius)
       radius_top = radius_interm(i_radius+1)
       if (radius_top > radius_bottom) then
          n_rad_sub = ceiling(log10(radius_top/radius_bottom)/d_l10_rad0)
          d_l10_rad_sub = log10(radius_top/radius_bottom)/n_rad_sub
          i_bracket = 0
          do i_rad_sub = 1, n_rad_sub
             rad_sub = radius_bottom*10**((i_rad_sub-0.5_CDR)*d_l10_rad_sub)
             d_rad_sub = d_l10_rad_sub * rad_sub * log(10._CDR)
             call bracket(GSD % dim_radius, GSD % radius(:), rad_sub, i_bracket)
             if (rad_sub >= GSD % radius(1) .and. rad_sub <= GSD % radius(GSD % dim_radius)) then
                d_n = interp_log_log(GSD % radius(i_bracket), GSD % radius(i_bracket+1), &
                     GSD % number(i_bracket), GSD % number(i_bracket+1), rad_sub)*d_rad_sub
             else
                d_n = 0
             endif
             n_tot = n_tot + d_n
             d_S_grain(i_radius) = d_S_grain(i_radius)+d_n*pi*rad_sub**2
             V_grain = V_grain+d_n*4*pi*rad_sub**3/3
          enddo
       endif
    enddo

!# Normalization to the mass of grains of the species.

    grain_mass = grain_density * V_grain
    if (grain_mass > 0) d_S_grain(:) = d_S_grain(:)/grain_mass/um_to_cm !# in cm2.g-1.

  end subroutine grain_size_distribution

!#======================================================================

  subroutine compute_kappa(dim_radius, d_S_grain, dim_lambda_grains, &
       Q_abs, Q_sca, cos_sca, kappa_ext, albedo, asym)

    use mod_types
    
    implicit none
    integer, intent(in) :: dim_lambda_grains, dim_radius
    real(CDR), dimension(:), intent(in) :: d_S_grain
    real(CDR), dimension(:, :), intent(in) :: Q_abs
    real(CDR), dimension(:, :), intent(in) :: Q_sca, cos_sca
    real(CDR), dimension(:), intent(out) :: kappa_ext, &
         albedo, asym
!#......................................................................
    real(CDR) :: kappa_sca, kappa_abs
    integer :: i_lambda, i_radius
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    do i_lambda = 1, dim_lambda_grains
       kappa_abs = 0
       kappa_sca = 0
       asym(i_lambda) = 0
       do i_radius = 1, dim_radius
          kappa_abs = kappa_abs + Q_abs(i_radius, i_lambda)*d_S_grain(i_radius)
          kappa_sca = kappa_sca + Q_sca(i_radius, i_lambda)*d_S_grain(i_radius)
          asym(i_lambda) = asym(i_lambda) + &
               cos_sca(i_radius, i_lambda)*Q_sca(i_radius, i_lambda)*d_S_grain(i_radius)
       enddo
       if (kappa_sca > 0) then
          asym(i_lambda) = asym(i_lambda)/kappa_sca
       else
          asym(i_lambda) = 0
       endif
!# Opacity (extinction = absorption + scattering) in cm^2.g^-1.
       kappa_ext(i_lambda) = kappa_abs+kappa_sca
       if (kappa_ext(i_lambda) > 0) then
          albedo(i_lambda) = kappa_sca/kappa_ext(i_lambda)
       else
          albedo(i_lambda) = 0
       endif
    enddo

  end subroutine compute_kappa

end module mod_grain_properties

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université,
!# Institut d'astrophysique de Paris/CNRS, France.
!#
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides
!# by the rules of distribution of free software. You can use, modify and/or
!# redistribute this software under the terms of the CeCILL license as circulated
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!#
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability.
!#
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#======================================================================

program spectra

  use mod_types
  use mod_linked_list
  use mod_directories, only : scenarios_dir, yields_dir, spectra_dir, &
       grain_temp_dir, grain_SED_dir, bin_dir, log_spectra_dir
  use mod_constants, only : Y_prim, Z_prim, L_sol, &
       lambda_Lyman_break_um, &
       in_A_to_in_um, &
       per_A_to_per_um, &
       per_um_to_per_A, &
       solar_abundances, &
       spectra_list, grain_temp_list, grain_SED_list
  use mod_spectra_constants, only : &
       dim_temp, T_CBR0, scenarios_list, eps_lambda
  use mod_stel_lib, only : spectra_read_stel_lib1, struct_stel_lib
  use mod_spectra_ages, only : read_spectra_ages
  use mod_nebular, only : nebular_computations
  use mod_RT, only : read_RT_data, struct_RT_sph_sym, struct_RT_cyl_sym
  use mod_grain_properties, only : read_dust, struct_grain_abs
  use mod_read_SSPs, only : read_SSP_Z, read_SSPs_set
  use mod_initialization, only : initialization
  use mod_evolution, only : evolution
  use mod_SFC_DISM, only : compute_stellar_spectrum, &
       compute_nebular_spectrum, SFC_DISM_properties
  use mod_extinction, only : compute_opacity_DISM, compute_opacity_SFC, &
       compute_RF_DISM, compute_RF_SFC, attenuate_DISM
  use mod_compute_various, only : compute_various
  use mod_file_access, only : open_file, close_file, file_name_decomposition, path_file, base_name
  use mod_dir_access, only : dir_sep
  use mod_dust_emission, only : temp_grid, compute_grain_bol_lum, compute_grain_energ, &
       compute_dust_emission, read_Debye, unit_grain_temp, unit_grain_SED, &
       do_output_grain, struct_grain
  use mod_write_scenario_param, only : write_scenario_param, ord_scenario, write_parameter
  use mod_write_spectra_output, only : write_spectra_main_preamble, write_spectra_various, &
       write_spectra_SED, write_spectra_warning, write_spectra_grain_preamble
  use mod_intersperse
  use mod_interp
  use mod_scenario
  use mod_parse_file, only : parse_file, file_list
  use mod_strings, only : quote_string, same_case_equal
  use mod_convert_type
  use mod_read_abundances, only : read_abundances
  use mod_ISO_8601, only : ISO_8601
  use mod_process_file_name, only : process_file_name, process_file_name_aux
  use mod_select_file, only : select_single_file
  use mod_interm_grid, only : interm_grid
  use mod_spectra_alloc, only : spectra_alloc1, spectra_alloc2
  use mod_compiler, only : compiler
  use mod_random, only : dim_seed, seed
  use mod_cosmo, only : fn_cosmic_time, fn_redshift
  implicit none
!#......................................................................
  character(len=25) :: run_begin_time
  character(len=14) :: time_stamp_value
  logical :: time_stamp_used
  integer :: unit_scenarios
  logical :: exist

  character(len=std_string) :: log_file

  integer :: dim_SSP
  character(std_string), dimension(:), pointer :: SSP_file => null()
  real(CDR), dimension(:), pointer :: Z_SSP => null()

  integer :: dim_cont, i_Lyman_break_cont, i_Lyman_break_stel, i_species, i_cont, i_inf, i_sup
  real(CDR), dimension(:), pointer :: lambda_cont => null()
  integer, dimension(:), allocatable :: i_bracket

  type(struct_grain), dimension(:), pointer :: grain_data_SFC => null(), &
       grain_data_DISM => null()

!# `_SFC` = from stars, gas or grains in star-forming clouds.
!# `_DISM` = from stars, gas or grains in the diffuse ISM.
!# `_unatt` = unattenuatted.
!# `_att_gas` = attenuated by gas only, and this in the region considered only.
  real(CDR), dimension(:), pointer :: lum_cont => null(), &
       lum_stel_SFC_att_gas => null(), &
       lum_stel_SFC_unatt => null(), &
       lum_stel_SFC => null(), &
       lum_stel_DISM_att_gas => null(), &
       lum_stel_DISM_unatt => null(), &
       lum_cont_unatt => null(), &
       lum_neb_cont_SFC_unatt => null(), &
       lum_neb_cont_SFC => null(), &
       lum_neb_cont_DISM_unatt => null(), &
       RF_cont_SFC => null(), &
       RF_line_SFC => null(), &
       RF_cont_DISM => null(), &
       RF_line_DISM => null()

  real(CDR) :: M_dust, L_dust, L_dust_SFC, L_dust_DISM, dust_bol_ratio
  real(CDR) :: M_dust_SFC
  real(CDR), dimension(:), pointer :: species_weight_SFC => null(), &
       species_weight_DISM => null()

  integer :: dim_output_age, i_output_age, i_time
  real(CDR), dimension(:), pointer :: output_age => null()
  real(CDR) :: time, time_step

  real(CDR), dimension(:), pointer :: lambda_stel => null() !# Wavelengths of the stellar spectra.
  integer :: dim_SL, dim_lambda_stel !# Number of stellar libraries ; number of wavelengths of the stellar spectra.
  integer, dimension(:), pointer :: dim_spec => null() !# Number of spectra for each stellar library.

  real(CDR), dimension(:,:,:), pointer :: rel_lum_neb_cont => null()
  integer :: dim_line
  real(CDR), dimension(:), pointer :: lambda_line => null()
  real(CDR), dimension(:,:,:), pointer :: rel_L_line => null()
  real(CDR), dimension(:,:), pointer :: rel_lum_other_lines => null()
  character(len=std_string), dimension(:), pointer :: line_id => null()
  real(CDR), dimension(:), pointer :: kappa_abs_cont => null()
  real(CDR), dimension(:), pointer :: kappa_abs_line => null()

  type(lk_lst_long_string), dimension(:), pointer :: &
       header_SSPs => null()

  real(CDR), dimension(:, :), pointer :: L_bol_SSP => null()
  real(CDR), dimension(:, :, :), pointer :: lum_SSP => null()
  real(CDR), dimension(:, :), pointer :: stellar_mass_SSP => null()
  integer, dimension(:), pointer :: inv_time => null()
  real(CDR), dimension(:), pointer :: beta => null()
  real(CDR), dimension(:, :), pointer :: LC_rate_SSP => null()
  real(CDR), dimension(:, :), pointer :: CCSN_rate_SSP => null(), &
       SNIa_rate_SSP => null()
  real(CDR), dimension(:, :), pointer :: ejec_rate_tot_SSP => null()
  real(CDR), dimension(:,:,:), pointer :: ejec_rate_elem_SSP => null()
  real(CDR), dimension(:, :), pointer :: carb_dust_prod_rate_SSP => null(), &
       sil_dust_prod_rate_SSP => null()
  real(CDR), dimension(:, :), pointer :: BHNS_mass_prod_rate_SSP => null(), &
       WD_mass_prod_rate_SSP => null()

  real(CDR), dimension(:), pointer :: lum_stel_SFC_att_gas0 => null(), &
       lum_stel_SFC_unatt0 => null(), &
       lum_stel_DISM_att_gas0 => null(), &
       lum_stel_DISM_unatt0 => null(), &
       lum_stel_SFC0 => null(), &
       lum_neb_cont_SFC_unatt0 => null(), &
       lum_neb_cont_SFC0 => null(), &
       lum_neb_cont_DISM_unatt0 => null()

  real(CDR), dimension(:), pointer :: L_line => null(), &
       L_line_SFC_unatt => null(), &
       L_line_SFC => null(), &
       L_line_DISM_unatt => null(), &
       L_line_unatt => null()

  real(CDR) :: Lyman_cont_rate

  real(CDR), dimension(:), pointer :: galaxy_mass => null(), &
       ISM_mass => null(), &
       BHNS_mass => null(), &
       WD_mass => null(), &
       carb_abund => null(), &
       sil_abund => null()
  real(CDR), dimension(max_dim_reserv) :: reserv_init_mass_scaled
  real(CDR) :: carb_init_mass, sil_init_mass, dust_abund
  logical :: SF_warn_present, outflow_warn_present, reserv_warn_present
  logical, dimension(max_dim_reserv) ::  infall_warn_present
  real(CDR) :: SF_warn_age, outflow_warn_age
  real(CDR), dimension(max_dim_reserv) :: infall_warn_age

  type(irreg_array_CDR), dimension(:), pointer :: RF_DISM => null(), &
       RF_SFC => null()

  real(CDR), dimension(:), pointer :: grain_density_SFC => null(), &
       grain_density_DISM => null(), &
       grain_mean_atomic_mass_SFC => null(), &
       grain_mean_atomic_mass_DISM => null()

  type(struct_grain_abs), dimension(:), pointer :: grain_abs_SFC => null(), &
       grain_abs_DISM => null()

  real(CDR), dimension(:), pointer :: ISM_elem_init_mass => null()
  real(CDR), dimension(:,:), pointer :: ISM_abund => null()
  real(CDR), dimension(:,:), pointer :: reserv_abund => null()

  real(CDR), dimension(:, :), pointer :: SSP_Z_weight => null()
  real(DPR), dimension(:), pointer :: SF_rate => null()
  real(DPR), dimension(:, :), pointer :: SF_live_d_mass => null()
  real(DPR), dimension(:), pointer :: CCSN_rate => null(), &
       SNIa_rate => null(), &
       ejec_rate_tot => null(), &
       infall_rate => null(), &
       outflow_rate => null(), &
       ejec_cumul_mass => null(), &
       SF_live_cumul_mass => null(), &
       infall_cumul_mass => null(), &
       outflow_cumul_mass => null()

  real(CDR), dimension(:), pointer :: inert_mass => null(), &
       ISM_over_H => null()

  real(CDR) :: stel_Z_mass_avrg, stel_age_mass_avrg, live_stars_mass

  real(CDR), dimension(:), pointer :: LC_gas_abs_birth_cloud => null(), &
       LC_dust_abs_birth_cloud => null(), &
       LC_gas_abs_DISM => null(), &
       dust_col_dens_birth_cloud => null(), &
       cloud_frac => null()
  real(CDR) :: Lyman_cont_dust_abs, Lyman_cont_gas_abs
  integer :: unit_spectra

  real(CDR) :: tau_V, stel_Z_bol_avrg, stel_age_bol_avrg, L_bol

  type(struct_RT_cyl_sym) :: slab, disk, bulge
  type(struct_RT_sph_sym) :: King

  character(std_string), dimension(:), pointer :: file_SL => null()
  type(irreg_array_int), dimension(:), pointer :: used_SL_global => null()

  integer :: i_SSP

  real(CDR), dimension(:), pointer :: cont_trans_DISM_tot => null(), &
       cont_trans_DISM_incl => null(), &
       cont_trans_SFC => null()

  real(CDR), dimension(:), pointer :: line_trans_DISM_tot => null(), &
       line_trans_DISM_incl => null(), &
       line_trans_SFC => null()

  real(CDR), dimension(:), pointer :: time_SSP => null()

  integer :: unit

  integer :: dim_Debye
  real(CDR), dimension(:), pointer :: u_Debye => null(), I2_Debye => null(), &
       I3_Debye => null()

  integer :: dim_elem_sol
  real(DPR), dimension(:), pointer :: abund_sol => null()
  character(len=std_string), dimension(:), pointer :: elem_sol => null()
  real(CDR) :: X_sol, Y_sol, Z_sol, dY_over_dZ

  logical, dimension(:), allocatable :: opt_depth_warn_present
  real(CDR), dimension(:), allocatable :: opt_depth_warn_min_lambda, &
       opt_depth_warn_max_lambda

  integer :: dim_species_SFC, dim_species_DISM
  real(CDR), dimension(:, :), pointer :: lum_species_SFC => null(), &
       lum_species_DISM => null()
  real(CDR), dimension(:, :), pointer :: sublim_lum_species_SFC => null(), &
       sublim_lum_species_DISM => null()

  type(struct_stel_lib), dimension(:), allocatable :: stel_lib

  integer :: i_Lyman_alpha

  integer :: dim_convol_time, dim_elem
  character(len=std_string), dimension(:), pointer :: elem_id => null()
  real(CDR), dimension(:), pointer :: convol_time => null()

  character(len=std_string), dimension(:), pointer :: &
       species_id_SFC => null(), &
       species_id_DISM => null()

  real(CDR), dimension(:), pointer :: carb_frac_SFC => null(), &
       carb_frac_DISM => null(), sil_frac_SFC => null(), &
       sil_frac_DISM => null()
  real(CDR), dimension(:), pointer :: sublim_temp_SFC => null(), &
       sublim_temp_DISM => null()

  logical :: first_scenario

  logical :: run, end_of_file
  logical :: end_statement, return_statement, initialize

  character(len=std_string) :: stel_lib_set, stel_lib_set_prev
  character(len=std_string) :: SSPs_set_prev, ages_file_prev
  character(len=std_string) :: grains_file_SFC_prev, grains_file_DISM_prev
  logical :: SSPs_set_changed, stel_lib_set_changed
  logical :: grains_file_SFC_changed, grains_file_DISM_changed
  real(CDR) :: close_bin_frac_prev
  logical :: opened

  integer :: unit_compiler

  real(CDR) :: t_for, redshift, cosmic_time

  real(CDR) :: inner_radius, H_density
  integer :: n_Z_neb, n_Q_neb
  real(CDR), dimension(:), pointer :: Z_neb => null(), Q_neb => null()
  real(CDR), dimension(:,:), pointer :: Z_neb_weight => null(), &
       Q_neb_weight_SFC => null(), Q_neb_weight_DISM => null()
  real(DPR), dimension(:,:), pointer :: rel_volume_neb => null()
  real(CDR), dimension(:,:), pointer :: LC_power_SSP => null()
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Create time-stamp:
  call ISO_8601(local_time_extended = run_begin_time, UTC_time_basic = time_stamp_value)
  write(*,"(a,a/)") "Time-stamp: ", quote_string(time_stamp_value)

  call open_file(unit_compiler, path_file(bin_dir, "compil_spectra.txt"))
  read(unit_compiler,*) compiler
  call close_file(unit_compiler)

!# Open the file containing the scenarios:
  write(*, "(a)") "Name of the file of scenarios?"
  call select_single_file(scenarios_dir, scenarios_list, scenarios_file, &
       "file of scenarios", "files of scenarios", back = .true.)
  call open_file(unit_scenarios, path_file(scenarios_dir, scenarios_file))

!# Open log-file:
  log_file = trim(time_stamp_value) // "_" // base_name(scenarios_file, dir_sep)
  call open_file(unit_log, path_file(log_spectra_dir, log_file), &
       status = "replace")

!#

  first_scenario = .true.

  initialize = .true. !# `initialize` /= `first_scenario`.
  end_of_file = .false.
  end_statement = .false.
  return_statement = .false.

  call random_seed(size = dim_seed)
  if (.not.allocated(seed)) allocate(seed(dim_seed))
  call random_seed(get = seed)

  SSPs_set_prev = ""
  stel_lib_set_prev = ""
  grains_file_SFC_prev = ""
  grains_file_DISM_prev = ""
  ages_file_prev = ""
  close_bin_frac_prev = -1

  allocate(file_list)
  file_list % unit = unit_scenarios
  file_list % file_name = path_file(scenarios_dir, scenarios_file)
  file_list % line_number = 0
  file_list % included_file = .false.

!# Loop on scenarios:
  ord_scenario = 0
  do
     if (end_of_file .or. end_statement) exit
     ord_scenario = ord_scenario + 1

     spectra_file = ""
     grain_temp_file = ""
     grain_SED_file = ""
     time_stamp_used = .false.

     if (initialize) then
        call parse_file(file_list = file_list, &
             read_proc = read_spectra_input_param, &
             end_proc = end_proc, &
             run = run, &
             end_of_file = end_of_file, &
             end_statement = end_statement, &
             return_statement = return_statement, &
             init_proc = init_proc)
     else
        call parse_file(file_list = file_list, &
             read_proc = read_spectra_input_param, &
             end_proc = end_proc, &
             run = run, &
             end_of_file = end_of_file, &
             end_statement = end_statement, &
             return_statement = return_statement)
     endif
     initialize = .false.
     new_statement = .false.

     if (.not. run) then
        if (verbosity >= 0) then
           write(*, "(a)") repeat("*",80)
           if (check_only) &
                write(*, "(a,i0,a)") "Checked scenario number ", &
                ord_scenario, ". OK."
        endif
        cycle
     else
        if (verbosity >= 0) then
           write(*, "(a)") repeat("*",80)
           write(*, "(a,i0,a)") "Processing scenario number ", ord_scenario, "."
        endif
     endif

     call random_seed(get = seed)

     orig_spectra_file = spectra_file
     call process_file_name(spectra_file, prefix, spectra_dir, "spectra", &
          time_stamp_value, stamp_time, ord_scenario, verbosity, time_stamp_used, &
          overwrite)
     if (spectra_output /= "none") then
        if (overwrite) then
           call open_file(unit_spectra, &
                path_file(spectra_dir, spectra_file), status = "replace", action = "write")
        else
           call open_file(unit_spectra, &
                path_file(spectra_dir, spectra_file), status = "new", action = "write")
        endif
     endif
!# ??? If `spectra_output == "none"`, the file referred to by `spectra_file`
!# is not created although the variable `spectra_file` has been assigned and is
!# used later.

     orig_grain_temp_file = grain_temp_file
     orig_grain_SED_file = grain_SED_file
     if (grain_temp_output) then
        call process_file_name_aux(grain_temp_file, spectra_file, prefix, grain_temp_dir, "grain_temp", &
             time_stamp_value, stamp_time, ord_scenario, verbosity, time_stamp_used, overwrite)

        if (overwrite) then
           call open_file(unit_grain_temp, &
                path_file(grain_temp_dir, grain_temp_file), &
                status = "replace", action = "write")
        else
           call open_file(unit_grain_temp, &
                path_file(grain_temp_dir, grain_temp_file), &
                status = "new", action = "write")
        endif
     endif

     if (grain_SED_output) then
        call process_file_name_aux(grain_SED_file, spectra_file, prefix, grain_SED_dir, "grain_SED", &
             time_stamp_value, stamp_time, ord_scenario, verbosity, time_stamp_used, overwrite)

        if (overwrite) then
           call open_file(unit_grain_SED, &
                path_file(grain_SED_dir, grain_SED_file), &
                status = "replace", action = "write")
        else
           call open_file(unit_grain_SED, &
                path_file(grain_SED_dir, grain_SED_file), &
                status = "new", action = "write")
        endif
     endif

!#

     if (SSPs_set /= SSPs_set_prev) SSPs_set_changed = .true.

     if (SSPs_set_changed) then
        call read_SSPs_set(SSPs_set, dim_SSP, SSP_file, &
             used_SL_global, stel_lib_set)
     endif

     if (stel_lib_set /= stel_lib_set_prev) stel_lib_set_changed = .true.

     if (stel_lib_set_changed) then
        call spectra_read_stel_lib1(dim_SL, dim_spec, dim_lambda_stel, lambda_stel, &
             file_SL, stel_lib_set)

        call nebular_computations(inner_radius, H_density, &
             n_Z_neb, n_Q_neb, Z_neb, Q_neb, &
             dim_lambda_stel, lambda_stel, rel_lum_neb_cont, &
             dim_line, lambda_line, rel_L_line, line_id, i_Lyman_alpha, &
             i_Lyman_break_stel, Q_neb_weight_DISM, &
             rel_lum_other_lines, rel_volume_neb)

!# Units: wavelengths now in micrometers:
        lambda_stel(:) = lambda_stel(:) * in_A_to_in_um
        lambda_line(:) = lambda_line(:) * in_A_to_in_um
     endif

     if (first_scenario) then
        call read_RT_data(King, slab, disk, bulge)

        call read_Debye(dim_Debye, u_Debye, I2_Debye, I3_Debye)

!# Read solar abundances:
        call read_abundances(path_file(yields_dir, solar_abundances), &
             dim_elem_sol, abund_sol, elem_sol)
        X_sol = sum(abund_sol, mask = elem_sol == "1H" .or. elem_sol == "2H")
        Y_sol = sum(abund_sol, mask = elem_sol == "3He" .or. elem_sol == "4He")
        Z_sol = 1 - X_sol - Y_sol
        dY_over_dZ = (Y_sol - Y_prim)/(Z_sol - Z_prim)
     endif

     if (grains_file_SFC /= grains_file_SFC_prev) &
          grains_file_SFC_changed = .true.
     if (grains_file_DISM /= grains_file_DISM_prev) &
          grains_file_DISM_changed = .true.

     if (grains_file_SFC_changed) then
        call read_dust(grain_abs_SFC, grain_density_SFC, &
             grain_mean_atomic_mass_SFC, &
             grains_file_SFC, dim_species_SFC, species_id_SFC, &
             carb_frac_SFC, sil_frac_SFC, carb_sublim_temp_SFC, &
             sil_sublim_temp_SFC, sublim_temp_SFC)

        if (associated(grain_data_SFC)) then
           do i_species = 1, size(grain_data_SFC)
              if (associated(grain_data_SFC(i_species) % temp)) &
                   deallocate(grain_data_SFC(i_species) % temp)
              if (associated(grain_data_SFC(i_species) % grain_energ0)) &
                   deallocate(grain_data_SFC(i_species) % grain_energ0)
              if (associated(grain_data_SFC(i_species) % bol_lum)) &
                   deallocate(grain_data_SFC(i_species) % bol_lum)
           enddo
           deallocate(grain_data_SFC)
        endif
        allocate(grain_data_SFC(dim_species_SFC))
        do i_species = 1, dim_species_SFC
           grain_data_SFC(i_species) % sublim_temp = sublim_temp_SFC(i_species)
           grain_data_SFC(i_species) % dim_temp = dim_temp
           call temp_grid(dim_temp, grain_data_SFC(i_species) % temp)

           call compute_grain_bol_lum(grain_abs_SFC(i_species) % dim_radius, &
                grain_abs_SFC(i_species) % radius(:), &
                grain_abs_SFC(i_species) % dim_lambda, &
                grain_abs_SFC(i_species) % lambda(:), &
                grain_abs_SFC(i_species) % Q_abs(:,:), &
                grain_data_SFC(i_species) % temp, &
                grain_data_SFC(i_species) % bol_lum)

           call compute_grain_energ(species_id_SFC(i_species), &
                grain_data_SFC(i_species) % temp, &
                grain_data_SFC(i_species) % grain_energ0, &
                dim_Debye, u_Debye, I2_Debye, &
                I3_Debye)
        enddo
     endif

     if (grains_file_DISM_changed) then
        call read_dust(grain_abs_DISM, grain_density_DISM, &
             grain_mean_atomic_mass_DISM, &
             grains_file_DISM, dim_species_DISM, species_id_DISM, &
             carb_frac_DISM, sil_frac_DISM, carb_sublim_temp_DISM, &
             sil_sublim_temp_DISM, sublim_temp_DISM)

        if (associated(grain_data_DISM)) then
           do i_species = 1, size(grain_data_DISM)
              if (associated(grain_data_DISM(i_species) % temp)) &
                   deallocate(grain_data_DISM(i_species) % temp)
              if (associated(grain_data_DISM(i_species) % grain_energ0)) &
                   deallocate(grain_data_DISM(i_species) % grain_energ0)
              if (associated(grain_data_DISM(i_species) % bol_lum)) &
                   deallocate(grain_data_DISM(i_species) % bol_lum)
           enddo
           deallocate(grain_data_DISM)
        endif
        allocate(grain_data_DISM(dim_species_DISM))
        do i_species = 1, dim_species_DISM
           grain_data_DISM(i_species) % sublim_temp = sublim_temp_DISM(i_species)
           grain_data_DISM(i_species) % dim_temp = dim_temp
           call temp_grid(dim_temp, grain_data_DISM(i_species) % temp)

           call compute_grain_bol_lum(grain_abs_DISM(i_species) % dim_radius, &
                grain_abs_DISM(i_species) % radius(:), &
                grain_abs_DISM(i_species) % dim_lambda, &
                grain_abs_DISM(i_species) % lambda(:), &
                grain_abs_DISM(i_species) % Q_abs(:,:), &
                grain_data_DISM(i_species) % temp, &
                grain_data_DISM(i_species) % bol_lum)

           call compute_grain_energ(species_id_DISM(i_species), &
                grain_data_DISM(i_species) % temp, &
                grain_data_DISM(i_species) % grain_energ0, &
                dim_Debye, u_Debye, I2_Debye, &
                I3_Debye)
        enddo
     endif

     if (stel_lib_set_changed .or. grains_file_SFC_changed &
          .or. grains_file_DISM_changed) then
        dim_cont = dim_lambda_stel
        if (associated(lambda_cont)) deallocate(lambda_cont)
        allocate(lambda_cont(dim_cont))
        lambda_cont(1:dim_cont) = lambda_stel(1:dim_lambda_stel)

!# Units: `lambda_cont` and `grain_abs % lambda` are in micrometers.
        do i_species = 1, dim_species_SFC !# Redundancy if the same grid of wavelengths \
!#                             is used for various grains.

           call intersperse(dim_cont, grain_abs_SFC(i_species) % dim_lambda, lambda_cont, &
                grain_abs_SFC(i_species) % lambda(:), eps = eps_lambda)
        enddo

        do i_species = 1, dim_species_DISM !# Redundancy if the same grid of wavelengths \
!#                             is used for various grains.

           call intersperse(dim_cont, grain_abs_DISM(i_species) % dim_lambda, lambda_cont, &
                grain_abs_DISM(i_species) % lambda(:), eps = eps_lambda)
        enddo

        if (allocated(i_bracket)) deallocate(i_bracket)
        allocate(i_bracket(dim_cont))
        do i_cont = 1, dim_cont
           if (i_cont == 1) then
              i_bracket(1) = 0
           else
              i_bracket(i_cont) = i_bracket(i_cont-1)
           endif
           call bracket(dim_lambda_stel, lambda_stel, lambda_cont(i_cont), i_bracket(i_cont))
!# Do not interpolate through the Lyman break. Extrapolate instead.
           if (lambda_stel(i_bracket(i_cont)) <= lambda_Lyman_break_um .and. &
                lambda_stel(i_bracket(i_cont)+1) >= lambda_Lyman_break_um) then
              if (lambda_cont(i_cont) < lambda_Lyman_break_um) then
                 i_bracket(i_cont) = i_bracket(i_cont)-1
              else
                 i_bracket(i_cont) = i_bracket(i_cont)+1
              endif
           endif
        enddo

!# Find the indices of the continuum wavelengths bracketing the Lyman break:
        i_Lyman_break_cont = 0 !# ??? Or `1`?
        do while (lambda_cont(i_Lyman_break_cont+1) < lambda_Lyman_break_um)
           i_Lyman_break_cont = i_Lyman_break_cont+1
        enddo

        call spectra_alloc1(dim_cont = dim_cont, dim_lambda_stel = dim_lambda_stel, &
             dim_line = dim_line, dim_species_SFC = dim_species_SFC, &
             dim_species_DISM = dim_species_DISM, lum_cont = lum_cont, &
             lum_stel_SFC_att_gas = lum_stel_SFC_att_gas, &
             lum_stel_SFC_unatt = lum_stel_SFC_unatt, lum_stel_SFC = lum_stel_SFC, &
             lum_stel_DISM_att_gas = lum_stel_DISM_att_gas, &
             lum_stel_DISM_unatt = lum_stel_DISM_unatt, &
             lum_cont_unatt = lum_cont_unatt, &
             lum_neb_cont_SFC_unatt = lum_neb_cont_SFC_unatt, &
             lum_neb_cont_SFC = lum_neb_cont_SFC, lum_neb_cont_DISM_unatt = lum_neb_cont_DISM_unatt, &
             kappa_abs_cont = kappa_abs_cont, cont_trans_DISM_tot = cont_trans_DISM_tot, &
             cont_trans_DISM_incl = cont_trans_DISM_incl, &
             cont_trans_SFC = cont_trans_SFC, lum_species_SFC = lum_species_SFC, &
             lum_species_DISM = lum_species_DISM, &
             sublim_lum_species_SFC = sublim_lum_species_SFC, &
             sublim_lum_species_DISM = sublim_lum_species_DISM, &
             kappa_abs_line = kappa_abs_line, L_line = L_line, &
             L_line_SFC_unatt = L_line_SFC_unatt, L_line_SFC = L_line_SFC, &
             L_line_DISM_unatt = L_line_DISM_unatt, &
             L_line_unatt = L_line_unatt, &
             line_trans_DISM_tot = line_trans_DISM_tot, &
             line_trans_DISM_incl = line_trans_DISM_incl, &
             line_trans_SFC = line_trans_SFC, &
             RF_cont_SFC = RF_cont_SFC, RF_line_SFC = RF_line_SFC, &
             RF_cont_DISM = RF_cont_DISM, RF_line_DISM = RF_line_DISM, &
             lum_stel_SFC_att_gas0 = lum_stel_SFC_att_gas0, &
             lum_stel_SFC_unatt0 = lum_stel_SFC_unatt0, &
             lum_stel_DISM_att_gas0 = lum_stel_DISM_att_gas0, &
             lum_stel_DISM_unatt0 = lum_stel_DISM_unatt0, &
             lum_stel_SFC0 = lum_stel_SFC0, &
             lum_neb_cont_SFC_unatt0 = lum_neb_cont_SFC_unatt0, &
             lum_neb_cont_SFC0 = lum_neb_cont_SFC0, &
             lum_neb_cont_DISM_unatt0 = lum_neb_cont_DISM_unatt0, &
             species_weight_SFC = species_weight_SFC, &
             species_weight_DISM = species_weight_DISM)
     endif

!# Read output ages if needed:
     if (ages_file /= ages_file_prev) then
        call read_spectra_ages(ages_file, dim_output_age, output_age)
        if (allocated(opt_depth_warn_present)) deallocate(opt_depth_warn_present)
        allocate(opt_depth_warn_present(dim_output_age))
        if (allocated(opt_depth_warn_min_lambda)) &
             deallocate(opt_depth_warn_min_lambda)
        allocate(opt_depth_warn_min_lambda(dim_output_age))
        if (allocated(opt_depth_warn_max_lambda)) &
             deallocate(opt_depth_warn_max_lambda)
        allocate(opt_depth_warn_max_lambda(dim_output_age))
     endif
     opt_depth_warn_present(:) = .false.
     opt_depth_warn_min_lambda(:) = lambda_cont(dim_cont)
     opt_depth_warn_max_lambda(:) = lambda_cont(1)

     if (SSPs_set_changed .or. close_bin_frac /= close_bin_frac_prev) then
        allocate(stel_lib(dim_SL))
        do i_SSP = 1, dim_SSP
           if (verbosity >= 1) write(*, "(a,i0,a,i0)") "SSP ", i_SSP, "/", dim_SSP
           call read_SSP_Z(time_step, dim_output_age, output_age, &
                dim_convol_time, convol_time, &
                dim_SSP, i_SSP, SSP_file, Z_SSP, close_bin_frac, &
                maxval(dim_spec), &
                dim_lambda_stel, &
                L_bol_SSP, lum_SSP, stellar_mass_SSP, inv_time, beta, &
                LC_rate_SSP, &
                ejec_rate_tot_SSP, ejec_rate_elem_SSP, &
                carb_dust_prod_rate_SSP, sil_dust_prod_rate_SSP, &
                BHNS_mass_prod_rate_SSP, WD_mass_prod_rate_SSP, &
                file_SL, used_SL_global, dim_SL, &
                time_SSP, stel_lib, &
                CCSN_rate_SSP, SNIa_rate_SSP, &
                dim_elem, elem_id, header_SSPs, LC_power_SSP)
        enddo
        if (verbosity >= 1) write(*, "(a/)") "Done."
        deallocate(stel_lib)
     endif

     call spectra_alloc2(dim_convol_time, dim_elem, &
          galaxy_mass, ISM_mass, BHNS_mass, &
          WD_mass, carb_abund, sil_abund, SF_rate, CCSN_rate, SNIa_rate, &
          ejec_rate_tot, infall_rate, outflow_rate, ejec_cumul_mass, &
          SF_live_cumul_mass, infall_cumul_mass, outflow_cumul_mass, &
          inert_mass, ISM_over_H, &
          LC_gas_abs_birth_cloud, LC_dust_abs_birth_cloud, &
          LC_gas_abs_DISM, dust_col_dens_birth_cloud, &
          cloud_frac, ISM_elem_init_mass, ISM_abund, reserv_abund, &
          n_Z_neb, n_Q_neb, Z_neb_weight, Q_neb_weight_SFC)

!# Initialization:
     call initialization(reserv_abund, &
          ISM_abund, galaxy_mass(1), reserv_init_mass_scaled, ISM_mass(1), &
          BHNS_mass(1), WD_mass(1), inert_mass(1), carb_abund(1), &
          sil_abund(1), ISM_elem_init_mass, carb_init_mass, sil_init_mass, &
          abund_sol, elem_sol, Z_sol, dY_over_dZ, SF_warn_present, infall_warn_present, &
          outflow_warn_present, reserv_warn_present)

!# Convolution of the SSPs with the star formation rate:
     call evolution(dim_convol_time, convol_time, time_step, Z_SSP, dim_SSP, &
          ejec_rate_tot_SSP, ejec_rate_elem_SSP, &
          carb_dust_prod_rate_SSP, sil_dust_prod_rate_SSP, &
          WD_mass_prod_rate_SSP, BHNS_mass_prod_rate_SSP, ISM_mass, &
          carb_init_mass, sil_init_mass, &
          ISM_elem_init_mass, carb_abund, sil_abund, &
          inert_mass, galaxy_mass, BHNS_mass, WD_mass, &
          ISM_abund, &
          SF_live_d_mass, &
          SSP_Z_weight, &
          reserv_init_mass_scaled, &
          reserv_abund, &
          time_SSP, CCSN_rate_SSP, SNIa_rate_SSP, &
          CCSN_rate, SNIa_rate, ejec_rate_tot, SF_rate, infall_rate, &
          outflow_rate, &
          ejec_cumul_mass, SF_live_cumul_mass, infall_cumul_mass, &
          outflow_cumul_mass, SF_warn_present, SF_warn_age, &
          infall_warn_present, infall_warn_age, &
          outflow_warn_present, outflow_warn_age, dim_elem, ISM_over_H, &
          Z_neb, Z_neb_weight)
!# (Mixing of galactic outflows with the reservoir is not implemented.
!# `reserv_abund` should change if such a mixing occurs.)

     call write_spectra_main_preamble(unit_spectra, spectra_output, time_step, &
          dim_output_age, dim_elem, elem_id, &
          dim_species_SFC, dim_species_DISM, &
          species_id_SFC, species_id_DISM, dim_cont, dim_line, &
          lambda_cont, lambda_line, line_id, &
          max_dim_reserv, &
          reserv_warn_present, SF_warn_present, SF_warn_age, &
          infall_warn_present, infall_warn_age, &
          outflow_warn_present, outflow_warn_age, &
          run_begin_time, dim_SSP, header_SSPs)

     call write_spectra_grain_preamble(unit_grain_temp, unit_grain_SED, &
          dim_species_SFC, dim_species_DISM, &
          stoch_heating_SFC, stoch_heating_DISM, &
          species_id_SFC, species_id_DISM, output_age, &
          grain_output_min_age, grain_output_max_age, &
          grain_output_SFC, grain_output_DISM, &
          grain_temp_output, grain_SED_output, &
          grain_abs_SFC, grain_abs_DISM, &
          run_begin_time, dim_SSP, header_SSPs)

!# Compute and output SEDs:
     t_for = fn_cosmic_time(form_redshift)

     do i_output_age = 1, dim_output_age
        if (verbosity >= 1) write(*, "(a,i0,a,i0)") "Age number ", &
             i_output_age, "/", dim_output_age
        time = output_age(i_output_age)

        cosmic_time = time + t_for
        redshift = fn_redshift(cosmic_time)

        if (verbosity >= 1) write(*, "(a,f8.2,a)") "Output time = ", time, " Myr"
        i_time = nint(time/time_step) + 1 !# Index of the nearest value of \
!#                                           `convol_time` to `output_age`.

        dust_abund = carb_abund(i_time) + sil_abund(i_time)
        if (dust_abund > 0) then
           species_weight_SFC(:) = (carb_frac_SFC(:)*carb_abund(i_time) + &
                sil_frac_SFC(:) * sil_abund(i_time))/ &
                dust_abund
           species_weight_DISM(:) = (carb_frac_DISM(:)*carb_abund(i_time) + &
                sil_frac_DISM(:) * sil_abund(i_time))/ &
                dust_abund
        else
           species_weight_SFC(:) = 0
           species_weight_DISM(:) = 0
        endif

        call SFC_DISM_properties(dim_species_SFC, grain_abs_SFC, LC_rate_SSP, &
             SF_live_d_mass, dust_abund, &
             species_weight_SFC, &
             LC_gas_abs_birth_cloud, LC_dust_abs_birth_cloud, &
             LC_gas_abs_DISM, &
             Lyman_cont_rate, Lyman_cont_dust_abs, Lyman_cont_gas_abs, &
             dust_col_dens_birth_cloud, cloud_frac, &
             M_dust_SFC, &
             ISM_over_H(i_time), i_time, convol_time, &
             n_Q_neb, Q_neb, Q_neb_weight_SFC, inner_radius, H_density, &
             n_Z_neb, Z_neb_weight, rel_volume_neb)
!# (Note: the composition of the ISM in the cloud is the same as in the diffuse
!# medium.)

        call compute_stellar_spectrum(convol_time = convol_time, &
             i_time = i_time, &
             dim_lambda_stel = dim_lambda_stel, &
             beta = beta, &
             inv_time = inv_time, &
             lum_SSP = lum_SSP, &
             SF_live_d_mass = SF_live_d_mass, &
             lum_stel_SFC_att_gas0 = lum_stel_SFC_att_gas0, &
             lum_stel_SFC_unatt0 = lum_stel_SFC_unatt0, &
             lum_stel_DISM_att_gas0 = lum_stel_DISM_att_gas0, &
             lum_stel_DISM_unatt0 = lum_stel_DISM_unatt0, &
             lum_stel_SFC0 = lum_stel_SFC0, &
             i_Lyman_break_stel = i_Lyman_break_stel, &
             LC_gas_abs_birth_cloud = LC_gas_abs_birth_cloud, &
             LC_gas_abs_DISM = LC_gas_abs_DISM, &
             dust_col_dens_birth_cloud = dust_col_dens_birth_cloud, &
             cloud_frac = cloud_frac, &
             dim_species = dim_species_SFC, &
             grain_abs = grain_abs_SFC, &
             species_weight = species_weight_SFC, &
             lambda_stel = lambda_stel)

        call compute_nebular_spectrum(convol_time = convol_time, &
             i_time = i_time, &
             dim_line = dim_line, &
             rel_L_line = rel_L_line, &
             dim_lambda_stel = dim_lambda_stel, &
             rel_lum_neb_cont = rel_lum_neb_cont, &
             SF_live_d_mass = SF_live_d_mass, &
             LC_gas_abs_birth_cloud = LC_gas_abs_birth_cloud, &
             LC_gas_abs_DISM = LC_gas_abs_DISM, &
             cloud_frac = cloud_frac, &
             i_Lyman_alpha = i_Lyman_alpha, &
             lum_neb_cont_SFC_unatt0 = lum_neb_cont_SFC_unatt0, &
             lum_neb_cont_SFC0 = lum_neb_cont_SFC0, &
             lum_neb_cont_DISM_unatt0 = lum_neb_cont_DISM_unatt0, &
             L_line_SFC_unatt = L_line_SFC_unatt, &
             L_line_SFC = L_line_SFC, &
             L_line_DISM_unatt = L_line_DISM_unatt, &
             M_dust_SFC = M_dust_SFC, &
             LC_power_SSP = LC_power_SSP, &
             n_Z_neb = n_Z_neb, n_Q_neb = n_Q_neb, &
             Z_neb_weight = Z_neb_weight, &
             Q_neb_weight_SFC = Q_neb_weight_SFC, &
             Q_neb_weight_DISM = Q_neb_weight_DISM)

!# Units: `lum_stel*0`, `lum_neb_cont*0` in erg.s-1.angstroem-1.L_sol-1.M_sys-1;
!# `L_line*` in erg.s-1.L_sol-1.M_sys-1.

!# Rebin to wavelengths `lambda_cont`:
        do i_cont = 1, dim_cont
           if (lambda_cont(i_cont) < lambda_stel(1)) then
!# No extrapolation of stellar spectra at short wavelengths.
              lum_stel_SFC_att_gas(i_cont) = 0
              lum_stel_SFC_unatt(i_cont) = 0
              lum_stel_SFC(i_cont) = 0
              lum_stel_DISM_att_gas(i_cont) = 0
              lum_stel_DISM_unatt(i_cont) = 0
              lum_neb_cont_SFC_unatt(i_cont) = 0
              lum_neb_cont_SFC(i_cont) = 0
              lum_neb_cont_DISM_unatt(i_cont) = 0
           else
              i_inf = i_bracket(i_cont)
              i_sup = i_inf+1
              lum_stel_SFC_att_gas(i_cont) = interp_log_log(lambda_stel(i_inf), &
                   lambda_stel(i_sup), lum_stel_SFC_att_gas0(i_inf), &
                   lum_stel_SFC_att_gas0(i_sup), lambda_cont(i_cont))
              lum_stel_SFC_unatt(i_cont) = interp_log_log(lambda_stel(i_inf), &
                   lambda_stel(i_sup), lum_stel_SFC_unatt0(i_inf), &
                   lum_stel_SFC_unatt0(i_sup), lambda_cont(i_cont))
              lum_stel_SFC(i_cont) = interp_log_log(lambda_stel(i_inf), &
                   lambda_stel(i_sup), lum_stel_SFC0(i_inf), &
                   lum_stel_SFC0(i_sup), lambda_cont(i_cont))
              lum_stel_DISM_att_gas(i_cont) = interp_log_log(lambda_stel(i_inf), &
                   lambda_stel(i_sup), lum_stel_DISM_att_gas0(i_inf), &
                   lum_stel_DISM_att_gas0(i_sup), lambda_cont(i_cont))
              lum_stel_DISM_unatt(i_cont) = interp_log_log(lambda_stel(i_inf), &
                   lambda_stel(i_sup), lum_stel_DISM_unatt0(i_inf), &
                   lum_stel_DISM_unatt0(i_sup), lambda_cont(i_cont))
              lum_neb_cont_SFC_unatt(i_cont) = interp_log_log(lambda_stel(i_inf), &
                   lambda_stel(i_sup), &
                   lum_neb_cont_SFC_unatt0(i_inf), lum_neb_cont_SFC_unatt0(i_sup), &
                   lambda_cont(i_cont))
              lum_neb_cont_SFC(i_cont) = interp_log_log(lambda_stel(i_inf), &
                   lambda_stel(i_sup), &
                   lum_neb_cont_SFC0(i_inf), lum_neb_cont_SFC0(i_sup), &
                   lambda_cont(i_cont))
              lum_neb_cont_DISM_unatt(i_cont) = interp_log_log(lambda_stel(i_inf), &
                   lambda_stel(i_sup), &
                   lum_neb_cont_DISM_unatt0(i_inf), lum_neb_cont_DISM_unatt0(i_sup), &
                   lambda_cont(i_cont))
!# Units: `lum_stel*`, `lum_neb_cont*` in erg.s-1.angstroem-1.L_sol-1.M_sys-1.

!# Following lines may be needed because the SEDs are extrapolated when `lambda_cont(i_cont) > lambda_stel(i_sup)`:
              lum_stel_SFC_att_gas(i_cont) = min(lum_stel_SFC_att_gas(i_cont), lum_stel_SFC_unatt(i_cont))
              lum_stel_SFC(i_cont) = min(lum_stel_SFC(i_cont), lum_stel_SFC_att_gas(i_cont))
              lum_neb_cont_SFC(i_cont) = min(lum_neb_cont_SFC(i_cont), lum_neb_cont_SFC_unatt(i_cont))
              lum_stel_DISM_att_gas(i_cont) = min(lum_stel_DISM_att_gas(i_cont), lum_stel_DISM_unatt(i_cont))
           endif
        enddo

!# Light emerging from star-forming clouds (if `_unatt`, attenuated only by gas in clouds;
!# otherwise, by gas and dust in clouds):
        lum_cont_unatt(:) = lum_stel_SFC_att_gas(:) + lum_neb_cont_SFC_unatt(:)
        lum_cont(:) = lum_stel_SFC(:) + lum_neb_cont_SFC(:)
        L_line_unatt(:) = L_line_SFC_unatt(:)
        L_line(:) = L_line_SFC(:)
!# (`lum_cont_unatt` <=> `lum_cont_SFC_att_gas`;
!# `lum_neb_cont_SFC_unatt` <=> `lum_neb_cont_SFC_att_gas`;
!# `lum_cont` <=> `lum_cont_SFC`;
!# `L_line_unatt` <=> `L_line_SFC_att_gas`.
!# Units: `lum_cont*` in erg.s-1.angstroem-1.L_sol-1.M_sys-1;
!# `L_line*` in erg.s-1.L_sol-1.M_sys-1.)


!# What about Lyman continuum photons emitted by the HII gas shortward
!# of the Lyman break???
!# Should they be reabsorbed? Here, we assumed they are not...

        tau_V = 0
        M_dust = 0
        L_dust = 0

!# Units: `lum_cont` and `lum_cont_unatt` now in erg.s-1.micrometer-1.M_sys-1:
        lum_cont(:) = lum_cont(:)*L_sol*per_A_to_per_um
        lum_cont_unatt(:) = lum_cont_unatt(:)*L_sol*per_A_to_per_um
!# Units: `L_line` and `L_line_unatt` now in erg.s-1.M_sys-1:
        L_line(:) = L_line(:)*L_sol
        L_line_unatt(:) = L_line_unatt(:)*L_sol

!# Compute dust opacity in star-forming clouds:
        call compute_opacity_SFC(dim_cont, lambda_cont, dim_line, lambda_line, &
             M_dust_SFC, carb_abund(i_time), sil_abund(i_time), &
             dim_species_SFC, grain_abs_SFC, species_weight_SFC, &
             kappa_abs_cont, kappa_abs_line, &
             lum_cont, lum_cont_unatt, L_line, L_line_unatt, &
             cont_trans_SFC, line_trans_SFC)
!# (The extinction by clouds has actually already been computed in subroutine
!# `compute_stellar_spectrum` of "mod_SFC_DISM.f90".)

!# Mean radiation field in star-forming clouds:
        if (CBR) then !# Add cosmic background radiation to the radiation field.
           call compute_RF_SFC(dim_cont, dim_line, dim_species_SFC, &
                grain_abs_SFC, &
                kappa_abs_cont, kappa_abs_line, &
                lambda_cont, lambda_line, M_dust_SFC, &
                lum_cont, lum_cont_unatt, &
                L_line, L_line_unatt, L_dust_SFC, &
                RF_SFC, RF_cont_SFC, RF_line_SFC, T_CBR0*(1+redshift))
        else
           call compute_RF_SFC(dim_cont, dim_line, dim_species_SFC, &
                grain_abs_SFC, &
                kappa_abs_cont, kappa_abs_line, &
                lambda_cont, lambda_line, M_dust_SFC, &
                lum_cont, lum_cont_unatt, &
                L_line, L_line_unatt, L_dust_SFC, &
                RF_SFC, RF_cont_SFC, RF_line_SFC)
        endif

!# Dust emission in star-forming clouds:
        if (dust_emission_SFC) then
           if (grain_output_SFC .and. time >= grain_output_min_age .and. &
                time <= grain_output_max_age) then
              do_output_grain = .true.
              if (grain_temp_output) &
                   write(unit_grain_temp, "(es10.4,tr1,a)") time, "!# Time."
              if (grain_SED_output) &
                   write(unit_grain_SED, "(es10.4,tr1,a)") time, "!# Time."
           else
              do_output_grain = .false.
           endif

           call compute_dust_emission(carb_abund(i_time), sil_abund(i_time), &
                dim_cont, lambda_cont, &
                grain_data_SFC, M_dust_SFC, &
                RF_SFC, lum_species_SFC, &
                dim_species_SFC, species_id_SFC, grain_density_SFC, grain_mean_atomic_mass_SFC, &
                species_weight_SFC, grain_abs_SFC, stoch_heating_SFC, &
                self_abs_power_SFC, cont_trans_SFC, cont_trans_SFC, &
                sublim_lum_species_SFC)
        else !# `dust_extinction_SFC = .false.`.
           lum_species_SFC(:,:) = 0
           sublim_lum_species_SFC(:,:) = 0
        endif

!# Add grain emission from star-forming clouds to `lum_cont`:
        lum_cont(1:dim_cont) = lum_cont(1:dim_cont) + &
             sum(lum_species_SFC(1:dim_species_SFC,1:dim_cont), dim = 1)

!# Add emission from stars and gas in the diffuse medium to `lum_cont` and `L_line`:
        lum_cont(:) = lum_cont(:) &
             + (lum_stel_DISM_att_gas(:) + lum_neb_cont_DISM_unatt(:))*L_sol*per_A_to_per_um
        L_line(:) = L_line(:) + L_line_DISM_unatt(:)*L_sol
!# (`lum_neb_cont_DISM_unatt` <=> `lum_neb_cont_DISM_att_gas`;
!# `L_line_DISM_unatt` <=> `L_line_DISM_att_gas`.
!# The (rare) Lyman continuum photons emitted by grains are neglected:
!# they are not absorbed by gas and do not contribute to nebular emission.)

!# Compute attenuation factors by dust in the diffuse medium:
        call compute_opacity_DISM(ISM_mass(i_time), dim_cont, &
             lambda_cont, dim_line, lambda_line, i_Lyman_alpha, M_dust, &
             carb_abund(i_time), sil_abund(i_time), &
             dim_species_DISM, grain_abs_DISM, &
             species_weight_DISM, &
             tau_V, King, slab, disk, bulge, &
             cont_trans_DISM_tot, cont_trans_DISM_incl, &
             line_trans_DISM_tot, line_trans_DISM_incl, &
             opt_depth_warn_present(i_output_age), &
             opt_depth_warn_min_lambda(i_output_age), &
             opt_depth_warn_max_lambda(i_output_age), &
             kappa_abs_cont, kappa_abs_line, ISM_over_H(i_time))

!# Compute radiation field in the diffuse medium:
        if (CBR) then !# Add cosmic background radiation to the radiation field.
           call compute_RF_DISM(dim_cont, dim_line, dim_species_DISM, &
                grain_abs_DISM, &
                kappa_abs_cont, kappa_abs_line, &
                lambda_cont, lambda_line, L_dust_SFC, M_dust, &
                lum_cont, L_line, cont_trans_DISM_tot, line_trans_DISM_tot, &
                L_dust_DISM, L_dust, RF_DISM, RF_cont_DISM, RF_line_DISM, &
                T_CBR0*(1+redshift))
        else
           call compute_RF_DISM(dim_cont, dim_line, dim_species_DISM, &
                grain_abs_DISM, &
                kappa_abs_cont, kappa_abs_line, &
                lambda_cont, lambda_line, L_dust_SFC, M_dust, &
                lum_cont, L_line, cont_trans_DISM_tot, line_trans_DISM_tot, &
                L_dust_DISM, L_dust, RF_DISM, RF_cont_DISM, RF_line_DISM)
        endif

!# Attenuation by dust in the diffuse medium:
        call attenuate_DISM( &
             lum_cont = lum_cont, &
             L_line = L_line, &
             cont_trans_DISM_incl = cont_trans_DISM_incl, &
             line_trans_DISM_incl = line_trans_DISM_incl, &
             lambda_cont = lambda_cont, &
             Lyman_cont_dust_abs = Lyman_cont_dust_abs, &
             cont_trans_DISM_tot = cont_trans_DISM_tot, &
             i_Lyman_break_cont = i_Lyman_break_cont)

!# Emission from dust in the diffuse medium:
        if (dust_emission_DISM) then
           if (grain_output_DISM .and. time >= grain_output_min_age .and. &
                time <= grain_output_max_age) then
              do_output_grain = .true.
              if (grain_temp_output) &
                   write(unit_grain_temp, "(es10.4,tr1,a)") time, "!# Time."
              if (grain_SED_output) &
                   write(unit_grain_SED, "(es10.4,tr1,a)") time, "!# Time."
           else
              do_output_grain = .false.
           endif

           call compute_dust_emission(carb_abund(i_time), sil_abund(i_time), &
                dim_cont, lambda_cont, &
                grain_data_DISM, M_dust, &
                RF_DISM, lum_species_DISM, &
                dim_species_DISM, species_id_DISM, &
                grain_density_DISM, grain_mean_atomic_mass_DISM, &
                species_weight_DISM, grain_abs_DISM, &
                stoch_heating_DISM, &
                self_abs_power_DISM, cont_trans_DISM_tot, cont_trans_DISM_incl, &
                sublim_lum_species_DISM)
        else
           lum_species_DISM(:,:) = 0
           sublim_lum_species_DISM(:,:) = 0
        endif

!# Add grain emission from the diffuse medium to `lum_cont`:
        do i_cont = 1, dim_cont
           lum_cont(i_cont) = lum_cont(i_cont) + &
                sum(lum_species_DISM(1:dim_species_DISM,i_cont))
        enddo

!# Convert back `lum_cont` to erg.s-1.angstroem-1.M_sys-1:
        lum_cont(:) = lum_cont(:) * per_um_to_per_A

        call compute_various(i_time, convol_time, beta, inv_time, L_bol_SSP, &
             SF_live_d_mass, SSP_Z_weight, L_dust, L_bol, dust_bol_ratio, &
             stel_Z_bol_avrg, stel_age_bol_avrg, &
             stellar_mass_SSP, live_stars_mass, &
             stel_Z_mass_avrg, stel_age_mass_avrg, &
             Lyman_cont_rate, Lyman_cont_gas_abs, Lyman_cont_dust_abs)

        call write_spectra_various(unit_spectra, spectra_output, &
             time, convol_time(i_time), &
             cosmic_time, redshift, &
             galaxy_mass(i_time), live_stars_mass, &
             WD_mass(i_time), BHNS_mass(i_time), &
             inert_mass(i_time), ISM_mass(i_time), ISM_abund(i_time, 0), &
             stel_Z_mass_avrg, stel_Z_bol_avrg, &
             carb_abund(i_time), sil_abund(i_time), &
             ISM_abund(i_time, 1:), L_bol, tau_V, dust_bol_ratio, SF_rate(i_time), &
             Lyman_cont_rate, CCSN_rate(i_time), SNIa_rate(i_time), &
             stel_age_mass_avrg, stel_age_bol_avrg, &
             Lyman_cont_gas_abs, Lyman_cont_dust_abs, &
             ejec_rate_tot(i_time), infall_rate(i_time), &
             outflow_rate(i_time), &
             ejec_cumul_mass(i_time), SF_live_cumul_mass(i_time), &
             infall_cumul_mass(i_time), outflow_cumul_mass(i_time), &
             L_dust_SFC, L_dust_DISM, &
             opt_depth_warn_present(i_output_age), &
             opt_depth_warn_min_lambda(i_output_age), &
             opt_depth_warn_max_lambda(i_output_age))

        call write_spectra_SED(unit_spectra, spectra_output, &
             dim_species_SFC, dim_species_DISM, dim_cont, dim_line, &
             lum_cont, lum_stel_SFC_unatt, lum_stel_DISM_unatt, &
             lum_neb_cont_SFC_unatt, lum_neb_cont_DISM_unatt, &
             lum_species_SFC, lum_species_DISM, &
             L_line, L_line_SFC_unatt, L_line_DISM_unatt, &
             RF_output, RF_cont_SFC, RF_cont_DISM, &
             RF_line_SFC, RF_line_DISM, &
             sublim_output, sublim_lum_species_SFC, &
             sublim_lum_species_DISM)
     end do

!# Warnings:
     call write_spectra_warning(unit_spectra, spectra_file, &
          spectra_output, unit_log, verbosity, output_age, max_dim_reserv, &
          reserv_warn_present, &
          SF_warn_present, SF_warn_age, &
          infall_warn_present, infall_warn_age, &
          outflow_warn_present, outflow_warn_age, &
          opt_depth_warn_present, opt_depth_warn_min_lambda, opt_depth_warn_max_lambda)

!# Close opened files:

     if (unit_spectra >= 0) then
        inquire(unit_spectra, opened = opened)
        if (opened) call close_file(unit_spectra)
     endif

     if (grain_temp_output) then
        inquire(unit_grain_temp, opened = opened)
        if (opened) call close_file(unit_grain_temp)
     endif

     if (grain_SED_output) then
        inquire(unit_grain_SED, opened = opened)
        if (opened) call close_file(unit_grain_SED)
     endif

!# Add the names of output files to the lists of output files of "spectra":

     inquire(file = path_file(spectra_dir, spectra_file), exist = exist)
     if (exist) then
        call open_file(unit, path_file(spectra_dir, spectra_list), &
             status = "old", position = "append", action = "write")
        write(unit, "(a)") trim(spectra_file)
        call close_file(unit)
     endif

     inquire(file = path_file(grain_temp_dir, grain_temp_file), exist = exist)
     if (exist) then
        call open_file(unit, path_file(grain_temp_dir, grain_temp_list), &
             status = "old", position = "append", action = "write")
        write(unit, "(a)") trim(grain_temp_file)
        call close_file(unit)
     endif

     inquire(file = path_file(grain_SED_dir, grain_SED_file), exist = exist)
     if (exist) then
        call open_file(unit, path_file(grain_SED_dir, grain_SED_list), &
             status = "old", position = "append", action = "write")
        write(unit, "(a)") trim(grain_SED_file)
        call close_file(unit)
     endif

!# Prepare things for the next scenario:

     first_scenario = .false.
     SSPs_set_prev = SSPs_set
     SSPs_set_changed = .false.
     stel_lib_set_prev = stel_lib_set
     stel_lib_set_changed = .false.
     grains_file_SFC_prev = grains_file_SFC
     grains_file_SFC_changed = .false.
     grains_file_DISM_prev = grains_file_DISM
     grains_file_DISM_changed = .false.
     ages_file_prev = ages_file
     close_bin_frac_prev = close_bin_frac
  end do !# End loop on scenarios.

  call close_file(unit_scenarios)
  call close_file(unit_log)

end program spectra

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

!# Read the spectral energy distribution (SED) of grains from a file.
!# For grain temperature distributions, see "mod_read_grain_temp.f90".
!#----------------------------------------------------------------------
!# To read these data, create a Fortran 95 code and type in it
!#
!#     `call read_grain_SED(file_name, data)`,
!#
!# where the string of characters denoted by `file_name` is the name of the file
!# and `data` is a structure of type `struct_grain_SED` and must be declared with
!#
!#     `type(struct_grain_SED) :: data`.
!#
!# The line
!#
!#     `use mod_read_grain_SED`
!#
!# must be inserted before all declarations.
!#
!# See file "plot_grain_SED.f90" for an example.
!#
!# To compile the code you created, link it (with the appropriate paths) to
!# "mod_types.f90", "mod_dir_access.f90", "mod_file_access.f90", 
!# "mod_strings.f90", "mod_directories.f90" and "mod_read_grain_SED.f90".
!#----------------------------------------------------------------------
!# The fields of `data` are the following:
!# -- `data % version_id`: code's version;
!# -- `data % version_date`: code's date;
!# -- `data % dim_age_grains`: number of ages
!#    -> index `i_age` hereafter;
!# -- `data % dim_region`: number of regions (star-forming clouds, diffuse 
!#    ISM)
!#    -> index `i_region` hereafter;
!# -- `data % age_grains(i_age)`: age in Myr;
!# -- `data % region(i_region)`: structure for the region #`i_region`.
!#
!# The fields of `data % region(i_region)` are the following:
!# -- `data % region(i_region) % id`: identifier of the region ("SFC" for 
!#    star-forming clouds, "DISM" for the diffuse ISM...;
!# -- `data % region(i_region) % dim_species`: number of grain species (graphite, 
!#    silicate, etc.) for this region
!#    -> index `i_species` hereafter;
!# -- `data % region(i_region) % stoch_heating`: boolean set to `.true.`
!#    if SEDs are computed both for stochastically heated grains (so, with a 
!#    temperature distribution) and at the equilibrium temperature, and to 
!#    `.false.` if SEDs are computed only at the equilibrium temperature;
!# -- `data % region(i_region) % species(i_species)`: structure for the grain species
!#    #`i_species` in the region #`i_region`.
!#
!# The fields of `data % region(i_region) % species(i_species)` are the following:
!# -- `data % region(i_region) % species(i_species) % id`: identifier of the grain species;
!# -- `data % region(i_region) % species(i_species) % dim_lambda`: number of 
!#    wavelengths for the radiation field
!#    -> index `i_lambda` hereafter;
!# -- `data % region(i_region) % species(i_species) % lambda(i_lambda)`: wavelength;
!# -- `data % region(i_region) % species(i_species) % dim_radius`: number of grain 
!#    radii
!#    -> index `i_radius` hereafter;
!# -- `data % region(i_region) % species(i_species) % radius(i_radius)`: radius in 
!#    micrometers;
!# -- `data % region(i_region) % species(i_species) 
!#    % lum_stoch(i_age, i_radius, i_lambda)`: monochromatic luminosity for 
!#    stochastically heated grains (void if `data % region(i_region) 
!#    % stoch_heating` is false);
!# -- `data % region(i_region) % species(i_species) 
!#    % lum_eq(i_age, i_radius, i_lambda)`: monochromatic luminosity for 
!#    grains at equilibrium temperature.

!#======================================================================

module mod_read_grain_SED

  use mod_types

  implicit none

  type :: struct_grain_SED
     character(len=std_string) :: version_id, version_date
     integer :: dim_age_grains, dim_region
     real(CDR), dimension(:), pointer :: age_grains => null()
     type(struct_grain_SED1), dimension(:), pointer :: region => null()
  end type struct_grain_SED

  type :: struct_grain_SED1
     character(len=std_string) :: id
     integer :: dim_species
     logical :: stoch_heating
     type(struct_grain_SED2), dimension(:), pointer :: species => null()
  end type struct_grain_SED1

  type :: struct_grain_SED2
     character(len=std_string) :: id
     integer :: dim_lambda
     real(CDR), dimension(:), pointer :: lambda => null()
     integer :: dim_radius
     real(CDR), dimension(:), pointer :: radius => null()
     real(CDR), dimension(:,:,:), pointer :: lum_stoch => null()
     real(CDR), dimension(:,:,:), pointer :: lum_eq => null()
  end type struct_grain_SED2

contains

!#======================================================================
  
  subroutine read_grain_SED(file_name, data)

    use mod_directories, only : grain_SED_dir
    use mod_file_access

    implicit none
    character(len=*), intent(in) :: file_name
    type(struct_grain_SED), intent(out) :: data
!#......................................................................
    integer :: i_species, i_age, i_region, i_radius, eff_dim_species
    integer :: unit
    integer :: dim_age_grains, dim_species, dim_lambda, dim_radius, dim_region
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call open_file(unit, path_file(grain_SED_dir, file_name))
    read(unit,*) data % version_id
    read(unit, *) data % version_date
    call skip_comment_lines(unit)
    read(unit,*) dim_age_grains, dim_region
    data % dim_age_grains = dim_age_grains
    data % dim_region = dim_region
    allocate(data % age_grains(dim_age_grains))
    allocate(data % region(dim_region))
    do i_region = 1, dim_region
       read(unit,*) data % region(i_region) % id, dim_species, &
            data % region(i_region) % stoch_heating
       data % region(i_region) % dim_species = dim_species
       allocate(data % region(i_region) % species(dim_species))
       do i_species = 1, data % region(i_region) % dim_species
          read(unit,*) data % region(i_region) % species(i_species) % id, &
               dim_lambda
          data % region(i_region) % species(i_species) % dim_lambda = dim_lambda
          allocate(data % region(i_region) % species(i_species) &
               % lambda(dim_lambda))
          read(unit,*) data % region(i_region) % species(i_species) % lambda(:)
       enddo
    enddo

    do i_age = 1, data % dim_age_grains
       do i_region = 1, data % dim_region
          read(unit,*) data % age_grains(i_age)
          read(unit,*) eff_dim_species
          if (eff_dim_species > 0) then
             do i_species = 1, data % region(i_region) % dim_species
                read(unit,*) dim_radius
                data % region(i_region) % species(i_species) % dim_radius = &
                     dim_radius
                if (i_age == 1) then
                   allocate(data % region(i_region) % species(i_species) &
                        % radius(dim_radius))
                   dim_lambda = data % region(i_region) % species(i_species) &
                        % dim_lambda
                   if (data % region(i_region) % stoch_heating) then
                      allocate(data % region(i_region) % species(i_species) &
                           % lum_stoch(dim_age_grains, dim_radius, dim_lambda))
                   endif
                   allocate(data % region(i_region) % species(i_species) &
                        % lum_eq(dim_age_grains, dim_radius, dim_lambda))
                end if
                do i_radius = 1, dim_radius
                   read(unit,*) data % region(i_region) % species(i_species) &
                        % radius(i_radius)
                   if (data % region(i_region) % stoch_heating) then
                      read(unit,*) data % region(i_region) % species(i_species) &
                           % lum_stoch(i_age, i_radius, :)
                   endif
                   read(unit,*) data % region(i_region) % species(i_species) &
                        % lum_eq(i_age, i_radius, :)
                enddo
             enddo
          else

          endif
       enddo
    enddo
    call close_file(unit)

  end subroutine read_grain_SED

end module mod_read_grain_SED

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_constants

  use mod_types
  implicit none
  private

!# Mathematical constants:
  real(CDR), parameter, public :: pi = 3.1415926535_CDR

!# Unit conversion factors
!# (A = angstroem, um = micrometer, cm = centimeter):
  real(CDR), parameter, public :: in_um_to_in_A = 1.e4_CDR, &
       per_A_to_per_um = in_um_to_in_A, &
       in_A_to_in_um = 1/in_um_to_in_A, &
       per_um_to_per_A = in_A_to_in_um
  real(CDR), parameter, public :: in_um_to_in_cm = 1.e-4_CDR, &
       per_cm_to_per_um = in_um_to_in_cm, &
       in_cm_to_in_um = 1/in_um_to_in_cm, &
       per_um_to_per_cm = in_cm_to_in_um, &
       um_to_cm = in_um_to_in_cm

!# Physical constants:
  real(CDR), parameter, public :: c_um = 2.99792458e14_CDR, &
       c_ang = c_um * in_um_to_in_A, &
       c_cm = c_um * in_um_to_in_cm !# Speed of light.
  real(CDR), parameter, public :: h_Planck = 6.62606876e-27_CDR !# Planck constant \
!# in erg.s.
  real(CDR), parameter, public :: kB = 1.3806503e-16_CDR !# Boltzmann constant \
!# in erg.K-1.
  real(CDR), parameter, public :: H_atom_mass = 1.67353e-24_CDR !# Mass of the \
!# hydrogen atom in g.
  real(CDR), parameter, public :: h_c = h_Planck*c_um
  real(DPR), parameter, public :: parsec = 3.08568e18_DPR !# 1 parsec in cm.
  real(DPR), parameter, public :: area_10pc = 4*pi*(10*parsec)**2 !# Area in cm^2 \
!# of a sphere of radius = 10 pc.

!# 1 km/s/Mpc in Myr^-1 (for `H_0`):
  real(CDR), parameter, public :: H_0_unit = 1e3*365.25*24*3600/(1e6*parsec*1e-2)*1e6

!# Wavelength of the Lyman break:
  real(CDR), parameter, public :: lambda_Lyman_break_A = 911.7643_CDR !# \
!# In angstroems (from the value of R_H given by doc hazy2 of Cloudy, Sec. 4.7).
  real(CDR), parameter, public :: lambda_Lyman_break_um = &
       lambda_Lyman_break_A * in_A_to_in_um !# In micrometers.

!# Astronomical constants:
  real(CDR), parameter, public :: M_sol = 1.989e33_CDR !# Mass of the Sun in g.
  real(CDR), parameter, public :: L_sol = 3.826e33_CDR !# Bolometric luminosity \
!# of the Sun in erg.s-1.
  real(CDR), parameter, public :: Y_prim = 0.23_CDR, Z_prim = 0 !# Primordial \
!# abundances of helium and metals (in mass fraction).

!# Chemical elements:
  integer, parameter, public :: dim_elem = 10
  character(len=std_string), dimension(dim_elem), parameter, public :: &
       elem_id = (/"O ", "C ", "Fe", "He", "N ", "Ne", "Mg", "Si", "S ", &
       "Ca"/)
  real(DPR), parameter, public :: A_C12 = 12._DPR, A_C13 = 13._DPR, &
       A_C14 = 14._DPR, A_O16 = 16._DPR, A_O17 = 17._DPR, A_O18 = 18._DPR, &
       A_Mg24 = 24._DPR, A_Si28 = 28._DPR, A_S32 = 32._DPR, A_Ca40 = 40._DPR, &
       A_Ti48 = 48._DPR, A_Fe56 = 56._DPR !# Atomic masses.

  character(len=std_string), parameter, public :: solar_abundances = "Anders_Grevesse_1989.txt"

  character(len=std_string), parameter, public :: neb_set = "neb_set.txt"

  character(len=std_string), parameter, public :: &
       spectra_list = "list_spectra.txt", &
       grain_temp_list = "list_grain_temp.txt", &
       grain_SED_list = "list_grain_SED.txt"

end module mod_constants

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_RT

  use mod_types

  implicit none
  private
    
  type :: struct_RT_sph_sym !# Radiative transfer for a spherically symmetric distribution \
!#                             of dust and stars.
     integer :: dim_tau = 0, dim_alb = 0, dim_asym = 0
     real(CDR), dimension(:), pointer :: tau => null()
     real(CDR), dimension(:), pointer :: alb => null()
     real(CDR), dimension(:), pointer :: asym => null()
     real(CDR), dimension(:,:,:), pointer :: ln_trans_tot => null()
  end type struct_RT_sph_sym
  
  type :: struct_RT_cyl_sym !# Radiative transfer for a cylindrically symmetric \
!#                             distribution of dust and stars.
     integer :: dim_tau = 0, dim_alb = 0, dim_asym = 0, dim_inclin = 0
     real(CDR), dimension(:), pointer :: tau => null()
     real(CDR), dimension(:), pointer :: alb => null()
     real(CDR), dimension(:), pointer :: asym => null()
     real(CDR), dimension(:), pointer :: inclin => null()
     real(CDR), dimension(:, :, :), pointer :: ln_trans_tot => null()
     real(CDR), dimension(:, :, :, :), pointer :: ln_trans_incl => null()
  end type struct_RT_cyl_sym
  
  public :: read_RT_data, struct_RT_sph_sym, struct_RT_cyl_sym

contains

!#======================================================================
  
  subroutine read_RT_data(King, &
       slab, disk, bulge)

    use mod_types
    use mod_directories, only : RT_dir
    use mod_file_access, only : open_file, close_file, path_file
    
    implicit none
    type(struct_RT_sph_sym), intent(out) :: King
    type(struct_RT_cyl_sym), intent(out) :: slab, disk, bulge
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
!# Read extinction parameters for the "slab" model.
    call read_RT_cyl_sym(path_file(RT_dir, "slab_transmit.txt"), slab)

!# Read extinction parameters for the "spiral" model.
    call read_RT_cyl_sym(path_file(RT_dir, "disk_transmit.txt"), disk)
    call read_RT_cyl_sym(path_file(RT_dir, "bulge_transmit.txt"), bulge)
    
!# Read extinction parameters for the King model.
    call read_RT_sph_sym(path_file(RT_dir, "King_transmit.txt"), King)

  end subroutine read_RT_data

!#======================================================================

  subroutine read_RT_cyl_sym(file, data)

    use mod_file_access, only : open_file, close_file
    
    implicit none
    character(len=*), intent(in) :: file
    type(struct_RT_cyl_sym), intent(out) :: data
!#......................................................................    
    integer :: unit, i1, i2, i3, i4
    real(CDR), dimension(:, :, :), allocatable :: trans_tot
    real(CDR), dimension(:, :, :, :), allocatable :: trans_incl
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call open_file(unit, file)
    read(unit,*) data % dim_tau, data % dim_alb, data % dim_asym, data % dim_inclin
    if (associated(data % tau)) deallocate(data % tau) 
    allocate(data % tau(data % dim_tau))
    if (associated(data % alb)) deallocate(data % alb) 
    allocate(data % alb(data % dim_alb))
    if (associated(data % asym)) deallocate(data % asym) 
    allocate(data % asym(data % dim_asym))
    if (associated(data % ln_trans_tot)) deallocate(data % ln_trans_tot) 
    allocate(data % ln_trans_tot(data % dim_tau, data % dim_alb, data % dim_asym))
    if (associated(data % inclin)) deallocate(data % inclin) 
    allocate(data % inclin(data % dim_inclin))
    if (associated(data % ln_trans_incl)) deallocate(data % ln_trans_incl) 
    allocate(data % ln_trans_incl(data % dim_tau, data % dim_alb, data % dim_asym, &
         data % dim_inclin))

    allocate(trans_tot(data % dim_tau, data % dim_alb, data % dim_asym))
    allocate(trans_incl(data % dim_tau, data % dim_alb, data % dim_asym, &
         data % dim_inclin))
    
    do i1 = 1, data % dim_tau
       do i2 = 1, data % dim_alb
          read(unit, *) data % tau(i1), data % alb(i2), (data % asym(i3), i3 = 1, &
               data % dim_asym)
          read(unit, *) (trans_tot(i1, i2, i3), i3 = 1, data % dim_asym)
          do i4 = 1, data % dim_inclin
             read(unit, *) data % inclin(i4), &
                  (trans_incl(i1, i2, i3, i4), i3 = 1, data % dim_asym)
          enddo
       end do
    end do
    where(trans_tot > tiny(1.))
       data % ln_trans_tot = log(trans_tot)
    elsewhere
       data % ln_trans_tot = -huge(1.) 
    end where
    where(trans_incl > tiny(1.))
       data % ln_trans_incl = log(trans_incl)
    elsewhere
       data % ln_trans_incl = -huge(1.)
    end where

    deallocate(trans_tot, trans_incl)
    call close_file(unit)

  end subroutine read_RT_cyl_sym

!#======================================================================

  subroutine read_RT_sph_sym(file, data)

    use mod_file_access, only : open_file, close_file
    
    implicit none
    character(len=*), intent(in) :: file
    type(struct_RT_sph_sym), intent(out) :: data
!#......................................................................
    integer :: unit, i1, i2, i3
    real(CDR), dimension(:, :, :), allocatable :: trans_tot
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call open_file(unit, file)
    read(unit,*) data % dim_tau, data % dim_alb, data % dim_asym
    if (associated(data % tau)) deallocate(data % tau) 
    allocate(data % tau(data % dim_tau))
    if (associated(data % alb)) deallocate(data % alb) 
    allocate(data % alb(data % dim_alb))
    if (associated(data % asym)) deallocate(data % asym) 
    allocate(data % asym(data % dim_asym))
    if (associated(data % ln_trans_tot)) deallocate(data % ln_trans_tot) 
    allocate(data % ln_trans_tot(data % dim_tau, data % dim_alb, data % dim_asym))

    allocate(trans_tot(data % dim_tau, data % dim_alb, data % dim_asym))

    do i1 = 1, data % dim_tau
       do i2 = 1, data % dim_alb
          do i3 = 1, data % dim_asym
             read(unit, *) data % tau(i1), data % alb(i2), data % asym(i3), &
                  trans_tot(i1, i2, i3)
          end do
       end do
    end do
    where(trans_tot > tiny(1.))
       data % ln_trans_tot = log(trans_tot)
    elsewhere
       data % ln_trans_tot = -huge(1.)
    end where
    
    deallocate(trans_tot)
    call close_file(unit)

  end subroutine read_RT_sph_sym

end module mod_RT

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

program SSPs

  use mod_types
  use mod_convert_type
  use mod_strings
  use mod_directories, only : tracks_dir, SSPs_dir, stel_lib_dir, ages_dir, &
       yields_dir, IMFs_dir, bin_dir
  use mod_dir_access, only : dir_sep
  use mod_select_file, only : select_single_file
  use mod_read_file_list, only : read_file_list
  use mod_constants, only : dim_elem, elem_id
  use mod_SSPs_constants, only : tracks_sets_list, SSPs_ages_list, &
       yields_list, &
       d_l10_m_ejec, SSPs_sets_list, stel_lib_sets_list, &
       P2_metal_conv, P2_Z_Sun
  use mod_IMF, only : choose_IMF, LN_C1, LN_C2
  use mod_stel_lib, only : SSP_read_stel_lib, struct_stel_lib
  use mod_tracks, only : read_tracks, connect_tracks, white_dwarfs_tracks, &
       struct_track
  use mod_yields, only : read_yields, compute_yields, fn_IRA_yield, struct_yield
  use mod_isochrone, only : compute_isochrone, compute_isochrone_WD, struct_isoch
  use mod_remnants_ejec_SN, only : isolated_stars, close_binaries, &
       reset_remnants_ejec_SN
  use mod_SSP_emission, only : SSP_emission
  use mod_file_access, only : open_file, close_file, path_file, extract_path, &
       base_name
  use mod_interp, only : bracket, interp_lin_lin
  use mod_SSPs_ages
  use mod_code_version, only : version_id, version_date
  use mod_compiler, only : compiler
  use mod_ISO_8601, only : ISO_8601

  implicit none
!#......................................................................
  integer :: dim_time_SSP
  real(CDR), dimension(:), pointer :: time_SSP => null()
  real(CDR) :: time_step
  character(std_string) :: IMF_file
  integer :: IMF_dim_slope
  real(DPR), dimension(:), pointer :: IMF_bin_coeff => null(), &
       IMF_bin_bottom_mass => null(), IMF_bin_slope => null()
  real(DPR) :: IMF_mass_min, IMF_mass_max, IMF_norm

  character(std_string) :: SSP_file, SSPs_set, yields_set
  character(std_string) :: SSPs_ages_file
  character(long_string) :: prefix
  integer :: i_bin, n_bins, unit, unit2
  integer :: i_time, i_tracks_file
  real(CDR) :: time
  integer :: dim_isoch !# Not used currently, but might be useful if \
!# isochrones were output. ???
  type(struct_isoch) :: isoch
  type(struct_isoch), pointer :: isoch_node
  real(DPR) :: top_isoch_mass
  real(DPR) :: d_l10_m, l10_mass
  real(DPR) :: m_end, IRA_yield
  integer :: i_SL, i_spec, n_used_SL
  type(irreg_array_int), dimension(:), allocatable :: used_spec
  logical, dimension(:), allocatable :: used_SL
  real(DPR) :: HI_rate_SSP, HeI_rate_SSP, HeII_rate_SSP, &
       HI_power_SSP, HeI_power_SSP, HeII_power_SSP, L_bol_tot
  type(irreg_array_DPR), dimension(:), allocatable :: L_spec
  real(DPR) :: nb_CCSN_IS, nb_CCSN_CB, nb_SNIa
  real(DPR) :: ejec_carb_LMW_IS, &
       ejec_sil_LMW_IS, ejec_carb_HMW_IS, ejec_sil_HMW_IS, &
       ejec_carb_CCSN_IS, ejec_sil_CCSN_IS
  real(DPR) :: ejec_carb_LMW_CB, &
       ejec_sil_LMW_CB, ejec_carb_HMW_CB, ejec_sil_HMW_CB, &
       ejec_carb_CCSN_CB, ejec_sil_CCSN_CB, &
       ejec_carb_SNIa, ejec_sil_SNIa

  real(DPR) :: ejec_dust_O_LMW_IS, ejec_dust_O_HMW_IS, &
       ejec_dust_O_CCSN_IS
  real(DPR) :: ejec_dust_O_LMW_CB, ejec_dust_O_HMW_CB, &
       ejec_dust_O_CCSN_CB, ejec_dust_O_SNIa

  real(DPR) :: mass_BHNS_IS, mass_BHNS_CB, mass_WD_IS, mass_WD_CB
  integer, dimension(:), pointer :: dim_spec => null()
  real(DPR), dimension(:), allocatable :: P2_Z_SL
  real(DPR), dimension(:), pointer :: M_over_H_SL => null(), &
       T_SL_max => null(), &
       T_SL_min => null()
  integer :: dim_SL, dim_low_T, dim_high_T
  type(struct_stel_lib), dimension(:), pointer :: stel_lib => null()
  integer :: dim_elem_SNIa, dim_elem_sol
  type(struct_yield), dimension(:), pointer :: yield_LMW => null(), &
       yield_HMW => null(), &
       yield_CCSN => null()
  real(DPR), dimension(:), pointer :: gross_ejec_SNIa => null()
  character(len=std_string), dimension(:), pointer :: elem_SNIa => null()
  real(DPR), dimension(:), pointer :: abund_sol => null()
  character(len=std_string), dimension(:), pointer :: elem_sol => null()
  integer :: dim_tracks_file
  integer :: dim_mass_yields
  real(DPR) :: carb_dust_SNIa, sil_dust_SNIa, O_dust_SNIa
  real(DPR), dimension(:), pointer :: ejec_tot => null()
  real(DPR), dimension(:, :), pointer :: ejec_elem => null()
  real(DPR), dimension(:), pointer :: mass_yields => null(), &
       carb_dust_LMW => null(), &
       sil_dust_LMW => null(), &
       carb_dust_HMW => null(), &
       sil_dust_HMW => null(), &
       carb_dust_CCSN => null(), &
       sil_dust_CCSN => null(), &
       O_dust_LMW => null(), &
       O_dust_HMW => null(), &
       O_dust_CCSN => null()
  real(DPR) :: ejec_tot_SNIa
  real(DPR), dimension(0:dim_elem) :: ejec_elem_SNIa
  real(DPR) :: ejec_tot_IS, ejec_tot_CB

  real(DPR), dimension(0:dim_elem) :: ejec_elem_IS, ejec_elem_CB

  character(std_string), dimension(:), pointer :: tracks_file => null()

  integer :: n_MS, n_He_flash, n_HB, n_VLM, dim_age_WD
  real(DPR) :: Y_track, Z_track, M_over_H_track, min_mass_CCSN, mass_Ch, X_sol, Y_sol, Z_sol
  type(struct_track), dimension(:), pointer :: std_track => null()
  integer :: dim_WD
  type(struct_track), dimension(:), pointer :: WD_track => null()

  character(len=std_string) :: tracks_set, stel_lib_set, answer

  integer :: i_elem
  logical :: exist, prefix_dir

  integer :: unit_compiler
  integer :: length
  character(len=25) :: run_begin_time
  character(len=14) :: time_stamp_value
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Create time-stamp:
  call ISO_8601(local_time_extended = run_begin_time, UTC_time_basic = time_stamp_value)
  write(*,"(/a,a)") "Time-stamp: ", quote_string(time_stamp_value)

  call open_file(unit_compiler, path_file(bin_dir, "compil_SSPs.txt"))
  read(unit_compiler,*) compiler
  call close_file(unit_compiler)

  write(*, "(/a)") "When a default value is proposed, press the &
       &<RETURN>/<ENTER> key to select it."

  write(*, "(/a)") repeat("=",80)
  write(*, "(a)") "Initial mass function?"
  call select_single_file(dir = IMFs_dir, list = "list_IMFs.txt", &
       selected_file = IMF_file, object = "IMF", objects = "IMFs", &
       print_first_line = .true.)
  call choose_IMF(IMF_file, IMF_dim_slope, IMF_bin_coeff, IMF_bin_bottom_mass, &
       IMF_bin_slope, IMF_mass_min, IMF_mass_max, IMF_norm)

  write(*, "(/a)") repeat("=",80)
  write(*, "(a)") "Set of evolutionary tracks?"
  call select_single_file(dir = tracks_dir, list = tracks_sets_list, &
       selected_file = tracks_set, object = "set of tracks", &
       objects = "sets of tracks")
  call read_file_list(dir = tracks_dir, list = tracks_set, &
       file = tracks_file, n_files = dim_tracks_file)

  write(*, "(/a)") repeat("=",80)
  write(*, "(a)") "Set of yields for high-mass stars?"
  call select_single_file(dir = yields_dir, list = yields_list, &
       selected_file = yields_set, object = "set of yields", &
       objects = "sets of yields")

  call read_yields(yields_set, &
       mass_Ch, dim_elem_SNIa, gross_ejec_SNIa, elem_SNIa, &
       X_sol, Y_sol, Z_sol, dim_elem_sol, abund_sol, elem_sol, dim_tracks_file, &
       yield_LMW, yield_HMW, yield_CCSN)

  write(*, "(/a)") repeat("=",80)
  write(*, "(a)") "Set of stellar libraries?"
  call select_single_file(dir = stel_lib_dir, list = stel_lib_sets_list, &
       selected_file = stel_lib_set, object="set of stellar libraries", &
       objects="sets of stellar libraries")
  call SSP_read_stel_lib(dim_low_T, dim_high_T, stel_lib, &
       M_over_H_SL, dim_SL, T_SL_max, T_SL_min, dim_spec, stel_lib_set)

  if (allocated(used_spec)) deallocate(used_spec)
  allocate(used_spec(dim_SL))
  do i_SL = 1, dim_SL
     if (associated(used_spec(i_SL) % val)) deallocate(used_spec(i_SL) % val)
     allocate(used_spec(i_SL) % val(dim_spec(i_SL)))
     used_spec(i_SL) % val(:) = 0
  enddo

  if (allocated(used_SL)) deallocate(used_SL)
  allocate(used_SL(dim_SL))

  if (allocated(L_spec)) deallocate(L_spec)
  allocate(L_spec(dim_SL))
  do i_SL = 1, dim_SL
     if (associated(L_spec(i_SL) % val)) deallocate(L_spec(i_SL) % val)
     allocate(L_spec(i_SL) % val(0:dim_spec(i_SL)))
  enddo

  if (allocated(P2_Z_SL)) deallocate(P2_Z_SL)
  allocate(P2_Z_SL(dim_SL))

  P2_Z_SL(:) = P2_Z_Sun * 10**M_over_H_SL(:)

  write(*, "(/a)") repeat("=",80)
  write(*, "(a)") "File defining the output ages of code ""SSPs""?"
  call select_single_file(dir = ages_dir, list = SSPs_ages_list, &
       selected_file = SSPs_ages_file, object = "sequence of ages", &
       objects = "sequences of ages")
  call read_SSPs_ages(SSPs_ages_file, time_step, dim_time_SSP, time_SSP)

  write(*, "(/a)") repeat("=",80)
  write(*, "(a)") "Identifier prefixed to the output files of code ""SSPs""?"
  write(*,"(a,a)") "Default: ", quote_string(time_stamp_value)
  prefix_loop: do
     read(*, "(a)") prefix
     prefix = unquote_string(prefix)
     if (prefix == "") prefix = time_stamp_value

     prefix_dir = .false.
     length = len_trim(prefix)
     if (length > 0) then
        if (prefix(length:length) == dir_sep) then
           prefix_dir = .true.
        endif
     endif
     if (prefix_dir) then
        inquire(file = path_file(SSPs_dir, prefix), exist=exist)
        if (.not.exist) then
           write(*, "(a)") "Directory """ // &
                trim(extract_path(SSPs_dir, prefix)) // &
                """ does not exist yet."
           write(*, "(a/a)") "Please create it by yourself; " // &
                "once created, press the <RETURN/ENTER> key to continue.", &
                "Otherwise, press <TAB>, then <RETURN> to select another &
                &prefix/directory."
           do
              read(*,"(a)") answer
              if (answer == "") then
                 inquire(file = path_file(SSPs_dir, prefix), exist=exist)
                 if (.not.exist) then
                    write(*, "(a)") "Directory """ // &
                         trim(extract_path(SSPs_dir, prefix)) // &
                         """ has not been created."
                    write(*, "(a/a)") "Please create it by yourself; " // &
                         "once created, press the <RETURN/ENTER> key to &
                         &continue.", &
                         "Otherwise, press <TAB>, then <RETURN> to select &
                         &another prefix/directory."
                    cycle
                 else
                    exit
                 endif
              else if (answer == HT) then
                 write(*, "(a)") "Identifier prefixed to the output files &
                      &of code ""SSPs""?"
                 cycle prefix_loop
              else
                 write(*,"(a)") "Press either the <RETURN/ENTER> key &
                      &to continue, or <TAB>, then <RETURN> to select another &
                      &prefix/directory!"
                 cycle
              endif
           enddo
        endif
        SSPs_set = trim(prefix) // "SSPs.txt"
     else
        SSPs_set = trim(prefix) // "_SSPs.txt"
     endif
     inquire(file = path_file(SSPs_dir, SSPs_set), exist=exist)
     if (.not.exist) then
        exit
     else !# File already exists.
        write(*, "(a)") "File """ // trim(base_name(SSPs_set)) // &
             """ already exists in directory """ // &
             trim(extract_path(SSPs_dir, SSPs_set)) // &
             """. Please enter another identifier to prefix the &
             &output files."
     endif
  enddo prefix_loop

  write(*, "(/a/)") repeat("*", 80)

!# Add the name of the new set of SSPs to the list of SSPs sets.
  call open_file(unit, path_file(SSPs_dir, SSPs_sets_list), status = "old", &
       position = "append", action = "write")
  write(unit, "(a)") trim(SSPs_set)
  call close_file(unit)

  call open_file(unit, path_file(SSPs_dir, SSPs_set), status = "new")
  write(unit, "(a)") quote_string(version_id) // " !# `version_id`."
  write(unit, "(a)") quote_string(version_date) // " !# `version_date`."
  write(unit, "(a)") "!# Code ""SSPs"" executed at " // trim(run_begin_time) // "."
  write(unit, "(a)") quote_string(stel_lib_set) // " !# Set of stellar spectra."
  write(unit, "(a)") "!# Files of SSPs:"

  do i_tracks_file = 1, dim_tracks_file
     write(*, "(a)") "Calculations for track """ // &
          trim(adjustl(tracks_file(i_tracks_file))) // """."

     used_SL(:) = .false.

     call read_tracks(tracks_file(i_tracks_file), X_sol, Z_sol, &
          n_MS, n_He_flash, n_HB, n_VLM, dim_age_WD, &
          Y_track, Z_track, M_over_H_track, &
          min_mass_CCSN, std_track)

     call connect_tracks(n_MS, n_VLM, n_He_flash, n_HB, dim_age_WD, &
          std_track)

     call white_dwarfs_tracks(dim_WD, n_MS, n_HB, n_VLM, n_He_flash, &
          dim_age_WD, &
          WD_track, std_track)

     call compute_yields(i_tracks_file, Y_track, Z_track, yields_set, &
          yield_LMW, yield_HMW, yield_CCSN, &
          gross_ejec_SNIa, elem_SNIa, &
          mass_Ch, Z_sol, abund_sol, elem_sol, &
          dim_mass_yields, mass_yields, ejec_tot, ejec_elem, ejec_tot_SNIa, &
          ejec_elem_SNIa, carb_dust_LMW, &
          sil_dust_LMW, carb_dust_HMW, sil_dust_HMW, carb_dust_CCSN, sil_dust_CCSN, &
          carb_dust_SNIa, sil_dust_SNIa, &
          O_dust_LMW, O_dust_HMW, O_dust_CCSN, O_dust_SNIa)

!# Indicative value of the total yield of metals, assuming instantaneous recycling (IRA).

     IRA_yield = fn_IRA_yield(IMF_file, IMF_dim_slope, IMF_bin_coeff, &
          IMF_bin_bottom_mass, IMF_bin_slope, &
          IMF_mass_min, IMF_mass_max, dim_mass_yields, mass_yields, ejec_tot(1:dim_mass_yields), &
          ejec_elem(1:dim_mass_yields, 0), IMF_norm)

     if (prefix_dir) then
        SSP_file = trim(prefix) // tracks_file(i_tracks_file)
     else
        SSP_file = trim(prefix) // "_" // tracks_file(i_tracks_file)
     endif

     call open_file(unit2, path_file(SSPs_dir, SSP_file), status = "new")
     write(unit, "(a)") quote_string(SSP_file)
     write(unit2, "(a)") quote_string(version_id) // " !# `version_id`."
     write(unit2, "(a)") quote_string(version_date) // " !# `version_date`."
     write(unit2, "(a)") "!# Code ""SSPs"" executed at " // trim(run_begin_time) // "."
     write(unit2, "(a)") "!# Compiler for ""SSPs"": " // &
          trim(compiler) // "."
     write(unit2, "(a)") "!# Ages: " // quote_string(SSPs_ages_file) // "."
     write(unit2, "(a)") "!# Evolutionary tracks: " // &
          quote_string(tracks_file(i_tracks_file)) // "."
     write(unit2, "(a,f7.4,a)") "!# Metallicity (mass fraction): ", Z_track, "."
     write(unit2, "(a)") "!# High-mass yields: " // &
          quote_string(yields_set) // "."
     write(unit2, "(a)") "!# Initial mass function: " // quote_string(IMF_file) // &
          " from " // to_string(IMF_mass_min,fmt="(f6.2)") // &
          " to " // to_string(IMF_mass_max,fmt="(f6.2)") // " solar masses."
     if (IMF_file == "IMF_log_normal.txt") then
        write(unit2, "(a)") "!# `LN_C1` = " // to_string(LN_C1) // "."
        write(unit2, "(a)") "!# `LN_C2` = " // to_string(LN_C2) // "."
     endif

     write(unit2, "(a)") "!# Set of stellar spectra: " // &
          quote_string(stel_lib_set) // "."

     write(unit2, "(f7.4,tr1, i5, 2(tr1, f10.4), tr1, i2, tr1, es10.3)") &
          Z_track, dim_time_SSP, time_step, time_SSP(dim_time_SSP), dim_elem, IRA_yield

     write(unit2, "(" // int_to_string(dim_elem) // "(a,tr1))") &
          (quote_string(elem_id(i_elem)), i_elem = 1, dim_elem)

!# Computation of the isochrones.
!# `time` in Myr
     m_end = std_track(n_MS) % l10_init_mass

     do i_time = 1, dim_time_SSP
        time = time_SSP(i_time)

        call compute_isochrone(time, dim_isoch, isoch, isoch_node, &
             top_isoch_mass, std_track, n_VLM, n_He_flash, n_MS, n_HB)

        if (10**top_isoch_mass > WD_track(1) % init_mass) then
           call compute_isochrone_WD(time, dim_isoch, isoch, isoch_node, &
                dim_WD, WD_track, dim_age_WD)
        end if

        if (P2_metal_conv) then !# Use Pégase.2 conversion of metallicity of \
!#                                 stellar spectra.
           call SSP_emission(Z_track, IMF_file, IMF_dim_slope, &
                IMF_bin_coeff, IMF_bin_bottom_mass, IMF_bin_slope, &
                IMF_mass_min, IMF_mass_max, IMF_norm, &
                dim_isoch, isoch, &
                HI_rate_SSP, HeI_rate_SSP, HeII_rate_SSP, &
                HI_power_SSP, HeI_power_SSP, HeII_power_SSP, L_bol_tot, &
                L_spec, &
                dim_low_T, P2_Z_SL, dim_SL, T_SL_max, T_SL_min, &
                dim_spec, stel_lib)
        else !# Pégase.3 default.
           call SSP_emission(M_over_H_track, IMF_file, IMF_dim_slope, &
                IMF_bin_coeff, IMF_bin_bottom_mass, IMF_bin_slope, &
                IMF_mass_min, IMF_mass_max, IMF_norm, &
                dim_isoch, isoch, &
                HI_rate_SSP, HeI_rate_SSP, HeII_rate_SSP, &
                HI_power_SSP, HeI_power_SSP, HeII_power_SSP, L_bol_tot, &
                L_spec, &
                dim_low_T, M_over_H_SL, dim_SL, T_SL_max, T_SL_min, &
                dim_spec, stel_lib)
        endif

        call reset_remnants_ejec_SN(nb_CCSN_IS, nb_CCSN_CB, nb_SNIa, &
             ejec_tot_IS, ejec_elem_IS, ejec_tot_CB, ejec_elem_CB, &
             ejec_carb_LMW_IS, ejec_sil_LMW_IS, &
             ejec_carb_HMW_IS, ejec_sil_HMW_IS, &
             ejec_carb_CCSN_IS, ejec_sil_CCSN_IS, &
             ejec_carb_LMW_CB, ejec_sil_LMW_CB, &
             ejec_carb_HMW_CB, ejec_sil_HMW_CB, &
             ejec_carb_CCSN_CB, ejec_sil_CCSN_CB, &
             ejec_carb_SNIa, ejec_sil_SNIa, &
             ejec_dust_O_LMW_IS, ejec_dust_O_HMW_IS, &
             ejec_dust_O_CCSN_IS,ejec_dust_O_LMW_CB, &
             ejec_dust_O_HMW_CB, ejec_dust_O_CCSN_CB, &
             ejec_dust_O_SNIa, &
             mass_BHNS_IS, &
             mass_BHNS_CB, mass_WD_IS, mass_WD_CB)

        n_bins = int((m_end-top_isoch_mass)/d_l10_m_ejec+1)
        d_l10_m = (m_end-top_isoch_mass)/n_bins
        do i_bin = 0, n_bins-1
           l10_mass = top_isoch_mass+(i_bin+0.5_DPR)*d_l10_m

           call isolated_stars(l10_mass, d_l10_m, IMF_file, IMF_dim_slope, &
                IMF_bin_coeff, IMF_bin_bottom_mass, &
                IMF_bin_slope, IMF_mass_min, IMF_mass_max, IMF_norm, &
                ejec_tot_IS, ejec_elem_IS, &
                ejec_carb_LMW_IS, ejec_sil_LMW_IS, &
                ejec_carb_HMW_IS, ejec_sil_HMW_IS, &
                ejec_carb_CCSN_IS, ejec_sil_CCSN_IS, &
                ejec_dust_O_LMW_IS, ejec_dust_O_HMW_IS, &
                ejec_dust_O_CCSN_IS, &
                nb_CCSN_IS, mass_BHNS_IS, mass_WD_IS, dim_mass_yields, mass_yields, ejec_tot, ejec_elem, &
                carb_dust_LMW, sil_dust_LMW, carb_dust_HMW, sil_dust_HMW, &
                carb_dust_CCSN, sil_dust_CCSN, &
                O_dust_LMW, O_dust_HMW, O_dust_CCSN, &
                min_mass_CCSN)

!# Note: there is some inconsistency here: close binaries are taken into
!# account for the chemical evolution, but not for the spectral evolution. !!!

           call close_binaries(l10_mass, d_l10_m, IMF_file, IMF_dim_slope, &
                IMF_bin_coeff, IMF_bin_bottom_mass, &
                IMF_bin_slope, IMF_mass_min, IMF_mass_max, IMF_norm, mass_Ch, &
                ejec_tot_CB, ejec_elem_CB, &
                ejec_carb_LMW_CB, ejec_sil_LMW_CB, &
                ejec_carb_HMW_CB, ejec_sil_HMW_CB, &
                ejec_carb_CCSN_CB, ejec_sil_CCSN_CB, &
                ejec_carb_SNIa, ejec_sil_SNIa, &
                ejec_dust_O_LMW_CB, ejec_dust_O_HMW_CB, &
                ejec_dust_O_CCSN_CB, ejec_dust_O_SNIa, &
                nb_CCSN_CB, mass_BHNS_CB, mass_WD_CB, nb_SNIa, dim_mass_yields, mass_yields, ejec_tot, &
                ejec_elem, carb_dust_LMW, sil_dust_LMW, &
                carb_dust_HMW, sil_dust_HMW, carb_dust_CCSN, sil_dust_CCSN, &
                carb_dust_SNIa, sil_dust_SNIa, &
                O_dust_LMW, O_dust_HMW, O_dust_CCSN, O_dust_SNIa, &
                ejec_tot_SNIa, ejec_elem_SNIa, min_mass_CCSN)
        end do

        m_end = top_isoch_mass

        write(unit2, "(f10.4, tr2, 8(es11.4,tr1))") time, 10**m_end, L_bol_tot, &
             HI_rate_SSP, HeI_rate_SSP, HeII_rate_SSP, &
             HI_power_SSP, HeI_power_SSP, HeII_power_SSP
        write(unit2, "(7(es11.4,tr1))") nb_CCSN_IS, nb_CCSN_CB, nb_SNIa, &
             mass_BHNS_IS, mass_BHNS_CB, mass_WD_IS, mass_WD_CB
        write(unit2, "(4(es11.4,tr1))") ejec_tot_IS, ejec_tot_CB, &
             ejec_elem_IS(0), ejec_elem_CB(0)
        write(unit2, "(6(es11.4,tr1))") ejec_carb_LMW_IS, &
             ejec_sil_LMW_IS, ejec_carb_HMW_IS, &
             ejec_sil_HMW_IS, ejec_carb_CCSN_IS, &
             ejec_sil_CCSN_IS
        write(unit2, "(6(es11.4,tr1))") ejec_carb_LMW_CB, &
             ejec_sil_LMW_CB, ejec_carb_HMW_CB, &
             ejec_sil_HMW_CB, ejec_carb_CCSN_CB, &
             ejec_sil_CCSN_CB
        write(unit2, "(3(es11.4,tr1))") ejec_dust_O_LMW_IS, &
             ejec_dust_O_HMW_IS, ejec_dust_O_CCSN_IS
        write(unit2, "(3(es11.4,tr1))") ejec_dust_O_LMW_CB, &
             ejec_dust_O_HMW_CB, ejec_dust_O_CCSN_CB
        write(unit2, "(3(es11.4,tr1))") ejec_carb_SNIa, &
             ejec_sil_SNIa, ejec_dust_O_SNIa
        write(unit2, "(" // int_to_string(dim_elem) // "(es11.4,tr1))") &
             ejec_elem_IS(1:)
        write(unit2, "(" // int_to_string(dim_elem) // "(es11.4,tr1))") &
             ejec_elem_CB(1:)
        used_spec(:) % dim = 0
        do i_SL = 1, dim_SL
           do i_spec = 1, dim_spec(i_SL)
              if (L_spec(i_SL) % val(i_spec) > 0) then
                 used_spec(i_SL) % dim = used_spec(i_SL) % dim + 1
                 used_spec(i_SL) % val(used_spec(i_SL) % dim) = i_spec
              endif
           enddo
        enddo
        n_used_SL = count(used_spec(1:dim_SL) % dim > 0)
        used_SL(1:dim_SL) = used_SL(1:dim_SL) .or. used_spec(1:dim_SL) % dim > 0

        write(unit2, "(i2)") n_used_SL
        do i_SL = 1, dim_SL
           if (used_spec(i_SL) % dim > 0) then
              write(unit2, "(i2, tr1, i4)") i_SL, used_spec(i_SL) % dim
              write(unit2, "(5(i4, tr1, es11.5, tr1))") &
                   (used_spec(i_SL) % val(i_spec), &
                   L_spec(i_SL) % val(used_spec(i_SL) % val(i_spec)), &
                   i_spec = 1, used_spec(i_SL) % dim)
           endif
        enddo
     end do

     do i_SL = 1, dim_SL
        if (used_SL(i_SL)) write(unit2, "(i0)") i_SL
     enddo
     write(unit2, "(i0)") count(used_SL(1:dim_SL))

     call close_file(unit2)

  enddo
  call close_file(unit)

end program SSPs

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_spectra_constants

  use mod_types

  implicit none
  private

!# Indicative value of the bin size in log10(radius) used for grains:
  real(CDR), parameter, public :: d_l10_rad0 = 0.01_CDR
  
!# Initial  number of temperatures used in the computation of temperature stochastic fluctuations:
  integer, parameter, public :: dim_temp = 201

!# Default minimal and maximal grain temperatures used in the computation of temperature 
!# stochastic fluctuations:
  real(CDR), parameter, public :: T_min_def = 1._CDR, &
       T_max_def = 1.e5_CDR

!# Minimal relative difference of wavelengths used in subroutine `intersperse` (called in 
!# "spectra.f90") when combining two sets of wavelengths:
  real(CDR), parameter, public :: eps_lambda = 1.e-4_CDR

!# Maximal numbers of reservoirs and of infall, star formation and outflow episodes:
  integer, parameter, public :: max_dim_reserv = 10
  integer, parameter, public :: max_dim_infall_epis = 10
  integer, parameter, public :: max_dim_SF_epis = 10
  integer, parameter, public :: max_dim_outflow_epis = 10

!# Redshift 0 temperature of the cosmic background radiation.
  real(CDR), parameter, public :: T_CBR0 = 2.7260_CDR !# Fixsen (2009), \
!# ApJ 707, 916.

!# Factor converting, for spheroidals, the dust mass to the total column 
!# density through the center, from side to side.
  real(CDR), parameter, public :: King_factor = 7.587e-5_CDR

!# Maximal age for an HII region. Stars producing Lyman continuum photons
!# but older than this age (post-AGB, hot horizontal branch stars) are not
!# considered when computing the nebular emission:
  real(CDR), parameter, public :: HII_max_age = 50._CDR

!# Approximate wavelength of the $V$ band in micrometers:
  real(CDR), parameter, public :: lambda_V = 5500.e-4_CDR

  character(len=std_string), parameter, public :: &
       scenarios_list = "list_scenarios.txt"

end module mod_spectra_constants

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_read_SSPs

  implicit none
  private
  public :: read_SSPs_set, read_SSP_Z

contains

!#======================================================================
  
  subroutine read_SSPs_set(SSPs_set, dim_SSP, SSP_file, used_SL_global, &
       stel_lib_set)

    use mod_types
    use mod_linked_list
    use mod_directories, only : SSPs_dir
    use mod_file_access, only : open_file, close_file, skip_comment_lines, &
         path_file

    implicit none
    character(len=*), intent(inout) :: SSPs_set
    character(len=*), intent(inout) :: stel_lib_set
    integer, intent(out) :: dim_SSP
    character(len=*), dimension(:), pointer :: SSP_file
    type(irreg_array_int), dimension(:), pointer :: used_SL_global
!#......................................................................
    integer :: i_SSP, unit_SSPs_set, error, unit_SSP, i_SL
    character(len=std_string) :: string
    type(lk_lst_std_string) :: head_node
    type(lk_lst_std_string), pointer :: current_node
    character(len=std_string) :: version_id, version_date
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call open_file(unit_SSPs_set, path_file(SSPs_dir, SSPs_set))
    read(unit_SSPs_set,*) version_id
    read(unit_SSPs_set,*) version_date 
    call skip_comment_lines(unit_SSPs_set)
    read(unit_SSPs_set, *, iostat = error) stel_lib_set
    call skip_comment_lines(unit_SSPs_set)

    dim_SSP = 0
    call lk_lst_initialize(head_node)
    do
       read(unit_SSPs_set, *, iostat = error) string
       if (error /= 0) exit
       dim_SSP = dim_SSP+1
       call lk_lst_new_node(head_node, current_node)
       current_node % val = string
    enddo
    call close_file(unit_SSPs_set)

    call lk_lst_to_array(head_node, SSP_file, dim_SSP)

!# Read the stellar libraries from the end of the file of SSPs.

    if (associated(used_SL_global)) deallocate(used_SL_global)
    allocate(used_SL_global(dim_SSP))
    do i_SSP = 1, dim_SSP
       call open_file(unit_SSP, path_file(SSPs_dir, SSP_file(i_SSP)), position="append")
       backspace(unit_SSP)
       read(unit_SSP, *) used_SL_global(i_SSP) % dim
       if (associated(used_SL_global(i_SSP) % val)) &
            deallocate(used_SL_global(i_SSP) % val)
       allocate(used_SL_global(i_SSP) % val(used_SL_global(i_SSP) % dim))

       backspace(unit_SSP)
       do i_SL = 1, used_SL_global(i_SSP) % dim
          backspace(unit_SSP)
       enddo
       do i_SL = 1, used_SL_global(i_SSP) % dim
          read(unit_SSP, *) used_SL_global(i_SSP) % val(i_SL)
       enddo
       call close_file(unit_SSP)
    enddo

  end subroutine read_SSPs_set

!#======================================================================

  subroutine read_SSP_Z(time_step, dim_output_age, output_age, &
       dim_convol_time, convol_time, &
       dim_SSP, i_SSP, SSP_file, Z_SSP, close_bin_frac, max_dim_spec, &
       dim_lambda_stel, &
       L_bol_SSP, lum_SSP, stellar_mass_SSP, inv_time, beta, &
       LC_rate_SSP, &
       ejec_rate_tot_SSP, ejec_rate_elem_SSP, carb_dust_prod_rate_SSP, &
       sil_dust_prod_rate_SSP, BHNS_mass_prod_rate_SSP, &
       WD_mass_prod_rate_SSP, stel_lib_file, used_SL_global, &
       dim_SL, &
       time_SSP, stel_lib, CCSN_rate_SSP, SNIa_rate_SSP, dim_elem, elem_id, &
       header_SSPs, LC_power_SSP)

    use mod_types
    use mod_linked_list
    use mod_read_dust_evol_param
    use mod_directories, only : SSPs_dir
    use mod_file_access, only : open_file, close_file, skip_lines, path_file
    use mod_convert_type, only : to_string
    use mod_stel_lib, only : spectra_read_stel_lib2, struct_stel_lib
    
    implicit none
    integer, intent(in) :: dim_SSP, i_SSP
    character(len=*), dimension(:), intent(in) :: SSP_file
    real(CDR), intent(in) :: close_bin_frac
    integer, intent(in) :: dim_lambda_stel, max_dim_spec
    real(CDR), intent(out) :: time_step
    integer, intent(inout) :: dim_output_age
    real(CDR), dimension(:), pointer :: output_age
    integer, intent(out) :: dim_convol_time
    real(CDR), dimension(:), pointer :: convol_time
    real(CDR), dimension(:, :), pointer :: L_bol_SSP
    real(CDR), dimension(:, :, :), pointer :: lum_SSP
    real(CDR), dimension(:, :), pointer :: stellar_mass_SSP
    integer, dimension(:), pointer :: inv_time
    real(CDR), dimension(:), pointer :: beta
    real(CDR), dimension(:, :), pointer :: LC_rate_SSP
    real(CDR), dimension(:, :), pointer :: ejec_rate_tot_SSP
    real(CDR), dimension(:, :, :), pointer :: ejec_rate_elem_SSP
    real(CDR), dimension(:, :), pointer :: carb_dust_prod_rate_SSP, &
         sil_dust_prod_rate_SSP
    real(CDR), dimension(:, :), pointer :: BHNS_mass_prod_rate_SSP, &
         WD_mass_prod_rate_SSP

    character(len=*), dimension(:), intent(in) :: stel_lib_file
    type(irreg_array_int), dimension(:), intent(in) :: used_SL_global
    integer, intent(in) :: dim_SL
    real(CDR), dimension(:), pointer :: time_SSP
    real(CDR), dimension(:), pointer :: Z_SSP
    real(CDR), dimension(:,:), pointer :: CCSN_rate_SSP, SNIa_rate_SSP
    integer, intent(out) :: dim_elem
    character(len=*), dimension(:), pointer :: elem_id
    type(struct_stel_lib), dimension(:), intent(inout) :: stel_lib

    type(lk_lst_long_string), dimension(:), pointer :: header_SSPs
    type(lk_lst_long_string), pointer :: header_node => null()

    real(CDR), dimension(:, :), pointer :: LC_power_SSP
!#......................................................................
    integer :: i_time_SSP, dim_time_SSP, unit_SSP
    real(CDR) :: x
    real(DPR) :: HI_rate_SSP, HI_rate_SSP_prev, HI_power_SSP, HI_power_SSP_prev
    real(CDR), dimension(max_dim_spec) :: L_spec
    real(CDR) :: nb_CCSN_IS, nb_CCSN_CB, nb_SNIa_int, mass_BHNS_SSP_IS, &
         mass_BHNS_SSP_CB, mass_WD_SSP_IS, mass_WD_SSP_CB
    real(CDR) :: ejec_tot_IS, ejec_tot_CB
    real(CDR), dimension(:), allocatable :: ejec_elem_IS, ejec_elem_CB
    real(CDR) :: ejec_carb_LMW_IS, ejec_sil_LMW_IS
    real(CDR) :: ejec_carb_HMW_IS, ejec_sil_HMW_IS, &
         ejec_carb_CCSN_IS, ejec_sil_CCSN_IS
    real(CDR) :: ejec_carb_LMW_CB, ejec_sil_LMW_CB
    real(CDR) :: ejec_carb_HMW_CB, ejec_sil_HMW_CB, &
         ejec_carb_CCSN_CB, ejec_sil_CCSN_CB, ejec_carb_SNIa, &
         ejec_sil_SNIa

    real(CDR) :: ejec_dust_O_LMW_IS, ejec_dust_O_HMW_IS, &
         ejec_dust_O_CCSN_IS, ejec_dust_O_LMW_CB, &
         ejec_dust_O_HMW_CB, ejec_dust_O_CCSN_CB, ejec_dust_O_SNIa

    real(CDR) :: delta_time, time, last_time_SSP

    integer :: n_used_SL, i_used_SL, i_SL, n_used_spec, i_spec
    integer, dimension(max_dim_spec) :: i_used_spec
    integer :: i_lambda
    character(len=len(header_SSPs(:) % val)) :: string
    integer, save :: dim_elem1
    character(len=std_string), dimension(:), allocatable, save :: elem1
    integer :: i_elem, i_convol
    integer, save :: dim_time_SSP1
    real(CDR), dimension(:), allocatable, save :: time_SSP1
    integer :: dim_time_tmp
    real(CDR), dimension(:), allocatable :: time_tmp

    character(len=std_string) :: version_id, version_date

    logical, dimension(:), allocatable, save :: SL_already_read
    logical, dimension(:), allocatable, save :: SL_needed
    logical, dimension(:), allocatable, save :: SL_must_read
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
!# Read stellar libraries used for this SSP which have not been read
!# previously for another SSP.

    if (i_SSP == 1) then
       if (associated(Z_SSP)) deallocate(Z_SSP)
       allocate(Z_SSP(dim_SSP))

       if (associated(header_SSPs)) deallocate(header_SSPs)
       allocate(header_SSPs(dim_SSP))

       if (allocated(SL_already_read)) deallocate(SL_already_read)
       allocate(SL_already_read(dim_SL))
       SL_already_read(:) = .false.

       if (allocated(SL_needed)) deallocate(SL_needed)
       allocate(SL_needed(dim_SL))

       if (allocated(SL_must_read)) deallocate(SL_must_read)
       allocate(SL_must_read(dim_SL))
    endif

    do i_SL = 1, dim_SL
       if (any(used_SL_global(i_SSP) % val(:) == i_SL)) then
          SL_needed(i_SL) = .true.
       else
          SL_needed(i_SL) = .false.
       endif
    enddo
    do i_SL = 1, dim_SL
       if (SL_needed(i_SL)) then
          if (SL_already_read(i_SL)) then
             SL_must_read(i_SL) = .false.
          else
             SL_must_read(i_SL) = .true.
             SL_already_read(i_SL) = .true. !# Anticipating...
          endif
       else
          if (SL_already_read(i_SL)) deallocate(stel_lib(i_SL) % lum_star)
          SL_must_read(i_SL) = .false.
          SL_already_read(i_SL) = .false. !# Once memory for the `i_SL`-th SL \
!#                                           has been freed.
       endif
    enddo

    do i_SL = 1, dim_SL
       if (SL_must_read(i_SL)) then
          call spectra_read_stel_lib2(stel_lib_file(i_SL), dim_lambda_stel, &
               stel_lib(i_SL) % lum_star)
       endif
    enddo
    
!# ??? Change notations? Read `L_spec` (contribution of stellar spectra to an SSP) 
!# and compute `lum_SSP` (monochromatic luminosity of an SSP).

    call open_file(unit_SSP, path_file(SSPs_dir, SSP_file(i_SSP)), skip = .false.)
    read(unit_SSP,*) version_id
    read(unit_SSP,*) version_date 
    call lk_lst_initialize(header_SSPs(i_SSP))
    do
       read(unit_SSP, "(a)") string !# Not `read(unit_SSP, *) string`, otherwise \
!#                                     everything is lost after the first space.
       string = adjustl(string)
       if (string(1:1) == "!") then
          call lk_lst_new_node(header_SSPs(i_SSP), header_node)
          header_node % val = string
       else
          backspace(unit_SSP)
          exit
       endif
    enddo
    read(unit_SSP, *) Z_SSP(i_SSP), dim_time_SSP, time_step, last_time_SSP, dim_elem
    if (i_SSP == 1) then
       if (associated(L_bol_SSP)) deallocate(L_bol_SSP)
       allocate(L_bol_SSP(dim_SSP, dim_time_SSP))

       if (associated(CCSN_rate_SSP)) deallocate(CCSN_rate_SSP)
       allocate(CCSN_rate_SSP(dim_SSP, dim_time_SSP))

       if (associated(SNIa_rate_SSP)) deallocate(SNIa_rate_SSP)
       allocate(SNIa_rate_SSP(dim_SSP, dim_time_SSP))

       if (associated(ejec_rate_tot_SSP)) deallocate(ejec_rate_tot_SSP)
       allocate(ejec_rate_tot_SSP(dim_SSP, dim_time_SSP))

       if (associated(carb_dust_prod_rate_SSP)) &
            deallocate(carb_dust_prod_rate_SSP)
       allocate(carb_dust_prod_rate_SSP(dim_SSP, dim_time_SSP))

       if (associated(sil_dust_prod_rate_SSP)) &
            deallocate(sil_dust_prod_rate_SSP)
       allocate(sil_dust_prod_rate_SSP(dim_SSP, dim_time_SSP))

       if (associated(BHNS_mass_prod_rate_SSP)) &
            deallocate(BHNS_mass_prod_rate_SSP)
       allocate(BHNS_mass_prod_rate_SSP(dim_SSP, dim_time_SSP))

       if (associated(WD_mass_prod_rate_SSP)) deallocate(WD_mass_prod_rate_SSP)
       allocate(WD_mass_prod_rate_SSP(dim_SSP, dim_time_SSP))

       if (associated(time_SSP)) deallocate(time_SSP)
       allocate(time_SSP(dim_time_SSP))

       if (associated(lum_SSP)) deallocate(lum_SSP)
       allocate(lum_SSP(dim_SSP, dim_time_SSP, dim_lambda_stel))

       if (associated(elem_id)) deallocate(elem_id)
       allocate(elem_id(dim_elem))

       if (associated(ejec_rate_elem_SSP)) deallocate(ejec_rate_elem_SSP)
       allocate(ejec_rate_elem_SSP(dim_SSP, dim_time_SSP, 0:dim_elem))

       dim_convol_time = ceiling(last_time_SSP/time_step)+1

       if (associated(convol_time)) deallocate(convol_time)
       allocate(convol_time(dim_convol_time+1))
       convol_time(:) = ((/(i_convol, i_convol = 1, dim_convol_time+1)/)-1) * time_step

       if (associated(stellar_mass_SSP)) deallocate(stellar_mass_SSP)
       allocate(stellar_mass_SSP(dim_SSP, dim_convol_time))

       if (associated(LC_rate_SSP)) deallocate(LC_rate_SSP)
       allocate(LC_rate_SSP(dim_SSP, dim_convol_time))

       if (associated(inv_time)) deallocate(inv_time)
       allocate(inv_time(dim_convol_time))

       if (associated(beta)) deallocate(beta)
       allocate(beta(dim_convol_time))

       if (associated(LC_power_SSP)) deallocate(LC_power_SSP)
       allocate(LC_power_SSP(dim_SSP, dim_convol_time))

    else
       if (Z_SSP(i_SSP) < Z_SSP(i_SSP-1)) then
          write(*, "(/a)") "Files of SSPs should be ordered by increasing metallicies:"
          write(*, "(a)") "the metallicity of """ // trim(SSP_file(i_SSP)) // &
               """ (" // to_string(Z_SSP(i_SSP)) // ")", &
               "is less than that of """ // trim(SSP_file(i_SSP-1)) // &
               """ (" // to_string(Z_SSP(i_SSP-1)) // "). ", &
               "Stopped."
          stop
       end if
    endif
    lum_SSP(i_SSP, :, :) = 0

    read(unit_SSP, *) elem_id(1:dim_elem)

    if (i_SSP == 1) then
       dim_elem1 = dim_elem
       if (allocated(elem1)) deallocate(elem1)
       allocate(elem1(dim_elem1))
       elem1(1:dim_elem1) = elem_id(1:dim_elem)
    else
       if (dim_elem1 /= dim_elem) then
          write(*, "(/,(a))") &
               "The number of chemical elements used in file of SSPs """ // &
               trim(SSP_file(i_SSP)) // """ (" // to_string(dim_elem) // ") ", &
               "is not the same as in """ // trim(SSP_file(1)) // """ (" // &
               to_string(dim_elem1) // "). ", &
               "Stopped."
          stop
       endif
       do i_elem = 1, dim_elem
          if (elem_id(i_elem) /= elem1(i_elem)) then
             write(*, "(/,(a))") "Chemical element #" // to_string(i_elem) // &
                  " used in file of SSPs """ // trim(SSP_file(i_SSP)) // &
                  """ (" // trim(elem_id(i_elem)) // ") ", &
                  "is not the same as in """ // trim(SSP_file(1)) // &
                  """ (" // trim(elem1(i_elem)) // "). ", &
                  "Stopped."
             stop
          endif
       end do

       if (i_SSP == dim_SSP) deallocate(elem1)
    endif

    if (allocated(ejec_elem_IS)) deallocate(ejec_elem_IS)
    allocate(ejec_elem_IS(0:dim_elem))
    if (allocated(ejec_elem_CB)) deallocate(ejec_elem_CB)
    allocate(ejec_elem_CB(0:dim_elem))

!# First age.

    i_time_SSP = 1
    read(unit_SSP, *) time_SSP(i_time_SSP), x, L_bol_SSP(i_SSP, i_time_SSP), &
         HI_rate_SSP_prev, x, x, HI_power_SSP_prev
    if (i_SSP > 1) then
       if (time_SSP(i_time_SSP) /= time_SSP1(i_time_SSP)) then
          write(*, "(/a)") "Files of SSPs should be computed at the same ages:"
          write(*, "(a)") "at time-step #" // to_string(i_time_SSP) // &
               ", the age is " // to_string(time_SSP(i_time_SSP)) // &
               " Myr for """ // trim(SSP_file(i_SSP)) // """ ", &
               "and " // to_string(time_SSP1(i_time_SSP)) // " Myr for """ // &
               trim(SSP_file(1)) // """. ", &
               "Stopped."
          stop
       endif
    endif
    read(unit_SSP, *) !# `nb_CCSN_IS`, etc. Skipped.
    read(unit_SSP, *) !# `ejec_tot_IS`, etc. Skipped.
    read(unit_SSP, *) !# `ejec_carb_LMW_IS`, etc. Skipped.
    read(unit_SSP, *) !# `ejec_carb_LMW_CB`, etc. Skipped.
    read(unit_SSP, *) !# `ejec_dust_O_LMW_IS`, etc. Skipped.
    read(unit_SSP, *) !# `ejec_dust_O_LMW_CB`, etc. Skipped.
    read(unit_SSP, *) !# `ejec_carb_SNIa`, etc. Skipped.
    read(unit_SSP, *) !# `ejec_elem_IS`, etc. Skipped.
    read(unit_SSP, *) !# `ejec_elem_CB`, etc. Skipped.
    read(unit_SSP, *) n_used_SL
    do i_used_SL = 1, n_used_SL
       read(unit_SSP, *) i_SL, n_used_spec
       read(unit_SSP, *) (i_used_spec(i_spec), L_spec(i_spec), &
            i_spec = 1, n_used_spec)
       do i_lambda = 1, dim_lambda_stel
          lum_SSP(i_SSP, i_time_SSP, i_lambda) = &
               lum_SSP(i_SSP, i_time_SSP, i_lambda) &
               + sum(L_spec(1:n_used_spec) * &
               stel_lib(i_SL) % lum_star(i_lambda, &
               i_used_spec(1:n_used_spec)))
       enddo
    end do

!# Following ages.

    i_convol = 1
    time = convol_time(i_convol)
    stellar_mass_SSP(i_SSP, i_convol) = 1

    do i_time_SSP = 1, dim_time_SSP-1
       read(unit_SSP, *) time_SSP(i_time_SSP+1), x, &
            L_bol_SSP(i_SSP, i_time_SSP+1), HI_rate_SSP, x, x, HI_power_SSP
       if (i_SSP > 1) then
          if (time_SSP(i_time_SSP+1) /= time_SSP1(i_time_SSP+1)) then
             write(*, "(/a)") "Files of SSPs should be computed at the same ages:"
             write(*, "(a)") "at time-step #" // to_string(i_time_SSP+1) // &
                  ", the age is " // to_string(time_SSP(i_time_SSP+1)) // &
                  " Myr for """ // trim(SSP_file(i_SSP)) // """ ", &
                  "and " // to_string(time_SSP1(i_time_SSP+1)) // " Myr for """ // &
                  trim(SSP_file(1)) // """. ", &
                  "Stopped."
             stop
          endif
       endif
!# Quantities produced (integrated over time, not rates) between
!# `time_SSP(i_time_SSP)` and `time_SSP(i_time_SSP+1)`:
!# {
       read(unit_SSP, *) nb_CCSN_IS, nb_CCSN_CB, nb_SNIa_int, mass_BHNS_SSP_IS, &
            mass_BHNS_SSP_CB, mass_WD_SSP_IS, mass_WD_SSP_CB
       read(unit_SSP, *) ejec_tot_IS, ejec_tot_CB, ejec_elem_IS(0), &
            ejec_elem_CB(0)
       read(unit_SSP, *) ejec_carb_LMW_IS, ejec_sil_LMW_IS, &
            ejec_carb_HMW_IS, ejec_sil_HMW_IS, &
            ejec_carb_CCSN_IS, ejec_sil_CCSN_IS
       read(unit_SSP, *) ejec_carb_LMW_CB, ejec_sil_LMW_CB, &
            ejec_carb_HMW_CB, ejec_sil_HMW_CB, &
            ejec_carb_CCSN_CB, ejec_sil_CCSN_CB
       read(unit_SSP, *) ejec_dust_O_LMW_IS, ejec_dust_O_HMW_IS, &
            ejec_dust_O_CCSN_IS
       read(unit_SSP, *) ejec_dust_O_LMW_CB, &
            ejec_dust_O_HMW_CB, ejec_dust_O_CCSN_CB
       read(unit_SSP, *) ejec_carb_SNIa, ejec_sil_SNIa, &
            ejec_dust_O_SNIa
       read(unit_SSP, *) ejec_elem_IS(1:dim_elem)
       read(unit_SSP, *) ejec_elem_CB(1:dim_elem)
!# }.
       delta_time = time_SSP(i_time_SSP+1)-time_SSP(i_time_SSP)
!# Mean rates between `time_SSP(i_time_SSP)` and `time_SSP(i_time_SSP+1)`:
!# {
       CCSN_rate_SSP(i_SSP, i_time_SSP) = ((1-close_bin_frac)*nb_CCSN_IS &
            + close_bin_frac*nb_CCSN_CB)/delta_time
       SNIa_rate_SSP(i_SSP, i_time_SSP) = close_bin_frac*nb_SNIa_int/delta_time
       BHNS_mass_prod_rate_SSP(i_SSP, i_time_SSP) = &
            ( (1-close_bin_frac) * mass_BHNS_SSP_IS &
            + close_bin_frac * mass_BHNS_SSP_CB )/delta_time
       WD_mass_prod_rate_SSP(i_SSP, i_time_SSP) = &
            ( (1-close_bin_frac) * mass_WD_SSP_IS &
            + close_bin_frac * mass_WD_SSP_CB )/delta_time
       ejec_rate_tot_SSP(i_SSP, i_time_SSP) = &
            ( (1-close_bin_frac) * ejec_tot_IS &
            + close_bin_frac * ejec_tot_CB )/delta_time
       ejec_rate_elem_SSP(i_SSP, i_time_SSP,0:dim_elem) = &
            ( (1-close_bin_frac) * ejec_elem_IS(0:dim_elem) &
            + close_bin_frac * ejec_elem_CB(0:dim_elem) )/delta_time
       carb_dust_prod_rate_SSP(i_SSP, i_time_SSP) = &
            ((1-close_bin_frac) * &
            ( LMW_carb_deplet * ejec_carb_LMW_IS &
            + HMW_carb_deplet * ejec_carb_HMW_IS &
            + CCSN_carb_deplet * ejec_carb_CCSN_IS) &
            + close_bin_frac * &
            ( LMW_carb_deplet * ejec_carb_LMW_CB &
            + HMW_carb_deplet * ejec_carb_HMW_CB &
            + CCSN_carb_deplet * ejec_carb_CCSN_CB &
            + SNIa_carb_deplet * ejec_carb_SNIa)) &
            /delta_time

       sil_dust_prod_rate_SSP(i_SSP, i_time_SSP) = &
            ((1-close_bin_frac) * &
            ( LMW_sil_deplet * (ejec_sil_LMW_IS + &
            O_sil_ratio*ejec_dust_O_LMW_IS) &
            + HMW_sil_deplet * (ejec_sil_HMW_IS + &
            O_sil_ratio*ejec_dust_O_HMW_IS) &
            + CCSN_sil_deplet * (ejec_sil_CCSN_IS + &
            O_sil_ratio*ejec_dust_O_CCSN_IS) ) &
            + close_bin_frac * &
            ( LMW_sil_deplet * (ejec_sil_LMW_CB + &
            O_sil_ratio*ejec_dust_O_LMW_CB) &
            + HMW_sil_deplet * (ejec_sil_HMW_CB + &
            O_sil_ratio*ejec_dust_O_HMW_CB) &
            + CCSN_sil_deplet * (ejec_sil_CCSN_CB + &
            O_sil_ratio*ejec_dust_O_CCSN_CB) &
            + SNIa_sil_deplet * (ejec_sil_SNIa + &
            O_sil_ratio*ejec_dust_O_SNIa) )) &
            /delta_time

!# }.
       read(unit_SSP, *) n_used_SL
       do i_used_SL = 1, n_used_SL
          read(unit_SSP, *) i_SL, n_used_spec
          read(unit_SSP, *) (i_used_spec(i_spec), L_spec(i_spec), &
               i_spec = 1, n_used_spec)
          do i_lambda = 1, dim_lambda_stel
             lum_SSP(i_SSP, i_time_SSP+1, i_lambda) = &
                  lum_SSP(i_SSP, i_time_SSP+1, i_lambda) &
                  + sum( L_spec(1:n_used_spec) * &
                  stel_lib(i_SL) % lum_star(i_lambda, &
                  i_used_spec(1:n_used_spec)))
          enddo
       end do

       do
          if (time >= time_SSP(i_time_SSP+1)) exit
          inv_time(i_convol) = i_time_SSP
          beta(i_convol) = (time_SSP(i_time_SSP+1)-time)/delta_time
          LC_rate_SSP(i_SSP, i_convol) = &
               HI_rate_SSP_prev + (HI_rate_SSP-HI_rate_SSP_prev)*(time-time_SSP(i_time_SSP))/ &
               delta_time

          LC_power_SSP(i_SSP,i_convol) = HI_power_SSP_prev + (HI_power_SSP-HI_power_SSP_prev)* &
               (time-time_SSP(i_time_SSP))/delta_time

          stellar_mass_SSP(i_SSP, i_convol+1) = stellar_mass_SSP(i_SSP, i_convol) - & !# ??? Inaccurate?
               ( ejec_rate_tot_SSP(i_SSP, i_time_SSP) &
               + BHNS_mass_prod_rate_SSP(i_SSP, i_time_SSP) &
               + WD_mass_prod_rate_SSP(i_SSP, i_time_SSP) ) &
               * time_step
          i_convol = i_convol+1
          if (i_convol > dim_convol_time) exit
          time = convol_time(i_convol)
       end do
       HI_rate_SSP_prev = HI_rate_SSP
       HI_power_SSP_prev = HI_power_SSP
    end do

!#{ Values at `dim_time_SSP`-1 are extrapolated at `dim_time_SSP`.
    CCSN_rate_SSP(i_SSP, dim_time_SSP) = CCSN_rate_SSP(i_SSP, dim_time_SSP-1)
    SNIa_rate_SSP(i_SSP, dim_time_SSP) = SNIa_rate_SSP(i_SSP, dim_time_SSP-1)
    ejec_rate_tot_SSP(i_SSP, dim_time_SSP) = ejec_rate_tot_SSP(i_SSP, dim_time_SSP-1)
    carb_dust_prod_rate_SSP(i_SSP, dim_time_SSP) = carb_dust_prod_rate_SSP(i_SSP, dim_time_SSP-1)
    sil_dust_prod_rate_SSP(i_SSP, dim_time_SSP) = sil_dust_prod_rate_SSP(i_SSP, dim_time_SSP-1)
    BHNS_mass_prod_rate_SSP(i_SSP, dim_time_SSP) = BHNS_mass_prod_rate_SSP(i_SSP, dim_time_SSP-1)
    WD_mass_prod_rate_SSP(i_SSP, dim_time_SSP) = WD_mass_prod_rate_SSP(i_SSP, dim_time_SSP-1)
    ejec_rate_elem_SSP(i_SSP, dim_time_SSP, :) = ejec_rate_elem_SSP(i_SSP, dim_time_SSP-1, :)
!#}
    
    call close_file(unit_SSP)

    inv_time(i_convol) = dim_time_SSP-1
    beta(i_convol) = 0

    deallocate(ejec_elem_IS, ejec_elem_CB)

    if (i_SSP == 1) then
       dim_time_SSP1 = dim_time_SSP
       if (allocated(time_SSP1)) deallocate(time_SSP1)
       allocate(time_SSP1(dim_time_SSP1))
       time_SSP1(1:dim_time_SSP1) = time_SSP(1:dim_time_SSP)

!# `output_age` must not be larger than the final `time_SSP`:
       if (output_age(dim_output_age) > time_SSP(dim_time_SSP)) then
          do dim_time_tmp = 0, dim_output_age-1
             if (output_age(dim_time_tmp+1) > time_SSP(dim_time_SSP)) exit
          enddo
          allocate(time_tmp(dim_time_tmp))
          time_tmp(1:dim_time_tmp) = output_age(1:dim_time_tmp)
          deallocate(output_age)
          allocate(output_age(dim_time_tmp))
          output_age(:) = time_tmp(:)
          deallocate(time_tmp)
          dim_output_age = dim_time_tmp
       endif
    else
       if (i_SSP == dim_SSP) then
          deallocate(time_SSP1)
          deallocate(SL_already_read)
          deallocate(SL_must_read)
          deallocate(SL_needed)
       end if
    endif

  end subroutine read_SSP_Z

end module mod_read_SSPs

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_calib

  implicit none
  private
  integer, save :: dim_col = 0
  integer, save :: unit_calib
  integer, parameter :: format_max_length = 300
  character(len=format_max_length), save :: fmt
  public :: format_output, unit_calib, fmt

contains

!#======================================================================

  subroutine format_output(column_heading, fmt_col)

    use mod_types
    use mod_convert_type, only : to_string

    implicit none
    character(len=*) :: column_heading
    character(len=*), optional :: fmt_col
!#......................................................................
    character(std_string) :: fmt_col_eff, fmt_col_def = "f8.3"
    integer :: heading_width, content_width, pos_digit, pos_point, format_length
    character(std_string) :: left, right
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
!# Set the content width.
    if (present(fmt_col)) then
       fmt_col_eff = fmt_col
    else
       fmt_col_eff = fmt_col_def
    endif
    pos_digit = scan(fmt_col_eff, "0123456789")
    pos_point = index(fmt_col_eff, ".")
    if (pos_point == 0) then !# For integer and string formats.
       read(fmt_col_eff(pos_digit:),*) content_width
    else !# For reals.
       read(fmt_col_eff(pos_digit:pos_point-1),*) content_width
    endif

!# Format and write the column heading.
    heading_width = len_trim(adjustl(column_heading))
    if (max(content_width-heading_width,0)/2 > 0) then
       left = "tr" // to_string(max(content_width-heading_width,0)/2) // ","
    else
       left = ""
    endif

    if (max(content_width-heading_width,0)-max(content_width-heading_width,0)/2 > 0) then
       right = ",tr" // to_string(max(content_width-heading_width,0)- &
            max(content_width-heading_width,0)/2)
    else
       right = ""
    endif

    write(unit_calib, &
         "(" // trim(left) // "a" // trim(right) // ",tr1)", &
         advance="no") adjustl(column_heading)

!# Format the column content (written in the main program).
    dim_col = dim_col+1
    if (max(heading_width-content_width,0)/2 > 0) then
       left = "tr" // to_string(max(heading_width-content_width,0)/2) // ","
    else
       left = ""
    endif
    if (max(heading_width-content_width,0)-max(heading_width-content_width,0)/2 > 0) then
       right = ",tr" // to_string(max(heading_width-content_width,0)- &
            max(heading_width-content_width,0)/2)
    else
       right = ""
    endif

    if (dim_col == 1) then
       format_length = len_trim(left) + len_trim(fmt_col_eff) + len_trim(right)
       if (format_length > format_max_length) then
          write(*, "(a,i0,a)") "Execution of ""calib"" failed: &
               &the length of string `fmt` is longer than `format_max_length`. &
               &Set the value of the latter in ""mod_calib.f90"" to ", &
               format_length, " or more, and recompile. Stopped."
          stop
       endif
       fmt = trim(left) // trim(fmt_col_eff) // trim(right)
    else
       format_length = len_trim(fmt) + len(",tr1,") + len_trim(left) + &
            len_trim(fmt_col_eff) + len_trim(right)
       if (format_length > format_max_length) then
          write(*, "(a,i0,a)") "Execution of ""calib"" failed: &
               &the length of string `fmt` is longer than `format_max_length`. &
               &Set the value of the latter in ""mod_calib.f90"" to ", &
               format_length, " or more, and recompile. Stopped."
          stop
       endif
       fmt = trim(fmt) // ",tr1," // trim(left) // &
            trim(fmt_col_eff) // trim(right)
    endif

  end subroutine format_output

end module mod_calib

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_stel_lib

  use mod_types

  implicit none
  private
  type :: struct_stel_lib
     integer :: dim_spec
     integer :: dim_lambda
     real(CDR), dimension(:,:), pointer :: lum_star => null()
     real(DPR), dimension(:), pointer :: HI_rate_star => null(), &
          HeI_rate_star => null(), &
          HeII_rate_star => null(), &
          T => null(), &
          g => null(), &
          HI_power_star => null(), &
          HeI_power_star => null(), &
          HeII_power_star => null()
  end type struct_stel_lib
  public :: SSP_read_stel_lib, spectra_read_stel_lib1, &
       spectra_read_stel_lib2, interp_stel_lib, struct_stel_lib

contains

!#======================================================================
  
  subroutine SSP_read_stel_lib(dim_low_T, dim_high_T, &
       stel_lib, &
       M_over_H_SL, dim_SL, T_SL_max, T_SL_min, dim_spec, stel_lib_set)

    use mod_types
    use mod_directories, only : stel_lib_dir
    use mod_file_access, only : open_file, close_file, skip_lines, path_file

    implicit none
    integer, intent(out) :: dim_SL, dim_low_T, dim_high_T
    type(struct_stel_lib), dimension(:), pointer :: stel_lib
    integer, dimension(:), pointer :: dim_spec
    real(DPR), dimension(:), pointer :: M_over_H_SL, T_SL_max, T_SL_min
    character(len=*), intent(in) :: stel_lib_set
!#......................................................................
    integer :: unit, i_SL, i_spec
    character(std_string), dimension(:), allocatable :: stel_lib_file
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call open_file(unit, path_file(stel_lib_dir, stel_lib_set))
    read(unit,*) !# Skip file of wavelengths.
    read(unit,*) dim_low_T, dim_high_T

    dim_SL = dim_low_T+dim_high_T

    if (allocated(stel_lib_file)) deallocate(stel_lib_file)
    allocate(stel_lib_file(dim_SL))

    if (associated(dim_spec)) deallocate(dim_spec)
    allocate(dim_spec(dim_SL))

    if (associated(M_over_H_SL)) deallocate(M_over_H_SL)
    allocate(M_over_H_SL(dim_SL))

    if (associated(stel_lib)) deallocate(stel_lib)
    allocate(stel_lib(dim_SL))

    if (associated(T_SL_max)) deallocate(T_SL_max)
    allocate(T_SL_max(dim_SL))

    if (associated(T_SL_min)) deallocate(T_SL_min)
    allocate(T_SL_min(dim_SL))

    do i_SL = 1, dim_SL
       read(unit,*) stel_lib_file(i_SL)
    enddo
    call close_file(unit)

    do i_SL = 1, dim_SL
       call open_file(unit, path_file(stel_lib_dir, stel_lib_file(i_SL)))
       call skip_lines(unit, 1) !# "[M/H]".
       read(unit,*) dim_spec(i_SL), M_over_H_SL(i_SL)

       if (associated(stel_lib(i_SL) % T)) deallocate(stel_lib(i_SL) % T)
       allocate(stel_lib(i_SL) % T(0:dim_spec(i_SL)))
       if (associated(stel_lib(i_SL) % g)) deallocate(stel_lib(i_SL) % g)
       allocate(stel_lib(i_SL) % g(0:dim_spec(i_SL)))
       if (associated(stel_lib(i_SL) % HI_rate_star)) deallocate(stel_lib(i_SL) % HI_rate_star)
       allocate(stel_lib(i_SL) % HI_rate_star(0:dim_spec(i_SL)))
       if (associated(stel_lib(i_SL) % HeI_rate_star)) deallocate(stel_lib(i_SL) % HeI_rate_star)
       allocate(stel_lib(i_SL) % HeI_rate_star(0:dim_spec(i_SL)))
       if (associated(stel_lib(i_SL) % HeII_rate_star)) deallocate(stel_lib(i_SL) % HeII_rate_star)
       allocate(stel_lib(i_SL) % HeII_rate_star(0:dim_spec(i_SL)))
       if (associated(stel_lib(i_SL) % HI_power_star)) deallocate(stel_lib(i_SL) % HI_power_star)
       allocate(stel_lib(i_SL) % HI_power_star(0:dim_spec(i_SL)))
       if (associated(stel_lib(i_SL) % HeI_power_star)) deallocate(stel_lib(i_SL) % HeI_power_star)
       allocate(stel_lib(i_SL) % HeI_power_star(0:dim_spec(i_SL)))
       if (associated(stel_lib(i_SL) % HeII_power_star)) deallocate(stel_lib(i_SL) % HeII_power_star)
       allocate(stel_lib(i_SL) % HeII_power_star(0:dim_spec(i_SL)))
       
       do i_spec = 1, dim_spec(i_SL)
          read(unit,*) stel_lib(i_SL) % T(i_spec), &
               stel_lib(i_SL) % g(i_spec), &
               stel_lib(i_SL) % HI_rate_star(i_spec), &
               stel_lib(i_SL) % HeI_rate_star(i_spec), &
               stel_lib(i_SL) % HeII_rate_star(i_spec), &
               stel_lib(i_SL) % HI_power_star(i_spec), &
               stel_lib(i_SL) % HeI_power_star(i_spec), &
               stel_lib(i_SL) % HeII_power_star(i_spec)
       enddo
       call close_file(unit)
       T_SL_max(i_SL) = maxval(stel_lib(i_SL) % T(1:dim_spec(i_SL)))
       T_SL_min(i_SL) = minval(stel_lib(i_SL) % T(1:dim_spec(i_SL)))
       stel_lib(i_SL) % T(0) = 0
       stel_lib(i_SL) % g(0) = 0
       stel_lib(i_SL) % HI_rate_star(0) = 0
       stel_lib(i_SL) % HeI_rate_star(0) = 0
       stel_lib(i_SL) % HeII_rate_star(0) = 0
       stel_lib(i_SL) % HI_power_star(0) = 0
       stel_lib(i_SL) % HeI_power_star(0) = 0
       stel_lib(i_SL) % HeII_power_star(0) = 0
    enddo

  end subroutine SSP_read_stel_lib

!#======================================================================

  subroutine spectra_read_stel_lib1(dim_SL, dim_spec, dim_lambda, lambda, stel_lib_file, &
       stel_lib_set)

    use mod_types
    use mod_directories, only : stel_lib_dir
    use mod_file_access, only : open_file, close_file, skip_lines, path_file

    implicit none
    integer, intent(out) :: dim_SL, dim_lambda
    integer, dimension(:), pointer :: dim_spec
    real(CDR), dimension(:), pointer :: lambda
    character(len=*), dimension(:), pointer :: stel_lib_file
    character(len=*), intent(in) :: stel_lib_set
!#......................................................................
    integer :: unit, i_SL, unit2
    character(len=std_string) :: SL_wavelengths_file
    integer :: dim_low_T, dim_high_T
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call open_file(unit, path_file(stel_lib_dir, stel_lib_set))
    read(unit, *) SL_wavelengths_file

    call open_file(unit2, path_file(stel_lib_dir, SL_wavelengths_file))
    read(unit2,*) dim_lambda
    if (associated(lambda)) deallocate(lambda)
    allocate(lambda(dim_lambda))
    read(unit2,*) lambda(1:dim_lambda)
    call close_file(unit2)

    read(unit,*) dim_low_T, dim_high_T
    dim_SL = dim_low_T+dim_high_T

    if (associated(stel_lib_file)) deallocate(stel_lib_file)
    allocate(stel_lib_file(dim_SL))
    if (associated(dim_spec)) deallocate(dim_spec)
    allocate(dim_spec(dim_SL))

    do i_SL = 1, dim_SL
       read(unit,*) stel_lib_file(i_SL)
    enddo
    call close_file(unit)

    do i_SL = 1, dim_SL
       call open_file(unit, path_file(stel_lib_dir, stel_lib_file(i_SL)))
       call skip_lines(unit, 1)
       read(unit,*) dim_spec(i_SL)
       call close_file(unit)
    enddo

  end subroutine spectra_read_stel_lib1

!#======================================================================

  subroutine spectra_read_stel_lib2(stel_lib_file, dim_lambda, &
       lum_star)

    use mod_types
    use mod_file_access, only : open_file, close_file, skip_lines, path_file
    use mod_directories, only : stel_lib_dir

    implicit none
    character(len=*), intent(in) :: stel_lib_file
    integer, intent(in) :: dim_lambda
    real(CDR), dimension(:,:), pointer :: lum_star
!#......................................................................
    integer :: unit, i_spec, dim_spec
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call open_file(unit, path_file(stel_lib_dir, stel_lib_file))
    call skip_lines(unit, 1)
    read(unit,*) dim_spec
    call skip_lines(unit, dim_spec)
    if (associated(lum_star)) deallocate(lum_star)
    allocate(lum_star(dim_lambda, dim_spec))
    do i_spec = 1, dim_spec
       read(unit,*) lum_star(1:dim_lambda, i_spec)
    enddo
    call close_file(unit)

  end subroutine spectra_read_stel_lib2

!#======================================================================

  subroutine interp_stel_lib(T, g, i1, i2, i3, i4, alpha1, alpha2, alpha3, &
       alpha4, i_SL12, i_SL34, dim_spec, stel_lib)

    use mod_types
    use mod_SSPs_constants, only : d_T_max_SL, kappa_SL

    implicit none
    integer, intent(in) :: i_SL12, i_SL34
    real(DPR), intent(in) :: T, g
    integer, intent(out) :: i1, i2, i3, i4
    real(DPR), intent(out) :: alpha1, alpha2, alpha3, alpha4
    integer, dimension(:), intent(in) :: dim_spec
    type(struct_stel_lib), dimension(:), intent(in) :: stel_lib
!#......................................................................
    integer :: i
    real(DPR) :: alpha, beta, gamma, g_prim, g_sec, g1, g2, g3, g4
    real(DPR) :: T1, T2, T3, T4
    real(DPR) :: delta1, delta2, delta3, delta4
    real(DPR) :: det0, det1, det2, det3, det4
    real(DPR), dimension(9) :: mat0, mat1, mat2, mat3, mat4

!# Parameter used to test if temperatures are equal:
    real(DPR), parameter :: eps_T = 1.e-6_DPR !# (Probably useless, but avoids warnings about \
!# equality tests of reals from quibbling compilers.)
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    i1 = 0
    i2 = 0
    i3 = 0
    i4 = 0

    delta1 = huge(1._DPR)
    delta2 = delta1
    delta3 = delta1
    delta4 = delta1

!# i1 = index of the star with temperature > T and gravity > g.
!# Among all such stars, one chooses the one minimizing
!# abs(Delta T)+kappa_SL*abs(Delta g).
!# If no star with temperature > T and gravity > g exists, i1 = 0.
!#
!# i2 = index of the star with temperature > T and gravity < g.
!#
!# i3 = index of the star with temperature < T and gravity > g.
!#
!# i4 = index of the star with temperature < T and gravity < g.

!#  g
!#
!# /|\
!#  | i3  |
!#  |     |  i1
!#  | ----x------
!#  |     |     i2
!#  |  i4 |
!#  |__________\ T
!#             /

    do i = 1, dim_spec(i_SL12)
       if (stel_lib(i_SL12) % T(i) >= T) then
          if (stel_lib(i_SL12) % g(i) >= g) then
             if ((stel_lib(i_SL12) % T(i)-T) + kappa_SL*(stel_lib(i_SL12) % g(i)-g) < &
                  delta1) then
                i1 = i
                delta1 = (stel_lib(i_SL12) % T(i)-T) + kappa_SL*(stel_lib(i_SL12) % g(i)-g)
             endif
          else
             if ((stel_lib(i_SL12) % T(i)-T) + kappa_SL*(g-stel_lib(i_SL12) % g(i)) < &
                  delta2) then
                i2 = i
                delta2 = (stel_lib(i_SL12) % T(i)-T) + kappa_SL*(g-stel_lib(i_SL12) % g(i))
             endif
          end if
       endif
    enddo

    do i = 1, dim_spec(i_SL34)
       if (stel_lib(i_SL34) % T(i) < T) then
          if (stel_lib(i_SL34) % g(i) >= g) then
             if ((T-stel_lib(i_SL34) % T(i)) + kappa_SL*(stel_lib(i_SL34) % g(i)-g) < &
                  delta3) then
                i3 = i
                delta3 = (T-stel_lib(i_SL34) % T(i)) + kappa_SL*(stel_lib(i_SL34) % g(i)-g)
             endif
          else
             if ((T-stel_lib(i_SL34) % T(i)) + kappa_SL*(g-stel_lib(i_SL34) % g(i)) < &
                  delta4) then
                i4 = i
                delta4 = (T-stel_lib(i_SL34) % T(i)) + kappa_SL*(g-stel_lib(i_SL34) % g(i))
             endif
          end if
       end if
    end do

    T1 = stel_lib(i_SL12) % T(i1)
    g1 = stel_lib(i_SL12) % g(i1)
    T2 = stel_lib(i_SL12) % T(i2)
    g2 = stel_lib(i_SL12) % g(i2)
    T3 = stel_lib(i_SL34) % T(i3)
    g3 = stel_lib(i_SL34) % g(i3)
    T4 = stel_lib(i_SL34) % T(i4)
    g4 = stel_lib(i_SL34) % g(i4)
    alpha1 = 0
    alpha2 = 0
    alpha3 = 0
    alpha4 = 0

!# If T2 (resp. T1) is too far from T compared to T1 (resp. T2), i2 (resp. i1)
!# is not used. The same for i3 and i4.

    if (i1 /= 0 .and. i2 /= 0) then
       if (T1 < T2-d_T_max_SL) then
          i2 = 0
       else if (T2 < T1-d_T_max_SL) then
          i1 = 0
       endif
    endif

    if (i3 /= 0 .and. i4 /= 0) then
       if (T3 > T4+d_T_max_SL) then
          i4 = 0
       else if (T4 > T3+d_T_max_SL) then
          i3 = 0
       endif
    endif

!# Interpolation in the (T, g) plane between the used points (at least 1, at most 4).
!# Code "0110" means that i1 = i4 = 0, i2 /= 0 and i3 /= 0.
!# Note: preference is always given to the temperature over the gravity when needed.

    if (i1 == 0) then
       if (i2 == 0) then
          if (i3 == 0) then
             if (i4 == 0) then !# 0000
                write(*, "(a)") "Error: i1 = i2 = i3 = i4 = 0. Stopped."
                stop
             else !# 0001
                alpha1 = 0
                alpha2 = 0
                alpha3 = 0
                alpha4 = 1
             endif
          else if (i4 == 0) then !# 0010
             alpha1 = 0
             alpha2 = 0
             alpha3 = 1
             alpha4 = 0
          else !# 0011
             alpha1 = 0
             alpha2 = 0
             if (abs(T3-T4) < eps_T) then
                if (g3 == g4) then
                   alpha3 = 0.5_DPR
                else
                   alpha3 = (g-g4)/(g3-g4)
                endif
                alpha4 = 1-alpha3
             else
                if (T3 > T4) then
                   alpha3 = 1
                   alpha4 = 0 ; i4 = 0
                else
                   alpha3 = 0 ; i3 = 0
                   alpha4 = 1
                end if
             end if
          endif
       else if (i3 == 0) then
          if (i4 == 0) then !# 0100
             alpha1 = 0
             alpha2 = 1
             alpha3 = 0
             alpha4 = 0
          else !# 0101
             alpha1 = 0
             if (T2 == T4) then
                alpha2 = 0.5_DPR
             else
                alpha2 = (T-T4)/(T2-T4)
             endif
             alpha3 = 0
             alpha4 = 1-alpha2
          endif
       else if (i4 == 0) then !# 0110
          alpha1 = 0
          if (T2 == T3) then
             alpha2 = 0.5_DPR
          else
             alpha2 = (T-T3)/(T2-T3)
          endif
          alpha3 = 1-alpha2
          alpha4 = 0
       else !# 0111

!# Assume that (T, g) is within the triangle formed by the three points.

          mat0 = (/ &
               T2, T3, T4, &
               g2, g3, g4, &
               1._DPR, 1._DPR, 1._DPR/)
          mat2 = (/ &
               T,  T3, T4, &
               g,  g3, g4, &
               1._DPR, 1._DPR, 1._DPR/)
          mat3 = (/ &
               T2, T,  T4, &
               g2, g,  g4, &
               1._DPR, 1._DPR, 1._DPR/)
          mat4 = (/ &
               T2, T3, T, &
               g2, g3, g, &
               1._DPR, 1._DPR, 1._DPR/)
          det0 = det3x3(mat0)
          det2 = det3x3(mat2)
          det3 = det3x3(mat3)
          det4 = det3x3(mat4)
          alpha1 = 0
          alpha2 = det2/det0
          alpha3 = det3/det0
          alpha4 = det4/det0

!# If (T, g) is outside the triangle formed by the three used points,
!# use only two points.

          if (alpha2 < 0 .or. alpha2 > 1 .or. alpha3 < 0 .or. &
               alpha3 > 1 .or. alpha4 < 0 .or. alpha4 > 1) then
             alpha1 = 0
             if (T2 == T3) then
                alpha2 = 0.5_DPR
             else
                alpha2 = (T-T3)/(T2-T3)
             endif
             alpha3 = 1-alpha2
             alpha4 = 0; i4 = 0
          endif
       endif
    else if (i2 == 0) then
       if (i3 == 0) then
          if (i4 == 0) then !# 1000
             alpha1 = 1
             alpha2 = 0
             alpha3 = 0
             alpha4 = 0
          else !# 1001
             if (T1 == T4) then
                alpha1 = 0.5_DPR
             else
                alpha1 = (T-T4)/(T1-T4)
             endif
             alpha2 = 0
             alpha3 = 0
             alpha4 = 1-alpha1
          endif
       else if (i4 == 0) then !# 1010
          if (T1 == T3) then
             alpha1 = 0.5_DPR
          else
             alpha1 = (T-T3)/(T1-T3)
          endif
          alpha2 = 0
          alpha3 = 1-alpha1
          alpha4 = 0
       else !# 1011

!# Assume that (T, g) is within the triangle formed by the three points.

          mat0 = (/ &
               T1, T3, T4, &
               g1, g3, g4, &
               1._DPR, 1._DPR, 1._DPR/)
          mat1 = (/ &
               T,  T3, T4, &
               g,  g3, g4, &
               1._DPR, 1._DPR, 1._DPR/)
          mat3 = (/ &
               T1, T,  T4, &
               g1, g,  g4, &
               1._DPR, 1._DPR, 1._DPR/)
          mat4 = (/ &
               T1, T3, T, &
               g1, g3, g, &
               1._DPR, 1._DPR, 1._DPR/)
          det0 = det3x3(mat0)
          det1 = det3x3(mat1)
          det3 = det3x3(mat3)
          det4 = det3x3(mat4)
          alpha1 = det1/det0
          alpha2 = 0
          alpha3 = det3/det0
          alpha4 = det4/det0

!# If (T, g) is outside the triangle formed by the three used points,
!# use only two points.

          if (alpha1 < 0 .or. alpha1 > 1 .or. alpha3 < 0 .or. &
               alpha3 > 1 .or. alpha4 < 0 .or. alpha4 > 1) then
             if (T1 == T4) then
                alpha1 = 0.5_DPR
             else
                alpha1 = (T-T4)/(T1-T4)
             endif
             alpha2 = 0
             alpha3 = 0 ; i3 = 0
             alpha4 = 1-alpha1
          endif
       endif
    else if (i3 == 0) then
       if (i4 == 0) then !# 1100
          if (abs(T1-T2) < eps_T) then
             if (g1 == g2) then
                alpha1 = 0.5_DPR
             else
                alpha1 = (g-g2)/(g1-g2)
             endif
             alpha2 = 1-alpha1
          else
             if (T1 < T2) then
                alpha1 = 1
                alpha2 = 0 ; i2 = 0
             else
                alpha1 = 0 ; i1 = 0
                alpha2 = 1
             end if
          end if
          alpha3 = 0
          alpha4 = 0
       else !# 1101

!# Assume that (T, g) is within the triangle formed by the three points.

          mat0 = (/ &
               T1, T2, T4, &
               g1, g2, g4, &
               1._DPR, 1._DPR, 1._DPR/)
          mat1 = (/ &
               T,  T2, T4, &
               g,  g2, g4, &
               1._DPR, 1._DPR, 1._DPR/)
          mat2 = (/ &
               T1, T,  T4, &
               g1, g,  g4, &
               1._DPR, 1._DPR, 1._DPR/)
          mat4 = (/ &
               T1, T2, T, &
               g1, g2, g, &
               1._DPR, 1._DPR, 1._DPR/)
          det0 = det3x3(mat0)
          det1 = det3x3(mat1)
          det2 = det3x3(mat2)
          det4 = det3x3(mat4)
          alpha1 = det1/det0
          alpha2 = det2/det0
          alpha3 = 0
          alpha4 = det4/det0

!# If (T, g) is outside the triangle formed by the three used points,
!# use only two points.

          if (alpha1 < 0 .or. alpha1 > 1 .or. alpha2 < 0 .or. &
               alpha2 > 1 .or. alpha4 < 0 .or. alpha4 > 1) then
             if (T1 == T4) then
                alpha1 = 0.5_DPR
             else
                alpha1 = (T-T4)/(T1-T4)
             endif
             alpha2 = 0 ; i2 = 0
             alpha3 = 0
             alpha4 = 1-alpha1
          endif
       endif
    else if (i4 == 0) then !# 1110

!# Assume that (T, g) is within the triangle formed by the three points.

       mat0 = (/ &
            T1, T2, T3, &
            g1, g2, g3, &
            1._DPR, 1._DPR, 1._DPR/)
       mat1 = (/ &
            T,  T2, T3, &
            g,  g2, g3, &
            1._DPR, 1._DPR, 1._DPR/)
       mat2 = (/ &
            T1, T,  T3, &
            g1, g,  g3, &
            1._DPR, 1._DPR, 1._DPR/)
       mat3 = (/ &
            T1, T2, T, &
            g1, g2, g, &
            1._DPR, 1._DPR, 1._DPR/)
       det0 = det3x3(mat0)
       det1 = det3x3(mat1)
       det2 = det3x3(mat2)
       det3 = det3x3(mat3)
       alpha1 = det1/det0
       alpha2 = det2/det0
       alpha3 = det3/det0
       alpha4 = 0

!# If (T, g) is outside the triangle formed by the three used points,
!# use only two points.

       if (alpha1 < 0 .or. alpha1 > 1 .or. alpha2 < 0 .or. &
            alpha2 > 1 .or. alpha3 < 0 .or. alpha3 > 1) then
          alpha1 = 0 ; i1 = 0
          if (T2 == T3) then
             alpha2 = 0.5_DPR
          else
             alpha2 = (T-T3)/(T2-T3)
          endif
          alpha3 = 1-alpha2
          alpha4 = 0
       endif
    end if

!# All four points used.

    if (i3 /= 0 .and. i4 /= 0 .and. i1 /= 0 .and. i2 /= 0) then
       if (T1 /= T3) then
          alpha = (T-T3)/(T1-T3)
       else
          alpha = 0.5_DPR
       endif
       if (T2 /= T4) then
          beta = (T-T4)/(T2-T4)
       else
          beta = 0.5_DPR
       endif
       g_prim = alpha*g1+(1-alpha)*g3
       g_sec = beta*g2+(1-beta)*g4
       if (g_prim /= g_sec) then
          gamma = (g-g_sec)/(g_prim-g_sec)
       else
          gamma = 0.5_DPR
       endif
       alpha1 = alpha*gamma
       alpha2 = beta*(1-gamma)
       alpha3 = (1-alpha)*gamma
       alpha4 = (1-beta)*(1-gamma)
    end if

  end subroutine interp_stel_lib

!#======================================================================

  function det3x3(a)

    use mod_types
    implicit none
    real(DPR), dimension(9) :: a
    real(DPR) :: det3x3

    det3x3 = &
         +a(1)*(a(5)*a(9)-a(8)*a(6)) &
         -a(2)*(a(4)*a(9)-a(7)*a(6)) &
         +a(3)*(a(4)*a(8)-a(7)*a(5))

  end function det3x3

end module mod_stel_lib

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_write_scenario_param

  implicit none
  private
  integer :: ord_scenario

  interface write_parameter
     module procedure write_parameter_integer, write_parameter_SPR, &
          write_parameter_DPR, write_parameter_bool, &
          write_parameter_string
  end interface write_parameter

  public :: write_scenario_param, ord_scenario, write_parameter

contains

!#======================================================================
!# `write_scenario_param` writes the processed name of output files.

  subroutine write_scenario_param( &
       version_id, &
       version_date, &
       compiler, &
       run_begin_time, &
       dim_SSP, &
       header_SSPs, &
       unit, line_prefix, for_grains)

    use mod_types
    use mod_linked_list
    use mod_strings, only : quote_string, same_case_equal
    use mod_convert_type
    use mod_read_SF_param
    use mod_read_reserv_infall_param
    use mod_read_outflow_param
    use mod_read_dust_evol_param
    use mod_read_dust_transfer_param
    use mod_read_cloud_neb_param
    use mod_read_output_param
    use mod_read_other_param
    use mod_read_cosmo_param

    implicit none
    character(len=*), intent(in), optional :: version_id, version_date
    character(len=*), intent(in), optional :: compiler
    character(len=*), intent(in), optional :: run_begin_time
    integer, intent(in), optional :: unit, dim_SSP
    type(lk_lst_long_string), dimension(:), intent(in), optional :: header_SSPs
    character(len=*), intent(in), optional :: line_prefix
    logical, optional :: for_grains
!#......................................................................
    integer :: i_SSP, i_reserv, i_epis
    type(lk_lst_long_string), pointer :: header_node => null()
    type(lk_lst_long_string), pointer :: text_current_node => null()
    logical :: for_grains_eff
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    for_grains_eff = .false.
    if (present(for_grains)) then
       if (for_grains) for_grains_eff = for_grains
    endif

!# Code version identifier and date.
    if (unit >= 0 .and. line_prefix == "!#") then
       write(unit, "(a)") quote_string(version_id) // " !# `version_id`."
       write(unit, "(a)") quote_string(version_date) // " !# `version_date`."
    endif

!# General comments on the scenario:
    text_current_node => text % ptr
    if (associated(text_current_node)) then
       if (unit < 0) then
          write(*, "(a,a)") trim(line_prefix), repeat("=", 70)
       else
          write(unit, "(a,a)") trim(line_prefix), repeat("=", 70)
       endif

       do
          if (.not.associated(text_current_node)) exit
          if (unit < 0) then
             write(*, "(a,tr1,a)") trim(line_prefix), trim(text_current_node % val)
          else
             write(unit, "(a,tr1,a)") trim(line_prefix), trim(text_current_node % val)
          endif
          text_current_node => text_current_node % ptr
       enddo

       if (unit < 0) then
          write(*, "(a,a)") trim(line_prefix), repeat("=", 70)
       else
          write(unit, "(a,a)") trim(line_prefix), repeat("=", 70)
       endif
    endif

!# Local time at which "spectra" was launched:
    if (present(run_begin_time)) write(unit, "(a)") &
         "!# Code ""spectra"" executed at " // trim(run_begin_time) // "."

!# Compiler used:
    if (unit >= 0 .and. line_prefix == "!#") then
       if (present(compiler)) write(unit, "(a)") &
            "!# Compiler for ""spectra"": " // trim(compiler) // "."
    endif

!# File of scenarios and rank of the scenario within this file:
    if (unit >= 0 .and. line_prefix == "!#") then
       write(unit, "(a)") "!# File of scenarios: " // &
            quote_string(scenarios_file) // "."
       write(unit, "(a, i0, a)") "!# Scenario number ", ord_scenario, &
            " in this file."
    endif

    if (unit < 0 .or. line_prefix /= "!#") then !# For the screen and the log-file.
       call write_parameter(unit, line_prefix, "verbosity", verbosity)
       call write_parameter(unit, line_prefix, "check_only", check_only)
       call write_parameter(unit, line_prefix, "overwrite", overwrite)
    endif

    if (unit < 0 .or. line_prefix /= "!#" .or. for_grains_eff) & 
         call write_parameter(unit, line_prefix, "spectra_output", spectra_output) !# \
!# `spectra_output` will be printed uncommented in the main output file (see the end
!# of this procedure). The same for `RF_output` and `sublim_output`.
    
    if (spectra_output /= "none") then
       call write_parameter(unit, line_prefix, "spectra_file", spectra_file)
       if (unit < 0 .or. line_prefix /= "!#" .or. for_grains_eff) then
          if (spectra_output == "detailed") then
             call write_parameter(unit, line_prefix, "RF_output", & 
                  RF_output)
             call write_parameter(unit, line_prefix, "sublim_output", &
                  sublim_output)
          endif
       endif
    endif

!# Associated files:
    call write_parameter(unit, line_prefix, "grain_temp_output", grain_temp_output)
    if (grain_temp_output) &
         call write_parameter(unit, line_prefix, "grain_temp_file", grain_temp_file)

    call write_parameter(unit, line_prefix, "grain_SED_output", grain_SED_output)
    if (grain_SED_output) &
         call write_parameter(unit, line_prefix, "grain_SED_file", grain_SED_file)
    if (grain_temp_output .or. grain_SED_output) then
       call write_parameter(unit, line_prefix, "grain_output_min_age", grain_output_min_age)
       call write_parameter(unit, line_prefix, "grain_output_max_age", grain_output_max_age)
       call write_parameter(unit, line_prefix, "grain_output_SFC", grain_output_SFC)
       call write_parameter(unit, line_prefix, "grain_output_DISM", grain_output_DISM)
       call write_parameter(unit, line_prefix, "grain_output_min_size", grain_output_min_size)
       call write_parameter(unit, line_prefix, "grain_output_max_size", grain_output_max_size)
    endif

!# Seeds used for random numbers:
    call write_seed(unit, line_prefix, dim_seed, seed)

!# Properties of SSPs (repetitive!):
    call write_parameter(unit, line_prefix, "SSPs_set", SSPs_set)
    if (present(header_SSPs)) then
       write(unit, "(a,a)") trim(line_prefix), repeat("=", 70)
       do i_SSP = 1, dim_SSP
          write(unit, "(a,i0,a,i0,a)") trim(line_prefix) // " SSP ", i_SSP, "/", dim_SSP, ":"
          header_node => header_SSPs(i_SSP) % ptr
          do
             if (.not.associated(header_node)) exit
             write(unit, "(a)") trim(header_node % val)
             header_node => header_node % ptr
          enddo
       enddo
       write(unit, "(a,a)") trim(line_prefix), repeat("=", 70)
    endif

!# Output ages, fraction of close binaries and initial metallicity:
    call write_parameter(unit, line_prefix, "ages_file", &
         ages_file)

    call write_parameter(unit, line_prefix, "close_bin_frac", close_bin_frac)

    call write_parameter(unit, line_prefix, "ISM_init_Z", ISM_init_Z)

!# Reservoirs:
    do i_reserv = 1, max_dim_reserv
       if (reserv_init_mass(i_reserv) > 0) then
          call write_parameter(unit, line_prefix, "reserv_init_mass", &
               reserv_init_mass(i_reserv), i_reserv)

          call write_parameter(unit, line_prefix, "reserv_Z", &
               reserv_Z(i_reserv), i_reserv)
       endif
    enddo

!# Infall episodes:
    do i_epis = 1, max_dim_infall_epis
       if (same_case_equal(infall_type(i_epis), "none")) cycle

       call write_parameter(unit, line_prefix, "infall_source", &
            infall_source(i_epis), i_epis)

       call write_parameter(unit, line_prefix, "infall_begin_time", &
            infall_begin_time(i_epis), i_epis)
       call write_parameter(unit, line_prefix, "infall_end_time", &
            infall_end_time(i_epis), i_epis)

       call write_parameter(unit, line_prefix, "infall_type", &
            infall_type(i_epis) , i_epis)

       if (same_case_equal(infall_type(i_epis), "instantaneous")) then
          call write_parameter(unit, line_prefix, "infall_inst_mass", &
               infall_inst_mass(i_epis), i_epis)

       else if (same_case_equal(infall_type(i_epis), "constant")) then
          call write_parameter(unit, line_prefix, "infall_const_mass", &
               infall_const_mass(i_epis), i_epis)

       else if (same_case_equal(infall_type(i_epis), "exponential")) then
          call write_parameter(unit, line_prefix, "infall_expo_timescale", &
               infall_expo_timescale(i_epis), i_epis)
          call write_parameter(unit, line_prefix, "infall_expo_mass", &
               infall_expo_mass(i_epis), i_epis)

       else if (same_case_equal(infall_type(i_epis), "reserv_mass")) then
          call write_parameter(unit, line_prefix, "infall_reserv_timescale", &
               infall_reserv_timescale(i_epis), i_epis)
          call write_parameter(unit, line_prefix, "infall_reserv_power", &
               infall_reserv_power(i_epis), i_epis)

       else if (same_case_equal(infall_type(i_epis), "file")) then
          call write_parameter(unit, line_prefix, "infall_file", &
               infall_file(i_epis), i_epis)
       endif

    enddo

!# Star formation episodes:
    do i_epis = 1, max_dim_SF_epis
       if (same_case_equal(SF_type(i_epis), "none")) cycle

       call write_parameter(unit, line_prefix, "SF_begin_time", &
            SF_begin_time(i_epis), i_epis)
       call write_parameter(unit, line_prefix, "SF_end_time", &
            SF_end_time(i_epis), i_epis)

       call write_parameter(unit, line_prefix, "SF_type", SF_type(i_epis), i_epis)

       if (same_case_equal(SF_type(i_epis), "instantaneous")) then
          call write_parameter(unit, line_prefix, "SF_inst_mass", &
               SF_inst_mass(i_epis), i_epis)

       else if (same_case_equal(SF_type(i_epis), "constant")) then
          call write_parameter(unit, line_prefix, "SF_const_mass", &
               SF_const_mass(i_epis), i_epis)

       else if (same_case_equal(SF_type(i_epis), "exponential")) then
          call write_parameter(unit, line_prefix, "SF_expo_timescale", &
               SF_expo_timescale(i_epis), i_epis)
          call write_parameter(unit, line_prefix, "SF_expo_mass", &
               SF_expo_mass(i_epis), i_epis)

       else if (same_case_equal(SF_type(i_epis), "peaked")) then
          call write_parameter(unit, line_prefix, "SF_peaked_timescale", &
               SF_peaked_timescale(i_epis), i_epis)
          call write_parameter(unit, line_prefix, "SF_peaked_mass", &
               SF_peaked_mass(i_epis), i_epis)

       else if (same_case_equal(SF_type(i_epis), "ISM_mass")) then
          call write_parameter(unit, line_prefix, "SF_ISM_timescale", &
               SF_ISM_timescale(i_epis), i_epis)
          call write_parameter(unit, line_prefix, "SF_ISM_power", &
               SF_ISM_power(i_epis), i_epis)
          call write_parameter(unit, line_prefix, "SF_ISM_threshold", &
               SF_ISM_threshold(i_epis), i_epis)

       else if (same_case_equal(SF_type(i_epis), "infall")) then
          call write_parameter(unit, line_prefix, "SF_infall_factor", &
               SF_infall_factor(i_epis), i_epis)

       else if (same_case_equal(SF_type(i_epis), "file")) then
          call write_parameter(unit, line_prefix, "SF_file", SF_file(i_epis), i_epis)
       endif

       call write_parameter(unit, line_prefix, "SF_stochastic", &
            SF_stochastic(i_epis), i_epis)
       if (SF_stochastic(i_epis)) then
          call write_parameter(unit, line_prefix, "SF_stoch_fluc", &
               SF_stoch_fluc(i_epis), i_epis)
          call write_parameter(unit, line_prefix, "SF_stoch_timescale", &
               SF_stoch_timescale(i_epis), i_epis)
       endif

       call write_parameter(unit, line_prefix, "SF_Z_type", SF_Z_type(i_epis), i_epis)
       if (same_case_equal(SF_Z_type(i_epis), "constant")) then
          call write_parameter(unit, line_prefix, "SF_Z_const_val", &
               SF_Z_const_val(i_epis), i_epis)
       else if (same_case_equal(SF_Z_type(i_epis), "file")) then
          call write_parameter(unit, line_prefix, "SF_Z_file", &
               SF_Z_file(i_epis), i_epis)
       end if

       call write_parameter(unit, line_prefix, "SF_inert_frac", &
            SF_inert_frac(i_epis), i_epis)
    enddo

!# Outflow episodes:
    do i_epis = 1, max_dim_outflow_epis
       if (same_case_equal(outflow_type(i_epis), "none")) cycle

       call write_parameter(unit, line_prefix, "outflow_begin_time", &
            outflow_begin_time(i_epis), i_epis)
       call write_parameter(unit, line_prefix, "outflow_end_time", &
            outflow_end_time(i_epis), i_epis)

       call write_parameter(unit, line_prefix, "outflow_type", &
            outflow_type(i_epis), i_epis)

       if (same_case_equal(outflow_type(i_epis), "radical")) then

       else if (same_case_equal(outflow_type(i_epis), "instantaneous")) then
          call write_parameter(unit, line_prefix, "outflow_inst_mass", &
               outflow_inst_mass(i_epis), i_epis)

       else if (same_case_equal(outflow_type(i_epis), "constant")) then
          call write_parameter(unit, line_prefix, "outflow_const_mass", &
               outflow_const_mass(i_epis), i_epis)

       else if (same_case_equal(outflow_type(i_epis), "SF")) then
          call write_parameter(unit, line_prefix, "outflow_SF_factor", &
               outflow_SF_factor(i_epis), i_epis)
          call write_parameter(unit, line_prefix, "outflow_SF_power", &
               outflow_SF_power(i_epis), i_epis)

       else if (same_case_equal(outflow_type(i_epis), "SN")) then
          call write_parameter(unit, line_prefix, "outflow_SN_mass", &
               outflow_SN_mass(i_epis), i_epis)
          call write_parameter(unit, line_prefix, "outflow_SN_power", &
               outflow_SN_power(i_epis), i_epis)

       else if (same_case_equal(outflow_type(i_epis), "CCSN")) then
          call write_parameter(unit, line_prefix, "outflow_CCSN_mass", &
               outflow_CCSN_mass(i_epis), i_epis)
          call write_parameter(unit, line_prefix, "outflow_CCSN_power", &
               outflow_CCSN_power(i_epis), i_epis)

       else if (same_case_equal(outflow_type(i_epis), "SNIa")) then
          call write_parameter(unit, line_prefix, "outflow_SNIa_mass", &
               outflow_SNIa_mass(i_epis), i_epis)
          call write_parameter(unit, line_prefix, "outflow_SNIa_power", &
               outflow_SNIa_power(i_epis), i_epis)

       else if (same_case_equal(outflow_type(i_epis), "ejecta")) then
          call write_parameter(unit, line_prefix, "outflow_ejec_threshold", &
               outflow_ejec_threshold(i_epis), i_epis)
          call write_parameter(unit, line_prefix, "outflow_ejec_factor", &
               outflow_ejec_factor(i_epis), i_epis)

       else if (same_case_equal(outflow_type(i_epis), "file")) then
          call write_parameter(unit, line_prefix, "outflow_file", &
               outflow_file(i_epis), i_epis)
       endif
    enddo

!# Nebular emission:
    call write_parameter(unit, line_prefix, "nebular_emission_SFC", &
         nebular_emission_SFC)

    call write_parameter(unit, line_prefix, "nebular_emission_DISM", &
         nebular_emission_DISM)

    if (nebular_emission_SFC) then
       call write_parameter(unit, line_prefix, "neb_emis_type_SFC", &
            neb_emis_type_SFC)

       if (neb_emis_type_SFC == "constant") &
            call write_parameter(unit, line_prefix, "neb_emis_const_frac_SFC", &
            neb_emis_const_frac_SFC)
    endif

    if (nebular_emission_DISM) then
       call write_parameter(unit, line_prefix, "neb_emis_type_DISM", &
            neb_emis_type_DISM)

       if (neb_emis_type_DISM == "constant") &
            call write_parameter(unit, line_prefix, "neb_emis_const_frac_DISM", &
            neb_emis_const_frac_DISM)
    endif

!# Properties of star-forming regions:
    call write_parameter(unit, line_prefix, "cluster_stel_mass", &
         cluster_stel_mass)

    call write_parameter(unit, line_prefix, "cloud_init_frac", &
         cloud_init_frac)

    call write_parameter(unit, line_prefix, "cloud_power", &
         cloud_power)

    call write_parameter(unit, line_prefix, "cloud_duration", &
         cloud_duration)

!# Dust evolution:
    call write_parameter(unit, line_prefix, "dust_evolution", &
         dust_evolution)
    call write_parameter(unit, line_prefix, "O_sil_ratio", O_sil_ratio)

    if (dust_evolution == "basic") then
       call write_parameter(unit, line_prefix, "ISM_carb_deplet", &
            ISM_carb_deplet)
       call write_parameter(unit, line_prefix, "ISM_sil_deplet", &
            ISM_sil_deplet)
    else if (dust_evolution == "Dwek") then
       call write_parameter(unit, line_prefix, "CCSN_carb_deplet", &
            CCSN_carb_deplet)
       call write_parameter(unit, line_prefix, "HMW_carb_deplet", &
            HMW_carb_deplet)
       call write_parameter(unit, line_prefix, "LMW_carb_deplet", &
            LMW_carb_deplet)
       call write_parameter(unit, line_prefix, "SNIa_carb_deplet", &
            SNIa_carb_deplet)
       call write_parameter(unit, line_prefix, "CCSN_sil_deplet", &
            CCSN_sil_deplet)
       call write_parameter(unit, line_prefix, "HMW_sil_deplet", &
            HMW_sil_deplet)
       call write_parameter(unit, line_prefix, "LMW_sil_deplet", &
            LMW_sil_deplet)
       call write_parameter(unit, line_prefix, "SNIa_sil_deplet", &
            SNIa_sil_deplet)
       call write_parameter(unit, line_prefix, "SN_swept_mass", SN_swept_mass)
       call write_parameter(unit, line_prefix, "carb_accr_timescale", &
            carb_accr_timescale)
       call write_parameter(unit, line_prefix, "sil_accr_timescale", &
            sil_accr_timescale)
    endif

!# Extinction and dust emission in star-forming clouds:
    call write_parameter(unit, line_prefix, "extinction_SFC", extinction_SFC)
    if (extinction_SFC) then
       call write_parameter(unit, line_prefix, "grains_file_SFC", &
            grains_file_SFC)

       call write_parameter(unit, line_prefix, "dust_emission_SFC", dust_emission_SFC)
       if (dust_emission_SFC) then
          call write_parameter(unit, line_prefix, "stoch_heating_SFC", &
               stoch_heating_SFC)
          call write_parameter(unit, line_prefix, "self_abs_power_SFC", &
               self_abs_power_SFC)
          if (spectra_output == "detailed" .and. sublim_output) then
             call write_parameter(unit, line_prefix, "carb_sublim_temp_SFC", &
                  carb_sublim_temp_SFC)
             call write_parameter(unit, line_prefix, "sil_sublim_temp_SFC", &
                  sil_sublim_temp_SFC)
          endif
       endif
    endif

!# Extinction and dust emission in the diffuse ISM:
    call write_parameter(unit, line_prefix, "extinction_DISM", extinction_DISM)
    if (extinction_DISM) then
       call write_parameter(unit, line_prefix, "grains_file_DISM", &
            grains_file_DISM)

       call write_parameter(unit, line_prefix, "geometry", geometry)

       if (geometry == "spiral" .or. geometry == "slab") then
          if (geometry == "spiral") then
             call write_parameter(unit, line_prefix, "bulge_tot_ratio", &
                  bulge_tot_ratio)
             call write_parameter(unit, line_prefix, "M_sys_spiral", &
                  M_sys_spiral)
             call write_parameter(unit, line_prefix, "expo_radius", &
                  expo_radius)
          else
             call write_parameter(unit, line_prefix, "slab_factor", &
                  slab_factor)
          endif
          call write_parameter(unit, line_prefix, "inclin_averaged", &
               inclin_averaged)
          if (.not.inclin_averaged) then
             call write_parameter(unit, line_prefix, "inclination", &
                  inclination)
          endif
       else if (geometry == "spheroidal") then
          call write_parameter(unit, line_prefix, "M_sys_spher", &
               M_sys_spher)
          call write_parameter(unit, line_prefix, "core_radius", &
               core_radius)
       endif

       call write_parameter(unit, line_prefix, "dust_emission_DISM", dust_emission_DISM)
       if (dust_emission_DISM) then
          call write_parameter(unit, line_prefix, "stoch_heating_DISM", &
               stoch_heating_DISM)
          call write_parameter(unit, line_prefix, "self_abs_power_DISM", &
               self_abs_power_DISM)
          if (spectra_output == "detailed" .and. sublim_output) then
             call write_parameter(unit, line_prefix, "carb_sublim_temp_DISM", &
                  carb_sublim_temp_DISM)
             call write_parameter(unit, line_prefix, "sil_sublim_temp_DISM", &
                  sil_sublim_temp_DISM)
          endif
       endif
    endif

!# Cosmological parameters:
    call write_parameter(unit, line_prefix, "Omega_m", Omega_m)

    call write_parameter(unit, line_prefix, "H_0", H_0)

    call write_parameter(unit, line_prefix, "form_redshift", form_redshift)

    call write_parameter(unit, line_prefix, "CBR", CBR)

!# For the main output file only:
    if (unit >= 0 .and. line_prefix == "!#" .and. .not.for_grains_eff) then
       write(unit, "(a)") quote_string(spectra_output) // " !# `spectra_output`."
       if (spectra_output == "detailed") then
          write(unit, "(a)") to_string(RF_output) // " !# `RF_output`."
          write(unit, "(a)") to_string(sublim_output) // " !# `sublim_output`."
       endif
    endif

  end subroutine write_scenario_param

!#======================================================================

  subroutine write_parameter_integer(unit, line_prefix, parameter_name, parameter_value, idx)

    use mod_convert_type

    implicit none
    integer, intent(in) :: unit
    character(len=*), intent(in) :: parameter_name, line_prefix
    integer, intent(in) :: parameter_value
    integer, intent(in), optional :: idx
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(idx)) then
       if (unit < 0) then
          write(*, "(a,tr1,a,i0,a,i0,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // &
               "(", idx, ")` = ", parameter_value, "."
       else
          write(unit, "(a,tr1,a,i0,a,i0,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // &
               "(", idx, ")` = ", parameter_value, "."
       endif
    else
       if (unit < 0) then
          write(*, "(a,tr1,a,i0,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // "` = ", &
               parameter_value, "."
       else
          write(unit, "(a,tr1,a,i0,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // "` = ", &
               parameter_value, "."
       endif
    endif

  end subroutine write_parameter_integer

!#======================================================================

  subroutine write_parameter_SPR(unit, line_prefix, parameter_name, parameter_value, idx)

    use mod_types
    use mod_convert_type

    implicit none
    integer, intent(in) :: unit
    character(len=*), intent(in) :: parameter_name, line_prefix
    real(SPR), intent(in) :: parameter_value
    integer, intent(in), optional :: idx
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(idx)) then
       if (unit < 0) then
          write(*, "(a,tr1,a,i0,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // &
               "(", idx, ")` = " // to_string(parameter_value) // "."
       else
          write(unit, "(a,tr1,a,i0,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // &
               "(", idx, ")` = " // to_string(parameter_value) // "."
       endif
    else
       if (unit < 0) then
          write(*, "(a,tr1,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // "` = " // &
               to_string(parameter_value) // "."
       else
          write(unit, "(a,tr1,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // "` = " // &
               to_string(parameter_value) // "."
       endif
    endif

  end subroutine write_parameter_SPR

!#======================================================================

  subroutine write_parameter_DPR(unit, line_prefix, parameter_name, parameter_value, idx)

    use mod_types
    use mod_convert_type

    implicit none
    integer, intent(in) :: unit
    character(len=*), intent(in) :: parameter_name, line_prefix
    real(DPR), intent(in) :: parameter_value
    integer, intent(in), optional :: idx
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(idx)) then
       if (unit < 0) then
          write(*, "(a,tr1,a,i0,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // &
               "(", idx, ")` = " // to_string(parameter_value) // "."
       else
          write(unit, "(a,tr1,a,i0,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // &
               "(", idx, ")` = " // to_string(parameter_value) // "."
       endif
    else
       if (unit < 0) then
          write(*, "(a,tr1,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // "` = " // &
               to_string(parameter_value) // "."
       else
          write(unit, "(a,tr1,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // "` = " // &
               to_string(parameter_value) // "."
       endif
    endif

  end subroutine write_parameter_DPR

!#======================================================================

  subroutine write_parameter_bool(unit, line_prefix, parameter_name, parameter_value, idx)

    use mod_convert_type

    implicit none
    integer, intent(in) :: unit
    character(len=*), intent(in) :: parameter_name, line_prefix
    logical, intent(in) :: parameter_value
    integer, intent(in), optional :: idx
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(idx)) then
       if (unit < 0) then
          write(*, "(a,tr1,a,i0,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // &
               "(", idx, ")` = " // to_string(parameter_value) // "."
       else
          write(unit, "(a,tr1,a,i0,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // &
               "(", idx, ")` = " // to_string(parameter_value) // "."
       endif
    else
       if (unit < 0) then
          write(*, "(a,tr1,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // "` = " // &
               to_string(parameter_value) // "."
       else
          write(unit, "(a,tr1,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // "` = " // &
               to_string(parameter_value) // "."
       endif
    endif

  end subroutine write_parameter_bool

!#======================================================================

  subroutine write_parameter_string(unit, line_prefix, parameter_name, parameter_value, idx)

    use mod_convert_type
    use mod_strings, only : quote_string

    implicit none
    integer, intent(in) :: unit
    character(len=*), intent(in) :: parameter_name, line_prefix
    character(len=*), intent(in) :: parameter_value
    integer, intent(in), optional :: idx
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(idx)) then
       if (unit < 0) then
          write(*, "(a,tr1,a,i0,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // &
               "(", idx, ")` = " // quote_string(adjustl(parameter_value)) // "."
       else
          write(unit, "(a,tr1,a,i0,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // &
               "(", idx, ")` = " // quote_string(adjustl(parameter_value)) // "."
       endif
    else
       if (unit < 0) then
          write(*, "(a,tr1,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // "` = " // &
               quote_string(adjustl(parameter_value)) // "."
       else
          write(unit, "(a,tr1,a)") trim(line_prefix), &
               "`" // trim(adjustl(parameter_name)) // "` = " // &
               quote_string(adjustl(parameter_value)) // "."
       endif
    endif

  end subroutine write_parameter_string

!#======================================================================

  subroutine write_seed(unit, line_prefix, dim_seed, seed)

    use mod_parse_file, only : len_max_line
    implicit none
    integer, intent(in) :: unit, dim_seed
    character(len=*), intent(in) :: line_prefix
    integer, dimension(:), intent(in) :: seed
!#......................................................................
    integer, parameter :: len_max_seed = len_max_line
    character(len=len_max_seed) :: seed_string, seed_string_aux
    integer :: len_seed, len_seed_aux, i_seed, horiz_shift
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    write(seed_string, "(a,tr1,a,i0,a)") trim(line_prefix), "`seed(1:", dim_seed, ")` ="
    len_seed = len_trim(seed_string)
    horiz_shift = len_seed + 1 -len_trim(line_prefix)
    if (dim_seed == 1) then
       write(seed_string_aux, "(a,i0,a)") " [", seed(1), "]."
       len_seed_aux = len_trim(seed_string_aux)
       if (len_seed + len_seed_aux > len_max_seed-2) then
!# Line too long. Break it.
          if (unit < 0) then
             write(*, "(a)") trim(seed_string) // " &"
          else
             write(unit, "(a)") trim(seed_string) // " &"
          endif
          seed_string = trim(line_prefix) // repeat(" ", horiz_shift) // seed_string_aux
          len_seed = len_trim(seed_string)
       else
          seed_string = trim(seed_string) // seed_string_aux
          len_seed = len_seed + len_seed_aux
       endif
       if (unit < 0) then
          write(*, "(a)") trim(seed_string)
       else
          write(unit, "(a)") trim(seed_string)
       endif
    else
       do i_seed = 1, dim_seed
          if (i_seed == 1) then
             write(seed_string_aux, "(a,i0,a)") " [", seed(1), ","
          else if (i_seed == dim_seed) then
             write(seed_string_aux, "(tr1,i0,a)") seed(dim_seed), "]."
          else
             write(seed_string_aux, "(tr1,i0,a)") seed(i_seed), ","
          endif
          len_seed_aux = len_trim(seed_string_aux)
          if (len_seed + len_seed_aux > len_max_seed-2) then
!# Line too long. Break it.
             if (unit < 0) then
                write(*, "(a)") trim(seed_string) // " &"
             else
                write(unit, "(a)") trim(seed_string) // " &"
             endif
             seed_string = trim(line_prefix) // repeat(" ", horiz_shift) // seed_string_aux
             len_seed = len_trim(seed_string)
          else
             seed_string = trim(seed_string) // seed_string_aux
             len_seed = len_seed + len_seed_aux
          endif
          if (i_seed == dim_seed) then
             if (unit < 0) then
                write(*, "(a)") trim(seed_string)
             else
                write(unit, "(a)") trim(seed_string)
             endif
          endif
       enddo
    endif

  end subroutine write_seed

end module mod_write_scenario_param

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_magnit

  use mod_types
  use mod_hash
  use mod_colors, only : dim_output_age
  use mod_filters_constants, only : undefined_mag

  implicit none
  private
  interface magnit
     module procedure magnit_scal, magnit_arr
  end interface magnit
  interface lum_band
     module procedure lum_band_scal, lum_band_arr
  end interface lum_band
  interface lum_band_rel_Sun
     module procedure lum_band_rel_Sun_scal, lum_band_rel_Sun_arr
  end interface lum_band_rel_Sun
  interface color
     module procedure color_scal, color_arr
  end interface color
  interface L_line
     module procedure L_line_scal, L_line_arr
  end interface L_line
  interface eq_width
     module procedure eq_width_scal, eq_width_arr
  end interface eq_width
  interface ISM_abund
     module procedure ISM_abund_scal, ISM_abund_arr
  end interface ISM_abund

  type(struct_hash), dimension(:), pointer, save :: hash_filter => null()
  integer, save :: dim_hash_filter

  type(struct_hash), dimension(:), pointer, save :: hash_line => null()
  integer, save :: dim_hash_line

  type(struct_hash), dimension(:), pointer, save :: hash_elem => null()
  integer, save :: dim_hash_elem

  real(DPR), dimension(:,:), allocatable, save :: magnit_aux !# Absolute magnitude.
  real(DPR), dimension(:,:), allocatable, save :: lum_band_aux
  real(DPR), dimension(:,:), allocatable, save :: L_line_aux
  real(DPR), dimension(:,:), allocatable, save :: eq_width_aux
  real(DPR), dimension(:,:), allocatable, save :: ISM_abund_aux

  real(DPR), dimension(:), allocatable, save :: lum_band_Sun
  public :: magnit, lum_band, lum_band_rel_Sun, color, L_line, eq_width, ISM_abund, &
       hash_filter, dim_hash_filter, hash_line, dim_hash_line, hash_elem, dim_hash_elem, &
       magnit_aux, lum_band_aux, lum_band_Sun, L_line_aux, eq_width_aux, ISM_abund_aux

contains

!#======================================================================
  
  function magnit_scal(i_output_age, filter_id)

    implicit none
    character(len=*), intent(in) :: filter_id
    integer, intent(in) :: i_output_age
    real(DPR) :: magnit_scal
!#......................................................................
    integer :: i_filter
    logical :: failed
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    i_filter = hash_index(filter_id, hash_filter, failed)
    if (failed) then
       write(*,"(a)") """" // trim(filter_id) // &
            """: this identifier does not correspond to any filter. Stopped."
       stop
    endif
    magnit_scal = magnit_aux(i_output_age, i_filter)

  end function magnit_scal

!#======================================================================

  function magnit_arr(filter_id)

    implicit none
    character(len=*), intent(in) :: filter_id
    real(DPR), dimension(dim_output_age) :: magnit_arr
!#......................................................................
    integer :: i_filter
    logical :: failed
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    i_filter = hash_index(filter_id, hash_filter, failed)
        if (failed) then
       write(*,"(a)") """" // trim(filter_id) // &
            """: this identifier does not correspond to any filter. Stopped."
       stop
    endif
    magnit_arr(1:dim_output_age) = magnit_aux(1:dim_output_age, i_filter)

  end function magnit_arr

!#======================================================================

  function lum_band_scal(i_output_age, filter_id)

    implicit none
    character(len=*), intent(in) :: filter_id
    integer, intent(in) :: i_output_age
    real(DPR) :: lum_band_scal
!#......................................................................
    integer :: i_filter
    logical :: failed
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    i_filter = hash_index(filter_id, hash_filter, failed)
    if (failed) then
       write(*,"(a)") """" // trim(filter_id) // &
            """: this identifier does not correspond to any filter. Stopped."
       stop
    endif
    lum_band_scal = lum_band_aux(i_output_age, i_filter)

  end function lum_band_scal

!#======================================================================

  function lum_band_arr(filter_id)

    implicit none
    character(len=*), intent(in) :: filter_id
    real(DPR), dimension(dim_output_age) :: lum_band_arr
!#......................................................................
    integer :: i_filter
    logical :: failed
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    i_filter = hash_index(filter_id, hash_filter, failed)
    if (failed) then
       write(*,"(a)") """" // trim(filter_id) // &
            """: this identifier does not correspond to any filter. Stopped."
       stop
    endif
    lum_band_arr(1:dim_output_age) = lum_band_aux(1:dim_output_age, i_filter)

  end function lum_band_arr

!#======================================================================

  function lum_band_rel_Sun_scal(i_output_age, filter_id)

    implicit none
    character(len=*), intent(in) :: filter_id
    integer, intent(in) :: i_output_age
    real(DPR) :: lum_band_rel_Sun_scal
!#......................................................................
    integer :: i_filter
    logical :: failed
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::  

    i_filter = hash_index(filter_id, hash_filter, failed)
    if (failed) then
       write(*,"(a)") """" // trim(filter_id) // &
            """: this identifier does not correspond to any filter. Stopped."
       stop
    endif
    lum_band_rel_Sun_scal = lum_band_aux(i_output_age, i_filter)/lum_band_Sun(i_filter)

  end function lum_band_rel_Sun_scal

!#======================================================================

  function lum_band_rel_Sun_arr(filter_id)

    implicit none
    character(len=*), intent(in) :: filter_id
    real(DPR), dimension(dim_output_age) :: lum_band_rel_Sun_arr
!#......................................................................
    integer :: i_filter
    logical :: failed
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    i_filter = hash_index(filter_id, hash_filter, failed)
    if (failed) then
       write(*,"(a)") """" // trim(filter_id) // &
            """: this identifier does not correspond to any filter. Stopped."
       stop
    endif
    lum_band_rel_Sun_arr(1:dim_output_age) = lum_band_aux(1:dim_output_age, i_filter)/lum_band_Sun(i_filter)

  end function lum_band_rel_Sun_arr

!#======================================================================

  function color_scal(i_output_age, filter1_id, filter2_id)

    implicit none
    character(len=*), intent(in) :: filter1_id, filter2_id
    integer, intent(in) :: i_output_age
    real(DPR) :: color_scal
!#......................................................................
    integer :: i_filter1, i_filter2
    logical :: failed
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    i_filter1 = hash_index(filter1_id, hash_filter, failed)
    if (failed) then
       write(*,"(a)") """" // trim(filter1_id) // &
            """: this identifier does not correspond to any filter. Stopped."
       stop
    endif

    i_filter2 = hash_index(filter2_id, hash_filter, failed)
    if (failed) then
       write(*,"(a)") """" // trim(filter2_id) // &
            """: this identifier does not correspond to any filter. Stopped."
       stop
    endif

    if (magnit_aux(i_output_age, i_filter1) /= undefined_mag .and. &
         magnit_aux(i_output_age, i_filter2) /= undefined_mag) then
       color_scal = magnit_aux(i_output_age, i_filter1) - magnit_aux(i_output_age, i_filter2)
    else
       color_scal = undefined_mag
    endif

  end function color_scal

!#======================================================================

  function color_arr(filter1_id, filter2_id)

    implicit none
    character(len=*), intent(in) :: filter1_id, filter2_id
    real(DPR), dimension(dim_output_age) :: color_arr
!#......................................................................
    integer :: i_filter1, i_filter2
    logical :: failed
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    i_filter1 = hash_index(filter1_id, hash_filter, failed)
    if (failed) then
       write(*,"(a)") """" // trim(filter1_id) // &
            """: this identifier does not correspond to any filter. Stopped."
       stop
    endif

    i_filter2 = hash_index(filter2_id, hash_filter, failed)
    if (failed) then
       write(*,"(a)") """" // trim(filter2_id) // &
            """: this identifier does not correspond to any filter. Stopped."
       stop
    endif

    where (magnit_aux(:, i_filter1) /= undefined_mag .and. magnit_aux(:, i_filter2) /= undefined_mag)
       color_arr(:) = magnit_aux(:, i_filter1) - magnit_aux(:, i_filter2)
    elsewhere
       color_arr(:) = undefined_mag
    end where

  end function color_arr

!#======================================================================

  function L_line_scal(i_output_age, line_id)

    implicit none
    character(len=*), intent(in) :: line_id
    integer, intent(in) :: i_output_age
    real(DPR) :: L_line_scal
!#......................................................................
    integer :: i_line
    logical :: failed
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    i_line = hash_index(line_id, hash_line, failed)
    if (failed) then
       write(*,"(a)") """" // trim(line_id) // &
            """: this identifier does not correspond to any emission line. Stopped."
       stop
    endif
    L_line_scal = L_line_aux(i_output_age, i_line)

  end function L_line_scal

!#======================================================================

  function L_line_arr(line_id)

    implicit none
    character(len=*), intent(in) :: line_id
    real(DPR), dimension(dim_output_age) :: L_line_arr
!#......................................................................
    integer :: i_line
    logical :: failed
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    i_line = hash_index(line_id, hash_line, failed)
    if (failed) then
       write(*,"(a)") """" // trim(line_id) // &
            """: this identifier does not correspond to any emission line. Stopped."
       stop
    endif
    L_line_arr(1:dim_output_age) = L_line_aux(1:dim_output_age, i_line)

  end function L_line_arr

!#======================================================================

  function eq_width_scal(i_output_age, line_id)

    implicit none
    character(len=*), intent(in) :: line_id
    integer, intent(in) :: i_output_age
    real(DPR) :: eq_width_scal
!#......................................................................
    integer :: i_line
    logical :: failed
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    i_line = hash_index(line_id, hash_line, failed)
    if (failed) then
       write(*,"(a)") """" // trim(line_id) // &
            """: this identifier does not correspond to any emission line. Stopped."
       stop
    endif
    eq_width_scal = eq_width_aux(i_output_age, i_line)

  end function eq_width_scal

!#======================================================================

  function eq_width_arr(line_id)

    implicit none
    character(len=*), intent(in) :: line_id
    real(DPR), dimension(dim_output_age) :: eq_width_arr
!#......................................................................
    integer :: i_line
    logical :: failed
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    i_line = hash_index(line_id, hash_line, failed)
    if (failed) then
       write(*,"(a)") """" // trim(line_id) // &
            """: this identifier does not correspond to any emission line. Stopped."
       stop
    endif
    eq_width_arr(1:dim_output_age) = eq_width_aux(1:dim_output_age, i_line)

  end function eq_width_arr

!#======================================================================
  
  function ISM_abund_scal(i_output_age, elem_id)

    implicit none
    character(len=*), intent(in) :: elem_id
    integer, intent(in) :: i_output_age
    real(DPR) :: ISM_abund_scal
!#......................................................................
    integer :: i_elem
    logical :: failed
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    i_elem = hash_index(elem_id, hash_elem, failed)
    if (failed) then
       write(*,"(a)") """" // trim(elem_id) // &
            """: this identifier does not correspond to any element. Stopped."
       stop
    endif
    ISM_abund_scal = ISM_abund_aux(i_output_age, i_elem)

  end function ISM_abund_scal

!#======================================================================

  function ISM_abund_arr(elem_id)

    implicit none
    character(len=*), intent(in) :: elem_id
    real(DPR), dimension(dim_output_age) :: ISM_abund_arr
!#......................................................................
    integer :: i_elem
    logical :: failed
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    i_elem = hash_index(elem_id, hash_elem, failed)
    if (failed) then
       write(*,"(a)") """" // trim(elem_id) // &
            """: this identifier does not correspond to any element. Stopped."
       stop
    endif
    ISM_abund_arr(1:dim_output_age) = ISM_abund_aux(1:dim_output_age, i_elem)

  end function ISM_abund_arr

end module mod_magnit

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_loc

  use mod_types

  implicit none
  private

  interface min_loc
     module procedure min_loc_i, min_loc_s, min_loc_d
  end interface

  interface max_loc
     module procedure max_loc_i, max_loc_s, max_loc_d
  end interface

  public :: min_loc, max_loc, i_loc
  
contains

!#======================================================================

  function min_loc_i(array, mask, default)

    implicit none
    integer, dimension(:), intent(in) :: array
    logical, dimension(size(array)), optional, intent(in) :: mask
    integer, optional, intent(in) :: default
    integer :: min_loc_i
!#......................................................................
    integer, dimension(1) :: loc
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(mask)) then
       if (any(mask)) then
          loc = minloc(array, mask)
       else
          if (present(default)) then
             loc = default
          else
             loc = 0
          endif
       endif
    else
       loc = minloc(array)
    endif
    min_loc_i = loc(1)

  end function min_loc_i

!#======================================================================

  function min_loc_s(array, mask, default)

    implicit none
    real(SPR), dimension(:), intent(in) :: array
    logical, dimension(size(array)), optional, intent(in) :: mask
    integer, optional, intent(in) :: default
    integer :: min_loc_s
!#......................................................................
    integer, dimension(1) :: loc
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    if (present(mask)) then
       if (any(mask)) then
          loc = minloc(array, mask)
       else
          if (present(default)) then
             loc = default
          else
             loc = 0
          endif
       endif
    else
       loc = minloc(array)
    endif
    min_loc_s = loc(1)

  end function min_loc_s

!#======================================================================

  function min_loc_d(array, mask, default)

    implicit none
    real(DPR), dimension(:), intent(in) :: array
    logical, dimension(size(array)), optional, intent(in) :: mask
    integer, optional, intent(in) :: default
    integer :: min_loc_d
!#......................................................................
    integer, dimension(1) :: loc
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(mask)) then
       if (any(mask)) then
          loc = minloc(array, mask)
       else
          if (present(default)) then
             loc = default
          else
             loc = 0
          endif
       endif
    else
       loc = minloc(array)
    endif
    min_loc_d = loc(1)

  end function min_loc_d

!#======================================================================

  function max_loc_i(array, mask, default)

    implicit none
    integer, dimension(:), intent(in) :: array
    logical, dimension(size(array)), optional, intent(in) :: mask
    integer, optional, intent(in) :: default
    integer :: max_loc_i
!#......................................................................
    integer, dimension(1) :: loc
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(mask)) then
       if (any(mask)) then
          loc = maxloc(array, mask)
       else
          if (present(default)) then
             loc = default
          else
             loc = 0
          endif
       endif
    else
       loc = maxloc(array)
    endif
    max_loc_i = loc(1)

  end function max_loc_i

!#======================================================================

  function max_loc_s(array, mask, default)

    implicit none
    real(SPR), dimension(:), intent(in) :: array
    logical, dimension(size(array)), optional, intent(in) :: mask
    integer, optional, intent(in) :: default
    integer :: max_loc_s
!#......................................................................
    integer, dimension(1) :: loc
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    if (present(mask)) then
       if (any(mask)) then
          loc = maxloc(array, mask)
       else
          if (present(default)) then
             loc = default
          else
             loc = 0
          endif
       endif
    else
       loc = maxloc(array)
    endif
    max_loc_s = loc(1)

  end function max_loc_s

!#======================================================================

  function max_loc_d(array, mask, default)

    implicit none
    real(DPR), dimension(:), intent(in) :: array
    logical, dimension(size(array)), optional, intent(in) :: mask
    integer, optional, intent(in) :: default
    integer :: max_loc_d
!#......................................................................
    integer, dimension(1) :: loc
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(mask)) then
       if (any(mask)) then
          loc = maxloc(array, mask)
       else
          if (present(default)) then
             loc = default
          else
             loc = 0
          endif
       endif
    else
       loc = maxloc(array)
    endif
    max_loc_d = loc(1)

  end function max_loc_d

!#======================================================================

  function i_loc(array, val)
    
    implicit none
    integer :: i_loc
    character(len=*), dimension(:), intent(in) :: array
    character(len=*), intent(in) :: val
!#......................................................................
    integer :: i
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    i_loc = 0
    do i = 1, size(array)
       if (array(i) == val) then
          i_loc = i
          exit
       endif
    enddo
    
  end function i_loc

end module mod_loc

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_file_access

  use mod_strings, only : down_case
  use mod_dir_access, only : home_dir
  use mod_types, only : std_int
  implicit none
  private
  integer, parameter :: input_unit = 5, output_unit = 6, error_unit = 0 !# Usual values \
!# for inputs from the keyboard (stdin), outputs to the terminal (stdout) and error messages (stderr).
  integer, parameter :: unit_min = max(input_unit, output_unit, error_unit, &
       0_std_int) + 1, unit_max = 999

  type :: lk_lst_path
     character(len=132) :: val
     type(lk_lst_path), pointer :: parent => null()
     type(lk_lst_path), pointer :: child => null()
  end type lk_lst_path

  public :: open_file, get_unit, skip_comment_lines, skip_lines, close_file, &
       file_name_decomposition, path_file, extract_path, base_name, &
       file_name_components

contains

!#======================================================================
  
  subroutine open_file(unit, file, status, position, action, delim, form, &
       exist, iostat, skip)

!# `skip` is a boolean set to `.true.` (default) to skip comment lines (empty 
!# lines or lines beginning with "!") at the beginning of a file. 
!#
!# Caution if overwriting a file, even with `position = "rewind`: by defaut, 
!# writing will begin after initial comment lines!

    use mod_types, only : long_string
    implicit none
    integer, intent(out) :: unit !# ??? or `intent(inout)`?
    character(len=*), intent(in), optional :: file !# Optional for scratch \
!# files.
    character(len=*), optional, intent(in) :: action, status, position, &
         delim, form
    logical, optional, intent(in) :: skip
    logical, optional, intent(out) :: exist
    integer, optional, intent(out) :: iostat
!#......................................................................
    integer, parameter :: n_char = max( &
         len("read"), len("write"), len("readwrite"), &  !# `action` values.
         len("old"), len("new"), len("replace"), &       !# `status` values.
         len("scratch"), len("unknown"), &               !# Idem.
         len("rewind"), len("append"), len("asis"), &    !# `position` values.
         len("apostrophe"), len("quote"), len("none"), & !# `delim` values.
         len("formatted"), len("unformatted"))           !# `form` values.
    character(len=n_char) :: action_def, status_def, position_def, &
         delim_def, form_def
    character(len=n_char) :: action_eff, status_eff, position_eff, &
         delim_eff, form_eff
    logical :: skip_def, skip_eff
    integer :: ios
    logical :: exist_val
    character(len=long_string) :: file_tmp
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    status_def = "old"
    action_def = "read"
    position_def = "rewind"
    delim_def = "quote"
    form_def = "formatted"
    skip_def = .true.
    if (present(status)) then
       status_eff = down_case(status)
    else
       status_eff = status_def
    endif
    if (status_eff /= "old") action_def = "readwrite"
    if (status_eff == "replace") skip_def = .false.
    if (present(action)) then
       action_eff = down_case(action)
    else
       action_eff = action_def
    endif
    if (action_eff /= "read") position_def = "append"
    if (present(position)) then
       position_eff = down_case(position)
    else
       position_eff = position_def
    endif
!# Note. With `position="append"` and `skip=.false.`, the `endfile` record is 
!# the next record (Fortran 95 standard, rule 9.3.34.7).
!# If `skip=.true.`, the code tries to read something. The position may then
!# be before or after the `endfile` record. This depends on the compiler 
!# (ifort, gfortran) and maybe on the version of gfortran.
    if (position_eff == "append") skip_def = .false.

    if (present(delim)) then
       delim_eff = down_case(delim)
    else
       delim_eff = delim_def
    endif
    if (present(form)) then
       form_eff = down_case(form)
    else
       form_eff = form_def
    endif
    if (present(skip)) then
       skip_eff = skip
    else
       skip_eff = skip_def
    endif

    if (status_eff /= "scratch") then
       file_tmp = adjustl(file)
       if (file_tmp(1:1) == "~") file_tmp = home_dir // file_tmp(3:)
       inquire(file = file_tmp, exist = exist_val)
       if (present(exist)) then
          exist = exist_val
!# Note: Windows does not seem to distinguish between uppercase 
!# and lowercase letters for filenames.
          if (exist .and. status_eff == "new") then
             write(*,*) "Error opening file """ // trim(adjustl(file)) // &
                  """: an existing file cannot have status ""new"". Stopped."
             stop
          else if (.not.exist .and. status_eff == "old") then
             write(*,*) "Error opening file """ // trim(adjustl(file)) // &
                  """: a non-existing file cannot have status ""old"". Stopped."
             stop
          endif
       else !# `exist` absent: proceed smoothly.
          if (.not.exist_val .and. status_eff == "old") status_eff = "new"
       endif
    endif

    call get_unit(unit)
    if (form == "unformatted") then
       if (status_eff == "scratch") then
          open(unit = unit, action = action_eff, &
               status = status_eff, position = position_eff, form = form_eff, &
               iostat = ios)
       else
          open(unit = unit, file = file_tmp, action = action_eff, &
               status = status_eff, position = position_eff, form = form_eff, &
               iostat = ios)
       endif
    else
       if (status_eff == "scratch") then
          open(unit = unit, action = action_eff, &
               status = status_eff, position = position_eff, delim = delim_eff, &
               form = form_eff, iostat = ios)
       else
          open(unit = unit, file = file_tmp, action = action_eff, &
               status = status_eff, position = position_eff, delim = delim_eff, &
               form = form_eff, iostat = ios)
       endif
    endif

    if (present(iostat)) then
       iostat = ios
    else
       if (ios /= 0) then
          write(*,*) "Error opening file """ // trim(adjustl(file)) // &
               """. Stopped."
          stop
       endif
    endif
    if (skip_eff) call skip_comment_lines(unit)

  end subroutine open_file

!#======================================================================

  subroutine get_unit(unit)
    
    implicit none
    integer, intent(out) :: unit
!#......................................................................
    integer :: i
    logical :: opened
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    unit = -1
    do i = unit_min, unit_max
       if (any((/input_unit, output_unit, error_unit/) == i)) cycle !# Not needed, \
!# given the definition of `unit_min`.
       inquire(unit = i, opened = opened)
       if (.not. opened) then
          unit = i
          exit
       endif
    enddo
    if (unit == (-1)) then
       write(*,*) "Error: all the units are used. Stopped."
       stop
    endif
    
  end subroutine get_unit

!#======================================================================

  subroutine skip_comment_lines(unit)
    
    use mod_types
    implicit none
    integer, intent(in) :: unit
!#......................................................................
    character(len=long_string) :: string
    integer :: ios
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    do
       read(unit, "(a)", iostat = ios) string
       if (ios /= 0) exit
       string = adjustl(string)
       if (string == "" .or. string(1:1) == "!") then
          cycle
       else
          backspace(unit)
          exit
       endif
    enddo
    write(unit, iostat=ios)

!# If this subroutine reaches the end of the file, the position is *after* the 
!# end of file with gfortran-6 and later versions, so one must backspace once 
!# to write something else. To do this, one can move the `backspace(unit)` 
!# after the `enddo`.
!# With ifort and some earlier versions of gfortran, the position reached when 
!# reading up to the end of the file is *before* the end of file, so one must 
!# not backspace to write something else (current implementation). 
!# (See https://gcc.gnu.org/bugzilla/show_bug.cgi?id=52860 .)
!#
!# The empty "write" statement `write(unit, iostat=ios)` seems to work in all 
!# cases and avoids to move the `backspace(unit)`, depending on the compiler.

  end subroutine skip_comment_lines

!#======================================================================

  subroutine skip_lines(unit, n_lines)
    
    implicit none
    integer, intent(in) :: unit, n_lines
!#......................................................................
    integer :: i_line, ios
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    do i_line = 1, n_lines
       read(unit, "(a)", iostat = ios) 
       if (ios /= 0) then
          write(*, "(a,i0,a)") "Could skip only ", i_line-1, " lines. Stopped."
          stop
       endif
    enddo

  end subroutine skip_lines

!#======================================================================

  subroutine close_file(unit)

    implicit none
    integer, intent(inout) :: unit
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    close(unit)
    unit = -1

  end subroutine close_file

!#======================================================================
  
  subroutine file_name_decomposition(full_name, dir_name, stem, &
       extension, base_name, dir_sep, ext_sep, absolute_path)

!# `full_name` = `dir_name` + `base_name`.
!# `base_name` = `stem` + `extension`.
!# If not void, the last non blank character of `dir_name` is `dir_sep_eff` 
!# (`/` in Unix).
!# If not void, the first character of `extension` is `ext_sep_eff`
!# (`.` normally).

    use mod_dir_access, only : dir_sep_def => dir_sep
    implicit none
    character(len=*), intent(in) :: full_name    
    character(len=1), intent(in), optional :: dir_sep, ext_sep
    character(len=len(full_name)), intent(out), optional :: &
         dir_name, stem, extension, base_name
    logical, intent(out), optional :: absolute_path
!#......................................................................
!    character(len=1), parameter :: dir_sep_def = "/"
    character(len=1) :: dir_sep_eff
    character(len=1), parameter :: ext_sep_def = "."
    character(len=1) :: ext_sep_eff
    character(len=len(full_name)) :: dir_name_eff, stem_eff, &
         extension_eff, base_name_eff
    integer :: pos
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(dir_sep)) then
       dir_sep_eff = dir_sep
    else
       dir_sep_eff = dir_sep_def
    endif

    pos = index(full_name, dir_sep_eff, back = .true.)
    dir_name_eff = adjustl(full_name(:pos))
    base_name_eff = adjustl(full_name(pos+1:))

    if (present(ext_sep)) then
       ext_sep_eff = ext_sep
    else
       ext_sep_eff = ext_sep_def
    endif

    pos = index(base_name_eff, ext_sep_eff, back = .true.)
    if (pos > 1) then !# "> 1" and not "> 0", so that hidden files (beginning
!# with a dot) will not be considered as extension if there is no other dot.
       stem_eff = base_name_eff(:pos-1)
       extension_eff = base_name_eff(pos:)
    else
       stem_eff = base_name_eff
       extension_eff = ""
    endif
    if (present(dir_name)) dir_name = dir_name_eff
    if (present(stem)) stem = stem_eff
    if (present(extension)) extension = extension_eff
    if (present(base_name)) base_name = base_name_eff
    if (present(absolute_path)) then
       if (dir_name_eff(1:1) == dir_sep_eff .or. dir_name_eff(1:1) == "~") then
          absolute_path = .true.
       else
          absolute_path = .false.
       endif
    endif

  end subroutine file_name_decomposition

!#======================================================================

  function path_file(path, file_name, dir_sep)

    use mod_dir_access, only : dir_sep_def => dir_sep
    use mod_types
    implicit none
    character(len=*), intent(in) :: path, file_name
    character(len=1), optional :: dir_sep
    character(len=len_trim(path)+len_trim(file_name)) :: path_file
!#......................................................................
!    character(len=1), parameter :: dir_sep_def = "/"
    character(len=1) :: dir_sep_eff
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(dir_sep)) then
       dir_sep_eff = dir_sep
    else
       dir_sep_eff = dir_sep_def
    endif

    call file_name_components(file_name=file_name, path=path, &
         full_name=path_file, dir_sep=dir_sep_eff)

  end function path_file

!#======================================================================

  function extract_path(dir_name, file_name, dir_sep)

    use mod_dir_access, only : dir_sep_def => dir_sep
    use mod_types
    implicit none
    character(len=*), intent(in) :: dir_name, file_name
    character(len=1), intent(in), optional :: dir_sep
    character(len=len_trim(dir_name)+len_trim(file_name)) :: extract_path
!#......................................................................
!    character(len=1), parameter :: dir_sep_def = "/"
    character(len=1) :: dir_sep_eff, first_char
    integer :: pos
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(dir_sep)) then
       dir_sep_eff = dir_sep
    else
       dir_sep_eff = dir_sep_def
    endif

    pos = index(file_name, dir_sep_eff, back = .true.)
    if (pos > 0) then
       first_char = file_name(1:1)
       if (first_char == dir_sep_eff .or. first_char == "~") then !# Absolute \
!# path given by `file_name`. Discard `dir_name`.
          extract_path = file_name(:pos)
       else !# Relative path.
          extract_path = trim(dir_name) // file_name(:pos) !???
       endif
    else
       extract_path = dir_name
    endif

  end function extract_path

!#======================================================================

  function base_name(file_name, dir_sep)

    use mod_dir_access, only : dir_sep_def => dir_sep
    use mod_types
    implicit none
    character(len=*), intent(in) :: file_name
    character(len=1), intent(in), optional :: dir_sep
    character(len=len_trim(file_name)) :: base_name
!#......................................................................
!    character(len=1), parameter :: dir_sep_def = "/"
    character(len=1) :: dir_sep_eff
    integer :: pos
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(dir_sep)) then
       dir_sep_eff = dir_sep
    else
       dir_sep_eff = dir_sep_def
    endif

    pos = index(file_name, dir_sep_eff, back = .true.)
    base_name = file_name(pos+1:)

  end function base_name

!#======================================================================
  
  subroutine file_name_components(file_name, path, full_name, dir_name, stem, &
       extension, base_name, dir_sep, ext_sep)

!# `file_name` is the input file name. It may begin with a path, absolute 
!# or relative.

!# `path` is the path to file pointed to by `file_name`. This path may be
!# completed or modified by `file_name`. If present, the value of `path` 
!# should end with `dir_sep_eff`.

!# `full_name` = `dir_name` + `base_name`.
!# `base_name` = `stem` + `extension`.
!# If not void, the last non blank character of `dir_name` is `dir_sep_eff` 
!# (`/` in Unix).
!# If not void, the first character of `extension` is `ext_sep_eff`
!# (`.` normally).

    use mod_dir_access, only : dir_sep_def => dir_sep
    use mod_types
    implicit none
    character(len=*), intent(in), optional :: file_name
    character(len=*), intent(in), optional :: path
    character(len=1), intent(in), optional :: dir_sep, ext_sep
    character(len=*), intent(out), optional :: &
         full_name, dir_name
    character(len=*), intent(out), optional :: &
         stem, extension, base_name
!#......................................................................
!    character(len=1), parameter :: dir_sep_def = "/"
    character(len=1) :: dir_sep_eff
    character(len=1), parameter :: ext_sep_def = "."
    character(len=1) :: ext_sep_eff
    character(len=0), parameter :: path_def = "", file_name_def = ""
    character(len=long_string) :: dir_name_eff
    character(len=long_string) :: stem_eff, extension_eff, base_name_eff, &
         path_eff, file_name_eff
    character(len=1) :: first_char
    type(lk_lst_path), pointer :: head_node => null(), current_node, &
         parent_node
    integer :: pos, length, pos2
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(dir_sep)) then
       dir_sep_eff = dir_sep
    else
       dir_sep_eff = dir_sep_def
    endif

    if (present(path)) then
       path_eff = adjustl(path)
       length = len_trim(path_eff)
       if (path_eff(length:length) /= dir_sep_eff) & !# Add directory \
!# separator at the end if forgotten.
            path_eff(length+1:length+1) = dir_sep_eff
       if (path_eff(1:1) == "~") path_eff = home_dir // path_eff(3:)
    else
       path_eff = path_def
    endif

    if (present(file_name)) then
       file_name_eff = adjustl(file_name)
    else
       file_name_eff = file_name_def
    endif
    
    pos = index(file_name_eff, dir_sep_eff, back = .true.)
    if (pos > 0) then
       first_char = file_name_eff(1:1)
       if (first_char == dir_sep_eff .or. first_char == "~") then !# Absolute \
!# path given by `file_name`. Discard `path`.
          if (first_char == "~") then
             full_name = home_dir // file_name_eff(3:)
          else
             full_name = file_name_eff
          endif
       else !# Relative path.
          full_name = trim(path_eff) // file_name_eff !???
       endif
    else
       full_name = trim(path_eff) // file_name_eff
    endif

    do !# Replace `//` (`\\`) by `/` (`\`).
       pos = index(full_name, dir_sep_eff // dir_sep_eff)
       if (pos == 0) exit
       if (full_name(pos+1:) /= dir_sep_eff) then
          full_name = full_name(:pos) // full_name(pos+2:)
       else !# Nothing after `//` (`\\`). Considered in case \
!# `pos+2 > len(full_name)`.
          full_name = full_name(:pos)
       endif
    enddo
    
    call lk_lst_initialize_path(head_node, current_node)

    pos = index(full_name, dir_sep_eff)
    if (pos == 0) then
       current_node % val = full_name
    else
       current_node % val = full_name(:pos)
       do
          pos2 = index(full_name(pos+1:), dir_sep_eff)
          call lk_lst_new_node_path(current_node)
          if (pos2 == 0) then
             current_node % val = full_name(pos+1:)
             exit
          else
             pos2 = pos + pos2
             current_node % val = full_name(pos+1:pos2)
             pos = pos2
          endif
       enddo
    endif
!# Last node: add `/` at the end if the last node is `.` or `..`.
    if (current_node % val == ".") then
       current_node % val = "." // dir_sep_eff
    else if (current_node % val == "..") then
       current_node % val = ".." // dir_sep_eff       
    endif

    current_node => head_node
    do
       if (.not.associated(current_node)) exit
       current_node => current_node % child
    enddo

    current_node => head_node
    do 
       if (.not.associated(current_node)) exit

!# `current_node = ./`.
       if (current_node % val == "." // dir_sep_eff) then
          parent_node => current_node % parent
          current_node => current_node % child
          current_node % parent => parent_node
          if (associated(parent_node)) then
             parent_node % child => current_node
          else !# `head_node = ./`.
             head_node => current_node             
          endif

!# `current_node = ../`.
       else if (current_node % val == ".." // dir_sep_eff) then
          parent_node => current_node % parent
          if (associated(parent_node)) then
             if (parent_node % val == dir_sep_eff) then
                write(*,"(a)") "Impossible path. Stopped."
                stop
             else if (parent_node % val(1:1) == "~") then
!# Let the calling program resolve `~/../` when executed.
                current_node => current_node % child
             else if (parent_node % val /= ".." // dir_sep_eff) then
                parent_node => parent_node % parent
                current_node => current_node % child
                parent_node % child => current_node
                if (associated(current_node)) then
                   current_node % parent => parent_node
                endif
             else !# All parent nodes should be equal to `../`.
                current_node => current_node % child
             endif
          else !# `current_node` is `head_node`.
             current_node => current_node % child
          endif
          
       else
          current_node => current_node % child
       endif
    enddo

    full_name = ""
    current_node => head_node
    do 
       if (.not.associated(current_node)) exit
       full_name = trim(full_name) // trim(current_node % val)
       current_node => current_node % child
    enddo
    call lk_lst_destroy_path(head_node)

    pos = index(full_name, dir_sep_eff, back = .true.)
    dir_name_eff = adjustl(full_name(:pos))
    base_name_eff = adjustl(full_name(pos+1:))

    if (present(ext_sep)) then
       ext_sep_eff = ext_sep
    else
       ext_sep_eff = ext_sep_def
    endif

    pos = index(base_name_eff, ext_sep_eff, back = .true.)
    if (pos > 1) then !# "> 1" and not "> 0", so that hidden files (beginning
!# with a dot) will not be considered as extension if there is no other dot.
       stem_eff = base_name_eff(:pos-1)
       extension_eff = base_name_eff(pos:)
    else
       stem_eff = base_name_eff
       extension_eff = ""
    endif
    if (present(dir_name)) dir_name = dir_name_eff
    if (present(stem)) stem = stem_eff
    if (present(extension)) extension = extension_eff
    if (present(base_name)) base_name = base_name_eff

  end subroutine file_name_components

!#======================================================================

  subroutine lk_lst_destroy_path(head_node)

    implicit none
    type(lk_lst_path), pointer :: head_node
!#......................................................................
    type(lk_lst_path), pointer :: current_node, next_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Delete linked list, if already existing.
    current_node => head_node
    do
       if (.not.associated(current_node)) exit
       next_node => current_node % child
       if (associated(next_node)) nullify(next_node % parent)
       deallocate(current_node)
       current_node => next_node
    enddo
    nullify(head_node)

  end subroutine lk_lst_destroy_path

!#======================================================================

  subroutine lk_lst_initialize_path(head_node, current_node)

    implicit none
    type(lk_lst_path), pointer :: head_node, current_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Delete linked list, if already existing.
    call lk_lst_destroy_path(head_node)

!# Set the head of the linked list.
    allocate(head_node)
    nullify(head_node % parent)
    nullify(head_node % child)
    current_node => head_node
    
  end subroutine lk_lst_initialize_path

!#======================================================================

  subroutine lk_lst_new_node_path(current_node)

    implicit none
    type(lk_lst_path), pointer :: current_node
!#......................................................................
    type(lk_lst_path), pointer :: parent_node
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    allocate(current_node % child)
    parent_node => current_node
    current_node => current_node % child
    current_node % parent => parent_node
    nullify(current_node % child)

  end subroutine lk_lst_new_node_path

end module mod_file_access

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_colors

  use mod_types
  use mod_linked_list

  implicit none
  private

  integer,save :: dim_col = 0

  integer, save :: unit_colors, dim_output_age
  real(CDR), dimension(:), pointer, save :: output_age => null()
  type(lk_lst_CDR), dimension(:), pointer, save :: row => null()
  type(lk_lst_long_string), save :: fmt

  interface add_column
     module procedure add_column_SPR, add_column_DPR
  end interface add_column

  public :: add_column, write_table, unit_colors, dim_output_age, output_age

contains
  
!#======================================================================
  
  subroutine add_column_SPR(column_heading, column, fmt_col)

    use mod_convert_type, only : to_string

    implicit none
    character(len=*) :: column_heading
    real(SPR), dimension(:), intent(in) :: column
    character(len=*), optional :: fmt_col
!#......................................................................
    character(std_string) :: fmt_col_eff, fmt_col_def = "f8.3"
    integer :: heading_width, content_width, pos_digit, pos_point
    character(std_string) :: left, right
    integer :: i_output_age, ios
    type(lk_lst_CDR), dimension(:), pointer, save :: row_node => null()
    type(lk_lst_long_string), pointer, save :: fmt_node => null()
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
!# Set the content width.
    if (present(fmt_col)) then
       fmt_col_eff = fmt_col
    else
       fmt_col_eff = fmt_col_def
    endif

    if (dim_col == 0) then
       write(unit_colors, "(a8,tr2)", advance="no", iostat=ios) "   age  "
!# Needed because of the gfortran bug mentionned in subroutine `skip_comment_lines`
!# of "mod_file_access.f90": {
       if (ios /= 0)  write(unit_colors, "(a8,tr2)", advance="no", iostat=ios) "   age  "
!# }
       call lk_lst_initialize(fmt)
       if (associated(row)) deallocate(row)
       allocate(row(size(column)))
       if (associated(row_node)) deallocate(row_node)
       allocate(row_node(size(column)))
       do i_output_age = 1, size(column)
          call lk_lst_initialize(row(i_output_age))
       enddo
    endif
    pos_digit = scan(fmt_col_eff, "0123456789")
    pos_point = index(fmt_col_eff, ".")
    read(fmt_col_eff(pos_digit:pos_point-1),*) content_width

!# Format and write the column heading.
    heading_width = len_trim(adjustl(column_heading))
    if (max(content_width-heading_width,0)/2 > 0) then
       left = "(tr" // to_string(max(content_width-heading_width,0)/2) // ","
    else
       left = "("
    endif
    if (max(content_width-heading_width,0)-max(content_width-heading_width,0)/2 > 0) then
       right = ",tr" // to_string(max(content_width-heading_width,0)- &
            max(content_width-heading_width,0)/2) // ","
    else
       right = ","
    endif

    write(unit_colors, &
         trim(adjustl(left)) // "a" // trim(adjustl(right)) // "tr2)", &
         advance="no") adjustl(column_heading)

!# Format the column content and fill a new column in array.

    if (max(heading_width-content_width,0)/2 > 0) then
       left = "tr" // to_string(max(heading_width-content_width,0)/2) // ","
    else
       left = ""
    endif
    if (max(heading_width-content_width,0)-max(heading_width-content_width,0)/2 > 0) then
       right = ",tr" // to_string(max(heading_width-content_width,0)- &
            max(heading_width-content_width,0)/2)
    else
       right = ""
    endif
    call lk_lst_new_node(fmt, fmt_node)
    fmt_node % val = "(tr2," // trim(adjustl(left)) // &
         trim(fmt_col_eff) // trim(adjustl(right)) // ")"

    dim_col = dim_col+1
    do i_output_age = 1, size(column)
       call lk_lst_new_node(row(i_output_age), row_node(i_output_age) % ptr)
       row_node(i_output_age) % ptr % val = column(i_output_age)
    enddo

  end subroutine add_column_SPR

!#======================================================================

  subroutine add_column_DPR(column_heading, column, fmt_col)

    use mod_convert_type, only : to_string
    
    implicit none
    character(len=*) :: column_heading
    real(DPR), dimension(:), intent(in) :: column
    character(len=*), optional :: fmt_col
!#......................................................................
    character(std_string) :: fmt_col_eff, fmt_col_def = "f8.3"
    integer :: heading_width, content_width, pos_digit, pos_point
    character(std_string) :: left, right
    integer :: i_output_age, ios
    type(lk_lst_CDR), dimension(:), pointer, save :: row_node => null()
    type(lk_lst_long_string), pointer, save :: fmt_node => null()
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
!# Set the content width.
    if (present(fmt_col)) then
       fmt_col_eff = fmt_col
    else
       fmt_col_eff = fmt_col_def
    endif

    if (dim_col == 0) then
       write(unit_colors, "(a8,tr2)", advance="no", iostat=ios) "   age  "
!# Needed because of the gfortran bug mentionned in subroutine `skip_comment_lines`
!# of "mod_file_access.f90": {
       if (ios /= 0)  write(unit_colors, "(a8,tr2)", advance="no", iostat=ios) "   agee  "
!# }
       call lk_lst_initialize(fmt)
       if (associated(row)) deallocate(row)
       allocate(row(size(column)))
       if (associated(row_node)) deallocate(row_node)
       allocate(row_node(size(column)))
       do i_output_age = 1, size(column)
          call lk_lst_initialize(row(i_output_age))
       enddo
    endif
    pos_digit = scan(fmt_col_eff, "0123456789")
    pos_point = index(fmt_col_eff, ".")
    read(fmt_col_eff(pos_digit:pos_point-1),*) content_width

!# Format and write the column heading.
    heading_width = len_trim(adjustl(column_heading))
    if (max(content_width-heading_width,0)/2 > 0) then
       left = "(tr" // to_string(max(content_width-heading_width,0)/2) // ","
    else
       left = "("
    endif
    if (max(content_width-heading_width,0)-max(content_width-heading_width,0)/2 > 0) then
       right = ",tr" // to_string(max(content_width-heading_width,0)- &
            max(content_width-heading_width,0)/2) // ","
    else
       right = ","
    endif

    write(unit_colors, &
         trim(adjustl(left)) // "a" // trim(adjustl(right)) // "tr2)", &
         advance="no") adjustl(column_heading)

!# Format the column content and fill a new column in array.

    if (max(heading_width-content_width,0)/2 > 0) then
       left = "tr" // to_string(max(heading_width-content_width,0)/2) // ","
    else
       left = ""
    endif
    if (max(heading_width-content_width,0)-max(heading_width-content_width,0)/2 > 0) then
       right = ",tr" // to_string(max(heading_width-content_width,0)- &
            max(heading_width-content_width,0)/2)
    else
       right = ""
    endif
    call lk_lst_new_node(fmt, fmt_node)
    fmt_node % val = "(tr2," // trim(adjustl(left)) //  &
         trim(fmt_col_eff) // trim(adjustl(right)) // ")"

    dim_col = dim_col+1
    do i_output_age = 1, size(column)
       call lk_lst_new_node(row(i_output_age), row_node(i_output_age) % ptr)
       row_node(i_output_age) % ptr % val = column(i_output_age)
    enddo

  end subroutine add_column_DPR

!#======================================================================

  subroutine write_table

    implicit none
!#......................................................................
    integer :: i_output_age, i_col
    type(lk_lst_long_string), pointer :: fmt_node => null()
    type(lk_lst_CDR), pointer :: row_node => null()
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    write(unit_colors,*) !# To finish the line of headings and move to the next one.
    do i_output_age = 1, dim_output_age
       fmt_node => fmt % ptr
       row_node => row(i_output_age) % ptr
       write(unit_colors, "(f8.2)", advance="no") output_age(i_output_age)
       do i_col = 1, dim_col-1
          write(unit_colors, fmt_node % val, advance="no") row_node % val
          fmt_node => fmt_node % ptr
          row_node => row_node % ptr
       end do
       write(unit_colors, fmt_node % val, advance="yes") row_node % val
    enddo
    dim_col = 0    

  end subroutine write_table

end module mod_colors

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_SFC_DISM

  private
  public :: compute_stellar_spectrum, compute_nebular_spectrum, SFC_DISM_properties

contains

!#======================================================================

  subroutine compute_stellar_spectrum(convol_time, i_time, &
       dim_lambda_stel, beta, inv_time, lum_SSP, &
       SF_live_d_mass, &
       lum_stel_SFC_att_gas0, lum_stel_SFC_unatt0, &
       lum_stel_DISM_att_gas0, lum_stel_DISM_unatt0, &
       lum_stel_SFC0, &
       i_Lyman_break_stel, LC_gas_abs_birth_cloud, &
       LC_gas_abs_DISM, &
       dust_col_dens_birth_cloud, cloud_frac, &
       dim_species, grain_abs, species_weight, lambda_stel)

    use mod_types
    use mod_extinction, only : dust_optical_properties
    use mod_interp, only : Steffen3
    use mod_grain_properties, only : struct_grain_abs
    use mod_scenario, only : nebular_emission_SFC, nebular_emission_DISM, &
         extinction_SFC, cloud_duration

    implicit none
    real(CDR), dimension(:), intent(in) :: convol_time
    integer, intent(in) :: i_time
    integer, intent(in) :: dim_lambda_stel
    real(CDR), dimension(:), intent(out) :: lum_stel_SFC0
    real(CDR), dimension(:), intent(in) :: beta
    integer, dimension(:), intent(in) :: inv_time
    real(CDR), dimension(:, :, :), intent(in) :: lum_SSP
    real(DPR), dimension(:,:), intent(in) :: SF_live_d_mass
    integer, intent(in) :: i_Lyman_break_stel
    real(CDR), dimension(:), intent(in) :: LC_gas_abs_birth_cloud, &
         LC_gas_abs_DISM, dust_col_dens_birth_cloud, cloud_frac
    integer, intent(in) :: dim_species
    type(struct_grain_abs), dimension(:), intent(in) :: grain_abs
    real(CDR), dimension(:), intent(in) :: species_weight
    real(CDR), dimension(:), intent(in) :: lambda_stel
    real(CDR), dimension(:), intent(out) :: lum_stel_SFC_att_gas0, &
         lum_stel_SFC_unatt0, lum_stel_DISM_att_gas0, lum_stel_DISM_unatt0
!#......................................................................
    integer :: i_convol1, i_convol2
    integer :: i_lambda
    real(CDR) :: trans, albedo, asym, kappa_ext, tau_abs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Notations:
!#
!# `SFC`: star-forming clouds.
!#
!# `DISM`: diffuse interstellar medium,
!#
!# `lum_stel_*_unatt`: unattenuated emission of all stars in the medium.
!#
!# `lum_stel_*_att_gas`: emission of all stars in the medium,
!#     attenuated only by gas in the medium.
!#
!# `lum_stel_SFC`: emission of stars in star-forming clouds,
!#     attenuated by gas and dust in clouds only
!#     (if it were printed in the output file, should also be attenuated
!#     by gas and dust in the diffuse medium).

    lum_stel_SFC_unatt0(:) = 0
    lum_stel_SFC_att_gas0(:) = 0
    lum_stel_SFC0(:) = 0
    lum_stel_DISM_unatt0(:) = 0
    lum_stel_DISM_att_gas0(:) = 0

!# Unattenuated emission of stars:
    do i_convol1 = 1, i_time
       i_convol2 = i_time+1-i_convol1
       if (convol_time(i_convol2) <= cloud_duration) then
          do i_lambda = 1, dim_lambda_stel
             lum_stel_SFC_unatt0(i_lambda) = lum_stel_SFC_unatt0(i_lambda) &
                  + cloud_frac(i_convol2)*( &
                  beta(i_convol2)*sum(SF_live_d_mass(:,i_convol1)* &
                  lum_SSP(:,inv_time(i_convol2),i_lambda)) &
                  + (1-beta(i_convol2))*sum(SF_live_d_mass(:,i_convol1)* &
                  lum_SSP(:,inv_time(i_convol2)+1,i_lambda)))

             lum_stel_DISM_unatt0(i_lambda) = lum_stel_DISM_unatt0(i_lambda) &
                  + (1-cloud_frac(i_convol2))*( &
                  beta(i_convol2)*sum(SF_live_d_mass(:,i_convol1)* &
                  lum_SSP(:,inv_time(i_convol2),i_lambda)) &
                  + (1-beta(i_convol2))*sum(SF_live_d_mass(:,i_convol1)* &
                  lum_SSP(:,inv_time(i_convol2)+1,i_lambda)))
          enddo
       else !# Age > `cloud_duration`.
          do i_lambda = 1, dim_lambda_stel
!# `cloud_frac` = 0 for clusters older than `cloud_duration`: no contribution
!# to `lum_stel_SFC_unatt`.
             lum_stel_DISM_unatt0(i_lambda) = lum_stel_DISM_unatt0(i_lambda) &
                  + beta(i_convol2)*sum(SF_live_d_mass(:,i_convol1)* &
                  lum_SSP(:,inv_time(i_convol2),i_lambda)) &
                  + (1-beta(i_convol2))*sum(SF_live_d_mass(:,i_convol1)* &
                  lum_SSP(:,inv_time(i_convol2)+1,i_lambda))
          enddo
       endif
    enddo

!#----------------------------------------------------------------------

!# Transmitted emission of stars in star-forming clouds after attenuation by gas only:
    if (nebular_emission_SFC) then
       do i_convol1 = 1, i_time
          i_convol2 = i_time+1-i_convol1
          if (convol_time(i_convol2) <= cloud_duration) then
!# For Lyman continuum photons:
             do i_lambda = 1, i_Lyman_break_stel 
                lum_stel_SFC_att_gas0(i_lambda) = &
                     lum_stel_SFC_att_gas0(i_lambda) &
                     + cloud_frac(i_convol2)* &
                     (1-LC_gas_abs_birth_cloud(i_convol2))* &
                     (beta(i_convol2)*sum(SF_live_d_mass(:,i_convol1)* &
                     lum_SSP(:,inv_time(i_convol2),i_lambda)) &
                     + (1-beta(i_convol2))*sum(SF_live_d_mass(:,i_convol1)* &
                     lum_SSP(:,inv_time(i_convol2)+1,i_lambda)))
             enddo
          endif
       enddo

!# For non-ionizing photons:
       lum_stel_SFC_att_gas0(i_Lyman_break_stel+1:) = lum_stel_SFC_unatt0(i_Lyman_break_stel+1:)
    else !# `nebular_emission_SFC = .false.`.
       lum_stel_SFC_att_gas0(:) = lum_stel_SFC_unatt0(:)
    endif

!#----------------------------------------------------------------------

!# Transmitted emission of stars in the diffuse medium after attenuation by gas only:
    if (nebular_emission_DISM) then
       do i_convol1 = 1, i_time
          i_convol2 = i_time+1-i_convol1
          if (convol_time(i_convol2) <= cloud_duration) then
!# For Lyman continuum photons:
             do i_lambda = 1, i_Lyman_break_stel
                lum_stel_DISM_att_gas0(i_lambda) = &
                     lum_stel_DISM_att_gas0(i_lambda) &
                     + (1-cloud_frac(i_convol2))* &
                     (1-LC_gas_abs_DISM(i_convol2))* &
                     (beta(i_convol2)*sum(SF_live_d_mass(:,i_convol1)* &
                     lum_SSP(:,inv_time(i_convol2),i_lambda)) &
                     + (1-beta(i_convol2))*sum(SF_live_d_mass(:,i_convol1)* &
                     lum_SSP(:,inv_time(i_convol2)+1,i_lambda)))
             enddo

!# Note: Given the values of `LC_gas_abs_DISM` assigned in subroutine 
!# `SFC_DISM_properties` of "mod_extinction.f90", all Lyman continuum photons 
!# emitted by stars in the diffuse medium are assumed to be absorbed by gas, 
!# and only by gas, if they are young enough (age <= `HII_max_age`). 
!# (This excludes post-AGB stars, for instance, if `HII_max_age` = 50 Myr.)
!# As a consequence, `lum_stel_DISM_att_gas` is currently incremented 
!# in the Lyman continuum only for ages > `HII_max_age`.

          else !# `convol_time(i_convol2) > cloud_duration`.
!# `cloud_frac` = 0 for clusters older than `cloud_duration`: no contribution
!# to `lum_stel_SFC_att_gas`.
             do i_lambda = 1, i_Lyman_break_stel
                lum_stel_DISM_att_gas0(i_lambda) = &
                     lum_stel_DISM_att_gas0(i_lambda) &
                     + (1-LC_gas_abs_DISM(i_convol2))* &
                     (beta(i_convol2)*sum(SF_live_d_mass(:,i_convol1)* &
                     lum_SSP(:,inv_time(i_convol2),i_lambda)) &
                     + (1-beta(i_convol2))*sum(SF_live_d_mass(:,i_convol1)* &
                     lum_SSP(:,inv_time(i_convol2)+1,i_lambda)))
             end do
          endif
       enddo

!# For non-ionizing photons:
       lum_stel_DISM_att_gas0(i_Lyman_break_stel+1:) = lum_stel_DISM_unatt0(i_Lyman_break_stel+1:)
    else !# `nebular_emission_DISM = .false.`.
       lum_stel_DISM_att_gas0(:) = lum_stel_DISM_unatt0(:)
    endif

!#----------------------------------------------------------------------

!# Transmitted emission of stars after attenuation within star-forming clouds
!# by both gas and dust:
    if (extinction_SFC .and. nebular_emission_SFC) then
       do i_convol1 = 1, i_time
          i_convol2 = i_time+1-i_convol1
          if (convol_time(i_convol2) <= cloud_duration) then
             do i_lambda = i_Lyman_break_stel+1, dim_lambda_stel
                call dust_optical_properties(dim_species, grain_abs, &
                     lambda_stel(i_lambda), species_weight, kappa_ext, albedo, asym)
!# Assume scattering is forward only:
                tau_abs = kappa_ext*(1-albedo)*dust_col_dens_birth_cloud(i_convol2)
                trans = exp(-tau_abs)

                lum_stel_SFC0(i_lambda) = &
                     lum_stel_SFC0(i_lambda) + trans*cloud_frac(i_convol2)* &
                     (beta(i_convol2)*sum(SF_live_d_mass(:,i_convol1)* &
                     lum_SSP(:,inv_time(i_convol2),i_lambda)) &
                     + (1-beta(i_convol2))*sum(SF_live_d_mass(:,i_convol1)* &
                     lum_SSP(:,inv_time(i_convol2)+1,i_lambda)))
             enddo
          endif
       enddo
       lum_stel_SFC0(:i_Lyman_break_stel) = 0
    else !# `extinction_SFC = .false.` or `nebular_emission_SFC = .false.`.
       lum_stel_SFC0(:) = lum_stel_SFC_att_gas0(:)
    endif

  end subroutine compute_stellar_spectrum

!#======================================================================
!# ??? Will need to be divided in `_SFC` and `_DISM` subroutines if 
!# the fraction of Lyman continuum and Lyman alpha photons is not either 
!# 0 or 1.

  subroutine compute_nebular_spectrum(convol_time, i_time, dim_line, rel_L_line, &
       dim_lambda_stel, rel_lum_neb_cont, &
       SF_live_d_mass, LC_gas_abs_birth_cloud, LC_gas_abs_DISM, cloud_frac, &
       i_Lyman_alpha, &
       lum_neb_cont_SFC_unatt0, lum_neb_cont_SFC0, &
       lum_neb_cont_DISM_unatt0, &
       L_line_SFC_unatt, L_line_SFC, L_line_DISM_unatt, &
       M_dust_SFC, LC_power_SSP, &
       n_Z_neb, n_Q_neb, Z_neb_weight, Q_neb_weight_SFC, Q_neb_weight_DISM)

    use mod_types
    use mod_spectra_constants, only : HII_max_age
    use mod_scenario, only : nebular_emission_SFC, nebular_emission_DISM, &
         extinction_SFC, cloud_duration

    implicit none
    real(CDR), dimension(:), intent(in) :: convol_time
    integer, intent(in) :: i_time
    integer, intent(in) :: dim_line, dim_lambda_stel
    real(CDR), dimension(:,:,:), intent(in) :: rel_L_line
    real(CDR), dimension(:,:,:), intent(in) :: rel_lum_neb_cont
    real(CDR), dimension(:), intent(out) :: &
         L_line_SFC_unatt, L_line_SFC, L_line_DISM_unatt, &
         lum_neb_cont_SFC_unatt0, lum_neb_cont_SFC0, &
         lum_neb_cont_DISM_unatt0
    real(DPR), dimension(:,:), intent(in) :: SF_live_d_mass
    real(CDR), dimension(:), intent(in) :: LC_gas_abs_birth_cloud, &
         LC_gas_abs_DISM, cloud_frac
    integer, intent(in) :: i_Lyman_alpha
    real(CDR), intent(in) :: M_dust_SFC
    real(CDR), dimension(:,:), intent(in) :: LC_power_SSP
    integer, intent(in):: n_Z_neb, n_Q_neb
    real(CDR), dimension(:,:), intent(in) :: Z_neb_weight, Q_neb_weight_SFC, &
         Q_neb_weight_DISM
!#......................................................................
    integer :: i_convol1, i_convol2
    integer :: i_lambda, i_line
    real(CDR), dimension(n_Z_neb, n_Q_neb) :: neb_weight_SFC, neb_weight_DISM
    integer :: i_Z_neb, i_Q_neb
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Many redundant computations in the present state.
!# Formulated to ease future improvements.

    lum_neb_cont_SFC_unatt0(:) = 0
    lum_neb_cont_SFC0(:) = 0
    lum_neb_cont_DISM_unatt0(:) = 0
    L_line_SFC_unatt(:) = 0
    L_line_SFC(:) = 0
    L_line_DISM_unatt(:) = 0

!#----------------------------------------------------------------------

!# Nebular emission from star-forming clouds:
    if(nebular_emission_SFC) then
       do i_convol1 = 1, i_time
          i_convol2 = i_time+1-i_convol1
          do i_Z_neb = 1, n_Z_neb
             do i_Q_neb = 1, n_Q_neb
                neb_weight_SFC(i_Z_neb,i_Q_neb) = Z_neb_weight(i_convol1,i_Z_neb) &
                     * Q_neb_weight_SFC(i_convol2,i_Q_neb)
             enddo
          enddo

          if (convol_time(i_convol2) <= cloud_duration) then
             do i_lambda = 1, dim_lambda_stel
                lum_neb_cont_SFC_unatt0(i_lambda) = &
                     lum_neb_cont_SFC_unatt0(i_lambda) &
                     + cloud_frac(i_convol2) * LC_gas_abs_birth_cloud(i_convol2) * &
                     sum(SF_live_d_mass(:,i_convol1) * LC_power_SSP(:, i_convol2)) * &
                     sum(neb_weight_SFC(:,:) * rel_lum_neb_cont(:,:,i_lambda))
             enddo

             do i_line = 1, dim_line
                L_line_SFC_unatt(i_line) = L_line_SFC_unatt(i_line) &
                     + cloud_frac(i_convol2) * LC_gas_abs_birth_cloud(i_convol2) * &
                     sum(SF_live_d_mass(:,i_convol1) * LC_power_SSP(:, i_convol2)) * &
                     sum(neb_weight_SFC(:,:) * rel_L_line(:,:,i_line))
             end do
          endif
       end do

!# ??? What about Lyman continuum photons possibly emitted by the HII gas shortward
!# of the Lyman break?
!# Should they be reabsorbed? Assume they are not...

!# Absorption of Lyman alpha photons by dust in star-forming clouds.
!# No absorption for other lines and nebular continuum.
       lum_neb_cont_SFC0(:) = lum_neb_cont_SFC_unatt0(:)
       L_line_SFC(:) = L_line_SFC_unatt(:)
       if (extinction_SFC .and. M_dust_SFC > 0) then
          L_line_SFC(i_Lyman_alpha) = 0
       endif
    endif

!#----------------------------------------------------------------------

!# Nebular emission from the diffuse medium:
    if(nebular_emission_DISM) then
       do i_convol1 = 1, i_time
          i_convol2 = i_time+1-i_convol1
          do i_Z_neb = 1, n_Z_neb
             do i_Q_neb = 1, n_Q_neb
                neb_weight_DISM(i_Z_neb,i_Q_neb) = Z_neb_weight(i_convol1,i_Z_neb) &
                     * Q_neb_weight_DISM(i_Z_neb,i_Q_neb)
             enddo
          enddo

          if (convol_time(i_convol2) <= cloud_duration) then
             do i_lambda = 1, dim_lambda_stel
                lum_neb_cont_DISM_unatt0(i_lambda) = &
                     lum_neb_cont_DISM_unatt0(i_lambda) &
                     + (1-cloud_frac(i_convol2)) * LC_gas_abs_DISM(i_convol2) * &
                     sum(SF_live_d_mass(:,i_convol1) * LC_power_SSP(:, i_convol2)) * &
                     sum(neb_weight_DISM(:,:) * rel_lum_neb_cont(:,:,i_lambda))
             enddo

             do i_line = 1, dim_line
                L_line_DISM_unatt(i_line) = L_line_DISM_unatt(i_line) &
                     + (1-cloud_frac(i_convol2)) * LC_gas_abs_DISM(i_convol2) * &
                     sum(SF_live_d_mass(:,i_convol1) * LC_power_SSP(:, i_convol2)) * &
                     sum(neb_weight_DISM(:,:) * rel_L_line(:,:,i_line))
             end do

          else if (convol_time(i_convol2) <= HII_max_age) then !# \
!#           `convol_time(i_convol2) > cloud_duration`.
!# All ionizing stars are in the diffuse medium.
             do i_lambda = 1, dim_lambda_stel
                lum_neb_cont_DISM_unatt0(i_lambda) = lum_neb_cont_DISM_unatt0(i_lambda) &
                     + LC_gas_abs_DISM(i_convol2) * &
                     sum(SF_live_d_mass(:,i_convol1) * LC_power_SSP(:, i_convol2)) * &
                     sum(neb_weight_DISM(:,:) * rel_lum_neb_cont(:,:,i_lambda))
             enddo

             do i_line = 1, dim_line
                L_line_DISM_unatt(i_line) = L_line_DISM_unatt(i_line) &
                     + LC_gas_abs_DISM(i_convol2) * &
                     sum(SF_live_d_mass(:,i_convol1) * LC_power_SSP(:, i_convol2)) * &
                     sum(neb_weight_DISM(:,:) * rel_L_line(:,:,i_line))
             end do
          endif
       end do

!# ??? What about Lyman continuum photons possibly emitted by the HII gas shortward
!# of the Lyman break?
!# Should they be reabsorbed? Assume they are not...
    endif

  end subroutine compute_nebular_spectrum

!#======================================================================

  subroutine SFC_DISM_properties(dim_species, grain_abs, &
       LC_rate_SSP, SF_live_d_mass, dust_abund, &
       species_weight, &
       LC_gas_abs_birth_cloud, LC_dust_abs_birth_cloud, &
       LC_gas_abs_DISM, Lyman_cont_rate, &
       Lyman_cont_dust_abs, Lyman_cont_gas_abs, dust_col_dens_birth_cloud, cloud_frac, &
       M_dust_SFC, ISM_over_H, &
       i_time, convol_time, &
       n_Q_neb, Q_neb, Q_neb_weight_SFC, inner_radius, H_density, &
       n_Z_neb, Z_neb_weight, rel_volume_neb)

    use mod_types
    use mod_interp, only : bracket, Steffen, compute_weights
    use mod_constants, only : H_atom_mass, &
         pi, L_sol, lambda_Lyman_break_um
    use mod_spectra_constants, only : HII_max_age
    use mod_grain_properties, only : struct_grain_abs
    use mod_scenario, only : nebular_emission_SFC, nebular_emission_DISM, &
         neb_emis_type_SFC, neb_emis_type_DISM, neb_emis_const_frac_SFC, neb_emis_const_frac_DISM, &
         cluster_stel_mass, extinction_SFC, &
         cloud_init_frac, cloud_power, cloud_duration
    use mod_extinction, only : dust_optical_properties

    implicit none
    integer, intent(in) :: i_time
    integer, intent(in) :: dim_species
    type(struct_grain_abs), dimension(:), intent(in) :: grain_abs
    real(CDR), dimension(:), intent(in) :: convol_time
    real(CDR), dimension(:,:), intent(in) :: LC_rate_SSP
    real(DPR), dimension(:,:), intent(in) :: SF_live_d_mass
    real(CDR), intent(in) :: dust_abund
    real(CDR), dimension(:), intent(in) :: species_weight
    real(CDR), dimension(:), intent(out) :: dust_col_dens_birth_cloud, cloud_frac
    real(CDR), dimension(:), intent(out) :: LC_gas_abs_birth_cloud, &
         LC_dust_abs_birth_cloud
    real(CDR), dimension(:), intent(out) :: LC_gas_abs_DISM
    real(CDR), intent(out) :: M_dust_SFC, Lyman_cont_rate
    real(CDR), intent(out) :: Lyman_cont_dust_abs, Lyman_cont_gas_abs
    real(CDR), intent(in) :: ISM_over_H
    integer, intent(in) :: n_Q_neb
    real(CDR), dimension(:), intent(in) :: Q_neb
    real(CDR), dimension(:,:), intent(out) :: Q_neb_weight_SFC
    real(CDR), intent(in) :: inner_radius, H_density
    integer, intent(in) :: n_Z_neb
    real(CDR), dimension(:,:), intent(in) :: Z_neb_weight
    real(DPR), dimension(:,:), intent(in) :: rel_volume_neb
!#......................................................................
    real(CDR) :: stellar_mass
    real(CDR) :: dust_col_dens_birth_cloud0
    real(CDR) :: albedo, asym, kappa_ext, M_ISM_birth_cloud
    real(DPR) :: LC_rate_birth_cloud, specific_LC_rate
    real(CDR) :: nb_clusters, M_stars_birth_cloud
    integer :: i_convol1, i_convol2, i_Z_neb, i_Q_neb
    real(CDR) :: M_dust_birth_cloud
    real(CDR) :: l10_LC_rate_birth_cloud
    real(CDR), dimension(n_Z_neb, n_Q_neb) :: Z_Q_neb_weight
    real(CDR) :: y_0, r_Stroemgren, tau_abs, y_i
    real(DPR) :: volume
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Notations. All the quantities are for a galactic age of `convol_time(i_time)`.
!#
!# `Lyman_cont_rate`: emission rate of Lyman continuum photons by the galaxy, in number
!#     per unit time.
!#     Unlike `Lyman_cont_gas_abs`, it includes photons emitted after `HII_max_age`
!#     (e.g., from central stars of planetary nebulae).
!#
!# `stellar_mass`: mass of stars formed at time `convol_time(i_convol1)`.
!#     Their age is `convol_time(i_convol2)`.
!#
!# `nb_clusters`: number of clusters with an age of `convol_time(i_convol2)`.
!#     Computed assuming a typical initial mass (in stars) of `cluster_stel_mass`
!#     for the stellar cluster.
!#
!# `specific_LC_rate`: emission rate of Lyman continuum photons
!#     by stars with an age `convol_time(i_convol2)`, in number of photons
!#     per unit time per unit mass of the said stars.
!#
!# `cloud_frac`: fraction of stars aged `convol_time(i_convol2)` still in
!#     their parent cloud. These stars are called "the cloud's stars" in what follows.
!#
!# `M_stars_birth_cloud`: for a typical cluster, mass of the cloud's stars.
!#
!# `LC_rate_birth_cloud`: rate of Lyman continuum photons emitted by the cloud's stars
!#     of a typical cluster. In number of photons per unit time.
!#
!# `r_Stroemgren`: Stroemgren radius, if there is no dust, of the HII region
!#     surrounding the cloud's stars. It is assumed that the HII region is spherical
!#     and that all the cloud's stars are at its center.
!#     -> Quantity $r_S$ in Spitzer (1978, sec. 5.1.c).
!#
!# `H_density`: uniform space density of hydrogen in the HII region.
!#
!# `dust_col_dens_birth_cloud0`: column density of dust in the HII region, computed
!#     on a distance `r_Stroemgren`.
!#
!# `tau_abs`: dust absorption optical depth of the HII region at the Lyman break,
!#     computed on a distance `r_Stroemgren`.
!#     The factor `1-albedo` in the expression of `tau_abs` is due to the fact
!#     that, in the UV, scattering is mainly forward.
!#     -> Quantity $\tau_{Sd}$ in Spitzer.
!#
!# `dust_col_dens_birth_cloud`: column density of dust on the effective radius
!#     of the HII region (taking into account the volume reduction due to dust).
!#
!# `LC_gas_abs_birth_cloud`: fraction of Lyman continuum photons (in number) emitted
!#     by the cloud's stars and absorbed by gas in this cloud.
!#     In the "automatic" case adapted from Spitzer (1978), it is computed at the Lyman break, 
!#     because most of Lyman continuum photons have a wavelength near that of the break.
!#     In the "constant" case, Lyman continuum photons emitted by the cloud's stars
!#     and not absorbed by gas or dust in the cloud may be absorbed in the
!#     diffuse medium by dust but not by gas.
!#     In all cases, the same fraction is used at all wavelengths in the
!#     Lyman continuum.
!#
!# `LC_gas_abs_DISM`: fraction of Lyman continuum photons (in number) emitted by stars
!#     in the diffuse medium and absorbed by gas in this medium.
!#     This fraction is 1 in the "automatic" case and a constant in the "constant"
!#     case.
!#     In all cases, the same fraction is used at all wavelengths in the
!#     Lyman continuum.
!#
!# `LC_dust_abs_birth_cloud`: fraction of Lyman continuum photons (in number) emitted
!#     by the cloud's stars and absorbed by dust in this cloud.
!#     The same fraction is used at all wavelengths in the
!#     Lyman continuum.
!#
!# `M_ISM_birth_cloud`: mass of the ISM (gas and dust) in the cloud considered.
!#
!# `M_dust_birth_cloud`: mass of dust in the cloud considered.
!#
!# `M_dust_SFC`: mass of dust in all currently existing star-forming clouds.
!#
!# `Lyman_cont_gas_abs`: fraction of Lyman continuum photons (in number) absorbed
!#     by gas, whether in star-forming clouds or in the diffuse medium.
!#
!# `Lyman_cont_dust_abs`: fraction of Lyman continuum photons (in number) absorbed
!#     by dust (here, in star-forming clouds only; for the diffuse_medium, see 
!#     `attenuate_DISM`).

!#----------------------------------------------------------------------
!# Assumptions:
!#
!# Stars are assumed to form in clusters with a typical stellar mass given by
!# `cluster_stel_mass`.
!# If the age of the cluster, `convol_time(i_convol2)`, is larger than
!# `cloud_duration`, all the stars formed in the cluster are outside the dust
!# cloud;
!# if the age is less than `cloud_duration`, a fraction `cloud_frac` of the
!# stars formed in the cluster is inside the dust cloud.
!#
!# As modeled here, Lyman continuum photons emitted by stars younger
!# than `HII_max_age` and not in their parent cloud (whether younger
!# than `cloud_duration` or not) are absorbed by gas in the diffuse medium:
!# all of them if `neb_emis_type = "automatic"` or a constant fraction if
!# `neb_emis_type = "constant"`.
!# Lyman continuum photons emitted by hot stars older than `HII_max_age` (e.g.,
!# central stars of planetary nebulae) are not absorbed by gas and do not
!# produce any nebular emission.

    M_dust_SFC = 0
    Lyman_cont_rate = 0
    Lyman_cont_dust_abs = 0
    Lyman_cont_gas_abs = 0
    LC_gas_abs_birth_cloud(:) = 0
    LC_dust_abs_birth_cloud(:) = 0
    LC_gas_abs_DISM(:) = 0
    dust_col_dens_birth_cloud(:) = 0
    cloud_frac(:) = 0

    Q_neb_weight_SFC(:,:) = 0

    do i_convol1 = 1, i_time
       i_convol2 = i_time+1-i_convol1
       Lyman_cont_rate = Lyman_cont_rate + & !# Multiplied by `L_sol` later.
            sum(SF_live_d_mass(:,i_convol1)*LC_rate_SSP(:, i_convol2))

       if (convol_time(i_convol2) <= cloud_duration) then
          stellar_mass = sum(SF_live_d_mass(:,i_convol1))
          nb_clusters = stellar_mass/cluster_stel_mass
          if (stellar_mass > 0) then
             specific_LC_rate = L_sol* &
                  sum(SF_live_d_mass(:,i_convol1)*LC_rate_SSP(:, i_convol2))/ &
                  stellar_mass
          else
             specific_LC_rate = 0
          endif

          if (cloud_power == 0) then
             cloud_frac(i_convol2) = cloud_init_frac
          else
             cloud_frac(i_convol2) = cloud_init_frac * &
                  (1-convol_time(i_convol2)/cloud_duration)**cloud_power
          endif

!# For young stars in star-forming clouds:
          if (nebular_emission_SFC) then
             M_stars_birth_cloud = cluster_stel_mass * cloud_frac(i_convol2)
             LC_rate_birth_cloud = specific_LC_rate*M_stars_birth_cloud
             l10_LC_rate_birth_cloud = log10(max(LC_rate_birth_cloud,tiny(1._DPR)))
             call compute_weights(Q_neb, &
                  l10_LC_rate_birth_cloud, Q_neb_weight_SFC(i_convol2,:))
             do i_Z_neb = 1, n_Z_neb
                do i_Q_neb = 1, n_Q_neb
                   Z_Q_neb_weight(i_Z_neb, i_Q_neb) = &
                        Z_neb_weight(i_convol1, i_Z_neb) &
                        * Q_neb_weight_SFC(i_convol2, i_Q_neb)
                enddo
             enddo
             volume = LC_rate_birth_cloud*sum(Z_Q_neb_weight(:,:)*rel_volume_neb(:,:))
             r_Stroemgren = max((3/(4*pi)*volume+inner_radius**3)**(1._DPR/3), inner_radius)
             y_0 = inner_radius/r_Stroemgren


             call dust_optical_properties(dim_species, grain_abs, lambda_Lyman_break_um, &
                  species_weight, kappa_ext, albedo, asym)

!# ??? Should one use the dust abundance at `convol_time(i_time)` or at `convol_time(i_convol1)`?
!# Same question for `species_weight` and `ISM_over_H`.

             dust_col_dens_birth_cloud0 = dust_abund * &
                  r_Stroemgren * H_density*H_atom_mass * ISM_over_H

             if (extinction_SFC) then
                if (neb_emis_type_SFC == "automatic") then
                   tau_abs = kappa_ext*(1-albedo)*dust_col_dens_birth_cloud0
                   y_i = Spitzer_solve(y_0=y_0, tau_abs=tau_abs, eps=1.e-6_CDR)
                   if (y_0 < 1) then
                      LC_gas_abs_birth_cloud(i_convol2) = (y_i**3-y_0**3)/(1-y_0**3)
                   else
                      LC_gas_abs_birth_cloud(i_convol2) = 1
                   endif
                   LC_dust_abs_birth_cloud(i_convol2) = 1 - LC_gas_abs_birth_cloud(i_convol2)

                else !# `neb_emis_type_SFC = "constant"`.
                   LC_gas_abs_birth_cloud(i_convol2) = neb_emis_const_frac_SFC
                   y_i = (y_0**3 + &
                        LC_gas_abs_birth_cloud(i_convol2)*(1-y_0**3))**(1._DPR/3)
                   if (dust_abund > 0) LC_dust_abs_birth_cloud(i_convol2) &
                        = 1 - LC_gas_abs_birth_cloud(i_convol2)
                endif

                dust_col_dens_birth_cloud(i_convol2) = (y_i-y_0) * dust_col_dens_birth_cloud0

                M_ISM_birth_cloud = (4*pi)/3* &
                     r_Stroemgren**3*(y_i**3-y_0**3) &
                     *H_density*H_atom_mass*ISM_over_H

                M_dust_birth_cloud = dust_abund*M_ISM_birth_cloud

                M_dust_SFC = M_dust_SFC + M_dust_birth_cloud*nb_clusters
             else !# `extinction_SFC = .false.`.
                if (neb_emis_type_SFC == "automatic") then
                   LC_gas_abs_birth_cloud(i_convol2) = 1
                else if (neb_emis_type_SFC == "constant") then
                   LC_gas_abs_birth_cloud(i_convol2) = neb_emis_const_frac_SFC
                endif
                LC_dust_abs_birth_cloud(i_convol2) = 0
                dust_col_dens_birth_cloud(i_convol2) = 0
             endif
             Lyman_cont_gas_abs = Lyman_cont_gas_abs + &
                  LC_gas_abs_birth_cloud(i_convol2) * LC_rate_birth_cloud &
                  * nb_clusters
             Lyman_cont_dust_abs = Lyman_cont_dust_abs + &
                  LC_dust_abs_birth_cloud(i_convol2) * LC_rate_birth_cloud &
                  * nb_clusters
          else !# `nebular_emission_SFC = .false.`.
!~           LC_gas_abs_birth_cloud(i_convol2) = 0
!~           LC_dust_abs_birth_cloud(i_convol2) = 0 !# This, even if \
!# `extinction_SFC = .true.`, because there is no HII region.
!~           dust_col_dens_birth_cloud(i_convol2) = 0
          endif

!# For stars younger than `cloud_duration` but in the diffuse medium:
          if (nebular_emission_DISM) then
             if (neb_emis_type_DISM == "automatic") then
                LC_gas_abs_DISM(i_convol2) = 1
             else if (neb_emis_type_DISM == "constant") then
                LC_gas_abs_DISM(i_convol2) = neb_emis_const_frac_DISM
             endif
             Lyman_cont_gas_abs = Lyman_cont_gas_abs &
                  + (1-cloud_frac(i_convol2)) * LC_gas_abs_DISM(i_convol2) * L_sol * &
                  sum(SF_live_d_mass(:,i_convol1)*LC_rate_SSP(:, i_convol2))
          else !# `nebular_emission_DISM = .false.`.
!~             LC_gas_abs_DISM(i_convol2) = 0
          endif

       else if (convol_time(i_convol2) <= HII_max_age) then !# Age >= `cloud_duration`.
!# Note: if the line above is replaced by a simple `else`, then hot stars
!# older than `HII_max_age` (central stars of planetary nebulae, for instance)
!# will produce emission lines in the diffuse medium.

          if (nebular_emission_DISM) then
             if (neb_emis_type_DISM == "automatic") then
                LC_gas_abs_DISM(i_convol2) = 1
             else if (neb_emis_type_DISM == "constant") then
                LC_gas_abs_DISM(i_convol2) = neb_emis_const_frac_DISM
             endif
             Lyman_cont_gas_abs = Lyman_cont_gas_abs + LC_gas_abs_DISM(i_convol2) * L_sol * &
                  sum(SF_live_d_mass(:,i_convol1)*LC_rate_SSP(:, i_convol2))
          else !# `nebular_emission_DISM = .false.`.
!~             LC_gas_abs_DISM(i_convol2) = 0
          endif
       else !# Age >= `HII_max_age`.
          LC_gas_abs_DISM(i_convol2) = 0
       endif
    enddo

    Lyman_cont_rate = Lyman_cont_rate*L_sol

  end subroutine SFC_DISM_properties

!#======================================================================

  function Spitzer_func(tau_abs, y_0, y_i)

    use mod_types
    implicit none
    real(CDR) :: Spitzer_func
    real(CDR), intent(in) :: tau_abs, y_0, y_i

    real(DPR) :: u_0, u_i !# Double precision required for stability when \
!# `tau_abs` > 1.e-2 but `u_i` ~= `u_0`.

    u_0 = y_0*tau_abs
    u_i = y_i*tau_abs
    if (tau_abs > 1.e-2) then
       Spitzer_func = 3/(1-y_0**3)/tau_abs**3* &
            (exp(u_i-u_0)*(u_i**2-2*u_i+2) - (u_0**2-2*u_0+2))-1
    else !# First order development in tau_abs for numerical reasons. \
!#
       Spitzer_func = (y_i**3-1 + tau_abs/4*(y_0**4-4*y_0*y_i**3+3*y_i**4))/(1-y_0**3)
    endif

  end function Spitzer_func

!#======================================================================

  function Spitzer_solve(y_0, tau_abs, eps)

    use mod_types
    implicit none
    real(CDR) :: Spitzer_solve
    real(CDR), intent(in) :: y_0, tau_abs, eps

    real(CDR) :: y1, y2, z1, z2, y_i, z_i

    y1 = y_0
    y2 = 1
    z1 = -1 !# By definition.
    z2 = Spitzer_func(tau_abs, y_0, y2) !# Must be > 0 for `y2` = 1.

    do
       y_i = (y1+y2)/2
       z_i = Spitzer_func(tau_abs, y_0, y_i)
       if (z_i > 0) then
          y2 = y_i
          z2 = z_i
       else
          y1 = y_i
          z1 = z_i
       endif
       if (y2-y1 < eps) exit
    enddo
    if (y2 == y1) then
       Spitzer_solve = y1
    else
       Spitzer_solve = (y1*z2-y2*z1)/(z2-z1) !# Linear interpolation.
    endif

  end function Spitzer_solve

end module mod_SFC_DISM

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_code_version

  implicit none
  character(len=*), parameter :: version_id = "P\'egase.3.0.1"
  character(len=*), parameter :: version_date = "2019-02-21T18:05:15Z" !# \
!# ISO 8601 date given by Linux/Unix command "date +%FT%TZ -u".
  public :: version_id, version_date

end module mod_code_version

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_evolution

  private
  public :: evolution

contains

!#======================================================================

  subroutine evolution(dim_convol_time, convol_time, time_step, &
       Z_SSP, dim_SSP, &
       ejec_rate_tot_SSP, ejec_rate_elem_SSP, carb_dust_prod_rate_SSP, &
       sil_dust_prod_rate_SSP, WD_mass_prod_rate_SSP, BHNS_mass_prod_rate_SSP, &
       ISM_mass, carb_init_mass, sil_init_mass, &
       ISM_elem_init_mass, carb_abund, sil_abund, &
       inert_mass, galaxy_mass, BHNS_mass, WD_mass, ISM_abund, &
       SF_live_d_mass, &
       SSP_Z_weight, &
       reserv_init_mass_scaled, &
       reserv_abund, &
       time_SSP, CCSN_rate_SSP, SNIa_rate_SSP, &
       CCSN_rate, SNIa_rate, ejec_rate_tot, SF_rate, infall_rate, &
       outflow_rate, &
       ejec_cumul_mass, SF_live_cumul_mass, &
       infall_cumul_mass, outflow_cumul_mass, &
       SF_warn_present, SF_warn_age, &
       infall_warn_present, infall_warn_age, &
       outflow_warn_present, outflow_warn_age, dim_elem, ISM_over_H &
       , Z_neb, Z_neb_weight &
       )

    use mod_types
    use mod_loc, only : i_loc
    use mod_constants, only : elem_id, &
         A_O16, A_Mg24, A_Si28, A_S32, A_Ca40, A_Fe56
    use mod_interp, only : bracket, Steffen
    use mod_scenario

    implicit none
    integer, intent(in) :: dim_convol_time
    real(CDR), dimension(:), intent(in) :: convol_time
    real(CDR), intent(in) :: time_step
    real(CDR), dimension(:), intent(in) :: Z_SSP
    integer, intent(in) :: dim_SSP
    real(CDR), dimension(:, :), intent(in) :: ejec_rate_tot_SSP
    real(CDR), dimension(:, :, 0:), intent(in) :: ejec_rate_elem_SSP
    real(CDR), dimension(:, :), intent(in) :: carb_dust_prod_rate_SSP, &
         sil_dust_prod_rate_SSP, WD_mass_prod_rate_SSP, BHNS_mass_prod_rate_SSP
    real(CDR), dimension(:), intent(inout) :: galaxy_mass, ISM_mass, &
         BHNS_mass, WD_mass, inert_mass, carb_abund, sil_abund
    real(CDR), intent(in) :: carb_init_mass, sil_init_mass
    real(CDR), dimension(0:), intent(in) :: ISM_elem_init_mass
    real(CDR), dimension(:,0:), intent(inout) :: ISM_abund
    real(DPR), dimension(:,:), pointer :: SF_live_d_mass
    real(CDR), dimension(:,:), pointer :: SSP_Z_weight
    real(CDR), dimension(:), intent(in) :: reserv_init_mass_scaled
    real(CDR), dimension(:,0:), intent(in) :: reserv_abund
    logical, intent(inout) :: SF_warn_present, outflow_warn_present
    logical, dimension(:), intent(inout) :: infall_warn_present
    real(CDR), intent(out) :: SF_warn_age, outflow_warn_age
    real(CDR), dimension(:), intent(inout) :: infall_warn_age
    real(CDR), dimension(:), intent(in) :: time_SSP
    real(CDR), dimension(:,:), intent(in) :: CCSN_rate_SSP, SNIa_rate_SSP
    real(DPR), dimension(:), intent(out) :: CCSN_rate, SNIa_rate
    real(DPR), dimension(:), intent(out) :: SF_rate
    real(DPR), dimension(:), intent(out) :: ejec_rate_tot, infall_rate, &
         outflow_rate
    real(DPR), dimension(:), intent(out) :: ejec_cumul_mass, SF_live_cumul_mass, &
         infall_cumul_mass, outflow_cumul_mass
    integer, intent(in) :: dim_elem
    real(CDR), dimension(:), intent(out) :: ISM_over_H
    real(CDR), dimension(:), intent(in) :: Z_neb
    real(CDR), dimension(:,:), intent(out) :: Z_neb_weight
!#......................................................................
    integer :: i_bracket, i_time, i_SSP, dim_time_SSP
    real(DPR), dimension(0:dim_elem) :: ejec_rate_elem, ISM_abund_prev
    real(DPR) :: carb_dust_prod_rate, sil_dust_prod_rate, BHNS_mass_prod_rate, &
         WD_mass_prod_rate, carb_abund_prev, sil_abund_prev, total_swept_mass, &
         potential_carb_mass, potential_sil_mass, ISM_over_H_prev
    integer :: i_epis
    real(CDR) :: time
    real(DPR) :: SF_d_mass, SF_inert_d_mass
    real(DPR) :: infall_d_mass
    real(DPR), dimension(size(SF_stochastic)) :: SF_stoch_time, &
         SF_stoch_modulation
    real(DPR) :: outflow_d_mass, SF_cumul_mass
    logical :: radical_outflow
    integer :: i_elem
    real(CDR) :: CCSN_max_age, time_inf, time_sup
    real(CDR) :: current_galaxy_mass, current_ISM_mass
    integer ::  i_Z, i_O, i_C, i_Fe, i_He, i_N, i_Ne, i_Mg, i_Si, i_S, i_Ca
    real(CDR), dimension(size(reserv_init_mass_scaled)) :: reserv_mass
    real(CDR), dimension(lbound(ISM_elem_init_mass, dim=1): &
         ubound(ISM_elem_init_mass, dim=1)) :: ISM_elem_mass
    real(CDR) :: carb_mass, sil_mass
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    reserv_mass(:) = reserv_init_mass_scaled(:)
    ISM_elem_mass(:) = ISM_elem_init_mass(:)
    carb_mass = carb_init_mass
    sil_mass = sil_init_mass

    i_Z = 0
    i_O = i_loc(elem_id, "O")
    i_C = i_loc(elem_id, "C")
    i_Fe = i_loc(elem_id, "Fe")
    i_He = i_loc(elem_id, "He")
    i_N = i_loc(elem_id, "N")
    i_Ne = i_loc(elem_id, "Ne")
    i_Mg = i_loc(elem_id, "Mg")
    i_Si = i_loc(elem_id, "Si")
    i_S = i_loc(elem_id, "S")
    i_Ca = i_loc(elem_id, "Ca")

    ISM_abund_prev(0:dim_elem) = ISM_abund(1,0:dim_elem)
    carb_abund_prev = carb_abund(1)
    sil_abund_prev = sil_abund(1)
    ISM_over_H_prev = 1

!# No core-collapse supernova after `CCSN_max_age`.
    CCSN_max_age = maxval((/(maxval(time_SSP(:), &
         mask = CCSN_rate_SSP(i_SSP,:) > 0), i_SSP = 1, dim_SSP)/))

    ejec_cumul_mass(1) = 0
    SF_live_cumul_mass(1) = 0
    SF_cumul_mass = 0
    infall_cumul_mass(1) = 0
    outflow_cumul_mass(1) = 0

    current_galaxy_mass = galaxy_mass(1)
    current_ISM_mass = ISM_mass(1)

    SF_stoch_time(:) = 0

    ejec_rate_tot = 0

    ejec_rate_elem(:) = 0
    carb_dust_prod_rate = 0
    sil_dust_prod_rate = 0
    BHNS_mass_prod_rate = 0
    WD_mass_prod_rate = 0

    CCSN_rate(:) = 0
    SNIa_rate(:) = 0

    if (associated(SF_live_d_mass)) deallocate(SF_live_d_mass)
    allocate(SF_live_d_mass(dim_SSP, dim_convol_time))
    if (associated(SSP_Z_weight)) deallocate(SSP_Z_weight)
    allocate(SSP_Z_weight(dim_SSP, dim_convol_time))
    SF_live_d_mass(:,:) = 0
    SSP_Z_weight(:,:) = 0

!# `galaxy_mass(i_time)` is the value of `galaxy_mass` just before
!# `time(i_time)`. Idem for all `*_mass` quantities.

!# `infall_rate(i_time)` is the average value of `infall_rate` in
!# [`time(i_time)`, `time(i_time+1)`[. Idem for all `*_rate` quantities.

!# `SF_d_mass(i_time)` is the integral of `SF_rate(i_time)` in
!# [`time(i_time)`, `time(i_time+1)`[. Idem for all `*_d_mass` quantities.

!# Quantities modified several times during a time-step are prefixed with
!# `current`.


    dim_time_SSP = size(time_SSP)

    i_bracket = 0 !# ??? Is `i_bracket` needed?
    do i_time = 1, dim_convol_time
       time = convol_time(i_time)

!# Infall.

       call compute_infall

!# If some outflow term is "radical", remove the ISM first
!# to avoid star formation.

       radical_outflow = .false.
       do i_epis = 1, max_dim_outflow_epis
          if (outflow_end_time(i_epis) >= outflow_begin_time(i_epis) .and. &
               convol_time(i_time+1) >= outflow_begin_time(i_epis) .and. &
               convol_time(i_time) < outflow_end_time(i_epis) .and. &
               outflow_type(i_epis) == "radical") then
             radical_outflow = .true.
             exit
          endif
       enddo

!# Star formation.

       call compute_star_formation

!# End products (SN rates, stellar ejecta, remnants...).

       call convolution

!# Processes occuring in the ISM.

       call ISM_processes

!# Outflow.
!# Subroutine `compute_outflow` called after `convolution` because the
!# supernovae rates computed by the latter may be needed by the former.
       call compute_outflow

!# Computations for next time-step.

       galaxy_mass(i_time+1) = current_galaxy_mass
       ISM_mass(i_time+1) = current_ISM_mass
       BHNS_mass(i_time+1) = BHNS_mass(i_time) &
            + BHNS_mass_prod_rate * time_step
       WD_mass(i_time+1) = WD_mass(i_time) + WD_mass_prod_rate * time_step

       infall_cumul_mass(i_time+1) = infall_cumul_mass(i_time) + infall_d_mass
       SF_live_cumul_mass(i_time+1) = SF_live_cumul_mass(i_time) &
            + sum(SF_live_d_mass(:,i_time))
       ejec_cumul_mass(i_time+1) = ejec_cumul_mass(i_time) &
            + ejec_rate_tot(i_time) * time_step
       outflow_cumul_mass(i_time+1) = outflow_cumul_mass(i_time) &
            + outflow_d_mass
       inert_mass(i_time+1) = inert_mass(i_time) &
            + SF_inert_d_mass
       SF_cumul_mass = SF_live_cumul_mass(i_time+1) + inert_mass(i_time+1)

!# Following values will be modified by subroutine "convolution":
       CCSN_rate(i_time+1) = CCSN_rate(i_time)
       SNIa_rate(i_time+1) = SNIa_rate(i_time)
       ejec_rate_tot(i_time+1) = ejec_rate_tot(i_time)

    end do

  contains

!#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    subroutine compute_abundances

      implicit none

!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      if (dust_evolution == "basic") then
         carb_mass = ISM_elem_mass(i_C) * ISM_carb_deplet !# !!! H atoms \
!# neglected.
         sil_mass = & !# !!! Not fully consistent: A_O17, etc., should be \
!# used too.
              (ISM_elem_mass(i_Mg)*(1 + O_sil_ratio*A_O16/A_Mg24) &   !# `O_sil_ratio` atom of \
!#                                                                          oxygen for each Mg atom, \
              + ISM_elem_mass(i_Si)*(1 + O_sil_ratio*A_O16/A_Si28) &  !# Si atom, \
              + ISM_elem_mass(i_S)*(1 + O_sil_ratio*A_O16/A_S32) &    !# S atom, \
              + ISM_elem_mass(i_Ca)*(1 + O_sil_ratio*A_O16/A_Ca40) &  !# Ca atom or \
              + ISM_elem_mass(i_Fe)*(1 + O_sil_ratio*A_O16/A_Fe56)) & !# Fe atom.
              * ISM_sil_deplet
      endif

      if (current_ISM_mass > 0) then
         ISM_abund(i_time,:) = ISM_elem_mass(:)/current_ISM_mass
         ISM_over_H(i_time) = &
              1/(1-ISM_abund(i_time,i_He)-ISM_abund(i_time,i_Z))
         carb_abund(i_time) = carb_mass/current_ISM_mass
         sil_abund(i_time) = sil_mass/current_ISM_mass

         ISM_abund_prev(0:dim_elem) = ISM_abund(i_time,0:dim_elem)
         carb_abund_prev = carb_abund(i_time)
         sil_abund_prev = sil_abund(i_time)
         ISM_over_H_prev = ISM_over_H(i_time)
      else !# Used in star-forming clouds even if the mass of the diffuse ISM is \
!#            null.
         ISM_abund(i_time,0:dim_elem) = ISM_abund_prev(0:dim_elem)
         carb_abund(i_time) = carb_abund_prev
         sil_abund(i_time) = sil_abund_prev
         ISM_over_H(i_time) = ISM_over_H_prev
      end if

    end subroutine compute_abundances

!#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    subroutine compute_star_formation

      use mod_random
      use mod_interp, only : compute_weights
      implicit none
!#......................................................................
      integer :: i_epis
      real(CDR), dimension(max_dim_SF_epis) :: SF_epis
      real(CDR), dimension(dim_SSP) :: SSP_epis_weight
      real(CDR) :: norm
      real(CDR) :: Z_epis
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      SF_d_mass = 0
      SF_inert_d_mass = 0
      if (radical_outflow) then
         SF_rate(i_time) = 0
         return !# No star formation. \
!# `SF_d_mass` set to 0 above; `SF_live_d_mass` and `SSP_Z_weight` too at the \
!# beginning of subroutine `evolution`.
      endif

      do i_epis = 1, max_dim_SF_epis
         SF_epis(i_epis) = 0
         if (SF_type(i_epis) == "none") cycle

         if (SF_type(i_epis) == "instantaneous") then
!# Take the nearest time-step.
            if (nint(SF_begin_time(i_epis)/time_step)+1 == i_time) &
                 SF_epis(i_epis) = SF_inst_mass(i_epis)

         else
            if (SF_end_time(i_epis) >= SF_begin_time(i_epis) .and. &
                 convol_time(i_time+1) >= SF_begin_time(i_epis) .and. &
                 convol_time(i_time) < SF_end_time(i_epis)) then
               time_inf = max(convol_time(i_time), SF_begin_time(i_epis))
               time_sup = min(convol_time(i_time+1), SF_end_time(i_epis))
            else
               cycle
            endif

            if (SF_type(i_epis) == "constant") then
               SF_epis(i_epis) = SF_const_mass(i_epis)/ &
                    (SF_end_time(i_epis)-SF_begin_time(i_epis))* &
                    (time_sup-time_inf)

            else if (SF_type(i_epis) == "exponential") then
!# `abs()` in case `SF_expo_timescale` < 0.
               SF_epis(i_epis) = SF_expo_mass(i_epis) * &
                    abs(exp(-(time_inf-SF_begin_time(i_epis))/ &
                    SF_expo_timescale(i_epis)) &
                    - exp(-(time_sup-SF_begin_time(i_epis))/ &
                    SF_expo_timescale(i_epis)))

            else if (SF_type(i_epis) == "peaked") then
               SF_epis(i_epis) = SF_peaked_mass(i_epis)/SF_peaked_timescale(i_epis) * &
                    (exp(-(time_inf-SF_begin_time(i_epis))/ &
                    SF_peaked_timescale(i_epis)) * &
                    (time_inf-SF_begin_time(i_epis) + SF_peaked_timescale(i_epis)) &
                    - exp(-(time_sup-SF_begin_time(i_epis))/ &
                    SF_peaked_timescale(i_epis)) * &
                    (time_sup-SF_begin_time(i_epis) + SF_peaked_timescale(i_epis)))

            else if (SF_type(i_epis) == "ISM_mass") then
!# !!! The formula below overestimates the mass removed from the ISM in
!# [`time_inf`, `time_sup`[ since it assumes that `SF_epis` is constant in
!# this interval. However, because too much mass has been removed, `SF_epis`
!# should underestimate the mass removed from the ISM in the next
!# bin of time. Overall, this should compensate.
               if (current_ISM_mass > SF_ISM_threshold(i_epis)) &
                    SF_epis(i_epis) = &
                    (current_ISM_mass-SF_ISM_threshold(i_epis))**SF_ISM_power(i_epis)/ &
                    SF_ISM_timescale(i_epis)*(time_sup-time_inf)

            else if (SF_type(i_epis) == "infall") then
               SF_epis(i_epis) = SF_infall_factor(i_epis)*infall_d_mass

            else if (SF_type(i_epis) == "file") then
!# !!! Should be improved to integrate from `time_inf` to `time_sup`.
               call bracket(SF_file_dim_time(i_epis), &
                    SF_file_time(i_epis) % val, time, i_bracket)
               call Steffen(SF_file_dim_time(i_epis), &
                    SF_file_time(i_epis) % val, &
                    SF_file_rate(i_epis) % val, &
                    time, SF_epis(i_epis), i_bracket)
               SF_epis(i_epis) = SF_epis(i_epis)*(time_sup-time_inf)

            else
               write(*, "(a,i0,a)") "`SF_type(", i_epis, ")` """ // &
                    trim(SF_type(i_epis)) // """ undefined. Stopped."
               stop
            endif
         endif

         if (SF_stochastic(i_epis)) then
!# Stochastic modulation of the SFR, so that the modulated SFR
!#    1. is equal to the unmodulated SFR in the mean;
!#    2. is non negative;
!#    3. and has an r.m.s. equal to $SF_stoch_fluc$ times the unmodulated SFR.
!# A log-normal random distribution is used to this purpose.
!# The times of modulation are determined according to a Poissonian law
!# of mean $SF_stoch_timescale$.
            if (time >= SF_stoch_time(i_epis)) then
               SF_stoch_modulation(i_epis) = &
                    exp(SF_stoch_sigma(i_epis)*gaussian_random() &
                    -SF_stoch_sigma(i_epis)**2/2)
               SF_stoch_time(i_epis) = SF_stoch_time(i_epis) &
                    - SF_stoch_timescale(i_epis)*log(uniform_random(exclude_zero = .true.))
            endif
            SF_epis(i_epis) = SF_epis(i_epis)*SF_stoch_modulation(i_epis)
         endif

         SF_d_mass = SF_d_mass + SF_epis(i_epis)
         SF_inert_d_mass = SF_inert_d_mass &
              + SF_epis(i_epis)*SF_inert_frac(i_epis)

         if (SF_Z_type(i_epis) == "consistent") then
            Z_epis = ISM_abund(i_time, i_Z)
         else if (SF_Z_type(i_epis) == "constant") then
            Z_epis = SF_Z_const_val(i_epis)
         else if (SF_Z_type(i_epis) == "file") then
            call bracket(SF_Z_file_dim_time(i_epis), SF_Z_file_time(i_epis) % val, time, i_bracket)
            call Steffen(SF_Z_file_dim_time(i_epis), SF_Z_file_time(i_epis) % val, &
                 SF_Z_file_Z(i_epis) % val, time, Z_epis, i_bracket)
         else
            write(*, "(a,i0,a)") "`SF_Z_type(", i_epis, ")` """ // &
                 trim( SF_Z_type(i_epis)) // """ undefined. Stopped."
            stop
         endif

         call compute_weights(Z_SSP, Z_epis, SSP_epis_weight, &
              interp_proc="interp_log_lin")
         SF_live_d_mass(:,i_time) = SF_live_d_mass(:,i_time) + &
              SSP_epis_weight(:)*SF_epis(i_epis)*(1-SF_inert_frac(i_epis))
         SSP_Z_weight(:, i_time) = SSP_Z_weight(:, i_time) + &
              SSP_epis_weight(:)*SF_epis(i_epis)*Z_epis*(1-SF_inert_frac(i_epis))
      enddo

      where (SF_live_d_mass(:,i_time) > 0)
         SSP_Z_weight(:, i_time) = &
              SSP_Z_weight(:, i_time)/SF_live_d_mass(:,i_time) !# Put before \
!# following "if" statement because of the possible normalization of \
!# `SF_live_d_mass`.
      elsewhere
         SSP_Z_weight(:, i_time) = 0
      end where

!# ??? Should one do the following as a function of the `Z_epis`s, not of 
!# the current value of `ISM_abund(., i_Z)`? No, since emission lines
!# are determined by ISM abundances.
!#
!# ??? Should one use the current value of `ISM_abund` or the value when the
!# ionizing source was formed? Assume the first one...
      call compute_weights(Z_neb, ISM_abund(i_time, i_Z), &
           Z_neb_weight(i_time,:), interp_proc="interp_log_lin")

      if (SF_d_mass > current_ISM_mass) then
         if (.not.SF_warn_present) then
            SF_warn_age = time
            SF_warn_present = .true.
         endif
!# Warn only if `SF_d_mass` > `current_ISM_mass` + some epsilon ???
!# Scale down star formation as much as necessary: {
         norm = current_ISM_mass/SF_d_mass
         SF_d_mass = current_ISM_mass
         SF_live_d_mass(:,i_time) = SF_live_d_mass(:,i_time) * norm
         SF_inert_d_mass = SF_inert_d_mass * norm
!# }.
!# ISM evolution due to star formation: {
         current_ISM_mass = 0
         ISM_elem_mass(:) = 0
         carb_mass = 0
         sil_mass = 0
      else
         current_ISM_mass = max(0._DPR, current_ISM_mass - SF_d_mass)
         ISM_elem_mass(:) = max(0._DPR, ISM_elem_mass(:) &
              - SF_d_mass*ISM_abund(i_time,:))
!# Remark on previous line: even if the metallicity of some newly formed stars
!# is not that of the ISM, the amount of metals removed from the ISM because
!# of star formation is related to the metallicity of the ISM.
         if (dust_evolution == "Dwek") then
            carb_mass = max(0._DPR, carb_mass - SF_d_mass * carb_abund(i_time))
            sil_mass = max(0._DPR, sil_mass - &
                 SF_d_mass * sil_abund(i_time))
         endif
!# }.
      endif

      SF_rate(i_time) = SF_d_mass/time_step
      call compute_abundances

    end subroutine compute_star_formation

!#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    subroutine compute_infall

      implicit none
      integer :: i_epis, i_reserv
      real(CDR), dimension(max_dim_infall_epis) :: infall_epis
      real(CDR), dimension(max_dim_reserv) :: reserv_d_mass
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      infall_d_mass = 0
      do i_epis = 1, max_dim_infall_epis
         infall_epis(i_epis) = 0

         if (infall_type(i_epis) == "none") cycle

         if (infall_type(i_epis) == "instantaneous") then
!# Take the nearest time-step.
            if (nint(infall_begin_time(i_epis)/time_step)+1 == i_time) &
                 infall_epis(i_epis) = infall_inst_mass(i_epis)

         else
            if (infall_end_time(i_epis) >= infall_begin_time(i_epis) .and. &
                 convol_time(i_time+1) >= infall_begin_time(i_epis) .and. &
                 convol_time(i_time) < infall_end_time(i_epis)) then
               time_inf = max(convol_time(i_time), infall_begin_time(i_epis))
               time_sup = min(convol_time(i_time+1), infall_end_time(i_epis))
            else
               cycle
            endif

            if (infall_type(i_epis) == "constant") then
               infall_epis(i_epis) = infall_const_mass(i_epis)/ &
                    (infall_end_time(i_epis)-infall_begin_time(i_epis))* &
                    (time_sup-time_inf)

            else if (infall_type(i_epis) == "exponential") then
!# `abs()` in case `infall_expo_timescale` < 0.
               infall_epis(i_epis) = infall_expo_mass(i_epis) * &
                    abs(exp(-(time_inf-infall_begin_time(i_epis))/ &
                    infall_expo_timescale(i_epis)) &
                    - exp(-(time_sup-infall_begin_time(i_epis))/ &
                    infall_expo_timescale(i_epis)))

            else if (infall_type(i_epis) == "reserv_mass") then
!# !!! The formula below overestimates the mass removed from the reservoir in
!# [`time_inf`, `time_sup`[ since it assumes that `infall_epis` is constant in
!# this interval. However, because too much mass has been removed, `infall_epis`
!# should underestimate the mass removed from the reservoir in the next
!# bin of time. Overall, this should compensate.
               infall_epis(i_epis) = reserv_mass(i_epis)**infall_reserv_power(i_epis)/ &
                    infall_reserv_timescale(i_epis)*(time_sup-time_inf)

            else if (infall_type(i_epis) == "file") then
!# !!! Should be improved to integrate from `time_inf` to `time_sup`.
               call bracket(infall_file_dim_time(i_epis), &
                    infall_file_time(i_epis) % val, time, i_bracket)
               call Steffen(infall_file_dim_time(i_epis), &
                    infall_file_time(i_epis) % val, &
                    infall_file_rate(i_epis) % val, &
                    time, infall_epis(i_epis), i_bracket)
               infall_epis(i_epis) = infall_epis(i_epis)*(time_sup-time_inf)

            else
               write(*, "(a,i0,a)") "`infall_type(", i_epis, ")` """ // &
                    trim(infall_type(i_epis)) // """ undefined. Stopped."
               stop
            endif
         endif
      enddo

      do i_reserv = 1, max_dim_reserv
         reserv_d_mass(i_reserv) = &
              sum(infall_epis(:), mask = infall_source(:) == i_reserv)
         if (reserv_d_mass(i_reserv) > reserv_mass(i_reserv)) then
            if (.not.infall_warn_present(i_reserv)) then
               infall_warn_age(i_reserv) = time
               infall_warn_present(i_reserv) = .true.
            endif
!# Warn only if `tmp` > `reserv_mass(i_reserv)` + some epsilon ???
            reserv_d_mass(i_reserv) = reserv_mass(i_reserv)
            reserv_mass(i_reserv) = 0
         else
            reserv_mass(i_reserv) = max(0._CDR, reserv_mass(i_reserv) &
                 - reserv_d_mass(i_reserv))
         endif
      enddo

      do i_reserv = 1, max_dim_reserv
         ISM_elem_mass(:) = ISM_elem_mass(:) &
              + reserv_d_mass(i_reserv)*reserv_abund(i_reserv,:)
         infall_d_mass = infall_d_mass + reserv_d_mass(i_reserv)
      enddo

      current_galaxy_mass = current_galaxy_mass + infall_d_mass
      current_ISM_mass = current_ISM_mass + infall_d_mass
      infall_rate(i_time) = infall_d_mass/time_step
      call compute_abundances

    end subroutine compute_infall

!#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    subroutine compute_outflow

      implicit none
      integer :: i_epis
      real(CDR), dimension(max_dim_outflow_epis) :: outflow_epis
      logical :: excessive_outflow
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      outflow_d_mass = 0
      do i_epis = 1, max_dim_outflow_epis
         outflow_epis(i_epis) = 0
         if (outflow_type(i_epis) == "none" .or. outflow_type(i_epis) == "radical") &
              cycle !# If the outflow is "radical" for episode `i_epis`, the \
!# corresponding rate remains provisionally to 0 to check if the sum of other \
!# terms is larger than the maximum possible rate. The right value of \
!# `outflow_d_mass` will be computed in the block "if (radical_outflow)" below.

         if (outflow_type(i_epis) == "instantaneous") then
!# Take the nearest time-step.
            if (nint(outflow_begin_time(i_epis)/time_step)+1 == i_time) &
                 outflow_epis(i_epis) = outflow_inst_mass(i_epis)
         else
            if  (outflow_end_time(i_epis) >= outflow_begin_time(i_epis) .and. &
                 convol_time(i_time+1) >= outflow_begin_time(i_epis) .and. &
                 convol_time(i_time) < outflow_end_time(i_epis)) then
               time_inf = max(convol_time(i_time), outflow_begin_time(i_epis))
               time_sup = min(convol_time(i_time+1), outflow_end_time(i_epis))
            else
               cycle
            endif

            if (outflow_type(i_epis) == "constant") then
               outflow_epis(i_epis) = outflow_const_mass(i_epis)/ &
                    (outflow_end_time(i_epis)-outflow_begin_time(i_epis))* &
                    (time_sup-time_inf)

            else if (outflow_type(i_epis) == "SF") then
!# ??? Use rather `SF_live_d_mass` instead of `SF_d_mass`?
               outflow_epis(i_epis) = SF_d_mass*outflow_SF_factor(i_epis)/ &
                    current_ISM_mass**outflow_SF_power(i_epis)

            else if (outflow_type(i_epis) == "SN") then
               outflow_epis(i_epis) = (CCSN_rate(i_time)+SNIa_rate(i_time))* &
                    outflow_SN_mass(i_epis)*(time_sup-time_inf)/ &
                    current_ISM_mass**outflow_SN_power(i_epis)

            else if (outflow_type(i_epis) == "CCSN") then
               outflow_epis(i_epis) = CCSN_rate(i_time)*outflow_CCSN_mass(i_epis)* &
                    (time_sup-time_inf)/current_ISM_mass**outflow_CCSN_power(i_epis)

            else if (outflow_type(i_epis) == "SNIa") then
               outflow_epis(i_epis) = SNIa_rate(i_time)*outflow_SNIa_mass(i_epis)* &
                    (time_sup-time_inf)/current_ISM_mass**outflow_SNIa_power(i_epis)

            else if (outflow_type(i_epis) == "ejecta") then
!# Note: although computed from the stellar ejection rate, the outflowing matter
!# is all the interstellar medium, not only the recent stellar ejecta.
               if (current_ISM_mass < outflow_ejec_threshold(i_epis)*SF_cumul_mass) &
                    then
                  outflow_epis(i_epis) = outflow_ejec_factor(i_epis) &
                       * ejec_rate_tot(i_time) * (time_sup-time_inf) &
                       * (1-current_ISM_mass/SF_cumul_mass/ &
                       outflow_ejec_threshold(i_epis))
               endif

            else if (outflow_type(i_epis) == "file") then
!# Should be improved to integrate from `time_inf` to `time_sup`.
               call bracket(outflow_file_dim_time(i_epis), &
                    outflow_file_time(i_epis) % val, time, i_bracket)
               call Steffen(outflow_file_dim_time(i_epis), &
                    outflow_file_time(i_epis) % val, &
                    outflow_file_rate(i_epis) % val, &
                    time, outflow_epis(i_epis), i_bracket)
               outflow_epis(i_epis) = outflow_epis(i_epis)*(time_sup-time_inf)

            else
               write(*, "(a,i0,a)") "`outflow_type(", i_epis, ")` """ // &
                    trim(outflow_type(i_epis)) // """ undefined. Stopped."
               stop
            endif
         endif

         outflow_d_mass = outflow_d_mass + outflow_epis(i_epis)
      enddo

      excessive_outflow = .false.
      if (outflow_d_mass > current_ISM_mass) then
         if (.not.outflow_warn_present) then
            outflow_warn_age = time
            outflow_warn_present = .true.
         endif
!# Warn only if `outflow_d_mass` > `current_ISM_mass` + some epsilon ???
         excessive_outflow = .true.
      endif

      if (radical_outflow .or. excessive_outflow) then
         outflow_d_mass = current_ISM_mass
         current_ISM_mass = 0
         ISM_elem_mass(:) = 0
         carb_mass = 0
         sil_mass = 0
      else
         current_ISM_mass = max(0._DPR, &
              current_ISM_mass - outflow_d_mass)
         ISM_elem_mass(:) = max(0._DPR, &
              ISM_elem_mass(:) - outflow_d_mass*ISM_abund(i_time,:))
         if (dust_evolution == "Dwek") then
            carb_mass = max(0._DPR, carb_mass - &
                 outflow_d_mass*carb_abund(i_time))
            sil_mass = max(0._DPR, &
                 sil_mass - outflow_d_mass*sil_abund(i_time))
         endif
      endif

      outflow_rate(i_time) = outflow_d_mass/time_step
      current_galaxy_mass = max(0._DPR, current_galaxy_mass - outflow_d_mass)

    end subroutine compute_outflow

!#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    subroutine ISM_processes

      implicit none
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      current_ISM_mass = current_ISM_mass &
           + ejec_rate_tot(i_time) * time_step
      ISM_elem_mass(0:dim_elem) = ISM_elem_mass(0:dim_elem) + ejec_rate_elem(0:dim_elem) * time_step
      if (dust_evolution == "Dwek") then
!# !!! The sublimation of dust grains submitted to an intense radiation
!# field is not taken into account.

!# Dust production.
         carb_mass = carb_mass + carb_dust_prod_rate * time_step
         sil_mass = sil_mass + sil_dust_prod_rate * time_step

!# Dust destruction.
         total_swept_mass = SN_swept_mass*(CCSN_rate(i_time) + &
              SNIa_rate(i_time))*time_step
         if (total_swept_mass >= current_ISM_mass) then
            carb_mass = 0
            sil_mass = 0
         else
            carb_mass = max(0._DPR, carb_mass - &
                 carb_abund(i_time)*total_swept_mass) !# ??? `carb_abund(i_time)` \
!# has not been recomputed yet.
            sil_mass = max(0._DPR, sil_mass - &
                 sil_abund(i_time)*total_swept_mass)
         endif

!# Dust accretion on grains in the ISM.
!# `potential_*_dust_mass` are the masses that would be in carbonaceous and silicate dust
!# if all the possible contributors in the ISM were in the form of grains.
         potential_carb_mass = ISM_elem_mass(i_C) !# !!! H atoms neglected.
         potential_sil_mass = & !# !!! Not fully consistent: A_O17, etc., should be \
!# used too.
              (ISM_elem_mass(i_Mg)*(1 + O_sil_ratio*A_O16/A_Mg24) &  !# `O_sil_ratio` atom of \
!#                                                                          oxygen for each Mg atom, \
              + ISM_elem_mass(i_Si)*(1 + O_sil_ratio*A_O16/A_Si28) & !# Si atom, \
              + ISM_elem_mass(i_S)*(1 + O_sil_ratio*A_O16/A_S32) &   !# S atom, \
              + ISM_elem_mass(i_Ca)*(1 + O_sil_ratio*A_O16/A_Ca40) & !# Ca atom or \
              + ISM_elem_mass(i_Fe)*(1 + O_sil_ratio*A_O16/A_Fe56))  !# Fe atom.
         if (potential_carb_mass > 0) &
              carb_mass = carb_mass &
              + max(0._DPR, (1-carb_mass/potential_carb_mass)) &
              * carb_mass/carb_accr_timescale*time_step
         if (potential_sil_mass > 0) &
              sil_mass = sil_mass &
              + max(0._DPR, (1-sil_mass/potential_sil_mass)) &
              * sil_mass/sil_accr_timescale*time_step
      endif

    end subroutine ISM_processes

!#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    subroutine convolution

      implicit none
!#......................................................................
      integer :: i_time_SSP, i_convol
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# The computation of `ejec_rate_tot(i_time)`, etc., by a direct convolution
!# is very slow. To speed it up, we assume that the quantities
!# `ejec_rate_tot_SSP(:,i_time_SSP)`, etc., may be considered as constant on
!# [`time_SSP(i_time_SSP-1)`, `time_SSP(i_time_SSP)`[. For each `i_time`, this allows to sum
!# `dim_time_SSP` terms instead of `dim_convol_time` ones. Since `dim_time_SSP` <<
!# `dim_convol_time`, this is much more rapid.
!# This requires however to use the value of `ejec_rate_tot`, etc., at
!# `i_time`-1. Numerical errors therefore increase from 1 to `dim_convol_time`.
!# {
      i_time_SSP = 1
      ejec_rate_tot(i_time) = ejec_rate_tot(i_time) + &
           dot_product(SF_live_d_mass(:,i_time), ejec_rate_tot_SSP(:,i_time_SSP))

      do i_elem = 0, dim_elem
         ejec_rate_elem(i_elem) = ejec_rate_elem(i_elem) + &
              dot_product(SF_live_d_mass(:,i_time), &
              max(0._CDR, ejec_rate_elem_SSP(:, i_time_SSP, i_elem) + &
              ISM_abund(i_time, i_elem) * ejec_rate_tot_SSP(:, i_time_SSP)))
      enddo

      carb_dust_prod_rate = carb_dust_prod_rate + &
           dot_product(SF_live_d_mass(:,i_time), carb_dust_prod_rate_SSP(:, i_time_SSP))

      sil_dust_prod_rate = sil_dust_prod_rate + &
           dot_product(SF_live_d_mass(:,i_time), sil_dust_prod_rate_SSP(:, i_time_SSP))

      BHNS_mass_prod_rate = BHNS_mass_prod_rate + &
           dot_product(SF_live_d_mass(:,i_time), BHNS_mass_prod_rate_SSP(:, i_time_SSP))

      WD_mass_prod_rate = WD_mass_prod_rate + &
           dot_product(SF_live_d_mass(:,i_time), WD_mass_prod_rate_SSP(:, i_time_SSP))

      SNIa_rate(i_time) = SNIa_rate(i_time) + &
           dot_product(SF_live_d_mass(:,i_time), SNIa_rate_SSP(:, i_time_SSP))

      do i_time_SSP = 2, dim_time_SSP
         i_convol = i_time+1-nint(time_SSP(i_time_SSP)/time_step+1) !# Dangerous???
         if (i_convol <= 0) exit
         if (all(SF_live_d_mass(:,i_convol) == 0)) cycle

         ejec_rate_tot(i_time) = ejec_rate_tot(i_time) + &
              dot_product(SF_live_d_mass(:,i_convol), &
              (ejec_rate_tot_SSP(:, i_time_SSP) - ejec_rate_tot_SSP(:, i_time_SSP-1)))

         do i_elem = 0, dim_elem
            ejec_rate_elem(i_elem) = ejec_rate_elem(i_elem) + &
                 dot_product(SF_live_d_mass(:,i_convol), &
                 (max(0._CDR, ejec_rate_elem_SSP(:, i_time_SSP, i_elem) &
                 + ISM_abund(i_convol,i_elem)*ejec_rate_tot_SSP(:, i_time_SSP)) &
                 - max(0._CDR, ejec_rate_elem_SSP(:, i_time_SSP-1, i_elem) &
                 + ISM_abund(i_convol,i_elem)*ejec_rate_tot_SSP(:, i_time_SSP-1))))
         enddo
!# Remark on previous lines: even if the initial metallicity of some stars
!# is not that of the ISM, the gross yield
!# `ejec_rate_elem_SSP+ISM_abund*ejec_rate_tot_SSP` is computed from the net
!# yield `ejec_rate_elem_SSP` using the metallicity of the ISM, not the initial
!# metallicity of the stars.

         carb_dust_prod_rate = carb_dust_prod_rate + &
              dot_product(SF_live_d_mass(:,i_convol), &
              (carb_dust_prod_rate_SSP(:, i_time_SSP) - &
              carb_dust_prod_rate_SSP(:, i_time_SSP-1)))

         sil_dust_prod_rate = sil_dust_prod_rate + &
              dot_product(SF_live_d_mass(:,i_convol), &
              (sil_dust_prod_rate_SSP(:, i_time_SSP) - &
              sil_dust_prod_rate_SSP(:, i_time_SSP-1)))

         BHNS_mass_prod_rate = BHNS_mass_prod_rate + &
              dot_product(SF_live_d_mass(:,i_convol), &
              (BHNS_mass_prod_rate_SSP(:, i_time_SSP) - &
              BHNS_mass_prod_rate_SSP(:, i_time_SSP-1)))

         WD_mass_prod_rate = WD_mass_prod_rate + &
              dot_product(SF_live_d_mass(:,i_convol), &
              (WD_mass_prod_rate_SSP(:, i_time_SSP) - &
              WD_mass_prod_rate_SSP(:, i_time_SSP-1)))

         SNIa_rate(i_time) = SNIa_rate(i_time) + &
              dot_product(SF_live_d_mass(:,i_convol), &
              (SNIa_rate_SSP(:, i_time_SSP) - &
              SNIa_rate_SSP(:, i_time_SSP-1)))
      enddo
!# }.
      ejec_rate_tot(i_time) = max(0._DPR, ejec_rate_tot(i_time))
      ejec_rate_elem(:) = max(0._DPR, ejec_rate_elem(:))
      carb_dust_prod_rate = max(0._DPR, carb_dust_prod_rate)
      sil_dust_prod_rate = max(0._DPR, sil_dust_prod_rate)
      BHNS_mass_prod_rate = max(0._DPR, BHNS_mass_prod_rate)
      WD_mass_prod_rate = max(0._DPR, WD_mass_prod_rate)
      SNIa_rate(i_time) = max(0._DPR, SNIa_rate(i_time))

!# Since core-collapse supernovae occur only for a few tens of millions of years,
!# there is no need to use the trick mentionned above. Since `CCSN_rate(i_time)`
!# does not depend on `CCSN_rate(i_time-1)`, it should be more accurate.
      CCSN_rate(i_time) = 0
      do i_time_SSP = 1, dim_time_SSP-1
         if (time_SSP(i_time_SSP) > time) exit
         do i_convol = nint(time_SSP(i_time_SSP)/time_step+1), &
              min(i_time, nint(time_SSP(i_time_SSP+1)/time_step))
            if (all(SF_live_d_mass(:,i_time+1-i_convol) == 0)) cycle
            if (time_SSP(i_time_SSP) > CCSN_max_age) exit
            CCSN_rate(i_time) = CCSN_rate(i_time) &
                 + dot_product(SF_live_d_mass(:,i_time+1-i_convol), CCSN_rate_SSP(:, i_time_SSP))
         enddo
      enddo

    end subroutine convolution

  end subroutine evolution

end module mod_evolution

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_black_body
  
  private
  public :: pi_B_lambda
  
contains

!#======================================================================
  elemental function pi_B_lambda(T, lambda) 
!# `pi_B_lambda` in erg.s-1.um-1.cm-2 (um-1 for the wavelength, cm-2 for the surface).
!# `lambda` in um. `T` in kelvins.
    
    use mod_types
    use mod_constants, only : h_Planck, c_um, kB, pi, per_um_to_per_cm

    implicit none
    real(CDR), intent(in) :: T, lambda
    real(CDR) :: pi_B_lambda
!#......................................................................
    real(CDR) :: x, x_max
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    x_max = log(huge(1._CDR))
    
    x = h_Planck*c_um/lambda/kB/T
    if (x < x_max) then
       pi_B_lambda = 2*pi*h_Planck*c_um**2/lambda**5/(exp(x)-1) &
            * per_um_to_per_cm**2
    else
       pi_B_lambda = 0
    endif
    
  end function pi_B_lambda
  
end module mod_black_body

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_strings

  use mod_types, only : long_string
  implicit none
  private

  interface quote_string
     module procedure quote_string1, quote_string2
  end interface quote_string

  character, parameter, public :: HT = achar(9) !# Horizontal tabulation.
  character, parameter :: NAK = achar(6) !# Negative-acknowledge character.

  integer, parameter :: shift = iachar("a")-iachar("A")

  public :: down_case, up_case, untabify, quote_string, same_case_equal, &
       find_closing_quote, unquote_string

contains

!#======================================================================

  function down_case(string) !# Replace uppercase characters by lowercase ones.

    implicit none
    character(len=*), intent(in) :: string
    character(len=len(string)) :: down_case
!#......................................................................
    integer :: i
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    do i = 1, len(string)
       if (string(i:i) >= "A" .and. string(i:i) <= "Z") then
          down_case(i:i) = achar(iachar(string(i:i))+shift)
       else
          down_case(i:i) = string(i:i)
       endif
    enddo

  end function down_case

!#======================================================================

  function up_case(string) !# Replace lowercase characters by uppercase ones.

    implicit none
    character(len=*), intent(in) :: string
    character(len=len(string)) :: up_case
!#......................................................................
    integer :: i
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    do i = 1, len(string)
       if (string(i:i) >= "A" .and. string(i:i) <= "Z") then
          up_case(i:i) = achar(iachar(string(i:i))-shift)
       else
          up_case(i:i) = string(i:i)
       endif
    enddo

  end function up_case

!#======================================================================

  function untabify(string) !# Replace each horizontal tabulation by one space.

    implicit none
    character(len=*), intent(in) :: string
    character(len=len(string)) :: untabify
!#......................................................................
    integer :: i, j
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    untabify = string
    i = 1
    do
       j = index(string(i:), HT)
       if (j == 0) exit
       i = i+j-1
       untabify(i:i) = " "
       i = i+1
    enddo

  end function untabify

!#======================================================================

  pure function quote_string_aux(string, delim)

    implicit none
    character(len=*), intent(in) :: string
    character(len=2*len(string)+2) :: quote_string_aux
    character(len=1), intent(in) :: delim
!#......................................................................
    integer :: i, j
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    quote_string_aux = ""
    i = 1
    do
       j = index(string(i:), delim)
       if (j == 0) then
          quote_string_aux = trim(quote_string_aux) // string(i:)
          exit
       else
          quote_string_aux = trim(quote_string_aux) // string(i:i+j-1) // delim
          i = i+j
       endif
    enddo
    quote_string_aux = delim // trim(quote_string_aux) // delim

  end function quote_string_aux

!#======================================================================

  function quote_string1(string)

    implicit none
    character(len=*), intent(in) :: string
    character(len=len_trim(quote_string_aux(string, '"'))) :: quote_string1
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    quote_string1 = quote_string_aux(string, '"')

  end function quote_string1

!#======================================================================

  function quote_string2(string, delim)

    implicit none
    character(len=*), intent(in) :: string
    character(len=1), intent(in) :: delim
    character(len=len_trim(quote_string_aux(string, delim))) :: quote_string2
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    quote_string2 = quote_string_aux(string, delim)

  end function quote_string2

!#======================================================================

  pure function unquote_string_aux(string)

    implicit none
    character(len=*), intent(in) :: string
    character(len=long_string) :: unquote_string_aux
!#......................................................................
    character(len=1) :: delim
    integer :: i, j
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Note: `unquote_string_aux` must be pure; otherwise, `unquote_string` cannot
!# be trimmed to its length without trailing spaces. Because  `unquote_string_aux`
!# must be pure, it cannot contain `write` or `stop` statements. These are moved in
!# `unquote_string` itself. To signal possible errors, the non-printable character
!# `NAK`, which the user is unlikely to type, is prepended to the error message
!# created in `unquote_string_aux`; `unquote_string` prints the error message and
!# stops if `unquote_string_aux` begins with `NAK`.

    if (string(1:1) == '"') then
       delim = '"'
    else if (string(1:1) == "'") then
       delim = "'"
    else
       delim = ""
    endif
    if (delim == "") then
       j = index(string, " ")
       if (j == 0) then
          unquote_string_aux = string
       else
          unquote_string_aux = string(:j-1)
       endif
    else
       unquote_string_aux = ""
       i = 2
       do
          j = index(string(i:), delim)
          if (j == 0) then !# No closing `delim` found.
             unquote_string_aux = NAK // "String `" // trim(string) // "` starts with `" // &
                  delim // "`, but there is no closing `" // delim // "`. Stopped."
             exit
          else
             if (string(i+j:i+j) == delim) then !# `delim` is doubled. Keep \
!# only one and continue.
                unquote_string_aux = trim(unquote_string_aux) // string(i:i+j-1)
                i = i+j+1
             else if (scan(string(i+j:i+j), " ,/") /= 0) then !# `delim` followed \
!# by a space character, `,` or `/`. OK.
                unquote_string_aux = trim(unquote_string_aux) // string(i:i+j-2)
                exit
             else
                unquote_string_aux = NAK // "Something lingering after the closing `" // &
                     delim // "`. Stopped."
                exit
             endif
          endif
       enddo
    endif

  end function unquote_string_aux

!#======================================================================

  function unquote_string(string)

    implicit none
    character(len=*), intent(in) :: string
    character(len=long_string) :: unquote_string
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!# Note: `unquote_string` should not be used in a `write` statement because it
!# already contains a `write` statement.

    unquote_string = unquote_string_aux(string)
    if (unquote_string(1:1) == NAK) then
       write(*, "(a)") trim(unquote_string(2:))
       stop
    endif

  end function unquote_string

!#======================================================================

  function same_case_equal(string1, string2)

    implicit none

    character(len=*), intent(in) :: string1, string2
    logical :: same_case_equal
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (down_case(string1) == down_case(string2)) then
       same_case_equal = .true.
    else
       same_case_equal = .false.
    endif

  end function same_case_equal

!#======================================================================

  recursive subroutine find_closing_quote(line, pos, quote_character, quote_found)

    implicit none
    character(len=*), intent(in) :: line
    character, intent(in) :: quote_character
    integer, intent(inout) :: pos
    logical, intent(out) :: quote_found
!#......................................................................
    integer :: shift
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    shift = index(line(pos:), quote_character)
    if (shift == 0) then !# No closing quote found.
       quote_found = .false.
    else !# Closing quote found.
       pos = pos+shift-1
       quote_found = .true.
       if (pos < len_trim(line)) then
          if (line(pos+1:pos+1) == quote_character) then !# Two consecutive quotes.
             pos = pos+2
             quote_found = .false.
             call find_closing_quote(line, pos, quote_character, quote_found)
          endif
       endif
    endif

  end subroutine find_closing_quote

end module mod_strings

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

program calib
  
  use mod_types
  use mod_directories, only : calib_dir, bin_dir
  use mod_file_access, only : open_file, close_file, path_file
  use mod_constants, only : c_ang, area_10pc
  use mod_filters_constants, only : filters_list, undefined_mag, std_Vega_def, &
       Vega_SED_file, Sun_SED_file, TG_SED_file
  use mod_filters, only : struct_filter, read_filters, flux_band
  use mod_calib, only : format_output, unit_calib, fmt
  use mod_strings, only : quote_string
  use mod_code_version, only : version_id, version_date
  use mod_compiler, only : compiler
  use mod_convert_type, only : to_string
  use mod_ISO_8601, only : ISO_8601

  implicit none
!#......................................................................
  type(struct_filter), dimension(:), pointer :: filter => null()
  integer :: dim_lambda_Vega, dim_filter, dim_lambda_TG, dim_lambda_Sun
  real(DPR) :: filter_norm, lambda_mean, area_nu, lambda_pivot, area_lambda
  real(DPR) :: flux_band_Vega, lambda_eff_Vega, flux_band_TG, AB_Vega, TG_Vega, &
       lum_band_Sun, flux_band_Vega_unnorm, mag_abs_Sun, filter_width, &
       std_Vega, calibration
  real(DPR), dimension(:), allocatable :: irrad_Vega, lambda_Vega, &
       lambda_TG, flux_TG, lambda_Sun, lum_Sun
  integer :: unit_Vega, unit_Sun, unit_TG
  integer :: i_filter, i_lambda
  integer :: unit_compiler
  character(len=25) :: run_begin_time
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

  call ISO_8601(local_time_extended = run_begin_time)
  
  call open_file(unit_compiler, path_file(bin_dir, "compil_calib.txt"))
  read(unit_compiler,*) compiler
  call close_file(unit_compiler)

!# Read the spectrum of Vega.
  
  call open_file(unit_Vega, path_file(calib_dir, Vega_SED_file))
  read(unit_Vega, *) dim_lambda_Vega
  allocate(lambda_Vega(dim_lambda_Vega))
  allocate(irrad_Vega(dim_lambda_Vega))
  do i_lambda = 1, dim_lambda_Vega
     read(unit_Vega, *) lambda_Vega(i_lambda), irrad_Vega(i_lambda) 
  end do
  call close_file(unit_Vega)
  
!# Read the spectrum of the Sun.
 
  call open_file(unit_Sun, path_file(calib_dir, Sun_SED_file))
!# Intrinsic flux: erg/s/A.
  read(unit_Sun, *) dim_lambda_Sun
  allocate(lambda_Sun(dim_lambda_Sun))
  allocate(lum_Sun(dim_lambda_Sun))
  do i_lambda = 1, dim_lambda_Sun
     read(unit_Sun, *) lambda_Sun(i_lambda), lum_Sun(i_lambda) 
  end do
  call close_file(unit_Sun)
  
!# Read the spectrum of BD+17o4708 (F subdwarf used to calibrate the 
!# Thuan & Gunn system).
  
  call open_file(unit_TG, path_file(calib_dir, TG_SED_file))
  read(unit_TG, *) dim_lambda_TG
  allocate(lambda_TG(dim_lambda_TG))
  allocate(flux_TG(dim_lambda_TG))
  do i_lambda = 1, dim_lambda_TG
     read(unit_TG, *) lambda_TG(i_lambda), flux_TG(i_lambda) 
  end do
  call close_file(unit_TG)
  
!# Read the transmissions of the filters.
  
  call read_filters(path_file(calib_dir, filters_list), dim_filter, filter)

  call open_file(unit_calib, path_file(calib_dir, "calib.txt"), &
       status = "replace")
  write(unit_calib, "(a)") quote_string(version_id) // " !# `version_id`." 
  write(unit_calib, "(a)") quote_string(version_date) // " !# `version_date`." 
  write(unit_calib, "(a)") "!# Code ""calib"" executed at " // trim(run_begin_time) // "."     
  write(unit_calib, "(a)") "!# Compiler for ""calib"": " // trim(compiler) // "."

  call format_output("!# filter_id", "a" // to_string(maxval(len_trim(filter(:) % id)) + 2))
  call format_output("i_filter", "i3")
  call format_output("flux_band_Vega", "es9.3")
  call format_output("filter_norm", "es9.3")
  call format_output("lambda_mean", "es9.3")
  call format_output("lambda_eff_Vega", "es9.3")
  call format_output("AB_Vega", "f8.3")
  call format_output("TG_Vega", "f8.3")
  call format_output("lum_band_Sun", "es9.3")
  call format_output("mag_abs_Sun", "f8.3")
  call format_output("lambda_pivot", "es9.3")
  call format_output("filter_width", "es9.3")
  call format_output("calib_type", "a7")

  fmt = "(" // trim(fmt) // ")"
  write(unit_calib,*)

!# Computation of the areas, mean and effective wavelengths, AB-magnitudes 
!# of Vega and calibration constants of the filters.
 
  do i_filter = 1, dim_filter
!# In what follows, we use the notations of Bessel & Murphy (2012, PASP 124, 140; BM2012):
!# -- $S'(\lambda)$ is the system (filter + detector) **energy** response fonction; 
!# -- $S(\lambda)$ is the system **photon** response function.
!# One has $S'(\lambda) = \lambda S(\lambda)$, up to some disappearing constant factor.

!#----------------------------------------------------------------------
     
     area_lambda = flux_band(filter(i_filter), filter(i_filter) % dim_lambda, &
          filter(i_filter) % lambda(:), spread(1._DPR, 1, filter(i_filter) % dim_lambda))

!# Compute `filter_norm`.
     if (filter(i_filter) % calib_type == "IRAS") then
!# The IRAS photometric system is designed in such a way that, for an 
!# $f_\lambda \propto \lambda^{-1}$ (<=> $f_\nu \propto \nu^{-1}$) spectrum, 
!# one has
!#
!#    $\int{f_\lambda S'(\lambda) d\lambda}/`filter_norm` = f_{\lambda_0}$, 
!#
!# where $\lambda_0 = 12, 25, 60, 100 {\mu}m$.

        filter_norm = flux_band(filter(i_filter), filter(i_filter) % dim_lambda, &
             filter(i_filter) % lambda(:), &
             filter(i_filter) % lambda_nom / filter(i_filter) % lambda(:))

     else
!# `filter_norm` = $\int{S'(\lambda) d\lambda}$.

        filter_norm = area_lambda
     endif

!#----------------------------------------------------------------------
!# Mean wavelength
!# `lambda_mean` = $\int{\lambda S'(\lambda) d\lambda} / \int{S'(\lambda) d\lambda}$.
!# (= $\lambda'_0$, not $\lambda_0$, in BM2012.)
     lambda_mean = flux_band(filter(i_filter), filter(i_filter) % dim_lambda, &
          filter(i_filter) % lambda(:), filter(i_filter) % lambda(:)) / area_lambda

!#----------------------------------------------------------------------
!# Filter's width:
!# `filter_width`**2 = $\int{(\lambda - `lambda_mean`)^2 S'(\lambda) d\lambda} / \int{S'(\lambda) d\lambda}$.
!# Note: Koornneef et al. (1986, HiA 7, 833) define it as the standard deviation 
!# around $\lambda_0$, not $\lambda'_0$, and with "S'(\lambda)" replaced by "S(\lambda)".

     filter_width = sqrt(flux_band(filter(i_filter), filter(i_filter) % dim_lambda, &
          filter(i_filter) % lambda(:), (filter(i_filter) % lambda(:) - lambda_mean)**2) / area_lambda)

!#----------------------------------------------------------------------
!# Pivot wavelength
!# `lambda_pivot`**2 = $\int{\lambda S(\lambda) d\lambda} / \int{1/\lambda S(\lambda) d\lambda}$.
!#                   = $\int{S'(\lambda) d\lambda} / \int{1/\lambda^2 S'(\lambda) d\lambda}$.
!#
!# Note: <$f_\nu$> = <$f_\lambda$> * $`lambda_pivot`^2/c$.

     lambda_pivot = sqrt(flux_band(filter(i_filter), filter(i_filter) % dim_lambda, &
          filter(i_filter) % lambda(:), spread(1._DPR, 1, filter(i_filter) % dim_lambda)) / &
          flux_band(filter(i_filter), filter(i_filter) % dim_lambda, &
          filter(i_filter) % lambda(:), 1/filter(i_filter) % lambda(:)**2))

!#----------------------------------------------------------------------
!# Flux of Vega.
!# $\int{f_\lambda(Vega) S'(\lambda) d\lambda}$ / `filter_norm`.

     if (filter(i_filter) % calib_type == "D4000") then
        flux_band_Vega_unnorm = flux_band(filter(i_filter), dim_lambda_Vega, lambda_Vega, &
             irrad_Vega*lambda_Vega**2) / c_ang
     else
        flux_band_Vega_unnorm = flux_band(filter(i_filter), dim_lambda_Vega, lambda_Vega, &
          irrad_Vega)
     endif

     flux_band_Vega = flux_band_Vega_unnorm/filter_norm

!#----------------------------------------------------------------------
!# Effective wavelength of Vega.
!# $\int{\lambda f_\lambda(Vega) S'(\lambda) d\lambda} / \int{f_\lambda(Vega) S'(\lambda) d\lambda}$.

     if (filter(i_filter) % calib_type == "D4000") then
        lambda_eff_Vega = flux_band(filter(i_filter), dim_lambda_Vega, lambda_Vega, &
             lambda_Vega**3*irrad_Vega) / c_ang
     else
        lambda_eff_Vega = flux_band(filter(i_filter), dim_lambda_Vega, lambda_Vega, &
             lambda_Vega*irrad_Vega)
     endif

     if (flux_band_Vega_unnorm > 0) &
          lambda_eff_Vega = lambda_eff_Vega/flux_band_Vega_unnorm

!#----------------------------------------------------------------------
!# Apparent AB magnitude of Vega.
!# `area_nu` = $\int{c/\lambda^2 S'(\lambda) d\lambda}$.

     area_nu = flux_band(filter(i_filter), filter(i_filter) % dim_lambda, &
          filter(i_filter) % lambda(:), &
          c_ang/filter(i_filter) % lambda(:)**2)

     if (filter(i_filter) % calib_type == "D4000") then
        AB_Vega = -2.5_DPR*log10(flux_band(filter(i_filter), dim_lambda_Vega, lambda_Vega, &
             irrad_Vega)/area_nu)-48.60_DPR
     else
        AB_Vega = -2.5_DPR*log10(flux_band_Vega_unnorm/area_nu)-48.60_DPR
     endif

!#----------------------------------------------------------------------
!# Apparent Thuan & Gunn magnitude of Vega.

     if (filter(i_filter) % calib_type == "D4000") then
        flux_band_TG = flux_band(filter(i_filter), dim_lambda_TG, lambda_TG, &
             flux_TG*lambda_TG**2) / c_ang / filter_norm
     else
        flux_band_TG = flux_band(filter(i_filter), dim_lambda_TG, lambda_TG, &
             flux_TG)/filter_norm        
     endif

     if (flux_band_TG > 0) then
        TG_Vega = -2.5_DPR*log10(flux_band_Vega/flux_band_TG)+9.5_DPR
     else
        TG_Vega = undefined_mag
     end if

!#----------------------------------------------------------------------
!# Monochromatic luminosity of the Sun.
!# $f_\lambda(Sun) S'(\lambda) d\lambda$ / `filter_norm`.

     if (filter(i_filter) % calib_type == "D4000") then
        lum_band_Sun = flux_band(filter(i_filter), dim_lambda_Sun, lambda_Sun, &
             lum_Sun*lambda_Sun**2) / c_ang / filter_norm
     else
        lum_band_Sun = flux_band(filter(i_filter), dim_lambda_Sun, lambda_Sun, &
             lum_Sun)/filter_norm
     endif

!#----------------------------------------------------------------------
!# Absolute magnitude of the Sun. 

     if (filter(i_filter) % calib_type == "D4000") then
        calibration = undefined_mag
     else if (filter(i_filter) % calib_type == "HST") then !# ref = -21.10
        calibration = -21.10_DPR
     else if (filter(i_filter) % calib_type == "FOCA") then !# ref = -21.175
        calibration = -21.175_DPR
     else if (filter(i_filter) % calib_type == "IRAS") then
        calibration = undefined_mag
     else
        std_Vega = std_Vega_def + filter(i_filter) % ZPO
        if (filter(i_filter) % calib_type == "Vega") then !# ref = Vega
           calibration = 2.5_DPR*log10(flux_band_Vega) + std_Vega
        else if (filter(i_filter) % calib_type == "AB") then !# ref = AB
           calibration = 2.5_DPR*log10(flux_band_Vega) + AB_Vega - std_Vega
        else if (filter(i_filter) % calib_type == "TG") then !# ref = BD+17d4708 (Thuan & Gunn system)
           if (TG_Vega == undefined_mag) then
              calibration = undefined_mag
           else
              calibration = 2.5_DPR*log10(flux_band_Vega) + TG_Vega - std_Vega
           endif
        end if
     endif

     if (lum_band_Sun > 0 .and. calibration /= undefined_mag) then
           mag_abs_Sun = -2.5_DPR*log10(lum_band_Sun/area_10pc) &
                + calibration
        else
           mag_abs_Sun = undefined_mag
        end if

!#----------------------------------------------------------------------
!# Write output
     write(unit_calib, fmt) &
          adjustl("""" // trim(filter(i_filter) % id) // """") // repeat(" ",12), & !# To flush left the filter's name.
          i_filter, flux_band_Vega, filter_norm, lambda_mean, &
          lambda_eff_Vega, AB_Vega, TG_Vega, lum_band_Sun, mag_abs_Sun, &
          lambda_pivot, filter_width, &
          adjustl("""" // trim(filter(i_filter) % calib_type) // """") // repeat(" ",7)
  end do
  call close_file(unit_calib)
  deallocate(irrad_Vega, lambda_Vega, lambda_TG, flux_TG, lambda_Sun, lum_Sun)
  
end program calib

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_ISO_8601
  
  implicit none
  private
  public ISO_8601
  
contains

!#======================================================================
  
  subroutine ISO_8601(local_time_extended, UTC_time_basic)

    implicit none
    character(len=25), optional :: local_time_extended
    character(len=14), optional :: UTC_time_basic
!#......................................................................
    integer, dimension(8) :: values
    integer, save :: local_year, local_month, local_day, local_hour, &
         local_minute, second, zone, &
         UTC_minute_time, zone_hour, zone_minute, zone_sign, UTC_year, &
         UTC_month, UTC_day, UTC_hour, UTC_minute
    logical :: leap_year
    integer, parameter :: dim_month = 12
    integer, dimension(dim_month), parameter :: common_year_month_length = &
         (/31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/)
    integer, dimension(dim_month) :: month_length

    character(len=4) :: string
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call date_and_time(values = values)
    local_year = values(1)
    local_month = values(2)
    local_day = values(3)
    zone = values(4)
    local_hour = values(5)
    local_minute = values(6)
    second = values(7)
!# `values(8)` (in thousand-ths of seconds) not used.

    if (zone >= 0) then
       zone_sign = +1
    else
       zone_sign = -1
    endif
    zone_hour = (zone_sign*zone)/60
    zone_minute = zone_sign*zone - 60*zone_hour
    zone_hour = zone_sign*zone_hour

    if (present(local_time_extended)) then
       write(string, "(i4.4)") local_year
       local_time_extended = trim(string) // "-"
       write(string, "(i2.2)") local_month
       local_time_extended = trim(local_time_extended) // trim(string) // "-"
       write(string, "(i2.2)") local_day
       local_time_extended = trim(local_time_extended) // trim(string) // "T"
       write(string, "(i2.2)") local_hour
       local_time_extended = trim(local_time_extended) // trim(string) // ":"
       write(string, "(i2.2)") local_minute
       local_time_extended = trim(local_time_extended) // trim(string) // ":"
       write(string, "(i2.2)") second
       local_time_extended = trim(local_time_extended) // trim(string)
       write(string, "(SP,i3.2)") zone_hour
       local_time_extended = trim(local_time_extended) // trim(string) // ":"
       write(string, "(i2.2)") zone_minute
       local_time_extended = trim(local_time_extended) // trim(string)
    endif

    leap_year = .false.
    if (mod(local_year, 4) == 0) leap_year = .true.
    if (mod(local_year, 100) == 0) leap_year = .false.
    if (mod(local_year, 400) == 0) leap_year = .true.
    month_length(:) = common_year_month_length(:)
    if (leap_year) month_length(2) = 29

    UTC_year = local_year
    UTC_month = local_month
    UTC_day = local_day
    UTC_hour = local_hour
    UTC_minute = local_minute
    
    UTC_minute_time = UTC_hour*60 + UTC_minute - zone
    if (UTC_minute_time < 0) then
       UTC_minute_time = UTC_minute_time + 24*60
       UTC_day = UTC_day - 1
       if (UTC_day == 0) then
          UTC_month = UTC_month - 1
          if (UTC_month == 0) then
             UTC_year = UTC_year - 1
             UTC_month = 12
          endif
          UTC_day = month_length(UTC_month)
       endif
    else if (UTC_minute_time >= 24*60) then
       UTC_minute_time = UTC_minute_time - 24*60
       UTC_day = UTC_day + 1
       if (UTC_day > month_length(UTC_month)) then
          UTC_month = UTC_month + 1
          if (UTC_month == 13) then 
             UTC_year = UTC_year + 1
             UTC_month = 1
          endif
          UTC_day = 1
       endif
    endif
    UTC_hour = UTC_minute_time/60
    UTC_minute = UTC_minute_time - 60*UTC_hour
    
    if (present(UTC_time_basic)) then
       write(string, "(i4.4)") UTC_year
       UTC_time_basic = string
       write(string, "(i2.2)") UTC_month
       UTC_time_basic = trim(UTC_time_basic) // string
       write(string, "(i2.2)") UTC_day
       UTC_time_basic = trim(UTC_time_basic) // string
       write(string, "(i2.2)") UTC_hour
       UTC_time_basic = trim(UTC_time_basic) // string
       write(string, "(i2.2)") UTC_minute
       UTC_time_basic = trim(UTC_time_basic) // string
       write(string, "(i2.2)") second
       UTC_time_basic = trim(UTC_time_basic) // string
    end if

  end subroutine ISO_8601

end module mod_ISO_8601

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_SSP_emission

  implicit none
  private
  public :: SSP_emission

contains

!#======================================================================
  
  subroutine SSP_emission(metallicity, &
       IMF_file, IMF_dim_slope, IMF_bin_coeff, IMF_bin_bottom_mass, &
       IMF_bin_slope, IMF_mass_min, IMF_mass_max, IMF_norm, &
       dim_isoch, isoch, HI_rate_SSP, HeI_rate_SSP, HeII_rate_SSP, &
       HI_power_SSP, HeI_power_SSP, HeII_power_SSP, L_bol_tot, &
       L_spec, dim_low_T, &
       metallicity_SL, dim_SL, T_SL_max, T_SL_min, dim_spec, stel_lib)

    use mod_types
    use mod_isochrone
    use mod_IMF, only : IMF_d_n
    use mod_stel_lib, only : interp_stel_lib, struct_stel_lib
    use mod_SSPs_constants, only : d_l10_m_isoch, d_T_isoch, d_L_isoch

    implicit none
    real(DPR), intent(in) :: metallicity
    character(len=*), intent(in) :: IMF_file
    integer, intent(in) :: IMF_dim_slope
    real(DPR), dimension(:), intent(in) :: IMF_bin_coeff, IMF_bin_bottom_mass, &
         IMF_bin_slope
    real(DPR), intent(in) :: IMF_mass_min, IMF_mass_max, IMF_norm
    integer, intent(in) :: dim_isoch
    type(struct_isoch), intent(in) :: isoch
    real(DPR), intent(out) :: HI_rate_SSP, HeI_rate_SSP, HeII_rate_SSP, HI_power_SSP, &
         HeI_power_SSP, HeII_power_SSP, L_bol_tot
    type(irreg_array_DPR), dimension(:), intent(inout) :: L_spec !# `intent(inout)` needed. \
!# Why does it fail with `intent(out)`???
    integer, intent(in) :: dim_low_T
    integer, intent(in) :: dim_SL
    integer, dimension(:), intent(in) :: dim_spec
    real(DPR), dimension(:), intent(in) :: metallicity_SL, T_SL_max, T_SL_min
    type(struct_stel_lib), dimension(:), intent(in) :: stel_lib
!#......................................................................
    integer :: i_isoch, dim_bin, i_bin, j1_inf, j2_inf, j3_inf, j4_inf, j1_sup, j2_sup, &
         j3_sup, j4_sup
    real(DPR) :: d_n, d_l10_mass, m_sub, T_sub, l10_L_sub, g_sub, &
         alpha1, alpha2, alpha3, alpha4, &
         L_sub, beta, metallicity_inf, metallicity_sup
    real(DPR) :: alpha1_inf, alpha2_inf, alpha3_inf, alpha4_inf, &
         alpha1_sup, alpha2_sup, alpha3_sup, alpha4_sup
    integer :: i_SL_sup12, i_SL_sup34, i_SL_inf12,i_SL_inf34
    integer :: i_low_T_sup, i_low_T_inf, i_high_T_sup, i_high_T_inf, i_SL
    type(struct_isoch), pointer :: isoch_node => null(), isoch1 => null(), &
         isoch2 => null()
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    do i_SL = 1, dim_SL
       L_spec(i_SL) % val(0:) = 0
    enddo
!# Bolometric luminosity.
    L_bol_tot = 0
!# Number rate of photons ionizing H.
    HI_rate_SSP = 0
    HI_power_SSP = 0
!# Number of photons ionizing He once.
    HeI_rate_SSP = 0
    HeI_power_SSP = 0
!# Number of photons ionizing He twice.
    HeII_rate_SSP = 0
    HeII_power_SSP = 0

    isoch_node => isoch % ptr
    do i_isoch = 1, dim_isoch-1
       isoch1 => isoch_node
       isoch2 => isoch_node % ptr
       isoch_node => isoch2

!# Subdivision of the isochrone in smaller bins.

       dim_bin = int((max(isoch2 % m-isoch1 % m, 0._DPR))/d_l10_m_isoch+1) &
            +int(abs(isoch2 % T-isoch1 % T)/d_T_isoch+1) &
            +int(abs(isoch2 % L-isoch1 % L)/d_L_isoch+1)
       d_l10_mass = (max(isoch2 % m-isoch1 % m, 0._DPR))/dim_bin

       do i_bin = 0, dim_bin-1
          m_sub = isoch1 % m+(i_bin+0.5_DPR)*d_l10_mass
          d_n = IMF_d_n(m_sub, d_l10_mass, IMF_file, IMF_dim_slope, &
               IMF_bin_coeff, IMF_bin_bottom_mass, IMF_bin_slope, &
               IMF_mass_min, IMF_mass_max, IMF_norm)
          T_sub = isoch1 % T+(i_bin+0.5_DPR)*(isoch2 % T-isoch1 % T)/dim_bin
          l10_L_sub = isoch1 % L+(i_bin+0.5_DPR)*(isoch2 % L-isoch1 % L)/dim_bin
          g_sub = isoch1 % g+(i_bin+0.5_DPR)*(isoch2 % g-isoch1 % g)/dim_bin

          L_sub = 10**l10_L_sub
          L_bol_tot = L_bol_tot+d_n*L_sub
!# bin number `i_bin`: centered on `m_sub` (log10(mass)) and of width `d_l10_mass`
!#                   (log10(mass)); contains `d_n` stars.

!# Computation of the radiation emitted in stellar spectra with a metallicity 
!# BELOW that of the tracks (idem for the number of photons).

          if (metallicity <= metallicity_SL(1)) then
             i_low_T_inf = 1
             i_low_T_sup = 1
          else if (metallicity >= metallicity_SL(dim_low_T)) then
             i_low_T_inf = dim_low_T
             i_low_T_sup = dim_low_T
          else
             do i_SL = 1, dim_low_T-1
                if (metallicity_SL(i_SL) <= metallicity .and. &
                     metallicity <= metallicity_SL(i_SL+1)) then
                   i_low_T_inf = i_SL
                   i_low_T_sup = i_SL+1
                   exit
                endif
             enddo
          endif

          if (metallicity <= metallicity_SL(dim_low_T+1)) then
             i_high_T_inf = dim_low_T+1
             i_high_T_sup = dim_low_T+1
          else if (metallicity >= metallicity_SL(dim_SL)) then
             i_high_T_inf = dim_SL
             i_high_T_sup = dim_SL
          else
             do i_SL = dim_low_T+1, dim_SL-1
                if (metallicity_SL(i_SL) <= metallicity .and. &
                     metallicity <= metallicity_SL(i_SL+1)) then
                   i_high_T_inf = i_SL
                   i_high_T_sup = i_SL+1
                   exit
                endif
             enddo
          endif

          if (T_sub <= T_SL_max(i_low_T_sup)) then
!# Within or below the temperature domain of the library of cold stellar spectra.
             i_SL_sup12 = i_low_T_sup
             i_SL_sup34 = i_low_T_sup
          else if (T_sub >= T_SL_min(i_high_T_sup)) then
!# Within or above the temperature domain of the library of hot stellar spectra.
             i_SL_sup12 = i_high_T_sup
             i_SL_sup34 = i_high_T_sup
          else
!# Between the cold and the hot library of stellar spectra.
             i_SL_sup12 = i_high_T_sup
             i_SL_sup34 = i_low_T_sup
             do i_SL = i_low_T_sup-1, 1, -1
                if (metallicity_SL(i_SL) >= metallicity_SL(i_high_T_sup) .and. &
                     T_SL_max(i_SL) >= T_sub) then
                   i_SL_sup12 = i_SL
                   exit
                endif
             enddo
          endif

          if (T_sub <= T_SL_max(i_low_T_inf)) then
!# Within or below the temperature domain of the library of cold stellar spectra.
             i_SL_inf12 = i_low_T_inf
             i_SL_inf34 = i_low_T_inf
          else if (T_sub >= T_SL_min(i_high_T_inf)) then
!# Within or above the temperature domain of the library of hot stellar spectra.
             i_SL_inf12 = i_high_T_inf
             i_SL_inf34 = i_high_T_inf
          else
!# Between the cold and the hot library of stellar spectra.
             i_SL_inf12 = i_high_T_inf
             i_SL_inf34 = i_low_T_inf
             do i_SL = i_low_T_inf-1, 1, -1
                if (metallicity_SL(i_SL) >= metallicity_SL(i_high_T_inf) .and. &
                     T_SL_max(i_SL) >= T_sub) then
                   i_SL_inf12 = i_SL
                   exit
                endif
             enddo
          endif

          call interp_stel_lib(T_sub, g_sub, j1_inf, j2_inf, j3_inf, j4_inf, &
               alpha1_inf, alpha2_inf, alpha3_inf, alpha4_inf, &
               i_SL_inf12, i_SL_inf34, dim_spec, stel_lib)

          call interp_stel_lib(T_sub, g_sub, j1_sup, j2_sup, j3_sup, j4_sup, &
               alpha1_sup, alpha2_sup, alpha3_sup, alpha4_sup, &
               i_SL_sup12, i_SL_sup34, dim_spec, stel_lib)

          metallicity_inf = metallicity_SL(i_SL_inf34) + &
               (metallicity_SL(i_SL_inf12)-metallicity_SL(i_SL_inf34)) &
               *(alpha1_inf+alpha2_inf)
          metallicity_sup = metallicity_SL(i_SL_sup34) + &
               (metallicity_SL(i_SL_sup12)-metallicity_SL(i_SL_sup34)) &
               *(alpha1_sup+alpha2_sup)

          if (metallicity < metallicity_inf) then
             beta = 1
          else if (metallicity > metallicity_sup) then
             beta = 0
          else if (metallicity_inf == metallicity_sup) then
             beta = 0.5_DPR
          else
             beta = (metallicity_sup-metallicity)/ &
                  (metallicity_sup-metallicity_inf)
          endif

          alpha1 = alpha1_inf*beta
          alpha2 = alpha2_inf*beta
          alpha3 = alpha3_inf*beta
          alpha4 = alpha4_inf*beta
          HI_rate_SSP = HI_rate_SSP+L_sub*d_n*( &
               alpha1*stel_lib(i_SL_inf12) % HI_rate_star(j1_inf) &
               +alpha2*stel_lib(i_SL_inf12) % HI_rate_star(j2_inf) &
               +alpha3*stel_lib(i_SL_inf34) % HI_rate_star(j3_inf) &
               +alpha4*stel_lib(i_SL_inf34) % HI_rate_star(j4_inf))
          HeI_rate_SSP = HeI_rate_SSP+L_sub*d_n*( &
               alpha1*stel_lib(i_SL_inf12) % HeI_rate_star(j1_inf) &
               +alpha2*stel_lib(i_SL_inf12) % HeI_rate_star(j2_inf) &
               +alpha3*stel_lib(i_SL_inf34) % HeI_rate_star(j3_inf) &
               +alpha4*stel_lib(i_SL_inf34) % HeI_rate_star(j4_inf))
          HeII_rate_SSP = HeII_rate_SSP+L_sub*d_n*( &
               alpha1*stel_lib(i_SL_inf12) % HeII_rate_star(j1_inf) &
               +alpha2*stel_lib(i_SL_inf12) % HeII_rate_star(j2_inf) &
               +alpha3*stel_lib(i_SL_inf34) % HeII_rate_star(j3_inf) &
               +alpha4*stel_lib(i_SL_inf34) % HeII_rate_star(j4_inf))

          HI_power_SSP = HI_power_SSP+L_sub*d_n*( &
               alpha1*stel_lib(i_SL_inf12) % HI_power_star(j1_inf) &
               +alpha2*stel_lib(i_SL_inf12) % HI_power_star(j2_inf) &
               +alpha3*stel_lib(i_SL_inf34) % HI_power_star(j3_inf) &
               +alpha4*stel_lib(i_SL_inf34) % HI_power_star(j4_inf))
          HeI_power_SSP = HeI_power_SSP+L_sub*d_n*( &
               alpha1*stel_lib(i_SL_inf12) % HeI_power_star(j1_inf) &
               +alpha2*stel_lib(i_SL_inf12) % HeI_power_star(j2_inf) &
               +alpha3*stel_lib(i_SL_inf34) % HeI_power_star(j3_inf) &
               +alpha4*stel_lib(i_SL_inf34) % HeI_power_star(j4_inf))
          HeII_power_SSP = HeII_power_SSP+L_sub*d_n*( &
               alpha1*stel_lib(i_SL_inf12) % HeII_power_star(j1_inf) &
               +alpha2*stel_lib(i_SL_inf12) % HeII_power_star(j2_inf) &
               +alpha3*stel_lib(i_SL_inf34) % HeII_power_star(j3_inf) &
               +alpha4*stel_lib(i_SL_inf34) % HeII_power_star(j4_inf))

          L_spec(i_SL_inf12) % val(j1_inf) = L_spec(i_SL_inf12) % val(j1_inf) &
               + L_sub*alpha1*d_n
          L_spec(i_SL_inf12) % val(j2_inf) = L_spec(i_SL_inf12) % val(j2_inf) &
               + L_sub*alpha2*d_n
          L_spec(i_SL_inf34) % val(j3_inf) = L_spec(i_SL_inf34) % val(j3_inf) &
               + L_sub*alpha3*d_n
          L_spec(i_SL_inf34) % val(j4_inf) = L_spec(i_SL_inf34) % val(j4_inf) &
               + L_sub*alpha4*d_n

!# Computation of the radiation emitted in stellar spectra with a metallicity 
!# ABOVE that of the tracks (idem for the number of photons).

          alpha1 = alpha1_sup*(1-beta)
          alpha2 = alpha2_sup*(1-beta)
          alpha3 = alpha3_sup*(1-beta)
          alpha4 = alpha4_sup*(1-beta)
          HI_rate_SSP = HI_rate_SSP+L_sub*d_n*( &
               alpha1*stel_lib(i_SL_sup12) % HI_rate_star(j1_sup) &
               +alpha2*stel_lib(i_SL_sup12) % HI_rate_star(j2_sup) &
               +alpha3*stel_lib(i_SL_sup34) % HI_rate_star(j3_sup) &
               +alpha4*stel_lib(i_SL_sup34) % HI_rate_star(j4_sup))
          HeI_rate_SSP = HeI_rate_SSP+L_sub*d_n*( &
               alpha1*stel_lib(i_SL_sup12) % HeI_rate_star(j1_sup) &
               +alpha2*stel_lib(i_SL_sup12) % HeI_rate_star(j2_sup) &
               +alpha3*stel_lib(i_SL_sup34) % HeI_rate_star(j3_sup) &
               +alpha4*stel_lib(i_SL_sup34) % HeI_rate_star(j4_sup))
          HeII_rate_SSP = HeII_rate_SSP+L_sub*d_n*( &
               alpha1*stel_lib(i_SL_sup12) % HeII_rate_star(j1_sup) &
               +alpha2*stel_lib(i_SL_sup12) % HeII_rate_star(j2_sup) &
               +alpha3*stel_lib(i_SL_sup34) % HeII_rate_star(j3_sup) &
               +alpha4*stel_lib(i_SL_sup34) % HeII_rate_star(j4_sup))

          HI_power_SSP = HI_power_SSP+L_sub*d_n*( &
               alpha1*stel_lib(i_SL_sup12) % HI_power_star(j1_sup) &
               +alpha2*stel_lib(i_SL_sup12) % HI_power_star(j2_sup) &
               +alpha3*stel_lib(i_SL_sup34) % HI_power_star(j3_sup) &
               +alpha4*stel_lib(i_SL_sup34) % HI_power_star(j4_sup))
          HeI_power_SSP = HeI_power_SSP+L_sub*d_n*( &
               alpha1*stel_lib(i_SL_sup12) % HeI_power_star(j1_sup) &
               +alpha2*stel_lib(i_SL_sup12) % HeI_power_star(j2_sup) &
               +alpha3*stel_lib(i_SL_sup34) % HeI_power_star(j3_sup) &
               +alpha4*stel_lib(i_SL_sup34) % HeI_power_star(j4_sup))
          HeII_power_SSP = HeII_power_SSP+L_sub*d_n*( &
               alpha1*stel_lib(i_SL_sup12) % HeII_power_star(j1_sup) &
               +alpha2*stel_lib(i_SL_sup12) % HeII_power_star(j2_sup) &
               +alpha3*stel_lib(i_SL_sup34) % HeII_power_star(j3_sup) &
               +alpha4*stel_lib(i_SL_sup34) % HeII_power_star(j4_sup))

          L_spec(i_SL_sup12) % val(j1_sup) = L_spec(i_SL_sup12) % val(j1_sup) &
               + L_sub*alpha1*d_n
          L_spec(i_SL_sup12) % val(j2_sup) = L_spec(i_SL_sup12) % val(j2_sup) &
               + L_sub*alpha2*d_n
          L_spec(i_SL_sup34) % val(j3_sup) = L_spec(i_SL_sup34) % val(j3_sup) &
               + L_sub*alpha3*d_n
          L_spec(i_SL_sup34) % val(j4_sup) = L_spec(i_SL_sup34) % val(j4_sup) &
               + L_sub*alpha4*d_n
       end do
    end do

  end subroutine SSP_emission

end module mod_SSP_emission

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_read_spectra_output

  use mod_types

  implicit none
  private
  type :: struct_spectra_output
     character(std_string) :: version_id, version_date
     character(std_string) :: spectra_output
     logical :: RF_output, sublim_output
     real(CDR) :: time_step
     integer :: dim_output_age, dim_elem, dim_cont, dim_line
     integer :: dim_species_SFC, dim_species_DISM
     character(std_string), dimension(:), pointer :: elem_id => null()
     character(std_string), dimension(:), pointer :: species_id_SFC => null()
     character(std_string), dimension(:), pointer :: species_id_DISM => null()
     real(CDR), dimension(:), pointer :: lambda_cont => null()
     real(CDR), dimension(:), pointer :: lambda_line => null()
     character(std_string), dimension(:), pointer :: line_id => null()
     logical :: reserv_warn_present
     logical :: SF_warn_present
     real(CDR) :: SF_warn_age
     integer :: dim_infall_warn
     integer, dimension(:), pointer :: infall_warn_present => null()
     real(CDR), dimension(:), pointer :: infall_warn_age => null()
     logical :: outflow_warn_present
     real(CDR) :: outflow_warn_age
     real(CDR), dimension(:), pointer :: output_age => null()
     real(CDR), dimension(:), pointer :: convol_time => null()
     real(CDR), dimension(:), pointer :: cosmic_time => null()
     real(CDR), dimension(:), pointer :: redshift => null()
     real(CDR), dimension(:), pointer :: galaxy_mass => null()
     real(CDR), dimension(:), pointer :: WD_mass => null()
     real(CDR), dimension(:), pointer :: BHNS_mass => null()
     real(CDR), dimension(:), pointer :: inert_mass => null()
     real(CDR), dimension(:), pointer :: ISM_mass => null()
     real(CDR), dimension(:), pointer :: ISM_Z => null()
     real(CDR), dimension(:), pointer :: carb_abund => null()
     real(CDR), dimension(:), pointer :: sil_abund => null()
     real(CDR), dimension(:), pointer :: SF_rate => null()
     real(CDR), dimension(:), pointer :: CCSN_rate => null()
     real(CDR), dimension(:), pointer :: SNIa_rate => null()
     real(CDR), dimension(:), pointer :: ejec_rate_tot => null()
     real(CDR), dimension(:), pointer :: infall_rate => null()
     real(CDR), dimension(:), pointer :: outflow_rate => null()
     real(CDR), dimension(:), pointer :: ejec_cumul_mass => null()
     real(CDR), dimension(:), pointer :: SF_live_cumul_mass => null()
     real(CDR), dimension(:), pointer :: infall_cumul_mass => null()
     real(CDR), dimension(:), pointer :: outflow_cumul_mass => null()
     real(CDR), dimension(:), pointer :: live_stars_mass => null()
     real(CDR), dimension(:), pointer :: stel_Z_mass_avrg => null()
     real(CDR), dimension(:), pointer :: stel_Z_bol_avrg => null()
     real(CDR), dimension(:), pointer :: L_bol => null()
     real(CDR), dimension(:), pointer :: tau_V => null()
     real(CDR), dimension(:), pointer :: L_dust => null()
     real(CDR), dimension(:), pointer :: stel_age_mass_avrg => null()
     real(CDR), dimension(:), pointer :: stel_age_bol_avrg => null()
     real(CDR), dimension(:), pointer :: Lyman_cont_gas_abs => null()
     real(CDR), dimension(:), pointer :: Lyman_cont_dust_abs => null()
     real(CDR), dimension(:), pointer :: L_dust_SFC => null()
     real(CDR), dimension(:), pointer :: L_dust_DISM => null()
     real(DPR), dimension(:), pointer :: Lyman_cont_rate => null()
     logical, dimension(:), pointer :: opt_depth_warn_present => null()
     real(CDR), dimension(:), pointer :: opt_depth_warn_min_lambda => null()
     real(CDR), dimension(:), pointer :: opt_depth_warn_max_lambda => null()
     real(CDR), dimension(:,:), pointer :: ISM_abund => null()
     real(CDR), dimension(:,:), pointer :: lum_cont => null()
     real(CDR), dimension(:,:), pointer :: lum_stel_unatt => null()
     real(CDR), dimension(:,:), pointer :: lum_stel_SFC_unatt => null()
     real(CDR), dimension(:,:), pointer :: lum_stel_DISM_unatt => null()
     real(CDR), dimension(:,:), pointer :: lum_neb_cont => null()
     real(CDR), dimension(:,:), pointer :: lum_neb_cont_SFC_unatt => null()
     real(CDR), dimension(:,:), pointer :: lum_neb_cont_DISM_unatt => null()
     real(CDR), dimension(:,:,:), pointer :: lum_species_SFC => null()
     real(CDR), dimension(:,:,:), pointer :: lum_species_DISM => null()
     real(CDR), dimension(:,:,:), pointer :: sublim_lum_species_DISM => null()
     real(CDR), dimension(:,:,:), pointer :: sublim_lum_species_SFC => null()
     real(CDR), dimension(:,:), pointer :: cont_trans_SFC => null()
     real(CDR), dimension(:,:), pointer :: cont_trans_DISM_tot => null()
     real(CDR), dimension(:,:), pointer :: &
          cont_trans_DISM_incl => null()
     real(CDR), dimension(:,:), pointer :: RF_cont_SFC => null()
     real(CDR), dimension(:,:), pointer :: RF_cont_DISM => null()
     real(CDR), dimension(:,:), pointer :: L_line => null()
     real(CDR), dimension(:,:), pointer :: L_line_unatt => null()
     real(CDR), dimension(:,:), pointer :: L_line_SFC_unatt => null()
     real(CDR), dimension(:,:), pointer :: L_line_DISM_unatt => null()
     real(CDR), dimension(:,:), pointer :: line_trans_SFC => null()
     real(CDR), dimension(:,:), pointer :: line_trans_DISM_tot => null()
     real(CDR), dimension(:,:), pointer :: &
          line_trans_DISM_incl => null()
     real(CDR), dimension(:,:), pointer :: RF_line_SFC => null()
     real(CDR), dimension(:,:), pointer :: RF_line_DISM => null()
  end type struct_spectra_output

  public :: read_spectra_output, struct_spectra_output

contains

!#======================================================================

  subroutine read_spectra_output(file_name, data)

    use mod_directories, only : spectra_dir
    use mod_file_access

    implicit none
    character(len=*), intent(in) :: file_name
    type(struct_spectra_output), intent(out) :: data
!#......................................................................
    integer :: unit, i_time, i_cont, i_line, i_species, i_reserv, &
         dim_output_age, dim_elem, dim_cont, dim_line
    integer :: dim_species_SFC, dim_species_DISM
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call open_file(unit, path_file(spectra_dir, file_name))

    read(unit,*) data % version_id
    read(unit, *) data % version_date

    call skip_comment_lines(unit)

    read(unit,*) data % spectra_output
    if (data % spectra_output == "detailed") then
       read(unit,*) data % RF_output
       read(unit,*) data % sublim_output
    else
       data % RF_output = .false.
       data % sublim_output = .false.
    endif

    read(unit,*) data % time_step

    read(unit,*) data % dim_output_age
    dim_output_age = data % dim_output_age

    read(unit,*) data % dim_elem
    dim_elem = data % dim_elem

    if (associated(data % elem_id)) deallocate(data % elem_id)
    allocate(data % elem_id(dim_elem))
    read(unit,*) data % elem_id(1:dim_elem)

    read(unit,*) data % dim_species_SFC, data % dim_species_DISM
    dim_species_SFC = data % dim_species_SFC
    dim_species_DISM = data % dim_species_DISM

    if (associated(data % species_id_SFC)) &
         deallocate(data % species_id_SFC)
    allocate(data % species_id_SFC(dim_species_SFC))
    read(unit,*) data % species_id_SFC(1:dim_species_SFC)

    if (associated(data % species_id_DISM)) &
         deallocate(data % species_id_DISM)
    allocate(data % species_id_DISM(dim_species_DISM))
    read(unit,*) data % species_id_DISM(1:dim_species_DISM)

    read(unit,*) data % dim_cont
    dim_cont = data % dim_cont

    read(unit,*) data % dim_line
    dim_line = data % dim_line

    if (associated(data % lambda_cont)) deallocate(data % lambda_cont)
    allocate(data % lambda_cont(dim_cont))

    if (associated(data % lambda_line)) deallocate(data % lambda_line)
    allocate(data % lambda_line(dim_line))

    if (associated(data % line_id)) deallocate(data % line_id)
    allocate(data % line_id(dim_line))

    read(unit,*)
    read(unit,*) data % lambda_cont(1:dim_cont)
    read(unit,*)
    do i_line = 1, dim_line
       read(unit,*) data % line_id(i_line), data % lambda_line(i_line)
    enddo

    read(unit,*) data % reserv_warn_present

    read(unit,*) data % SF_warn_present
    if (data % SF_warn_present) read(unit,*) data % SF_warn_age

    read(unit,*) data % dim_infall_warn
    if (associated(data % infall_warn_present)) &
         deallocate(data % infall_warn_present)
    allocate(data % infall_warn_present(data % dim_infall_warn))
    if (associated(data % infall_warn_age)) &
         deallocate(data % infall_warn_age)
    allocate(data % infall_warn_age(data % dim_infall_warn))
    do i_reserv = 1, data % dim_infall_warn
       read(unit,*) data % infall_warn_present(i_reserv), &
            data % infall_warn_age(i_reserv)
    enddo

    read(unit,*) data % outflow_warn_present
    if (data % outflow_warn_present) read(unit,*) data % outflow_warn_age

    if (associated(data % output_age)) deallocate(data % output_age)
    allocate(data % output_age(dim_output_age))

    if (associated(data % convol_time)) deallocate(data % convol_time)
    allocate(data % convol_time(dim_output_age))

    if (associated(data % cosmic_time)) deallocate(data % cosmic_time)
    allocate(data % cosmic_time(dim_output_age))

    if (associated(data % redshift)) deallocate(data % redshift)
    allocate(data % redshift(dim_output_age))

    if (associated(data % galaxy_mass)) deallocate(data % galaxy_mass)
    allocate(data % galaxy_mass(dim_output_age))

    if (associated(data % WD_mass)) deallocate(data % WD_mass)
    allocate(data % WD_mass(dim_output_age))

    if (associated(data % BHNS_mass)) deallocate(data % BHNS_mass)
    allocate(data % BHNS_mass(dim_output_age))

    if (associated(data % inert_mass)) deallocate(data % inert_mass)
    allocate(data % inert_mass(dim_output_age))

    if (associated(data % ISM_mass)) deallocate(data % ISM_mass)
    allocate(data % ISM_mass(dim_output_age))

    if (associated(data % ISM_Z)) deallocate(data % ISM_Z)
    allocate(data % ISM_Z(dim_output_age))

    if (associated(data % carb_abund)) deallocate(data % carb_abund)
    allocate(data % carb_abund(dim_output_age))

    if (associated(data % sil_abund)) deallocate(data % sil_abund)
    allocate(data % sil_abund(dim_output_age))

    if (associated(data % SF_rate)) deallocate(data % SF_rate)
    allocate(data % SF_rate(dim_output_age))

    if (associated(data % CCSN_rate)) deallocate(data % CCSN_rate)
    allocate(data % CCSN_rate(dim_output_age))

    if (associated(data % SNIa_rate)) deallocate(data % SNIa_rate)
    allocate(data % SNIa_rate(dim_output_age))

    if (associated(data % ejec_rate_tot)) deallocate(data % ejec_rate_tot)
    allocate(data % ejec_rate_tot(dim_output_age))

    if (associated(data % infall_rate)) deallocate(data % infall_rate)
    allocate(data % infall_rate(dim_output_age))

    if (associated(data % outflow_rate)) deallocate(data % outflow_rate)
    allocate(data % outflow_rate(dim_output_age))

    if (associated(data % ejec_cumul_mass)) deallocate(data % ejec_cumul_mass)
    allocate(data % ejec_cumul_mass(dim_output_age))

    if (associated(data % SF_live_cumul_mass)) deallocate(data % SF_live_cumul_mass)
    allocate(data % SF_live_cumul_mass(dim_output_age))

    if (associated(data % infall_cumul_mass)) deallocate(data % infall_cumul_mass)
    allocate(data % infall_cumul_mass(dim_output_age))

    if (associated(data % outflow_cumul_mass)) &
         deallocate(data % outflow_cumul_mass)
    allocate(data % outflow_cumul_mass(dim_output_age))

    if (associated(data % live_stars_mass)) deallocate(data % live_stars_mass)
    allocate(data % live_stars_mass(dim_output_age))

    if (associated(data % stel_Z_mass_avrg)) deallocate(data % stel_Z_mass_avrg)
    allocate(data % stel_Z_mass_avrg(dim_output_age))

    if (associated(data % stel_Z_bol_avrg)) deallocate(data % stel_Z_bol_avrg)
    allocate(data % stel_Z_bol_avrg(dim_output_age))

    if (associated(data % L_bol)) deallocate(data % L_bol)
    allocate(data % L_bol(dim_output_age))

    if (associated(data % tau_V)) deallocate(data % tau_V)
    allocate(data % tau_V(dim_output_age))

    if (associated(data % L_dust)) deallocate(data % L_dust)
    allocate(data % L_dust(dim_output_age))

    if (associated(data % stel_age_mass_avrg)) &
         deallocate(data % stel_age_mass_avrg)
    allocate(data % stel_age_mass_avrg(dim_output_age))

    if (associated(data % stel_age_bol_avrg)) &
         deallocate(data % stel_age_bol_avrg)
    allocate(data % stel_age_bol_avrg(dim_output_age))

    if (associated(data % Lyman_cont_gas_abs)) deallocate(data % Lyman_cont_gas_abs)
    allocate(data % Lyman_cont_gas_abs(dim_output_age))

    if (associated(data % Lyman_cont_dust_abs)) deallocate(data % Lyman_cont_dust_abs)
    allocate(data % Lyman_cont_dust_abs(dim_output_age))

    if (associated(data % L_dust_SFC)) deallocate(data % L_dust_SFC)
    allocate(data % L_dust_SFC(dim_output_age))

    if (associated(data % L_dust_DISM)) deallocate(data % L_dust_DISM)
    allocate(data % L_dust_DISM(dim_output_age))

    if (associated(data % Lyman_cont_rate)) deallocate(data % Lyman_cont_rate)
    allocate(data % Lyman_cont_rate(dim_output_age))

    if (associated(data % ISM_abund)) deallocate(data % ISM_abund)
    allocate(data % ISM_abund(dim_output_age, dim_elem))

    if (associated(data % lum_cont)) deallocate(data % lum_cont)
    allocate(data % lum_cont(dim_output_age, dim_cont))

    if (associated(data % lum_stel_SFC_unatt)) deallocate(data % lum_stel_SFC_unatt)
    allocate(data % lum_stel_SFC_unatt(dim_output_age, dim_cont))

    if (associated(data % lum_stel_DISM_unatt)) deallocate(data % lum_stel_DISM_unatt)
    allocate(data % lum_stel_DISM_unatt(dim_output_age, dim_cont))

    if (associated(data % lum_neb_cont_SFC_unatt)) deallocate(data % lum_neb_cont_SFC_unatt)
    allocate(data % lum_neb_cont_SFC_unatt(dim_output_age, dim_cont))

    if (associated(data % lum_neb_cont_DISM_unatt)) deallocate(data % lum_neb_cont_DISM_unatt)
    allocate(data % lum_neb_cont_DISM_unatt(dim_output_age, dim_cont))

    if (associated(data % lum_species_SFC)) deallocate(data % lum_species_SFC)
    allocate(data % lum_species_SFC(dim_species_SFC, dim_output_age, dim_cont))

    if (associated(data % lum_species_DISM)) deallocate(data % lum_species_DISM)
    allocate(data % lum_species_DISM(dim_species_DISM, dim_output_age, dim_cont))

    if (data % sublim_output) then
       if (associated(data % sublim_lum_species_SFC)) deallocate(data % sublim_lum_species_SFC)
       allocate(data % sublim_lum_species_SFC(dim_species_SFC, dim_output_age, dim_cont))

       if (associated(data % sublim_lum_species_DISM)) deallocate(data % sublim_lum_species_DISM)
       allocate(data % sublim_lum_species_DISM(dim_species_SFC, dim_output_age, dim_cont))
    endif

    if (data % RF_output) then
       if (associated(data % RF_cont_SFC)) &
            deallocate(data % RF_cont_SFC)
       allocate(data % RF_cont_SFC(dim_output_age, dim_cont))

       if (associated(data % RF_cont_DISM)) &
            deallocate(data % RF_cont_DISM)
       allocate(data % RF_cont_DISM(dim_output_age, dim_cont))
    endif

    if (associated(data % L_line)) deallocate(data % L_line)
    allocate(data % L_line(dim_output_age, dim_line))

    if (associated(data % L_line_SFC_unatt)) deallocate(data % L_line_SFC_unatt)
    allocate(data % L_line_SFC_unatt(dim_output_age, dim_line))

    if (associated(data % L_line_DISM_unatt)) deallocate(data % L_line_DISM_unatt)
    allocate(data % L_line_DISM_unatt(dim_output_age, dim_line))

    if (data % RF_output) then
       if (associated(data % RF_line_SFC)) &
            deallocate(data % RF_line_SFC)
       allocate(data % RF_line_SFC(dim_output_age, dim_line))

       if (associated(data % RF_line_DISM)) &
            deallocate(data % RF_line_DISM)
       allocate(data % RF_line_DISM(dim_output_age, dim_line))
    endif

    do i_time = 1, dim_output_age
       read(unit,*) data % output_age(i_time)
       read(unit,*) data % convol_time(i_time)
       read(unit,*) data % cosmic_time(i_time)
       read(unit,*) data % redshift(i_time)
       read(unit,*) data % galaxy_mass(i_time)
       read(unit,*) data % live_stars_mass(i_time)
       read(unit,*) data % WD_mass(i_time)
       read(unit,*) data % BHNS_mass(i_time)
       read(unit,*) data % inert_mass(i_time)
       read(unit,*) data % ISM_mass(i_time)
       read(unit,*) data % ISM_Z(i_time)
       read(unit,*) data % stel_Z_mass_avrg(i_time)
       read(unit,*) data % stel_Z_bol_avrg(i_time)
       read(unit,*) data % carb_abund(i_time)
       read(unit,*) data % sil_abund(i_time)
       read(unit,*) data % ISM_abund(i_time,:)
       read(unit,*) data % L_bol(i_time)
       read(unit,*) data % tau_V(i_time)
       read(unit,*) data % L_dust(i_time)
       read(unit,*) data % SF_rate(i_time)
       read(unit,*) data % Lyman_cont_rate(i_time)
       read(unit,*) data % CCSN_rate(i_time)
       read(unit,*) data % SNIa_rate(i_time)
       read(unit,*) data % stel_age_mass_avrg(i_time)
       read(unit,*) data % stel_age_bol_avrg(i_time)
       read(unit,*) data % Lyman_cont_gas_abs(i_time)
       read(unit,*) data % Lyman_cont_dust_abs(i_time)
       read(unit,*) data % ejec_rate_tot(i_time)
       read(unit,*) data % infall_rate(i_time)
       read(unit,*) data % outflow_rate(i_time)
       read(unit,*) data % ejec_cumul_mass(i_time)
       read(unit,*) data % SF_live_cumul_mass(i_time)
       read(unit,*) data % infall_cumul_mass(i_time)
       read(unit,*) data % outflow_cumul_mass(i_time)

       read(unit,*) data % L_dust_SFC(i_time)
       read(unit,*) data % L_dust_DISM(i_time)

       if (associated(data % opt_depth_warn_present)) deallocate(data % opt_depth_warn_present)
       allocate(data % opt_depth_warn_present(dim_output_age))
       if (associated(data % opt_depth_warn_min_lambda)) &
            deallocate(data % opt_depth_warn_min_lambda)
       allocate(data % opt_depth_warn_min_lambda(dim_output_age))
       if (associated(data % opt_depth_warn_max_lambda)) &
            deallocate(data % opt_depth_warn_max_lambda)
       allocate(data % opt_depth_warn_max_lambda(dim_output_age))

       read(unit,*) data % opt_depth_warn_present(i_time)
       if (data % opt_depth_warn_present(i_time)) then
          read(unit,*) data % opt_depth_warn_min_lambda(i_time)
          read(unit,*) data % opt_depth_warn_max_lambda(i_time)
       endif

       if (data % spectra_output == "detailed") then
          read(unit,*)
          do i_cont = 1, dim_cont
             if (data % RF_output) then
                read(unit,*) data % lum_cont(i_time, i_cont), &
                     data % lum_stel_SFC_unatt(i_time, i_cont), &
                     data % lum_stel_DISM_unatt(i_time, i_cont), &
                     data % lum_neb_cont_SFC_unatt(i_time, i_cont), &
                     data % lum_neb_cont_DISM_unatt(i_time, i_cont), &
                     data % RF_cont_SFC(i_time, i_cont), &
                     data % RF_cont_DISM(i_time, i_cont)
             else
                read(unit,*) data % lum_cont(i_time, i_cont), &
                     data % lum_stel_SFC_unatt(i_time, i_cont), &
                     data % lum_stel_DISM_unatt(i_time, i_cont), &
                     data % lum_neb_cont_SFC_unatt(i_time, i_cont), &
                     data % lum_neb_cont_DISM_unatt(i_time, i_cont)
             endif
          enddo
          read(unit,*)
          do i_cont = 1, dim_cont
             read(unit,*) (data % lum_species_SFC(i_species, i_time, i_cont), &
                  i_species = 1, dim_species_SFC), &
                  (data % lum_species_DISM(i_species, i_time, i_cont), &
                  i_species = 1, dim_species_DISM)
          enddo
          if (data % sublim_output) then
             read(unit,*)
             do i_cont = 1, dim_cont
                read(unit,*) &
                     (data % sublim_lum_species_SFC(i_species, i_time, i_cont), &
                     i_species = 1, dim_species_SFC), &
                     (data % sublim_lum_species_DISM(i_species, i_time, i_cont), &
                     i_species = 1, dim_species_DISM)
             enddo
          endif

          read(unit,*)
          do i_line = 1, dim_line
             if (data % RF_output) then
                read(unit,*) data % L_line(i_time, i_line), &
                     data % L_line_SFC_unatt(i_time, i_line), &
                     data % L_line_DISM_unatt(i_time, i_line), &
                     data % RF_line_SFC(i_time, i_line), &
                     data % RF_line_DISM(i_time, i_line)
             else
                read(unit,*) data % L_line(i_time, i_line), &
                     data % L_line_SFC_unatt(i_time, i_line), &
                     data % L_line_DISM_unatt(i_time, i_line)
             endif
          enddo
       else if (data % spectra_output == "basic") then
          read(unit,*)
          read(unit,*) data % lum_cont(i_time, 1:dim_cont)
          read(unit,*)
          read(unit,*) data % L_line(i_time, 1:dim_line)
       else
          write(*, "(a)") "Wrong value for `spectra_output`. Stopped."
          stop
       endif
    enddo
    call close_file(unit)

  end subroutine read_spectra_output

end module mod_read_spectra_output

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_read_columns

  use mod_types

  implicit none
  private
  public :: read_columns

contains

!#======================================================================
  
  subroutine read_columns(file, dim_array, array1, array2)

!# Read a file containing two arrays of reals, `array1` and `array2`, in columns 1 and 2 respectively.
!# Computes their size, `dim_array`, and allocates the arrays.
!# Comment lines (blank lines or lines beginning with "!") at the beginning of the file are skipped.

    use mod_types
    use mod_linked_list
    use mod_file_access, only : open_file, skip_comment_lines, close_file

    implicit none
    character(len=*), intent(in) :: file
    integer, intent(out) :: dim_array
    real(CDR), dimension(:), pointer :: array1, array2
!#......................................................................
    integer :: unit, ios
    real(CDR) :: tmp1, tmp2
    type(lk_lst_CDR) :: head_node1, head_node2
    type(lk_lst_CDR), pointer :: current_node1, current_node2
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call open_file(unit, file)
    dim_array = 0
    call lk_lst_initialize(head_node1)
    call lk_lst_initialize(head_node2)
    do
       read(unit,*,iostat=ios) tmp1, tmp2
       if (ios /= 0) exit
       dim_array = dim_array + 1
       call lk_lst_new_node(head_node1, current_node1)
       call lk_lst_new_node(head_node2, current_node2)
       current_node1 % val = tmp1
       current_node2 % val = tmp2
    enddo
    call close_file(unit)
    
    call lk_lst_to_array(head_node1, array1, dim_array)
    call lk_lst_to_array(head_node2, array2, dim_array)

  end subroutine read_columns

end module mod_read_columns

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

program plot_spectra

  use mod_read_spectra_output
  use mod_types
  use mod_directories, only : spectra_dir
  use mod_select_file, only : select_several_files
  use mod_constants, only : spectra_list, pi, c_cm
  use mod_interp, only : bracket, interp_log_log
  use mod_convert_type

  implicit none
!#......................................................................
  character(std_string), dimension(:), pointer :: file_name => null()
  type(struct_spectra_output), dimension(:), allocatable :: data
  real :: x_min, x_max
  real(DPR) :: y_min, y_max
  real, dimension(:), allocatable :: x_max_file, x_min_file
  real(DPR), dimension(:), allocatable :: y_max_file, y_min_file
  integer :: i_cont, i_time, dim_file, i_file
  real, parameter :: bottom_margin = 0, top_margin = 0.1
  real :: tmp
  character(std_string) :: string
  integer, dimension(10), parameter :: color = (/1, 2, 3, 4, 5, 6, 7, 8, 9, 10/)
  integer, dimension(5), parameter :: line_style = (/1, 2, 3, 4, 5/)
  integer, dimension(1), parameter :: line_width = (/1/)
  logical :: erase
  integer :: pos_token, i_line

!# For the plot, emission lines are assumed to have a Gaussian profile 
!# with standard deviation `sigma` (in angstroems). Only the peak of lines 
!# is plotted.
!# Default full width at half-maximum, in km/s, from Mocz et al. (2012; 
!# MNRAS 425, 296):
  real(DPR), parameter :: FWHM_v_def = 10**2.2_DPR
!# Speed of light in km/s:
  real(DPR), parameter :: c_km = c_cm/1.e5_DPR
  real(DPR) :: sigma, FWHM_v
  integer :: error

  integer :: dim_time, dim_cont, dim_line, pos_line
  type struct_plot
     real, dimension(:), pointer :: x_cont => null(), x_line => null()
     real(DPR), dimension(:,:), pointer :: y_cont => null()
     real(DPR), dimension(:,:), pointer :: y_line_bottom => null()
     real(DPR), dimension(:,:), pointer :: y_line_top => null()
  end type struct_plot
  type(struct_plot), dimension(:), allocatable :: plotted
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

  write(*, "(a/)") "Possible input files (files of spectra):"
  call select_several_files(dir = spectra_dir, list = spectra_list, &
       selected_file = file_name, n_selected_files = dim_file, &
       back = .true.)

  if (dim_file == 0) stop

  write(*,*) "Reading files..."
  allocate(data(dim_file))
  do i_file = 1, dim_file
     call read_spectra_output(file_name(i_file), data(i_file))
  enddo

  dim_time = data(1) % dim_output_age
  dim_cont = data(1) % dim_cont
  dim_line = data(1) % dim_line

  allocate(plotted(dim_file))
  do i_file = 1, dim_file
     if (associated(plotted(i_file) % x_cont)) deallocate(plotted(i_file) % x_cont)
     allocate(plotted(i_file) % x_cont(data(i_file) % dim_cont))

     if (associated(plotted(i_file) % x_line)) deallocate(plotted(i_file) % x_line)
     allocate(plotted(i_file) % x_line(data(i_file) % dim_line))

     if (associated(plotted(i_file) % y_cont)) deallocate(plotted(i_file) % y_cont)
     allocate(plotted(i_file) % y_cont(data(i_file) % dim_output_age, &
          data(i_file) % dim_cont))

     if (associated(plotted(i_file) % y_line_bottom)) deallocate(plotted(i_file) % y_line_bottom)
     allocate(plotted(i_file) % y_line_bottom(data(i_file) % dim_output_age, &
          data(i_file) % dim_line))

     if (associated(plotted(i_file) % y_line_top)) deallocate(plotted(i_file) % y_line_top)
     allocate(plotted(i_file) % y_line_top(data(i_file) % dim_output_age, &
          data(i_file) % dim_line))
  enddo

  if (any(data(2:) % dim_output_age /= dim_time)) then
     write(*,*) "Warning: `dim_output_age` is not the same for all files."
  else 
     do i_file = 2, dim_file
        if (any(data(i_file) % output_age /= data(1) % output_age)) then
           write(*,*) "Warning: not the same `output_age` for all files."
           exit
        endif
     enddo
  endif

  if (any(data(2:) % dim_cont /= dim_cont)) then
     write(*,*) "Warning: `dim_cont` is not the same for all files."
  else 
     do i_file = 2, dim_file
        if (any(data(i_file) % lambda_cont /= data(1) % lambda_cont)) then
           write(*,*) "Warning: not the same `lambda_cont` for all files."
           exit
        endif
     enddo
  endif

  if (any(data(2:) % dim_line /= dim_line)) then
     write(*,*) "Warning: `dim_line` is not the same for all files."
  else
     do i_file = 2, dim_file
        if (any(data(i_file) % lambda_line /= data(1) % lambda_line)) then
           write(*,*) "Warning: not the same `lambda_line` for all files."
           exit
        endif
     enddo
  endif

  write(*,"(/a)") "Full width at half-maximum, in km/s, used to &
       &represent emission lines?"
  write(*,"(a, es8.2, a)") "Default: ", FWHM_v_def, " km/s."
  write(*,"(a)") "Press the <RETURN>/<ENTER> key to select the default &
       &value or provide a number."
  do 
     read(*, "(a)") string !# Not `read(*, *) string`!
     if (string /= "") then
        read(string, *, iostat = error) FWHM_v
        if (FWHM_v <= 0) error = 1
     else
        error = 0
        FWHM_v = FWHM_v_def
     end if
     if (error == 0) exit
     write(*, "(a)") "Invalid input!"
  enddo

  do i_file = 1, dim_file
     do i_cont = 1, data(i_file) % dim_cont
        plotted(i_file) % y_cont(:,i_cont) = &
             data(i_file) % lum_cont(:,i_cont) &
             * data(i_file) % lambda_cont(i_cont)
     enddo
     
     do i_line = 1, data(i_file) % dim_line
        pos_line = 0
        call bracket(data(i_file) % dim_cont, data(i_file) % lambda_cont(:), &
             data(i_file) % lambda_line(i_line), &
             pos_line)
        sigma = data(i_file) % lambda_line(i_line)* &
             FWHM_v/(2*sqrt(2*log(2._DPR)))/c_km
        do i_time = 1, data(i_file) % dim_output_age
           plotted(i_file) % y_line_bottom(i_time, i_line) = interp_log_log( &
                data(i_file) % lambda_cont(pos_line), &
                data(i_file) % lambda_cont(pos_line+1), &
                data(i_file) % lambda_cont(pos_line) * &
                data(i_file) % lum_cont(i_time, pos_line), &
                data(i_file) % lambda_cont(pos_line+1) * &
                data(i_file) % lum_cont(i_time, pos_line+1), &
                data(i_file) % lambda_line(i_line))
           plotted(i_file) % y_line_top(i_time, i_line) = &
                plotted(i_file) % y_line_bottom(i_time, i_line) + &
                data(i_file) % lambda_line(i_line) * &
                data(i_file) % L_line(i_time, i_line) / (sqrt(2*pi)*sigma)
        enddo
     enddo
  enddo

  allocate(x_max_file(dim_file))
  allocate(x_min_file(dim_file))
  allocate(y_max_file(dim_file))
  allocate(y_min_file(dim_file))

  do i_file = 1, dim_file
     y_max_file(i_file) = max(maxval(plotted(i_file) % y_cont(:, :)), &
          maxval(plotted(i_file) % y_line_top(:, :)))
     y_min_file(i_file) = minval(plotted(i_file) % y_cont(:, :), &
          mask = plotted(i_file) % y_cont(:, :) > tiny(1.))
  enddo
  y_max = log10(maxval(y_max_file(1:dim_file)))
  y_min = minval(y_min_file(1:dim_file))

  do i_file = 1, dim_file
     plotted(i_file) % x_cont(:) = log10(data(i_file) % lambda_cont(:))
     plotted(i_file) % x_line(:) = log10(data(i_file) % lambda_line(:))
     plotted(i_file) % y_cont(:, :) = &
          log10(max(plotted(i_file) % y_cont(:, :), y_min))
     plotted(i_file) % y_line_bottom(:, :) = &
          log10(plotted(i_file) % y_line_bottom(:, :))
     plotted(i_file) % y_line_top(:, :) = &
          log10(plotted(i_file) % y_line_top(:, :))
  enddo
  y_min = log10(y_min)

  do i_file = 1, dim_file
     x_max_file(i_file) = maxval(plotted(i_file) % x_cont(:))
     x_min_file(i_file) = minval(plotted(i_file) % x_cont(:))
  enddo
  x_max = maxval(x_max_file(:))
  x_min = minval(x_min_file(:))

  write(*, "(/a)") "x-axis: log_10(lambda/angstroem)."
  write(*, "(a)") "y-axis: log_10(lambda L_lambda/[erg s^-1/M_sys])."
  write(*, "(a)") "Default values of `x_min`, `x_max`, `y_min`, `y_max`:"
  write(*,*) x_min, x_max, y_min, y_max
  write(*, "(a)") "Enter modified values separated by commas. &
       &An empty value is unchanged."
  write(*, "(a)") "Press the <RETURN>/<ENTER> key after the last modified value &
       &to keep the remaining ones unchanged."
  read(*, "(a)") string !# Not `read(*,*) string`.
  string = adjustl(string)
  if (string /= "") then
     if (string(1:1) /= ",") then
        read(string,*) x_min
     endif
     pos_token = index(string, ",")
     if (pos_token /= 0) then
        string = adjustl(string(pos_token+1:))
        if (string(1:1) /= ",") then
           read(string,*) x_max
        endif
        pos_token = index(string, ",")
        if (pos_token /= 0) then
           string = adjustl(string(pos_token+1:))
           if (string(1:1) /= ",") then
              read(string,*) y_min
           endif
           pos_token = index(string, ",")
           if (pos_token /= 0) then
              string = adjustl(string(pos_token+1:))
              if (string /= "") then
                 read(string,*) y_max
              endif
           endif
        endif
     endif
  endif

  write(*, "(/a)") "Erase after each age?"
  call boolean_answer(erase, .true.)

  tmp = y_min
  y_min = (1.+bottom_margin)*y_min - bottom_margin*y_max
  y_max = -top_margin*tmp + (1.+top_margin)*y_max
  call pgbeg(0, "?", 1, 1) !# Enter pgplot.
  call pgask(.false.) !# Do not ask for confirmation when beginning an new plot.
  do i_time = 1, dim_time
     call pgsci(1) !# Color used for axes ("1" -> black).
     call pgsls(1) !# Line style for axes ("1" -> solid).
     call pgslw(1) !# Line width for axes.
     call pgscf(2) !# Default font ("2" -> serif, upright).
     call pgsch(1.) !# Size of characters.
     if (erase) then
        call pgenv(x_min, x_max, real(y_min), real(y_max), 0, 10) !# Plot's \
!# frame. "10" -> log scale along x-axis.
        call pglabel("\gl/\A", & !# x-axis label.
             "log\d10\u(\gl \fiL\fr\d\gl\u/[erg s\u-1\d/M\dsys\u])", & !# y-axis label.
             "Age = " // to_string(data(1) % output_age(i_time)) // " Myr") !# General label.
     else if (i_time == 1) then
        call pgenv(x_min, x_max, real(y_min), real(y_max), 0, 10)
        call pglabel("\gl/\A", &
             "log\d10\u(\gl \fiL\fr\d\gl\u/[erg s\u-1\d/\fiM\fr\dsys\u])", "")
     endif
     if (.not.erase) write(*,*) data(1) % output_age(i_time)
     do i_file = 1, dim_file
        call pgsci(color(mod(i_file-1, size(color))+1)) !# Color of the SED.
!# Uncomment the line "call pgsls[...]" below to change the style 
!# (dashed, etc.) of the SED for each file:
!        call pgsls(line_style(mod(i_file-1, size(line_style))+1))
        call pgslw(line_width(mod(i_file-1, size(line_width))+1)) !# Line width of the SED.
        call pgline(data(i_file) % dim_cont, plotted(i_file) % x_cont(:), &
             real(plotted(i_file) % y_cont(i_time, :))) !# Plot the SED.
!# Plot emission lines as vertical segments:
        do i_line = 1, data(i_file) % dim_line
           call pgmove(plotted(i_file) % x_line(i_line), &
                real(plotted(i_file) % y_line_bottom(i_time, i_line))) 
           call pgdraw(plotted(i_file) % x_line(i_line), &
                real(plotted(i_file) % y_line_top(i_time, i_line)))
!# Draw a small horizontal tick to see the top of the emission line 
!# if several SEDS are plotted and the height of the line is large enough:
           if ((dim_file > 1 .or. .not.erase) .and. &
              plotted(i_file) % y_line_top(i_time, i_line) - &
              plotted(i_file) % y_line_bottom(i_time, i_line) > &
              (y_max-y_min)/100) then
              call pgerr1(2, plotted(i_file) % x_line(i_line), &
                   real(plotted(i_file) % y_line_top(i_time, i_line)), 0., 1.)
           endif
        enddo
     enddo
     write(*, "(a)") "Press the <RETURN>/<ENTER> key to jump to the next time."
     read(*,*)
  enddo
  call pgend
  
end program plot_spectra

!# With "example_read_spectra.f90" in "source_dir/", type for instance
!# ''gfortran -o example_read_spectra ../util_dir/mod_types.f90 ../util_dir/mod_dir_access.f90 ../util_dir/mod_file_access.f90 ../util_dir/mod_strings.f90 ../source_dir/mod_directories.f90 ../source_dir/mod_read_spectra_output.f90 ../source_dir/example_read_spectra.f90''
!# (without quotation marks!) to compile it from within "bin_dir/" 
!# with `gfortran`.

program example_read_spectra

  use mod_read_spectra_output
  implicit none
  type(struct_spectra_output), dimension(2) :: data
  integer :: i, j, k

  call read_spectra_output("example_spectra1.txt", data(1))
  call read_spectra_output("spectra2.txt", data(2))
  do j = 1, data(1) % dim_output_age
     write(*,*) "Wavelength, monochromatic luminosities in &
          &''example_spectra1.txt'' and ''example_spectra2.txt'' &
          &at age = ", data(1) % output_age(j), ":"
     do k = 1, data(1) % dim_cont
        write(*,*) data(1) % lambda_cont(k), (data(i) % lum_cont(j, k), i = 1, 2)
     enddo
  enddo

end program example_read_spectra

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_spectra_ages

  private
  public :: read_spectra_ages

contains
  
!#======================================================================
  
  subroutine read_spectra_ages(ages_file, dim_output_age, output_age)

    use mod_types
    use mod_linked_list
    use mod_directories, only : ages_dir
    use mod_file_access, only : open_file, skip_comment_lines, close_file, &
         path_file

    implicit none
    character(len=*), intent(in) :: ages_file
    integer, intent(out) :: dim_output_age
    real(CDR), dimension(:), pointer :: output_age
!#......................................................................
    integer :: ios, unit
    type(lk_lst_CDR) :: head_node
    type(lk_lst_CDR), pointer :: current_node
    real(CDR) :: x
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call open_file(unit, path_file(ages_dir, ages_file))
    dim_output_age = 0
    call lk_lst_initialize(head_node)
    do
       read(unit,*,iostat=ios) x
       if (ios /= 0) exit
       dim_output_age = dim_output_age+1
       call lk_lst_new_node(head_node, current_node)
       current_node % val = x
    enddo
    call close_file(unit)

    call lk_lst_to_array(head_node, output_age, dim_output_age)

  end subroutine read_spectra_ages
  
end module mod_spectra_ages

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_process_file_name

  implicit none
  private
  public :: process_file_name, process_file_name_aux

contains

!#======================================================================

  subroutine process_file_name(full_name, prefix, default_dir, file_type, &
       time_stamp_value, stamp_time, ordinal, verbosity, time_stamp_used, overwrite)

    use mod_file_access, only : file_name_decomposition, path_file
    use mod_strings, only : quote_string
    use mod_convert_type

    implicit none
    character(len=*), intent(inout) :: full_name
    character(len=*), intent(in) :: prefix, default_dir, file_type, time_stamp_value
    logical, intent(in) :: stamp_time
    integer, intent(in) :: verbosity
    integer, intent(in) :: ordinal
    logical, intent(in) :: overwrite
    logical, intent(inout) :: time_stamp_used
!#......................................................................
    logical :: exist
    character(len=len(full_name)) :: dir_name, stem, extension, base_name
    integer :: number
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (.not.time_stamp_used) then
       if (stamp_time) then
          time_stamp_used = .true.
       endif
    endif
    call file_name_decomposition(full_name, dir_name = dir_name, &
         stem = stem, extension = extension, base_name = base_name)
    if (stem == "") then
       if (extension == "") then
          extension = ".txt"
       endif
       if (prefix == "") then
          full_name = trim(dir_name) // trim(time_stamp_value) // "_" // &
               trim(file_type) // to_string(ordinal) // extension
          time_stamp_used = .true.
       else !# `prefix /= ""`.
          if (stamp_time) then
             full_name = trim(dir_name) // trim(prefix) // "_" // &
                  trim(time_stamp_value) // "_" // trim(file_type) // &
                  to_string(ordinal) // extension
          else
             full_name = trim(dir_name) // trim(prefix) // "_" // &
                  trim(file_type) // to_string(ordinal) // extension
          endif
       endif
    else !# `stem /= ""`.
       if (prefix == "") then
          if (stamp_time) then
             full_name = trim(dir_name) // trim(time_stamp_value) // "_" //  base_name
          else
             full_name = trim(dir_name) // base_name
          endif
       else !# `prefix /= ""`.
          if (stamp_time) then
             full_name = trim(dir_name) // trim(prefix) // "_" // &
                  trim(time_stamp_value) // "_" // base_name
          else
             full_name = trim(dir_name) // trim(prefix) // "_" // base_name
          endif
       endif
    endif

    inquire(file = path_file(default_dir, full_name), exist = exist)
    if (exist .and. .not.overwrite) then
       if (verbosity >= 0) write(*, "(a)") "File " // &
            quote_string(full_name) // " already existed in " // &
            quote_string(default_dir) // "."
!# Add `time_stamp_value` as a prefix, unless it already has been used previously;
!# if so, write a number before the extension.
!# (Excessively unlikely that it will be needed since `time_stamp_value` is derived
!# from the time at the beginning of the run, from the year up to the second.)
       if (.not.time_stamp_used) then
          call file_name_decomposition(full_name, dir_name = dir_name, &
               stem = stem, extension = extension, &
               base_name = base_name)
          full_name = trim(dir_name) // trim(time_stamp_value) // "_" // &
               trim(stem) // extension
       end if

       inquire(file = path_file(default_dir, full_name), exist = exist)
       if (exist) then
          call file_name_decomposition(full_name, dir_name = dir_name, &
               stem = stem, extension = extension, &
               base_name = base_name)
          number = 0
          do
             number = number + 1
             full_name = trim(dir_name) // trim(stem) // "_" // &
                  to_string(number) // extension
             inquire(file = path_file(default_dir, full_name), exist = exist)
             if (.not.exist) exit
          enddo
       endif
       if (verbosity >= 0) write(*, "(a/)") "A new file named " // &
            quote_string(full_name) // " will be created instead."
    endif

  end subroutine process_file_name

!#======================================================================

  subroutine process_file_name_aux(full_name_aux, full_name_main, prefix, default_dir, file_type, &
       time_stamp_value, stamp_time, ordinal, verbosity, time_stamp_used_main, overwrite)

    use mod_file_access, only : file_name_decomposition
    use mod_strings, only : quote_string
    use mod_convert_type

    implicit none
    character(len=*), intent(inout) :: full_name_aux
    character(len=*), intent(in) :: full_name_main, prefix, default_dir, file_type, time_stamp_value
    logical, intent(in) :: stamp_time
    integer, intent(in) :: verbosity
    integer, intent(in) :: ordinal
    logical, intent(in) :: time_stamp_used_main
    logical, intent(in) :: overwrite
!#......................................................................
    character(len=max(len(full_name_aux),len(full_name_main))) :: dir_name, base_name
    logical :: time_stamp_used_aux
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (full_name_aux /= "") then
       time_stamp_used_aux = .false.
       call process_file_name(full_name_aux, prefix, default_dir, &
            file_type, time_stamp_value, stamp_time, ordinal, verbosity, &
            time_stamp_used_aux, overwrite)
    else !# No name provided for the auxiliary file. Create one based on that \
!# of the main file.
       call file_name_decomposition(full_name_main, dir_name = dir_name, &
            base_name = base_name)
       if (prefix /= "" .and. index(base_name,trim(prefix)) == 1) &
            then !# Prefix found at the beginning of `base_name`.
          if (time_stamp_used_main) then
             full_name_aux = trim(dir_name) // trim(prefix) // "_" // &
                  trim(time_stamp_value) // "_" // trim(file_type) // "_" // &
                  base_name(len_trim(prefix)+len_trim(time_stamp_value)+3:)
          else
             full_name_aux = trim(dir_name) // trim(prefix) // "_" // &
                  trim(file_type) // "_" // base_name(len_trim(prefix)+2:)
          endif
       else !# No prefix found.
          if (time_stamp_used_main) then
             full_name_aux = trim(dir_name) // trim(time_stamp_value) // "_" // &
                  trim(file_type) // "_" // base_name(len_trim(time_stamp_value)+2:)  
        else
             full_name_aux = trim(dir_name) // trim(file_type) // "_" // base_name
          endif
       endif
       time_stamp_used_aux = time_stamp_used_main
       call process_file_name(full_name_aux, "", default_dir, "", &
            time_stamp_value, stamp_time, ordinal, verbosity, time_stamp_used_aux, &
            overwrite)
    endif

  end subroutine process_file_name_aux

end module mod_process_file_name

!# This source file is distributed with code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_random

  use mod_types
  implicit none
  private
  integer, save :: dim_seed
  integer, dimension(:), allocatable, save :: seed  

  public :: uniform_random, gaussian_random, initialize_seed, dim_seed, seed

contains

!#======================================================================

  function uniform_random(exclude_zero, exclude_one) 

!# Draws a random number uniformly distributed in [0, 1].
!# Exclude 0 if `exclude_zero` is present and true.
!# Exclude 1 if `exclude_one` is present and true.

    implicit none
    real(CDR) :: uniform_random
    logical, intent(in), optional :: exclude_zero, exclude_one
!#......................................................................
    logical :: exclude_zero_eff, exclude_one_eff
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (present(exclude_zero)) then
       exclude_zero_eff = exclude_zero
    else
       exclude_zero_eff = .false.
    endif
    if (present(exclude_one)) then
       exclude_one_eff = exclude_one
    else
       exclude_one_eff = .false.
    endif

    do
       call random_number(uniform_random)
       if (exclude_zero_eff .and. uniform_random == 0) cycle
       if (exclude_one_eff .and. uniform_random == 1) cycle
       exit
    enddo

  end function uniform_random

!#======================================================================

  function gaussian_random()

!# Draws a random number following a Gaussian distribution of mean 0 and
!# variance 1.

    implicit none
    real(CDR) :: gaussian_random
!#......................................................................
    real(CDR), dimension(2) :: random
    real(CDR) :: x
    real(CDR), save :: next
    logical, save :: exist_next = .false.
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (exist_next) then
       gaussian_random = next
       exist_next = .false.
    else
       do
          call random_number(random(:))
          random(:) = 2*random(:)-1
          x = sum(random(:)**2)
          if (x > 0 .and. x < 1) exit
       enddo
       x = sqrt(-2*log(x)/x)
       gaussian_random = random(1)*x
       next = random(2)*x
       exist_next = .true.
    endif

  end function gaussian_random

!#======================================================================

  subroutine initialize_seed

!# With gfortran (but not ifort), `call random_seed()` always provide
!# the same seeds. Use this routine instead.
    
    implicit none
!#......................................................................
    integer :: clock
    integer, dimension(dim_seed) :: seed2
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call random_seed()
    call random_seed(get = seed)
    call random_seed()
    call random_seed(get = seed2)
    if (all(seed == seed2)) then !# gfortran.
       call system_clock(count = clock)
       
!# A standard way is to set `seed = clock + 37*(/(i_seed, i_seed = 0, dim_seed-1)/)`,
!# but the following seems safer.
       call random_seed(get = seed)
       seed = ieor(seed, clock)
       
       call random_seed(put = seed)
    end if
    
  end subroutine initialize_seed
  
end module mod_random

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_read_cosmo_param

  use mod_types
  use mod_analyze_statement, only : get_val, error_message

  implicit none
  public
  real(CDR), save :: Omega_m, H_0, form_redshift
  logical, save :: CBR

contains

!#======================================================================

  subroutine reset_cosmo

    use mod_spectra_def_param
    implicit none
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    Omega_m = Omega_m_def
    H_0 = H_0_def
    form_redshift = form_redshift_def
    CBR = CBR_def

  end subroutine reset_cosmo

!#======================================================================

  subroutine read_Omega_m(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(Omega_m, rhs)

  end subroutine read_Omega_m

!#======================================================================

  subroutine read_H_0(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(H_0, rhs)

  end subroutine read_H_0

!#======================================================================

  subroutine read_form_redshift(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(form_redshift, rhs)

  end subroutine read_form_redshift

!#======================================================================

  subroutine read_CBR(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(CBR, rhs)

  end subroutine read_CBR

end module mod_read_cosmo_param

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_compute_various

  private
  public :: compute_various

contains

!#======================================================================
  
  subroutine compute_various(i_time, convol_time, beta, inv_time, L_bol_SSP, SF_live_d_mass, &
       SSP_Z_weight, &
       L_dust, L_bol, dust_bol_ratio, stel_Z_bol_avrg, &
       stel_age_bol_avrg, &
       mass_stars_SSP, live_stars_mass, stel_Z_mass_avrg, stel_age_mass_avrg, &
       Lyman_cont_rate, Lyman_cont_gas_abs, Lyman_cont_dust_abs)

    use mod_types
    use mod_constants, only : L_sol
    
    implicit none
    integer, intent(in) :: i_time
    real(CDR), dimension(:), intent(in) :: convol_time
    real(CDR), dimension(:), intent(in) :: beta
    integer, dimension(:), intent(in) :: inv_time
    real(CDR), dimension(:, :), intent(in) :: L_bol_SSP, mass_stars_SSP
    real(CDR), dimension(:,:), intent(in) :: SSP_Z_weight
    real(DPR), dimension(:,:), intent(in) :: SF_live_d_mass
    real(CDR), intent(in) :: L_dust
    real(CDR), intent(out) :: L_bol, stel_age_bol_avrg, stel_Z_bol_avrg, &
         live_stars_mass, stel_Z_mass_avrg, stel_age_mass_avrg, dust_bol_ratio
    real(CDR), intent(in) :: Lyman_cont_rate
    real(CDR), intent(inout) :: Lyman_cont_gas_abs, Lyman_cont_dust_abs
!#......................................................................
    integer :: i_convol1, i_convol2
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    L_bol = 0
    stel_Z_bol_avrg = 0
    stel_age_bol_avrg = 0
    live_stars_mass = 0
    stel_Z_mass_avrg = 0
    stel_age_mass_avrg = 0
    do i_convol1 = 1, i_time
       i_convol2 = i_time+1-i_convol1
       L_bol = L_bol + beta(i_convol2)*sum(SF_live_d_mass(:,i_convol1)*L_bol_SSP(:,inv_time(i_convol2))) &
            + (1-beta(i_convol2))*sum(SF_live_d_mass(:,i_convol1)*L_bol_SSP(:,inv_time(i_convol2)+1))

       stel_Z_bol_avrg = stel_Z_bol_avrg + (beta(i_convol2) * &
            sum(SF_live_d_mass(:,i_convol1)*SSP_Z_weight(:,i_convol1)*L_bol_SSP(:,inv_time(i_convol2))) &
            + (1-beta(i_convol2)) * &
            sum(SF_live_d_mass(:,i_convol1)*SSP_Z_weight(:,i_convol1)*L_bol_SSP(:,inv_time(i_convol2)+1)))

       stel_age_bol_avrg = stel_age_bol_avrg + (convol_time(i_time)-convol_time(i_convol1)) * &
            (beta(i_convol2)*sum(SF_live_d_mass(:,i_convol1)*L_bol_SSP(:,inv_time(i_convol2))) &
            + (1-beta(i_convol2))*sum(SF_live_d_mass(:,i_convol1)*L_bol_SSP(:,inv_time(i_convol2)+1)))

!# "Stars" = luminous, evolving stars, not dark and unevolving (inert) objects from the outset.

       live_stars_mass = live_stars_mass + sum(SF_live_d_mass(:,i_convol1)*mass_stars_SSP(:, i_convol2))

       stel_Z_mass_avrg = stel_Z_mass_avrg + &
            sum(SF_live_d_mass(:,i_convol1)*SSP_Z_weight(:,i_convol1)*mass_stars_SSP(:, i_convol2))

       stel_age_mass_avrg = stel_age_mass_avrg &
            + (convol_time(i_time)-convol_time(i_convol1)) &
            * sum(SF_live_d_mass(:,i_convol1)*mass_stars_SSP(:, i_convol2))
    end do

    if (live_stars_mass > 0) then
       stel_age_mass_avrg = stel_age_mass_avrg/live_stars_mass
       stel_Z_mass_avrg = stel_Z_mass_avrg/live_stars_mass
    else
       stel_age_mass_avrg = 0
       stel_Z_mass_avrg = 0
    end if

    if (L_bol > 0) then
       dust_bol_ratio = L_dust/L_bol/L_sol
       stel_Z_bol_avrg = stel_Z_bol_avrg/L_bol
       stel_age_bol_avrg = stel_age_bol_avrg/L_bol
    else
       dust_bol_ratio = 0
       stel_Z_bol_avrg = 0
       stel_age_bol_avrg = 0
    end if

    if (Lyman_cont_rate > 0) then
       Lyman_cont_gas_abs = Lyman_cont_gas_abs/Lyman_cont_rate
       Lyman_cont_dust_abs = Lyman_cont_dust_abs/Lyman_cont_rate
    else
       Lyman_cont_gas_abs = 0
       Lyman_cont_dust_abs = 0
    endif

  end subroutine compute_various

end module mod_compute_various

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_read_reserv_infall_param

  use mod_types
  use mod_analyze_statement, only : get_val, file_name, line_number, &
       error_message, warning_message
  use mod_convert_type, only : to_string
  use mod_spectra_constants, only : max_dim_reserv, max_dim_infall_epis

  implicit none
  public

  real(CDR), dimension(max_dim_reserv), save :: reserv_init_mass, &
       reserv_Z

  integer, dimension(max_dim_infall_epis), save :: infall_source
  real(CDR), dimension(max_dim_infall_epis), save :: infall_begin_time, &
       infall_end_time

  character(len=std_string), dimension(max_dim_infall_epis), save :: &
       infall_type
  real(CDR), dimension(max_dim_infall_epis), save :: infall_inst_mass, &
       infall_const_mass, &
       infall_expo_timescale, infall_expo_mass, &
       infall_reserv_timescale, infall_reserv_power
  character(len=std_string), dimension(max_dim_infall_epis), save :: &
       infall_file
  integer, dimension(max_dim_infall_epis), save :: infall_file_dim_time
  type(irreg_array_CDR), dimension(max_dim_infall_epis), save :: &
       infall_file_time, infall_file_rate

  logical, dimension(max_dim_infall_epis), private :: infall_file_set, &
       infall_expo_timescale_set, &
       infall_reserv_timescale_set

contains

!#======================================================================

  subroutine read_reserv_init_mass(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_reserv) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(reserv_init_mass, rhs, indices_string, &
         index_present)

  end subroutine read_reserv_init_mass

!#======================================================================

  subroutine read_reserv_Z(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_reserv) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(reserv_Z, rhs, indices_string, index_present)

  end subroutine read_reserv_Z

!#======================================================================

  subroutine reset_reserv_infall

    use mod_spectra_def_param
    implicit none
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    reserv_init_mass(:) = reserv_init_mass_def
    reserv_Z(:) = reserv_Z_def

    infall_source(:) = 1

    infall_begin_time(:) = infall_begin_time_def
    infall_end_time(:) = infall_end_time_def

    infall_type(:) = infall_type_def

    infall_inst_mass(:) = infall_inst_mass_def

    infall_const_mass(:) = infall_const_mass_def

    infall_expo_timescale_set(:) = .false.
    infall_expo_mass(:) = infall_expo_mass_def

    infall_reserv_timescale_set(:) = .false.
    infall_reserv_power(:) = infall_reserv_power_def

    infall_file_set(:) = .false.

  end subroutine reset_reserv_infall

!#======================================================================

  subroutine infall_check

    implicit none
!#......................................................................
    integer :: i_epis
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    do i_epis = 1, max_dim_infall_epis
       if (infall_type(i_epis) == "none") cycle

       if (infall_type(i_epis) == "exponential") then
          if (.not. infall_expo_timescale_set(i_epis)) then
             call error_message("Value of `infall_expo_timescale(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
       endif

       if (infall_type(i_epis) == "reserv_mass") then
          if (.not. infall_reserv_timescale_set(i_epis)) then
             call error_message("Value of `infall_reserv_timescale(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
       endif

       if (infall_type(i_epis) == "file") then
          if (.not. infall_file_set(i_epis)) then
             call error_message("Value of `infall_file(" // &
                  to_string(i_epis) // ")` is unknown.")
          endif
       endif

       if (infall_end_time(i_epis) <= infall_begin_time(i_epis)) &
            call warning_message("`infall_end_time(" // &
            to_string(i_epis) // ")` = " // &
            to_string(infall_end_time(i_epis), "(f6.0)") // &
            " <= `infall_begin_time(" // to_string(i_epis) // ")` = " // &
            to_string(infall_begin_time(i_epis), "(f6.0)") // ".")
    enddo

  end subroutine infall_check

!#======================================================================

  subroutine read_infall_source(rhs, indices_string)

    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_infall_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(infall_source, rhs, indices_string, index_present)

  end subroutine read_infall_source

!#======================================================================

  subroutine read_infall_begin_time(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_infall_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(infall_begin_time, rhs, indices_string, index_present)
    where (infall_begin_time(:) > 0)
!# To make sure that the interval is closed on the left.
       infall_begin_time(:) = nearest(infall_begin_time(:), -1.)
    end where

  end subroutine read_infall_begin_time

!#======================================================================

  subroutine read_infall_end_time(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_infall_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(infall_end_time, rhs, indices_string, index_present)
    where (infall_end_time(:) > 0)
!# To make sure that the interval is open on the right.
       infall_end_time(:) = nearest(infall_end_time(:), -1.)
    end where

  end subroutine read_infall_end_time

!#======================================================================

  subroutine read_infall_type(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_infall_epis) :: index_present
    integer :: i_epis
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(infall_type, rhs, indices_string, index_present)
    do i_epis = 1, max_dim_infall_epis
       if (index_present(i_epis)) then
          if (all(infall_type(i_epis) /= (/ &
               "none         ", &
               "instantaneous", &
               "constant     ", &
               "exponential  ", &
               "reserv_mass  ", &
               "file         "/))) &
               call error_message("The value of `infall_type(" // &
               to_string(i_epis) // ")` should be ""none"", &
               &""instantaneous"", ""constant"", ""exponential"", &
               &""reserv_mass"" or ""file"".")
       endif
    enddo

  end subroutine read_infall_type

!#======================================================================
  
  subroutine read_infall_inst_mass(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_infall_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(infall_inst_mass, rhs, indices_string, index_present)
    call set_infall_type(index_present, "instantaneous")

  end subroutine read_infall_inst_mass

!#======================================================================

  subroutine read_infall_const_mass(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_infall_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(infall_const_mass, rhs, indices_string, index_present)
    call set_infall_type(index_present, "constant")

  end subroutine read_infall_const_mass

!#======================================================================

  subroutine read_infall_expo_timescale(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_infall_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(infall_expo_timescale, rhs, indices_string, index_present)
    where (index_present(:)) infall_expo_timescale_set(:) = .true.
    call set_infall_type(index_present, "exponential")

  end subroutine read_infall_expo_timescale

!#======================================================================

  subroutine read_infall_expo_mass(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_infall_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(infall_expo_mass, rhs, indices_string, index_present)
    call set_infall_type(index_present, "exponential")

  end subroutine read_infall_expo_mass

!#======================================================================

  subroutine read_infall_reserv_timescale(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_infall_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(infall_reserv_timescale, rhs, indices_string, index_present)
    where (index_present(:)) infall_reserv_timescale_set(:) = .true.
    call set_infall_type(index_present, "reserv_mass")

  end subroutine read_infall_reserv_timescale

!#======================================================================

  subroutine read_infall_reserv_power(rhs, indices_string)

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    logical, dimension(max_dim_infall_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(infall_reserv_power, rhs, indices_string, index_present)
    call set_infall_type(index_present, "reserv_mass")

  end subroutine read_infall_reserv_power

!#======================================================================

  subroutine read_infall_file(rhs, indices_string)

    use mod_strings, only : same_case_equal
    use mod_directories, only : scenarios_dir
    use mod_read_columns
    use mod_file_access, only : path_file

    implicit none
    character(len=*), intent(in) :: rhs
    character(len=*), intent(inout) :: indices_string
!#......................................................................
    integer :: i_epis
    logical, dimension(max_dim_infall_epis) :: index_present
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    call get_val(infall_file, rhs, indices_string, index_present)

    do i_epis = 1, max_dim_infall_epis
       if (index_present(i_epis)) then
          call read_columns(path_file(scenarios_dir, adjustl(infall_file(i_epis))), &
               infall_file_dim_time(i_epis), infall_file_time(i_epis) % val, &
               infall_file_rate(i_epis) % val)
       endif
    enddo

    where (index_present(:)) infall_file_set(:) = .true.
    call set_infall_type(index_present, "file")

  end subroutine read_infall_file

!#======================================================================

  subroutine set_infall_type(index_present, string)

    implicit none
    logical, dimension(:), intent(in) :: index_present
    character(len=*), intent(in) :: string
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    
    where (index_present(:)) infall_type(:) = string

  end subroutine set_infall_type

end module mod_read_reserv_infall_param

!# This source file is part of code Pégase.3.0.1 (2019-02-21).
!# Copyright: Michel Fioc (Michel.Fioc@iap.fr), Sorbonne université, 
!# Institut d'astrophysique de Paris/CNRS, France.
!# 
!# Pégase.3.0.1 is governed by the CeCILL license under French law and abides 
!# by the rules of distribution of free software. You can use, modify and/or 
!# redistribute this software under the terms of the CeCILL license as circulated 
!# by CEA, CNRS and INRIA at "http://www.cecill.info". The text of this license
!# is also available in French and in English in directory "doc_dir/" of this
!# code.
!# 
!# As a counterpart to the access to the source code and to the rights to copy,
!# modify and redistribute it granted by the license, users are provided only
!# with a limited warranty, and the software's author, the holder of the
!# economic rights, and the successive licensors have only limited
!# liability. 
!# 
!# The fact that you are presently reading this means that you have had
!# knowledge of the CeCILL license and that you accept its terms.
!#====================================================================== 

module mod_read_dust_transfer_param

  use mod_types
  use mod_analyze_statement, only : get_val, file_name, line_number, &
       error_message, warning_message

  implicit none
  public
  logical, save :: extinction, extinction_SFC, extinction_DISM, &
       dust_emission, dust_emission_SFC, dust_emission_DISM, &
       stoch_heating, stoch_heating_SFC, &
       stoch_heating_DISM, inclin_averaged
  real(CDR), save :: inclination, bulge_tot_ratio, &
       M_sys_spiral, expo_radius, M_sys_spher, core_radius, slab_factor, &
       self_abs_power, self_abs_power_SFC, self_abs_power_DISM, &
       carb_sublim_temp, carb_sublim_temp_SFC, carb_sublim_temp_DISM, &
       sil_sublim_temp, sil_sublim_temp_SFC, sil_sublim_temp_DISM

  character(len=std_string), save :: geometry, grains_file, &
       grains_file_SFC, grains_file_DISM

!# Following parameters are made private to ensure `_SFC` and `_DISM`
!# versions may be used.
  private :: extinction, dust_emission, self_abs_power, &
       stoch_heating, grains_file, carb_sublim_temp, sil_sublim_temp

contains

!#======================================================================

  subroutine reset_dust_transfer

    use mod_spectra_def_param
    implicit none
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    extinction = extinction_def
    extinction_SFC = extinction_SFC_def
    extinction_DISM = extinction_DISM_def

    grains_file = grains_file_def
    grains_file_SFC = grains_file_SFC_def
    grains_file_DISM = grains_file_DISM_def

    bulge_tot_ratio = bulge_tot_ratio_def
    geometry = geometry_def
    inclin_averaged = inclin_averaged_def
    inclination = inclination_def
    M_sys_spiral = M_sys_spiral_def
    expo_radius = expo_radius_def
    M_sys_spher = M_sys_spher_def
    core_radius = core_radius_def
    slab_factor = slab_factor_def

    carb_sublim_temp = carb_sublim_temp_def
    carb_sublim_temp_SFC = carb_sublim_temp_SFC_def
    carb_sublim_temp_DISM = carb_sublim_temp_DISM_def
    sil_sublim_temp = sil_sublim_temp_def
    sil_sublim_temp_SFC = sil_sublim_temp_SFC_def
    sil_sublim_temp_DISM = sil_sublim_temp_DISM_def

    dust_emission = dust_emission_def
    dust_emission_SFC = dust_emission_SFC_def
    dust_emission_DISM = dust_emission_DISM_def
    self_abs_power = self_abs_power_def
    self_abs_power_SFC = self_abs_power_SFC_def
    self_abs_power_DISM = self_abs_power_DISM_def
    stoch_heating = stoch_heating_def
    stoch_heating_SFC = stoch_heating_SFC_def
    stoch_heating_DISM = stoch_heating_DISM_def

  end subroutine reset_dust_transfer

!#======================================================================

  subroutine dust_transfer_check
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    if (self_abs_power < 0) then
       call warning_message("`self_abs_power` < 0. Set to 0.")
       self_abs_power = 0
    endif

    if (self_abs_power > 1) then
       call warning_message("`self_abs_power` > 1. Set to 1.")
       self_abs_power = 1
    endif

    if (self_abs_power_SFC < 0) then
       call warning_message("`self_abs_power_SFC` < 0. Set to 0.")
       self_abs_power_SFC = 0
    endif

    if (self_abs_power_SFC > 1) then
       call warning_message("`self_abs_power_SFC` > 1. Set to 1.")
       self_abs_power_SFC = 1
    endif

    if (self_abs_power_DISM < 0) then
       call warning_message("`self_abs_power_DISM` < 0. Set to 0.")
       self_abs_power_DISM = 0
    endif

    if (self_abs_power_DISM > 1) then
       call warning_message("`self_abs_power_DISM` > 1. Set to 1.")
       self_abs_power_DISM = 1
    endif

  end subroutine dust_transfer_check

!#======================================================================

  subroutine read_extinction(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(extinction, rhs)
    extinction_SFC = extinction
    extinction_DISM = extinction

  end subroutine read_extinction

!#======================================================================

  subroutine read_extinction_SFC(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(extinction_SFC, rhs)

  end subroutine read_extinction_SFC

!#======================================================================

  subroutine read_extinction_DISM(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(extinction_DISM, rhs)

  end subroutine read_extinction_DISM

!#======================================================================

  subroutine read_geometry(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(geometry, rhs)
    if (all(geometry /= (/ &
         "spheroidal", &
         "spiral    ", &
         "slab      "/))) &
         call error_message("The value of `geometry` should be &
         &""spheroidal"", ""spiral"" or ""slab"".")

  end subroutine read_geometry

!#======================================================================
  subroutine read_inclin_averaged(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(inclin_averaged, rhs)

  end subroutine read_inclin_averaged

!#======================================================================

  subroutine read_inclination(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(inclination, rhs)
    call set_inclin_averaged

  end subroutine read_inclination

!#======================================================================

  subroutine read_bulge_tot_ratio(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(bulge_tot_ratio, rhs)
    call set_geometry("spiral")

  end subroutine read_bulge_tot_ratio

!#======================================================================

  subroutine read_M_sys_spiral(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(M_sys_spiral, rhs)
    call set_geometry("spiral")

  end subroutine read_M_sys_spiral

!#======================================================================

  subroutine read_expo_radius(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(expo_radius, rhs)
    call set_geometry("spiral")

  end subroutine read_expo_radius

!#======================================================================

  subroutine read_M_sys_spher(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(M_sys_spher, rhs)
    call set_geometry("spheroidal")

  end subroutine read_M_sys_spher

!#======================================================================

  subroutine read_core_radius(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(core_radius, rhs)
    call set_geometry("spheroidal")

  end subroutine read_core_radius

!#======================================================================

  subroutine read_slab_factor(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(slab_factor, rhs)
    call set_geometry("slab")

  end subroutine read_slab_factor

!#======================================================================

  subroutine read_dust_emission(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(dust_emission, rhs)
    dust_emission_SFC = dust_emission
    dust_emission_DISM = dust_emission

  end subroutine read_dust_emission

!#======================================================================

  subroutine read_dust_emission_SFC(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(dust_emission_SFC, rhs)

  end subroutine read_dust_emission_SFC

!#======================================================================

  subroutine read_dust_emission_DISM(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(dust_emission_DISM, rhs)

  end subroutine read_dust_emission_DISM

!#======================================================================

  subroutine read_self_abs_power(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(self_abs_power, rhs)
    self_abs_power_SFC = self_abs_power
    self_abs_power_DISM = self_abs_power

  end subroutine read_self_abs_power

!#======================================================================

  subroutine read_self_abs_power_SFC(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(self_abs_power_SFC, rhs)

  end subroutine read_self_abs_power_SFC

!#======================================================================

  subroutine read_self_abs_power_DISM(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(self_abs_power_DISM, rhs)

  end subroutine read_self_abs_power_DISM

!#======================================================================

  subroutine read_stoch_heating(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(stoch_heating, rhs)
    stoch_heating_SFC = stoch_heating
    stoch_heating_DISM = stoch_heating

  end subroutine read_stoch_heating

!#======================================================================

  subroutine read_stoch_heating_SFC(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(stoch_heating_SFC, rhs)

  end subroutine read_stoch_heating_SFC

!#======================================================================

  subroutine read_stoch_heating_DISM(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(stoch_heating_DISM, rhs)

  end subroutine read_stoch_heating_DISM

!#======================================================================

  subroutine read_carb_sublim_temp(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(carb_sublim_temp, rhs)
    carb_sublim_temp_SFC = carb_sublim_temp
    carb_sublim_temp_DISM = carb_sublim_temp

  end subroutine read_carb_sublim_temp

!#======================================================================

  subroutine read_carb_sublim_temp_SFC(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(carb_sublim_temp_SFC, rhs)

  end subroutine read_carb_sublim_temp_SFC

!#======================================================================

  subroutine read_carb_sublim_temp_DISM(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(carb_sublim_temp_DISM, rhs)

  end subroutine read_carb_sublim_temp_DISM

!#======================================================================

  subroutine read_sil_sublim_temp(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(sil_sublim_temp, rhs)
    sil_sublim_temp_SFC = sil_sublim_temp
    sil_sublim_temp_DISM = sil_sublim_temp

  end subroutine read_sil_sublim_temp

!#======================================================================

  subroutine read_sil_sublim_temp_SFC(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(sil_sublim_temp_SFC, rhs)

  end subroutine read_sil_sublim_temp_SFC
!#======================================================================

  subroutine read_sil_sublim_temp_DISM(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(sil_sublim_temp_DISM, rhs)

  end subroutine read_sil_sublim_temp_DISM

!#======================================================================

  subroutine read_grains_file(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(grains_file, rhs)

!# ??? Put all possible `grains_file`s in a list and check if the provided `grains_file` is in this list.
    if (all(grains_file /= (/ &
         "ZDA.txt", &
         "LWD.txt", &
         "MRN.txt"/))) &
         call error_message("The value of `grains_file` should be &
         &""ZDA.txt"", ""LWD.txt"" or ""MRN.txt"".")

    grains_file_SFC = grains_file
    grains_file_DISM = grains_file

  end subroutine read_grains_file

!#======================================================================

  subroutine read_grains_file_SFC(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(grains_file_SFC, rhs)
    if (all(grains_file_SFC /= (/ &
         "ZDA.txt", &
         "LWD.txt", &
         "MRN.txt"/))) &
         call error_message("The value of `grains_file_SFC` should be &
         &""ZDA.txt"", ""LWD.txt"" or ""MRN.txt"".")

  end subroutine read_grains_file_SFC

!#======================================================================

  subroutine read_grains_file_DISM(rhs)

    implicit none
    character(len=*), intent(in) :: rhs
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    call get_val(grains_file_DISM, rhs)
    if (all(grains_file_DISM /= (/ &
         "ZDA.txt", &
         "LWD.txt", &
         "MRN.txt"/))) &
         call error_message("The value of `grains_file_DISM` should be &
         &""ZDA.txt"", ""LWD.txt"" or ""MRN.txt"".")

  end subroutine read_grains_file_DISM

!#======================================================================

  subroutine set_inclin_averaged

    implicit none

    inclin_averaged = .false.

  end subroutine set_inclin_averaged

!#======================================================================

  subroutine set_geometry(val_geometry)

    implicit none
    character(len=*), intent(in) :: val_geometry
!#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    geometry = val_geometry

  end subroutine set_geometry

end module mod_read_dust_transfer_param
